/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/errors","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/uuid","vs/editor/common/core/range","vs/base/common/process","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","child_process","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/editor/common/core/position","vs/base/common/errorMessage","vs/base/common/stopwatch","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/assert","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","fs","os","vs/editor/common/languages","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","string_decoder","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/mime","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/node/decoder","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/environment/node/userDataPath","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","path","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],ke=function(J){for(var e=[],u=0,n=J.length;u<n;u++)e[u]=Ie[J[u]];return e};define(Ie[56],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function u(n,D){if(!n)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=u}),define(Ie[77],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function u(C){return C?C.replace(/\$\((.*?)\)/g,(y,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=u;class n{constructor(y,b,I){this.id=y,this.definition=b,this.description=I,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.circleSmallFilled=new n("circle-small-filled",{fontCharacter:"\\eb8a"}),n.debugStackframeDot=new n("debug-stackframe-dot",n.circleSmallFilled.definition),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.layoutSidebarRightOff=new n("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),n.layoutPanelOff=new n("layout-panel-off",{fontCharacter:"\\ec01"}),n.layoutSidebarLeftOff=new n("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.indent=new n("indent",{fontCharacter:"\\ebf9"}),n.recordSmall=new n("record-small",{fontCharacter:"\\ebfa"}),n.errorSmall=new n("error-small",{fontCharacter:"\\ebfb"}),n.arrowCircleDown=new n("arrow-circle-down",{fontCharacter:"\\ebfc"}),n.arrowCircleLeft=new n("arrow-circle-left",{fontCharacter:"\\ebfd"}),n.arrowCircleRight=new n("arrow-circle-right",{fontCharacter:"\\ebfe"}),n.arrowCircleUp=new n("arrow-circle-up",{fontCharacter:"\\ebff"}),n.heartFilled=new n("heart-filled",{fontCharacter:"\\ec04"}),n.map=new n("map",{fontCharacter:"\\ec05"}),n.mapFilled=new n("map-filled",{fontCharacter:"\\ec06"}),n.circleSmall=new n("circle-small",{fontCharacter:"\\ec07"}),n.bellSlash=new n("bell-slash",{fontCharacter:"\\ec08"}),n.bellSlashDot=new n("bell-slash-dot",{fontCharacter:"\\ec09"}),n.commentUnresolved=new n("comment-unresolved",{fontCharacter:"\\ec0a"}),n.gitPullRequestGoToChanges=new n("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),n.gitPullRequestNewChanges=new n("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function D(C,y){const b=["codicon","codicon-"+C];return y&&b.push("codicon-modifier-"+y),b}e.getClassNamesArray=D;var T;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function b(k){if(k instanceof n)return["codicon","codicon-"+k.id];const _=y.exec(k.id);if(!_)return b(n.error);const[,P,v]=_,w=["codicon","codicon-"+P];return v&&w.push("codicon-modifier-"+v.substr(1)),w}C.asClassNameArray=b;function I(k){return b(k).join(" ")}C.asClassName=I;function R(k){return"."+b(k).join(".")}C.asCSSSelector=R})(T=e.CSSIcon||(e.CSSIcon={}))}),define(Ie[78],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function u(C,y){const b=Object.create(null);for(const I of C){const R=y(I);let k=b[R];k||(k=b[R]=[]),k.push(I)}return b}e.groupBy=u;function n(C,y){const b=[],I=[];for(const R of C)y.has(R)||b.push(R);for(const R of y)C.has(R)||I.push(R);return{removed:b,added:I}}e.diffSets=n;function D(C,y){const b=[],I=[];for(const[R,k]of C)y.has(R)||b.push(k);for(const[R,k]of y)C.has(R)||I.push(k);return{removed:b,added:I}}e.diffMaps=D;class T{constructor(){this.map=new Map}add(y,b){let I=this.map.get(y);I||(I=new Set,this.map.set(y,I)),I.add(b)}delete(y,b){const I=this.map.get(y);!I||(I.delete(b),I.size===0&&this.map.delete(y))}forEach(y,b){const I=this.map.get(y);!I||I.forEach(b)}}e.SetMap=T}),define(Ie[57],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function u(C){return(y,b,I)=>{let R=null,k=null;if(typeof I.value=="function"?(R="value",k=I.value):typeof I.get=="function"&&(R="get",k=I.get),!k)throw new Error("not supported");I[R]=C(k,b)}}e.createDecorator=u;function n(C,y,b){let I=null,R=null;if(typeof b.value=="function"?(I="value",R=b.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(I="get",R=b.get),!R)throw new Error("not supported");const k=`$memoize$${y}`;b[I]=function(..._){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,_)}),this[k]}}e.memoize=n;function D(C,y,b){return u((I,R)=>{const k=`$debounce$${R}`,_=`$debounce$result$${R}`;return function(...P){this[_]||(this[_]=b?b():void 0),clearTimeout(this[k]),y&&(this[_]=y(this[_],...P),P=[this[_]]),this[k]=setTimeout(()=>{I.apply(this,P),this[_]=b?b():void 0},C)}})}e.debounce=D;function T(C,y,b){return u((I,R)=>{const k=`$throttle$timer$${R}`,_=`$throttle$result$${R}`,P=`$throttle$lastRun$${R}`,v=`$throttle$pending$${R}`;return function(...w){if(this[_]||(this[_]=b?b():void 0),(this[P]===null||this[P]===void 0)&&(this[P]=-Number.MAX_VALUE),y&&(this[_]=y(this[_],...w)),this[v])return;const p=this[P]+C;p<=Date.now()?(this[P]=Date.now(),I.apply(this,[this[_]]),this[_]=b?b():void 0):(this[v]=!0,this[k]=setTimeout(()=>{this[v]=!1,this[P]=Date.now(),I.apply(this,[this[_]]),this[_]=b?b():void 0},p-Date.now()))}})}e.throttle=T}),define(Ie[12],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class u{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(a){setTimeout(()=>{throw a.stack?g.isErrorNoTelemetry(a)?new g(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.listeners.push(a),()=>{this._removeListener(a)}}emit(a){this.listeners.forEach(d=>{d(a)})}_removeListener(a){this.listeners.splice(this.listeners.indexOf(a),1)}setUnexpectedErrorHandler(a){this.unexpectedErrorHandler=a}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(a){this.unexpectedErrorHandler(a),this.emit(a)}onUnexpectedExternalError(a){this.unexpectedErrorHandler(a)}}e.ErrorHandler=u,e.errorHandler=new u;function n(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=n;function D(m){b(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=D;function T(m){b(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=T;function C(m){if(m instanceof Error){const{name:a,message:d}=m,i=m.stacktrace||m.stack;return{$isError:!0,name:a,message:d,stack:i,noTelemetry:g.isErrorNoTelemetry(m)}}return m}e.transformErrorForSerialization=C;const y="Canceled";function b(m){return m instanceof I?!0:m instanceof Error&&m.name===y&&m.message===y}e.isCancellationError=b;class I extends Error{constructor(){super(y);this.name=this.message}}e.CancellationError=I;function R(){const m=new Error(y);return m.name=m.message,m}e.canceled=R;function k(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=k;function _(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=_;function P(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=P;function v(m){const a=new Error(`${m} has been disposed`);return a.name="DISPOSED",a}e.disposed=v;function w(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=w;class p extends Error{constructor(a){super("NotImplemented");a&&(this.message=a)}}e.NotImplementedError=p;class f extends Error{constructor(a){super("NotSupported");a&&(this.message=a)}}e.NotSupportedError=f;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;class g extends Error{constructor(a){super(a);this.name="ErrorNoTelemetry"}static fromError(a){if(a instanceof g)return a;const d=new g;return d.message=a.message,d.stack=a.stack,d}static isErrorNoTelemetry(a){return a.name==="ErrorNoTelemetry"}}e.ErrorNoTelemetry=g;class c extends Error{constructor(a){super(a||"An unexpected bug occurred.");Object.setPrototypeOf(this,c.prototype);debugger}}e.BugIndicatingError=c}),define(Ie[16],ke([0,1,12]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function n(ve,ue=0){return ve[ve.length-(1+ue)]}e.tail=n;function D(ve){if(ve.length===0)throw new Error("Invalid tail call");return[ve.slice(0,ve.length-1),ve[ve.length-1]]}e.tail2=D;function T(ve,ue,de=(we,re)=>we===re){if(ve===ue)return!0;if(!ve||!ue||ve.length!==ue.length)return!1;for(let we=0,re=ve.length;we<re;we++)if(!de(ve[we],ue[we]))return!1;return!0}e.equals=T;function C(ve,ue){const de=ve.length-1;ue<de&&(ve[ue]=ve[de]),ve.pop()}e.removeFastWithoutKeepingOrder=C;function y(ve,ue,de){return b(ve.length,we=>de(ve[we],ue))}e.binarySearch=y;function b(ve,ue){let de=0,we=ve-1;for(;de<=we;){const re=(de+we)/2|0,me=ue(re);if(me<0)de=re+1;else if(me>0)we=re-1;else return re}return-(de+1)}e.binarySearch2=b;function I(ve,ue){let de=0,we=ve.length;if(we===0)return 0;for(;de<we;){const re=Math.floor((de+we)/2);ue(ve[re])?we=re:de=re+1}return de}e.findFirstInSorted=I;function R(ve,ue,de){if(ve=ve|0,ve>=ue.length)throw new TypeError("invalid index");const we=ue[Math.floor(ue.length*Math.random())],re=[],me=[],Z=[];for(const se of ue){const O=de(se,we);O<0?re.push(se):O>0?me.push(se):Z.push(se)}return ve<re.length?R(ve,re,de):ve<re.length+Z.length?Z[0]:R(ve-(re.length+Z.length),me,de)}e.quickSelect=R;function k(ve,ue){const de=[];let we;for(const re of ve.slice(0).sort(ue))!we||ue(we[0],re)!==0?(we=[re],de.push(we)):we.push(re);return de}e.groupBy=k;function _(ve,ue,de){const we=[];function re(se,O,H){if(O===0&&H.length===0)return;const K=we[we.length-1];K&&K.start+K.deleteCount===se?(K.deleteCount+=O,K.toInsert.push(...H)):we.push({start:se,deleteCount:O,toInsert:H})}let me=0,Z=0;for(;;){if(me===ve.length){re(me,0,ue.slice(Z));break}if(Z===ue.length){re(me,ve.length-me,[]);break}const se=ve[me],O=ue[Z],H=de(se,O);H===0?(me+=1,Z+=1):H<0?(re(me,1,[]),me+=1):H>0&&(re(me,0,[O]),Z+=1)}return we}e.sortedDiff=_;function P(ve,ue,de){const we=_(ve,ue,de),re=[],me=[];for(const Z of we)re.push(...ve.slice(Z.start,Z.start+Z.deleteCount)),me.push(...Z.toInsert);return{removed:re,added:me}}e.delta=P;function v(ve,ue,de){if(de===0)return[];const we=ve.slice(0,de).sort(ue);return p(ve,ue,we,de,ve.length),we}e.top=v;function w(ve,ue,de,we,re){return de===0?Promise.resolve([]):new Promise((me,Z)=>{(async()=>{const se=ve.length,O=ve.slice(0,de).sort(ue);for(let H=de,K=Math.min(de+we,se);H<se;H=K,K=Math.min(K+we,se)){if(H>de&&await new Promise(Q=>setTimeout(Q)),re&&re.isCancellationRequested)throw new u.CancellationError;p(ve,ue,O,H,K)}return O})().then(me,Z)})}e.topAsync=w;function p(ve,ue,de,we,re){for(const me=de.length;we<re;we++){const Z=ve[we];if(ue(Z,de[me-1])<0){de.pop();const se=I(de,O=>ue(Z,O)<0);de.splice(se,0,Z)}}}function f(ve){return ve.filter(ue=>!!ue)}e.coalesce=f;function E(ve){let ue=0;for(let de=0;de<ve.length;de++)ve[de]&&(ve[ue]=ve[de],ue+=1);ve.length=ue}e.coalesceInPlace=E;function g(ve,ue,de){ve.splice(de,0,ve.splice(ue,1)[0])}e.move=g;function c(ve){return!Array.isArray(ve)||ve.length===0}e.isFalsyOrEmpty=c;function m(ve){return Array.isArray(ve)&&ve.length>0}e.isNonEmptyArray=m;function a(ve,ue=de=>de){const de=new Set;return ve.filter(we=>{const re=ue(we);return de.has(re)?!1:(de.add(re),!0)})}e.distinct=a;function d(ve){const ue=new Set;return de=>{const we=ve(de);return ue.has(we)?!1:(ue.add(we),!0)}}e.uniqueFilter=d;function i(ve,ue){const de=o(ve,ue);if(de!==-1)return ve[de]}e.findLast=i;function o(ve,ue){for(let de=ve.length-1;de>=0;de--){const we=ve[de];if(ue(we))return de}return-1}e.lastIndex=o;function r(ve,ue){return ve.length>0?ve[0]:ue}e.firstOrDefault=r;function t(ve,ue){return ve.length>0?ve[ve.length-1]:ue}e.lastOrDefault=t;function s(ve,ue,de=(we,re)=>we===re){let we=0;for(let re=0,me=Math.min(ve.length,ue.length);re<me&&de(ve[re],ue[re]);re++)we++;return we}e.commonPrefixLength=s;function l(ve){return[].concat(...ve)}e.flatten=l;function h(ve,ue){let de=typeof ue=="number"?ve:0;typeof ue=="number"?de=ve:(de=0,ue=ve);const we=[];if(de<=ue)for(let re=de;re<ue;re++)we.push(re);else for(let re=de;re>ue;re--)we.push(re);return we}e.range=h;function S(ve,ue,de){return ve.reduce((we,re)=>(we[ue(re)]=de?de(re):re,we),Object.create(null))}e.index=S;function L(ve,ue){return ve.push(ue),()=>F(ve,ue)}e.insert=L;function F(ve,ue){const de=ve.indexOf(ue);if(de>-1)return ve.splice(de,1),ue}e.remove=F;function M(ve,ue,de){const we=ve.slice(0,ue),re=ve.slice(ue);return we.concat(de,re)}e.arrayInsert=M;function A(ve,ue){let de;if(typeof ue=="number"){let we=ue;de=()=>{const re=Math.sin(we++)*179426549;return re-Math.floor(re)}}else de=Math.random;for(let we=ve.length-1;we>0;we-=1){const re=Math.floor(de()*(we+1)),me=ve[we];ve[we]=ve[re],ve[re]=me}}e.shuffle=A;function B(ve,ue){const de=ve.indexOf(ue);de>-1&&(ve.splice(de,1),ve.unshift(ue))}e.pushToStart=B;function $(ve,ue){const de=ve.indexOf(ue);de>-1&&(ve.splice(de,1),ve.push(ue))}e.pushToEnd=$;function U(ve,ue){for(const de of ue)ve.push(de)}e.pushMany=U;function X(ve,ue){return Array.isArray(ve)?ve.map(ue):ue(ve)}e.mapArrayOrNot=X;function z(ve){return Array.isArray(ve)?ve:[ve]}e.asArray=z;function N(ve){return ve[Math.floor(Math.random()*ve.length)]}e.getRandomElement=N;function V(ve,ue){for(const de of ve){const we=ue(de);if(we!==void 0)return we}}e.mapFind=V;function x(ve,ue,de){const we=te(ve,ue),re=ve.length,me=de.length;ve.length=re+me;for(let Z=re-1;Z>=we;Z--)ve[Z+me]=ve[Z];for(let Z=0;Z<me;Z++)ve[Z+we]=de[Z]}e.insertInto=x;function q(ve,ue,de,we){const re=te(ve,ue),me=ve.splice(re,de);return x(ve,re,we),me}e.splice=q;function te(ve,ue){return ue<0?Math.max(ue+ve.length,0):Math.min(ue,ve.length)}var Y;(function(ve){function ue(re){return re<0}ve.isLessThan=ue;function de(re){return re>0}ve.isGreaterThan=de;function we(re){return re===0}ve.isNeitherLessOrGreaterThan=we,ve.greaterThan=1,ve.lessThan=-1,ve.neitherLessOrGreaterThan=0})(Y=e.CompareResult||(e.CompareResult={}));function le(ve,ue){return(de,we)=>ue(ve(de),ve(we))}e.compareBy=le;function pe(...ve){return(ue,de)=>{for(const we of ve){const re=we(ue,de);if(!Y.isNeitherLessOrGreaterThan(re))return re}return Y.neitherLessOrGreaterThan}}e.tieBreakComparators=pe;const ee=(ve,ue)=>ve-ue;e.numberComparator=ee;function ge(ve,ue){if(ve.length===0)return;let de=ve[0];for(let we=1;we<ve.length;we++){const re=ve[we];ue(re,de)>0&&(de=re)}return de}e.findMaxBy=ge;function Ee(ve,ue){if(ve.length===0)return;let de=ve[0];for(let we=1;we<ve.length;we++){const re=ve[we];ue(re,de)>=0&&(de=re)}return de}e.findLastMaxBy=Ee;function Pe(ve,ue){return ge(ve,(de,we)=>-ue(de,we))}e.findMinBy=Pe;class Ne{constructor(ue){this.items=ue,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ue){let de=this.firstIdx;for(;de<this.items.length&&ue(this.items[de]);)de++;const we=de===this.firstIdx?null:this.items.slice(this.firstIdx,de);return this.firstIdx=de,we}takeFromEndWhile(ue){let de=this.lastIdx;for(;de>=0&&ue(this.items[de]);)de--;const we=de===this.lastIdx?null:this.items.slice(de+1,this.lastIdx+1);return this.lastIdx=de,we}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ue=this.items[this.firstIdx];return this.firstIdx++,ue}removeLast(){const ue=this.items[this.lastIdx];return this.lastIdx--,ue}takeCount(ue){const de=this.items.slice(this.firstIdx,this.firstIdx+ue);return this.firstIdx+=ue,de}}e.ArrayQueue=Ne}),define(Ie[58],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function u(n){const D=this;let T=!1,C;return function(){return T||(T=!0,C=n.apply(D,arguments)),C}}e.once=u}),define(Ie[93],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class u{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=u,e.defaultGenerator=new u("id#")}),define(Ie[59],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var u;(function(n){function D(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}n.is=D;const T=Object.freeze([]);function C(){return T}n.empty=C;function*y(d){yield d}n.single=y;function b(d){return d||T}n.from=b;function I(d){return!d||d[Symbol.iterator]().next().done===!0}n.isEmpty=I;function R(d){return d[Symbol.iterator]().next().value}n.first=R;function k(d,i){for(const o of d)if(i(o))return!0;return!1}n.some=k;function _(d,i){for(const o of d)if(i(o))return o}n.find=_;function*P(d,i){for(const o of d)i(o)&&(yield o)}n.filter=P;function*v(d,i){let o=0;for(const r of d)yield i(r,o++)}n.map=v;function*w(...d){for(const i of d)for(const o of i)yield o}n.concat=w;function*p(d){for(const i of d)for(const o of i)yield o}n.concatNested=p;function f(d,i,o){let r=o;for(const t of d)r=i(r,t);return r}n.reduce=f;function E(d,i){let o=0;for(const r of d)i(r,o++)}n.forEach=E;function*g(d,i,o=d.length){for(i<0&&(i+=d.length),o<0?o+=d.length:o>d.length&&(o=d.length);i<o;i++)yield d[i]}n.slice=g;function c(d,i=Number.POSITIVE_INFINITY){const o=[];if(i===0)return[o,d];const r=d[Symbol.iterator]();for(let t=0;t<i;t++){const s=r.next();if(s.done)return[o,n.empty()];o.push(s.value)}return[o,{[Symbol.iterator](){return r}}]}n.consume=c;function m(d){return c(d)[0]}n.collect=m;function a(d,i,o=(r,t)=>r===t){const r=d[Symbol.iterator](),t=i[Symbol.iterator]();for(;;){const s=r.next(),l=t.next();if(s.done!==l.done)return!1;if(s.done)return!0;if(!o(s.value,l.value))return!1}}n.equals=a})(u=e.Iterable||(e.Iterable={}))}),define(Ie[142],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var u;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(u=e.ScanError||(e.ScanError={}));var n;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(a){a.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function C(a,d=!1){let i=0;const o=a.length;let r="",t=0,s=16,l=0;function h($){let U=0,X=0;for(;U<$;){const z=a.charCodeAt(i);if(z>=48&&z<=57)X=X*16+z-48;else if(z>=65&&z<=70)X=X*16+z-65+10;else if(z>=97&&z<=102)X=X*16+z-97+10;else break;i++,U++}return U<$&&(X=-1),X}function S($){i=$,r="",t=0,s=16,l=0}function L(){const $=i;if(a.charCodeAt(i)===48)i++;else for(i++;i<a.length&&I(a.charCodeAt(i));)i++;if(i<a.length&&a.charCodeAt(i)===46)if(i++,i<a.length&&I(a.charCodeAt(i)))for(i++;i<a.length&&I(a.charCodeAt(i));)i++;else return l=3,a.substring($,i);let U=i;if(i<a.length&&(a.charCodeAt(i)===69||a.charCodeAt(i)===101))if(i++,(i<a.length&&a.charCodeAt(i)===43||a.charCodeAt(i)===45)&&i++,i<a.length&&I(a.charCodeAt(i))){for(i++;i<a.length&&I(a.charCodeAt(i));)i++;U=i}else l=3;return a.substring($,U)}function F(){let $="",U=i;for(;;){if(i>=o){$+=a.substring(U,i),l=2;break}const X=a.charCodeAt(i);if(X===34){$+=a.substring(U,i),i++;break}if(X===92){if($+=a.substring(U,i),i++,i>=o){l=2;break}switch(a.charCodeAt(i++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const N=h(4);N>=0?$+=String.fromCharCode(N):l=4;break}default:l=5}U=i;continue}if(X>=0&&X<=31)if(b(X)){$+=a.substring(U,i),l=2;break}else l=6;i++}return $}function M(){if(r="",l=0,t=i,i>=o)return t=o,s=17;let $=a.charCodeAt(i);if(y($)){do i++,r+=String.fromCharCode($),$=a.charCodeAt(i);while(y($));return s=15}if(b($))return i++,r+=String.fromCharCode($),$===13&&a.charCodeAt(i)===10&&(i++,r+=`
`),s=14;switch($){case 123:return i++,s=1;case 125:return i++,s=2;case 91:return i++,s=3;case 93:return i++,s=4;case 58:return i++,s=6;case 44:return i++,s=5;case 34:return i++,r=F(),s=10;case 47:{const U=i-1;if(a.charCodeAt(i+1)===47){for(i+=2;i<o&&!b(a.charCodeAt(i));)i++;return r=a.substring(U,i),s=12}if(a.charCodeAt(i+1)===42){i+=2;const X=o-1;let z=!1;for(;i<X;){if(a.charCodeAt(i)===42&&a.charCodeAt(i+1)===47){i+=2,z=!0;break}i++}return z||(i++,l=1),r=a.substring(U,i),s=13}return r+=String.fromCharCode($),i++,s=16}case 45:if(r+=String.fromCharCode($),i++,i===o||!I(a.charCodeAt(i)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=L(),s=11;default:for(;i<o&&A($);)i++,$=a.charCodeAt(i);if(t!==i){switch(r=a.substring(t,i),r){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return r+=String.fromCharCode($),i++,s=16}}function A($){if(y($)||b($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function B(){let $;do $=M();while($>=12&&$<=15);return $}return{setPosition:S,getPosition:()=>i,scan:d?B:M,getToken:()=>s,getTokenValue:()=>r,getTokenOffset:()=>t,getTokenLength:()=>i-t,getTokenError:()=>l}}e.createScanner=C;function y(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function b(a){return a===10||a===13||a===8232||a===8233}function I(a){return a>=48&&a<=57}var R;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(R||(R={}));function k(a,d){const i=[],o=new Object;let r;const t={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function l(h,S,L,F){t.value=h,t.offset=S,t.length=L,t.type=F,t.colonOffset=void 0,r=t}try{g(a,{onObjectBegin:(h,S)=>{if(d<=h)throw o;r=void 0,s=d>h,i.push("")},onObjectProperty:(h,S,L)=>{if(d<S||(l(h,S,L,"property"),i[i.length-1]=h,d<=S+L))throw o},onObjectEnd:(h,S)=>{if(d<=h)throw o;r=void 0,i.pop()},onArrayBegin:(h,S)=>{if(d<=h)throw o;r=void 0,i.push(0)},onArrayEnd:(h,S)=>{if(d<=h)throw o;r=void 0,i.pop()},onLiteralValue:(h,S,L)=>{if(d<S||(l(h,S,L,m(h)),d<=S+L))throw o},onSeparator:(h,S,L)=>{if(d<=S)throw o;if(h===":"&&r&&r.type==="property")r.colonOffset=S,s=!1,r=void 0;else if(h===","){const F=i[i.length-1];typeof F=="number"?i[i.length-1]=F+1:(s=!0,i[i.length-1]=""),r=void 0}}})}catch(h){if(h!==o)throw h}return{path:i,previousNode:r,isAtPropertyKey:s,matches:h=>{let S=0;for(let L=0;S<h.length&&L<i.length;L++)if(h[S]===i[L]||h[S]==="*")S++;else if(h[S]!=="**")return!1;return S===h.length}}}e.getLocation=k;function _(a,d=[],i=T.DEFAULT){let o=null,r=[];const t=[];function s(h){Array.isArray(r)?r.push(h):o!==null&&(r[o]=h)}return g(a,{onObjectBegin:()=>{const h={};s(h),t.push(r),r=h,o=null},onObjectProperty:h=>{o=h},onObjectEnd:()=>{r=t.pop()},onArrayBegin:()=>{const h=[];s(h),t.push(r),r=h,o=null},onArrayEnd:()=>{r=t.pop()},onLiteralValue:s,onError:(h,S,L)=>{d.push({error:h,offset:S,length:L})}},i),r[0]}e.parse=_;function P(a,d=[],i=T.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(h){o.type==="property"&&(o.length=h-o.offset,o=o.parent)}function t(h){return o.children.push(h),h}g(a,{onObjectBegin:h=>{o=t({type:"object",offset:h,length:-1,parent:o,children:[]})},onObjectProperty:(h,S,L)=>{o=t({type:"property",offset:S,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:h,offset:S,length:L,parent:o})},onObjectEnd:(h,S)=>{o.length=h+S-o.offset,o=o.parent,r(h+S)},onArrayBegin:(h,S)=>{o=t({type:"array",offset:h,length:-1,parent:o,children:[]})},onArrayEnd:(h,S)=>{o.length=h+S-o.offset,o=o.parent,r(h+S)},onLiteralValue:(h,S,L)=>{t({type:m(h),offset:S,length:L,parent:o,value:h}),r(S+L)},onSeparator:(h,S,L)=>{o.type==="property"&&(h===":"?o.colonOffset=S:h===","&&r(S))},onError:(h,S,L)=>{d.push({error:h,offset:S,length:L})}},i);const l=o.children[0];return l&&delete l.parent,l}e.parseTree=P;function v(a,d){if(!a)return;let i=a;for(const o of d)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const t of i.children)if(Array.isArray(t.children)&&t.children[0].value===o){i=t.children[1],r=!0;break}if(!r)return}else{const r=o;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=v;function w(a){if(!a.parent||!a.parent.children)return[];const d=w(a.parent);if(a.parent.type==="property"){const i=a.parent.children[0].value;d.push(i)}else if(a.parent.type==="array"){const i=a.parent.children.indexOf(a);i!==-1&&d.push(i)}return d}e.getNodePath=w;function p(a){switch(a.type){case"array":return a.children.map(p);case"object":{const d=Object.create(null);for(const i of a.children){const o=i.children[1];o&&(d[i.children[0].value]=p(o))}return d}case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=p;function f(a,d,i=!1){return d>=a.offset&&d<a.offset+a.length||i&&d===a.offset+a.length}e.contains=f;function E(a,d,i=!1){if(f(a,d,i)){const o=a.children;if(Array.isArray(o))for(let r=0;r<o.length&&o[r].offset<=d;r++){const t=E(o[r],d,i);if(t)return t}return a}}e.findNodeAtOffset=E;function g(a,d,i=T.DEFAULT){const o=C(a,!1);function r(le){return le?()=>le(o.getTokenOffset(),o.getTokenLength()):()=>!0}function t(le){return le?pe=>le(pe,o.getTokenOffset(),o.getTokenLength()):()=>!0}const s=r(d.onObjectBegin),l=t(d.onObjectProperty),h=r(d.onObjectEnd),S=r(d.onArrayBegin),L=r(d.onArrayEnd),F=t(d.onLiteralValue),M=t(d.onSeparator),A=r(d.onComment),B=t(d.onError),$=i&&i.disallowComments,U=i&&i.allowTrailingComma;function X(){for(;;){const le=o.scan();switch(o.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:$||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(le){case 12:case 13:$?z(10):A();break;case 16:z(1);break;case 15:case 14:break;default:return le}}}function z(le,pe=[],ee=[]){if(B(le),pe.length+ee.length>0){let ge=o.getToken();for(;ge!==17;){if(pe.indexOf(ge)!==-1){X();break}else if(ee.indexOf(ge)!==-1)break;ge=X()}}}function N(le){const pe=o.getTokenValue();return le?F(pe):l(pe),X(),!0}function V(){switch(o.getToken()){case 11:{let le=0;try{le=JSON.parse(o.getTokenValue()),typeof le!="number"&&(z(2),le=0)}catch{z(2)}F(le);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return X(),!0}function x(){return o.getToken()!==10?(z(3,[],[2,5]),!1):(N(!1),o.getToken()===6?(M(":"),X(),Y()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function q(){s(),X();let le=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(le||z(4,[],[]),M(","),X(),o.getToken()===2&&U)break}else le&&z(6,[],[]);x()||z(4,[],[2,5]),le=!0}return h(),o.getToken()!==2?z(7,[2],[]):X(),!0}function te(){S(),X();let le=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(le||z(4,[],[]),M(","),X(),o.getToken()===4&&U)break}else le&&z(6,[],[]);Y()||z(4,[],[4,5]),le=!0}return L(),o.getToken()!==4?z(8,[4],[]):X(),!0}function Y(){switch(o.getToken()){case 3:return te();case 1:return q();case 10:return N(!0);default:return V()}}return X(),o.getToken()===17?i.allowEmptyContent?!0:(z(4,[],[]),!1):Y()?(o.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=g;function c(a,d){const i=C(a),o=[];let r,t=0,s;do switch(s=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:t!==s&&o.push(a.substring(t,s)),d!==void 0&&o.push(i.getTokenValue().replace(/[^\r\n]/g,d)),t=i.getPosition();break}while(r!==17);return o.join("")}e.stripComments=c;function m(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(Ie[79],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class u{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new u(()=>D(this.getValue()))}}e.Lazy=u}),define(Ie[6],ke([0,1,58,59]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let T=null;function C(r){T=r}if(e.setDisposableTracker=C,D){const r="__is_disposable_tracked__";C(new class{trackDisposable(t){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{t[r]||console.log(s)},3e3)}setParent(t,s){if(t&&t!==E.None)try{t[r]=!0}catch{}}markAsDisposed(t){if(t&&t!==E.None)try{t[r]=!0}catch{}}markAsSingleton(t){}})}function y(r){return T?.trackDisposable(r),r}function b(r){T?.markAsDisposed(r)}function I(r,t){T?.setParent(r,t)}function R(r,t){if(!!T)for(const s of r)T.setParent(s,t)}function k(r){return T?.markAsSingleton(r),r}e.markAsSingleton=k;class _ extends Error{constructor(t){super(`Encountered errors while disposing of store. Errors: [${t.join(", ")}]`);this.errors=t}}e.MultiDisposeError=_;function P(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=P;function v(r){if(n.Iterable.is(r)){const t=[];for(const s of r)if(s)try{s.dispose()}catch(l){t.push(l)}if(t.length===1)throw t[0];if(t.length>1)throw new _(t);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=v;function w(...r){const t=p(()=>v(r));return R(r,t),t}e.combinedDisposable=w;function p(r){const t=y({dispose:(0,u.once)(()=>{b(t),r()})});return t}e.toDisposable=p;class f{constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{v(this._toDispose.values())}finally{this._toDispose.clear()}}add(t){if(!t)return t;if(t===this)throw new Error("Cannot register a disposable on itself!");return I(t,this),this._isDisposed?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(t),t}}e.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class E{constructor(){this._store=new f,y(this),I(this._store,this)}dispose(){b(this),this._store.dispose()}_register(t){if(t===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(t)}}e.Disposable=E,E.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(t){this._isDisposed||t===this._value||(this._value?.dispose(),t&&I(t,this),this._value=t)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const t=this._value;return this._value=void 0,t&&I(t,null),t}}e.MutableDisposable=g;class c{constructor(t){this._disposable=t,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(t){let s=t;return this.unset=()=>s=void 0,this.isset=()=>s!==void 0,this.dispose=()=>{s&&(s(),s=void 0,b(this))},this}}e.SafeDisposable=m;class a{constructor(){this.references=new Map}acquire(t,...s){let l=this.references.get(t);l||(l={counter:0,object:this.createReferencedObject(t,...s)},this.references.set(t,l));const{object:h}=l,S=(0,u.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(t,l.object),this.references.delete(t))});return l.counter++,{object:h,dispose:S}}}e.ReferenceCollection=a;class d{constructor(t){this.referenceCollection=t}async acquire(t,...s){const l=this.referenceCollection.acquire(t,...s);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(h){throw l.dispose(),h}}}e.AsyncReferenceCollection=d;class i{constructor(t){this.object=t}dispose(){}}e.ImmortalReference=i;function o(r){const t=new f;try{r(t)}finally{t.dispose()}}e.disposeOnReturn=o}),define(Ie[80],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class u{constructor(T){this.element=T,this.next=u.Undefined,this.prev=u.Undefined}}u.Undefined=new u(void 0);class n{constructor(){this._first=u.Undefined,this._last=u.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===u.Undefined}clear(){let T=this._first;for(;T!==u.Undefined;){const C=T.next;T.prev=u.Undefined,T.next=u.Undefined,T=C}this._first=u.Undefined,this._last=u.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,C){const y=new u(T);if(this._first===u.Undefined)this._first=y,this._last=y;else if(C){const I=this._last;this._last=y,y.prev=I,I.next=y}else{const I=this._first;this._first=y,y.next=I,I.prev=y}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(y))}}shift(){if(this._first!==u.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==u.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==u.Undefined&&T.next!==u.Undefined){const C=T.prev;C.next=T.next,T.next.prev=C}else T.prev===u.Undefined&&T.next===u.Undefined?(this._first=u.Undefined,this._last=u.Undefined):T.next===u.Undefined?(this._last=this._last.prev,this._last.next=u.Undefined):T.prev===u.Undefined&&(this._first=this._first.next,this._first.prev=u.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==u.Undefined;)yield T.element,T=T.next}}e.LinkedList=n}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(Ie[143],ke([1]),e):(J=typeof globalThis!="undefined"?globalThis:J||self,e(J.marked={}))}(this,function(J){"use strict";function e(ue,de){for(var we=0;we<de.length;we++){var re=de[we];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(ue,re.key,re)}}function u(ue,de,we){return de&&e(ue.prototype,de),we&&e(ue,we),Object.defineProperty(ue,"prototype",{writable:!1}),ue}function n(ue,de){if(!!ue){if(typeof ue=="string")return D(ue,de);var we=Object.prototype.toString.call(ue).slice(8,-1);if(we==="Object"&&ue.constructor&&(we=ue.constructor.name),we==="Map"||we==="Set")return Array.from(ue);if(we==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(we))return D(ue,de)}}function D(ue,de){(de==null||de>ue.length)&&(de=ue.length);for(var we=0,re=new Array(de);we<de;we++)re[we]=ue[we];return re}function T(ue,de){var we=typeof Symbol!="undefined"&&ue[Symbol.iterator]||ue["@@iterator"];if(we)return(we=we.call(ue)).next.bind(we);if(Array.isArray(ue)||(we=n(ue))||de&&ue&&typeof ue.length=="number"){we&&(ue=we);var re=0;return function(){return re>=ue.length?{done:!0}:{done:!1,value:ue[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}J.defaults=C();function y(ue){J.defaults=ue}var b=/[&<>"']/,I=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,_={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},P=function(de){return _[de]};function v(ue,de){if(de){if(b.test(ue))return ue.replace(I,P)}else if(R.test(ue))return ue.replace(k,P);return ue}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function p(ue){return ue.replace(w,function(de,we){return we=we.toLowerCase(),we==="colon"?":":we.charAt(0)==="#"?we.charAt(1)==="x"?String.fromCharCode(parseInt(we.substring(2),16)):String.fromCharCode(+we.substring(1)):""})}var f=/(^|[^\[])\^/g;function E(ue,de){ue=typeof ue=="string"?ue:ue.source,de=de||"";var we={replace:function(me,Z){return Z=Z.source||Z,Z=Z.replace(f,"$1"),ue=ue.replace(me,Z),we},getRegex:function(){return new RegExp(ue,de)}};return we}var g=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(ue,de,we){if(ue){var re;try{re=decodeURIComponent(p(we)).replace(g,"").toLowerCase()}catch{return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}de&&!c.test(we)&&(we=r(de,we));try{we=encodeURI(we).replace(/%25/g,"%")}catch{return null}return we}var a={},d=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(ue,de){a[" "+ue]||(d.test(ue)?a[" "+ue]=ue+"/":a[" "+ue]=h(ue,"/",!0)),ue=a[" "+ue];var we=ue.indexOf(":")===-1;return de.substring(0,2)==="//"?we?de:ue.replace(i,"$1")+de:de.charAt(0)==="/"?we?de:ue.replace(o,"$1")+de:ue+de}var t={exec:function(){}};function s(ue){for(var de=1,we,re;de<arguments.length;de++){we=arguments[de];for(re in we)Object.prototype.hasOwnProperty.call(we,re)&&(ue[re]=we[re])}return ue}function l(ue,de){var we=ue.replace(/\|/g,function(Z,se,O){for(var H=!1,K=se;--K>=0&&O[K]==="\\";)H=!H;return H?"|":" |"}),re=we.split(/ \|/),me=0;if(re[0].trim()||re.shift(),re.length>0&&!re[re.length-1].trim()&&re.pop(),re.length>de)re.splice(de);else for(;re.length<de;)re.push("");for(;me<re.length;me++)re[me]=re[me].trim().replace(/\\\|/g,"|");return re}function h(ue,de,we){var re=ue.length;if(re===0)return"";for(var me=0;me<re;){var Z=ue.charAt(re-me-1);if(Z===de&&!we)me++;else if(Z!==de&&we)me++;else break}return ue.slice(0,re-me)}function S(ue,de){if(ue.indexOf(de[1])===-1)return-1;for(var we=ue.length,re=0,me=0;me<we;me++)if(ue[me]==="\\")me++;else if(ue[me]===de[0])re++;else if(ue[me]===de[1]&&(re--,re<0))return me;return-1}function L(ue){ue&&ue.sanitize&&!ue.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(ue,de){if(de<1)return"";for(var we="";de>1;)de&1&&(we+=ue),de>>=1,ue+=ue;return we+ue}function M(ue,de,we,re){var me=de.href,Z=de.title?v(de.title):null,se=ue[1].replace(/\\([\[\]])/g,"$1");if(ue[0].charAt(0)!=="!"){re.state.inLink=!0;var O={type:"link",raw:we,href:me,title:Z,text:se,tokens:re.inlineTokens(se,[])};return re.state.inLink=!1,O}return{type:"image",raw:we,href:me,title:Z,text:v(se)}}function A(ue,de){var we=ue.match(/^(\s+)(?:```)/);if(we===null)return de;var re=we[1];return de.split(`
`).map(function(me){var Z=me.match(/^\s+/);if(Z===null)return me;var se=Z[0];return se.length>=re.length?me.slice(re.length):me}).join(`
`)}var B=function(){function ue(we){this.options=we||J.defaults}var de=ue.prototype;return de.space=function(re){var me=this.rules.block.newline.exec(re);if(me&&me[0].length>0)return{type:"space",raw:me[0]}},de.code=function(re){var me=this.rules.block.code.exec(re);if(me){var Z=me[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:me[0],codeBlockStyle:"indented",text:this.options.pedantic?Z:h(Z,`
`)}}},de.fences=function(re){var me=this.rules.block.fences.exec(re);if(me){var Z=me[0],se=A(Z,me[3]||"");return{type:"code",raw:Z,lang:me[2]?me[2].trim():me[2],text:se}}},de.heading=function(re){var me=this.rules.block.heading.exec(re);if(me){var Z=me[2].trim();if(/#$/.test(Z)){var se=h(Z,"#");(this.options.pedantic||!se||/ $/.test(se))&&(Z=se.trim())}var O={type:"heading",raw:me[0],depth:me[1].length,text:Z,tokens:[]};return this.lexer.inline(O.text,O.tokens),O}},de.hr=function(re){var me=this.rules.block.hr.exec(re);if(me)return{type:"hr",raw:me[0]}},de.blockquote=function(re){var me=this.rules.block.blockquote.exec(re);if(me){var Z=me[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:me[0],tokens:this.lexer.blockTokens(Z,[]),text:Z}}},de.list=function(re){var me=this.rules.block.list.exec(re);if(me){var Z,se,O,H,K,Q,he,be,ce,De,ye,Be,qe=me[1].trim(),et=qe.length>1,Xe={type:"list",raw:"",ordered:et,start:et?+qe.slice(0,-1):"",loose:!1,items:[]};qe=et?"\\d{1,9}\\"+qe.slice(-1):"\\"+qe,this.options.pedantic&&(qe=et?qe:"[*+-]");for(var Oe=new RegExp("^( {0,3}"+qe+")((?:[	 ][^\\n]*)?(?:\\n|$))");re&&(Be=!1,!(!(me=Oe.exec(re))||this.rules.block.hr.test(re)));){if(Z=me[0],re=re.substring(Z.length),be=me[2].split(`
`,1)[0],ce=re.split(`
`,1)[0],this.options.pedantic?(H=2,ye=be.trimLeft()):(H=me[2].search(/[^ ]/),H=H>4?1:H,ye=be.slice(H),H+=me[1].length),Q=!1,!be&&/^ *$/.test(ce)&&(Z+=ce+`
`,re=re.substring(ce.length+1),Be=!0),!Be)for(var ot=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ie=new RegExp("^ {0,"+Math.min(3,H-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");re&&(De=re.split(`
`,1)[0],be=De,this.options.pedantic&&(be=be.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ot.test(be)||ie.test(re)));){if(be.search(/[^ ]/)>=H||!be.trim())ye+=`
`+be.slice(H);else if(!Q)ye+=`
`+be;else break;!Q&&!be.trim()&&(Q=!0),Z+=De+`
`,re=re.substring(De.length+1)}Xe.loose||(he?Xe.loose=!0:/\n *\n *$/.test(Z)&&(he=!0)),this.options.gfm&&(se=/^\[[ xX]\] /.exec(ye),se&&(O=se[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:Z,task:!!se,checked:O,loose:!1,text:ye}),Xe.raw+=Z}Xe.items[Xe.items.length-1].raw=Z.trimRight(),Xe.items[Xe.items.length-1].text=ye.trimRight(),Xe.raw=Xe.raw.trimRight();var oe=Xe.items.length;for(K=0;K<oe;K++){this.lexer.state.top=!1,Xe.items[K].tokens=this.lexer.blockTokens(Xe.items[K].text,[]);var G=Xe.items[K].tokens.filter(function(Re){return Re.type==="space"}),Ce=G.every(function(Re){for(var We=Re.raw.split(""),ze=0,$e=T(We),tt;!(tt=$e()).done;){var st=tt.value;if(st===`
`&&(ze+=1),ze>1)return!0}return!1});!Xe.loose&&G.length&&Ce&&(Xe.loose=!0,Xe.items[K].loose=!0)}return Xe}},de.html=function(re){var me=this.rules.block.html.exec(re);if(me){var Z={type:"html",raw:me[0],pre:!this.options.sanitizer&&(me[1]==="pre"||me[1]==="script"||me[1]==="style"),text:me[0]};return this.options.sanitize&&(Z.type="paragraph",Z.text=this.options.sanitizer?this.options.sanitizer(me[0]):v(me[0]),Z.tokens=[],this.lexer.inline(Z.text,Z.tokens)),Z}},de.def=function(re){var me=this.rules.block.def.exec(re);if(me){me[3]&&(me[3]=me[3].substring(1,me[3].length-1));var Z=me[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Z,raw:me[0],href:me[2],title:me[3]}}},de.table=function(re){var me=this.rules.block.table.exec(re);if(me){var Z={type:"table",header:l(me[1]).map(function(he){return{text:he}}),align:me[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:me[3]&&me[3].trim()?me[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Z.header.length===Z.align.length){Z.raw=me[0];var se=Z.align.length,O,H,K,Q;for(O=0;O<se;O++)/^ *-+: *$/.test(Z.align[O])?Z.align[O]="right":/^ *:-+: *$/.test(Z.align[O])?Z.align[O]="center":/^ *:-+ *$/.test(Z.align[O])?Z.align[O]="left":Z.align[O]=null;for(se=Z.rows.length,O=0;O<se;O++)Z.rows[O]=l(Z.rows[O],Z.header.length).map(function(he){return{text:he}});for(se=Z.header.length,H=0;H<se;H++)Z.header[H].tokens=[],this.lexer.inline(Z.header[H].text,Z.header[H].tokens);for(se=Z.rows.length,H=0;H<se;H++)for(Q=Z.rows[H],K=0;K<Q.length;K++)Q[K].tokens=[],this.lexer.inline(Q[K].text,Q[K].tokens);return Z}}},de.lheading=function(re){var me=this.rules.block.lheading.exec(re);if(me){var Z={type:"heading",raw:me[0],depth:me[2].charAt(0)==="="?1:2,text:me[1],tokens:[]};return this.lexer.inline(Z.text,Z.tokens),Z}},de.paragraph=function(re){var me=this.rules.block.paragraph.exec(re);if(me){var Z={type:"paragraph",raw:me[0],text:me[1].charAt(me[1].length-1)===`
`?me[1].slice(0,-1):me[1],tokens:[]};return this.lexer.inline(Z.text,Z.tokens),Z}},de.text=function(re){var me=this.rules.block.text.exec(re);if(me){var Z={type:"text",raw:me[0],text:me[0],tokens:[]};return this.lexer.inline(Z.text,Z.tokens),Z}},de.escape=function(re){var me=this.rules.inline.escape.exec(re);if(me)return{type:"escape",raw:me[0],text:v(me[1])}},de.tag=function(re){var me=this.rules.inline.tag.exec(re);if(me)return!this.lexer.state.inLink&&/^<a /i.test(me[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(me[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(me[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(me[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:me[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):v(me[0]):me[0]}},de.link=function(re){var me=this.rules.inline.link.exec(re);if(me){var Z=me[2].trim();if(!this.options.pedantic&&/^</.test(Z)){if(!/>$/.test(Z))return;var se=h(Z.slice(0,-1),"\\");if((Z.length-se.length)%2==0)return}else{var O=S(me[2],"()");if(O>-1){var H=me[0].indexOf("!")===0?5:4,K=H+me[1].length+O;me[2]=me[2].substring(0,O),me[0]=me[0].substring(0,K).trim(),me[3]=""}}var Q=me[2],he="";if(this.options.pedantic){var be=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Q);be&&(Q=be[1],he=be[3])}else he=me[3]?me[3].slice(1,-1):"";return Q=Q.trim(),/^</.test(Q)&&(this.options.pedantic&&!/>$/.test(Z)?Q=Q.slice(1):Q=Q.slice(1,-1)),M(me,{href:Q&&Q.replace(this.rules.inline._escapes,"$1"),title:he&&he.replace(this.rules.inline._escapes,"$1")},me[0],this.lexer)}},de.reflink=function(re,me){var Z;if((Z=this.rules.inline.reflink.exec(re))||(Z=this.rules.inline.nolink.exec(re))){var se=(Z[2]||Z[1]).replace(/\s+/g," ");if(se=me[se.toLowerCase()],!se||!se.href){var O=Z[0].charAt(0);return{type:"text",raw:O,text:O}}return M(Z,se,Z[0],this.lexer)}},de.emStrong=function(re,me,Z){Z===void 0&&(Z="");var se=this.rules.inline.emStrong.lDelim.exec(re);if(!!se&&!(se[3]&&Z.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var O=se[1]||se[2]||"";if(!O||O&&(Z===""||this.rules.inline.punctuation.exec(Z))){var H=se[0].length-1,K,Q,he=H,be=0,ce=se[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ce.lastIndex=0,me=me.slice(-1*re.length+H);(se=ce.exec(me))!=null;)if(K=se[1]||se[2]||se[3]||se[4]||se[5]||se[6],!!K){if(Q=K.length,se[3]||se[4]){he+=Q;continue}else if((se[5]||se[6])&&H%3&&!((H+Q)%3)){be+=Q;continue}if(he-=Q,!(he>0)){if(Q=Math.min(Q,Q+he+be),Math.min(H,Q)%2){var De=re.slice(1,H+se.index+Q);return{type:"em",raw:re.slice(0,H+se.index+Q+1),text:De,tokens:this.lexer.inlineTokens(De,[])}}var ye=re.slice(2,H+se.index+Q-1);return{type:"strong",raw:re.slice(0,H+se.index+Q+1),text:ye,tokens:this.lexer.inlineTokens(ye,[])}}}}}},de.codespan=function(re){var me=this.rules.inline.code.exec(re);if(me){var Z=me[2].replace(/\n/g," "),se=/[^ ]/.test(Z),O=/^ /.test(Z)&&/ $/.test(Z);return se&&O&&(Z=Z.substring(1,Z.length-1)),Z=v(Z,!0),{type:"codespan",raw:me[0],text:Z}}},de.br=function(re){var me=this.rules.inline.br.exec(re);if(me)return{type:"br",raw:me[0]}},de.del=function(re){var me=this.rules.inline.del.exec(re);if(me)return{type:"del",raw:me[0],text:me[2],tokens:this.lexer.inlineTokens(me[2],[])}},de.autolink=function(re,me){var Z=this.rules.inline.autolink.exec(re);if(Z){var se,O;return Z[2]==="@"?(se=v(this.options.mangle?me(Z[1]):Z[1]),O="mailto:"+se):(se=v(Z[1]),O=se),{type:"link",raw:Z[0],text:se,href:O,tokens:[{type:"text",raw:se,text:se}]}}},de.url=function(re,me){var Z;if(Z=this.rules.inline.url.exec(re)){var se,O;if(Z[2]==="@")se=v(this.options.mangle?me(Z[0]):Z[0]),O="mailto:"+se;else{var H;do H=Z[0],Z[0]=this.rules.inline._backpedal.exec(Z[0])[0];while(H!==Z[0]);se=v(Z[0]),Z[1]==="www."?O="http://"+se:O=se}return{type:"link",raw:Z[0],text:se,href:O,tokens:[{type:"text",raw:se,text:se}]}}},de.inlineText=function(re,me){var Z=this.rules.inline.text.exec(re);if(Z){var se;return this.lexer.state.inRawBlock?se=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):v(Z[0]):Z[0]:se=v(this.options.smartypants?me(Z[0]):Z[0]),{type:"text",raw:Z[0],text:se}}},ue}(),$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:t,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=E($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.listItemStart=E(/^( *)(bull) */).replace("bull",$.bullet).getRegex(),$.list=E($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=E($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=E($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.blockquote=E($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=s({},$),$.gfm=s({},$.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.table=E($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.gfm.paragraph=E($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",$.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.pedantic=s({},$.normal,{html:E(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:t,paragraph:E($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var U={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:t,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:t,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};U._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",U.punctuation=E(U.punctuation).replace(/punctuation/g,U._punctuation).getRegex(),U.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,U.escapedEmSt=/\\\*|\\_/g,U._comment=E($._comment).replace("(?:-->|$)","-->").getRegex(),U.emStrong.lDelim=E(U.emStrong.lDelim).replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimAst=E(U.emStrong.rDelimAst,"g").replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimUnd=E(U.emStrong.rDelimUnd,"g").replace(/punct/g,U._punctuation).getRegex(),U._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,U._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,U._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,U.autolink=E(U.autolink).replace("scheme",U._scheme).replace("email",U._email).getRegex(),U._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,U.tag=E(U.tag).replace("comment",U._comment).replace("attribute",U._attribute).getRegex(),U._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,U._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,U._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,U.link=E(U.link).replace("label",U._label).replace("href",U._href).replace("title",U._title).getRegex(),U.reflink=E(U.reflink).replace("label",U._label).replace("ref",$._label).getRegex(),U.nolink=E(U.nolink).replace("ref",$._label).getRegex(),U.reflinkSearch=E(U.reflinkSearch,"g").replace("reflink",U.reflink).replace("nolink",U.nolink).getRegex(),U.normal=s({},U),U.pedantic=s({},U.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:E(/^!?\[(label)\]\((.*?)\)/).replace("label",U._label).getRegex(),reflink:E(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",U._label).getRegex()}),U.gfm=s({},U.normal,{escape:E(U.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),U.gfm.url=E(U.gfm.url,"i").replace("email",U.gfm._extended_email).getRegex(),U.breaks=s({},U.gfm,{br:E(U.br).replace("{2,}","*").getRegex(),text:E(U.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function X(ue){return ue.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(ue){var de="",we,re,me=ue.length;for(we=0;we<me;we++)re=ue.charCodeAt(we),Math.random()>.5&&(re="x"+re.toString(16)),de+="&#"+re+";";return de}var N=function(){function ue(we){this.tokens=[],this.tokens.links=Object.create(null),this.options=we||J.defaults,this.options.tokenizer=this.options.tokenizer||new B,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:$.normal,inline:U.normal};this.options.pedantic?(re.block=$.pedantic,re.inline=U.pedantic):this.options.gfm&&(re.block=$.gfm,this.options.breaks?re.inline=U.breaks:re.inline=U.gfm),this.tokenizer.rules=re}ue.lex=function(re,me){var Z=new ue(me);return Z.lex(re)},ue.lexInline=function(re,me){var Z=new ue(me);return Z.inlineTokens(re)};var de=ue.prototype;return de.lex=function(re){re=re.replace(/\r\n|\r/g,`
`),this.blockTokens(re,this.tokens);for(var me;me=this.inlineQueue.shift();)this.inlineTokens(me.src,me.tokens);return this.tokens},de.blockTokens=function(re,me){var Z=this;me===void 0&&(me=[]),this.options.pedantic?re=re.replace(/\t/g,"    ").replace(/^ +$/gm,""):re=re.replace(/^( *)(\t+)/gm,function(he,be,ce){return be+"    ".repeat(ce.length)});for(var se,O,H,K;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(he){return(se=he.call({lexer:Z},re,me))?(re=re.substring(se.raw.length),me.push(se),!0):!1}))){if(se=this.tokenizer.space(re)){re=re.substring(se.raw.length),se.raw.length===1&&me.length>0?me[me.length-1].raw+=`
`:me.push(se);continue}if(se=this.tokenizer.code(re)){re=re.substring(se.raw.length),O=me[me.length-1],O&&(O.type==="paragraph"||O.type==="text")?(O.raw+=`
`+se.raw,O.text+=`
`+se.text,this.inlineQueue[this.inlineQueue.length-1].src=O.text):me.push(se);continue}if(se=this.tokenizer.fences(re)){re=re.substring(se.raw.length),me.push(se);continue}if(se=this.tokenizer.heading(re)){re=re.substring(se.raw.length),me.push(se);continue}if(se=this.tokenizer.hr(re)){re=re.substring(se.raw.length),me.push(se);continue}if(se=this.tokenizer.blockquote(re)){re=re.substring(se.raw.length),me.push(se);continue}if(se=this.tokenizer.list(re)){re=re.substring(se.raw.length),me.push(se);continue}if(se=this.tokenizer.html(re)){re=re.substring(se.raw.length),me.push(se);continue}if(se=this.tokenizer.def(re)){re=re.substring(se.raw.length),O=me[me.length-1],O&&(O.type==="paragraph"||O.type==="text")?(O.raw+=`
`+se.raw,O.text+=`
`+se.raw,this.inlineQueue[this.inlineQueue.length-1].src=O.text):this.tokens.links[se.tag]||(this.tokens.links[se.tag]={href:se.href,title:se.title});continue}if(se=this.tokenizer.table(re)){re=re.substring(se.raw.length),me.push(se);continue}if(se=this.tokenizer.lheading(re)){re=re.substring(se.raw.length),me.push(se);continue}if(H=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var he=1/0,be=re.slice(1),ce=void 0;Z.options.extensions.startBlock.forEach(function(De){ce=De.call({lexer:this},be),typeof ce=="number"&&ce>=0&&(he=Math.min(he,ce))}),he<1/0&&he>=0&&(H=re.substring(0,he+1))}(),this.state.top&&(se=this.tokenizer.paragraph(H))){O=me[me.length-1],K&&O.type==="paragraph"?(O.raw+=`
`+se.raw,O.text+=`
`+se.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=O.text):me.push(se),K=H.length!==re.length,re=re.substring(se.raw.length);continue}if(se=this.tokenizer.text(re)){re=re.substring(se.raw.length),O=me[me.length-1],O&&O.type==="text"?(O.raw+=`
`+se.raw,O.text+=`
`+se.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=O.text):me.push(se);continue}if(re){var Q="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return this.state.top=!0,me},de.inline=function(re,me){this.inlineQueue.push({src:re,tokens:me})},de.inlineTokens=function(re,me){var Z=this;me===void 0&&(me=[]);var se,O,H,K=re,Q,he,be;if(this.tokens.links){var ce=Object.keys(this.tokens.links);if(ce.length>0)for(;(Q=this.tokenizer.rules.inline.reflinkSearch.exec(K))!=null;)ce.includes(Q[0].slice(Q[0].lastIndexOf("[")+1,-1))&&(K=K.slice(0,Q.index)+"["+F("a",Q[0].length-2)+"]"+K.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Q=this.tokenizer.rules.inline.blockSkip.exec(K))!=null;)K=K.slice(0,Q.index)+"["+F("a",Q[0].length-2)+"]"+K.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Q=this.tokenizer.rules.inline.escapedEmSt.exec(K))!=null;)K=K.slice(0,Q.index)+"++"+K.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(he||(be=""),he=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(se=ye.call({lexer:Z},re,me))?(re=re.substring(se.raw.length),me.push(se),!0):!1}))){if(se=this.tokenizer.escape(re)){re=re.substring(se.raw.length),me.push(se);continue}if(se=this.tokenizer.tag(re)){re=re.substring(se.raw.length),O=me[me.length-1],O&&se.type==="text"&&O.type==="text"?(O.raw+=se.raw,O.text+=se.text):me.push(se);continue}if(se=this.tokenizer.link(re)){re=re.substring(se.raw.length),me.push(se);continue}if(se=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(se.raw.length),O=me[me.length-1],O&&se.type==="text"&&O.type==="text"?(O.raw+=se.raw,O.text+=se.text):me.push(se);continue}if(se=this.tokenizer.emStrong(re,K,be)){re=re.substring(se.raw.length),me.push(se);continue}if(se=this.tokenizer.codespan(re)){re=re.substring(se.raw.length),me.push(se);continue}if(se=this.tokenizer.br(re)){re=re.substring(se.raw.length),me.push(se);continue}if(se=this.tokenizer.del(re)){re=re.substring(se.raw.length),me.push(se);continue}if(se=this.tokenizer.autolink(re,z)){re=re.substring(se.raw.length),me.push(se);continue}if(!this.state.inLink&&(se=this.tokenizer.url(re,z))){re=re.substring(se.raw.length),me.push(se);continue}if(H=re,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,Be=re.slice(1),qe=void 0;Z.options.extensions.startInline.forEach(function(et){qe=et.call({lexer:this},Be),typeof qe=="number"&&qe>=0&&(ye=Math.min(ye,qe))}),ye<1/0&&ye>=0&&(H=re.substring(0,ye+1))}(),se=this.tokenizer.inlineText(H,X)){re=re.substring(se.raw.length),se.raw.slice(-1)!=="_"&&(be=se.raw.slice(-1)),he=!0,O=me[me.length-1],O&&O.type==="text"?(O.raw+=se.raw,O.text+=se.text):me.push(se);continue}if(re){var De="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return me},u(ue,null,[{key:"rules",get:function(){return{block:$,inline:U}}}]),ue}(),V=function(){function ue(we){this.options=we||J.defaults}var de=ue.prototype;return de.code=function(re,me,Z){var se=(me||"").match(/\S*/)[0];if(this.options.highlight){var O=this.options.highlight(re,se);O!=null&&O!==re&&(Z=!0,re=O)}return re=re.replace(/\n$/,"")+`
`,se?'<pre><code class="'+this.options.langPrefix+v(se,!0)+'">'+(Z?re:v(re,!0))+`</code></pre>
`:"<pre><code>"+(Z?re:v(re,!0))+`</code></pre>
`},de.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},de.html=function(re){return re},de.heading=function(re,me,Z,se){if(this.options.headerIds){var O=this.options.headerPrefix+se.slug(Z);return"<h"+me+' id="'+O+'">'+re+"</h"+me+`>
`}return"<h"+me+">"+re+"</h"+me+`>
`},de.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},de.list=function(re,me,Z){var se=me?"ol":"ul",O=me&&Z!==1?' start="'+Z+'"':"";return"<"+se+O+`>
`+re+"</"+se+`>
`},de.listitem=function(re){return"<li>"+re+`</li>
`},de.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},de.paragraph=function(re){return"<p>"+re+`</p>
`},de.table=function(re,me){return me&&(me="<tbody>"+me+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+me+`</table>
`},de.tablerow=function(re){return`<tr>
`+re+`</tr>
`},de.tablecell=function(re,me){var Z=me.header?"th":"td",se=me.align?"<"+Z+' align="'+me.align+'">':"<"+Z+">";return se+re+("</"+Z+`>
`)},de.strong=function(re){return"<strong>"+re+"</strong>"},de.em=function(re){return"<em>"+re+"</em>"},de.codespan=function(re){return"<code>"+re+"</code>"},de.br=function(){return this.options.xhtml?"<br/>":"<br>"},de.del=function(re){return"<del>"+re+"</del>"},de.link=function(re,me,Z){if(re=m(this.options.sanitize,this.options.baseUrl,re),re===null)return Z;var se='<a href="'+v(re)+'"';return me&&(se+=' title="'+me+'"'),se+=">"+Z+"</a>",se},de.image=function(re,me,Z){if(re=m(this.options.sanitize,this.options.baseUrl,re),re===null)return Z;var se='<img src="'+re+'" alt="'+Z+'"';return me&&(se+=' title="'+me+'"'),se+=this.options.xhtml?"/>":">",se},de.text=function(re){return re},ue}(),x=function(){function ue(){}var de=ue.prototype;return de.strong=function(re){return re},de.em=function(re){return re},de.codespan=function(re){return re},de.del=function(re){return re},de.html=function(re){return re},de.text=function(re){return re},de.link=function(re,me,Z){return""+Z},de.image=function(re,me,Z){return""+Z},de.br=function(){return""},ue}(),q=function(){function ue(){this.seen={}}var de=ue.prototype;return de.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},de.getNextSafeSlug=function(re,me){var Z=re,se=0;if(this.seen.hasOwnProperty(Z)){se=this.seen[re];do se++,Z=re+"-"+se;while(this.seen.hasOwnProperty(Z))}return me||(this.seen[re]=se,this.seen[Z]=0),Z},de.slug=function(re,me){me===void 0&&(me={});var Z=this.serialize(re);return this.getNextSafeSlug(Z,me.dryrun)},ue}(),te=function(){function ue(we){this.options=we||J.defaults,this.options.renderer=this.options.renderer||new V,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new x,this.slugger=new q}ue.parse=function(re,me){var Z=new ue(me);return Z.parse(re)},ue.parseInline=function(re,me){var Z=new ue(me);return Z.parseInline(re)};var de=ue.prototype;return de.parse=function(re,me){me===void 0&&(me=!0);var Z="",se,O,H,K,Q,he,be,ce,De,ye,Be,qe,et,Xe,Oe,ot,ie,oe,G,Ce=re.length;for(se=0;se<Ce;se++){if(ye=re[se],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(G=this.options.extensions.renderers[ye.type].call({parser:this},ye),G!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){Z+=G||"";continue}switch(ye.type){case"space":continue;case"hr":{Z+=this.renderer.hr();continue}case"heading":{Z+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,p(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{Z+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(ce="",be="",K=ye.header.length,O=0;O<K;O++)be+=this.renderer.tablecell(this.parseInline(ye.header[O].tokens),{header:!0,align:ye.align[O]});for(ce+=this.renderer.tablerow(be),De="",K=ye.rows.length,O=0;O<K;O++){for(he=ye.rows[O],be="",Q=he.length,H=0;H<Q;H++)be+=this.renderer.tablecell(this.parseInline(he[H].tokens),{header:!1,align:ye.align[H]});De+=this.renderer.tablerow(be)}Z+=this.renderer.table(ce,De);continue}case"blockquote":{De=this.parse(ye.tokens),Z+=this.renderer.blockquote(De);continue}case"list":{for(Be=ye.ordered,qe=ye.start,et=ye.loose,K=ye.items.length,De="",O=0;O<K;O++)Oe=ye.items[O],ot=Oe.checked,ie=Oe.task,Xe="",Oe.task&&(oe=this.renderer.checkbox(ot),et?Oe.tokens.length>0&&Oe.tokens[0].type==="paragraph"?(Oe.tokens[0].text=oe+" "+Oe.tokens[0].text,Oe.tokens[0].tokens&&Oe.tokens[0].tokens.length>0&&Oe.tokens[0].tokens[0].type==="text"&&(Oe.tokens[0].tokens[0].text=oe+" "+Oe.tokens[0].tokens[0].text)):Oe.tokens.unshift({type:"text",text:oe}):Xe+=oe),Xe+=this.parse(Oe.tokens,et),De+=this.renderer.listitem(Xe,ie,ot);Z+=this.renderer.list(De,Be,qe);continue}case"html":{Z+=this.renderer.html(ye.text);continue}case"paragraph":{Z+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(De=ye.tokens?this.parseInline(ye.tokens):ye.text;se+1<Ce&&re[se+1].type==="text";)ye=re[++se],De+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);Z+=me?this.renderer.paragraph(De):De;continue}default:{var Re='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return Z},de.parseInline=function(re,me){me=me||this.renderer;var Z="",se,O,H,K=re.length;for(se=0;se<K;se++){if(O=re[se],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[O.type]&&(H=this.options.extensions.renderers[O.type].call({parser:this},O),H!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(O.type))){Z+=H||"";continue}switch(O.type){case"escape":{Z+=me.text(O.text);break}case"html":{Z+=me.html(O.text);break}case"link":{Z+=me.link(O.href,O.title,this.parseInline(O.tokens,me));break}case"image":{Z+=me.image(O.href,O.title,O.text);break}case"strong":{Z+=me.strong(this.parseInline(O.tokens,me));break}case"em":{Z+=me.em(this.parseInline(O.tokens,me));break}case"codespan":{Z+=me.codespan(O.text);break}case"br":{Z+=me.br();break}case"del":{Z+=me.del(this.parseInline(O.tokens,me));break}case"text":{Z+=me.text(O.text);break}default:{var Q='Token with "'+O.type+'" type was not found.';if(this.options.silent){console.error(Q);return}else throw new Error(Q)}}}return Z},ue}();function Y(ue,de,we){if(typeof ue=="undefined"||ue===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ue!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ue)+", string expected");if(typeof de=="function"&&(we=de,de=null),de=s({},Y.defaults,de||{}),L(de),we){var re=de.highlight,me;try{me=N.lex(ue,de)}catch(H){return we(H)}var Z=function(K){var Q;if(!K)try{de.walkTokens&&Y.walkTokens(me,de.walkTokens),Q=te.parse(me,de)}catch(he){K=he}return de.highlight=re,K?we(K):we(null,Q)};if(!re||re.length<3||(delete de.highlight,!me.length))return Z();var se=0;Y.walkTokens(me,function(H){H.type==="code"&&(se++,setTimeout(function(){re(H.text,H.lang,function(K,Q){if(K)return Z(K);Q!=null&&Q!==H.text&&(H.text=Q,H.escaped=!0),se--,se===0&&Z()})},0))}),se===0&&Z();return}try{var O=N.lex(ue,de);return de.walkTokens&&Y.walkTokens(O,de.walkTokens),te.parse(O,de)}catch(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,de.silent)return"<p>An error occurred:</p><pre>"+v(H.message+"",!0)+"</pre>";throw H}}Y.options=Y.setOptions=function(ue){return s(Y.defaults,ue),y(Y.defaults),Y},Y.getDefaults=C,Y.defaults=J.defaults,Y.use=function(){for(var ue=arguments.length,de=new Array(ue),we=0;we<ue;we++)de[we]=arguments[we];var re=s.apply(void 0,[{}].concat(de)),me=Y.defaults.extensions||{renderers:{},childTokens:{}},Z;de.forEach(function(se){if(se.extensions&&(Z=!0,se.extensions.forEach(function(H){if(!H.name)throw new Error("extension name required");if(H.renderer){var K=me.renderers?me.renderers[H.name]:null;K?me.renderers[H.name]=function(){for(var Q=arguments.length,he=new Array(Q),be=0;be<Q;be++)he[be]=arguments[be];var ce=H.renderer.apply(this,he);return ce===!1&&(ce=K.apply(this,he)),ce}:me.renderers[H.name]=H.renderer}if(H.tokenizer){if(!H.level||H.level!=="block"&&H.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");me[H.level]?me[H.level].unshift(H.tokenizer):me[H.level]=[H.tokenizer],H.start&&(H.level==="block"?me.startBlock?me.startBlock.push(H.start):me.startBlock=[H.start]:H.level==="inline"&&(me.startInline?me.startInline.push(H.start):me.startInline=[H.start]))}H.childTokens&&(me.childTokens[H.name]=H.childTokens)})),se.renderer&&function(){var H=Y.defaults.renderer||new V,K=function(be){var ce=H[be];H[be]=function(){for(var De=arguments.length,ye=new Array(De),Be=0;Be<De;Be++)ye[Be]=arguments[Be];var qe=se.renderer[be].apply(H,ye);return qe===!1&&(qe=ce.apply(H,ye)),qe}};for(var Q in se.renderer)K(Q);re.renderer=H}(),se.tokenizer&&function(){var H=Y.defaults.tokenizer||new B,K=function(be){var ce=H[be];H[be]=function(){for(var De=arguments.length,ye=new Array(De),Be=0;Be<De;Be++)ye[Be]=arguments[Be];var qe=se.tokenizer[be].apply(H,ye);return qe===!1&&(qe=ce.apply(H,ye)),qe}};for(var Q in se.tokenizer)K(Q);re.tokenizer=H}(),se.walkTokens){var O=Y.defaults.walkTokens;re.walkTokens=function(H){se.walkTokens.call(this,H),O&&O.call(this,H)}}Z&&(re.extensions=me),Y.setOptions(re)})},Y.walkTokens=function(ue,de){for(var we=function(){var se=me.value;switch(de.call(Y,se),se.type){case"table":{for(var O=T(se.header),H;!(H=O()).done;){var K=H.value;Y.walkTokens(K.tokens,de)}for(var Q=T(se.rows),he;!(he=Q()).done;)for(var be=he.value,ce=T(be),De;!(De=ce()).done;){var ye=De.value;Y.walkTokens(ye.tokens,de)}break}case"list":{Y.walkTokens(se.items,de);break}default:Y.defaults.extensions&&Y.defaults.extensions.childTokens&&Y.defaults.extensions.childTokens[se.type]?Y.defaults.extensions.childTokens[se.type].forEach(function(Be){Y.walkTokens(se[Be],de)}):se.tokens&&Y.walkTokens(se.tokens,de)}},re=T(ue),me;!(me=re()).done;)we()},Y.parseInline=function(ue,de){if(typeof ue=="undefined"||ue===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ue!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ue)+", string expected");de=s({},Y.defaults,de||{}),L(de);try{var we=N.lexInline(ue,de);return de.walkTokens&&Y.walkTokens(we,de.walkTokens),te.parseInline(we,de)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,de.silent)return"<p>An error occurred:</p><pre>"+v(re.message+"",!0)+"</pre>";throw re}},Y.Parser=te,Y.parser=te.parse,Y.Renderer=V,Y.TextRenderer=x,Y.Lexer=N,Y.lexer=N.lex,Y.Tokenizer=B,Y.Slugger=q,Y.parse=Y;var le=Y.options,pe=Y.setOptions,ee=Y.use,ge=Y.walkTokens,Ee=Y.parseInline,Pe=Y,Ne=te.parse,ve=N.lex;J.Lexer=N,J.Parser=te,J.Renderer=V,J.Slugger=q,J.TextRenderer=x,J.Tokenizer=B,J.getDefaults=C,J.lexer=ve,J.marked=Y,J.options=le,J.parse=Pe,J.parseInline=Ee,J.parser=Ne,J.setOptions=pe,J.use=ee,J.walkTokens=ge,Object.defineProperty(J,"__esModule",{value:!0})}),define(Ie[94],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function u(y,b,I){return Math.min(Math.max(y,b),I)}e.clamp=u;function n(y,b){return(b+y%b)%b}e.rot=n;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class T{constructor(){this._n=1,this._val=0}update(b){return this._val=this._val+(b-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=T;class C{constructor(b){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(b),this._values.fill(0,0,b)}update(b){const I=this._values[this._index];return this._values[this._index]=b,this._index=(this._index+1)%this._values.length,this._sum-=I,this._sum+=b,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=C}),function(){function J(D){const T=[];typeof D=="number"&&T.push("code/timeOrigin",D);function C(b){T.push(b,Date.now())}function y(){const b=[];for(let I=0;I<T.length;I+=2)b.push({name:T[I],startTime:T[I+1]});return b}return{mark:C,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const C of performance.getEntriesByType("mark"))T.push({name:C.name,startTime:Math.round(D+C.startTime)});return T}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function u(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return u(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=u(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=u(n))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var u=e();for(var n in u)(typeof exports=="object"?exports:J)[n]=u[n]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function u(n){if(e[n])return e[n].exports;var D=e[n]={i:n,l:!1,exports:{}};return J[n].call(D.exports,D,D.exports,u),D.l=!0,D.exports}return u.m=J,u.c=e,u.d=function(n,D,T){u.o(n,D)||Object.defineProperty(n,D,{enumerable:!0,get:T})},u.r=function(n){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},u.t=function(n,D){if(1&D&&(n=u(n)),8&D||4&D&&typeof n=="object"&&n&&n.__esModule)return n;var T=Object.create(null);if(u.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:n}),2&D&&typeof n!="string")for(var C in n)u.d(T,C,function(y){return n[y]}.bind(null,C));return T},u.n=function(n){var D=n&&n.__esModule?function(){return n.default}:function(){return n};return u.d(D,"a",D),D},u.o=function(n,D){return Object.prototype.hasOwnProperty.call(n,D)},u.p="",u(u.s=0)}([function(J,e,u){(function(n){var D;e=J.exports=ee,D=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,y=e.re=[],b=e.src=[],I=0,R=I++;b[R]="0|[1-9]\\d*";var k=I++;b[k]="[0-9]+";var _=I++;b[_]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=I++;b[P]="("+b[R]+")\\.("+b[R]+")\\.("+b[R]+")";var v=I++;b[v]="("+b[k]+")\\.("+b[k]+")\\.("+b[k]+")";var w=I++;b[w]="(?:"+b[R]+"|"+b[_]+")";var p=I++;b[p]="(?:"+b[k]+"|"+b[_]+")";var f=I++;b[f]="(?:-("+b[w]+"(?:\\."+b[w]+")*))";var E=I++;b[E]="(?:-?("+b[p]+"(?:\\."+b[p]+")*))";var g=I++;b[g]="[0-9A-Za-z-]+";var c=I++;b[c]="(?:\\+("+b[g]+"(?:\\."+b[g]+")*))";var m=I++,a="v?"+b[P]+b[f]+"?"+b[c]+"?";b[m]="^"+a+"$";var d="[v=\\s]*"+b[v]+b[E]+"?"+b[c]+"?",i=I++;b[i]="^"+d+"$";var o=I++;b[o]="((?:<|>)?=?)";var r=I++;b[r]=b[k]+"|x|X|\\*";var t=I++;b[t]=b[R]+"|x|X|\\*";var s=I++;b[s]="[v=\\s]*("+b[t]+")(?:\\.("+b[t]+")(?:\\.("+b[t]+")(?:"+b[f]+")?"+b[c]+"?)?)?";var l=I++;b[l]="[v=\\s]*("+b[r]+")(?:\\.("+b[r]+")(?:\\.("+b[r]+")(?:"+b[E]+")?"+b[c]+"?)?)?";var h=I++;b[h]="^"+b[o]+"\\s*"+b[s]+"$";var S=I++;b[S]="^"+b[o]+"\\s*"+b[l]+"$";var L=I++;b[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=I++;b[F]="(?:~>?)";var M=I++;b[M]="(\\s*)"+b[F]+"\\s+",y[M]=new RegExp(b[M],"g");var A=I++;b[A]="^"+b[F]+b[s]+"$";var B=I++;b[B]="^"+b[F]+b[l]+"$";var $=I++;b[$]="(?:\\^)";var U=I++;b[U]="(\\s*)"+b[$]+"\\s+",y[U]=new RegExp(b[U],"g");var X=I++;b[X]="^"+b[$]+b[s]+"$";var z=I++;b[z]="^"+b[$]+b[l]+"$";var N=I++;b[N]="^"+b[o]+"\\s*("+d+")$|^$";var V=I++;b[V]="^"+b[o]+"\\s*("+a+")$|^$";var x=I++;b[x]="(\\s*)"+b[o]+"\\s*("+d+"|"+b[s]+")",y[x]=new RegExp(b[x],"g");var q=I++;b[q]="^\\s*("+b[s]+")\\s+-\\s+("+b[s]+")\\s*$";var te=I++;b[te]="^\\s*("+b[l]+")\\s+-\\s+("+b[l]+")\\s*$";var Y=I++;b[Y]="(<|>)?=?\\s*\\*";for(var le=0;le<35;le++)D(le,b[le]),y[le]||(y[le]=new RegExp(b[le]));function pe(ce,De){if(ce instanceof ee)return ce;if(typeof ce!="string"||ce.length>T||!(De?y[i]:y[m]).test(ce))return null;try{return new ee(ce,De)}catch{return null}}function ee(ce,De){if(ce instanceof ee){if(ce.loose===De)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof ee))return new ee(ce,De);D("SemVer",ce,De),this.loose=De;var ye=ce.trim().match(De?y[i]:y[m]);if(!ye)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(Be){if(/^[0-9]+$/.test(Be)){var qe=+Be;if(qe>=0&&qe<C)return qe}return Be}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=pe,e.valid=function(ce,De){var ye=pe(ce,De);return ye?ye.version:null},e.clean=function(ce,De){var ye=pe(ce.trim().replace(/^[=v]+/,""),De);return ye?ye.version:null},e.SemVer=ee,ee.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ee.prototype.toString=function(){return this.version},ee.prototype.compare=function(ce){return D("SemVer.compare",this.version,this.loose,ce),ce instanceof ee||(ce=new ee(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},ee.prototype.compareMain=function(ce){return ce instanceof ee||(ce=new ee(ce,this.loose)),Ee(this.major,ce.major)||Ee(this.minor,ce.minor)||Ee(this.patch,ce.patch)},ee.prototype.comparePre=function(ce){if(ce instanceof ee||(ce=new ee(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var De=0;do{var ye=this.prerelease[De],Be=ce.prerelease[De];if(D("prerelease compare",De,ye,Be),ye===void 0&&Be===void 0)return 0;if(Be===void 0)return 1;if(ye===void 0)return-1;if(ye!==Be)return Ee(ye,Be)}while(++De)},ee.prototype.inc=function(ce,De){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",De);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",De);break;case"prepatch":this.prerelease.length=0,this.inc("patch",De),this.inc("pre",De);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",De),this.inc("pre",De);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}De&&(this.prerelease[0]===De?isNaN(this.prerelease[1])&&(this.prerelease=[De,0]):this.prerelease=[De,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,De,ye,Be){typeof ye=="string"&&(Be=ye,ye=void 0);try{return new ee(ce,ye).inc(De,Be).version}catch{return null}},e.diff=function(ce,De){if(ue(ce,De))return null;var ye=pe(ce),Be=pe(De);if(ye.prerelease.length||Be.prerelease.length){for(var qe in ye)if((qe==="major"||qe==="minor"||qe==="patch")&&ye[qe]!==Be[qe])return"pre"+qe;return"prerelease"}for(var qe in ye)if((qe==="major"||qe==="minor"||qe==="patch")&&ye[qe]!==Be[qe])return qe},e.compareIdentifiers=Ee;var ge=/^[0-9]+$/;function Ee(ce,De){var ye=ge.test(ce),Be=ge.test(De);return ye&&Be&&(ce=+ce,De=+De),ye&&!Be?-1:Be&&!ye?1:ce<De?-1:ce>De?1:0}function Pe(ce,De,ye){return new ee(ce,ye).compare(new ee(De,ye))}function Ne(ce,De,ye){return Pe(ce,De,ye)>0}function ve(ce,De,ye){return Pe(ce,De,ye)<0}function ue(ce,De,ye){return Pe(ce,De,ye)===0}function de(ce,De,ye){return Pe(ce,De,ye)!==0}function we(ce,De,ye){return Pe(ce,De,ye)>=0}function re(ce,De,ye){return Pe(ce,De,ye)<=0}function me(ce,De,ye,Be){var qe;switch(De){case"===":typeof ce=="object"&&(ce=ce.version),typeof ye=="object"&&(ye=ye.version),qe=ce===ye;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ye=="object"&&(ye=ye.version),qe=ce!==ye;break;case"":case"=":case"==":qe=ue(ce,ye,Be);break;case"!=":qe=de(ce,ye,Be);break;case">":qe=Ne(ce,ye,Be);break;case">=":qe=we(ce,ye,Be);break;case"<":qe=ve(ce,ye,Be);break;case"<=":qe=re(ce,ye,Be);break;default:throw new TypeError("Invalid operator: "+De)}return qe}function Z(ce,De){if(ce instanceof Z){if(ce.loose===De)return ce;ce=ce.value}if(!(this instanceof Z))return new Z(ce,De);D("comparator",ce,De),this.loose=De,this.parse(ce),this.semver===se?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ce,De){return Ee(De,ce)},e.major=function(ce,De){return new ee(ce,De).major},e.minor=function(ce,De){return new ee(ce,De).minor},e.patch=function(ce,De){return new ee(ce,De).patch},e.compare=Pe,e.compareLoose=function(ce,De){return Pe(ce,De,!0)},e.rcompare=function(ce,De,ye){return Pe(De,ce,ye)},e.sort=function(ce,De){return ce.sort(function(ye,Be){return e.compare(ye,Be,De)})},e.rsort=function(ce,De){return ce.sort(function(ye,Be){return e.rcompare(ye,Be,De)})},e.gt=Ne,e.lt=ve,e.eq=ue,e.neq=de,e.gte=we,e.lte=re,e.cmp=me,e.Comparator=Z;var se={};function O(ce,De){if(ce instanceof O)return ce.loose===De?ce:new O(ce.raw,De);if(ce instanceof Z)return new O(ce.value,De);if(!(this instanceof O))return new O(ce,De);if(this.loose=De,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function H(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function K(ce,De,ye,Be,qe,et,Xe,Oe,ot,ie,oe,G,Ce){return((De=H(ye)?"":H(Be)?">="+ye+".0.0":H(qe)?">="+ye+"."+Be+".0":">="+De)+" "+(Oe=H(ot)?"":H(ie)?"<"+(+ot+1)+".0.0":H(oe)?"<"+ot+"."+(+ie+1)+".0":G?"<="+ot+"."+ie+"."+oe+"-"+G:"<="+Oe)).trim()}function Q(ce,De){for(var ye=0;ye<ce.length;ye++)if(!ce[ye].test(De))return!1;if(De.prerelease.length){for(ye=0;ye<ce.length;ye++)if(D(ce[ye].semver),ce[ye].semver!==se&&ce[ye].semver.prerelease.length>0){var Be=ce[ye].semver;if(Be.major===De.major&&Be.minor===De.minor&&Be.patch===De.patch)return!0}return!1}return!0}function he(ce,De,ye){try{De=new O(De,ye)}catch{return!1}return De.test(ce)}function be(ce,De,ye,Be){var qe,et,Xe,Oe,ot;switch(ce=new ee(ce,Be),De=new O(De,Be),ye){case">":qe=Ne,et=re,Xe=ve,Oe=">",ot=">=";break;case"<":qe=ve,et=we,Xe=Ne,Oe="<",ot="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(he(ce,De,Be))return!1;for(var ie=0;ie<De.set.length;++ie){var oe=De.set[ie],G=null,Ce=null;if(oe.forEach(function(Re){Re.semver===se&&(Re=new Z(">=0.0.0")),G=G||Re,Ce=Ce||Re,qe(Re.semver,G.semver,Be)?G=Re:Xe(Re.semver,Ce.semver,Be)&&(Ce=Re)}),G.operator===Oe||G.operator===ot||(!Ce.operator||Ce.operator===Oe)&&et(ce,Ce.semver)||Ce.operator===ot&&Xe(ce,Ce.semver))return!1}return!0}Z.prototype.parse=function(ce){var De=this.loose?y[N]:y[V],ye=ce.match(De);if(!ye)throw new TypeError("Invalid comparator: "+ce);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new ee(ye[2],this.loose):this.semver=se},Z.prototype.toString=function(){return this.value},Z.prototype.test=function(ce){return D("Comparator.test",ce,this.loose),this.semver===se||(typeof ce=="string"&&(ce=new ee(ce,this.loose)),me(ce,this.operator,this.semver,this.loose))},Z.prototype.intersects=function(ce,De){if(!(ce instanceof Z))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new O(ce.value,De),he(this.value,ye,De);if(ce.operator==="")return ye=new O(this.value,De),he(ce.semver,ye,De);var Be=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),qe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),et=this.semver.version===ce.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),Oe=me(this.semver,"<",ce.semver,De)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),ot=me(this.semver,">",ce.semver,De)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Be||qe||et&&Xe||Oe||ot},e.Range=O,O.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},O.prototype.toString=function(){return this.range},O.prototype.parseRange=function(ce){var De=this.loose;ce=ce.trim(),D("range",ce,De);var ye=De?y[te]:y[q];ce=ce.replace(ye,K),D("hyphen replace",ce),ce=ce.replace(y[x],"$1$2$3"),D("comparator trim",ce,y[x]),ce=(ce=(ce=ce.replace(y[M],"$1~")).replace(y[U],"$1^")).split(/\s+/).join(" ");var Be=De?y[N]:y[V],qe=ce.split(" ").map(function(et){return function(Xe,Oe){return D("comp",Xe),Xe=function(ot,ie){return ot.trim().split(/\s+/).map(function(oe){return function(G,Ce){D("caret",G,Ce);var Re=Ce?y[z]:y[X];return G.replace(Re,function(We,ze,$e,tt,st){var lt;return D("caret",G,We,ze,$e,tt,st),H(ze)?lt="":H($e)?lt=">="+ze+".0.0 <"+(+ze+1)+".0.0":H(tt)?lt=ze==="0"?">="+ze+"."+$e+".0 <"+ze+"."+(+$e+1)+".0":">="+ze+"."+$e+".0 <"+(+ze+1)+".0.0":st?(D("replaceCaret pr",st),st.charAt(0)!=="-"&&(st="-"+st),lt=ze==="0"?$e==="0"?">="+ze+"."+$e+"."+tt+st+" <"+ze+"."+$e+"."+(+tt+1):">="+ze+"."+$e+"."+tt+st+" <"+ze+"."+(+$e+1)+".0":">="+ze+"."+$e+"."+tt+st+" <"+(+ze+1)+".0.0"):(D("no pr"),lt=ze==="0"?$e==="0"?">="+ze+"."+$e+"."+tt+" <"+ze+"."+$e+"."+(+tt+1):">="+ze+"."+$e+"."+tt+" <"+ze+"."+(+$e+1)+".0":">="+ze+"."+$e+"."+tt+" <"+(+ze+1)+".0.0"),D("caret return",lt),lt})}(oe,ie)}).join(" ")}(Xe,Oe),D("caret",Xe),Xe=function(ot,ie){return ot.trim().split(/\s+/).map(function(oe){return function(G,Ce){var Re=Ce?y[B]:y[A];return G.replace(Re,function(We,ze,$e,tt,st){var lt;return D("tilde",G,We,ze,$e,tt,st),H(ze)?lt="":H($e)?lt=">="+ze+".0.0 <"+(+ze+1)+".0.0":H(tt)?lt=">="+ze+"."+$e+".0 <"+ze+"."+(+$e+1)+".0":st?(D("replaceTilde pr",st),st.charAt(0)!=="-"&&(st="-"+st),lt=">="+ze+"."+$e+"."+tt+st+" <"+ze+"."+(+$e+1)+".0"):lt=">="+ze+"."+$e+"."+tt+" <"+ze+"."+(+$e+1)+".0",D("tilde return",lt),lt})}(oe,ie)}).join(" ")}(Xe,Oe),D("tildes",Xe),Xe=function(ot,ie){return D("replaceXRanges",ot,ie),ot.split(/\s+/).map(function(oe){return function(G,Ce){G=G.trim();var Re=Ce?y[S]:y[h];return G.replace(Re,function(We,ze,$e,tt,st,lt){D("xRange",G,We,ze,$e,tt,st,lt);var nt=H($e),it=nt||H(tt),ft=it||H(st);return ze==="="&&ft&&(ze=""),nt?We=ze===">"||ze==="<"?"<0.0.0":"*":ze&&ft?(it&&(tt=0),ft&&(st=0),ze===">"?(ze=">=",it?($e=+$e+1,tt=0,st=0):ft&&(tt=+tt+1,st=0)):ze==="<="&&(ze="<",it?$e=+$e+1:tt=+tt+1),We=ze+$e+"."+tt+"."+st):it?We=">="+$e+".0.0 <"+(+$e+1)+".0.0":ft&&(We=">="+$e+"."+tt+".0 <"+$e+"."+(+tt+1)+".0"),D("xRange return",We),We})}(oe,ie)}).join(" ")}(Xe,Oe),D("xrange",Xe),Xe=function(ot,ie){return D("replaceStars",ot,ie),ot.trim().replace(y[Y],"")}(Xe,Oe),D("stars",Xe),Xe}(et,De)}).join(" ").split(/\s+/);return this.loose&&(qe=qe.filter(function(et){return!!et.match(Be)})),qe=qe.map(function(et){return new Z(et,De)})},O.prototype.intersects=function(ce,De){if(!(ce instanceof O))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(Be){return ce.set.some(function(qe){return qe.every(function(et){return Be.intersects(et,De)})})})})},e.toComparators=function(ce,De){return new O(ce,De).set.map(function(ye){return ye.map(function(Be){return Be.value}).join(" ").trim().split(" ")})},O.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new ee(ce,this.loose));for(var De=0;De<this.set.length;De++)if(Q(this.set[De],ce))return!0;return!1},e.satisfies=he,e.maxSatisfying=function(ce,De,ye){var Be=null,qe=null;try{var et=new O(De,ye)}catch{return null}return ce.forEach(function(Xe){et.test(Xe)&&(Be&&qe.compare(Xe)!==-1||(qe=new ee(Be=Xe,ye)))}),Be},e.minSatisfying=function(ce,De,ye){var Be=null,qe=null;try{var et=new O(De,ye)}catch{return null}return ce.forEach(function(Xe){et.test(Xe)&&(Be&&qe.compare(Xe)!==1||(qe=new ee(Be=Xe,ye)))}),Be},e.validRange=function(ce,De){try{return new O(ce,De).range||"*"}catch{return null}},e.ltr=function(ce,De,ye){return be(ce,De,"<",ye)},e.gtr=function(ce,De,ye){return be(ce,De,">",ye)},e.outside=be,e.prerelease=function(ce,De){var ye=pe(ce,De);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(ce,De,ye){return ce=new O(ce,ye),De=new O(De,ye),ce.intersects(De)},e.coerce=function(ce){if(ce instanceof ee)return ce;if(typeof ce!="string")return null;var De=ce.match(y[L]);return De==null?null:pe((De[1]||"0")+"."+(De[2]||"0")+"."+(De[3]||"0"))}}).call(this,u(1))},function(J,e){var u,n,D=J.exports={};function T(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function y(p){if(u===setTimeout)return setTimeout(p,0);if((u===T||!u)&&setTimeout)return u=setTimeout,setTimeout(p,0);try{return u(p,0)}catch{try{return u.call(null,p,0)}catch{return u.call(this,p,0)}}}(function(){try{u=typeof setTimeout=="function"?setTimeout:T}catch{u=T}try{n=typeof clearTimeout=="function"?clearTimeout:C}catch{n=C}})();var b,I=[],R=!1,k=-1;function _(){R&&b&&(R=!1,b.length?I=b.concat(I):k=-1,I.length&&P())}function P(){if(!R){var p=y(_);R=!0;for(var f=I.length;f;){for(b=I,I=[];++k<f;)b&&b[k].run();k=-1,f=I.length}b=null,R=!1,function(E){if(n===clearTimeout)return clearTimeout(E);if((n===C||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(E);try{n(E)}catch{try{return n.call(null,E)}catch{return n.call(this,E)}}}(p)}}function v(p,f){this.fun=p,this.array=f}function w(){}D.nextTick=function(p){var f=new Array(arguments.length-1);if(arguments.length>1)for(var E=1;E<arguments.length;E++)f[E-1]=arguments[E];I.push(new v(p,f)),I.length!==1||R||y(P)},v.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=w,D.addListener=w,D.once=w,D.off=w,D.removeListener=w,D.removeAllListeners=w,D.emit=w,D.prependListener=w,D.prependOnceListener=w,D.listeners=function(p){return[]},D.binding=function(p){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(p){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(Ie[95],ke([0,1,12,6]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(c){const m=c;return m?typeof m.read=="function":!1}e.isReadable=D;function T(c){const m=c;return m?[m.on,m.pause,m.resume,m.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=T;function C(c){const m=c;return m?T(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=C;function y(c,m){return new b(c,m)}e.newWriteableStream=y;class b{constructor(m,a){this.reducer=m,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(a=>a(m))}emitError(m){this.listeners.error.length===0?(0,u.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(a=>a(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,a){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(m,a){if(this.state.destroyed)return;let d;switch(m){case"data":d=this.listeners.data;break;case"end":d=this.listeners.end;break;case"error":d=this.listeners.error;break}if(d){const i=d.indexOf(a);i>=0&&d.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(d=>d())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function I(c,m){const a=[];let d;for(;(d=c.read())!==null;)a.push(d);return m(a)}e.consumeReadable=I;function R(c,m,a){const d=[];let i;for(;(i=c.read())!==null&&d.length<a;)d.push(i);return i===null&&d.length>0?m(d):{read:()=>{if(d.length>0)return d.shift();if(typeof i!="undefined"){const o=i;return i=void 0,o}return c.read()}}}e.peekReadable=R;function k(c,m){return new Promise((a,d)=>{const i=[];_(c,{onData:o=>{m&&i.push(o)},onError:o=>{m?d(o):a(void 0)},onEnd:()=>{a(m?m(i):void 0)}})})}e.consumeStream=k;function _(c,m){let a=!1;return c.on("error",d=>{a||m.onError(d)}),c.on("end",()=>{a||m.onEnd()}),c.on("data",d=>{a||m.onData(d)}),(0,n.toDisposable)(()=>a=!0)}e.listenStream=_;function P(c,m){return new Promise((a,d)=>{const i=new n.DisposableStore,o=[],r=l=>{if(o.push(l),o.length>m)return i.dispose(),c.pause(),a({stream:c,buffer:o,ended:!1})},t=l=>d(l),s=()=>a({stream:c,buffer:o,ended:!0});i.add((0,n.toDisposable)(()=>c.removeListener("error",t))),c.on("error",t),i.add((0,n.toDisposable)(()=>c.removeListener("end",s))),c.on("end",s),i.add((0,n.toDisposable)(()=>c.removeListener("data",r))),c.on("data",r)})}e.peekStream=P;function v(c,m){const a=y(m);return a.end(c),a}e.toStream=v;function w(){const c=y(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=w;function p(c){let m=!1;return{read:()=>m?null:(m=!0,c)}}e.toReadable=p;function f(c,m,a){const d=y(a);return _(c,{onData:i=>d.write(m.data(i)),onError:i=>d.error(m.error?m.error(i):i),onEnd:()=>d.end()}),d}e.transform=f;function E(c,m,a){let d=!1;return{read:()=>{const i=m.read();return d?i:(d=!0,i!==null?a([c,i]):c)}}}e.prefixedReadable=E;function g(c,m,a){let d=!1;const i=y(a);return _(m,{onData:o=>d?i.write(o):(d=!0,i.write(a([c,o]))),onError:o=>i.error(o),onEnd:()=>{d||(d=!0,i.write(c)),i.end()}}),i}e.prefixedStream=g}),define(Ie[23],ke([0,1,95]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let D,T;class C{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return n?new C(Buffer.allocUnsafe(l)):new C(new Uint8Array(l))}static wrap(l){return n&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new C(l)}static fromString(l,h){return!(h?.dontUseNodeBuffer||!1)&&n?new C(Buffer.from(l)):(D||(D=new TextEncoder),new C(D.encode(l)))}static fromByteArray(l){const h=C.alloc(l.length);for(let S=0,L=l.length;S<L;S++)h.buffer[S]=l[S];return h}static concat(l,h){if(typeof h=="undefined"){h=0;for(let F=0,M=l.length;F<M;F++)h+=l[F].byteLength}const S=C.alloc(h);let L=0;for(let F=0,M=l.length;F<M;F++){const A=l[F];S.set(A,L),L+=A.byteLength}return S}clone(){const l=C.alloc(this.byteLength);return l.set(this),l}toString(){return n?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(l,h){return new C(this.buffer.subarray(l,h))}set(l,h){if(l instanceof C)this.buffer.set(l.buffer,h);else if(l instanceof Uint8Array)this.buffer.set(l,h);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),h);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return I(this.buffer,l)}writeUInt32BE(l,h){R(this.buffer,l,h)}readUInt32LE(l){return k(this.buffer,l)}writeUInt32LE(l,h){_(this.buffer,l,h)}readUInt8(l){return P(this.buffer,l)}writeUInt8(l,h){v(this.buffer,l,h)}}e.VSBuffer=C;function y(s,l){return s[l+0]<<0>>>0|s[l+1]<<8>>>0}e.readUInt16LE=y;function b(s,l,h){s[h+0]=l&255,l=l>>>8,s[h+1]=l&255}e.writeUInt16LE=b;function I(s,l){return s[l]*2**24+s[l+1]*2**16+s[l+2]*2**8+s[l+3]}e.readUInt32BE=I;function R(s,l,h){s[h+3]=l,l=l>>>8,s[h+2]=l,l=l>>>8,s[h+1]=l,l=l>>>8,s[h]=l}e.writeUInt32BE=R;function k(s,l){return s[l+0]<<0>>>0|s[l+1]<<8>>>0|s[l+2]<<16>>>0|s[l+3]<<24>>>0}e.readUInt32LE=k;function _(s,l,h){s[h+0]=l&255,l=l>>>8,s[h+1]=l&255,l=l>>>8,s[h+2]=l&255,l=l>>>8,s[h+3]=l&255}e.writeUInt32LE=_;function P(s,l){return s[l]}e.readUInt8=P;function v(s,l,h){s[h]=l}e.writeUInt8=v;function w(s){return u.consumeReadable(s,l=>C.concat(l))}e.readableToBuffer=w;function p(s){return u.toReadable(s)}e.bufferToReadable=p;function f(s){return u.consumeStream(s,l=>C.concat(l))}e.streamToBuffer=f;async function E(s){return s.ended?C.concat(s.buffer):C.concat([...s.buffer,await f(s.stream)])}e.bufferedStreamToBuffer=E;function g(s){return u.toStream(s,l=>C.concat(l))}e.bufferToStream=g;function c(s){return u.transform(s,{data:l=>typeof l=="string"?C.fromString(l):C.wrap(l)},l=>C.concat(l))}e.streamToBufferReadableStream=c;function m(s){return u.newWriteableStream(l=>C.concat(l),s)}e.newWriteableBufferStream=m;function a(s,l){return u.prefixedReadable(s,l,h=>C.concat(h))}e.prefixedBufferReadable=a;function d(s,l){return u.prefixedStream(s,l,h=>C.concat(h))}e.prefixedBufferStream=d;function i(s){let l=0,h=0,S=0;const L=new Uint8Array(Math.floor(s.length/4*3)),F=A=>{switch(h){case 3:L[S++]=l|A,h=0;break;case 2:L[S++]=l|A>>>2,l=A<<6,h=3;break;case 1:L[S++]=l|A>>>4,l=A<<4,h=2;break;default:l=A<<2,h=1}};for(let A=0;A<s.length;A++){const B=s.charCodeAt(A);if(B>=65&&B<=90)F(B-65);else if(B>=97&&B<=122)F(B-97+26);else if(B>=48&&B<=57)F(B-48+52);else if(B===43||B===45)F(62);else if(B===47||B===95)F(63);else{if(B===61)break;throw new SyntaxError(`Unexpected base64 character ${s[A]}`)}}const M=S;for(;h>0;)F(0);return C.wrap(L).slice(0,M)}e.decodeBase64=i;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function t({buffer:s},l=!0,h=!1){const S=h?r:o;let L="";const F=s.byteLength%3;let M=0;for(;M<s.byteLength-F;M+=3){const A=s[M+0],B=s[M+1],$=s[M+2];L+=S[A>>>2],L+=S[(A<<4|B>>>4)&63],L+=S[(B<<2|$>>>6)&63],L+=S[$&63]}if(F===1){const A=s[M+0];L+=S[A>>>2],L+=S[A<<4&63],l&&(L+="==")}else if(F===2){const A=s[M+0],B=s[M+1];L+=S[A>>>2],L+=S[(A<<4|B>>>4)&63],L+=S[B<<2&63],l&&(L+="=")}return L}e.encodeBase64=t}),define(Ie[11],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function u(s){return Array.isArray(s)}e.isArray=u;function n(s){return typeof s=="string"}e.isString=n;function D(s){return Array.isArray(s)&&s.every(l=>n(l))}e.isStringArray=D;function T(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=T;function C(s){const l=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof l}e.isTypedArray=C;function y(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=y;function b(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=b;function I(s){return s===!0||s===!1}e.isBoolean=I;function R(s){return typeof s=="undefined"}e.isUndefined=R;function k(s){return!_(s)}e.isDefined=k;function _(s){return R(s)||s===null}e.isUndefinedOrNull=_;function P(s,l){if(!s)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=P;function v(s){if(_(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=v;function w(...s){const l=[];for(let h=0;h<s.length;h++){const S=s[h];if(_(S))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);l.push(S)}return l}e.assertAllDefined=w;const p=Object.prototype.hasOwnProperty;function f(s){if(!T(s))return!1;for(const l in s)if(p.call(s,l))return!1;return!0}e.isEmptyObject=f;function E(s){return typeof s=="function"}e.isFunction=E;function g(...s){return s.length>0&&s.every(E)}e.areFunctions=g;function c(s,l){const h=Math.min(s.length,l.length);for(let S=0;S<h;S++)m(s[S],l[S])}e.validateConstraints=c;function m(s,l){if(n(l)){if(typeof s!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(E(l)){try{if(s instanceof l)return}catch{}if(!_(s)&&s.constructor===l||l.length===1&&l.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=m;function a(s){let l=[],h=Object.getPrototypeOf(s);for(;Object.prototype!==h;)l=l.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return l}e.getAllPropertyNames=a;function d(s){const l=[];for(const h of a(s))typeof s[h]=="function"&&l.push(h);return l}e.getAllMethodNames=d;function i(s,l){const h=L=>function(){const F=Array.prototype.slice.call(arguments,0);return l(L,F)},S={};for(const L of s)S[L]=h(L);return S}e.createProxyObject=i;function o(s){return s===null?void 0:s}e.withNullAsUndefined=o;function r(s){return typeof s=="undefined"?null:s}e.withUndefinedAsNull=r;function t(s,l="Unreachable"){throw new Error(l)}e.assertNever=t}),define(Ie[24],ke([0,1,11]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const w=Array.isArray(v)?[]:{};return Object.keys(v).forEach(p=>{v[p]&&typeof v[p]=="object"?w[p]=n(v[p]):w[p]=v[p]}),w}e.deepClone=n;function D(v){if(!v||typeof v!="object")return v;const w=[v];for(;w.length>0;){const p=w.shift();Object.freeze(p);for(const f in p)if(T.call(p,f)){const E=p[f];typeof E=="object"&&!Object.isFrozen(E)&&!(0,u.isTypedArray)(E)&&w.push(E)}}return v}e.deepFreeze=D;const T=Object.prototype.hasOwnProperty;function C(v,w){return y(v,w,new Set)}e.cloneAndChange=C;function y(v,w,p){if((0,u.isUndefinedOrNull)(v))return v;const f=w(v);if(typeof f!="undefined")return f;if((0,u.isArray)(v)){const E=[];for(const g of v)E.push(y(g,w,p));return E}if((0,u.isObject)(v)){if(p.has(v))throw new Error("Cannot clone recursive data-structure");p.add(v);const E={};for(const g in v)T.call(v,g)&&(E[g]=y(v[g],w,p));return p.delete(v),E}return v}function b(v,w,p=!0){return(0,u.isObject)(v)?((0,u.isObject)(w)&&Object.keys(w).forEach(f=>{f in v?p&&((0,u.isObject)(v[f])&&(0,u.isObject)(w[f])?b(v[f],w[f],p):v[f]=w[f]):v[f]=w[f]}),v):w}e.mixin=b;function I(v,w){if(v===w)return!0;if(v==null||w===null||w===void 0||typeof v!=typeof w||typeof v!="object"||Array.isArray(v)!==Array.isArray(w))return!1;let p,f;if(Array.isArray(v)){if(v.length!==w.length)return!1;for(p=0;p<v.length;p++)if(!I(v[p],w[p]))return!1}else{const E=[];for(f in v)E.push(f);E.sort();const g=[];for(f in w)g.push(f);if(g.sort(),!I(E,g))return!1;for(p=0;p<E.length;p++)if(!I(v[E[p]],w[E[p]]))return!1}return!0}e.equals=I;function R(v){const w=new Set;return JSON.stringify(v,(p,f)=>{if((0,u.isObject)(f)||Array.isArray(f)){if(w.has(f))return"[Circular]";w.add(f)}return f})}e.safeStringify=R;function k(v,w){const p=Object.create(null);return!v||!w||Object.keys(w).forEach(E=>{const g=v[E],c=w[E];I(g,c)||(p[E]=c)}),p}e.distinct=k;function _(v,w){const p=w.toLowerCase(),f=Object.keys(v).find(E=>E.toLowerCase()===p);return f?v[f]:v[w]}e.getCaseInsensitive=_;function P(v,w){const p=Object.create(null);for(const[f,E]of Object.entries(v))w(f,E)&&(p[f]=E);return p}e.filter=P}),define(Ie[96],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var u;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(u=e.Constants||(e.Constants={}));function n(T){return T<0?0:T>255?255:T|0}e.toUint8=n;function D(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=D}),define(Ie[34],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const u=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(D){return u.test(D)}e.isUUID=n,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(y){for(let b=0;b<y.length;b++)y[b]=Math.floor(Math.random()*256);return y};const T=new Uint8Array(16),C=[];for(let y=0;y<256;y++)C.push(y.toString(16).padStart(2,"0"));return function(){D(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let b=0,I="";return I+=C[T[b++]],I+=C[T[b++]],I+=C[T[b++]],I+=C[T[b++]],I+="-",I+=C[T[b++]],I+=C[T[b++]],I+="-",I+=C[T[b++]],I+=C[T[b++]],I+="-",I+=C[T[b++]],I+=C[T[b++]],I+="-",I+=C[T[b++]],I+=C[T[b++]],I+=C[T[b++]],I+=C[T[b++]],I+=C[T[b++]],I+=C[T[b++]],I}}()}),define(Ie[144],ke([0,1,97]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(T="utf8"){this.stringDecoder=new u.StringDecoder(T),this.remaining=null}write(T){const C=[],y=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(y.length<1)return C;let b=0,I,R=b;for(;R<y.length;)if(I=y.charCodeAt(R),I===13||I===10){if(C.push(y.substring(b,R)),R++,R<y.length){const k=I;I=y.charCodeAt(R),(k===13&&I===10||k===10&&I===13)&&R++}b=R}else R++;return this.remaining=b<y.length?y.substr(b):null,C}end(){return this.remaining}}e.LineDecoder=n}),define(Ie[98],ke([0,1,96]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class n{constructor(y){const b=(0,u.toUint8)(y);this._defaultValue=b,this._asciiMap=n._createAsciiMap(b),this._map=new Map}static _createAsciiMap(y){const b=new Uint8Array(256);for(let I=0;I<256;I++)b[I]=y;return b}set(y,b){const I=(0,u.toUint8)(b);y>=0&&y<256?this._asciiMap[y]=I:this._map.set(y,I)}get(y){return y>=0&&y<256?this._asciiMap[y]:this._map.get(y)||this._defaultValue}}e.CharacterClassifier=n;var D;(function(C){C[C.False=0]="False",C[C.True=1]="True"})(D||(D={}));class T{constructor(){this._actual=new n(0)}add(y){this._actual.set(y,1)}has(y){return this._actual.get(y)===1}}e.CharacterSet=T}),define(Ie[48],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class u{constructor(D,T){this.lineNumber=D,this.column=T}with(D=this.lineNumber,T=this.column){return D===this.lineNumber&&T===this.column?this:new u(D,T)}delta(D=0,T=0){return this.with(this.lineNumber+D,this.column+T)}equals(D){return u.equals(this,D)}static equals(D,T){return!D&&!T?!0:!!D&&!!T&&D.lineNumber===T.lineNumber&&D.column===T.column}isBefore(D){return u.isBefore(this,D)}static isBefore(D,T){return D.lineNumber<T.lineNumber?!0:T.lineNumber<D.lineNumber?!1:D.column<T.column}isBeforeOrEqual(D){return u.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,T){return D.lineNumber<T.lineNumber?!0:T.lineNumber<D.lineNumber?!1:D.column<=T.column}static compare(D,T){const C=D.lineNumber|0,y=T.lineNumber|0;if(C===y){const b=D.column|0,I=T.column|0;return b-I}return C-y}clone(){return new u(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new u(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=u}),define(Ie[35],ke([0,1,48]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class n{constructor(T,C,y,b){T>y||T===y&&C>b?(this.startLineNumber=y,this.startColumn=b,this.endLineNumber=T,this.endColumn=C):(this.startLineNumber=T,this.startColumn=C,this.endLineNumber=y,this.endColumn=b)}isEmpty(){return n.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return n.containsPosition(this,T)}static containsPosition(T,C){return!(C.lineNumber<T.startLineNumber||C.lineNumber>T.endLineNumber||C.lineNumber===T.startLineNumber&&C.column<T.startColumn||C.lineNumber===T.endLineNumber&&C.column>T.endColumn)}static strictContainsPosition(T,C){return!(C.lineNumber<T.startLineNumber||C.lineNumber>T.endLineNumber||C.lineNumber===T.startLineNumber&&C.column<=T.startColumn||C.lineNumber===T.endLineNumber&&C.column>=T.endColumn)}containsRange(T){return n.containsRange(this,T)}static containsRange(T,C){return!(C.startLineNumber<T.startLineNumber||C.endLineNumber<T.startLineNumber||C.startLineNumber>T.endLineNumber||C.endLineNumber>T.endLineNumber||C.startLineNumber===T.startLineNumber&&C.startColumn<T.startColumn||C.endLineNumber===T.endLineNumber&&C.endColumn>T.endColumn)}strictContainsRange(T){return n.strictContainsRange(this,T)}static strictContainsRange(T,C){return!(C.startLineNumber<T.startLineNumber||C.endLineNumber<T.startLineNumber||C.startLineNumber>T.endLineNumber||C.endLineNumber>T.endLineNumber||C.startLineNumber===T.startLineNumber&&C.startColumn<=T.startColumn||C.endLineNumber===T.endLineNumber&&C.endColumn>=T.endColumn)}plusRange(T){return n.plusRange(this,T)}static plusRange(T,C){let y,b,I,R;return C.startLineNumber<T.startLineNumber?(y=C.startLineNumber,b=C.startColumn):C.startLineNumber===T.startLineNumber?(y=C.startLineNumber,b=Math.min(C.startColumn,T.startColumn)):(y=T.startLineNumber,b=T.startColumn),C.endLineNumber>T.endLineNumber?(I=C.endLineNumber,R=C.endColumn):C.endLineNumber===T.endLineNumber?(I=C.endLineNumber,R=Math.max(C.endColumn,T.endColumn)):(I=T.endLineNumber,R=T.endColumn),new n(y,b,I,R)}intersectRanges(T){return n.intersectRanges(this,T)}static intersectRanges(T,C){let y=T.startLineNumber,b=T.startColumn,I=T.endLineNumber,R=T.endColumn;const k=C.startLineNumber,_=C.startColumn,P=C.endLineNumber,v=C.endColumn;return y<k?(y=k,b=_):y===k&&(b=Math.max(b,_)),I>P?(I=P,R=v):I===P&&(R=Math.min(R,v)),y>I||y===I&&b>R?null:new n(y,b,I,R)}equalsRange(T){return n.equalsRange(this,T)}static equalsRange(T,C){return!!T&&!!C&&T.startLineNumber===C.startLineNumber&&T.startColumn===C.startColumn&&T.endLineNumber===C.endLineNumber&&T.endColumn===C.endColumn}getEndPosition(){return n.getEndPosition(this)}static getEndPosition(T){return new u.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return n.getStartPosition(this)}static getStartPosition(T){return new u.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,C){return new n(this.startLineNumber,this.startColumn,T,C)}setStartPosition(T,C){return new n(T,C,this.endLineNumber,this.endColumn)}collapseToStart(){return n.collapseToStart(this)}static collapseToStart(T){return new n(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,C=T){return new n(T.lineNumber,T.column,C.lineNumber,C.column)}static lift(T){return T?new n(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,C){return!(T.endLineNumber<C.startLineNumber||T.endLineNumber===C.startLineNumber&&T.endColumn<C.startColumn||C.endLineNumber<T.startLineNumber||C.endLineNumber===T.startLineNumber&&C.endColumn<T.startColumn)}static areIntersecting(T,C){return!(T.endLineNumber<C.startLineNumber||T.endLineNumber===C.startLineNumber&&T.endColumn<=C.startColumn||C.endLineNumber<T.startLineNumber||C.endLineNumber===T.startLineNumber&&C.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,C){if(T&&C){const I=T.startLineNumber|0,R=C.startLineNumber|0;if(I===R){const k=T.startColumn|0,_=C.startColumn|0;if(k===_){const P=T.endLineNumber|0,v=C.endLineNumber|0;if(P===v){const w=T.endColumn|0,p=C.endColumn|0;return w-p}return P-v}return k-_}return I-R}return(T?1:0)-(C?1:0)}static compareRangesUsingEnds(T,C){return T.endLineNumber===C.endLineNumber?T.endColumn===C.endColumn?T.startLineNumber===C.startLineNumber?T.startColumn-C.startColumn:T.startLineNumber-C.startLineNumber:T.endColumn-C.endColumn:T.endLineNumber-C.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}toJSON(){return this}}e.Range=n}),define(Ie[145],ke([0,1,48,35]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(C){C[C.LTR=0]="LTR",C[C.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class T extends n.Range{constructor(y,b,I,R){super(y,b,I,R);this.selectionStartLineNumber=y,this.selectionStartColumn=b,this.positionLineNumber=I,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(y){return T.selectionsEqual(this,y)}static selectionsEqual(y,b){return y.selectionStartLineNumber===b.selectionStartLineNumber&&y.selectionStartColumn===b.selectionStartColumn&&y.positionLineNumber===b.positionLineNumber&&y.positionColumn===b.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(y,b){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,y,b):new T(y,b,this.startLineNumber,this.startColumn)}getPosition(){return new u.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new u.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(y,b){return this.getDirection()===0?new T(y,b,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,y,b)}static fromPositions(y,b=y){return new T(y.lineNumber,y.column,b.lineNumber,b.column)}static fromRange(y,b){return b===0?new T(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):new T(y.endLineNumber,y.endColumn,y.startLineNumber,y.startColumn)}static liftSelection(y){return new T(y.selectionStartLineNumber,y.selectionStartColumn,y.positionLineNumber,y.positionColumn)}static selectionsArrEqual(y,b){if(y&&!b||!y&&b)return!1;if(!y&&!b)return!0;if(y.length!==b.length)return!1;for(let I=0,R=y.length;I<R;I++)if(!this.selectionsEqual(y[I],b[I]))return!1;return!0}static isISelection(y){return y&&typeof y.selectionStartLineNumber=="number"&&typeof y.selectionStartColumn=="number"&&typeof y.positionLineNumber=="number"&&typeof y.positionColumn=="number"}static createWithDirection(y,b,I,R,k){return k===0?new T(y,b,I,R):new T(I,R,y,b)}}e.Selection=T}),define(Ie[146],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[147],ke([0,1,98]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var n;(function(C){C[C.Regular=0]="Regular",C[C.Whitespace=1]="Whitespace",C[C.WordSeparator=2]="WordSeparator"})(n=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends u.CharacterClassifier{constructor(y){super(0);for(let b=0,I=y.length;b<I;b++)this.set(y.charCodeAt(b),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function T(C){const y={};return b=>(y.hasOwnProperty(b)||(y[b]=C(b)),y[b])}e.getMapForWordSeparators=T(C=>new D(C))}),define(Ie[99],ke([0,1,59,6,80]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function T(k=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)k.indexOf(P)>=0||(_+="\\"+P);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=T();function C(k){let _=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)_=k;else{let P="g";k.ignoreCase&&(P+="i"),k.multiline&&(P+="m"),k.unicode&&(P+="u"),_=new RegExp(k.source,P)}return _.lastIndex=0,_}e.ensureValidWordDefinition=C;const y=new D.LinkedList;y.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function b(k){const _=y.unshift(k);return(0,n.toDisposable)(_)}e.setDefaultGetWordAtTextConfig=b;function I(k,_,P,v,w){if(w||(w=u.Iterable.first(y)),P.length>w.maxLen){let c=k-w.maxLen/2;return c<0?c=0:v+=c,P=P.substring(c,k+w.maxLen/2),I(k,_,P,v,w)}const p=Date.now(),f=k-1-v;let E=-1,g=null;for(let c=1;!(Date.now()-p>=w.timeBudget);c++){const m=f-w.windowSize*c;_.lastIndex=Math.max(0,m);const a=R(_,P,f,E);if(!a&&g||(g=a,m<=0))break;E=m}if(g){const c={word:g[0],startColumn:v+1+g.index,endColumn:v+1+g.index+g[0].length};return _.lastIndex=0,c}return null}e.getWordAtText=I;function R(k,_,P,v){let w;for(;w=k.exec(_);){const p=w.index||0;if(p<=P&&k.lastIndex>=P)return w;if(v>0&&p>v)return null}return null}}),define(Ie[148],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var u;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(u=e.IndentAction||(e.IndentAction={}));class n{constructor(y){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=y.open,this.close=y.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(y.notIn))for(let b=0,I=y.notIn.length;b<I;b++)switch(y.notIn[b]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(y){switch(y){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(y,b){if(y.getTokenCount()===0)return!0;const I=y.findTokenIndexAtOffset(b-2),R=y.getStandardTokenType(I);return this.isOK(R)}_findNeutralCharacterInRange(y,b){for(let I=y;I<=b;I++){const R=String.fromCharCode(I);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=n;class D{constructor(y){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const b of y)T(this.autoClosingPairsOpenByStart,b.open.charAt(0),b),T(this.autoClosingPairsOpenByEnd,b.open.charAt(b.open.length-1),b),T(this.autoClosingPairsCloseByStart,b.close.charAt(0),b),T(this.autoClosingPairsCloseByEnd,b.close.charAt(b.close.length-1),b),b.close.length===1&&b.open.length===1&&T(this.autoClosingPairsCloseSingleChar,b.close,b)}}e.AutoClosingPairs=D;function T(C,y,b){C.has(y)?C.get(y).push(b):C.set(y,[b])}}),define(Ie[149],ke([0,1,98]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var n;(function(P){P[P.Invalid=0]="Invalid",P[P.Start=1]="Start",P[P.H=2]="H",P[P.HT=3]="HT",P[P.HTT=4]="HTT",P[P.HTTP=5]="HTTP",P[P.F=6]="F",P[P.FI=7]="FI",P[P.FIL=8]="FIL",P[P.BeforeColon=9]="BeforeColon",P[P.AfterColon=10]="AfterColon",P[P.AlmostThere=11]="AlmostThere",P[P.End=12]="End",P[P.Accept=13]="Accept",P[P.LastKnownState=14]="LastKnownState"})(n=e.State||(e.State={}));class D{constructor(v,w,p){const f=new Uint8Array(v*w);for(let E=0,g=v*w;E<g;E++)f[E]=p;this._data=f,this.rows=v,this.cols=w}get(v,w){return this._data[v*this.cols+w]}set(v,w,p){this._data[v*this.cols+w]=p}}e.Uint8Matrix=D;class T{constructor(v){let w=0,p=0;for(let E=0,g=v.length;E<g;E++){const[c,m,a]=v[E];m>w&&(w=m),c>p&&(p=c),a>p&&(p=a)}w++,p++;const f=new D(p,w,0);for(let E=0,g=v.length;E<g;E++){const[c,m,a]=v[E];f.set(c,m,a)}this._states=f,this._maxCharCode=w}nextState(v,w){return w<0||w>=this._maxCharCode?0:this._states.get(v,w)}}e.StateMachine=T;let C=null;function y(){return C===null&&(C=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),C}var b;(function(P){P[P.None=0]="None",P[P.ForceTermination=1]="ForceTermination",P[P.CannotEndIn=2]="CannotEndIn"})(b||(b={}));let I=null;function R(){if(I===null){I=new u.CharacterClassifier(0);const P=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<P.length;w++)I.set(P.charCodeAt(w),1);const v=".,;:";for(let w=0;w<v.length;w++)I.set(v.charCodeAt(w),2)}return I}class k{static _createLink(v,w,p,f,E){let g=E-1;do{const c=w.charCodeAt(g);if(v.get(c)!==2)break;g--}while(g>f);if(f>0){const c=w.charCodeAt(f-1),m=w.charCodeAt(g);(c===40&&m===41||c===91&&m===93||c===123&&m===125)&&g--}return{range:{startLineNumber:p,startColumn:f+1,endLineNumber:p,endColumn:g+2},url:w.substring(f,g+1)}}static computeLinks(v,w=y()){const p=R(),f=[];for(let E=1,g=v.getLineCount();E<=g;E++){const c=v.getLineContent(E),m=c.length;let a=0,d=0,i=0,o=1,r=!1,t=!1,s=!1,l=!1;for(;a<m;){let h=!1;const S=c.charCodeAt(a);if(o===13){let L;switch(S){case 40:r=!0,L=0;break;case 41:L=r?0:1;break;case 91:s=!0,t=!0,L=0;break;case 93:s=!1,L=t?0:1;break;case 123:l=!0,L=0;break;case 125:L=l?0:1;break;case 39:L=i===39?1:0;break;case 34:L=i===34?1:0;break;case 96:L=i===96?1:0;break;case 42:L=i===42?1:0;break;case 124:L=i===124?1:0;break;case 32:L=s?0:1;break;default:L=p.get(S)}L===1&&(f.push(k._createLink(p,c,E,d,a)),h=!0)}else if(o===12){let L;S===91?(t=!0,L=0):L=p.get(S),L===1?h=!0:o=13}else o=w.nextState(o,S),o===0&&(h=!0);h&&(o=1,r=!1,t=!1,l=!1,d=a+1,i=S),a++}o===13&&f.push(k._createLink(p,c,E,d,m))}return f}}e.LinkComputer=k;function _(P){return!P||typeof P.getLineCount!="function"||typeof P.getLineContent!="function"?[]:k.computeLinks(P)}e.computeLinks=_}),define(Ie[100],ke([0,1,24]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var n;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(n=e.OverviewRulerLane||(e.OverviewRulerLane={}));var D;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(D=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(g){g[g.Both=0]="Both",g[g.Right=1]="Right",g[g.Left=2]="Left",g[g.None=3]="None"})(T=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var C;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var y;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(y=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var b;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(b=e.EndOfLineSequence||(e.EndOfLineSequence={}));class I{constructor(c){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,c.tabSize|0),this.indentSize=c.tabSize|0,this.insertSpaces=Boolean(c.insertSpaces),this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=Boolean(c.trimAutoWhitespace),this.bracketPairColorizationOptions=c.bracketPairColorizationOptions}equals(c){return this.tabSize===c.tabSize&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace&&(0,u.equals)(this.bracketPairColorizationOptions,c.bracketPairColorizationOptions)}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}e.TextModelResolvedOptions=I;class R{constructor(c,m){this._findMatchBrand=void 0,this.range=c,this.matches=m}}e.FindMatch=R;var k;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function _(g){return g&&typeof g.read=="function"}e.isITextSnapshot=_;var P;(function(g){g[g.Left=0]="Left",g[g.Right=1]="Right",g[g.None=2]="None",g[g.LeftOfInjectedText=3]="LeftOfInjectedText",g[g.RightOfInjectedText=4]="RightOfInjectedText"})(P=e.PositionAffinity||(e.PositionAffinity={}));var v;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v=e.ModelConstants||(e.ModelConstants={}));class w{constructor(c,m,a,d,i,o){this.identifier=c,this.range=m,this.text=a,this.forceMoveMarkers=d,this.isAutoWhitespaceEdit=i,this._isTracked=o}}e.ValidAnnotatedEditOperation=w;class p{constructor(c,m,a){this.regex=c,this.wordSeparators=m,this.simpleSearch=a}}e.SearchData=p;class f{constructor(c,m,a){this.reverseEdits=c,this.changes=m,this.trimAutoWhitespaceLineNumbers=a}}e.ApplyEditsResult=f;function E(g){return!g.isTooLargeForSyncing()&&!g.isForSimpleWidget}e.shouldSynchronizeModel=E}),define(Ie[150],ke([0,1,16,96]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class D{constructor(b){this.values=b,this.prefixSum=new Uint32Array(b.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(b,I){b=(0,n.toUint32)(b);const R=this.values,k=this.prefixSum,_=I.length;return _===0?!1:(this.values=new Uint32Array(R.length+_),this.values.set(R.subarray(0,b),0),this.values.set(R.subarray(b),b+_),this.values.set(I,b),b-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=b-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(b,I){return b=(0,n.toUint32)(b),I=(0,n.toUint32)(I),this.values[b]===I?!1:(this.values[b]=I,b-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=b-1),!0)}removeValues(b,I){b=(0,n.toUint32)(b),I=(0,n.toUint32)(I);const R=this.values,k=this.prefixSum;if(b>=R.length)return!1;const _=R.length-b;return I>=_&&(I=_),I===0?!1:(this.values=new Uint32Array(R.length-I),this.values.set(R.subarray(0,b),0),this.values.set(R.subarray(b+I),b),this.prefixSum=new Uint32Array(this.values.length),b-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=b-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(b){return b<0?0:(b=(0,n.toUint32)(b),this._getPrefixSum(b))}_getPrefixSum(b){if(b<=this.prefixSumValidIndex[0])return this.prefixSum[b];let I=this.prefixSumValidIndex[0]+1;I===0&&(this.prefixSum[0]=this.values[0],I++),b>=this.values.length&&(b=this.values.length-1);for(let R=I;R<=b;R++)this.prefixSum[R]=this.prefixSum[R-1]+this.values[R];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],b),this.prefixSum[b]}getIndexOf(b){b=Math.floor(b),this.getTotalSum();let I=0,R=this.values.length-1,k=0,_=0,P=0;for(;I<=R;)if(k=I+(R-I)/2|0,_=this.prefixSum[k],P=_-this.values[k],b<P)R=k-1;else if(b>=_)I=k+1;else break;return new C(k,b-P)}}e.PrefixSumComputer=D;class T{constructor(b){this._values=b,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(b){return this._ensureValid(),b===0?0:this._prefixSum[b-1]}getIndexOf(b){this._ensureValid();const I=this._indexBySum[b],R=I>0?this._prefixSum[I-1]:0;return new C(I,b-R)}removeValues(b,I){this._values.splice(b,I),this._invalidate(b)}insertValues(b,I){this._values=(0,u.arrayInsert)(this._values,b,I),this._invalidate(b)}_invalidate(b){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,b-1)}_ensureValid(){if(!this._isValid){for(let b=this._validEndIndex+1,I=this._values.length;b<I;b++){const R=this._values[b],k=b>0?this._prefixSum[b-1]:0;this._prefixSum[b]=k+R;for(let _=0;_<R;_++)this._indexBySum[k+_]=b}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(b,I){this._values[b]!==I&&(this._values[b]=I,this._invalidate(b))}}e.ConstantTimePrefixSumComputer=T;class C{constructor(b,I){this.index=b,this.remainder=I,this._prefixSumIndexOfResultBrand=void 0,this.index=b,this.remainder=I}}e.PrefixSumIndexOfResult=C}),define(Ie[151],ke([19,20]),function(J,e){return J.create("vs/base/common/date",e)}),define(Ie[152],ke([0,1,151]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,D=n*60,T=D*24,C=T*7,y=T*30,b=T*365;function I(k,_,P){typeof k!="number"&&(k=k.getTime());const v=Math.round((new Date().getTime()-k)/1e3);if(v<-30)return(0,u.localize)(0,null,I(new Date().getTime()+v*1e3,!1));if(v<30)return(0,u.localize)(1,null);let w;return v<n?(w=v,_?w===1?P?(0,u.localize)(2,null,w):(0,u.localize)(3,null,w):P?(0,u.localize)(4,null,w):(0,u.localize)(5,null,w):w===1?P?(0,u.localize)(6,null,w):(0,u.localize)(7,null,w):P?(0,u.localize)(8,null,w):(0,u.localize)(9,null,w)):v<D?(w=Math.floor(v/n),_?w===1?P?(0,u.localize)(10,null,w):(0,u.localize)(11,null,w):P?(0,u.localize)(12,null,w):(0,u.localize)(13,null,w):w===1?P?(0,u.localize)(14,null,w):(0,u.localize)(15,null,w):P?(0,u.localize)(16,null,w):(0,u.localize)(17,null,w)):v<T?(w=Math.floor(v/D),_?w===1?P?(0,u.localize)(18,null,w):(0,u.localize)(19,null,w):P?(0,u.localize)(20,null,w):(0,u.localize)(21,null,w):w===1?P?(0,u.localize)(22,null,w):(0,u.localize)(23,null,w):P?(0,u.localize)(24,null,w):(0,u.localize)(25,null,w)):v<C?(w=Math.floor(v/T),_?w===1?(0,u.localize)(26,null,w):(0,u.localize)(27,null,w):w===1?(0,u.localize)(28,null,w):(0,u.localize)(29,null,w)):v<y?(w=Math.floor(v/C),_?w===1?P?(0,u.localize)(30,null,w):(0,u.localize)(31,null,w):P?(0,u.localize)(32,null,w):(0,u.localize)(33,null,w):w===1?P?(0,u.localize)(34,null,w):(0,u.localize)(35,null,w):P?(0,u.localize)(36,null,w):(0,u.localize)(37,null,w)):v<b?(w=Math.floor(v/y),_?w===1?P?(0,u.localize)(38,null,w):(0,u.localize)(39,null,w):P?(0,u.localize)(40,null,w):(0,u.localize)(41,null,w):w===1?P?(0,u.localize)(42,null,w):(0,u.localize)(43,null,w):P?(0,u.localize)(44,null,w):(0,u.localize)(45,null,w)):(w=Math.floor(v/b),_?w===1?P?(0,u.localize)(46,null,w):(0,u.localize)(47,null,w):P?(0,u.localize)(48,null,w):(0,u.localize)(49,null,w):w===1?P?(0,u.localize)(50,null,w):(0,u.localize)(51,null,w):P?(0,u.localize)(52,null,w):(0,u.localize)(53,null,w))}e.fromNow=I;function R(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Ie[153],ke([19,20]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(Ie[49],ke([0,1,16,11,153]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(k,_){return _&&(k.stack||k.stacktrace)?D.localize(0,null,y(k),C(k.stack)||C(k.stacktrace)):y(k)}function C(k){return Array.isArray(k)?k.join(`
`):k}function y(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?D.localize(1,null,k.message):k.message||D.localize(2,null)}function b(k=null,_=!1){if(!k)return D.localize(3,null);if(Array.isArray(k)){const P=u.coalesce(k),v=b(P[0],_);return P.length>1?D.localize(4,null,v,P.length):v}if(n.isString(k))return k;if(k.detail){const P=k.detail;if(P.error)return T(P.error,_);if(P.exception)return T(P.exception,_)}return k.stack?T(k,_):k.message?k.message:D.localize(5,null)}e.toErrorMessage=b;function I(k){const _=k;return _ instanceof Error&&Array.isArray(_.actions)}e.isErrorWithActions=I;function R(k,_){let P;return typeof k=="string"?P=new Error(k):P=k,P.actions=_,P}e.createErrorWithActions=R}),define(Ie[154],ke([19,20]),function(J,e){return J.create("vs/base/common/platform",e)}),define(Ie[13],ke([0,1,154]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const n="en";let D=!1,T=!1,C=!1,y=!1,b=!1,I=!1,R=!1,k=!1,_=!1,P,v=n,w,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?f=e.globals.vscode.process:typeof process!="undefined"&&(f=process);const E=typeof f?.versions?.electron=="string",g=E&&f?.type==="renderer";if(typeof navigator=="object"&&!g)p=navigator.userAgent,D=p.indexOf("Windows")>=0,T=p.indexOf("Macintosh")>=0,k=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=p.indexOf("Linux")>=0,I=!0,P=u.getConfiguredDefaultLocale(u.localize(0,null))||n,v=P;else if(typeof f=="object"){D=f.platform==="win32",T=f.platform==="darwin",C=f.platform==="linux",y=C&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,R=E,_=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,P=n,v=n;const s=f.env.VSCODE_NLS_CONFIG;if(s)try{const l=JSON.parse(s),h=l.availableLanguages["*"];P=l.locale,v=h||n,w=l._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var c;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(c=e.Platform||(e.Platform={}));function m(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=m;let a=0;T?a=1:D?a=3:C&&(a=2),e.isWindows=D,e.isMacintosh=T,e.isLinux=C,e.isLinuxSnap=y,e.isNative=b,e.isElectron=R,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=k,e.isCI=_,e.platform=a,e.userAgent=p,e.language=v;var d;(function(s){function l(){return e.language}s.value=l;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=h;function S(){return e.language==="en"}s.isDefault=S})(d=e.Language||(e.Language={})),e.locale=P,e.translationsConfigFile=w,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const s=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let S=0,L=s.length;S<L;S++){const F=s[S];if(F.id===h.data.vscodeScheduleAsyncWork){s.splice(S,1),F.callback();return}}});let l=0;return h=>{const S=++l;s.push({id:S,callback:h}),e.globals.postMessage({vscodeScheduleAsyncWork:S},"*")}}return s=>setTimeout(s)})();var i;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||k?2:D?1:3;let o=!0,r=!1;function t(){if(!r){r=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,o=new Uint16Array(s.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=t,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Ie[36],ke([0,1,13]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof u.globals.vscode!="undefined"&&typeof u.globals.vscode.process!="undefined"){const D=u.globals.vscode.process;n={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return u.isWindows?"win32":u.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(Ie[9],ke([0,1,36]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,D=97,T=90,C=122,y=46,b=47,I=92,R=58,k=63;class _ extends Error{constructor(c,m,a){let d;typeof m=="string"&&m.indexOf("not ")===0?(d="must not be",m=m.replace(/^not /,"")):d="must be";const i=c.indexOf(".")!==-1?"property":"argument";let o=`The "${c}" ${i} ${d} of type ${m}`;o+=`. Received type ${typeof a}`;super(o);this.code="ERR_INVALID_ARG_TYPE"}}function P(g,c){if(typeof g!="string")throw new _(c,"string",g)}function v(g){return g===b||g===I}function w(g){return g===b}function p(g){return g>=n&&g<=T||g>=D&&g<=C}function f(g,c,m,a){let d="",i=0,o=-1,r=0,t=0;for(let s=0;s<=g.length;++s){if(s<g.length)t=g.charCodeAt(s);else{if(a(t))break;t=b}if(a(t)){if(!(o===s-1||r===1))if(r===2){if(d.length<2||i!==2||d.charCodeAt(d.length-1)!==y||d.charCodeAt(d.length-2)!==y){if(d.length>2){const l=d.lastIndexOf(m);l===-1?(d="",i=0):(d=d.slice(0,l),i=d.length-1-d.lastIndexOf(m)),o=s,r=0;continue}else if(d.length!==0){d="",i=0,o=s,r=0;continue}}c&&(d+=d.length>0?`${m}..`:"..",i=2)}else d.length>0?d+=`${m}${g.slice(o+1,s)}`:d=g.slice(o+1,s),i=s-o-1;o=s,r=0}else t===y&&r!==-1?++r:r=-1}return d}function E(g,c){if(c===null||typeof c!="object")throw new _("pathObject","Object",c);const m=c.dir||c.root,a=c.base||`${c.name||""}${c.ext||""}`;return m?m===c.root?`${m}${a}`:`${m}${g}${a}`:a}e.win32={resolve(...g){let c="",m="",a=!1;for(let d=g.length-1;d>=-1;d--){let i;if(d>=0){if(i=g[d],P(i,"path"),i.length===0)continue}else c.length===0?i=u.cwd():(i=u.env[`=${c}`]||u.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==c.toLowerCase()&&i.charCodeAt(2)===I)&&(i=`${c}\\`));const o=i.length;let r=0,t="",s=!1;const l=i.charCodeAt(0);if(o===1)v(l)&&(r=1,s=!0);else if(v(l))if(s=!0,v(i.charCodeAt(1))){let h=2,S=h;for(;h<o&&!v(i.charCodeAt(h));)h++;if(h<o&&h!==S){const L=i.slice(S,h);for(S=h;h<o&&v(i.charCodeAt(h));)h++;if(h<o&&h!==S){for(S=h;h<o&&!v(i.charCodeAt(h));)h++;(h===o||h!==S)&&(t=`\\\\${L}\\${i.slice(S,h)}`,r=h)}}}else r=1;else p(l)&&i.charCodeAt(1)===R&&(t=i.slice(0,2),r=2,o>2&&v(i.charCodeAt(2))&&(s=!0,r=3));if(t.length>0)if(c.length>0){if(t.toLowerCase()!==c.toLowerCase())continue}else c=t;if(a){if(c.length>0)break}else if(m=`${i.slice(r)}\\${m}`,a=s,s&&c.length>0)break}return m=f(m,!a,"\\",v),a?`${c}\\${m}`:`${c}${m}`||"."},normalize(g){P(g,"path");const c=g.length;if(c===0)return".";let m=0,a,d=!1;const i=g.charCodeAt(0);if(c===1)return w(i)?"\\":g;if(v(i))if(d=!0,v(g.charCodeAt(1))){let r=2,t=r;for(;r<c&&!v(g.charCodeAt(r));)r++;if(r<c&&r!==t){const s=g.slice(t,r);for(t=r;r<c&&v(g.charCodeAt(r));)r++;if(r<c&&r!==t){for(t=r;r<c&&!v(g.charCodeAt(r));)r++;if(r===c)return`\\\\${s}\\${g.slice(t)}\\`;r!==t&&(a=`\\\\${s}\\${g.slice(t,r)}`,m=r)}}}else m=1;else p(i)&&g.charCodeAt(1)===R&&(a=g.slice(0,2),m=2,c>2&&v(g.charCodeAt(2))&&(d=!0,m=3));let o=m<c?f(g.slice(m),!d,"\\",v):"";return o.length===0&&!d&&(o="."),o.length>0&&v(g.charCodeAt(c-1))&&(o+="\\"),a===void 0?d?`\\${o}`:o:d?`${a}\\${o}`:`${a}${o}`},isAbsolute(g){P(g,"path");const c=g.length;if(c===0)return!1;const m=g.charCodeAt(0);return v(m)||c>2&&p(m)&&g.charCodeAt(1)===R&&v(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let c,m;for(let i=0;i<g.length;++i){const o=g[i];P(o,"path"),o.length>0&&(c===void 0?c=m=o:c+=`\\${o}`)}if(c===void 0)return".";let a=!0,d=0;if(typeof m=="string"&&v(m.charCodeAt(0))){++d;const i=m.length;i>1&&v(m.charCodeAt(1))&&(++d,i>2&&(v(m.charCodeAt(2))?++d:a=!1))}if(a){for(;d<c.length&&v(c.charCodeAt(d));)d++;d>=2&&(c=`\\${c.slice(d)}`)}return e.win32.normalize(c)},relative(g,c){if(P(g,"from"),P(c,"to"),g===c)return"";const m=e.win32.resolve(g),a=e.win32.resolve(c);if(m===a||(g=m.toLowerCase(),c=a.toLowerCase(),g===c))return"";let d=0;for(;d<g.length&&g.charCodeAt(d)===I;)d++;let i=g.length;for(;i-1>d&&g.charCodeAt(i-1)===I;)i--;const o=i-d;let r=0;for(;r<c.length&&c.charCodeAt(r)===I;)r++;let t=c.length;for(;t-1>r&&c.charCodeAt(t-1)===I;)t--;const s=t-r,l=o<s?o:s;let h=-1,S=0;for(;S<l;S++){const F=g.charCodeAt(d+S);if(F!==c.charCodeAt(r+S))break;F===I&&(h=S)}if(S!==l){if(h===-1)return a}else{if(s>l){if(c.charCodeAt(r+S)===I)return a.slice(r+S+1);if(S===2)return a.slice(r+S)}o>l&&(g.charCodeAt(d+S)===I?h=S:S===2&&(h=3)),h===-1&&(h=0)}let L="";for(S=d+h+1;S<=i;++S)(S===i||g.charCodeAt(S)===I)&&(L+=L.length===0?"..":"\\..");return r+=h,L.length>0?`${L}${a.slice(r,t)}`:(a.charCodeAt(r)===I&&++r,a.slice(r,t))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const c=e.win32.resolve(g);if(c.length<=2)return g;if(c.charCodeAt(0)===I){if(c.charCodeAt(1)===I){const m=c.charCodeAt(2);if(m!==k&&m!==y)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(p(c.charCodeAt(0))&&c.charCodeAt(1)===R&&c.charCodeAt(2)===I)return`\\\\?\\${c}`;return g},dirname(g){P(g,"path");const c=g.length;if(c===0)return".";let m=-1,a=0;const d=g.charCodeAt(0);if(c===1)return v(d)?g:".";if(v(d)){if(m=a=1,v(g.charCodeAt(1))){let r=2,t=r;for(;r<c&&!v(g.charCodeAt(r));)r++;if(r<c&&r!==t){for(t=r;r<c&&v(g.charCodeAt(r));)r++;if(r<c&&r!==t){for(t=r;r<c&&!v(g.charCodeAt(r));)r++;if(r===c)return g;r!==t&&(m=a=r+1)}}}}else p(d)&&g.charCodeAt(1)===R&&(m=c>2&&v(g.charCodeAt(2))?3:2,a=m);let i=-1,o=!0;for(let r=c-1;r>=a;--r)if(v(g.charCodeAt(r))){if(!o){i=r;break}}else o=!1;if(i===-1){if(m===-1)return".";i=m}return g.slice(0,i)},basename(g,c){c!==void 0&&P(c,"ext"),P(g,"path");let m=0,a=-1,d=!0,i;if(g.length>=2&&p(g.charCodeAt(0))&&g.charCodeAt(1)===R&&(m=2),c!==void 0&&c.length>0&&c.length<=g.length){if(c===g)return"";let o=c.length-1,r=-1;for(i=g.length-1;i>=m;--i){const t=g.charCodeAt(i);if(v(t)){if(!d){m=i+1;break}}else r===-1&&(d=!1,r=i+1),o>=0&&(t===c.charCodeAt(o)?--o==-1&&(a=i):(o=-1,a=r))}return m===a?a=r:a===-1&&(a=g.length),g.slice(m,a)}for(i=g.length-1;i>=m;--i)if(v(g.charCodeAt(i))){if(!d){m=i+1;break}}else a===-1&&(d=!1,a=i+1);return a===-1?"":g.slice(m,a)},extname(g){P(g,"path");let c=0,m=-1,a=0,d=-1,i=!0,o=0;g.length>=2&&g.charCodeAt(1)===R&&p(g.charCodeAt(0))&&(c=a=2);for(let r=g.length-1;r>=c;--r){const t=g.charCodeAt(r);if(v(t)){if(!i){a=r+1;break}continue}d===-1&&(i=!1,d=r+1),t===y?m===-1?m=r:o!==1&&(o=1):m!==-1&&(o=-1)}return m===-1||d===-1||o===0||o===1&&m===d-1&&m===a+1?"":g.slice(m,d)},format:E.bind(null,"\\"),parse(g){P(g,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return c;const m=g.length;let a=0,d=g.charCodeAt(0);if(m===1)return v(d)?(c.root=c.dir=g,c):(c.base=c.name=g,c);if(v(d)){if(a=1,v(g.charCodeAt(1))){let h=2,S=h;for(;h<m&&!v(g.charCodeAt(h));)h++;if(h<m&&h!==S){for(S=h;h<m&&v(g.charCodeAt(h));)h++;if(h<m&&h!==S){for(S=h;h<m&&!v(g.charCodeAt(h));)h++;h===m?a=h:h!==S&&(a=h+1)}}}}else if(p(d)&&g.charCodeAt(1)===R){if(m<=2)return c.root=c.dir=g,c;if(a=2,v(g.charCodeAt(2))){if(m===3)return c.root=c.dir=g,c;a=3}}a>0&&(c.root=g.slice(0,a));let i=-1,o=a,r=-1,t=!0,s=g.length-1,l=0;for(;s>=a;--s){if(d=g.charCodeAt(s),v(d)){if(!t){o=s+1;break}continue}r===-1&&(t=!1,r=s+1),d===y?i===-1?i=s:l!==1&&(l=1):i!==-1&&(l=-1)}return r!==-1&&(i===-1||l===0||l===1&&i===r-1&&i===o+1?c.base=c.name=g.slice(o,r):(c.name=g.slice(o,i),c.base=g.slice(o,r),c.ext=g.slice(i,r))),o>0&&o!==a?c.dir=g.slice(0,o-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let c="",m=!1;for(let a=g.length-1;a>=-1&&!m;a--){const d=a>=0?g[a]:u.cwd();P(d,"path"),d.length!==0&&(c=`${d}/${c}`,m=d.charCodeAt(0)===b)}return c=f(c,!m,"/",w),m?`/${c}`:c.length>0?c:"."},normalize(g){if(P(g,"path"),g.length===0)return".";const c=g.charCodeAt(0)===b,m=g.charCodeAt(g.length-1)===b;return g=f(g,!c,"/",w),g.length===0?c?"/":m?"./":".":(m&&(g+="/"),c?`/${g}`:g)},isAbsolute(g){return P(g,"path"),g.length>0&&g.charCodeAt(0)===b},join(...g){if(g.length===0)return".";let c;for(let m=0;m<g.length;++m){const a=g[m];P(a,"path"),a.length>0&&(c===void 0?c=a:c+=`/${a}`)}return c===void 0?".":e.posix.normalize(c)},relative(g,c){if(P(g,"from"),P(c,"to"),g===c||(g=e.posix.resolve(g),c=e.posix.resolve(c),g===c))return"";const m=1,a=g.length,d=a-m,i=1,o=c.length-i,r=d<o?d:o;let t=-1,s=0;for(;s<r;s++){const h=g.charCodeAt(m+s);if(h!==c.charCodeAt(i+s))break;h===b&&(t=s)}if(s===r)if(o>r){if(c.charCodeAt(i+s)===b)return c.slice(i+s+1);if(s===0)return c.slice(i+s)}else d>r&&(g.charCodeAt(m+s)===b?t=s:s===0&&(t=0));let l="";for(s=m+t+1;s<=a;++s)(s===a||g.charCodeAt(s)===b)&&(l+=l.length===0?"..":"/..");return`${l}${c.slice(i+t)}`},toNamespacedPath(g){return g},dirname(g){if(P(g,"path"),g.length===0)return".";const c=g.charCodeAt(0)===b;let m=-1,a=!0;for(let d=g.length-1;d>=1;--d)if(g.charCodeAt(d)===b){if(!a){m=d;break}}else a=!1;return m===-1?c?"/":".":c&&m===1?"//":g.slice(0,m)},basename(g,c){c!==void 0&&P(c,"ext"),P(g,"path");let m=0,a=-1,d=!0,i;if(c!==void 0&&c.length>0&&c.length<=g.length){if(c===g)return"";let o=c.length-1,r=-1;for(i=g.length-1;i>=0;--i){const t=g.charCodeAt(i);if(t===b){if(!d){m=i+1;break}}else r===-1&&(d=!1,r=i+1),o>=0&&(t===c.charCodeAt(o)?--o==-1&&(a=i):(o=-1,a=r))}return m===a?a=r:a===-1&&(a=g.length),g.slice(m,a)}for(i=g.length-1;i>=0;--i)if(g.charCodeAt(i)===b){if(!d){m=i+1;break}}else a===-1&&(d=!1,a=i+1);return a===-1?"":g.slice(m,a)},extname(g){P(g,"path");let c=-1,m=0,a=-1,d=!0,i=0;for(let o=g.length-1;o>=0;--o){const r=g.charCodeAt(o);if(r===b){if(!d){m=o+1;break}continue}a===-1&&(d=!1,a=o+1),r===y?c===-1?c=o:i!==1&&(i=1):c!==-1&&(i=-1)}return c===-1||a===-1||i===0||i===1&&c===a-1&&c===m+1?"":g.slice(c,a)},format:E.bind(null,"/"),parse(g){P(g,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return c;const m=g.charCodeAt(0)===b;let a;m?(c.root="/",a=1):a=0;let d=-1,i=0,o=-1,r=!0,t=g.length-1,s=0;for(;t>=a;--t){const l=g.charCodeAt(t);if(l===b){if(!r){i=t+1;break}continue}o===-1&&(r=!1,o=t+1),l===y?d===-1?d=t:s!==1&&(s=1):d!==-1&&(s=-1)}if(o!==-1){const l=i===0&&m?1:i;d===-1||s===0||s===1&&d===o-1&&d===i+1?c.base=c.name=g.slice(l,o):(c.name=g.slice(l,d),c.base=g.slice(l,o),c.ext=g.slice(d,o))}return i>0?c.dir=g.slice(0,i-1):m&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=u.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=u.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=u.platform==="win32"?e.win32.join:e.posix.join,e.resolve=u.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=u.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=u.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=u.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=u.platform==="win32"?e.win32.extname:e.posix.extname,e.format=u.platform==="win32"?e.win32.format:e.posix.format,e.parse=u.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=u.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=u.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=u.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Ie[101],ke([0,1,9]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const n={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(R){const k=(0,u.extname)(R),_=n[k.toLowerCase()];return _!==void 0?_:C(R)}e.getMediaOrTextMime=T;function C(R){const k=(0,u.extname)(R);return D[k.toLowerCase()]}e.getMediaMime=C;function y(R){for(const k in D)if(D[k]===R)return k}e.getExtensionForMimeType=y;const b=/^(.+)\/(.+?)(;.+)?$/;function I(R,k){const _=b.exec(R);return _?`${_[1].toLowerCase()}/${_[2].toLowerCase()}${_[3]??""}`:k?void 0:R}e.normalizeMimeType=I}),define(Ie[102],ke([0,1,13]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var n;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(n=e.Source||(e.Source={}));var D;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(y,...b){const I=b.reduce((_,P)=>(_[P]=!0,_),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(_=>!I[_]).forEach(_=>{for(let P=0;P<R.length;P++)if(_.search(R[P])!==-1){delete y[_];break}})}e.sanitizeProcessEnvironment=T;function C(y){!y||(delete y.DEBUG,u.isMacintosh&&delete y.DYLD_LIBRARY_PATH,u.isLinux&&delete y.LD_PRELOAD)}e.removeDangerousEnvVariables=C}),define(Ie[50],ke([0,1,13]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=u.globals.performance&&typeof u.globals.performance.now=="function";class D{constructor(C){this._highResolution=n&&C,this._startTime=this._now(),this._stopTime=-1}static create(C=!0){return new D(C)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?u.globals.performance.now():Date.now()}}e.StopWatch=D}),define(Ie[3],ke([0,1,12,58,6,80,50]),function(J,e,u,n,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const y=!1,b=!1;var I;(function(t){t.None=()=>D.Disposable.None;function s(ge){if(b){const{onListenerDidAdd:Ee}=ge,Pe=v.create();let Ne=0;ge.onListenerDidAdd=()=>{++Ne==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Pe.print()),Ee?.()}}}function l(ge){return(Ee,Pe=null,Ne)=>{let ve=!1,ue;return ue=ge(de=>{if(!ve)return ue?ue.dispose():ve=!0,Ee.call(Pe,de)},null,Ne),ve&&ue.dispose(),ue}}t.once=l;function h(ge,Ee,Pe){return B((Ne,ve=null,ue)=>ge(de=>Ne.call(ve,Ee(de)),null,ue),Pe)}t.map=h;function S(ge,Ee,Pe){return B((Ne,ve=null,ue)=>ge(de=>{Ee(de),Ne.call(ve,de)},null,ue),Pe)}t.forEach=S;function L(ge,Ee,Pe){return B((Ne,ve=null,ue)=>ge(de=>Ee(de)&&Ne.call(ve,de),null,ue),Pe)}t.filter=L;function F(ge){return ge}t.signal=F;function M(...ge){return(Ee,Pe=null,Ne)=>(0,D.combinedDisposable)(...ge.map(ve=>ve(ue=>Ee.call(Pe,ue),null,Ne)))}t.any=M;function A(ge,Ee,Pe,Ne){let ve=Pe;return h(ge,ue=>(ve=Ee(ve,ue),ve),Ne)}t.reduce=A;function B(ge,Ee){let Pe;const Ne={onFirstListenerAdd(){Pe=ge(ve.fire,ve)},onLastListenerRemove(){Pe?.dispose()}};Ee||s(Ne);const ve=new p(Ne);return Ee?.add(ve),ve.event}function $(ge,Ee,Pe=100,Ne=!1,ve,ue){let de,we,re,me=0;const Z={leakWarningThreshold:ve,onFirstListenerAdd(){de=ge(O=>{me++,we=Ee(we,O),Ne&&!re&&(se.fire(we),we=void 0),clearTimeout(re),re=setTimeout(()=>{const H=we;we=void 0,re=void 0,(!Ne||me>1)&&se.fire(H),me=0},Pe)})},onLastListenerRemove(){de.dispose()}};ue||s(Z);const se=new p(Z);return ue?.add(se),se.event}t.debounce=$;function U(ge,Ee=(Ne,ve)=>Ne===ve,Pe){let Ne=!0,ve;return L(ge,ue=>{const de=Ne||!Ee(ue,ve);return Ne=!1,ve=ue,de},Pe)}t.latch=U;function X(ge,Ee,Pe){return[t.filter(ge,Ee,Pe),t.filter(ge,Ne=>!Ee(Ne),Pe)]}t.split=X;function z(ge,Ee=!1,Pe=[]){let Ne=Pe.slice(),ve=ge(we=>{Ne?Ne.push(we):de.fire(we)});const ue=()=>{Ne?.forEach(we=>de.fire(we)),Ne=null},de=new p({onFirstListenerAdd(){ve||(ve=ge(we=>de.fire(we)))},onFirstListenerDidAdd(){Ne&&(Ee?setTimeout(ue):ue())},onLastListenerRemove(){ve&&ve.dispose(),ve=null}});return de.event}t.buffer=z;class N{constructor(Ee){this.event=Ee,this.disposables=new D.DisposableStore}map(Ee){return new N(h(this.event,Ee,this.disposables))}forEach(Ee){return new N(S(this.event,Ee,this.disposables))}filter(Ee){return new N(L(this.event,Ee,this.disposables))}reduce(Ee,Pe){return new N(A(this.event,Ee,Pe,this.disposables))}latch(){return new N(U(this.event,void 0,this.disposables))}debounce(Ee,Pe=100,Ne=!1,ve){return new N($(this.event,Ee,Pe,Ne,ve,this.disposables))}on(Ee,Pe,Ne){return this.event(Ee,Pe,Ne)}once(Ee,Pe,Ne){return l(this.event)(Ee,Pe,Ne)}dispose(){this.disposables.dispose()}}function V(ge){return new N(ge)}t.chain=V;function x(ge,Ee,Pe=Ne=>Ne){const Ne=(...we)=>de.fire(Pe(...we)),ve=()=>ge.on(Ee,Ne),ue=()=>ge.removeListener(Ee,Ne),de=new p({onFirstListenerAdd:ve,onLastListenerRemove:ue});return de.event}t.fromNodeEventEmitter=x;function q(ge,Ee,Pe=Ne=>Ne){const Ne=(...we)=>de.fire(Pe(...we)),ve=()=>ge.addEventListener(Ee,Ne),ue=()=>ge.removeEventListener(Ee,Ne),de=new p({onFirstListenerAdd:ve,onLastListenerRemove:ue});return de.event}t.fromDOMEventEmitter=q;function te(ge){return new Promise(Ee=>l(ge)(Ee))}t.toPromise=te;function Y(ge,Ee){return Ee(void 0),ge(Pe=>Ee(Pe))}t.runAndSubscribe=Y;function le(ge,Ee){let Pe=null;function Ne(ue){Pe?.dispose(),Pe=new D.DisposableStore,Ee(ue,Pe)}Ne(void 0);const ve=ge(ue=>Ne(ue));return(0,D.toDisposable)(()=>{ve.dispose(),Pe?.dispose()})}t.runAndSubscribeWithStore=le;class pe{constructor(Ee,Pe){this.obs=Ee,this._counter=0,this._hasChanged=!1;const Ne={onFirstListenerAdd:()=>{Ee.addObserver(this)},onLastListenerRemove:()=>{Ee.removeObserver(this)}};Pe||s(Ne),this.emitter=new p(Ne),Pe&&Pe.add(this.emitter)}beginUpdate(Ee){this._counter++}handleChange(Ee,Pe){this._hasChanged=!0}endUpdate(Ee){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function ee(ge,Ee){return new pe(ge,Ee).emitter.event}t.fromObservable=ee})(I=e.Event||(e.Event={}));class R{constructor(s){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${s}_${R._idPool++}`}start(s){this._stopWatch=new C.StopWatch(!0),this._listenerCount=s}stop(){if(this._stopWatch){const s=this._stopWatch.elapsed();this._elapsedOverall+=s,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${s.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}R._idPool=0;let k=-1;function _(t){const s=k;return k=t,{dispose(){k=s}}}e.setGlobalLeakWarningThreshold=_;class P{constructor(s,l=Math.random().toString(18).slice(2,5)){this.customThreshold=s,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(s,l){let h=k;if(typeof this.customThreshold=="number"&&(h=this.customThreshold),h<=0||l<h)return;this._stacks||(this._stacks=new Map);const S=this._stacks.get(s.value)||0;if(this._stacks.set(s.value,S+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=h*.5;let L,F=0;for(const[M,A]of this._stacks)(!L||F<A)&&(L=M,F=A);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${F}):`),console.warn(L)}return()=>{const L=this._stacks.get(s.value)||0;this._stacks.set(s.value,L-1)}}}class v{constructor(s){this.value=s}static create(){return new v(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class w{constructor(s,l,h){this.callback=s,this.callbackThis=l,this.stack=h,this.subscription=new D.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class p{constructor(s){this._disposed=!1,this._options=s,this._leakageMon=k>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new R(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(y){const s=Array.from(this._listeners);queueMicrotask(()=>{for(const l of s)l.subscription.isset()&&(l.subscription.unset(),l.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(s,l,h)=>{this._listeners||(this._listeners=new T.LinkedList);const S=this._listeners.isEmpty();S&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let L,F;this._leakageMon&&this._listeners.size>=30&&(F=v.create(),L=this._leakageMon.check(F,this._listeners.size+1)),y&&(F=F??v.create());const M=new w(s,l,F),A=this._listeners.push(M);S&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,s,l);const B=M.subscription.set(()=>{L?.(),this._disposed||(A(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return h instanceof D.DisposableStore?h.add(B):Array.isArray(h)&&h.push(B),B}),this._event}fire(s){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new E);for(const l of this._listeners)this._deliveryQueue.push(this,l,s);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=p;class f{constructor(){this._queue=new T.LinkedList}get size(){return this._queue.size}push(s,l,h){this._queue.push(new g(s,l,h))}clear(s){const l=new T.LinkedList;for(const h of this._queue)h.emitter!==s&&l.push(h);this._queue=l}deliver(){for(;this._queue.size>0;){const s=this._queue.shift();try{s.listener.invoke(s.event)}catch(l){(0,u.onUnexpectedError)(l)}}}}e.EventDeliveryQueue=f;class E extends f{clear(s){this._queue.clear()}}class g{constructor(s,l,h){this.emitter=s,this.listener=l,this.event=h}}class c extends p{async fireAsync(s,l,h){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const S of this._listeners)this._asyncDeliveryQueue.push([S,s]);for(;this._asyncDeliveryQueue.size>0&&!l.isCancellationRequested;){const[S,L]=this._asyncDeliveryQueue.shift(),F=[],M={...L,token:l,waitUntil:A=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");h&&(A=h(A,S.callback)),F.push(A)}};try{S.invoke(M)}catch(A){(0,u.onUnexpectedError)(A);continue}Object.freeze(F),await Promise.allSettled(F).then(A=>{for(const B of A)B.status==="rejected"&&(0,u.onUnexpectedError)(B.reason)})}}}}e.AsyncEmitter=c;class m extends p{constructor(s){super(s);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=s?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const s=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(s))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(s){this._listeners&&(this._isPaused!==0?this._eventQueue.push(s):super.fire(s))}}e.PauseableEmitter=m;class a extends m{constructor(s){super(s);this._delay=s.delay??100}fire(s){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(s)}}e.DebounceEmitter=a;class d extends p{constructor(s){super(s);this._queuedEvents=[],this._mergeFn=s?.merge}fire(s){this._queuedEvents.push(s),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(l=>super.fire(l)),this._queuedEvents=[]})}}e.MicrotaskEmitter=d;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new p({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(s){const l={event:s,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const h=()=>{this.hasListeners&&this.unhook(l);const S=this.events.indexOf(l);this.events.splice(S,1)};return(0,D.toDisposable)((0,n.once)(h))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(s=>this.hook(s))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(s=>this.unhook(s))}hook(s){s.listener=s.event(l=>this.emitter.fire(l))}unhook(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class o{constructor(){this.buffers=[]}wrapEvent(s){return(l,h,S)=>s(L=>{const F=this.buffers[this.buffers.length-1];F?F.push(()=>l.call(h,L)):l.call(h,L)},void 0,S)}bufferEvents(s){const l=[];this.buffers.push(l);const h=s();return this.buffers.pop(),l.forEach(S=>S()),h}}e.EventBufferer=o;class r{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=D.Disposable.None,this.emitter=new p({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(s){this.inputEvent=s,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=s(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=r}),define(Ie[21],ke([0,1,3]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(y,b){const I=setTimeout(y.bind(b),0);return{dispose(){clearTimeout(I)}}});var D;(function(y){function b(I){return I===y.None||I===y.Cancelled||I instanceof T?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}y.isCancellationToken=b,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:u.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(D=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new u.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class C{constructor(b){this._token=void 0,this._parentListener=void 0,this._parentListener=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=D.Cancelled}dispose(b=!1){b&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=C}),define(Ie[155],ke([0,1,21]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class n{constructor(y){this.task=y,this.result=null}get(){if(this.result)return this.result;const y=new u.CancellationTokenSource,b=this.task(y.token);return this.result={promise:b,dispose:()=>{this.result=null,y.cancel(),y.dispose()}},this.result}}e.Cache=n;class D{constructor(y){this.fn=y,this.lastCache=void 0,this.lastArgKey=void 0}get(y){const b=JSON.stringify(y);return this.lastArgKey!==b&&(this.lastArgKey=b,this.lastCache=this.fn(y)),this.lastCache}}e.LRUCachedFunction=D;class T{constructor(y){this.fn=y,this._map=new Map}get cachedValues(){return this._map}get(y){if(this._map.has(y))return this._map.get(y);const b=this.fn(y);return this._map.set(y,b),b}}e.CachedFunction=T}),define(Ie[8],ke([0,1,155,79]),function(J,e,u,n){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=T;const C=/{(\d+)}/g;function y(G,...Ce){return Ce.length===0?G:G.replace(C,function(Re,We){const ze=parseInt(We,10);return isNaN(ze)||ze<0||ze>=Ce.length?Re:Ce[ze]})}e.format=y;const b=/{([^}]+)}/g;function I(G,Ce){return G.replace(b,(Re,We)=>Ce[We]??Re)}e.format2=I;function R(G){return G.replace(/[<>&]/g,function(Ce){switch(Ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ce}})}e.escape=R;function k(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function _(G,Ce){let Re=0;const We=Ce.charCodeAt(0);for(let ze=G.length-1;ze>=0;ze--)G.charCodeAt(ze)===We&&Re++;return Re}e.count=_;function P(G,Ce,Re="\u2026"){return G.length<=Ce?G:`${G.substr(0,Ce)}${Re}`}e.truncate=P;function v(G,Ce=" "){const Re=w(G,Ce);return p(Re,Ce)}e.trim=v;function w(G,Ce){if(!G||!Ce)return G;const Re=Ce.length;if(Re===0||G.length===0)return G;let We=0;for(;G.indexOf(Ce,We)===We;)We=We+Re;return G.substring(We)}e.ltrim=w;function p(G,Ce){if(!G||!Ce)return G;const Re=Ce.length,We=G.length;if(Re===0||We===0)return G;let ze=We,$e=-1;for(;$e=G.lastIndexOf(Ce,ze-1),!($e===-1||$e+Re!==ze);){if($e===0)return"";ze=$e}return G.substring(0,ze)}e.rtrim=p;function f(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function E(G){return G.replace(/\*/g,"")}e.stripWildcards=E;function g(G,Ce,Re={}){if(!G)throw new Error("Cannot create regex from empty string");Ce||(G=k(G)),Re.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let We="";return Re.global&&(We+="g"),Re.matchCase||(We+="i"),Re.multiline&&(We+="m"),Re.unicode&&(We+="u"),new RegExp(G,We)}e.createRegExp=g;function c(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=c;function m(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=m;function a(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=a;function d(G){return G.split(/\r\n|\r|\n/)}e.splitLines=d;function i(G){for(let Ce=0,Re=G.length;Ce<Re;Ce++){const We=G.charCodeAt(Ce);if(We!==32&&We!==9)return Ce}return-1}e.firstNonWhitespaceIndex=i;function o(G,Ce=0,Re=G.length){for(let We=Ce;We<Re;We++){const ze=G.charCodeAt(We);if(ze!==32&&ze!==9)return G.substring(Ce,We)}return G.substring(Ce,Re)}e.getLeadingWhitespace=o;function r(G,Ce=G.length-1){for(let Re=Ce;Re>=0;Re--){const We=G.charCodeAt(Re);if(We!==32&&We!==9)return Re}return-1}e.lastNonWhitespaceIndex=r;function t(G,Ce,Re){const We=[];let ze=0;for(const $e of G.matchAll(Ce)){if(We.push(G.slice(ze,$e.index)),$e.index===void 0)throw new Error("match.index should be defined");ze=$e.index+$e[0].length,We.push(Re($e[0],...$e.slice(1),$e.index,G,$e.groups))}return We.push(G.slice(ze)),Promise.all(We).then($e=>$e.join(""))}e.replaceAsync=t;function s(G,Ce){return G<Ce?-1:G>Ce?1:0}e.compare=s;function l(G,Ce,Re=0,We=G.length,ze=0,$e=Ce.length){for(;Re<We&&ze<$e;Re++,ze++){const lt=G.charCodeAt(Re),nt=Ce.charCodeAt(ze);if(lt<nt)return-1;if(lt>nt)return 1}const tt=We-Re,st=$e-ze;return tt<st?-1:tt>st?1:0}e.compareSubstring=l;function h(G,Ce){return S(G,Ce,0,G.length,0,Ce.length)}e.compareIgnoreCase=h;function S(G,Ce,Re=0,We=G.length,ze=0,$e=Ce.length){for(;Re<We&&ze<$e;Re++,ze++){let lt=G.charCodeAt(Re),nt=Ce.charCodeAt(ze);if(lt===nt)continue;if(lt>=128||nt>=128)return l(G.toLowerCase(),Ce.toLowerCase(),Re,We,ze,$e);F(lt)&&(lt-=32),F(nt)&&(nt-=32);const it=lt-nt;if(it!==0)return it}const tt=We-Re,st=$e-ze;return tt<st?-1:tt>st?1:0}e.compareSubstringIgnoreCase=S;function L(G){return G>=48&&G<=57}e.isAsciiDigit=L;function F(G){return G>=97&&G<=122}e.isLowerAsciiLetter=F;function M(G){return G>=65&&G<=90}e.isUpperAsciiLetter=M;function A(G,Ce){return G.length===Ce.length&&S(G,Ce)===0}e.equalsIgnoreCase=A;function B(G,Ce){const Re=Ce.length;return Ce.length>G.length?!1:S(G,Ce,0,Re)===0}e.startsWithIgnoreCase=B;function $(G,Ce){const Re=Math.min(G.length,Ce.length);let We;for(We=0;We<Re;We++)if(G.charCodeAt(We)!==Ce.charCodeAt(We))return We;return Re}e.commonPrefixLength=$;function U(G,Ce){const Re=Math.min(G.length,Ce.length);let We;const ze=G.length-1,$e=Ce.length-1;for(We=0;We<Re;We++)if(G.charCodeAt(ze-We)!==Ce.charCodeAt($e-We))return We;return Re}e.commonSuffixLength=U;function X(G){return 55296<=G&&G<=56319}e.isHighSurrogate=X;function z(G){return 56320<=G&&G<=57343}e.isLowSurrogate=z;function N(G,Ce){return(G-55296<<10)+(Ce-56320)+65536}e.computeCodePoint=N;function V(G,Ce,Re){const We=G.charCodeAt(Re);if(X(We)&&Re+1<Ce){const ze=G.charCodeAt(Re+1);if(z(ze))return N(We,ze)}return We}e.getNextCodePoint=V;function x(G,Ce){const Re=G.charCodeAt(Ce-1);if(z(Re)&&Ce>1){const We=G.charCodeAt(Ce-2);if(X(We))return N(We,Re)}return Re}class q{constructor(Ce,Re=0){this._str=Ce,this._len=Ce.length,this._offset=Re}get offset(){return this._offset}setOffset(Ce){this._offset=Ce}prevCodePoint(){const Ce=x(this._str,this._offset);return this._offset-=Ce>=65536?2:1,Ce}nextCodePoint(){const Ce=V(this._str,this._len,this._offset);return this._offset+=Ce>=65536?2:1,Ce}eol(){return this._offset>=this._len}}e.CodePointIterator=q;class te{constructor(Ce,Re=0){this._iterator=new q(Ce,Re)}get offset(){return this._iterator.offset}nextGraphemeLength(){const Ce=Be.getInstance(),Re=this._iterator,We=Re.offset;let ze=Ce.getGraphemeBreakType(Re.nextCodePoint());for(;!Re.eol();){const $e=Re.offset,tt=Ce.getGraphemeBreakType(Re.nextCodePoint());if(De(ze,tt)){Re.setOffset($e);break}ze=tt}return Re.offset-We}prevGraphemeLength(){const Ce=Be.getInstance(),Re=this._iterator,We=Re.offset;let ze=Ce.getGraphemeBreakType(Re.prevCodePoint());for(;Re.offset>0;){const $e=Re.offset,tt=Ce.getGraphemeBreakType(Re.prevCodePoint());if(De(tt,ze)){Re.setOffset($e);break}ze=tt}return We-Re.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=te;function Y(G,Ce){return new te(G,Ce).nextGraphemeLength()}e.nextCharLength=Y;function le(G,Ce){return new te(G,Ce).prevGraphemeLength()}e.prevCharLength=le;function pe(G,Ce){Ce>0&&z(G.charCodeAt(Ce))&&Ce--;const Re=Ce+Y(G,Ce);return[Re-le(G,Re),Re]}e.getCharContainingOffset=pe;const ee=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ge(G){return ee.test(G)}e.containsRTL=ge;const Ee=/^[\t\n\r\x20-\x7E]*$/;function Pe(G){return Ee.test(G)}e.isBasicASCII=Pe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ne(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=Ne;function ve(G){return G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=ve;function ue(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129008||G>=129280&&G<=129535||G>=129648&&G<=129782}e.isEmojiImprecise=ue;function de(G,Ce){if(G.length<Ce)return G;const Re=/\b/g;let We=0;for(;Re.test(G)&&!(G.length-Re.lastIndex<Ce);)We=Re.lastIndex,Re.lastIndex+=1;return G.substring(We).replace(/^\s/,"")}e.lcut=de;const we=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,me=/\x1b\[0?m/g;function Z(G){return G&&(G=G.replace(we,""),G=G.replace(re,""),G=G.replace(me,"")),G}e.removeAnsiEscapeCodes=Z,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function se(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=se;function O(G){return se(G)?G.substr(1):G}e.stripUTF8BOM=O;function H(G,Ce){if(!G||!Ce||G.length<Ce.length)return!1;const Re=Ce.length,We=G.toLowerCase();let ze=0,$e=-1;for(;ze<Re;){const tt=We.indexOf(Ce[ze],$e+1);if(tt<0)return!1;$e=tt,ze++}return!0}e.fuzzyContains=H;function K(G,Ce=!1){return G?(Ce&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=K;function Q(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=Q;function he(G,Ce=1){if(Ce===0)return"";let Re=-1;do Re=G.indexOf(`
`,Re+1),Ce--;while(Ce>0&&Re>=0);return Re===-1?G:(G[Re-1]==="\r"&&Re--,G.substr(0,Re))}e.getNLines=he;function be(G){const Ce=90-65+1;return G=G%(2*Ce),G<Ce?String.fromCharCode(97+G):String.fromCharCode(65+G-Ce)}e.singleLetterHash=be;function ce(G){return Be.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=ce;function De(G,Ce){return G===0?Ce!==5&&Ce!==7:G===2&&Ce===3?!1:G===4||G===2||G===3||Ce===4||Ce===2||Ce===3?!0:!(G===8&&(Ce===8||Ce===9||Ce===11||Ce===12)||(G===11||G===9)&&(Ce===9||Ce===10)||(G===12||G===10)&&Ce===10||Ce===5||Ce===13||Ce===7||G===1||G===13&&Ce===14||G===6&&Ce===6)}var ye;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(ye=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=qe()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(Ce){if(Ce<32)return Ce===10?3:Ce===13?2:4;if(Ce<127)return 0;const Re=this._data,We=Re.length/3;let ze=1;for(;ze<=We;)if(Ce<Re[3*ze])ze=2*ze;else if(Ce>Re[3*ze+1])ze=2*ze+1;else return Re[3*ze+2];return 0}}Be._INSTANCE=null;function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function et(G,Ce){if(G===0)return 0;const Re=Xe(G,Ce);if(Re!==void 0)return Re;const We=new q(Ce,G);return We.prevCodePoint(),We.offset}e.getLeftDeleteOffset=et;function Xe(G,Ce){const Re=new q(Ce,G);let We=Re.prevCodePoint();for(;Oe(We)||We===65039||We===8419;){if(Re.offset===0)return;We=Re.prevCodePoint()}if(!ue(We))return;let ze=Re.offset;return ze>0&&Re.prevCodePoint()===8205&&(ze=Re.offset),ze}function Oe(G){return 127995<=G&&G<=127999}var ot;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(ot||(ot={})),e.noBreakWhitespace="\xA0";class ie{constructor(Ce){this.confusableDictionary=Ce}static getInstance(Ce){return ie.cache.get(Array.from(Ce))}static getLocales(){return ie._locales.getValue()}isAmbiguous(Ce){return this.confusableDictionary.has(Ce)}getPrimaryConfusable(Ce){return this.confusableDictionary.get(Ce)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ie,D=ie,ie.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ie.cache=new u.LRUCachedFunction(G=>{function Ce(nt){const it=new Map;for(let ft=0;ft<nt.length;ft+=2)it.set(nt[ft],nt[ft+1]);return it}function Re(nt,it){const ft=new Map(nt);for(const[Ct,kt]of it)ft.set(Ct,kt);return ft}function We(nt,it){if(!nt)return it;const ft=new Map;for(const[Ct,kt]of nt)it.has(Ct)&&ft.set(Ct,kt);return ft}const ze=D.ambiguousCharacterData.getValue();let $e=G.filter(nt=>!nt.startsWith("_")&&nt in ze);$e.length===0&&($e=["_default"]);let tt;for(const nt of $e){const it=Ce(ze[nt]);tt=We(tt,it)}const st=Ce(ze._common),lt=Re(st,tt);return new ie(lt)}),ie._locales=new n.Lazy(()=>Object.keys(ie.ambiguousCharacterData.getValue()).filter(G=>!G.startsWith("_")));class oe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(oe.getRawData())),this._data}static isInvisibleCharacter(Ce){return oe.getData().has(Ce)}static get codePoints(){return oe.getData()}}e.InvisibleCharacters=oe,oe._data=void 0}),define(Ie[30],ke([0,1,9,13,8,11]),function(J,e,u,n,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(r){return r===47||r===92}e.isPathSeparator=C;function y(r){return r.replace(/[\\/]/g,u.posix.sep)}e.toSlashes=y;function b(r){return r.indexOf("/")===-1&&(r=y(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=b;function I(r,t=u.posix.sep){if(!r)return"";const s=r.length,l=r.charCodeAt(0);if(C(l)){if(C(r.charCodeAt(1))&&!C(r.charCodeAt(2))){let S=3;const L=S;for(;S<s&&!C(r.charCodeAt(S));S++);if(L!==S&&!C(r.charCodeAt(S+1))){for(S+=1;S<s;S++)if(C(r.charCodeAt(S)))return r.slice(0,S+1).replace(/[\\/]/g,t)}}return t}else if(f(l)&&r.charCodeAt(1)===58)return C(r.charCodeAt(2))?r.slice(0,2)+t:r.slice(0,2);let h=r.indexOf("://");if(h!==-1){for(h+=3;h<s;h++)if(C(r.charCodeAt(h)))return r.slice(0,h+1)}return""}e.getRoot=I;function R(r){if(!n.isWindows||!r||r.length<5)return!1;let t=r.charCodeAt(0);if(t!==92||(t=r.charCodeAt(1),t!==92))return!1;let s=2;const l=s;for(;s<r.length&&(t=r.charCodeAt(s),t!==92);s++);return!(l===s||(t=r.charCodeAt(s+1),isNaN(t)||t===92))}e.isUNC=R;const k=/[\\/:\*\?"<>\|]/g,_=/[\\/]/g,P=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(r,t=n.isWindows){const s=t?k:_;return!(!r||r.length===0||/^\s+$/.test(r)||(s.lastIndex=0,s.test(r))||t&&P.test(r)||r==="."||r===".."||t&&r[r.length-1]==="."||t&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=v;function w(r,t,s){const l=r===t;return!s||l?l:!r||!t?!1:(0,D.equalsIgnoreCase)(r,t)}e.isEqual=w;function p(r,t,s,l=u.sep){if(r===t)return!0;if(!r||!t||t.length>r.length)return!1;if(s){if(!(0,D.startsWithIgnoreCase)(r,t))return!1;if(t.length===r.length)return!0;let S=t.length;return t.charAt(t.length-1)===l&&S--,r.charAt(S)===l}return t.charAt(t.length-1)!==l&&(t+=l),r.indexOf(t)===0}e.isEqualOrParent=p;function f(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=f;function E(r,t){return n.isWindows&&r.endsWith(":")&&(r+=u.sep),(0,u.isAbsolute)(r)||(r=(0,u.join)(t,r)),r=(0,u.normalize)(r),n.isWindows?(r=(0,D.rtrim)(r,u.sep),r.endsWith(":")&&(r+=u.sep)):(r=(0,D.rtrim)(r,u.sep),r||(r=u.sep)),r}e.sanitizeFilePath=E;function g(r){const t=(0,u.normalize)(r);return n.isWindows?r.length>3?!1:c(t)&&(r.length===2||t.charCodeAt(2)===92):t===u.posix.sep}e.isRootOrDriveLetter=g;function c(r,t=n.isWindows){return t?f(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function m(r){return c(r)?r[0]:void 0}e.getDriveLetter=m;function a(r,t,s){return t.length>r.length?-1:r===t?0:(s&&(r=r.toLowerCase(),t=t.toLowerCase()),r.indexOf(t))}e.indexOfPath=a;function d(r){const t=r.split(":");let s,l,h;for(const S of t){const L=Number(S);(0,T.isNumber)(L)?l===void 0?l=L:h===void 0&&(h=L):s=s?[s,S].join(":"):S}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:l!==void 0?l:void 0,column:h!==void 0?h:l!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(r,t,s=8){let l="";for(let S=0;S<s;S++)l+=i.charAt(Math.floor(Math.random()*i.length));let h;return t?h=`${t}-${l}`:h=l,r?(0,u.join)(r,h):h}e.randomPath=o}),define(Ie[60],ke([0,1,8]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(f){return D(f,0)}e.hash=n;function D(f,E){switch(typeof f){case"object":return f===null?T(349,E):Array.isArray(f)?b(f,E):I(f,E);case"string":return y(f,E);case"boolean":return C(f,E);case"number":return T(f,E);case"undefined":return T(937,E);default:return T(617,E)}}e.doHash=D;function T(f,E){return(E<<5)-E+f|0}e.numberHash=T;function C(f,E){return T(f?433:863,E)}function y(f,E){E=T(149417,E);for(let g=0,c=f.length;g<c;g++)E=T(f.charCodeAt(g),E);return E}e.stringHash=y;function b(f,E){return E=T(104579,E),f.reduce((g,c)=>D(c,g),E)}function I(f,E){return E=T(181387,E),Object.keys(f).sort().reduce((g,c)=>(g=y(c,g),D(f[c],g)),E)}class R{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=D(E,this._value),this._value}}e.Hasher=R;var k;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function _(f,E,g=32){const c=g-E,m=~((1<<c)-1);return(f<<E|(m&f)>>>c)>>>0}function P(f,E=0,g=f.byteLength,c=0){for(let m=0;m<g;m++)f[E+m]=c}function v(f,E,g="0"){for(;f.length<E;)f=g+f;return f}function w(f,E=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(g=>g.toString(16).padStart(2,"0")).join(""):v((f>>>0).toString(16),E/4)}e.toHexString=w;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const g=E.length;if(g===0)return;const c=this._buff;let m=this._buffLen,a=this._leftoverHighSurrogate,d,i;for(a!==0?(d=a,i=-1,a=0):(d=E.charCodeAt(0),i=0);;){let o=d;if(u.isHighSurrogate(d))if(i+1<g){const r=E.charCodeAt(i+1);u.isLowSurrogate(r)?(i++,o=u.computeCodePoint(d,r)):o=65533}else{a=d;break}else u.isLowSurrogate(d)&&(o=65533);if(m=this._push(c,m,o),i++,i<g)d=E.charCodeAt(i);else break}this._buffLen=m,this._leftoverHighSurrogate=a}_push(E,g,c){return c<128?E[g++]=c:c<2048?(E[g++]=192|(c&1984)>>>6,E[g++]=128|(c&63)>>>0):c<65536?(E[g++]=224|(c&61440)>>>12,E[g++]=128|(c&4032)>>>6,E[g++]=128|(c&63)>>>0):(E[g++]=240|(c&1835008)>>>18,E[g++]=128|(c&258048)>>>12,E[g++]=128|(c&4032)>>>6,E[g++]=128|(c&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,P(this._buff,this._buffLen),this._buffLen>56&&(this._step(),P(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=p._bigBlock32,g=this._buffDV;for(let s=0;s<64;s+=4)E.setUint32(s,g.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)E.setUint32(s,_(E.getUint32(s-12,!1)^E.getUint32(s-32,!1)^E.getUint32(s-56,!1)^E.getUint32(s-64,!1),1),!1);let c=this._h0,m=this._h1,a=this._h2,d=this._h3,i=this._h4,o,r,t;for(let s=0;s<80;s++)s<20?(o=m&a|~m&d,r=1518500249):s<40?(o=m^a^d,r=1859775393):s<60?(o=m&a|m&d|a&d,r=2400959708):(o=m^a^d,r=3395469782),t=_(c,5)+o+i+r+E.getUint32(s*4,!1)&4294967295,i=d,d=a,a=_(m,30),m=c,c=t;this._h0=this._h0+c&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+a&4294967295,this._h3=this._h3+d&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))});var Ze=this&&this.__classPrivateFieldSet||function(J,e,u,n,D){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?D.call(J,u):D?D.value=u:e.set(J,u),u},Me=this&&this.__classPrivateFieldGet||function(J,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!n:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(J):n?n.value:e.get(J)};define(Ie[25],ke([0,1,16,8]),function(J,e,u,n){"use strict";var D,T,C,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function b(r,t,s){let l=r.get(t);return l===void 0&&(l=s,r.set(t,l)),l}e.getOrSet=b;function I(r){const t=[];return r.forEach((s,l)=>{t.push(`${l} => ${s}`)}),`Map(${r.size}) {${t.join(", ")}}`}e.mapToString=I;function R(r){const t=[];return r.forEach(s=>{t.push(s)}),`Set(${r.size}) {${t.join(", ")}}`}e.setToString=R;class k{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const s=t.charCodeAt(0),l=this._value.charCodeAt(this._pos);return s-l}value(){return this._value[this._pos]}}e.StringIterator=k;class _{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class P{constructor(t=!0,s=!0){this._splitOnBackslash=t,this._caseSensitive=s}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let s=t.length-1;s>=0;s--,this._valueLen--){const l=this._value.charCodeAt(s);if(!(l===47||this._splitOnBackslash&&l===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=P;var v;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(v||(v={}));class w{constructor(t,s){this._ignorePathCasing=t,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new P(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(t)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,n.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=w;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var f;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(f||(f={}));class E{constructor(t){this._iter=t}static forUris(t=()=>!1,s=()=>!1){return new E(new w(t,s))}static forPaths(t=!1){return new E(new P(void 0,!t))}static forStrings(){return new E(new k)}static forConfigKeys(){return new E(new _)}clear(){this._root=void 0}fill(t,s){if(s){const l=s.slice(0);(0,u.shuffle)(l);for(const h of l)this.set(h,t)}else{const l=t.slice(0);(0,u.shuffle)(l);for(const h of l)this.set(h[0],h[1])}}set(t,s){const l=this._iter.reset(t);let h;this._root||(this._root=new p,this._root.segment=l.value());const S=[];for(h=this._root;;){const F=l.cmp(h.segment);if(F>0)h.left||(h.left=new p,h.left.segment=l.value()),S.push([-1,h]),h=h.left;else if(F<0)h.right||(h.right=new p,h.right.segment=l.value()),S.push([1,h]),h=h.right;else if(l.hasNext())l.next(),h.mid||(h.mid=new p,h.mid.segment=l.value()),S.push([0,h]),h=h.mid;else break}const L=h.value;h.value=s,h.key=t;for(let F=S.length-1;F>=0;F--){const M=S[F][1];M.updateHeight();const A=M.balanceFactor();if(A<-1||A>1){const B=S[F][0],$=S[F+1][0];if(B===1&&$===1)S[F][1]=M.rotateLeft();else if(B===-1&&$===-1)S[F][1]=M.rotateRight();else if(B===1&&$===-1)M.right=S[F+1][1]=S[F+1][1].rotateRight(),S[F][1]=M.rotateLeft();else if(B===-1&&$===1)M.left=S[F+1][1]=S[F+1][1].rotateLeft(),S[F][1]=M.rotateRight();else throw new Error;if(F>0)switch(S[F-1][0]){case-1:S[F-1][1].left=S[F][1];break;case 1:S[F-1][1].right=S[F][1];break;case 0:S[F-1][1].mid=S[F][1];break}else this._root=S[0][1]}}return L}get(t){return this._getNode(t)?.value}_getNode(t){const s=this._iter.reset(t);let l=this._root;for(;l;){const h=s.cmp(l.segment);if(h>0)l=l.left;else if(h<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else break}return l}has(t){const s=this._getNode(t);return!(s?.value===void 0&&s?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,s){const l=this._iter.reset(t),h=[];let S=this._root;for(;S;){const L=l.cmp(S.segment);if(L>0)h.push([-1,S]),S=S.left;else if(L<0)h.push([1,S]),S=S.right;else if(l.hasNext())l.next(),h.push([0,S]),S=S.mid;else break}if(!!S){if(s?(S.left=void 0,S.mid=void 0,S.right=void 0,S.height=1):(S.key=void 0,S.value=void 0),!S.mid&&!S.value)if(S.left&&S.right){const L=this._min(S.right),{key:F,value:M,segment:A}=L;this._delete(L.key,!1),S.key=F,S.value=M,S.segment=A}else{const L=S.left??S.right;if(h.length>0){const[F,M]=h[h.length-1];switch(F){case-1:M.left=L;break;case 0:M.mid=L;break;case 1:M.right=L;break}}else this._root=L}for(let L=h.length-1;L>=0;L--){const F=h[L][1];F.updateHeight();const M=F.balanceFactor();if(M>1?(F.right.balanceFactor()>=0||(F.right=F.right.rotateRight()),h[L][1]=F.rotateLeft()):M<-1&&(F.left.balanceFactor()<=0||(F.left=F.left.rotateLeft()),h[L][1]=F.rotateRight()),L>0)switch(h[L-1][0]){case-1:h[L-1][1].left=h[L][1];break;case 1:h[L-1][1].right=h[L][1];break;case 0:h[L-1][1].mid=h[L][1];break}else this._root=h[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const s=this._iter.reset(t);let l=this._root,h;for(;l;){const S=s.cmp(l.segment);if(S>0)l=l.left;else if(S<0)l=l.right;else if(s.hasNext())s.next(),h=l.value||h,l=l.mid;else break}return l&&l.value||h}findSuperstr(t){const s=this._iter.reset(t);let l=this._root;for(;l;){const h=s.cmp(l.segment);if(h>0)l=l.left;else if(h<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(t){for(const[s,l]of this)t(l,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(t){const s=[];return this._dfsEntries(t,s),s[Symbol.iterator]()}_dfsEntries(t,s){!t||(t.left&&this._dfsEntries(t.left,s),t.value&&s.push([t.key,t.value]),t.mid&&this._dfsEntries(t.mid,s),t.right&&this._dfsEntries(t.right,s))}_isBalanced(){const t=s=>{if(!s)return!0;const l=s.balanceFactor();return l<-1||l>1?!1:t(s.left)&&t(s.right)};return t(this._root)}}e.TernarySearchTree=E;class g{constructor(t,s){this.uri=t,this.value=s}}class c{constructor(t,s){this[D]="ResourceMap",t instanceof c?(this.map=new Map(t.map),this.toKey=s??c.defaultToKey):(this.map=new Map,this.toKey=t??c.defaultToKey)}set(t,s){return this.map.set(this.toKey(t),new g(t,s)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,s){typeof s!="undefined"&&(t=t.bind(s));for(const[l,h]of this.map)t(h.value,h.uri,this)}*values(){for(const t of this.map.values())yield t.value}*keys(){for(const t of this.map.values())yield t.uri}*entries(){for(const t of this.map.values())yield[t.uri,t.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=c,c.defaultToKey=r=>r.toString();class m{constructor(t,s){this[T]="ResourceSet",!t||typeof t=="function"?this._map=new c(t):(this._map=new c(s),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,s){this._map.forEach((l,h)=>t.call(s,h,h,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=m;var a;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class d{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,s=0){const l=this._map.get(t);if(!!l)return s!==0&&this.touch(l,s),l.value}set(t,s,l=0){let h=this._map.get(t);if(h)h.value=s,l!==0&&this.touch(h,l);else{switch(h={key:t,value:s,next:void 0,previous:void 0},l){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(t,h),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this._map.get(t);if(!!s)return this._map.delete(t),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,s){const l=this._state;let h=this._head;for(;h;){if(s?t.bind(s)(h.value,h.key,this):t(h.value,h.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const t=this,s=this._state;let l=this._head;const h={[Symbol.iterator](){return h},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const S={value:l.key,done:!1};return l=l.next,S}else return{value:void 0,done:!0}}};return h}values(){const t=this,s=this._state;let l=this._head;const h={[Symbol.iterator](){return h},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const S={value:l.value,done:!1};return l=l.next,S}else return{value:void 0,done:!0}}};return h}entries(){const t=this,s=this._state;let l=this._head;const h={[Symbol.iterator](){return h},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const S={value:[l.key,l.value],done:!1};return l=l.next,S}else return{value:void 0,done:!0}}};return h}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this._head,l=this.size;for(;s&&l>t;)this._map.delete(s.key),s=s.next,l--;this._head=s,this._size=l,s&&(s.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const s=t.next,l=t.previous;if(!s||!l)throw new Error("Invalid list");s.previous=l,l.next=s}t.next=void 0,t.previous=void 0,this._state++}touch(t,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(t===this._head)return;const l=t.next,h=t.previous;t===this._tail?(h.next=void 0,this._tail=h):(l.previous=h,h.next=l),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(s===2){if(t===this._tail)return;const l=t.next,h=t.previous;t===this._head?(l.previous=void 0,this._head=l):(l.previous=h,h.next=l),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((s,l)=>{t.push([l,s])}),t}fromJSON(t){this.clear();for(const[s,l]of t)this.set(s,l)}}e.LinkedMap=d;class i extends d{constructor(t,s=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,s=2){return super.get(t,s)}peek(t){return super.get(t,0)}set(t,s){return super.set(t,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class o{constructor(t){y.set(this,void 0),Ze(this,y,t,"f")}get size(){return Me(this,y,"f").size}forEach(t,s){Me(this,y,"f").forEach(t,s)}get(t){return Me(this,y,"f").get(t)}has(t){return Me(this,y,"f").has(t)}entries(){return Me(this,y,"f").entries()}keys(){return Me(this,y,"f").keys()}values(){return Me(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return Me(this,y,"f").entries()}}e.ReadonlyMapView=o}),define(Ie[103],ke([0,1,25,8]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...Z){return function(se,O){for(let H=0,K=Z.length;H<K;H++){const Q=Z[H](se,O);if(Q)return Q}return null}}e.or=D,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(Z,se,O){if(!O||O.length<se.length)return null;let H;return Z?H=n.startsWithIgnoreCase(O,se):H=O.indexOf(se)===0,H?se.length>0?[{start:0,end:se.length}]:[]:null}function C(Z,se){const O=se.toLowerCase().indexOf(Z.toLowerCase());return O===-1?null:[{start:O,end:O+Z.length}]}e.matchesContiguousSubString=C;function y(Z,se){return b(Z.toLowerCase(),se.toLowerCase(),0,0)}e.matchesSubString=y;function b(Z,se,O,H){if(O===Z.length)return[];if(H===se.length)return null;if(Z[O]===se[H]){let K=null;return(K=b(Z,se,O+1,H+1))?f({start:H,end:H+1},K):null}return b(Z,se,O,H+1)}function I(Z){return 97<=Z&&Z<=122}function R(Z){return 65<=Z&&Z<=90}e.isUpper=R;function k(Z){return 48<=Z&&Z<=57}function _(Z){return Z===32||Z===9||Z===10||Z===13}const P=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Z=>P.add(Z.charCodeAt(0)));function v(Z){return _(Z)||P.has(Z)}function w(Z,se){return Z===se||v(Z)&&v(se)}function p(Z){return I(Z)||R(Z)||k(Z)}function f(Z,se){return se.length===0?se=[Z]:Z.end===se[0].start?se[0].start=Z.start:se.unshift(Z),se}function E(Z,se){for(let O=se;O<Z.length;O++){const H=Z.charCodeAt(O);if(R(H)||k(H)||O>0&&!p(Z.charCodeAt(O-1)))return O}return Z.length}function g(Z,se,O,H){if(O===Z.length)return[];if(H===se.length)return null;if(Z[O]!==se[H].toLowerCase())return null;{let K=null,Q=H+1;for(K=g(Z,se,O+1,H+1);!K&&(Q=E(se,Q))<se.length;)K=g(Z,se,O+1,Q),Q++;return K===null?null:f({start:H,end:H+1},K)}}function c(Z){let se=0,O=0,H=0,K=0,Q=0;for(let ye=0;ye<Z.length;ye++)Q=Z.charCodeAt(ye),R(Q)&&se++,I(Q)&&O++,p(Q)&&H++,k(Q)&&K++;const he=se/Z.length,be=O/Z.length,ce=H/Z.length,De=K/Z.length;return{upperPercent:he,lowerPercent:be,alphaPercent:ce,numericPercent:De}}function m(Z){const{upperPercent:se,lowerPercent:O}=Z;return O===0&&se>.6}function a(Z){const{upperPercent:se,lowerPercent:O,alphaPercent:H,numericPercent:K}=Z;return O>.2&&se<.8&&H>.6&&K<.2}function d(Z){let se=0,O=0,H=0,K=0;for(let Q=0;Q<Z.length;Q++)H=Z.charCodeAt(Q),R(H)&&se++,I(H)&&O++,_(H)&&K++;return(se===0||O===0)&&K===0?Z.length<=30:se<=5}function i(Z,se){if(!se||(se=se.trim(),se.length===0)||!d(Z)||se.length>60)return null;const O=c(se);if(!a(O)){if(!m(O))return null;se=se.toLowerCase()}let H=null,K=0;for(Z=Z.toLowerCase();K<se.length&&(H=g(Z,se,0,K))===null;)K=E(se,K+1);return H}e.matchesCamelCase=i;function o(Z,se,O=!1){if(!se||se.length===0)return null;let H=null,K=0;for(Z=Z.toLowerCase(),se=se.toLowerCase();K<se.length&&(H=r(Z,se,0,K,O))===null;)K=t(se,K+1);return H}e.matchesWords=o;function r(Z,se,O,H,K){if(O===Z.length)return[];if(H===se.length)return null;if(w(Z.charCodeAt(O),se.charCodeAt(H))){let Q=null,he=H+1;if(Q=r(Z,se,O+1,H+1,K),!K)for(;!Q&&(he=t(se,he))<se.length;)Q=r(Z,se,O+1,he,K),he++;return Q===null?null:f({start:H,end:H+1},Q)}else return null}function t(Z,se){for(let O=se;O<Z.length;O++)if(v(Z.charCodeAt(O))||O>0&&v(Z.charCodeAt(O-1)))return O;return Z.length}const s=D(e.matchesPrefix,i,C),l=D(e.matchesPrefix,i,y),h=new u.LRUCache(1e4);function S(Z,se,O=!1){if(typeof Z!="string"||typeof se!="string")return null;let H=h.get(Z);H||(H=new RegExp(n.convertSimple2RegExpPattern(Z),"i"),h.set(Z,H));const K=H.exec(se);return K?[{start:K.index,end:K.index+K[0].length}]:O?l(Z,se):s(Z,se)}e.matchesFuzzy=S;function L(Z,se){const O=Ne(Z,Z.toLowerCase(),0,se,se.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return O?M(O):null}e.matchesFuzzy2=L;function F(Z,se,O,H,K,Q){const he=Math.min(13,Z.length);for(;O<he;O++){const be=Ne(Z,se,O,H,K,Q,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(be)return be}return[0,Q]}e.anyScore=F;function M(Z){if(typeof Z=="undefined")return[];const se=[],O=Z[1];for(let H=Z.length-1;H>1;H--){const K=Z[H]+O,Q=se[se.length-1];Q&&Q.end===K?Q.end=K+1:se.push({start:K,end:K+1})}return se}e.createMatches=M;const A=128;function B(){const Z=[],se=[];for(let O=0;O<=A;O++)se[O]=0;for(let O=0;O<=A;O++)Z.push(se.slice(0));return Z}function $(Z){const se=[];for(let O=0;O<=Z;O++)se[O]=0;return se}const U=$(2*A),X=$(2*A),z=B(),N=B(),V=B(),x=!1;function q(Z,se,O,H,K){function Q(be,ce,De=" "){for(;be.length<ce;)be=De+be;return be}let he=` |   |${H.split("").map(be=>Q(be,3)).join("|")}
`;for(let be=0;be<=O;be++)be===0?he+=" |":he+=`${se[be-1]}|`,he+=Z[be].slice(0,K+1).map(ce=>Q(ce.toString(),3)).join("|")+`
`;return he}function te(Z,se,O,H){Z=Z.substr(se),O=O.substr(H),console.log(q(N,Z,Z.length,O,O.length)),console.log(q(V,Z,Z.length,O,O.length)),console.log(q(z,Z,Z.length,O,O.length))}function Y(Z,se){if(se<0||se>=Z.length)return!1;const O=Z.codePointAt(se);switch(O){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!n.isEmojiImprecise(O)}}function le(Z,se){if(se<0||se>=Z.length)return!1;switch(Z.charCodeAt(se)){case 32:case 9:return!0;default:return!1}}function pe(Z,se,O){return se[Z]!==O[Z]}function ee(Z,se,O,H,K,Q,he=!1){for(;se<O&&K<Q;)Z[se]===H[K]&&(he&&(U[se]=K),se+=1),K+=1;return se===O}e.isPatternInWord=ee;var ge;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(ge||(ge={}));var Ee;(function(Z){Z.Default=[-100,0];function se(O){return!O||O.length===2&&O[0]===-100&&O[1]===0}Z.isDefault=se})(Ee=e.FuzzyScore||(e.FuzzyScore={}));class Pe{constructor(se,O){this.firstMatchCanBeWeak=se,this.boostFullMatch=O}}e.FuzzyScoreOptions=Pe,Pe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Ne(Z,se,O,H,K,Q,he=Pe.default){const be=Z.length>A?A:Z.length,ce=H.length>A?A:H.length;if(O>=be||Q>=ce||be-O>ce-Q||!ee(se,O,be,K,Q,ce,!0))return;ve(be,ce,O,Q,se,K);let De=1,ye=1,Be=O,qe=Q;const et=[!1];for(De=1,Be=O;Be<be;De++,Be++){const oe=U[Be],G=X[Be],Ce=Be+1<be?X[Be+1]:ce;for(ye=oe-Q+1,qe=oe;qe<Ce;ye++,qe++){let Re=Number.MIN_SAFE_INTEGER,We=!1;qe<=G&&(Re=ue(Z,se,Be,O,H,K,qe,ce,Q,z[De-1][ye-1]===0,et));let ze=0;Re!==Number.MAX_SAFE_INTEGER&&(We=!0,ze=Re+N[De-1][ye-1]);const $e=qe>oe,tt=$e?N[De][ye-1]+(z[De][ye-1]>0?-5:0):0,st=qe>oe+1&&z[De][ye-1]>0,lt=st?N[De][ye-2]+(z[De][ye-2]>0?-5:0):0;if(st&&(!$e||lt>=tt)&&(!We||lt>=ze))N[De][ye]=lt,V[De][ye]=3,z[De][ye]=0;else if($e&&(!We||tt>=ze))N[De][ye]=tt,V[De][ye]=2,z[De][ye]=0;else if(We)N[De][ye]=ze,V[De][ye]=1,z[De][ye]=z[De-1][ye-1]+1;else throw new Error("not possible")}}if(x&&te(Z,O,H,Q),!et[0]&&!he.firstMatchCanBeWeak)return;De--,ye--;const Xe=[N[De][ye],Q];let Oe=0,ot=0;for(;De>=1;){let oe=ye;do{const G=V[De][oe];if(G===3)oe=oe-2;else if(G===2)oe=oe-1;else break}while(oe>=1);Oe>1&&se[O+De-1]===K[Q+ye-1]&&!pe(oe+Q-1,H,K)&&Oe+1>z[De][oe]&&(oe=ye),oe===ye?Oe++:Oe=1,ot||(ot=oe),De--,ye=oe-1,Xe.push(ye)}ce===be&&he.boostFullMatch&&(Xe[0]+=2);const ie=ot-be;return Xe[0]-=ie,Xe}e.fuzzyScore=Ne;function ve(Z,se,O,H,K,Q){let he=Z-1,be=se-1;for(;he>=O&&be>=H;)K[he]===Q[be]&&(X[he]=be,he--),be--}function ue(Z,se,O,H,K,Q,he,be,ce,De,ye){if(se[O]!==Q[he])return Number.MIN_SAFE_INTEGER;let Be=1,qe=!1;return he===O-H?Be=Z[O]===K[he]?7:5:pe(he,K,Q)&&(he===0||!pe(he-1,K,Q))?(Be=Z[O]===K[he]?7:5,qe=!0):Y(Q,he)&&(he===0||!Y(Q,he-1))?Be=5:(Y(Q,he-1)||le(Q,he-1))&&(Be=5,qe=!0),Be>1&&O===H&&(ye[0]=!0),qe||(qe=pe(he,K,Q)||Y(Q,he-1)||le(Q,he-1)),O===H?he>ce&&(Be-=qe?3:5):De?Be+=qe?2:0:Be+=qe?0:1,he+1===be&&(Be-=qe?3:5),Be}function de(Z,se,O,H,K,Q,he){return re(Z,se,O,H,K,Q,!0,he)}e.fuzzyScoreGracefulAggressive=de;function we(Z,se,O,H,K,Q,he){return re(Z,se,O,H,K,Q,!1,he)}e.fuzzyScoreGraceful=we;function re(Z,se,O,H,K,Q,he,be){let ce=Ne(Z,se,O,H,K,Q,be);if(ce&&!he)return ce;if(Z.length>=3){const De=Math.min(7,Z.length-1);for(let ye=O+1;ye<De;ye++){const Be=me(Z,ye);if(Be){const qe=Ne(Be,Be.toLowerCase(),O,H,K,Q,be);qe&&(qe[0]-=3,(!ce||qe[0]>ce[0])&&(ce=qe))}}}return ce}function me(Z,se){if(se+1>=Z.length)return;const O=Z[se],H=Z[se+1];if(O!==H)return Z.slice(0,se)+H+O+Z.slice(se+2)}}),define(Ie[156],ke([0,1,77,103,8]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${u.CSSIcon.iconNameExpression}(?:${u.CSSIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(u.CSSIcon.iconNameCharacter),y=new RegExp(`(\\\\)?${T.source}`,"g");function b(p){return p.replace(y,(f,E)=>E?f:`\\${f}`)}e.escapeIcons=b;const I=new RegExp(`\\\\${T.source}`,"g");function R(p){return p.replace(I,f=>`\\${f}`)}e.markdownEscapeEscapedIcons=R;const k=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function _(p){return p.indexOf(e.iconStartMarker)===-1?p:p.replace(k,(f,E,g,c)=>g?f:E||c||"")}e.stripIcons=_;function P(p){const f=p.indexOf(e.iconStartMarker);return f===-1?{text:p}:v(p,f)}e.parseLabelWithIcons=P;function v(p,f){const E=[];let g="";function c(s){if(s){g+=s;for(const l of s)E.push(d)}}let m=-1,a="",d=0,i,o,r=f;const t=p.length;for(c(p.substr(0,f));r<t;)i=p[r],o=p[r+1],i===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(m=r,c(a),a=e.iconStartMarker,r++):i===")"&&m!==-1?(d+=r-m+1,m=-1,a=""):m!==-1?C.test(i)?a+=i:(c(a),m=-1,a=""):c(i),r++;return c(a),{text:g,iconOffsets:E}}function w(p,f,E=!1){const{text:g,iconOffsets:c}=f;if(!c||c.length===0)return(0,n.matchesFuzzy)(p,g,E);const m=(0,D.ltrim)(g," "),a=g.length-m.length,d=(0,n.matchesFuzzy)(p,m,E);if(d)for(const i of d){const o=c[i.start+a]+a;i.start+=o,i.end+=o}return d}e.matchesFuzzyIconAware=w}),define(Ie[81],ke([0,1,25]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new u.LRUCache(1e4);function D(I){return b(I,"NFC",n)}e.normalizeNFC=D;const T=new u.LRUCache(1e4);function C(I){return b(I,"NFD",T)}e.normalizeNFD=C;const y=/[^\u0000-\u0080]/;function b(I,R,k){if(!I)return I;const _=k.get(I);if(_)return _;let P;return y.test(I)?P=I.normalize(R):P=I,k.set(I,P),P}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(R){return C(R).replace(I,"")}}()}),define(Ie[41],ke([0,1,8]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var n;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(n||(n={})),function(D){const T="error",C="warning",y="warn",b="info",I="ignore";function R(_){return _?u.equalsIgnoreCase(T,_)?D.Error:u.equalsIgnoreCase(C,_)||u.equalsIgnoreCase(y,_)?D.Warning:u.equalsIgnoreCase(b,_)?D.Info:D.Ignore:D.Ignore}D.fromValue=R;function k(_){switch(_){case D.Error:return T;case D.Warning:return C;case D.Info:return b;default:return I}}D.toString=k}(n||(n={})),e.default=n}),define(Ie[2],ke([0,1,9,13]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,T=/^\//,C=/^\/\//;function y(i,o){if(!i.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!D.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!T.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(i,o){return!i&&!o?"file":i}function I(i,o){switch(i){case"https":case"http":case"file":o?o[0]!==k&&(o=k+o):o=k;break}return o}const R="",k="/",_=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class P{constructor(o,r,t,s,l,h=!1){typeof o=="object"?(this.scheme=o.scheme||R,this.authority=o.authority||R,this.path=o.path||R,this.query=o.query||R,this.fragment=o.fragment||R):(this.scheme=b(o,h),this.authority=r||R,this.path=I(this.scheme,t||R),this.query=s||R,this.fragment=l||R,y(this,h))}static isUri(o){return o instanceof P?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return g(this,!1)}with(o){if(!o)return this;let{scheme:r,authority:t,path:s,query:l,fragment:h}=o;return r===void 0?r=this.scheme:r===null&&(r=R),t===void 0?t=this.authority:t===null&&(t=R),s===void 0?s=this.path:s===null&&(s=R),l===void 0?l=this.query:l===null&&(l=R),h===void 0?h=this.fragment:h===null&&(h=R),r===this.scheme&&t===this.authority&&s===this.path&&l===this.query&&h===this.fragment?this:new w(r,t,s,l,h)}static parse(o,r=!1){const t=_.exec(o);return t?new w(t[2]||R,d(t[4]||R),d(t[5]||R),d(t[7]||R),d(t[9]||R),r):new w(R,R,R,R,R)}static file(o){let r=R;if(n.isWindows&&(o=o.replace(/\\/g,k)),o[0]===k&&o[1]===k){const t=o.indexOf(k,2);t===-1?(r=o.substring(2),o=k):(r=o.substring(2,t),o=o.substring(t)||k)}return new w("file",r,o,R,R)}static from(o){const r=new w(o.scheme,o.authority,o.path,o.query,o.fragment);return y(r,!0),r}static joinPath(o,...r){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let t;return n.isWindows&&o.scheme==="file"?t=P.file(u.win32.join(g(o,!0),...r)).path:t=u.posix.join(o.path,...r),o.with({path:t})}toString(o=!1){return c(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof P)return o;{const r=new w(o);return r._formatted=o.external,r._fsPath=o._sep===v?o.fsPath:null,r}}else return o}}e.URI=P;const v=n.isWindows?1:void 0;class w extends P{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(o=!1){return o?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=v),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(i,o){let r,t=-1;for(let s=0;s<i.length;s++){const l=i.charCodeAt(s);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||o&&l===47)t!==-1&&(r+=encodeURIComponent(i.substring(t,s)),t=-1),r!==void 0&&(r+=i.charAt(s));else{r===void 0&&(r=i.substr(0,s));const h=p[l];h!==void 0?(t!==-1&&(r+=encodeURIComponent(i.substring(t,s)),t=-1),r+=h):t===-1&&(t=s)}}return t!==-1&&(r+=encodeURIComponent(i.substring(t))),r!==void 0?r:i}function E(i){let o;for(let r=0;r<i.length;r++){const t=i.charCodeAt(r);t===35||t===63?(o===void 0&&(o=i.substr(0,r)),o+=p[t]):o!==void 0&&(o+=i[r])}return o!==void 0?o:i}function g(i,o){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?o?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,n.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=g;function c(i,o){const r=o?E:f;let t="",{scheme:s,authority:l,path:h,query:S,fragment:L}=i;if(s&&(t+=s,t+=":"),(l||s==="file")&&(t+=k,t+=k),l){let F=l.indexOf("@");if(F!==-1){const M=l.substr(0,F);l=l.substr(F+1),F=M.indexOf(":"),F===-1?t+=r(M,!1):(t+=r(M.substr(0,F),!1),t+=":",t+=r(M.substr(F+1),!1)),t+="@"}l=l.toLowerCase(),F=l.indexOf(":"),F===-1?t+=r(l,!1):(t+=r(l.substr(0,F),!1),t+=l.substr(F))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const F=h.charCodeAt(1);F>=65&&F<=90&&(h=`/${String.fromCharCode(F+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const F=h.charCodeAt(0);F>=65&&F<=90&&(h=`${String.fromCharCode(F+32)}:${h.substr(2)}`)}t+=r(h,!0)}return S&&(t+="?",t+=r(S,!1)),L&&(t+="#",t+=o?L:f(L,!1)),t}function m(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+m(i.substr(3)):i}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(i){return i.match(a)?i.replace(a,o=>m(o)):i}}),define(Ie[61],ke([0,1,23,8,2]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(I){return JSON.stringify(I,y)}e.stringify=T;function C(I){let R=JSON.parse(I);return R=b(R),R}e.parse=C;function y(I,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,n.regExpFlags)(R)}:R}function b(I,R=0){if(!I||R>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return D.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 14:return new Date(I.source)}if(I instanceof u.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let k=0;k<I.length;++k)I[k]=b(I[k],R+1);else for(const k in I)Object.hasOwnProperty.call(I,k)&&(I[k]=b(I[k],R+1))}return I}e.revive=b}),define(Ie[10],ke([0,1,13,2]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}setServerRootPath(b){this._remoteResourcesPath=`${b}/${D.vscodeRemoteResource}`}set(b,I,R){this._hosts[b]=I,this._ports[b]=R}setConnectionToken(b,I){this._connectionTokens[b]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(b){if(this._delegate)return this._delegate(b);const I=b.authority;let R=this._hosts[I];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const k=this._ports[I],_=this._connectionTokens[I];let P=`path=${encodeURIComponent(b.path)}`;return typeof _=="string"&&(P+=`&${e.connectionTokenQueryName}=${encodeURIComponent(_)}`),n.URI.from({scheme:u.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${R}:${k}`,path:this._remoteResourcesPath,query:P})}}e.RemoteAuthorities=new T;class C{asBrowserUri(b,I){const R=this.toUri(b,I);return R.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===D.file&&(u.isNative||u.isWebWorker&&u.globals.origin===`${D.vscodeFileResource}://${C.FALLBACK_AUTHORITY}`)?R.with({scheme:D.vscodeFileResource,authority:R.authority||C.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(b,I){const R=this.toUri(b,I);return R.scheme===D.vscodeFileResource?R.with({scheme:D.file,authority:R.authority!==C.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(b,I){return n.URI.isUri(b)?b:n.URI.parse(I.toUrl(b))}}C.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new C}),define(Ie[22],ke([0,1,30,10,9,13,8,2]),function(J,e,u,n,D,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(P){return(0,y.uriToFsPath)(P,!0)}e.originalFSPath=b;class I{constructor(v){this._ignorePathCasing=v}compare(v,w,p=!1){return v===w?0:(0,C.compare)(this.getComparisonKey(v,p),this.getComparisonKey(w,p))}isEqual(v,w,p=!1){return v===w?!0:!v||!w?!1:this.getComparisonKey(v,p)===this.getComparisonKey(w,p)}getComparisonKey(v,w=!1){return v.with({path:this._ignorePathCasing(v)?v.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(v){return this._ignorePathCasing(v)}isEqualOrParent(v,w,p=!1){if(v.scheme===w.scheme){if(v.scheme===n.Schemas.file)return u.isEqualOrParent(b(v),b(w),this._ignorePathCasing(v))&&v.query===w.query&&(p||v.fragment===w.fragment);if((0,e.isEqualAuthority)(v.authority,w.authority))return u.isEqualOrParent(v.path,w.path,this._ignorePathCasing(v),"/")&&v.query===w.query&&(p||v.fragment===w.fragment)}return!1}joinPath(v,...w){return y.URI.joinPath(v,...w)}basenameOrAuthority(v){return(0,e.basename)(v)||v.authority}basename(v){return D.posix.basename(v.path)}extname(v){return D.posix.extname(v.path)}dirname(v){if(v.path.length===0)return v;let w;return v.scheme===n.Schemas.file?w=y.URI.file(D.dirname(b(v))).path:(w=D.posix.dirname(v.path),v.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),w="/")),v.with({path:w})}normalizePath(v){if(!v.path.length)return v;let w;return v.scheme===n.Schemas.file?w=y.URI.file(D.normalize(b(v))).path:w=D.posix.normalize(v.path),v.with({path:w})}relativePath(v,w){if(v.scheme!==w.scheme||!(0,e.isEqualAuthority)(v.authority,w.authority))return;if(v.scheme===n.Schemas.file){const E=D.relative(b(v),b(w));return T.isWindows?u.toSlashes(E):E}let p=v.path||"/";const f=w.path||"/";if(this._ignorePathCasing(v)){let E=0;for(const g=Math.min(p.length,f.length);E<g&&!(p.charCodeAt(E)!==f.charCodeAt(E)&&p.charAt(E).toLowerCase()!==f.charAt(E).toLowerCase());E++);p=f.substr(0,E)+p.substr(E)}return D.posix.relative(p,f)}resolvePath(v,w){if(v.scheme===n.Schemas.file){const p=y.URI.file(D.resolve(b(v),w));return v.with({authority:p.authority,path:p.path})}return w=u.toPosixPath(w),v.with({path:D.posix.resolve(v.path,w)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,w){return v===w||v!==void 0&&w!==void 0&&(0,C.equalsIgnoreCase)(v,w)}hasTrailingPathSeparator(v,w=D.sep){if(v.scheme===n.Schemas.file){const p=b(v);return p.length>u.getRoot(p).length&&p[p.length-1]===w}else{const p=v.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,w=D.sep){return(0,e.hasTrailingPathSeparator)(v,w)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,w=D.sep){let p=!1;if(v.scheme===n.Schemas.file){const f=b(v);p=f!==void 0&&f.length===u.getRoot(f).length&&f[f.length-1]===w}else{w="/";const f=v.path;p=f.length===1&&f.charCodeAt(f.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(v,w)?v.with({path:v.path+"/"}):v}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(P=>P.scheme===n.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new I(P=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(P,v){const w=[];for(let p=0;p<P.length;p++){const f=v(P[p]);P.some((E,g)=>g===p?!1:(0,e.isEqualOrParent)(f,v(E)))||w.push(P[p])}return w}e.distinctParents=R;var k;(function(P){P.META_DATA_LABEL="label",P.META_DATA_DESCRIPTION="description",P.META_DATA_SIZE="size",P.META_DATA_MIME="mime";function v(w){const p=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(g=>{const[c,m]=g.split(":");c&&m&&p.set(c,m)});const E=w.path.substring(0,w.path.indexOf(";"));return E&&p.set(P.META_DATA_MIME,E),p}P.parseMetaData=v})(k=e.DataUri||(e.DataUri={}));function _(P,v,w){if(v){let p=P.path;return p&&p[0]!==D.posix.sep&&(p=D.posix.sep+p),P.with({scheme:w,authority:v,path:p})}return P.with({scheme:w})}e.toLocalResource=_}),define(Ie[18],ke([0,1,21,12,3,6,22,13]),function(J,e,u,n,D,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(pe){return!!pe&&typeof pe.then=="function"}e.isThenable=b;function I(pe){const ee=new u.CancellationTokenSource,ge=pe(ee.token),Ee=new Promise((Pe,Ne)=>{const ve=ee.token.onCancellationRequested(()=>{ve.dispose(),ee.dispose(),Ne(new n.CancellationError)});Promise.resolve(ge).then(ue=>{ve.dispose(),ee.dispose(),Pe(ue)},ue=>{ve.dispose(),ee.dispose(),Ne(ue)})});return new class{cancel(){ee.cancel()}then(Pe,Ne){return Ee.then(Pe,Ne)}catch(Pe){return this.then(void 0,Pe)}finally(Pe){return Ee.finally(Pe)}}}e.createCancelablePromise=I;function R(pe,ee,ge){return new Promise((Ee,Pe)=>{const Ne=ee.onCancellationRequested(()=>{Ne.dispose(),Ee(ge)});pe.then(Ee,Pe).finally(()=>Ne.dispose())})}e.raceCancellation=R;function k(pe,ee){return new Promise((ge,Ee)=>{const Pe=ee.onCancellationRequested(()=>{Pe.dispose(),Ee(new n.CancellationError)});pe.then(ge,Ee).finally(()=>Pe.dispose())})}e.raceCancellationError=k;async function _(pe){let ee=-1;const ge=pe.map((Pe,Ne)=>Pe.then(ve=>(ee=Ne,ve))),Ee=await Promise.race(ge);return pe.forEach((Pe,Ne)=>{Ne!==ee&&Pe.cancel()}),Ee}e.raceCancellablePromises=_;function P(pe,ee,ge){let Ee;const Pe=setTimeout(()=>{Ee?.(void 0),ge?.()},ee);return Promise.race([pe.finally(()=>clearTimeout(Pe)),new Promise(Ne=>Ee=Ne)])}e.raceTimeout=P;function v(pe){return new Promise((ee,ge)=>{const Ee=pe();b(Ee)?Ee.then(ee,ge):ee(Ee)})}e.asPromise=v;class w{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ee){if(this.activePromise){if(this.queuedPromiseFactory=ee,!this.queuedPromise){const ge=()=>{this.queuedPromise=null;const Ee=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Ee};this.queuedPromise=new Promise(Ee=>{this.activePromise.then(ge,ge).then(Ee)})}return new Promise((ge,Ee)=>{this.queuedPromise.then(ge,Ee)})}return this.activePromise=ee(),new Promise((ge,Ee)=>{this.activePromise.then(Pe=>{this.activePromise=null,ge(Pe)},Pe=>{this.activePromise=null,Ee(Pe)})})}}e.Throttler=w;class p{constructor(){this.current=Promise.resolve(null)}queue(ee){return this.current=this.current.then(()=>ee(),()=>ee())}}e.Sequencer=p;class f{constructor(){this.promiseMap=new Map}queue(ee,ge){const Pe=(this.promiseMap.get(ee)??Promise.resolve()).catch(()=>{}).then(ge).finally(()=>{this.promiseMap.get(ee)===Pe&&this.promiseMap.delete(ee)});return this.promiseMap.set(ee,Pe),Pe}}e.SequencerByKey=f;const E=(pe,ee)=>{let ge=!0;const Ee=setTimeout(()=>{ge=!1,ee()},pe);return{isTriggered:()=>ge,dispose:()=>{clearTimeout(Ee),ge=!1}}},g=pe=>{let ee=!0;return queueMicrotask(()=>{ee&&(ee=!1,pe())}),{isTriggered:()=>ee,dispose:()=>{ee=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class c{constructor(ee){this.defaultDelay=ee,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ee,ge=this.defaultDelay){this.task=ee,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Pe,Ne)=>{this.doResolve=Pe,this.doReject=Ne}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Pe=this.task;return this.task=null,Pe()}}));const Ee=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ge===e.MicrotaskDelay?g(Ee):E(ge,Ee),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=c;class m{constructor(ee){this.delayer=new c(ee),this.throttler=new w}trigger(ee,ge){return this.delayer.trigger(()=>this.throttler.queue(ee),ge)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=m;class a{constructor(){this._isOpen=!1,this._promise=new Promise((ee,ge)=>{this._completePromise=ee})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class d extends a{constructor(ee){super();this._timeout=setTimeout(()=>this.open(),ee)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function i(pe,ee){return ee?new Promise((ge,Ee)=>{const Pe=setTimeout(()=>{Ne.dispose(),ge()},pe),Ne=ee.onCancellationRequested(()=>{clearTimeout(Pe),Ne.dispose(),Ee(new n.CancellationError)})}):I(ge=>i(pe,ge))}e.timeout=i;function o(pe,ee=0){const ge=setTimeout(pe,ee);return(0,T.toDisposable)(()=>clearTimeout(ge))}e.disposableTimeout=o;function r(pe){const ee=[];let ge=0;const Ee=pe.length;function Pe(){return ge<Ee?pe[ge++]():null}function Ne(ve){ve!=null&&ee.push(ve);const ue=Pe();return ue?ue.then(Ne):Promise.resolve(ee)}return Promise.resolve(null).then(Ne)}e.sequence=r;function t(pe,ee=Ee=>!!Ee,ge=null){let Ee=0;const Pe=pe.length,Ne=()=>{if(Ee>=Pe)return Promise.resolve(ge);const ve=pe[Ee++];return Promise.resolve(ve()).then(de=>ee(de)?Promise.resolve(de):Ne())};return Ne()}e.first=t;function s(pe,ee=Ee=>!!Ee,ge=null){if(pe.length===0)return Promise.resolve(ge);let Ee=pe.length;const Pe=()=>{Ee=-1;for(const Ne of pe)Ne.cancel?.()};return new Promise((Ne,ve)=>{for(const ue of pe)ue.then(de=>{--Ee>=0&&ee(de)?(Pe(),Ne(de)):Ee===0&&Ne(ge)}).catch(de=>{--Ee>=0&&(Pe(),ve(de))})})}e.firstParallel=s;class l{constructor(ee){this._size=0,this.maxDegreeOfParalellism=ee,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new D.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(ee){return this._size++,new Promise((ge,Ee)=>{this.outstandingPromises.push({factory:ee,c:ge,e:Ee}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ee=this.outstandingPromises.shift();this.runningPromises++;const ge=ee.factory();ge.then(ee.c,ee.e),ge.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=l;class h extends l{constructor(){super(1)}}e.Queue=h;class S{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const ee=new V;return this.drainers.add(ee),ee.p}isDrained(){for(const[,ee]of this.queues)if(ee.size>0)return!1;return!0}queueFor(ee,ge=C.extUri){const Ee=ge.getComparisonKey(ee);let Pe=this.queues.get(Ee);return Pe||(Pe=new h,D.Event.once(Pe.onDrained)(()=>{Pe?.dispose(),this.queues.delete(Ee),this.onDidQueueDrain()}),this.queues.set(Ee,Pe)),Pe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const ee of this.drainers)ee.complete();this.drainers.clear()}dispose(){for(const[,ee]of this.queues)ee.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=S;class L{constructor(ee,ge){this._token=-1,typeof ee=="function"&&typeof ge=="number"&&this.setIfNotSet(ee,ge)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ee,ge){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ee()},ge)}setIfNotSet(ee,ge){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ee()},ge))}}e.TimeoutTimer=L;class F{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(ee,ge){this.cancel(),this._token=setInterval(()=>{ee()},ge)}}e.IntervalTimer=F;class M{constructor(ee,ge){this.timeoutToken=-1,this.runner=ee,this.timeout=ge,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ee=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ee)}get delay(){return this.timeout}set delay(ee){this.timeout=ee}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=M;class A{constructor(ee,ge){ge%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ge}ms is not a multiple of 1000ms.`),this.runner=ee,this.timeout=ge,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ee=this.timeout){ee%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ee/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=A;class B extends M{constructor(ee,ge){super(ee,ge);this.units=[]}work(ee){this.units.push(ee),this.isScheduled()||this.schedule()}doRun(){const ee=this.units;this.units=[],this.runner?.(ee)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=B;class $ extends T.Disposable{constructor(ee,ge){super();this.options=ee,this.handler=ge,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ee){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ee.length>this.options.maxBufferedWork)return!1}else if(this.pending+ee.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...ee),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new M(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=pe=>{(0,y.setTimeout0)(()=>{if(ee)return;const ge=Date.now()+15;pe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ge-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.runWhenIdle=(pe,ee)=>{const ge=requestIdleCallback(pe,typeof ee=="number"?{timeout:ee}:void 0);let Ee=!1;return{dispose(){Ee||(Ee=!0,cancelIdleCallback(ge))}}}}();class U{constructor(ee){this._didRun=!1,this._executor=()=>{try{this._value=ee()}catch(ge){this._error=ge}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=U;async function X(pe,ee,ge){let Ee;for(let Pe=0;Pe<ge;Pe++)try{return await pe()}catch(Ne){Ee=Ne,await i(ee)}throw Ee}e.retry=X;class z{hasPending(ee){return this._pending?typeof ee=="number"?this._pending.taskId===ee:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(ee,ge,Ee){return this._pending={taskId:ee,cancel:()=>Ee?.(),promise:ge},ge.then(()=>this.donePending(ee),()=>this.donePending(ee)),ge}donePending(ee){this._pending&&ee===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const ee=this._next;this._next=void 0,ee.run().then(ee.promiseResolve,ee.promiseReject)}}setNext(ee){if(this._next)this._next.run=ee;else{let ge,Ee;const Pe=new Promise((Ne,ve)=>{ge=Ne,Ee=ve});this._next={run:ee,promise:Pe,promiseResolve:ge,promiseReject:Ee}}return this._next.promise}}e.TaskSequentializer=z;class N{constructor(ee,ge=()=>Date.now()){this.interval=ee,this.nowFn=ge,this.lastIncrementTime=0,this.value=0}increment(){const ee=this.nowFn();return ee-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ee,this.value=0),this.value++,this.value}}e.IntervalCounter=N;class V{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((ee,ge)=>{this.completeCallback=ee,this.errorCallback=ge})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(ee){return new Promise(ge=>{this.completeCallback(ee),this.resolved=!0,ge()})}error(ee){return new Promise(ge=>{this.errorCallback(ee),this.rejected=!0,ge()})}cancel(){new Promise(ee=>{this.errorCallback(new n.CancellationError),this.rejected=!0,ee()})}}e.DeferredPromise=V;var x;(function(pe){async function ee(Ee){let Pe;const Ne=await Promise.all(Ee.map(ve=>ve.then(ue=>ue,ue=>{Pe||(Pe=ue)})));if(typeof Pe!="undefined")throw Pe;return Ne}pe.settled=ee;function ge(Ee){return new Promise(async(Pe,Ne)=>{try{await Ee(Pe,Ne)}catch(ve){Ne(ve)}})}pe.withAsyncBody=ge})(x=e.Promises||(e.Promises={}));var q;(function(pe){pe[pe.Initial=0]="Initial",pe[pe.DoneOK=1]="DoneOK",pe[pe.DoneError=2]="DoneError"})(q||(q={}));class te{constructor(ee){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const ge={emitOne:Ee=>this.emitOne(Ee),emitMany:Ee=>this.emitMany(Ee),reject:Ee=>this.reject(Ee)};try{await Promise.resolve(ee(ge)),this.resolve()}catch(Ee){this.reject(Ee)}finally{ge.emitOne=void 0,ge.emitMany=void 0,ge.reject=void 0}})}static fromArray(ee){return new te(ge=>{ge.emitMany(ee)})}static fromPromise(ee){return new te(async ge=>{ge.emitMany(await ee)})}static fromPromises(ee){return new te(async ge=>{await Promise.all(ee.map(async Ee=>ge.emitOne(await Ee)))})}static merge(ee){return new te(async ge=>{await Promise.all(ee.map(async Ee=>{for await(const Pe of Ee)ge.emitOne(Pe)}))})}[Symbol.asyncIterator](){let ee=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ee<this._results.length)return{done:!1,value:this._results[ee++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ee,ge){return new te(async Ee=>{for await(const Pe of ee)Ee.emitOne(ge(Pe))})}map(ee){return te.map(this,ee)}static filter(ee,ge){return new te(async Ee=>{for await(const Pe of ee)ge(Pe)&&Ee.emitOne(Pe)})}filter(ee){return te.filter(this,ee)}static coalesce(ee){return te.filter(ee,ge=>!!ge)}coalesce(){return te.coalesce(this)}static async toPromise(ee){const ge=[];for await(const Ee of ee)ge.push(Ee);return ge}toPromise(){return te.toPromise(this)}emitOne(ee){this._state===0&&(this._results.push(ee),this._onStateChanged.fire())}emitMany(ee){this._state===0&&(this._results=this._results.concat(ee),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ee){this._state===0&&(this._state=2,this._error=ee,this._onStateChanged.fire())}}e.AsyncIterableObject=te,te.EMPTY=te.fromArray([]);class Y extends te{constructor(ee,ge){super(ge);this._source=ee}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Y;function le(pe){const ee=new u.CancellationTokenSource,ge=pe(ee.token);return new Y(ee,async Ee=>{const Pe=ee.token.onCancellationRequested(()=>{Pe.dispose(),ee.dispose(),Ee.reject(new n.CancellationError)});try{for await(const Ne of ge){if(ee.token.isCancellationRequested)return;Ee.emitOne(Ne)}Pe.dispose(),ee.dispose()}catch(Ne){Pe.dispose(),ee.dispose(),Ee.reject(Ne)}})}e.createCancelableAsyncIterable=le}),define(Ie[104],ke([0,1,18,9]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new u.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),T=new u.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new u.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function y(h,S,L=!1){const F=h||"",M=S||"",A=D.value.collator.compare(F,M);return D.value.collatorIsNumeric&&A===0&&F!==M?F<M?-1:1:A}e.compareFileNames=y;function b(h,S){const L=T.value.collator;return h=h||"",S=S||"",m(L,h,S)}e.compareFileNamesDefault=b;function I(h,S){const L=T.value.collator;return h=h||"",S=S||"",o(h,S)||m(L,h,S)}e.compareFileNamesUpper=I;function R(h,S){const L=T.value.collator;return h=h||"",S=S||"",i(h,S)||m(L,h,S)}e.compareFileNamesLower=R;function k(h,S){return h=h||"",S=S||"",h===S?0:h<S?-1:1}e.compareFileNamesUnicode=k;function _(h,S,L=!1){L||(h=h&&h.toLowerCase(),S=S&&S.toLowerCase());const[F,M]=g(h),[A,B]=g(S);return F!==A?F<A?-1:1:M===B?0:M<B?-1:1}e.noIntlCompareFileNames=_;function P(h,S){const[L,F]=g(h),[M,A]=g(S);let B=D.value.collator.compare(F,A);if(B===0){if(D.value.collatorIsNumeric&&F!==A)return F<A?-1:1;if(B=D.value.collator.compare(L,M),D.value.collatorIsNumeric&&B===0&&L!==M)return L<M?-1:1}return B}e.compareFileExtensions=P;function v(h,S){h=h||"",S=S||"";const L=c(h),F=c(S),M=T.value.collator,A=C.value.collator;return m(A,L,F)||m(M,h,S)}e.compareFileExtensionsDefault=v;function w(h,S){h=h||"",S=S||"";const L=c(h),F=c(S),M=T.value.collator,A=C.value.collator;return m(A,L,F)||o(h,S)||m(M,h,S)}e.compareFileExtensionsUpper=w;function p(h,S){h=h||"",S=S||"";const L=c(h),F=c(S),M=T.value.collator,A=C.value.collator;return m(A,L,F)||i(h,S)||m(M,h,S)}e.compareFileExtensionsLower=p;function f(h,S){h=h||"",S=S||"";const L=c(h).toLowerCase(),F=c(S).toLowerCase();return L!==F?L<F?-1:1:h!==S?h<S?-1:1:0}e.compareFileExtensionsUnicode=f;const E=/^(.*?)(\.([^.]*))?$/;function g(h,S=!1){const L=h?E.exec(h):[];let F=[L&&L[1]||"",L&&L[3]||""];return S&&(!F[0]&&F[1]||F[0]&&F[0].charAt(0)===".")&&(F=[F[0]+"."+F[1],""]),F}function c(h){const S=h?E.exec(h):[];return S&&S[1]&&S[1].charAt(0)!=="."&&S[3]||""}function m(h,S,L){const F=h.compare(S,L);return F!==0?F:S.length!==L.length?S.length<L.length?-1:1:0}function a(h){const S=h.charAt(0);return S.toLocaleUpperCase()!==S}function d(h){const S=h.charAt(0);return S.toLocaleLowerCase()!==S}function i(h,S){return a(h)&&d(S)?-1:d(h)&&a(S)?1:0}function o(h,S){return d(h)&&a(S)?-1:a(h)&&d(S)?1:0}function r(h,S,L=!1){return L||(h=h&&h.toLowerCase(),S=S&&S.toLowerCase()),h===S?0:h<S?-1:1}function t(h,S,L=!1){const F=h.split(n.sep),M=S.split(n.sep),A=F.length-1,B=M.length-1;let $,U;for(let X=0;;X++){if($=A===X,U=B===X,$&&U)return y(F[X],M[X],L);if($)return-1;if(U)return 1;const z=r(F[X],M[X],L);if(z!==0)return z}}e.comparePaths=t;function s(h,S,L){const F=h.toLowerCase(),M=S.toLowerCase(),A=l(h,S,L);if(A)return A;const B=F.endsWith(L),$=M.endsWith(L);if(B!==$)return B?-1:1;const U=y(F,M);return U!==0?U:F.localeCompare(M)}e.compareAnything=s;function l(h,S,L){const F=h.toLowerCase(),M=S.toLowerCase(),A=F.startsWith(L),B=M.startsWith(L);if(A!==B)return A?-1:1;if(A&&B){if(F.length<M.length)return-1;if(F.length>M.length)return 1}return 0}e.compareByPrefix=l}),define(Ie[105],ke([0,1,104,103,60,9,13,8]),function(J,e,u,n,D,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const b=0,I=[b,[]];function R(z,N,V,x){if(!z||!N)return I;const q=z.length,te=N.length;if(q<te)return I;const Y=z.toLowerCase();return k(N,V,te,z,Y,q,x)}e.scoreFuzzy=R;function k(z,N,V,x,q,te,Y){const le=[],pe=[];for(let Pe=0;Pe<V;Pe++){const Ne=Pe*te,ve=Ne-te,ue=Pe>0,de=z[Pe],we=N[Pe];for(let re=0;re<te;re++){const me=re>0,Z=Ne+re,se=Z-1,O=ve+re-1,H=me?le[se]:0,K=ue&&me?le[O]:0,Q=ue&&me?pe[O]:0;let he;!K&&ue?he=0:he=_(de,we,x,q,re,Q),he&&K+he>=H&&(Y||ue||q.startsWith(N,re))?(pe[Z]=Q+1,le[Z]=K+he):(pe[Z]=b,le[Z]=H)}}const ee=[];let ge=V-1,Ee=te-1;for(;ge>=0&&Ee>=0;){const Pe=ge*te+Ee;pe[Pe]===b||(ee.push(Ee),ge--),Ee--}return[le[V*te-1],ee.reverse()]}function _(z,N,V,x,q,te){let Y=0;if(!P(N,x[q]))return Y;if(Y+=1,te>0&&(Y+=te*5),z===V[q]&&(Y+=1),q===0)Y+=8;else{const le=v(V.charCodeAt(q-1));le?Y+=le:(0,n.isUpper)(V.charCodeAt(q))&&te===0&&(Y+=2)}return Y}function P(z,N){return z===N?!0:z==="/"||z==="\\"?N==="/"||N==="\\":!1}function v(z){switch(z){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function p(z,N,V=0,x=0){const q=N;return q.values&&q.values.length>1?f(z,q.values,V,x):E(z,N,V,x)}e.scoreFuzzy2=p;function f(z,N,V,x){let q=0;const te=[];for(const Y of N){const[le,pe]=E(z,Y,V,x);if(typeof le!="number")return w;q+=le,te.push(...pe)}return[q,l(te)]}function E(z,N,V,x){const q=(0,n.fuzzyScore)(N.original,N.originalLowercase,V,z,z.toLowerCase(),x,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return q?[q[0],(0,n.createMatches)(q)]:w}const g=Object.freeze({score:0}),c=1<<18,m=1<<17,a=1<<16;function d(z,N,V,x){const q=x.values?x.values:[x];return(0,D.hash)({[x.normalized]:{values:q.map(Y=>({value:Y.normalized,expectContiguousMatch:Y.expectContiguousMatch})),label:z,description:N,allowNonContiguousMatches:V}})}function i(z,N,V,x,q){if(!z||!N.normalized)return g;const te=x.getItemLabel(z);if(!te)return g;const Y=x.getItemDescription(z),le=d(te,Y,V,N),pe=q[le];if(pe)return pe;const ee=o(te,Y,x.getItemPath(z),N,V);return q[le]=ee,ee}e.scoreItemFuzzy=i;function o(z,N,V,x,q){const te=!V||!x.containsPathSeparator;return V&&(C.isLinux?x.pathNormalized===V:(0,y.equalsIgnoreCase)(x.pathNormalized,V))?{score:c,labelMatch:[{start:0,end:z.length}],descriptionMatch:N?[{start:0,end:N.length}]:void 0}:x.values&&x.values.length>1?r(z,N,V,x.values,te,q):t(z,N,V,x,te,q)}function r(z,N,V,x,q,te){let Y=0;const le=[],pe=[];for(const ee of x){const{score:ge,labelMatch:Ee,descriptionMatch:Pe}=t(z,N,V,ee,q,te);if(ge===b)return g;Y+=ge,Ee&&le.push(...Ee),Pe&&pe.push(...Pe)}return{score:Y,labelMatch:l(le),descriptionMatch:l(pe)}}function t(z,N,V,x,q,te){if(q||!N){const[Y,le]=R(z,x.normalized,x.normalizedLowercase,te&&!x.expectContiguousMatch);if(Y){const pe=(0,n.matchesPrefix)(x.normalized,z);let ee;return pe?(ee=m,ee+=Math.round(x.normalized.length/z.length*100)):ee=a,{score:ee+Y,labelMatch:pe||s(le)}}}if(N){let Y=N;V&&(Y=`${N}${T.sep}`);const le=Y.length,pe=`${Y}${z}`,[ee,ge]=R(pe,x.normalized,x.normalizedLowercase,te&&!x.expectContiguousMatch);if(ee){const Ee=s(ge),Pe=[],Ne=[];return Ee.forEach(ve=>{ve.start<le&&ve.end>le?(Pe.push({start:0,end:ve.end-le}),Ne.push({start:ve.start,end:le})):ve.start>=le?Pe.push({start:ve.start-le,end:ve.end-le}):Ne.push(ve)}),{score:ee,labelMatch:Pe,descriptionMatch:Ne}}}return g}function s(z){const N=[];if(!z)return N;let V;for(const x of z)V&&V.end===x?V.end+=1:(V={start:x,end:x+1},N.push(V));return N}function l(z){const N=z.sort((q,te)=>q.start-te.start),V=[];let x;for(const q of N)!x||!h(x,q)?(x=q,V.push(q)):(x.start=Math.min(x.start,q.start),x.end=Math.max(x.end,q.end));return V}function h(z,N){return!(z.end<N.start||N.end<z.start)}function S(z,N,V,x,q,te){const Y=i(z,V,x,q,te),le=i(N,V,x,q,te),pe=Y.score,ee=le.score;if((pe===c||ee===c)&&pe!==ee)return pe===c?-1:1;if(pe>a||ee>a){if(pe!==ee)return pe>ee?-1:1;if(pe<m&&ee<m){const de=F(Y.labelMatch,le.labelMatch);if(de!==0)return de}const ve=q.getItemLabel(z)||"",ue=q.getItemLabel(N)||"";if(ve.length!==ue.length)return ve.length-ue.length}if(pe!==ee)return pe>ee?-1:1;const ge=Array.isArray(Y.labelMatch)&&Y.labelMatch.length>0,Ee=Array.isArray(le.labelMatch)&&le.labelMatch.length>0;if(ge&&!Ee)return-1;if(Ee&&!ge)return 1;const Pe=L(z,Y,q),Ne=L(N,le,q);return Pe&&Ne&&Pe!==Ne?Ne>Pe?-1:1:M(z,N,V,q)}e.compareItemsByFuzzyScore=S;function L(z,N,V){let x=-1,q=-1;if(N.descriptionMatch&&N.descriptionMatch.length?x=N.descriptionMatch[0].start:N.labelMatch&&N.labelMatch.length&&(x=N.labelMatch[0].start),N.labelMatch&&N.labelMatch.length){if(q=N.labelMatch[N.labelMatch.length-1].end,N.descriptionMatch&&N.descriptionMatch.length){const te=V.getItemDescription(z);te&&(q+=te.length)}}else N.descriptionMatch&&N.descriptionMatch.length&&(q=N.descriptionMatch[N.descriptionMatch.length-1].end);return q-x}function F(z,N){if(!z&&!N||(!z||!z.length)&&(!N||!N.length))return 0;if(!N||!N.length)return-1;if(!z||!z.length)return 1;const V=z[0].start,q=z[z.length-1].end-V,te=N[0].start,le=N[N.length-1].end-te;return q===le?0:le<q?1:-1}function M(z,N,V,x){const q=x.getItemLabel(z)||"",te=x.getItemLabel(N)||"",Y=x.getItemDescription(z),le=x.getItemDescription(N),pe=q.length+(Y?Y.length:0),ee=te.length+(le?le.length:0);if(pe!==ee)return pe-ee;const ge=x.getItemPath(z),Ee=x.getItemPath(N);return ge&&Ee&&ge.length!==Ee.length?ge.length-Ee.length:q!==te?(0,u.compareAnything)(q,te,V.normalized):Y&&le&&Y!==le?(0,u.compareAnything)(Y,le,V.normalized):ge&&Ee&&ge!==Ee?(0,u.compareAnything)(ge,Ee,V.normalized):0}function A(z){return z.startsWith('"')&&z.endsWith('"')}const B=" ";function $(z){typeof z!="string"&&(z="");const N=z.toLowerCase(),{pathNormalized:V,normalized:x,normalizedLowercase:q}=U(z),te=V.indexOf(T.sep)>=0,Y=A(z);let le;const pe=z.split(B);if(pe.length>1)for(const ee of pe){const ge=A(ee),{pathNormalized:Ee,normalized:Pe,normalizedLowercase:Ne}=U(ee);Pe&&(le||(le=[]),le.push({original:ee,originalLowercase:ee.toLowerCase(),pathNormalized:Ee,normalized:Pe,normalizedLowercase:Ne,expectContiguousMatch:ge}))}return{original:z,originalLowercase:N,pathNormalized:V,normalized:x,normalizedLowercase:q,values:le,containsPathSeparator:te,expectContiguousMatch:Y}}e.prepareQuery=$;function U(z){let N;C.isWindows?N=z.replace(/\//g,T.sep):N=z.replace(/\\/g,T.sep);const V=(0,y.stripWildcards)(N).replace(/\s|"/g,"");return{pathNormalized:N,normalized:V,normalizedLowercase:V.toLowerCase()}}function X(z){return Array.isArray(z)?$(z.map(N=>N.original).join(B)):$(z.original)}e.pieceToQuery=X}),define(Ie[37],ke([0,1,16,18,30,25,9,13,8]),function(J,e,u,n,D,T,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",k="[^/\\\\]",_=/\//g;function P(V,x){switch(V){case 0:return"";case 1:return`${k}*?`;default:return`(?:${R}|${k}+${R}${x?`|${R}${k}+`:""})*?`}}function v(V,x){if(!V)return[];const q=[];let te=!1,Y=!1,le="";for(const pe of V){switch(pe){case x:if(!te&&!Y){q.push(le),le="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":Y=!0;break;case"]":Y=!1;break}le+=pe}return le&&q.push(le),q}e.splitGlobAware=v;function w(V){if(!V)return"";let x="";const q=v(V,e.GLOB_SPLIT);if(q.every(te=>te===e.GLOBSTAR))x=".*";else{let te=!1;q.forEach((Y,le)=>{if(Y===e.GLOBSTAR){if(te)return;x+=P(2,le===q.length-1)}else{let pe=!1,ee="",ge=!1,Ee="";for(const Pe of Y){if(Pe!=="}"&&pe){ee+=Pe;continue}if(ge&&(Pe!=="]"||!Ee)){let Ne;Pe==="-"?Ne=Pe:(Pe==="^"||Pe==="!")&&!Ee?Ne="^":Pe===e.GLOB_SPLIT?Ne="":Ne=(0,b.escapeRegExpCharacters)(Pe),Ee+=Ne;continue}switch(Pe){case"{":pe=!0;continue;case"[":ge=!0;continue;case"}":{x+=`(?:${v(ee,",").map(ue=>w(ue)).join("|")})`,pe=!1,ee="";break}case"]":{x+="["+Ee+"]",ge=!1,Ee="";break}case"?":x+=k;continue;case"*":x+=P(1);continue;default:x+=(0,b.escapeRegExpCharacters)(Pe)}}le<q.length-1&&(q[le+1]!==e.GLOBSTAR||le+2<q.length)&&(x+=R)}te=Y===e.GLOBSTAR})}return x}const p=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,a=new T.LRUCache(1e4),d=function(){return!1},i=function(){return null};function o(V,x){if(!V)return i;let q;typeof V!="string"?q=V.pattern:q=V,q=q.trim();const te=`${q}_${!!x.trimForExclusions}`;let Y=a.get(te);if(Y)return r(Y,V);let le;return p.test(q)?Y=s(q.substr(4),q):(le=f.exec(t(q,x)))?Y=l(le[1],q):(x.trimForExclusions?g:E).test(q)?Y=h(q,x):(le=c.exec(t(q,x)))?Y=S(le[1].substr(1),q,!0):(le=m.exec(t(q,x)))?Y=S(le[1],q,!1):Y=L(q),a.set(te,Y),r(Y,V)}function r(V,x){if(typeof x=="string")return V;const q=function(te,Y){return(0,D.isEqualOrParent)(te,x.base,!y.isLinux)?V(te.substr(x.base.length+1),Y):null};return q.allBasenames=V.allBasenames,q.allPaths=V.allPaths,q.basenames=V.basenames,q.patterns=V.patterns,q}function t(V,x){return x.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function s(V,x){return function(q,te){return typeof q=="string"&&q.endsWith(V)?x:null}}function l(V,x){const q=`/${V}`,te=`\\${V}`,Y=function(pe,ee){return typeof pe!="string"?null:ee?ee===V?x:null:pe===V||pe.endsWith(q)||pe.endsWith(te)?x:null},le=[V];return Y.basenames=le,Y.patterns=[x],Y.allBasenames=le,Y}function h(V,x){const q=z(V.slice(1,-1).split(",").map(ee=>o(ee,x)).filter(ee=>ee!==i),V),te=q.length;if(!te)return i;if(te===1)return q[0];const Y=function(ee,ge){for(let Ee=0,Pe=q.length;Ee<Pe;Ee++)if(q[Ee](ee,ge))return V;return null},le=q.find(ee=>!!ee.allBasenames);le&&(Y.allBasenames=le.allBasenames);const pe=q.reduce((ee,ge)=>ge.allPaths?ee.concat(ge.allPaths):ee,[]);return pe.length&&(Y.allPaths=pe),Y}function S(V,x,q){const te=C.sep===C.posix.sep,Y=te?V:V.replace(_,C.sep),le=C.sep+Y,pe=C.posix.sep+V;let ee;return q?ee=function(ge,Ee){return typeof ge=="string"&&(ge===Y||ge.endsWith(le)||!te&&(ge===V||ge.endsWith(pe)))?x:null}:ee=function(ge,Ee){return typeof ge=="string"&&(ge===Y||!te&&ge===V)?x:null},ee.allPaths=[(q?"*/":"./")+V],ee}function L(V){try{const x=new RegExp(`^${w(V)}$`);return function(q){return x.lastIndex=0,typeof q=="string"&&x.test(q)?V:null}}catch{return i}}function F(V,x,q){return!V||typeof x!="string"?!1:M(V)(x,void 0,q)}e.match=F;function M(V,x={}){if(!V)return d;if(typeof V=="string"||A(V)){const q=o(V,x);if(q===i)return d;const te=function(Y,le){return!!q(Y,le)};return q.allBasenames&&(te.allBasenames=q.allBasenames),q.allPaths&&(te.allPaths=q.allPaths),te}return U(V,x)}e.parse=M;function A(V){const x=V;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=A;function B(V){return V.allBasenames||[]}e.getBasenameTerms=B;function $(V){return V.allPaths||[]}e.getPathTerms=$;function U(V,x){const q=z(Object.getOwnPropertyNames(V).map(ee=>X(ee,V[ee],x)).filter(ee=>ee!==i)),te=q.length;if(!te)return i;if(!q.some(ee=>!!ee.requiresSiblings)){if(te===1)return q[0];const ee=function(Pe,Ne){let ve;for(let ue=0,de=q.length;ue<de;ue++){const we=q[ue](Pe,Ne);if(typeof we=="string")return we;(0,n.isThenable)(we)&&(ve||(ve=[]),ve.push(we))}return ve?(async()=>{for(const ue of ve){const de=await ue;if(typeof de=="string")return de}return null})():null},ge=q.find(Pe=>!!Pe.allBasenames);ge&&(ee.allBasenames=ge.allBasenames);const Ee=q.reduce((Pe,Ne)=>Ne.allPaths?Pe.concat(Ne.allPaths):Pe,[]);return Ee.length&&(ee.allPaths=Ee),ee}const Y=function(ee,ge,Ee){let Pe,Ne;for(let ve=0,ue=q.length;ve<ue;ve++){const de=q[ve];de.requiresSiblings&&Ee&&(ge||(ge=(0,C.basename)(ee)),Pe||(Pe=ge.substr(0,ge.length-(0,C.extname)(ee).length)));const we=de(ee,ge,Pe,Ee);if(typeof we=="string")return we;(0,n.isThenable)(we)&&(Ne||(Ne=[]),Ne.push(we))}return Ne?(async()=>{for(const ve of Ne){const ue=await ve;if(typeof ue=="string")return ue}return null})():null},le=q.find(ee=>!!ee.allBasenames);le&&(Y.allBasenames=le.allBasenames);const pe=q.reduce((ee,ge)=>ge.allPaths?ee.concat(ge.allPaths):ee,[]);return pe.length&&(Y.allPaths=pe),Y}function X(V,x,q){if(x===!1)return i;const te=o(V,q);if(te===i)return i;if(typeof x=="boolean")return te;if(x){const Y=x.when;if(typeof Y=="string"){const le=(pe,ee,ge,Ee)=>{if(!Ee||!te(pe,ee))return null;const Pe=Y.replace("$(basename)",ge),Ne=Ee(Pe);return(0,n.isThenable)(Ne)?Ne.then(ve=>ve?V:null):Ne?V:null};return le.requiresSiblings=!0,le}}return te}function z(V,x){const q=V.filter(ee=>!!ee.basenames);if(q.length<2)return V;const te=q.reduce((ee,ge)=>{const Ee=ge.basenames;return Ee?ee.concat(Ee):ee},[]);let Y;if(x){Y=[];for(let ee=0,ge=te.length;ee<ge;ee++)Y.push(x)}else Y=q.reduce((ee,ge)=>{const Ee=ge.patterns;return Ee?ee.concat(Ee):ee},[]);const le=function(ee,ge){if(typeof ee!="string")return null;if(!ge){let Pe;for(Pe=ee.length;Pe>0;Pe--){const Ne=ee.charCodeAt(Pe-1);if(Ne===47||Ne===92)break}ge=ee.substr(Pe)}const Ee=te.indexOf(ge);return Ee!==-1?Y[Ee]:null};le.basenames=te,le.patterns=Y,le.allBasenames=te;const pe=V.filter(ee=>!ee.basenames);return pe.push(le),pe}function N(V,x){return(0,u.equals)(V,x,(q,te)=>typeof q=="string"&&typeof te=="string"?q===te:typeof q!="string"&&typeof te!="string"?q.base===te.base&&q.pattern===te.pattern:!1)}e.patternsEquals=N}),define(Ie[106],ke([0,1,12,156,22,8,2]),function(J,e,u,n,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var y;(function(p){p[p.Paragraph=0]="Paragraph",p[p.Break=1]="Break"})(y=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class b{constructor(f="",E=!1){if(this.value=f,typeof this.value!="string")throw(0,u.illegalArgument)("value");typeof E=="boolean"?(this.isTrusted=E,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=E.isTrusted??void 0,this.supportThemeIcons=E.supportThemeIcons??!1,this.supportHtml=E.supportHtml??!1)}appendText(f,E=0){return this.value+=_(this.supportThemeIcons?(0,n.escapeIcons)(f):f).replace(/([ \t]+)/g,(g,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,E===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,E){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=E,this.value+="\n```\n",this}appendLink(f,E,g){return this.value+="[",this.value+=this._escape(E,"]"),this.value+="](",this.value+=this._escape(String(f),")"),g&&(this.value+=` "${this._escape(this._escape(g,'"'),")")}"`),this.value+=")",this}_escape(f,E){const g=new RegExp((0,T.escapeRegExpCharacters)(E),"g");return f.replace(g,(c,m)=>f.charAt(m-1)!=="\\"?`\\${c}`:c)}}e.MarkdownString=b;function I(p){return R(p)?!p.value:Array.isArray(p)?p.every(I):!0}e.isEmptyMarkdownString=I;function R(p){return p instanceof b?!0:p&&typeof p=="object"?typeof p.value=="string"&&(typeof p.isTrusted=="boolean"||p.isTrusted===void 0)&&(typeof p.supportThemeIcons=="boolean"||p.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function k(p,f){return p===f?!0:!p||!f?!1:p.value===f.value&&p.isTrusted===f.isTrusted&&p.supportThemeIcons===f.supportThemeIcons&&p.supportHtml===f.supportHtml&&(p.baseUri===f.baseUri||!!p.baseUri&&!!f.baseUri&&(0,D.isEqual)(C.URI.from(p.baseUri),C.URI.from(f.baseUri)))}e.markdownStringEqual=k;function _(p){return p.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=_;function P(p){return p.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=P;function v(p){return p&&p.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=v;function w(p){const f=[],E=p.split("|").map(c=>c.trim());p=E[0];const g=E[1];if(g){const c=/height=(\d+)/.exec(g),m=/width=(\d+)/.exec(g),a=c?c[1]:"",d=m?m[1]:"",i=isFinite(parseInt(d)),o=isFinite(parseInt(a));i&&f.push(`width="${d}"`),o&&f.push(`height="${a}"`)}return{href:p,dimensions:f}}e.parseHrefAndDimensions=w}),define(Ie[107],ke([0,1,16,30,9,13,22,8]),function(J,e,u,n,D,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function b(i,o){const{os:r,tildify:t,relative:s}=o;if(s){const S=I(i,s,r);if(typeof S=="string")return S}let l=i.fsPath;if(r===1&&!T.isWindows?l=l.replace(/\//g,"\\"):r!==1&&T.isWindows&&(l=l.replace(/\\/g,"/")),r!==1&&t?.userHome){const S=t.userHome.fsPath;let L;i.scheme!==t.userHome.scheme&&i.path.startsWith(D.posix.sep)?L=t.userHome.with({path:i.path}).fsPath:L=i.fsPath,l=_(L,S,r)}return(r===1?D.win32:D.posix).normalize(R(l,r===1))}e.getPathLabel=b;function I(i,o,r){const t=r===1?D.win32:D.posix,s=r===3?C.extUri:C.extUriIgnorePathCase,l=o.getWorkspace(),h=(0,u.firstOrDefault)(l.folders);if(!h)return;i.scheme!==h.uri.scheme&&i.path.startsWith(D.posix.sep)&&(i=h.uri.with({path:i.path}));const S=o.getWorkspaceFolder(i);if(!S)return;let L;if(s.isEqual(S.uri,i)?L="":L=s.relativePath(S.uri,i)??"",L&&(L=t.normalize(L)),l.folders.length>1&&!o.noPrefix){const F=S.name?S.name:s.basenameOrAuthority(S.uri);L=L?`${F} \u2022 ${L}`:F}return L}function R(i,o=T.isWindows){return(0,n.hasDriveLetter)(i,o)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=R;let k=Object.create(null);function _(i,o,r=T.OS){if(r===1||!i||!o)return i;let t=k.original===o?k.normalized:void 0;t||(t=o,T.isWindows&&(t=(0,n.toSlashes)(t)),t=`${(0,y.rtrim)(t,D.posix.sep)}${D.posix.sep}`,k={original:o,normalized:t});let s=i;return T.isWindows&&(s=(0,n.toSlashes)(s)),(r===3?s.startsWith(t):(0,y.startsWithIgnoreCase)(s,t))?`~/${s.substr(t.length)}`:i}e.tildify=_;function P(i,o){return i.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=P;const v="\u2026",w="\\\\",p="~";function f(i,o=D.sep){const r=new Array(i.length);let t=!1;for(let s=0;s<i.length;s++){const l=i[s];if(l===""){r[s]=`.${o}`;continue}if(!l){r[s]=l;continue}t=!0;let h="",S=l;S.indexOf(w)===0?(h=S.substr(0,S.indexOf(w)+w.length),S=S.substr(S.indexOf(w)+w.length)):S.indexOf(o)===0?(h=S.substr(0,S.indexOf(o)+o.length),S=S.substr(S.indexOf(o)+o.length)):S.indexOf(p)===0&&(h=S.substr(0,S.indexOf(p)+p.length),S=S.substr(S.indexOf(p)+p.length));const L=S.split(o);for(let F=1;t&&F<=L.length;F++)for(let M=L.length-F;t&&M>=0;M--){t=!1;let A=L.slice(M,M+F).join(o);for(let B=0;!t&&B<i.length;B++)if(B!==s&&i[B]&&i[B].indexOf(A)>-1){const $=M+F===L.length,U=M>0&&i[B].indexOf(o)>-1?o+A:A,X=i[B].endsWith(U);t=!$||X}if(!t){let B="";(L[0].endsWith(":")||h!=="")&&(M===1&&(M=0,F++,A=L[0]+o+A),M>0&&(B=L[0]+o),B=h+B),M>0&&(B=B+v+o),B=B+A,M+F<L.length&&(B=B+o+v),r[s]=B}}t&&(r[s]=l)}return r}e.shorten=f;var E;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(E||(E={}));function g(i,o=Object.create(null)){const r=[];let t=!1,s="";for(const l of i)if(l==="$"||t&&l==="{")s&&r.push({value:s,type:E.TEXT}),s="",t=!0;else if(l==="}"&&t){const h=o[s];if(typeof h=="string")h.length&&r.push({value:h,type:E.VARIABLE});else if(h){const S=r[r.length-1];(!S||S.type!==E.SEPARATOR)&&r.push({value:h.label,type:E.SEPARATOR})}s="",t=!1}else s+=l;return s&&!t&&r.push({value:s,type:E.TEXT}),r.filter((l,h)=>{if(l.type===E.SEPARATOR){const S=r[h-1],L=r[h+1];return[S,L].every(F=>F&&(F.type===E.VARIABLE||F.type===E.TEXT)&&F.value.length>0)}return!0}).map(l=>l.value).join("")}e.template=g;function c(i,o){return T.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):i.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function m(i,o){return T.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,""):T.isWindows?i.replace(/&&|&/g,r=>r==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=m;function a(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=a;function d(i){const o=i.indexOf("/")!==-1?D.posix:D.win32,r=o.basename(i),t=o.dirname(i);return r.length?{name:r,parentPath:t}:{name:t,parentPath:""}}e.splitName=d}),define(Ie[108],ke([0,1,2]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(R){return R.toJSON()}class D{constructor(k){this._uriTransformer=k}transformIncoming(k){const _=this._uriTransformer.transformIncoming(k);return _===k?k:n(u.URI.from(_))}transformOutgoing(k){const _=this._uriTransformer.transformOutgoing(k);return _===k?k:n(u.URI.from(_))}transformOutgoingURI(k){const _=this._uriTransformer.transformOutgoing(k);return _===k?k:u.URI.from(_)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function T(R,k,_){if(!R||_>200)return null;if(typeof R=="object"){if(R instanceof u.URI)return k.transformOutgoing(R);for(const P in R)if(Object.hasOwnProperty.call(R,P)){const v=T(R[P],k,_+1);v!==null&&(R[P]=v)}}return null}function C(R,k){const _=T(R,k,0);return _===null?R:_}e.transformOutgoingURIs=C;function y(R,k,_,P){if(!R||P>200)return null;if(typeof R=="object"){if(R.$mid===1)return _?u.URI.revive(k.transformIncoming(R)):k.transformIncoming(R);for(const v in R)if(Object.hasOwnProperty.call(R,v)){const w=y(R[v],k,_,P+1);w!==null&&(R[v]=w)}}return null}function b(R,k){const _=y(R,k,!1,0);return _===null?R:_}e.transformIncomingURIs=b;function I(R,k){const _=y(R,k,!0,0);return _===null?R:_}e.transformAndReviveIncomingURIs=I}),define(Ie[29],ke([0,1,62,63,303,18,30,81,9,13,22,2]),function(J,e,u,n,D,T,C,y,b,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var _;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(_=e.RimRafMode||(e.RimRafMode={}));async function P(U,X=_.UNLINK){if((0,C.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return X===_.UNLINK?w(U):v(U)}async function v(U){try{const X=(0,C.randomPath)((0,n.tmpdir)());try{await u.promises.rename(U,X)}catch{return w(U)}w(X).catch(z=>{})}catch(X){if(X.code!=="ENOENT")throw X}}async function w(U){return(0,D.promisify)(u.rm)(U,{recursive:!0,force:!0,maxRetries:3})}function p(U){if((0,C.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");u.rmSync(U,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=p;async function f(U,X){return c(await(X?E(U):(0,D.promisify)(u.readdir)(U)))}async function E(U){try{return await(0,D.promisify)(u.readdir)(U,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const X=[],z=await f(U);for(const N of z){let V=!1,x=!1,q=!1;try{const te=await e.Promises.lstat((0,b.join)(U,N));V=te.isFile(),x=te.isDirectory(),q=te.isSymbolicLink()}catch(te){console.warn("[node.js fs] unexpected error from lstat after readdir: ",te)}X.push({name:N,isFile:()=>V,isDirectory:()=>x,isSymbolicLink:()=>q})}return X}function g(U){return c(u.readdirSync(U))}e.readdirSync=g;function c(U){return U.map(X=>typeof X=="string"?I.isMacintosh?(0,y.normalizeNFC)(X):X:(X.name=I.isMacintosh?(0,y.normalizeNFC)(X.name):X.name,X))}async function m(U){const X=await f(U),z=[];for(const N of X)await d.existsDirectory((0,b.join)(U,N))&&z.push(N);return z}function a(U,X=1e3){return new Promise(z=>{let N=!1;const V=setInterval(()=>{N||(N=!0,u.access(U,x=>{N=!1,x&&(clearInterval(V),z(void 0))}))},X)})}e.whenDeleted=a;var d;(function(U){async function X(V){let x;try{if(x=await e.Promises.lstat(V),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(I.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(te){if(te.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw te}throw q}}U.stat=X;async function z(V){try{const{stat:x,symbolicLink:q}=await U.stat(V);return x.isFile()&&q?.dangling!==!0}catch{}return!1}U.existsFile=z;async function N(V){try{const{stat:x,symbolicLink:q}=await U.stat(V);return x.isDirectory()&&q?.dangling!==!0}catch{}return!1}U.existsDirectory=N})(d=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new T.ResourceQueue;function o(U,X,z){return i.queueFor(k.URI.file(U),R.extUriBiasedIgnorePathCase).queue(()=>{const N=h(z);return new Promise((V,x)=>s(U,X,N,q=>q?x(q):V()))})}let r=!0;function t(U){r=U}e.configureFlushOnWrite=t;function s(U,X,z,N){if(!r)return u.writeFile(U,X,{mode:z.mode,flag:z.flag},N);u.open(U,z.flag,z.mode,(V,x)=>{if(V)return N(V);u.writeFile(x,X,q=>{if(q)return u.close(x,()=>N(q));u.fdatasync(x,te=>(te&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",te),t(!1)),u.close(x,Y=>N(Y))))})})}function l(U,X,z){const N=h(z);if(!r)return u.writeFileSync(U,X,{mode:N.mode,flag:N.flag});const V=u.openSync(U,N.flag,N.mode);try{u.writeFileSync(V,X);try{u.fdatasyncSync(V)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),t(!1)}}finally{u.closeSync(V)}}e.writeFileSync=l;function h(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function S(U,X){if(U!==X)try{await e.Promises.rename(U,X)}catch(z){if(U.toLowerCase()!==X.toLowerCase()&&z.code==="EXDEV"||U.endsWith("."))await L(U,X,{preserveSymlinks:!1}),await P(U,_.MOVE);else throw z}}async function L(U,X,z){return M(U,X,{root:{source:U,target:X},options:z,handledSourcePaths:new Set})}const F=511;async function M(U,X,z){if(z.handledSourcePaths.has(U))return;z.handledSourcePaths.add(U);const{stat:N,symbolicLink:V}=await d.stat(U);if(V){if(z.options.preserveSymlinks)try{return await $(U,X,z)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(V.dangling)return}return N.isDirectory()?A(U,X,N.mode&F,z):B(U,X,N.mode&F)}async function A(U,X,z,N){await e.Promises.mkdir(X,{recursive:!0,mode:z});const V=await f(U);for(const x of V)await M((0,b.join)(U,x),(0,b.join)(X,x),N)}async function B(U,X,z){await e.Promises.copyFile(U,X),await e.Promises.chmod(X,z)}async function $(U,X,z){let N=await e.Promises.readlink(U);(0,C.isEqualOrParent)(N,z.root.source,!I.isLinux)&&(N=(0,b.join)(z.root.target,N.substr(z.root.source.length+1))),await e.Promises.symlink(N,X)}e.Promises=new class{get access(){return(0,D.promisify)(u.access)}get stat(){return(0,D.promisify)(u.stat)}get lstat(){return(0,D.promisify)(u.lstat)}get utimes(){return(0,D.promisify)(u.utimes)}get read(){return(U,X,z,N,V)=>new Promise((x,q)=>{u.read(U,X,z,N,V,(te,Y,le)=>te?q(te):x({bytesRead:Y,buffer:le}))})}get readFile(){return(0,D.promisify)(u.readFile)}get write(){return(U,X,z,N,V)=>new Promise((x,q)=>{u.write(U,X,z,N,V,(te,Y,le)=>te?q(te):x({bytesWritten:Y,buffer:le}))})}get appendFile(){return(0,D.promisify)(u.appendFile)}get fdatasync(){return(0,D.promisify)(u.fdatasync)}get truncate(){return(0,D.promisify)(u.truncate)}get rename(){return(0,D.promisify)(u.rename)}get copyFile(){return(0,D.promisify)(u.copyFile)}get open(){return(0,D.promisify)(u.open)}get close(){return(0,D.promisify)(u.close)}get symlink(){return(0,D.promisify)(u.symlink)}get readlink(){return(0,D.promisify)(u.readlink)}get chmod(){return(0,D.promisify)(u.chmod)}get mkdir(){return(0,D.promisify)(u.mkdir)}get unlink(){return(0,D.promisify)(u.unlink)}get rmdir(){return(0,D.promisify)(u.rmdir)}get realpath(){return(0,D.promisify)(u.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return m}get writeFile(){return o}get rm(){return P}get move(){return S}get copy(){return L}}}),define(Ie[109],ke([0,1,62,9,13,8,29]),function(J,e,u,n,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function y(_){if(D.isLinux)return _;const P=(0,n.dirname)(_);if(_===P)return _;const v=((0,n.basename)(_)||_).toLowerCase();try{const p=(0,C.readdirSync)(P).filter(f=>f.toLowerCase()===v);if(p.length===1){const f=y(P);if(f)return(0,n.join)(f,p[0])}else if(p.length>1){const f=p.indexOf(v);if(f>=0){const E=y(P);if(E)return(0,n.join)(E,p[f])}}}catch{}return null}e.realcaseSync=y;async function b(_){if(D.isLinux)return _;const P=(0,n.dirname)(_);if(_===P)return _;const v=((0,n.basename)(_)||_).toLowerCase();try{const p=(await C.Promises.readdir(P)).filter(f=>f.toLowerCase()===v);if(p.length===1){const f=await b(P);if(f)return(0,n.join)(f,p[0])}else if(p.length>1){const f=p.indexOf(v);if(f>=0){const E=await b(P);if(E)return(0,n.join)(E,p[f])}}}catch{}return null}e.realcase=b;async function I(_){try{return await C.Promises.realpath(_)}catch{const v=k(_);return await C.Promises.access(v,u.constants.R_OK),v}}e.realpath=I;function R(_){try{return u.realpathSync(_)}catch{const v=k(_);return u.accessSync(v,u.constants.R_OK),v}}e.realpathSync=R;function k(_){return(0,T.rtrim)((0,n.normalize)(_),n.sep)}});var je=this&&this.__decorate||function(J,e,u,n){var D=arguments.length,T=D<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,u):n,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(J,e,u,n);else for(var y=J.length-1;y>=0;y--)(C=J[y])&&(T=(D<3?C(T):D>3?C(e,u,T):C(e,u))||T);return D>3&&T&&Object.defineProperty(e,u,T),T};define(Ie[110],ke([0,1,16,18,23,21,57,12,3,6,61,8,11]),function(J,e,u,n,D,T,C,y,b,I,R,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var P;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(P=e.RequestType||(e.RequestType={}));function v(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function p(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(f||(f={}));class E{constructor(x){this.buffer=x,this.pos=0}read(x){const q=this.buffer.slice(this.pos,this.pos+x);return this.pos+=q.byteLength,q}}class g{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(x){this.buffers.push(x)}}var c;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object"})(c||(c={}));function m(V){const x=D.VSBuffer.alloc(4);return x.writeUInt32BE(V,0),x}function a(V){return V.read(4).readUInt32BE(0)}function d(V){const x=D.VSBuffer.alloc(1);return x.writeUInt8(V,0),x}const i={Undefined:d(c.Undefined),String:d(c.String),Buffer:d(c.Buffer),VSBuffer:d(c.VSBuffer),Array:d(c.Array),Object:d(c.Object)},o=typeof Buffer!="undefined";function r(V,x){if(typeof x=="undefined")V.write(i.Undefined);else if(typeof x=="string"){const q=D.VSBuffer.fromString(x);V.write(i.String),V.write(m(q.byteLength)),V.write(q)}else if(o&&Buffer.isBuffer(x)){const q=D.VSBuffer.wrap(x);V.write(i.Buffer),V.write(m(q.byteLength)),V.write(q)}else if(x instanceof D.VSBuffer)V.write(i.VSBuffer),V.write(m(x.byteLength)),V.write(x);else if(Array.isArray(x)){V.write(i.Array),V.write(m(x.length));for(const q of x)r(V,q)}else{const q=D.VSBuffer.fromString(JSON.stringify(x));V.write(i.Object),V.write(m(q.byteLength)),V.write(q)}}function t(V){switch(V.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return V.read(a(V)).toString();case c.Buffer:return V.read(a(V)).buffer;case c.VSBuffer:return V.read(a(V));case c.Array:{const q=a(V),te=[];for(let Y=0;Y<q;Y++)te.push(t(V));return te}case c.Object:return JSON.parse(V.read(a(V)).toString())}}class s{constructor(x,q,te=null,Y=1e3){this.protocol=x,this.ctx=q,this.logger=te,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(le=>this.onRawMessage(le)),this.sendResponse({type:200})}registerChannel(x,q){this.channels.set(x,q),setTimeout(()=>this.flushPendingRequests(x),0)}sendResponse(x){switch(x.type){case 200:{const q=this.send([x.type]);this.logger?.logOutgoing(q,0,1,p(x.type));return}case 201:case 202:case 204:case 203:{const q=this.send([x.type,x.id],x.data);this.logger?.logOutgoing(q,x.id,1,p(x.type),x.data);return}}}send(x,q=void 0){const te=new g;return r(te,x),r(te,q),this.sendBuffer(te.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onRawMessage(x){const q=new E(x),te=t(q),Y=t(q),le=te[0];switch(le){case 100:return this.logger?.logIncoming(x.byteLength,te[1],1,`${v(le)}: ${te[2]}.${te[3]}`,Y),this.onPromise({type:le,id:te[1],channelName:te[2],name:te[3],arg:Y});case 102:return this.logger?.logIncoming(x.byteLength,te[1],1,`${v(le)}: ${te[2]}.${te[3]}`,Y),this.onEventListen({type:le,id:te[1],channelName:te[2],name:te[3],arg:Y});case 101:return this.logger?.logIncoming(x.byteLength,te[1],1,`${v(le)}`),this.disposeActiveRequest({type:le,id:te[1]});case 103:return this.logger?.logIncoming(x.byteLength,te[1],1,`${v(le)}`),this.disposeActiveRequest({type:le,id:te[1]})}}onPromise(x){const q=this.channels.get(x.channelName);if(!q){this.collectPendingRequest(x);return}const te=new T.CancellationTokenSource;let Y;try{Y=q.call(this.ctx,x.name,x.arg,te.token)}catch(ee){Y=Promise.reject(ee)}const le=x.id;Y.then(ee=>{this.sendResponse({id:le,data:ee,type:201}),this.activeRequests.delete(x.id)},ee=>{ee instanceof Error?this.sendResponse({id:le,data:{message:ee.message,name:ee.name,stack:ee.stack?ee.stack.split?ee.stack.split(`
`):ee.stack:void 0},type:202}):this.sendResponse({id:le,data:ee,type:203}),this.activeRequests.delete(x.id)});const pe=(0,I.toDisposable)(()=>te.cancel());this.activeRequests.set(x.id,pe)}onEventListen(x){const q=this.channels.get(x.channelName);if(!q){this.collectPendingRequest(x);return}const te=x.id,le=q.listen(this.ctx,x.name,x.arg)(pe=>this.sendResponse({id:te,data:pe,type:204}));this.activeRequests.set(x.id,le)}disposeActiveRequest(x){const q=this.activeRequests.get(x.id);q&&(q.dispose(),this.activeRequests.delete(x.id))}collectPendingRequest(x){let q=this.pendingRequests.get(x.channelName);q||(q=[],this.pendingRequests.set(x.channelName,q));const te=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.sendResponse({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:x,timeoutTimer:te})}flushPendingRequests(x){const q=this.pendingRequests.get(x);if(q){for(const te of q)switch(clearTimeout(te.timeoutTimer),te.request.type){case 100:this.onPromise(te.request);break;case 102:this.onEventListen(te.request);break}this.pendingRequests.delete(x)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=s;var l;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));class h{constructor(x,q=null){this.protocol=x,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(te=>this.onBuffer(te)),this.logger=q}getChannel(x){const q=this;return{call(te,Y,le){return q.isDisposed?Promise.reject(y.canceled()):q.requestPromise(x,te,Y,le)},listen(te,Y){return q.isDisposed?b.Event.None:q.requestEvent(x,te,Y)}}}requestPromise(x,q,te,Y=T.CancellationToken.None){const le=this.lastRequestId++,ee={id:le,type:100,channelName:x,name:q,arg:te};if(Y.isCancellationRequested)return Promise.reject(y.canceled());let ge;return new Promise((Pe,Ne)=>{if(Y.isCancellationRequested)return Ne(y.canceled());const ve=()=>{const re=me=>{switch(me.type){case 201:this.handlers.delete(le),Pe(me.data);break;case 202:{this.handlers.delete(le);const Z=new Error(me.data.message);Z.stack=me.data.stack,Z.name=me.data.name,Ne(Z);break}case 203:this.handlers.delete(le),Ne(me.data);break}};this.handlers.set(le,re),this.sendRequest(ee)};let ue=null;this.state===f.Idle?ve():(ue=(0,n.createCancelablePromise)(re=>this.whenInitialized()),ue.then(()=>{ue=null,ve()}));const de=()=>{ue?(ue.cancel(),ue=null):this.sendRequest({id:le,type:101}),Ne(y.canceled())},we=Y.onCancellationRequested(de);ge=(0,I.combinedDisposable)((0,I.toDisposable)(de),we),this.activeRequests.add(ge)}).finally(()=>{this.activeRequests.delete(ge)})}requestEvent(x,q,te){const Y=this.lastRequestId++,pe={id:Y,type:102,channelName:x,name:q,arg:te};let ee=null;const ge=new b.Emitter({onFirstListenerAdd:()=>{ee=(0,n.createCancelablePromise)(Pe=>this.whenInitialized()),ee.then(()=>{ee=null,this.activeRequests.add(ge),this.sendRequest(pe)})},onLastListenerRemove:()=>{ee?(ee.cancel(),ee=null):(this.activeRequests.delete(ge),this.sendRequest({id:Y,type:103}))}}),Ee=Pe=>ge.fire(Pe.data);return this.handlers.set(Y,Ee),ge.event}sendRequest(x){switch(x.type){case 100:case 102:{const q=this.send([x.type,x.id,x.channelName,x.name],x.arg);this.logger?.logOutgoing(q,x.id,0,`${v(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const q=this.send([x.type,x.id]);this.logger?.logOutgoing(q,x.id,0,v(x.type));return}}}send(x,q=void 0){const te=new g;return r(te,x),r(te,q),this.sendBuffer(te.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onBuffer(x){const q=new E(x),te=t(q),Y=t(q),le=te[0];switch(le){case 200:return this.logger?.logIncoming(x.byteLength,0,0,p(le)),this.onResponse({type:te[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(x.byteLength,te[1],0,p(le),Y),this.onResponse({type:te[0],id:te[1],data:Y})}}onResponse(x){if(x.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}this.handlers.get(x.id)?.(x)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}je([C.memoize],h.prototype,"onDidInitializePromise",null),e.ChannelClient=h;class S{constructor(x){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,x(({protocol:q,onDidClientDisconnect:te})=>{b.Event.once(q.onMessage)(le=>{const pe=new E(le),ee=t(pe),ge=new s(q,ee),Ee=new h(q);this.channels.forEach((Ne,ve)=>ge.registerChannel(ve,Ne));const Pe={channelServer:ge,channelClient:Ee,ctx:ee};this._connections.add(Pe),this._onDidAddConnection.fire(Pe),te(()=>{ge.dispose(),Ee.dispose(),this._connections.delete(Pe),this._onDidRemoveConnection.fire(Pe)})})})}get connections(){const x=[];return this._connections.forEach(q=>x.push(q)),x}getChannel(x,q){const te=this;return{call(Y,le,pe){let ee;if((0,_.isFunction)(q)){const Ee=(0,u.getRandomElement)(te.connections.filter(q));ee=Ee?Promise.resolve(Ee):b.Event.toPromise(b.Event.filter(te.onDidAddConnection,q))}else ee=q.routeCall(te,Y,le);const ge=ee.then(Ee=>Ee.channelClient.getChannel(x));return F(ge).call(Y,le,pe)},listen(Y,le){if((0,_.isFunction)(q))return te.getMulticastEvent(x,q,Y,le);const pe=q.routeEvent(te,Y,le).then(ee=>ee.channelClient.getChannel(x));return F(pe).listen(Y,le)}}}getMulticastEvent(x,q,te,Y){const le=this;let pe=new I.DisposableStore;const ee=new b.Emitter({onFirstListenerAdd:()=>{pe=new I.DisposableStore;const ge=new b.EventMultiplexer,Ee=new Map,Pe=ve=>{const de=ve.channelClient.getChannel(x).listen(te,Y),we=ge.add(de);Ee.set(ve,we)},Ne=ve=>{const ue=Ee.get(ve);!ue||(ue.dispose(),Ee.delete(ve))};le.connections.filter(q).forEach(Pe),b.Event.filter(le.onDidAddConnection,q)(Pe,void 0,pe),le.onDidRemoveConnection(Ne,void 0,pe),ge.event(ee.fire,ee,pe),pe.add(ge)},onLastListenerRemove:()=>{pe.dispose()}});return ee.event}registerChannel(x,q){this.channels.set(x,q),this._connections.forEach(te=>{te.channelServer.registerChannel(x,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=S;class L{constructor(x,q,te=null){const Y=new g;r(Y,q),x.send(Y.buffer),this.channelClient=new h(x,te),this.channelServer=new s(x,q,te)}getChannel(x){return this.channelClient.getChannel(x)}registerChannel(x,q){this.channelServer.registerChannel(x,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=L;function F(V){return{call(x,q,te){return V.then(Y=>Y.call(x,q,te))},listen(x,q){const te=new b.Relay;return V.then(Y=>te.input=Y.listen(x,q)),te.event}}}e.getDelayedChannel=F;function M(V){let x=!1;return{call(q,te,Y){return x?V.call(q,te,Y):(0,n.timeout)(0).then(()=>x=!0).then(()=>V.call(q,te,Y))},listen(q,te){if(x)return V.listen(q,te);const Y=new b.Relay;return(0,n.timeout)(0).then(()=>x=!0).then(()=>Y.input=V.listen(q,te)),Y.event}}}e.getNextTickChannel=M;class A{constructor(x){this.fn=x}routeCall(x){return this.route(x)}routeEvent(x){return this.route(x)}async route(x){for(const q of x.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await b.Event.toPromise(x.onDidAddConnection),await this.route(x)}}e.StaticRouter=A;var B;(function(V){function x(le,pe){const ee=le,ge=pe&&pe.disableMarshalling,Ee=new Map;for(const Pe in ee)te(Pe)&&Ee.set(Pe,b.Event.buffer(ee[Pe],!0));return new class{listen(Pe,Ne,ve){const ue=Ee.get(Ne);if(ue)return ue;if(Y(Ne)){const de=ee[Ne];if(typeof de=="function")return de.call(ee,ve)}throw new Error(`Event not found: ${Ne}`)}call(Pe,Ne,ve){const ue=ee[Ne];if(typeof ue=="function"){if(!ge&&Array.isArray(ve))for(let de=0;de<ve.length;de++)ve[de]=(0,R.revive)(ve[de]);return ue.apply(ee,ve)}throw new Error(`Method not found: ${Ne}`)}}}V.fromService=x;function q(le,pe){const ee=pe&&pe.disableMarshalling;return new Proxy({},{get(ge,Ee){if(typeof Ee=="string")return pe?.properties?.has(Ee)?pe.properties.get(Ee):Y(Ee)?function(Pe){return le.listen(Ee,Pe)}:te(Ee)?le.listen(Ee):async function(...Pe){let Ne;pe&&!(0,_.isUndefinedOrNull)(pe.context)?Ne=[pe.context,...Pe]:Ne=Pe;const ve=await le.call(Ee,Ne);return ee?ve:(0,R.revive)(ve)};throw new Error(`Property not found: ${String(Ee)}`)}})}V.toService=q;function te(le){return le[0]==="o"&&le[1]==="n"&&k.isUpperAsciiLetter(le.charCodeAt(2))}function Y(le){return/^onDynamic/.test(le)&&k.isUpperAsciiLetter(le.charCodeAt(9))}})(B=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const x=V.toString();if(x!=="[object Object]")return x}return V}function X(V){return Array.isArray(V)?V.map(U):U(V)}function z(V,x,q,te,Y,le,pe){pe=X(pe);const ee=$[Y],ge=ee[te%ee.length];let Ee=[`%c[${V}]%c[${String(x).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(te).padStart(5," ")} - ${le}`,"color: darkgreen","color: grey","color: grey",`color: ${ge}`];/\($/.test(le)?(Ee=Ee.concat(pe),Ee.push(")")):Ee.push(pe),console.log.apply(console,Ee)}e.logWithColors=z;class N{constructor(x,q){this._outgoingPrefix=x,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(x,q,te,Y,le){this._totalOutgoing+=x,z(this._outgoingPrefix,this._totalOutgoing,x,q,te,Y,le)}logIncoming(x,q,te,Y,le){this._totalIncoming+=x,z(this._incomingPrefix,this._totalIncoming,x,q,te,Y,le)}}e.IPCLogger=N}),define(Ie[111],ke([0,1,23,3,6,110]),function(J,e,u,n,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(o){o.Created="created",o.Read="read",o.Write="write",o.Open="open",o.Error="error",o.Close="close",o.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",o.NodeEndReceived="nodeEndReceived",o.NodeEndSent="nodeEndSent",o.NodeDrainBegin="nodeDrainBegin",o.NodeDrainEnd="nodeDrainEnd",o.zlibInflateError="zlibInflateError",o.zlibInflateData="zlibInflateData",o.zlibInflateInitialWrite="zlibInflateInitialWrite",o.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",o.zlibInflateWrite="zlibInflateWrite",o.zlibInflateFlushFired="zlibInflateFlushFired",o.zlibDeflateError="zlibDeflateError",o.zlibDeflateData="zlibDeflateData",o.zlibDeflateWrite="zlibDeflateWrite",o.zlibDeflateFlushFired="zlibDeflateFlushFired",o.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",o.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",o.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",o.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",o.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",o.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",o.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",o.ProtocolHeaderRead="protocolHeaderRead",o.ProtocolMessageRead="protocolMessageRead",o.ProtocolHeaderWrite="protocolHeaderWrite",o.ProtocolMessageWrite="protocolMessageWrite",o.ProtocolWrite="protocolWrite"})(C=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var y;(function(o){o.enableDiagnostics=!1,o.records=[];const r=new WeakMap;let t=0;function s(h,S){if(!r.has(h)){const L=String(++t);r.set(h,L)}return r.get(h)}function l(h,S,L,F){if(!o.enableDiagnostics)return;const M=s(h,S);if(F instanceof u.VSBuffer||F instanceof Uint8Array||F instanceof ArrayBuffer||ArrayBuffer.isView(F)){const A=u.VSBuffer.alloc(F.byteLength);A.set(F),o.records.push({timestamp:Date.now(),id:M,label:S,type:L,buff:A})}else o.records.push({timestamp:Date.now(),id:M,label:S,type:L,data:F})}o.traceSocketEvent=l})(y=e.SocketDiagnostics||(e.SocketDiagnostics={}));var b;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function R(){return I||(I=u.VSBuffer.alloc(0)),I}class k{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,t){if(r===0)return R();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const S=this._chunks[0];return t&&(this._chunks.shift(),this._totalLength-=r),S}if(this._chunks[0].byteLength>r){const S=this._chunks[0].slice(0,r);return t&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),S}const s=u.VSBuffer.alloc(r);let l=0,h=0;for(;r>0;){const S=this._chunks[h];if(S.byteLength>r){const L=S.slice(0,r);s.set(L,l),l+=r,t&&(this._chunks[h]=S.slice(r),this._totalLength-=r),r-=r}else s.set(S,l),l+=S.byteLength,t?(this._chunks.shift(),this._totalLength-=S.byteLength):h++,r-=S.byteLength}return s}}e.ChunkStream=k;var _;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest",o[o.Pause=7]="Pause",o[o.Resume=8]="Resume"})(_||(_={}));function P(o){switch(o){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var v;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.TimeoutTime=2e4]="TimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class w{constructor(r,t,s,l){this.type=r,this.id=t,this.ack=s,this.data=l,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends D.Disposable{constructor(r){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(t=>this.acceptChunk(t))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const t=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=t.readUInt32BE(9),this._state.messageType=t.readUInt8(0),this._state.id=t.readUInt32BE(1),this._state.ack=t.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:P(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const s=this._state.messageType,l=this._state.id,h=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",t),this._onMessage.fire(new w(s,l,h,t)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class f{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const t=u.VSBuffer.alloc(13);t.writeUInt8(r.type,0),t.writeUInt32BE(r.id,1),t.writeUInt32BE(r.ack,5),t.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:P(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(t,r.data)}_bufferAdd(r,t){const s=this._totalLength===0;return this._data.push(r,t),this._totalLength+=r.byteLength+t.byteLength,s}_bufferTake(){const r=u.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,t){this._bufferAdd(r,t)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class E extends D.Disposable{constructor(r){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new f(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(t=>{t.type===1&&this._onMessage.fire(t.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new w(1,0,0,r))}}e.Protocol=E;class g extends T.IPCClient{constructor(r,t,s=null){super(r,t,s);this.protocol=r}static fromSocket(r,t){return new g(new E(r),t)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=g;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class m{constructor(r){this.data=r,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){const r=[];let t=0,s=this._first;for(;s;)r[t++]=s.data,s=s.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const t=new m(r);if(!this._first){this._first=t,this._last=t;return}this._last.next=t,this._last=t}}class d{constructor(){this.lastRuns=[];const r=Date.now();for(let t=0;t<d._HISTORY_LENGTH;t++)this.lastRuns[t]=r-1e3*t;setInterval(()=>{for(let t=d._HISTORY_LENGTH;t>=1;t--)this.lastRuns[t]=this.lastRuns[t-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return d._INSTANCE||(d._INSTANCE=new d),d._INSTANCE}load(){const r=Date.now(),t=(1+d._HISTORY_LENGTH)*1e3;let s=0;for(let l=0;l<d._HISTORY_LENGTH;l++)r-this.lastRuns[l]<=t&&s++;return 1-s/d._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}d._HISTORY_LENGTH=10,d._INSTANCE=null;class i{constructor(r,t=null,s=d.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=s,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),t&&this._socketReader.acceptChunk(t)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new w(5,0,0,R());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new w(7,0,0,R());this._socketWriter.write(r)}sendResume(){const r=new w(8,0,0,R());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,t){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(s=>this._receiveMessage(s))),this._socketDisposables.push(this._socket.onClose(s=>this._onSocketClose.fire(s))),this._socketReader.acceptChunk(t)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new w(3,0,this._incomingAckId,R());this._socketWriter.write(r);const t=this._outgoingUnackMsg.toArray();for(let s=0,l=t.length;s<l;s++)this._socketWriter.write(t[s]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const t=this._outgoingUnackMsg.peek();if(t&&t.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const t=Date.now();t-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=t,this._socketWriter.write(new w(6,0,0,R())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const t=this._outgoingUnackMsg.toArray();for(let s=0,l=t.length;s<l;s++)this._socketWriter.write(t[s]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const t=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const s=new w(1,t,this._incomingAckId,r);this._outgoingUnackMsg.push(s),this._isReconnecting||(this._socketWriter.write(s),this._recvAckCheck())}sendControl(r){const t=new w(2,0,0,r);this._socketWriter.write(t)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),t=Date.now()-r.writtenTime,s=Date.now()-this._socketReader.lastReadTime,l=Date.now()-this._lastSocketTimeoutTime;if(t>=2e4&&s>=2e4&&l>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const h=Math.max(2e4-t,2e4-s,2e4-l,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},h)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new w(3,0,this._incomingAckId,R());this._socketWriter.write(r)}}e.PersistentProtocol=i}),define(Ie[112],ke([0,1,23,12,3,6,9,13,34,110,111]),function(J,e,u,n,D,T,C,y,b,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function k(){return{crypto:J.__$__nodeRequire("crypto"),zlib:J.__$__nodeRequire("zlib"),net:J.__$__nodeRequire("net"),os:J.__$__nodeRequire("os")}}class _{constructor(s,l=""){this.debugLabel=l,this.socket=s,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=h=>{if(this.traceSocketEvent("error",{code:h?.code,message:h?.message}),h){if(h.code==="EPIPE")return;(0,n.onUnexpectedError)(h)}},this.socket.on("error",this._errorListener)}traceSocketEvent(s,l){R.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,s,l)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(s){const l=h=>{this.traceSocketEvent("read",h),s(u.VSBuffer.wrap(h))};return this.socket.on("data",l),{dispose:()=>this.socket.off("data",l)}}onClose(s){const l=h=>{this.traceSocketEvent("close",{hadError:h}),s({type:0,hadError:h,error:void 0})};return this.socket.on("close",l),{dispose:()=>this.socket.off("close",l)}}onEnd(s){const l=()=>{this.traceSocketEvent("nodeEndReceived"),s()};return this.socket.on("end",l),{dispose:()=>this.socket.off("end",l)}}write(s){if(!this.socket.destroyed)try{this.traceSocketEvent("write",s),this.socket.write(s.buffer,l=>{if(l){if(l.code==="EPIPE")return;(0,n.onUnexpectedError)(l)}})}catch(l){if(l.code==="EPIPE")return;(0,n.onUnexpectedError)(l)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((s,l)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),s();return}const h=()=>{this.socket.off("close",h),this.socket.off("end",h),this.socket.off("error",h),this.socket.off("timeout",h),this.socket.off("drain",h),this.traceSocketEvent("nodeDrainEnd"),s()};this.socket.on("close",h),this.socket.on("end",h),this.socket.on("error",h),this.socket.on("timeout",h),this.socket.on("drain",h)})}}e.NodeSocket=_;var P;(function(t){t[t.MinHeaderByteSize=2]="MinHeaderByteSize"})(P||(P={}));var v;(function(t){t[t.PeekHeader=1]="PeekHeader",t[t.ReadHeader=2]="ReadHeader",t[t.ReadBody=3]="ReadBody",t[t.Fin=4]="Fin"})(v||(v={}));class w extends T.Disposable{constructor(s,l,h,S){super();this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=s,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:l,inflateBytesLength:h?.byteLength||0,recordInflateBytes:S}),this._flowManager=this._register(new p(this,l,h,S,this._onData,(L,F)=>this._write(L,F))),this._register(this._flowManager.onError(L=>{console.error(L),(0,n.onUnexpectedError)(L),this._onClose.fire({type:0,hadError:!0,error:L})})),this._incomingData=new R.ChunkStream,this._register(this.socket.onData(L=>this._acceptChunk(L))),this._register(this.socket.onClose(L=>this._onClose.fire(L)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(s,l){this.socket.traceSocketEvent(s,l)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(s){return this._onData.event(s)}onClose(s){return this._onClose.event(s)}onEnd(s){return this.socket.onEnd(s)}write(s){this._flowManager.writeMessage(s)}_write(s,l){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",s);let h=2;s.byteLength<126?h+=0:s.byteLength<2**16?h+=2:h+=8;const S=u.VSBuffer.alloc(h);if(l?S.writeUInt8(194,0):S.writeUInt8(130,0),s.byteLength<126)S.writeUInt8(s.byteLength,1);else if(s.byteLength<2**16){S.writeUInt8(126,1);let L=1;S.writeUInt8(s.byteLength>>>8&255,++L),S.writeUInt8(s.byteLength>>>0&255,++L)}else{S.writeUInt8(127,1);let L=1;S.writeUInt8(0,++L),S.writeUInt8(0,++L),S.writeUInt8(0,++L),S.writeUInt8(0,++L),S.writeUInt8(s.byteLength>>>24&255,++L),S.writeUInt8(s.byteLength>>>16&255,++L),S.writeUInt8(s.byteLength>>>8&255,++L),S.writeUInt8(s.byteLength>>>0&255,++L)}this.socket.write(u.VSBuffer.concat([S,s]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(s){if(s.byteLength!==0){for(this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const l=this._incomingData.peek(this._state.readLen),h=l.readUInt8(0),S=(h&128)>>>7,L=(h&64)>>>6,F=l.readUInt8(1),M=(F&128)>>>7,A=F&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(A===126?2:0)+(A===127?8:0),this._state.fin=S,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(L)),this._state.firstFrameOfMessage=Boolean(S),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const l=this._incomingData.read(this._state.readLen),h=l.readUInt8(1),S=(h&128)>>>7;let L=h&127,F=1;L===126?L=l.readUInt8(++F)*2**8+l.readUInt8(++F):L===127&&(L=l.readUInt8(++F)*0+l.readUInt8(++F)*0+l.readUInt8(++F)*0+l.readUInt8(++F)*0+l.readUInt8(++F)*2**24+l.readUInt8(++F)*2**16+l.readUInt8(++F)*2**8+l.readUInt8(++F));let M=0;S&&(M=l.readUInt8(++F)*2**24+l.readUInt8(++F)*2**16+l.readUInt8(++F)*2**8+l.readUInt8(++F)),this._state.state=3,this._state.readLen=L,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const l=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",l),g(l,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",l),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(l,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class p extends T.Disposable{constructor(s,l,h,S,L,F){super();this._tracer=s,this._onData=L,this._writeFn=F,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,l?(this._zlibInflateStream=this._register(new f(this._tracer,S,h,{windowBits:15})),this._zlibDeflateStream=this._register(new E(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:u.VSBuffer.alloc(0)}writeMessage(s){this._writeQueue.push(s),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const s=this._writeQueue.shift();if(this._zlibDeflateStream){const l=await this._deflateMessage(this._zlibDeflateStream,s);this._writeFn(l,!0)}else this._writeFn(s,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(s,l){return new Promise((h,S)=>{s.write(l),s.flush(L=>h(L))})}acceptFrame(s,l,h){this._readQueue.push({data:s,isCompressed:l,isLastFrameOfMessage:h}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const s=this._readQueue.shift();if(this._zlibInflateStream&&s.isCompressed){const l=await this._inflateFrame(this._zlibInflateStream,s.data,s.isLastFrameOfMessage);this._onData.fire(l)}else this._onData.fire(s.data)}this._isProcessingReadQueue=!1}}_inflateFrame(s,l,h){return new Promise((S,L)=>{s.write(l),h&&s.write(u.VSBuffer.fromByteArray([0,0,255,255])),s.flush(F=>S(F))})}}class f extends T.Disposable{constructor(s,l,h,S){super();this._tracer=s,this._recordInflateBytes=l,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=k().zlib.createInflateRaw(S),this._zlibInflate.on("error",L=>{this._tracer.traceSocketEvent("zlibInflateError",{message:L?.message,code:L?.code}),this._onError.fire(L)}),this._zlibInflate.on("data",L=>{this._tracer.traceSocketEvent("zlibInflateData",L),this._pendingInflateData.push(u.VSBuffer.wrap(L))}),h&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",h.buffer),this._zlibInflate.write(h.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?u.VSBuffer.concat(this._recordedInflateBytes):u.VSBuffer.alloc(0)}write(s){this._recordInflateBytes&&this._recordedInflateBytes.push(s.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",s),this._zlibInflate.write(s.buffer)}flush(s){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const l=u.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,s(l)})}}class E extends T.Disposable{constructor(s,l){super();this._tracer=s,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=k().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",h=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:h?.message,code:h?.code}),this._onError.fire(h)}),this._zlibDeflate.on("data",h=>{this._tracer.traceSocketEvent("zlibDeflateData",h),this._pendingDeflateData.push(u.VSBuffer.wrap(h))})}write(s){this._tracer.traceSocketEvent("zlibDeflateWrite",s.buffer),this._zlibDeflate.write(s.buffer)}flush(s){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let l=u.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,l=l.slice(0,l.byteLength-4),s(l)})}}function g(t,s){if(s===0)return;const l=t.byteLength>>>2;for(let A=0;A<l;A++){const B=t.readUInt32BE(A*4);t.writeUInt32BE(B^s,A*4)}const h=l*4,S=t.byteLength-h,L=s>>>24&255,F=s>>>16&255,M=s>>>8&255;S>=1&&t.writeUInt8(t.readUInt8(h)^L,h),S>=2&&t.writeUInt8(t.readUInt8(h+1)^F,h+1),S>=3&&t.writeUInt8(t.readUInt8(h+2)^M,h+2)}e.XDG_RUNTIME_DIR=typeof process!="undefined"?process.env.XDG_RUNTIME_DIR:void 0;const c={[2]:107,[1]:103};function m(){const t=(0,b.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${t}-sock`;let s;return e.XDG_RUNTIME_DIR?s=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${t}.sock`):s=(0,C.join)(k().os.tmpdir(),`vscode-ipc-${t}.sock`),d(s),s}e.createRandomIPCHandle=m;function a(t,s,l){const h=k().crypto.createHash("md5").update(t).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${h}-${l}-${s}-sock`;let S;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?S=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${h.substr(0,8)}-${l}-${s}.sock`):S=(0,C.join)(t,`${l}-${s}.sock`),d(S),S}e.createStaticIPCHandle=a;function d(t){const s=c[y.platform];typeof s=="number"&&t.length>=s&&console.warn(`WARNING: IPC handle "${t}" is longer than ${s} chars, try a shorter --user-data-dir`)}class i extends I.IPCServer{constructor(s){super(i.toClientConnectionEvent(s));this.server=s}static toClientConnectionEvent(s){const l=D.Event.fromNodeEventEmitter(s,"connection");return D.Event.map(l,h=>({protocol:new R.Protocol(new _(h,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(h,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function o(t){return new Promise((s,l)=>{const h=k().net.createServer();h.on("error",l),h.listen(t,()=>{h.removeListener("error",l),s(new i(h))})})}e.serve=o;function r(t,s){return new Promise((l,h)=>{const S=k().net.createConnection(t,()=>{S.removeListener("error",h),l(R.Client.fromSocket(new _(S,`ipc-client${s}`),s))});S.once("error",h)})}e.connect=r}),define(Ie[157],ke([0,1,37,9]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(T,C,y,b,I,R){if(Array.isArray(T)){let k=0;for(const _ of T){const P=D(_,C,y,b,I,R);if(P===10)return P;P>k&&(k=P)}return k}else{if(typeof T=="string")return b?T==="*"?5:T===y?10:0:0;if(T){const{language:k,pattern:_,scheme:P,hasAccessToAllModels:v,notebookType:w}=T;if(!b&&!v)return 0;w&&I&&(C=I);let p=0;if(P)if(P===C.scheme)p=10;else if(P==="*")p=5;else return 0;if(k)if(k===y)p=10;else if(k==="*")p=Math.max(p,5);else return 0;if(w)if(w===R)p=10;else if(w==="*"&&R!==void 0)p=Math.max(p,5);else return 0;if(_){let f;if(typeof _=="string"?f=_:f={..._,base:(0,n.normalize)(_.base)},f===C.fsPath||(0,u.match)(f,C.fsPath))p=10;else return 0}return p}else return 0}}e.score=D}),define(Ie[158],ke([0,1,8,48,150]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(y,b,I,R){this._uri=y,this._lines=b,this._eol=I,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(y){y.eol&&y.eol!==this._eol&&(this._eol=y.eol,this._lineStarts=null);const b=y.changes;for(const I of b)this._acceptDeleteRange(I.range),this._acceptInsertText(new n.Position(I.range.startLineNumber,I.range.startColumn),I.text);this._versionId=y.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const y=this._eol.length,b=this._lines.length,I=new Uint32Array(b);for(let R=0;R<b;R++)I[R]=this._lines[R].length+y;this._lineStarts=new D.PrefixSumComputer(I)}}_setLineText(y,b){this._lines[y]=b,this._lineStarts&&this._lineStarts.setValue(y,this._lines[y].length+this._eol.length)}_acceptDeleteRange(y){if(y.startLineNumber===y.endLineNumber){if(y.startColumn===y.endColumn)return;this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.startLineNumber-1].substring(y.endColumn-1));return}this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.endLineNumber-1].substring(y.endColumn-1)),this._lines.splice(y.startLineNumber,y.endLineNumber-y.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(y.startLineNumber,y.endLineNumber-y.startLineNumber)}_acceptInsertText(y,b){if(b.length===0)return;const I=(0,u.splitLines)(b);if(I.length===1){this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+I[0]+this._lines[y.lineNumber-1].substring(y.column-1));return}I[I.length-1]+=this._lines[y.lineNumber-1].substring(y.column-1),this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+I[0]);const R=new Uint32Array(I.length-1);for(let k=1;k<I.length;k++)this._lines.splice(y.lineNumber+k-1,0,I[k]),R[k-1]=I[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(y.lineNumber,R)}}e.MirrorTextModel=T}),define(Ie[159],ke([0,1,8,147,48,35,100]),function(J,e,u,n,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const y=999;class b{constructor(E,g,c,m){this.searchString=E,this.isRegex=g,this.matchCase=c,this.wordSeparators=m}parseSearchRequest(){if(this.searchString==="")return null;let E;this.isRegex?E=I(this.searchString):E=this.searchString.indexOf(`
`)>=0;let g=null;try{g=u.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:E,global:!0,unicode:!0})}catch{return null}if(!g)return null;let c=!this.isRegex&&!E;return c&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(c=this.matchCase),new C.SearchData(g,this.wordSeparators?(0,n.getMapForWordSeparators)(this.wordSeparators):null,c?this.searchString:null)}}e.SearchParams=b;function I(f){if(!f||f.length===0)return!1;for(let E=0,g=f.length;E<g;E++){const c=f.charCodeAt(E);if(c===10)return!0;if(c===92){if(E++,E>=g)break;const m=f.charCodeAt(E);if(m===110||m===114||m===87)return!0}}return!1}e.isMultilineRegexSource=I;function R(f,E,g){if(!g)return new C.FindMatch(f,null);const c=[];for(let m=0,a=E.length;m<a;m++)c[m]=E[m];return new C.FindMatch(f,c)}e.createFindMatch=R;class k{constructor(E){const g=[];let c=0;for(let m=0,a=E.length;m<a;m++)E.charCodeAt(m)===10&&(g[c++]=m);this._lineFeedsOffsets=g}findLineFeedCountBeforeOffset(E){const g=this._lineFeedsOffsets;let c=0,m=g.length-1;if(m===-1||E<=g[0])return 0;for(;c<m;){const a=c+((m-c)/2>>0);g[a]>=E?m=a-1:g[a+1]>=E?(c=a,m=a):c=a+1}return c+1}}class _{static findMatches(E,g,c,m,a){const d=g.parseSearchRequest();return d?d.regex.multiline?this._doFindMatchesMultiline(E,c,new p(d.wordSeparators,d.regex),m,a):this._doFindMatchesLineByLine(E,c,d,m,a):[]}static _getMultilineMatchRange(E,g,c,m,a,d){let i,o=0;m?(o=m.findLineFeedCountBeforeOffset(a),i=g+a+o):i=g+a;let r;if(m){const h=m.findLineFeedCountBeforeOffset(a+d.length)-o;r=i+d.length+h}else r=i+d.length;const t=E.getPositionAt(i),s=E.getPositionAt(r);return new T.Range(t.lineNumber,t.column,s.lineNumber,s.column)}static _doFindMatchesMultiline(E,g,c,m,a){const d=E.getOffsetAt(g.getStartPosition()),i=E.getValueInRange(g,1),o=E.getEOL()===`\r
`?new k(i):null,r=[];let t=0,s;for(c.reset(0);s=c.next(i);)if(r[t++]=R(this._getMultilineMatchRange(E,d,i,o,s.index,s[0]),s,m),t>=a)return r;return r}static _doFindMatchesLineByLine(E,g,c,m,a){const d=[];let i=0;if(g.startLineNumber===g.endLineNumber){const r=E.getLineContent(g.startLineNumber).substring(g.startColumn-1,g.endColumn-1);return i=this._findMatchesInLine(c,r,g.startLineNumber,g.startColumn-1,i,d,m,a),d}const o=E.getLineContent(g.startLineNumber).substring(g.startColumn-1);i=this._findMatchesInLine(c,o,g.startLineNumber,g.startColumn-1,i,d,m,a);for(let r=g.startLineNumber+1;r<g.endLineNumber&&i<a;r++)i=this._findMatchesInLine(c,E.getLineContent(r),r,0,i,d,m,a);if(i<a){const r=E.getLineContent(g.endLineNumber).substring(0,g.endColumn-1);i=this._findMatchesInLine(c,r,g.endLineNumber,0,i,d,m,a)}return d}static _findMatchesInLine(E,g,c,m,a,d,i,o){const r=E.wordSeparators;if(!i&&E.simpleSearch){const l=E.simpleSearch,h=l.length,S=g.length;let L=-h;for(;(L=g.indexOf(l,L+h))!==-1;)if((!r||w(r,g,S,L,h))&&(d[a++]=new C.FindMatch(new T.Range(c,L+1+m,c,L+1+h+m),null),a>=o))return a;return a}const t=new p(E.wordSeparators,E.regex);let s;t.reset(0);do if(s=t.next(g),s&&(d[a++]=R(new T.Range(c,s.index+1+m,c,s.index+1+s[0].length+m),s,i),a>=o))return a;while(s);return a}static findNextMatch(E,g,c,m){const a=g.parseSearchRequest();if(!a)return null;const d=new p(a.wordSeparators,a.regex);return a.regex.multiline?this._doFindNextMatchMultiline(E,c,d,m):this._doFindNextMatchLineByLine(E,c,d,m)}static _doFindNextMatchMultiline(E,g,c,m){const a=new D.Position(g.lineNumber,1),d=E.getOffsetAt(a),i=E.getLineCount(),o=E.getValueInRange(new T.Range(a.lineNumber,a.column,i,E.getLineMaxColumn(i)),1),r=E.getEOL()===`\r
`?new k(o):null;c.reset(g.column-1);const t=c.next(o);return t?R(this._getMultilineMatchRange(E,d,o,r,t.index,t[0]),t,m):g.lineNumber!==1||g.column!==1?this._doFindNextMatchMultiline(E,new D.Position(1,1),c,m):null}static _doFindNextMatchLineByLine(E,g,c,m){const a=E.getLineCount(),d=g.lineNumber,i=E.getLineContent(d),o=this._findFirstMatchInLine(c,i,d,g.column,m);if(o)return o;for(let r=1;r<=a;r++){const t=(d+r-1)%a,s=E.getLineContent(t+1),l=this._findFirstMatchInLine(c,s,t+1,1,m);if(l)return l}return null}static _findFirstMatchInLine(E,g,c,m,a){E.reset(m-1);const d=E.next(g);return d?R(new T.Range(c,d.index+1,c,d.index+1+d[0].length),d,a):null}static findPreviousMatch(E,g,c,m){const a=g.parseSearchRequest();if(!a)return null;const d=new p(a.wordSeparators,a.regex);return a.regex.multiline?this._doFindPreviousMatchMultiline(E,c,d,m):this._doFindPreviousMatchLineByLine(E,c,d,m)}static _doFindPreviousMatchMultiline(E,g,c,m){const a=this._doFindMatchesMultiline(E,new T.Range(1,1,g.lineNumber,g.column),c,m,10*y);if(a.length>0)return a[a.length-1];const d=E.getLineCount();return g.lineNumber!==d||g.column!==E.getLineMaxColumn(d)?this._doFindPreviousMatchMultiline(E,new D.Position(d,E.getLineMaxColumn(d)),c,m):null}static _doFindPreviousMatchLineByLine(E,g,c,m){const a=E.getLineCount(),d=g.lineNumber,i=E.getLineContent(d).substring(0,g.column-1),o=this._findLastMatchInLine(c,i,d,m);if(o)return o;for(let r=1;r<=a;r++){const t=(a+d-r-1)%a,s=E.getLineContent(t+1),l=this._findLastMatchInLine(c,s,t+1,m);if(l)return l}return null}static _findLastMatchInLine(E,g,c,m){let a=null,d;for(E.reset(0);d=E.next(g);)a=R(new T.Range(c,d.index+1,c,d.index+1+d[0].length),d,m);return a}}e.TextModelSearch=_;function P(f,E,g,c,m){if(c===0)return!0;const a=E.charCodeAt(c-1);if(f.get(a)!==0||a===13||a===10)return!0;if(m>0){const d=E.charCodeAt(c);if(f.get(d)!==0)return!0}return!1}function v(f,E,g,c,m){if(c+m===g)return!0;const a=E.charCodeAt(c+m);if(f.get(a)!==0||a===13||a===10)return!0;if(m>0){const d=E.charCodeAt(c+m-1);if(f.get(d)!==0)return!0}return!1}function w(f,E,g,c,m){return P(f,E,g,c,m)&&v(f,E,g,c,m)}e.isValidMatch=w;class p{constructor(E,g){this._wordSeparators=E,this._searchRegex=g,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(E){this._searchRegex.lastIndex=E,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(E){const g=E.length;let c;do{if(this._prevMatchStartIndex+this._prevMatchLength===g||(c=this._searchRegex.exec(E),!c))return null;const m=c.index,a=c[0].length;if(m===this._prevMatchStartIndex&&a===this._prevMatchLength){if(a===0){u.getNextCodePoint(E,g,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=m,this._prevMatchLength=a,!this._wordSeparators||w(this._wordSeparators,E,g,m,a))return c}while(c);return null}}e.Searcher=p}),define(Ie[113],ke([0,1,23,13]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(D||(D={}));function T(k){for(let _=0,P=k.length;_<P;_+=4){const v=k[_+0],w=k[_+1],p=k[_+2],f=k[_+3];k[_+0]=f,k[_+1]=p,k[_+2]=w,k[_+3]=v}}function C(k){const _=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return n.isLittleEndian()||T(_),u.VSBuffer.wrap(_)}function y(k){const _=k.buffer;if(n.isLittleEndian()||T(_),_.byteOffset%4==0)return new Uint32Array(_.buffer,_.byteOffset,_.length/4);{const P=new Uint8Array(_.byteLength);return P.set(_),new Uint32Array(P.buffer,P.byteOffset,P.length/4)}}function b(k){const _=new Uint32Array(I(k));let P=0;if(_[P++]=k.id,k.type==="full")_[P++]=1,_[P++]=k.data.length,_.set(k.data,P),P+=k.data.length;else{_[P++]=2,_[P++]=k.deltas.length;for(const v of k.deltas)_[P++]=v.start,_[P++]=v.deleteCount,v.data?(_[P++]=v.data.length,_.set(v.data,P),P+=v.data.length):_[P++]=0}return C(_)}e.encodeSemanticTokensDto=b;function I(k){let _=0;if(_+=1+1,k.type==="full")_+=1+k.data.length;else{_+=1,_+=(1+1+1)*k.deltas.length;for(const P of k.deltas)P.data&&(_+=P.data.length)}return _}function R(k){const _=y(k);let P=0;const v=_[P++];if(_[P++]===1){const E=_[P++],g=_.subarray(P,P+E);return P+=E,{id:v,type:"full",data:g}}const p=_[P++],f=[];for(let E=0;E<p;E++){const g=_[P++],c=_[P++],m=_[P++];let a;m>0&&(a=_.subarray(P,P+m),P+=m),f[E]={start:g,deleteCount:c,data:a}}return{id:v,type:"delta",deltas:f}}e.decodeSemanticTokensDto=R}),define(Ie[160],ke([0,1,3,6]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class D{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new u.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,b){return this._map.set(y,b),this.fire([y]),(0,n.toDisposable)(()=>{this._map.get(y)===b&&(this._map.delete(y),this.fire([y]))})}registerFactory(y,b){this._factories.get(y)?.dispose();const I=new T(this,y,b);return this._factories.set(y,I),(0,n.toDisposable)(()=>{const R=this._factories.get(y);!R||R!==I||(this._factories.delete(y),R.dispose())})}async getOrCreate(y){const b=this.get(y);if(b)return b;const I=this._factories.get(y);return!I||I.isResolved?null:(await I.resolve(),this.get(y))}get(y){return this._map.get(y)||null}isResolved(y){if(this.get(y))return!0;const I=this._factories.get(y);return!!(!I||I.isResolved)}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=D;class T extends n.Disposable{constructor(y,b,I){super();this._registry=y,this._languageId=b,this._factory=I,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const y=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,y&&!this._isDisposed&&this._register(this._registry.register(this._languageId,y))}}}),define(Ie[64],ke([0,1,77,2,35,160]),function(J,e,u,n,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class C{constructor(h,S,L){this._tokenBrand=void 0,this.offset=h,this.type=S,this.language=L}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=C;class y{constructor(h,S){this._tokenizationResultBrand=void 0,this.tokens=h,this.endState=S}}e.TokenizationResult=y;class b{constructor(h,S){this._encodedTokenizationResultBrand=void 0,this.tokens=h,this.endState=S}}e.EncodedTokenizationResult=b;var I;(function(l){l[l.Method=0]="Method",l[l.Function=1]="Function",l[l.Constructor=2]="Constructor",l[l.Field=3]="Field",l[l.Variable=4]="Variable",l[l.Class=5]="Class",l[l.Struct=6]="Struct",l[l.Interface=7]="Interface",l[l.Module=8]="Module",l[l.Property=9]="Property",l[l.Event=10]="Event",l[l.Operator=11]="Operator",l[l.Unit=12]="Unit",l[l.Value=13]="Value",l[l.Constant=14]="Constant",l[l.Enum=15]="Enum",l[l.EnumMember=16]="EnumMember",l[l.Keyword=17]="Keyword",l[l.Text=18]="Text",l[l.Color=19]="Color",l[l.File=20]="File",l[l.Reference=21]="Reference",l[l.Customcolor=22]="Customcolor",l[l.Folder=23]="Folder",l[l.TypeParameter=24]="TypeParameter",l[l.User=25]="User",l[l.Issue=26]="Issue",l[l.Snippet=27]="Snippet"})(I=e.CompletionItemKind||(e.CompletionItemKind={}));var R;(function(l){const h=new Map;h.set(0,u.Codicon.symbolMethod),h.set(1,u.Codicon.symbolFunction),h.set(2,u.Codicon.symbolConstructor),h.set(3,u.Codicon.symbolField),h.set(4,u.Codicon.symbolVariable),h.set(5,u.Codicon.symbolClass),h.set(6,u.Codicon.symbolStruct),h.set(7,u.Codicon.symbolInterface),h.set(8,u.Codicon.symbolModule),h.set(9,u.Codicon.symbolProperty),h.set(10,u.Codicon.symbolEvent),h.set(11,u.Codicon.symbolOperator),h.set(12,u.Codicon.symbolUnit),h.set(13,u.Codicon.symbolValue),h.set(15,u.Codicon.symbolEnum),h.set(14,u.Codicon.symbolConstant),h.set(15,u.Codicon.symbolEnum),h.set(16,u.Codicon.symbolEnumMember),h.set(17,u.Codicon.symbolKeyword),h.set(27,u.Codicon.symbolSnippet),h.set(18,u.Codicon.symbolText),h.set(19,u.Codicon.symbolColor),h.set(20,u.Codicon.symbolFile),h.set(21,u.Codicon.symbolReference),h.set(22,u.Codicon.symbolCustomColor),h.set(23,u.Codicon.symbolFolder),h.set(24,u.Codicon.symbolTypeParameter),h.set(25,u.Codicon.account),h.set(26,u.Codicon.issues);function S(M){let A=h.get(M);return A||(console.info("No codicon found for CompletionItemKind "+M),A=u.Codicon.symbolProperty),A}l.toIcon=S;const L=new Map;L.set("method",0),L.set("function",1),L.set("constructor",2),L.set("field",3),L.set("variable",4),L.set("class",5),L.set("struct",6),L.set("interface",7),L.set("module",8),L.set("property",9),L.set("event",10),L.set("operator",11),L.set("unit",12),L.set("value",13),L.set("constant",14),L.set("enum",15),L.set("enum-member",16),L.set("enumMember",16),L.set("keyword",17),L.set("snippet",27),L.set("text",18),L.set("color",19),L.set("file",20),L.set("reference",21),L.set("customcolor",22),L.set("folder",23),L.set("type-parameter",24),L.set("typeParameter",24),L.set("account",25),L.set("issue",26);function F(M,A){let B=L.get(M);return typeof B=="undefined"&&!A&&(B=9),B}l.fromString=F})(R=e.CompletionItemKinds||(e.CompletionItemKinds={}));var k;(function(l){l[l.Deprecated=1]="Deprecated"})(k=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(l){l[l.KeepWhitespace=1]="KeepWhitespace",l[l.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var P;(function(l){l[l.Invoke=0]="Invoke",l[l.TriggerCharacter=1]="TriggerCharacter",l[l.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(P=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var v;(function(l){l[l.Automatic=0]="Automatic",l[l.Explicit=1]="Explicit"})(v=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var w;(function(l){l[l.Invoke=1]="Invoke",l[l.Auto=2]="Auto"})(w=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var p;(function(l){l[l.Invoke=1]="Invoke",l[l.TriggerCharacter=2]="TriggerCharacter",l[l.ContentChange=3]="ContentChange"})(p=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(l){l[l.Text=0]="Text",l[l.Read=1]="Read",l[l.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function E(l){return l&&n.URI.isUri(l.uri)&&D.Range.isIRange(l.range)&&(D.Range.isIRange(l.originSelectionRange)||D.Range.isIRange(l.targetSelectionRange))}e.isLocationLink=E;var g;(function(l){l[l.File=0]="File",l[l.Module=1]="Module",l[l.Namespace=2]="Namespace",l[l.Package=3]="Package",l[l.Class=4]="Class",l[l.Method=5]="Method",l[l.Property=6]="Property",l[l.Field=7]="Field",l[l.Constructor=8]="Constructor",l[l.Enum=9]="Enum",l[l.Interface=10]="Interface",l[l.Function=11]="Function",l[l.Variable=12]="Variable",l[l.Constant=13]="Constant",l[l.String=14]="String",l[l.Number=15]="Number",l[l.Boolean=16]="Boolean",l[l.Array=17]="Array",l[l.Object=18]="Object",l[l.Key=19]="Key",l[l.Null=20]="Null",l[l.EnumMember=21]="EnumMember",l[l.Struct=22]="Struct",l[l.Event=23]="Event",l[l.Operator=24]="Operator",l[l.TypeParameter=25]="TypeParameter"})(g=e.SymbolKind||(e.SymbolKind={}));var c;(function(l){l[l.Deprecated=1]="Deprecated"})(c=e.SymbolTag||(e.SymbolTag={}));var m;(function(l){const h=new Map;h.set(0,u.Codicon.symbolFile),h.set(1,u.Codicon.symbolModule),h.set(2,u.Codicon.symbolNamespace),h.set(3,u.Codicon.symbolPackage),h.set(4,u.Codicon.symbolClass),h.set(5,u.Codicon.symbolMethod),h.set(6,u.Codicon.symbolProperty),h.set(7,u.Codicon.symbolField),h.set(8,u.Codicon.symbolConstructor),h.set(9,u.Codicon.symbolEnum),h.set(10,u.Codicon.symbolInterface),h.set(11,u.Codicon.symbolFunction),h.set(12,u.Codicon.symbolVariable),h.set(13,u.Codicon.symbolConstant),h.set(14,u.Codicon.symbolString),h.set(15,u.Codicon.symbolNumber),h.set(16,u.Codicon.symbolBoolean),h.set(17,u.Codicon.symbolArray),h.set(18,u.Codicon.symbolObject),h.set(19,u.Codicon.symbolKey),h.set(20,u.Codicon.symbolNull),h.set(21,u.Codicon.symbolEnumMember),h.set(22,u.Codicon.symbolStruct),h.set(23,u.Codicon.symbolEvent),h.set(24,u.Codicon.symbolOperator),h.set(25,u.Codicon.symbolTypeParameter);function S(L){let F=h.get(L);return F||(console.info("No codicon found for SymbolKind "+L),F=u.Codicon.symbolProperty),F}l.toIcon=S})(m=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(h){this.value=h}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var d;(function(l){function h(S){return!S||typeof S!="object"?!1:typeof S.id=="string"&&typeof S.title=="string"}l.is=h})(d=e.Command||(e.Command={}));var i;(function(l){l[l.Collapsed=0]="Collapsed",l[l.Expanded=1]="Expanded"})(i=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var o;(function(l){l[l.Unresolved=0]="Unresolved",l[l.Resolved=1]="Resolved"})(o=e.CommentThreadState||(e.CommentThreadState={}));var r;(function(l){l[l.Editing=0]="Editing",l[l.Preview=1]="Preview"})(r=e.CommentMode||(e.CommentMode={}));var t;(function(l){l[l.Type=1]="Type",l[l.Parameter=2]="Parameter"})(t=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new T.TokenizationRegistry;var s;(function(l){l[l.None=0]="None",l[l.Option=1]="Option",l[l.Default=2]="Default",l[l.Preferred=3]="Preferred"})(s=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ie[161],ke([19,20]),function(J,e){return J.create("vs/base/node/processes",e)}),define(Ie[114],ke([0,1,42,30,10,24,9,13,36,102,11,144,29,161]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function v(m){switch(m){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(m,a){if(y.isWindows)try{const d={stdio:["pipe","pipe","ignore"]};a&&(d.cwd=a);const i=u.execFile("taskkill",["/T","/F","/PID",m.pid.toString()],d);return new Promise(o=>{i.once("error",r=>{o({success:!1,error:r})}),i.once("exit",(r,t)=>{o(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(d){return Promise.resolve({success:!1,error:d,code:d.status?v(d.status):1})}else if(y.isLinux||y.isMacintosh)try{const d=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(i=>{u.execFile(d,[m.pid.toString()],{encoding:"utf8",shell:!0},(o,r,t)=>{i(o?{success:!1,error:o}:{success:!0})})})}catch(d){return Promise.resolve({success:!1,error:d})}else m.kill("SIGKILL");return Promise.resolve({success:!0})}function p(m=b.env){return m.comspec||"cmd.exe"}e.getWindowsShell=p;class f{constructor(a,d,i,o){if(d!==void 0&&i!==void 0&&o!==void 0)this.cmd=a,this.args=d,this.shell=i,this.options=o;else{const r=a;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(b.env).forEach(t=>{r[t]=b.env[t]}),Object.keys(this.options.env).forEach(t=>{r[t]=this.options.env[t]}),this.options.env=r}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const d=a.lastIndexOf(C.sep);return d!==-1&&(a=a.substring(d+1)),f.WellKnowCommands[a]?a:"other"}start(a){return y.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(b.cwd()))?Promise.reject(new Error(P.localize(0,null))):this.useExec().then(d=>{let i,o;const r=new Promise((t,s)=>{i=t,o=s});if(d){let t=this.cmd;this.args&&(t=t+" "+this.args.join(" ")),this.childProcess=u.exec(t,this.options,(s,l,h)=>{this.childProcess=null;const S=s;S&&S.killed?o({killed:this.terminateRequested,stdout:l.toString(),stderr:h.toString()}):this.handleExec(i,a,s,l,h)})}else{let t=null;const s=l=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(l,i,a,o);const h={terminated:this.terminateRequested};R.isNumber(l)&&(h.cmdCode=l),i(h)};if(this.shell&&y.isWindows){const l=T.deepClone(this.options);l.windowsVerbatimArguments=!0,l.detached=!1;let h=!1,S=!1;const L=[];let F=this.ensureQuotes(this.cmd);L.push(F.value),h=F.quoted,this.args&&this.args.forEach(A=>{F=this.ensureQuotes(A),L.push(F.value),S=S&&F.quoted});const M=["/s","/c"];h?S?M.push('"'+L.join(" ")+'"'):L.length>1?M.push('"'+L[0]+'" '+L.slice(1).join(" ")):M.push('"'+L[0]+'"'):M.push(L.join(" ")),t=u.spawn(p(),M,l)}else this.cmd&&(t=u.spawn(this.cmd,this.args,this.options));t&&(this.childProcess=t,this.childProcessPromise=Promise.resolve(t),this.pidResolve&&(this.pidResolve(R.isNumber(t.pid)?t.pid:-1),this.pidResolve=void 0),t.on("error",l=>{this.childProcess=null,o({terminated:this.terminateRequested,error:l})}),t.pid&&(this.childProcess.on("close",s),this.handleSpawn(t,i,a,o,!0)))}return r})}handleClose(a,d,i,o){}ensureQuotes(a){return f.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,w(a,this.options.cwd).then(d=>(d.success&&(this.childProcess=null),d))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!y.isWindows)return a(!1);const d=u.spawn(p(),["/s","/c"]);d.on("error",i=>a(!0)),d.on("exit",i=>a(!1))})}}e.AbstractProcess=f,f.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},f.regexp=/^[^"].* .*[^"]/;class E extends f{constructor(a,d,i,o){super(a,d,i,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,d,i,o,r){[o,r].forEach((t,s)=>{const l=new k.LineDecoder;l.write(t).forEach(L=>{d({line:L,source:s===0?0:1})});const S=l.end();S&&d({line:S,source:s===0?0:1})}),a({terminated:this.terminateRequested,error:i})}handleSpawn(a,d,i,o,r){const t=new k.LineDecoder,s=new k.LineDecoder;a.stdout.on("data",l=>{t.write(l).forEach(S=>i({line:S,source:0}))}),a.stderr.on("data",l=>{s.write(l).forEach(S=>i({line:S,source:1}))}),this.stdoutLineDecoder=t,this.stderrLineDecoder=s}handleClose(a,d,i,o){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&i({line:r,source:0});const t=this.stderrLineDecoder?this.stderrLineDecoder.end():null;t&&i({line:t,source:1})}}e.LineProcess=E;function g(m){let a=[],d=!1;const i=function(o){if(d){a.push(o);return}(!m.send(o,t=>{if(t&&console.error(t),d=!1,a.length>0){const s=a.slice(0);a=[],s.forEach(l=>i(l))}})||y.isWindows)&&(d=!0)};return{send:i}}e.createQueuedSender=g;var c;(function(m){async function a(d,i,o){if(C.isAbsolute(d))return d;if(i===void 0&&(i=b.cwd()),C.dirname(d)!=="."||(o===void 0&&R.isString(b.env.PATH)&&(o=b.env.PATH.split(C.delimiter)),o===void 0||o.length===0))return C.join(i,d);async function t(s){if(await _.Promises.exists(s)){let l;try{l=await _.Promises.stat(s)}catch(h){h.message.startsWith("EACCES")&&(l=await _.Promises.lstat(s))}return l?!l.isDirectory():!1}return!1}for(const s of o){let l;if(C.isAbsolute(s)?l=C.join(s,d):l=C.join(i,s,d),await t(l))return l;let h=l+".com";if(await t(h)||(h=l+".exe",await t(h)))return h}return C.join(i,d)}m.findExecutable=a})(c=e.win32||(e.win32={}))}),define(Ie[162],ke([19,20]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(Ie[115],ke([0,1,162,13,99,16,24,146]),function(J,e,u,n,D,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var b;(function(ie){ie[ie.None=0]="None",ie[ie.Keep=1]="Keep",ie[ie.Brackets=2]="Brackets",ie[ie.Advanced=3]="Advanced",ie[ie.Full=4]="Full"})(b=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class I{constructor(oe){this._values=oe}hasChanged(oe){return this._values[oe]}}e.ConfigurationChangedEvent=I;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class k{constructor(oe,G,Ce,Re){this.id=oe,this.name=G,this.defaultValue=Ce,this.schema=Re}applyUpdate(oe,G){return P(oe,G)}compute(oe,G,Ce){return Ce}}class _{constructor(oe,G){this.newValue=oe,this.didChange=G}}e.ApplyUpdateResult=_;function P(ie,oe){if(typeof ie!="object"||typeof oe!="object"||!ie||!oe)return new _(oe,ie!==oe);if(Array.isArray(ie)||Array.isArray(oe)){const Ce=Array.isArray(ie)&&Array.isArray(oe)&&T.equals(ie,oe);return new _(oe,!Ce)}let G=!1;for(const Ce in oe)if(oe.hasOwnProperty(Ce)){const Re=P(ie[Ce],oe[Ce]);Re.didChange&&(ie[Ce]=Re.newValue,G=!0)}return new _(ie,G)}class v{constructor(oe){this.schema=void 0,this.id=oe,this.name="_never_",this.defaultValue=void 0}applyUpdate(oe,G){return P(oe,G)}validate(oe){return this.defaultValue}}class w{constructor(oe,G,Ce,Re){this.id=oe,this.name=G,this.defaultValue=Ce,this.schema=Re}applyUpdate(oe,G){return P(oe,G)}validate(oe){return typeof oe=="undefined"?this.defaultValue:oe}compute(oe,G,Ce){return Ce}}function p(ie,oe){return typeof ie=="undefined"?oe:ie==="false"?!1:Boolean(ie)}e.boolean=p;class f extends w{constructor(oe,G,Ce,Re=void 0){typeof Re!="undefined"&&(Re.type="boolean",Re.default=Ce);super(oe,G,Ce,Re)}validate(oe){return p(oe,this.defaultValue)}}function E(ie,oe,G,Ce){if(typeof ie=="undefined")return oe;let Re=parseInt(ie,10);return isNaN(Re)?oe:(Re=Math.max(G,Re),Re=Math.min(Ce,Re),Re|0)}e.clampedInt=E;class g extends w{constructor(oe,G,Ce,Re,We,ze=void 0){typeof ze!="undefined"&&(ze.type="integer",ze.default=Ce,ze.minimum=Re,ze.maximum=We);super(oe,G,Ce,ze);this.minimum=Re,this.maximum=We}static clampedInt(oe,G,Ce,Re){return E(oe,G,Ce,Re)}validate(oe){return g.clampedInt(oe,this.defaultValue,this.minimum,this.maximum)}}class c extends w{constructor(oe,G,Ce,Re,We){typeof We!="undefined"&&(We.type="number",We.default=Ce);super(oe,G,Ce,We);this.validationFn=Re}static clamp(oe,G,Ce){return oe<G?G:oe>Ce?Ce:oe}static float(oe,G){if(typeof oe=="number")return oe;if(typeof oe=="undefined")return G;const Ce=parseFloat(oe);return isNaN(Ce)?G:Ce}validate(oe){return this.validationFn(c.float(oe,this.defaultValue))}}class m extends w{static string(oe,G){return typeof oe!="string"?G:oe}constructor(oe,G,Ce,Re=void 0){typeof Re!="undefined"&&(Re.type="string",Re.default=Ce);super(oe,G,Ce,Re)}validate(oe){return m.string(oe,this.defaultValue)}}function a(ie,oe,G){return typeof ie!="string"||G.indexOf(ie)===-1?oe:ie}e.stringSet=a;class d extends w{constructor(oe,G,Ce,Re,We=void 0){typeof We!="undefined"&&(We.type="string",We.enum=Re,We.default=Ce);super(oe,G,Ce,We);this._allowedValues=Re}validate(oe){return a(oe,this.defaultValue,this._allowedValues)}}class i extends k{constructor(oe,G,Ce,Re,We,ze,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.enum=We,$e.default=Re);super(oe,G,Ce,$e);this._allowedValues=We,this._convert=ze}validate(oe){return typeof oe!="string"?this.defaultValue:this._allowedValues.indexOf(oe)===-1?this.defaultValue:this._convert(oe)}}function o(ie){switch(ie){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[u.localize(0,null),u.localize(1,null),u.localize(2,null)],default:"auto",description:u.localize(3,null)})}validate(oe){switch(oe){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(oe,G,Ce){return Ce===0?oe.accessibilitySupport:Ce}}class t extends k{constructor(){const oe={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",oe,{"editor.comments.insertSpace":{type:"boolean",default:oe.insertSpace,description:u.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:oe.ignoreEmptyLines,description:u.localize(5,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const G=oe;return{insertSpace:p(G.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:p(G.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(ie){ie[ie.Hidden=0]="Hidden",ie[ie.Blink=1]="Blink",ie[ie.Smooth=2]="Smooth",ie[ie.Phase=3]="Phase",ie[ie.Expand=4]="Expand",ie[ie.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function l(ie){switch(ie){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(ie){ie[ie.Line=1]="Line",ie[ie.Block=2]="Block",ie[ie.Underline=3]="Underline",ie[ie.LineThin=4]="LineThin",ie[ie.BlockOutline=5]="BlockOutline",ie[ie.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function S(ie){switch(ie){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=S;function L(ie){switch(ie){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class F extends v{constructor(){super(130)}compute(oe,G,Ce){const Re=["monaco-editor"];return G.get(35)&&Re.push(G.get(35)),oe.extraEditorClassName&&Re.push(oe.extraEditorClassName),G.get(68)==="default"?Re.push("mouse-default"):G.get(68)==="copy"&&Re.push("mouse-copy"),G.get(102)&&Re.push("showUnused"),G.get(128)&&Re.push("showDeprecated"),Re.join(" ")}}class M extends f{constructor(){super(33,"emptySelectionClipboard",!0,{description:u.localize(6,null)})}compute(oe,G,Ce){return Ce&&oe.emptySelectionClipboard}}class A extends k{constructor(){const oe={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(37,"find",oe,{"editor.find.cursorMoveOnType":{type:"boolean",default:oe.cursorMoveOnType,description:u.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:oe.seedSearchStringFromSelection,enumDescriptions:[u.localize(8,null),u.localize(9,null),u.localize(10,null)],description:u.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:oe.autoFindInSelection,enumDescriptions:[u.localize(12,null),u.localize(13,null),u.localize(14,null)],description:u.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:oe.globalFindClipboard,description:u.localize(16,null),included:n.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:oe.addExtraSpaceOnTop,description:u.localize(17,null)},"editor.find.loop":{type:"boolean",default:oe.loop,description:u.localize(18,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const G=oe;return{cursorMoveOnType:p(G.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof oe.seedSearchStringFromSelection=="boolean"?oe.seedSearchStringFromSelection?"always":"never":a(G.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof oe.autoFindInSelection=="boolean"?oe.autoFindInSelection?"always":"never":a(G.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:p(G.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:p(G.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:p(G.loop,this.defaultValue.loop)}}}class B extends k{constructor(){super(47,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:u.localize(19,null)},{type:"string",description:u.localize(20,null)}],description:u.localize(21,null),default:!1})}validate(oe){return typeof oe=="undefined"?this.defaultValue:typeof oe=="string"?oe==="false"?B.OFF:oe==="true"?B.ON:oe:Boolean(oe)?B.ON:B.OFF}}e.EditorFontLigatures=B,B.OFF='"liga" off, "calt" off',B.ON='"liga" on, "calt" on';class $ extends v{constructor(){super(46)}compute(oe,G,Ce){return oe.fontInfo}}class U extends w{constructor(){super(48,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:u.localize(22,null)})}validate(oe){const G=c.float(oe,this.defaultValue);return G===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(G,6,100)}compute(oe,G,Ce){return oe.fontInfo.fontSize}}class X extends k{constructor(){super(49,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:X.MINIMUM_VALUE,maximum:X.MAXIMUM_VALUE,errorMessage:u.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:X.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:u.localize(24,null)})}validate(oe){return oe==="normal"||oe==="bold"?oe:String(g.clampedInt(oe,e.EDITOR_FONT_DEFAULTS.fontWeight,X.MINIMUM_VALUE,X.MAXIMUM_VALUE))}}X.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],X.MINIMUM_VALUE=1,X.MAXIMUM_VALUE=1e3;class z extends k{constructor(){const oe={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},G={type:"string",enum:["peek","gotoAndPeek","goto"],default:oe.multiple,enumDescriptions:[u.localize(25,null),u.localize(26,null),u.localize(27,null)]},Ce=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(53,"gotoLocation",oe,{"editor.gotoLocation.multiple":{deprecationMessage:u.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:u.localize(29,null),...G},"editor.gotoLocation.multipleTypeDefinitions":{description:u.localize(30,null),...G},"editor.gotoLocation.multipleDeclarations":{description:u.localize(31,null),...G},"editor.gotoLocation.multipleImplementations":{description:u.localize(32,null),...G},"editor.gotoLocation.multipleReferences":{description:u.localize(33,null),...G},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:oe.alternativeDefinitionCommand,enum:Ce,description:u.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:oe.alternativeTypeDefinitionCommand,enum:Ce,description:u.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:oe.alternativeDeclarationCommand,enum:Ce,description:u.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:oe.alternativeImplementationCommand,enum:Ce,description:u.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:oe.alternativeReferenceCommand,enum:Ce,description:u.localize(38,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const G=oe;return{multiple:a(G.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:G.multipleDefinitions??a(G.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:G.multipleTypeDefinitions??a(G.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:G.multipleDeclarations??a(G.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:G.multipleImplementations??a(G.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:G.multipleReferences??a(G.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:m.string(G.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:m.string(G.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:m.string(G.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:m.string(G.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:m.string(G.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class N extends k{constructor(){const oe={enabled:!0,delay:300,sticky:!0,above:!0};super(55,"hover",oe,{"editor.hover.enabled":{type:"boolean",default:oe.enabled,description:u.localize(39,null)},"editor.hover.delay":{type:"number",default:oe.delay,minimum:0,maximum:1e4,description:u.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:oe.sticky,description:u.localize(41,null)},"editor.hover.above":{type:"boolean",default:oe.above,description:u.localize(42,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const G=oe;return{enabled:p(G.enabled,this.defaultValue.enabled),delay:g.clampedInt(G.delay,this.defaultValue.delay,0,1e4),sticky:p(G.sticky,this.defaultValue.sticky),above:p(G.above,this.defaultValue.above)}}}var V;(function(ie){ie[ie.None=0]="None",ie[ie.Text=1]="Text",ie[ie.Blocks=2]="Blocks"})(V=e.RenderMinimap||(e.RenderMinimap={}));class x extends v{constructor(){super(133)}compute(oe,G,Ce){return x.computeLayout(G,{memory:oe.memory,outerWidth:oe.outerWidth,outerHeight:oe.outerHeight,isDominatedByLongLines:oe.isDominatedByLongLines,lineHeight:oe.fontInfo.lineHeight,viewLineCount:oe.viewLineCount,lineNumbersDigitCount:oe.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:oe.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:oe.fontInfo.maxDigitWidth,pixelRatio:oe.pixelRatio})}static computeContainedMinimapLineCount(oe){const G=oe.height/oe.lineHeight,Ce=oe.scrollBeyondLastLine?G-1:0,Re=(oe.viewLineCount+Ce)/(oe.pixelRatio*oe.height),We=Math.floor(oe.viewLineCount/Re);return{typicalViewportLineCount:G,extraLinesBeyondLastLine:Ce,desiredRatio:Re,minimapLineCount:We}}static _computeMinimapLayout(oe,G){const Ce=oe.outerWidth,Re=oe.outerHeight,We=oe.pixelRatio;if(!oe.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(We*Re),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Re};const ze=G.stableMinimapLayoutInput,$e=ze&&oe.outerHeight===ze.outerHeight&&oe.lineHeight===ze.lineHeight&&oe.typicalHalfwidthCharacterWidth===ze.typicalHalfwidthCharacterWidth&&oe.pixelRatio===ze.pixelRatio&&oe.scrollBeyondLastLine===ze.scrollBeyondLastLine&&oe.minimap.enabled===ze.minimap.enabled&&oe.minimap.side===ze.minimap.side&&oe.minimap.size===ze.minimap.size&&oe.minimap.showSlider===ze.minimap.showSlider&&oe.minimap.renderCharacters===ze.minimap.renderCharacters&&oe.minimap.maxColumn===ze.minimap.maxColumn&&oe.minimap.scale===ze.minimap.scale&&oe.verticalScrollbarWidth===ze.verticalScrollbarWidth&&oe.isViewportWrapping===ze.isViewportWrapping,tt=oe.lineHeight,st=oe.typicalHalfwidthCharacterWidth,lt=oe.scrollBeyondLastLine,nt=oe.minimap.renderCharacters;let it=We>=2?Math.round(oe.minimap.scale*2):oe.minimap.scale;const ft=oe.minimap.maxColumn,Ct=oe.minimap.size,kt=oe.minimap.side,mt=oe.verticalScrollbarWidth,Dt=oe.viewLineCount,Ut=oe.remainingWidth,Nt=oe.isViewportWrapping,Ge=nt?2:3;let Ft=Math.floor(We*Re);const Lt=Ft/We;let Mt=!1,pt=!1,Pt=Ge*it,Te=it/We,Le=1;if(Ct==="fill"||Ct==="fit"){const{typicalViewportLineCount:Qe,extraLinesBeyondLastLine:vt,desiredRatio:Et,minimapLineCount:Tt}=x.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:lt,height:Re,lineHeight:tt,pixelRatio:We});if(Dt/Tt>1)Mt=!0,pt=!0,it=1,Pt=1,Te=it/We;else{let ht=!1,Ot=it+1;if(Ct==="fit"){const St=Math.ceil((Dt+vt)*Pt);Nt&&$e&&Ut<=G.stableFitRemainingWidth?(ht=!0,Ot=G.stableFitMaxMinimapScale):ht=St>Ft}if(Ct==="fill"||ht){Mt=!0;const St=it;Pt=Math.min(tt*We,Math.max(1,Math.floor(1/Et))),Nt&&$e&&Ut<=G.stableFitRemainingWidth&&(Ot=G.stableFitMaxMinimapScale),it=Math.min(Ot,Math.max(1,Math.floor(Pt/Ge))),it>St&&(Le=Math.min(2,it/St)),Te=it/We/Le,Ft=Math.ceil(Math.max(Qe,Dt+vt)*Pt),Nt?(G.stableMinimapLayoutInput=oe,G.stableFitRemainingWidth=Ut,G.stableFitMaxMinimapScale=it):(G.stableMinimapLayoutInput=null,G.stableFitRemainingWidth=0)}}}const Se=Math.floor(ft*Te),ne=Math.min(Se,Math.max(0,Math.floor((Ut-mt-2)*Te/(st+Te)))+e.MINIMAP_GUTTER_WIDTH);let Fe=Math.floor(We*ne);const xe=Fe/We;Fe=Math.floor(Fe*Le);const Ye=nt?1:2,Je=kt==="left"?0:Ce-ne-mt;return{renderMinimap:Ye,minimapLeft:Je,minimapWidth:ne,minimapHeightIsEditorHeight:Mt,minimapIsSampling:pt,minimapScale:it,minimapLineHeight:Pt,minimapCanvasInnerWidth:Fe,minimapCanvasInnerHeight:Ft,minimapCanvasOuterWidth:xe,minimapCanvasOuterHeight:Lt}}static computeLayout(oe,G){const Ce=G.outerWidth|0,Re=G.outerHeight|0,We=G.lineHeight|0,ze=G.lineNumbersDigitCount|0,$e=G.typicalHalfwidthCharacterWidth,tt=G.maxDigitWidth,st=G.pixelRatio,lt=G.viewLineCount,nt=oe.get(125),it=nt==="inherit"?oe.get(124):nt,ft=it==="inherit"?oe.get(120):it,Ct=oe.get(123),kt=oe.get(2),mt=G.isDominatedByLongLines,Dt=oe.get(52),Ut=oe.get(62).renderType!==0,Nt=oe.get(63),Ge=oe.get(96),Ft=oe.get(67),Lt=oe.get(94),Mt=Lt.verticalScrollbarSize,pt=Lt.verticalHasArrows,Pt=Lt.arrowSize,Te=Lt.horizontalScrollbarSize,Le=oe.get(60),Se=oe.get(39),ne=oe.get(101)!=="never";let Fe;if(typeof Le=="string"&&/^\d+(\.\d+)?ch$/.test(Le)){const xt=parseFloat(Le.substr(0,Le.length-2));Fe=g.clampedInt(xt*$e,0,0,1e3)}else Fe=g.clampedInt(Le,0,0,1e3);Se&&ne&&(Fe+=16);let xe=0;if(Ut){const xt=Math.max(ze,Nt);xe=Math.round(xt*tt)}let Ye=0;Dt&&(Ye=We);let Je=0,Qe=Je+Ye,vt=Qe+xe,Et=vt+Fe;const Tt=Ce-Ye-xe-Fe;let bt=!1,ht=!1,Ot=-1;kt!==2&&(it==="inherit"&&mt?(bt=!0,ht=!0):ft==="on"||ft==="bounded"?ht=!0:ft==="wordWrapColumn"&&(Ot=Ct));const St=x._computeMinimapLayout({outerWidth:Ce,outerHeight:Re,lineHeight:We,typicalHalfwidthCharacterWidth:$e,pixelRatio:st,scrollBeyondLastLine:Ge,minimap:Ft,verticalScrollbarWidth:Mt,viewLineCount:lt,remainingWidth:Tt,isViewportWrapping:ht},G.memory||new R);St.renderMinimap!==0&&St.minimapLeft===0&&(Je+=St.minimapWidth,Qe+=St.minimapWidth,vt+=St.minimapWidth,Et+=St.minimapWidth);const wt=Tt-St.minimapWidth,Kt=Math.max(1,Math.floor((wt-Mt-2)/$e)),Xt=pt?Pt:0;return ht&&(Ot=Math.max(1,Kt),ft==="bounded"&&(Ot=Math.min(Ot,Ct))),{width:Ce,height:Re,glyphMarginLeft:Je,glyphMarginWidth:Ye,lineNumbersLeft:Qe,lineNumbersWidth:xe,decorationsLeft:vt,decorationsWidth:Fe,contentLeft:Et,contentWidth:wt,minimap:St,viewportColumn:Kt,isWordWrapMinified:bt,isViewportWrapping:ht,wrappingColumn:Ot,verticalScrollbarWidth:Mt,horizontalScrollbarHeight:Te,overviewRuler:{top:Xt,width:Mt,height:Re-2*Xt,right:0}}}}e.EditorLayoutInfoComputer=x;class q extends k{constructor(){const oe={enabled:!0};super(59,"lightbulb",oe,{"editor.lightbulb.enabled":{type:"boolean",default:oe.enabled,description:u.localize(43,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:p(oe.enabled,this.defaultValue.enabled)}}}class te extends k{constructor(){const oe={stickyScroll:{enabled:!1}};super(34,"experimental",oe,{"editor.experimental.stickyScroll.enabled":{type:"boolean",default:oe.stickyScroll.enabled,description:u.localize(44,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{stickyScroll:{enabled:p(oe.stickyScroll?.enabled,this.defaultValue.stickyScroll.enabled)}}}}class Y extends k{constructor(){const oe={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",oe,{"editor.inlayHints.enabled":{type:"string",default:oe.enabled,description:u.localize(45,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[u.localize(46,null),u.localize(47,null),u.localize(48,null),u.localize(49,null)]},"editor.inlayHints.fontSize":{type:"number",default:oe.fontSize,markdownDescription:u.localize(50,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:oe.fontFamily,markdownDescription:u.localize(51,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:oe.padding,description:u.localize(52,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const G=oe;return typeof G.enabled=="boolean"&&(G.enabled=G.enabled?"on":"off"),{enabled:a(G.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:g.clampedInt(G.fontSize,this.defaultValue.fontSize,0,100),fontFamily:m.string(G.fontFamily,this.defaultValue.fontFamily),padding:p(G.padding,this.defaultValue.padding)}}}class le extends c{constructor(){super(61,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,oe=>c.clamp(oe,0,150),{markdownDescription:u.localize(53,null)})}compute(oe,G,Ce){return oe.fontInfo.lineHeight}}class pe extends k{constructor(){const oe={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(67,"minimap",oe,{"editor.minimap.enabled":{type:"boolean",default:oe.enabled,description:u.localize(54,null)},"editor.minimap.autohide":{type:"boolean",default:oe.autohide,description:u.localize(55,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[u.localize(56,null),u.localize(57,null),u.localize(58,null)],default:oe.size,description:u.localize(59,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:oe.side,description:u.localize(60,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:oe.showSlider,description:u.localize(61,null)},"editor.minimap.scale":{type:"number",default:oe.scale,minimum:1,maximum:3,enum:[1,2,3],description:u.localize(62,null)},"editor.minimap.renderCharacters":{type:"boolean",default:oe.renderCharacters,description:u.localize(63,null)},"editor.minimap.maxColumn":{type:"number",default:oe.maxColumn,description:u.localize(64,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const G=oe;return{enabled:p(G.enabled,this.defaultValue.enabled),autohide:p(G.autohide,this.defaultValue.autohide),size:a(G.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(G.side,this.defaultValue.side,["right","left"]),showSlider:a(G.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:p(G.renderCharacters,this.defaultValue.renderCharacters),scale:g.clampedInt(G.scale,1,1,3),maxColumn:g.clampedInt(G.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ee(ie){return ie==="ctrlCmd"?n.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ge extends k{constructor(){super(77,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(65,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(66,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const G=oe;return{top:g.clampedInt(G.top,0,0,1e3),bottom:g.clampedInt(G.bottom,0,0,1e3)}}}class Ee extends k{constructor(){const oe={enabled:!0,cycle:!1};super(78,"parameterHints",oe,{"editor.parameterHints.enabled":{type:"boolean",default:oe.enabled,description:u.localize(67,null)},"editor.parameterHints.cycle":{type:"boolean",default:oe.cycle,description:u.localize(68,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const G=oe;return{enabled:p(G.enabled,this.defaultValue.enabled),cycle:p(G.cycle,this.defaultValue.cycle)}}}class Pe extends v{constructor(){super(131)}compute(oe,G,Ce){return oe.pixelRatio}}class Ne extends k{constructor(){const oe={other:"on",comments:"off",strings:"off"},G=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[u.localize(69,null),u.localize(70,null),u.localize(71,null)]}];super(81,"quickSuggestions",oe,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:G,default:oe.strings,description:u.localize(72,null)},comments:{anyOf:G,default:oe.comments,description:u.localize(73,null)},other:{anyOf:G,default:oe.other,description:u.localize(74,null)}},default:oe,markdownDescription:u.localize(75,null,"#editor.suggestOnTriggerCharacters#")});this.defaultValue=oe}validate(oe){if(typeof oe=="boolean"){const st=oe?"on":"off";return{comments:st,strings:st,other:st}}if(!oe||typeof oe!="object")return this.defaultValue;const{other:G,comments:Ce,strings:Re}=oe,We=["on","inline","off"];let ze,$e,tt;return typeof G=="boolean"?ze=G?"on":"off":ze=a(G,this.defaultValue.other,We),typeof Ce=="boolean"?$e=Ce?"on":"off":$e=a(Ce,this.defaultValue.comments,We),typeof Re=="boolean"?tt=Re?"on":"off":tt=a(Re,this.defaultValue.strings,We),{other:ze,comments:$e,strings:tt}}}var ve;(function(ie){ie[ie.Off=0]="Off",ie[ie.On=1]="On",ie[ie.Relative=2]="Relative",ie[ie.Interval=3]="Interval",ie[ie.Custom=4]="Custom"})(ve=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ue extends k{constructor(){super(62,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[u.localize(76,null),u.localize(77,null),u.localize(78,null),u.localize(79,null)],default:"on",description:u.localize(80,null)})}validate(oe){let G=this.defaultValue.renderType,Ce=this.defaultValue.renderFn;return typeof oe!="undefined"&&(typeof oe=="function"?(G=4,Ce=oe):oe==="interval"?G=3:oe==="relative"?G=2:oe==="on"?G=1:G=0),{renderType:G,renderFn:Ce}}}function de(ie){const oe=ie.get(89);return oe==="editable"?ie.get(83):oe!=="on"}e.filterValidationDecorations=de;class we extends k{constructor(){const oe=[],G={type:"number",description:u.localize(81,null)};super(93,"rulers",oe,{type:"array",items:{anyOf:[G,{type:["object"],properties:{column:G,color:{type:"string",description:u.localize(82,null),format:"color-hex"}}}]},default:oe,description:u.localize(83,null)})}validate(oe){if(Array.isArray(oe)){const G=[];for(const Ce of oe)if(typeof Ce=="number")G.push({column:g.clampedInt(Ce,0,0,1e4),color:null});else if(Ce&&typeof Ce=="object"){const Re=Ce;G.push({column:g.clampedInt(Re.column,0,0,1e4),color:Re.color})}return G.sort((Ce,Re)=>Ce.column-Re.column),G}return this.defaultValue}}function re(ie,oe){if(typeof ie!="string")return oe;switch(ie){case"hidden":return 2;case"visible":return 3;default:return 1}}class me extends k{constructor(){const oe={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(94,"scrollbar",oe,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(84,null),u.localize(85,null),u.localize(86,null)],default:"auto",description:u.localize(87,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(88,null),u.localize(89,null),u.localize(90,null)],default:"auto",description:u.localize(91,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:oe.verticalScrollbarSize,description:u.localize(92,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:oe.horizontalScrollbarSize,description:u.localize(93,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:oe.scrollByPage,description:u.localize(94,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const G=oe,Ce=g.clampedInt(G.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Re=g.clampedInt(G.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:g.clampedInt(G.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:re(G.vertical,this.defaultValue.vertical),horizontal:re(G.horizontal,this.defaultValue.horizontal),useShadows:p(G.useShadows,this.defaultValue.useShadows),verticalHasArrows:p(G.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:p(G.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:p(G.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:p(G.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ce,horizontalSliderSize:g.clampedInt(G.horizontalSliderSize,Ce,0,1e3),verticalScrollbarSize:Re,verticalSliderSize:g.clampedInt(G.verticalSliderSize,Re,0,1e3),scrollByPage:p(G.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Z extends k{constructor(){const oe={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",oe,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.nonBasicASCII,description:u.localize(95,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:oe.invisibleCharacters,description:u.localize(96,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:oe.ambiguousCharacters,description:u.localize(97,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeComments,description:u.localize(98,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeStrings,description:u.localize(99,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:oe.allowedCharacters,description:u.localize(100,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:oe.allowedLocales,description:u.localize(101,null)}})}applyUpdate(oe,G){let Ce=!1;G.allowedCharacters&&oe&&(C.equals(oe.allowedCharacters,G.allowedCharacters)||(oe={...oe,allowedCharacters:G.allowedCharacters},Ce=!0)),G.allowedLocales&&oe&&(C.equals(oe.allowedLocales,G.allowedLocales)||(oe={...oe,allowedLocales:G.allowedLocales},Ce=!0));const Re=super.applyUpdate(oe,G);return Ce?new _(Re.newValue,!0):Re}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const G=oe;return{nonBasicASCII:K(G.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:p(G.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:p(G.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:K(G.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:K(G.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(oe.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(oe.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(oe,G){if(typeof oe!="object"||!oe)return G;const Ce={};for(const[Re,We]of Object.entries(oe))We===!0&&(Ce[Re]=!0);return Ce}}class se extends k{constructor(){const oe={enabled:!0,mode:"subwordSmart"};super(57,"inlineSuggest",oe,{"editor.inlineSuggest.enabled":{type:"boolean",default:oe.enabled,description:u.localize(102,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const G=oe;return{enabled:p(G.enabled,this.defaultValue.enabled),mode:a(G.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class O extends k{constructor(){const oe={enabled:y.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:y.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",oe,{"editor.bracketPairColorization.enabled":{type:"boolean",default:oe.enabled,markdownDescription:u.localize(103,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:oe.independentColorPoolPerBracketType,description:u.localize(104,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const G=oe;return{enabled:p(G.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:p(G.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends k{constructor(){const oe={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",oe,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(105,null),u.localize(106,null),u.localize(107,null)],default:oe.bracketPairs,description:u.localize(108,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(109,null),u.localize(110,null),u.localize(111,null)],default:oe.bracketPairsHorizontal,description:u.localize(112,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:oe.highlightActiveBracketPair,description:u.localize(113,null)},"editor.guides.indentation":{type:"boolean",default:oe.indentation,description:u.localize(114,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[u.localize(115,null),u.localize(116,null),u.localize(117,null)],default:oe.highlightActiveIndentation,description:u.localize(118,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const G=oe;return{bracketPairs:K(G.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:K(G.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:p(G.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:p(G.indentation,this.defaultValue.indentation),highlightActiveIndentation:K(G.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function K(ie,oe,G){const Ce=G.indexOf(ie);return Ce===-1?oe:G[Ce]}class Q extends k{constructor(){const oe={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",oe,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[u.localize(119,null),u.localize(120,null)],default:oe.insertMode,description:u.localize(121,null)},"editor.suggest.filterGraceful":{type:"boolean",default:oe.filterGraceful,description:u.localize(122,null)},"editor.suggest.localityBonus":{type:"boolean",default:oe.localityBonus,description:u.localize(123,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:oe.shareSuggestSelections,markdownDescription:u.localize(124,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:oe.snippetsPreventQuickSuggestions,description:u.localize(125,null)},"editor.suggest.showIcons":{type:"boolean",default:oe.showIcons,description:u.localize(126,null)},"editor.suggest.showStatusBar":{type:"boolean",default:oe.showStatusBar,description:u.localize(127,null)},"editor.suggest.preview":{type:"boolean",default:oe.preview,description:u.localize(128,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:oe.showInlineDetails,description:u.localize(129,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:u.localize(130,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:u.localize(131,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:u.localize(132,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:u.localize(133,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:u.localize(134,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:u.localize(135,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:u.localize(136,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:u.localize(137,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:u.localize(138,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:u.localize(139,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:u.localize(140,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:u.localize(141,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:u.localize(142,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:u.localize(143,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:u.localize(144,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:u.localize(145,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:u.localize(146,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:u.localize(147,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:u.localize(148,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:u.localize(149,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:u.localize(150,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:u.localize(151,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:u.localize(152,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:u.localize(153,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:u.localize(154,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:u.localize(155,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:u.localize(156,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:u.localize(157,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:u.localize(158,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:u.localize(159,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:u.localize(160,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const G=oe;return{insertMode:a(G.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:p(G.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:p(G.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:p(G.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:p(G.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:p(G.showIcons,this.defaultValue.showIcons),showStatusBar:p(G.showStatusBar,this.defaultValue.showStatusBar),preview:p(G.preview,this.defaultValue.preview),previewMode:a(G.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:p(G.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:p(G.showMethods,this.defaultValue.showMethods),showFunctions:p(G.showFunctions,this.defaultValue.showFunctions),showConstructors:p(G.showConstructors,this.defaultValue.showConstructors),showDeprecated:p(G.showDeprecated,this.defaultValue.showDeprecated),showFields:p(G.showFields,this.defaultValue.showFields),showVariables:p(G.showVariables,this.defaultValue.showVariables),showClasses:p(G.showClasses,this.defaultValue.showClasses),showStructs:p(G.showStructs,this.defaultValue.showStructs),showInterfaces:p(G.showInterfaces,this.defaultValue.showInterfaces),showModules:p(G.showModules,this.defaultValue.showModules),showProperties:p(G.showProperties,this.defaultValue.showProperties),showEvents:p(G.showEvents,this.defaultValue.showEvents),showOperators:p(G.showOperators,this.defaultValue.showOperators),showUnits:p(G.showUnits,this.defaultValue.showUnits),showValues:p(G.showValues,this.defaultValue.showValues),showConstants:p(G.showConstants,this.defaultValue.showConstants),showEnums:p(G.showEnums,this.defaultValue.showEnums),showEnumMembers:p(G.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:p(G.showKeywords,this.defaultValue.showKeywords),showWords:p(G.showWords,this.defaultValue.showWords),showColors:p(G.showColors,this.defaultValue.showColors),showFiles:p(G.showFiles,this.defaultValue.showFiles),showReferences:p(G.showReferences,this.defaultValue.showReferences),showFolders:p(G.showFolders,this.defaultValue.showFolders),showTypeParameters:p(G.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:p(G.showSnippets,this.defaultValue.showSnippets),showUsers:p(G.showUsers,this.defaultValue.showUsers),showIssues:p(G.showIssues,this.defaultValue.showIssues)}}}class he extends k{constructor(){super(104,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:u.localize(161,null),default:!0,type:"boolean"}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:p(oe.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class be extends v{constructor(){super(132)}compute(oe,G,Ce){return G.get(83)?!0:oe.tabFocusMode}}var ce;(function(ie){ie[ie.None=0]="None",ie[ie.Same=1]="Same",ie[ie.Indent=2]="Indent",ie[ie.DeepIndent=3]="DeepIndent"})(ce=e.WrappingIndent||(e.WrappingIndent={}));function De(ie){switch(ie){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ye extends v{constructor(){super(134)}compute(oe,G,Ce){const Re=G.get(133);return{isDominatedByLongLines:oe.isDominatedByLongLines,isWordWrapMinified:Re.isWordWrapMinified,isViewportWrapping:Re.isViewportWrapping,wrappingColumn:Re.wrappingColumn}}}class Be extends k{constructor(){const oe={enabled:!0};super(32,"dropIntoEditor",oe,{"editor.dropIntoEditor.enabled":{type:"boolean",default:oe.enabled,markdownDescription:u.localize(162,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:p(oe.enabled,this.defaultValue.enabled)}}}const qe="Consolas, 'Courier New', monospace",et="Menlo, Monaco, 'Courier New', monospace",Xe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:n.isMacintosh?et:n.isLinux?Xe:qe,fontWeight:"normal",fontSize:n.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Oe(ie){return e.editorOptionsRegistry[ie.id]=ie,ie}var ot;(function(ie){ie[ie.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ie[ie.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ie[ie.accessibilitySupport=2]="accessibilitySupport",ie[ie.accessibilityPageSize=3]="accessibilityPageSize",ie[ie.ariaLabel=4]="ariaLabel",ie[ie.autoClosingBrackets=5]="autoClosingBrackets",ie[ie.autoClosingDelete=6]="autoClosingDelete",ie[ie.autoClosingOvertype=7]="autoClosingOvertype",ie[ie.autoClosingQuotes=8]="autoClosingQuotes",ie[ie.autoIndent=9]="autoIndent",ie[ie.automaticLayout=10]="automaticLayout",ie[ie.autoSurround=11]="autoSurround",ie[ie.bracketPairColorization=12]="bracketPairColorization",ie[ie.guides=13]="guides",ie[ie.codeLens=14]="codeLens",ie[ie.codeLensFontFamily=15]="codeLensFontFamily",ie[ie.codeLensFontSize=16]="codeLensFontSize",ie[ie.colorDecorators=17]="colorDecorators",ie[ie.columnSelection=18]="columnSelection",ie[ie.comments=19]="comments",ie[ie.contextmenu=20]="contextmenu",ie[ie.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ie[ie.cursorBlinking=22]="cursorBlinking",ie[ie.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ie[ie.cursorStyle=24]="cursorStyle",ie[ie.cursorSurroundingLines=25]="cursorSurroundingLines",ie[ie.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ie[ie.cursorWidth=27]="cursorWidth",ie[ie.disableLayerHinting=28]="disableLayerHinting",ie[ie.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ie[ie.domReadOnly=30]="domReadOnly",ie[ie.dragAndDrop=31]="dragAndDrop",ie[ie.dropIntoEditor=32]="dropIntoEditor",ie[ie.emptySelectionClipboard=33]="emptySelectionClipboard",ie[ie.experimental=34]="experimental",ie[ie.extraEditorClassName=35]="extraEditorClassName",ie[ie.fastScrollSensitivity=36]="fastScrollSensitivity",ie[ie.find=37]="find",ie[ie.fixedOverflowWidgets=38]="fixedOverflowWidgets",ie[ie.folding=39]="folding",ie[ie.foldingStrategy=40]="foldingStrategy",ie[ie.foldingHighlight=41]="foldingHighlight",ie[ie.foldingImportsByDefault=42]="foldingImportsByDefault",ie[ie.foldingMaximumRegions=43]="foldingMaximumRegions",ie[ie.unfoldOnClickAfterEndOfLine=44]="unfoldOnClickAfterEndOfLine",ie[ie.fontFamily=45]="fontFamily",ie[ie.fontInfo=46]="fontInfo",ie[ie.fontLigatures=47]="fontLigatures",ie[ie.fontSize=48]="fontSize",ie[ie.fontWeight=49]="fontWeight",ie[ie.formatOnPaste=50]="formatOnPaste",ie[ie.formatOnType=51]="formatOnType",ie[ie.glyphMargin=52]="glyphMargin",ie[ie.gotoLocation=53]="gotoLocation",ie[ie.hideCursorInOverviewRuler=54]="hideCursorInOverviewRuler",ie[ie.hover=55]="hover",ie[ie.inDiffEditor=56]="inDiffEditor",ie[ie.inlineSuggest=57]="inlineSuggest",ie[ie.letterSpacing=58]="letterSpacing",ie[ie.lightbulb=59]="lightbulb",ie[ie.lineDecorationsWidth=60]="lineDecorationsWidth",ie[ie.lineHeight=61]="lineHeight",ie[ie.lineNumbers=62]="lineNumbers",ie[ie.lineNumbersMinChars=63]="lineNumbersMinChars",ie[ie.linkedEditing=64]="linkedEditing",ie[ie.links=65]="links",ie[ie.matchBrackets=66]="matchBrackets",ie[ie.minimap=67]="minimap",ie[ie.mouseStyle=68]="mouseStyle",ie[ie.mouseWheelScrollSensitivity=69]="mouseWheelScrollSensitivity",ie[ie.mouseWheelZoom=70]="mouseWheelZoom",ie[ie.multiCursorMergeOverlapping=71]="multiCursorMergeOverlapping",ie[ie.multiCursorModifier=72]="multiCursorModifier",ie[ie.multiCursorPaste=73]="multiCursorPaste",ie[ie.occurrencesHighlight=74]="occurrencesHighlight",ie[ie.overviewRulerBorder=75]="overviewRulerBorder",ie[ie.overviewRulerLanes=76]="overviewRulerLanes",ie[ie.padding=77]="padding",ie[ie.parameterHints=78]="parameterHints",ie[ie.peekWidgetDefaultFocus=79]="peekWidgetDefaultFocus",ie[ie.definitionLinkOpensInPeek=80]="definitionLinkOpensInPeek",ie[ie.quickSuggestions=81]="quickSuggestions",ie[ie.quickSuggestionsDelay=82]="quickSuggestionsDelay",ie[ie.readOnly=83]="readOnly",ie[ie.renameOnType=84]="renameOnType",ie[ie.renderControlCharacters=85]="renderControlCharacters",ie[ie.renderFinalNewline=86]="renderFinalNewline",ie[ie.renderLineHighlight=87]="renderLineHighlight",ie[ie.renderLineHighlightOnlyWhenFocus=88]="renderLineHighlightOnlyWhenFocus",ie[ie.renderValidationDecorations=89]="renderValidationDecorations",ie[ie.renderWhitespace=90]="renderWhitespace",ie[ie.revealHorizontalRightPadding=91]="revealHorizontalRightPadding",ie[ie.roundedSelection=92]="roundedSelection",ie[ie.rulers=93]="rulers",ie[ie.scrollbar=94]="scrollbar",ie[ie.scrollBeyondLastColumn=95]="scrollBeyondLastColumn",ie[ie.scrollBeyondLastLine=96]="scrollBeyondLastLine",ie[ie.scrollPredominantAxis=97]="scrollPredominantAxis",ie[ie.selectionClipboard=98]="selectionClipboard",ie[ie.selectionHighlight=99]="selectionHighlight",ie[ie.selectOnLineNumbers=100]="selectOnLineNumbers",ie[ie.showFoldingControls=101]="showFoldingControls",ie[ie.showUnused=102]="showUnused",ie[ie.snippetSuggestions=103]="snippetSuggestions",ie[ie.smartSelect=104]="smartSelect",ie[ie.smoothScrolling=105]="smoothScrolling",ie[ie.stickyTabStops=106]="stickyTabStops",ie[ie.stopRenderingLineAfter=107]="stopRenderingLineAfter",ie[ie.suggest=108]="suggest",ie[ie.suggestFontSize=109]="suggestFontSize",ie[ie.suggestLineHeight=110]="suggestLineHeight",ie[ie.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",ie[ie.suggestSelection=112]="suggestSelection",ie[ie.tabCompletion=113]="tabCompletion",ie[ie.tabIndex=114]="tabIndex",ie[ie.unicodeHighlighting=115]="unicodeHighlighting",ie[ie.unusualLineTerminators=116]="unusualLineTerminators",ie[ie.useShadowDOM=117]="useShadowDOM",ie[ie.useTabStops=118]="useTabStops",ie[ie.wordSeparators=119]="wordSeparators",ie[ie.wordWrap=120]="wordWrap",ie[ie.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",ie[ie.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",ie[ie.wordWrapColumn=123]="wordWrapColumn",ie[ie.wordWrapOverride1=124]="wordWrapOverride1",ie[ie.wordWrapOverride2=125]="wordWrapOverride2",ie[ie.wrappingIndent=126]="wrappingIndent",ie[ie.wrappingStrategy=127]="wrappingStrategy",ie[ie.showDeprecated=128]="showDeprecated",ie[ie.inlayHints=129]="inlayHints",ie[ie.editorClassName=130]="editorClassName",ie[ie.pixelRatio=131]="pixelRatio",ie[ie.tabFocusMode=132]="tabFocusMode",ie[ie.layoutInfo=133]="layoutInfo",ie[ie.wrappingInfo=134]="wrappingInfo"})(ot=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Oe(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:u.localize(163,null)})),acceptSuggestionOnEnter:Oe(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",u.localize(164,null),""],markdownDescription:u.localize(165,null)})),accessibilitySupport:Oe(new r),accessibilityPageSize:Oe(new g(3,"accessibilityPageSize",10,1,1073741824,{description:u.localize(166,null)})),ariaLabel:Oe(new m(4,"ariaLabel",u.localize(167,null))),autoClosingBrackets:Oe(new d(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(168,null),u.localize(169,null),""],description:u.localize(170,null)})),autoClosingDelete:Oe(new d(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",u.localize(171,null),""],description:u.localize(172,null)})),autoClosingOvertype:Oe(new d(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",u.localize(173,null),""],description:u.localize(174,null)})),autoClosingQuotes:Oe(new d(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(175,null),u.localize(176,null),""],description:u.localize(177,null)})),autoIndent:Oe(new i(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],o,{enumDescriptions:[u.localize(178,null),u.localize(179,null),u.localize(180,null),u.localize(181,null),u.localize(182,null)],description:u.localize(183,null)})),automaticLayout:Oe(new f(10,"automaticLayout",!1)),autoSurround:Oe(new d(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[u.localize(184,null),u.localize(185,null),u.localize(186,null),""],description:u.localize(187,null)})),bracketPairColorization:Oe(new O),bracketPairGuides:Oe(new H),stickyTabStops:Oe(new f(106,"stickyTabStops",!1,{description:u.localize(188,null)})),codeLens:Oe(new f(14,"codeLens",!0,{description:u.localize(189,null)})),codeLensFontFamily:Oe(new m(15,"codeLensFontFamily","",{description:u.localize(190,null)})),codeLensFontSize:Oe(new g(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:u.localize(191,null)})),colorDecorators:Oe(new f(17,"colorDecorators",!0,{description:u.localize(192,null)})),columnSelection:Oe(new f(18,"columnSelection",!1,{description:u.localize(193,null)})),comments:Oe(new t),contextmenu:Oe(new f(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Oe(new f(21,"copyWithSyntaxHighlighting",!0,{description:u.localize(194,null)})),cursorBlinking:Oe(new i(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],l,{description:u.localize(195,null)})),cursorSmoothCaretAnimation:Oe(new f(23,"cursorSmoothCaretAnimation",!1,{description:u.localize(196,null)})),cursorStyle:Oe(new i(24,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:u.localize(197,null)})),cursorSurroundingLines:Oe(new g(25,"cursorSurroundingLines",0,0,1073741824,{description:u.localize(198,null)})),cursorSurroundingLinesStyle:Oe(new d(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[u.localize(199,null),u.localize(200,null)],description:u.localize(201,null)})),cursorWidth:Oe(new g(27,"cursorWidth",0,0,1073741824,{markdownDescription:u.localize(202,null)})),disableLayerHinting:Oe(new f(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Oe(new f(29,"disableMonospaceOptimizations",!1)),domReadOnly:Oe(new f(30,"domReadOnly",!1)),dragAndDrop:Oe(new f(31,"dragAndDrop",!0,{description:u.localize(203,null)})),emptySelectionClipboard:Oe(new M),dropIntoEditor:Oe(new Be),experimental:Oe(new te),extraEditorClassName:Oe(new m(35,"extraEditorClassName","")),fastScrollSensitivity:Oe(new c(36,"fastScrollSensitivity",5,ie=>ie<=0?5:ie,{markdownDescription:u.localize(204,null)})),find:Oe(new A),fixedOverflowWidgets:Oe(new f(38,"fixedOverflowWidgets",!1)),folding:Oe(new f(39,"folding",!0,{description:u.localize(205,null)})),foldingStrategy:Oe(new d(40,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[u.localize(206,null),u.localize(207,null)],description:u.localize(208,null)})),foldingHighlight:Oe(new f(41,"foldingHighlight",!0,{description:u.localize(209,null)})),foldingImportsByDefault:Oe(new f(42,"foldingImportsByDefault",!1,{description:u.localize(210,null)})),foldingMaximumRegions:Oe(new g(43,"foldingMaximumRegions",5e3,10,65e3,{description:u.localize(211,null)})),unfoldOnClickAfterEndOfLine:Oe(new f(44,"unfoldOnClickAfterEndOfLine",!1,{description:u.localize(212,null)})),fontFamily:Oe(new m(45,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:u.localize(213,null)})),fontInfo:Oe(new $),fontLigatures2:Oe(new B),fontSize:Oe(new U),fontWeight:Oe(new X),formatOnPaste:Oe(new f(50,"formatOnPaste",!1,{description:u.localize(214,null)})),formatOnType:Oe(new f(51,"formatOnType",!1,{description:u.localize(215,null)})),glyphMargin:Oe(new f(52,"glyphMargin",!0,{description:u.localize(216,null)})),gotoLocation:Oe(new z),hideCursorInOverviewRuler:Oe(new f(54,"hideCursorInOverviewRuler",!1,{description:u.localize(217,null)})),hover:Oe(new N),inDiffEditor:Oe(new f(56,"inDiffEditor",!1)),letterSpacing:Oe(new c(58,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ie=>c.clamp(ie,-5,20),{description:u.localize(218,null)})),lightbulb:Oe(new q),lineDecorationsWidth:Oe(new w(60,"lineDecorationsWidth",10)),lineHeight:Oe(new le),lineNumbers:Oe(new ue),lineNumbersMinChars:Oe(new g(63,"lineNumbersMinChars",5,1,300)),linkedEditing:Oe(new f(64,"linkedEditing",!1,{description:u.localize(219,null)})),links:Oe(new f(65,"links",!0,{description:u.localize(220,null)})),matchBrackets:Oe(new d(66,"matchBrackets","always",["always","near","never"],{description:u.localize(221,null)})),minimap:Oe(new pe),mouseStyle:Oe(new d(68,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Oe(new c(69,"mouseWheelScrollSensitivity",1,ie=>ie===0?1:ie,{markdownDescription:u.localize(222,null)})),mouseWheelZoom:Oe(new f(70,"mouseWheelZoom",!1,{markdownDescription:u.localize(223,null)})),multiCursorMergeOverlapping:Oe(new f(71,"multiCursorMergeOverlapping",!0,{description:u.localize(224,null)})),multiCursorModifier:Oe(new i(72,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ee,{markdownEnumDescriptions:[u.localize(225,null),u.localize(226,null)],markdownDescription:u.localize(227,null)})),multiCursorPaste:Oe(new d(73,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[u.localize(228,null),u.localize(229,null)],markdownDescription:u.localize(230,null)})),occurrencesHighlight:Oe(new f(74,"occurrencesHighlight",!0,{description:u.localize(231,null)})),overviewRulerBorder:Oe(new f(75,"overviewRulerBorder",!0,{description:u.localize(232,null)})),overviewRulerLanes:Oe(new g(76,"overviewRulerLanes",3,0,3)),padding:Oe(new ge),parameterHints:Oe(new Ee),peekWidgetDefaultFocus:Oe(new d(79,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[u.localize(233,null),u.localize(234,null)],description:u.localize(235,null)})),definitionLinkOpensInPeek:Oe(new f(80,"definitionLinkOpensInPeek",!1,{description:u.localize(236,null)})),quickSuggestions:Oe(new Ne),quickSuggestionsDelay:Oe(new g(82,"quickSuggestionsDelay",10,0,1073741824,{description:u.localize(237,null)})),readOnly:Oe(new f(83,"readOnly",!1)),renameOnType:Oe(new f(84,"renameOnType",!1,{description:u.localize(238,null),markdownDeprecationMessage:u.localize(239,null)})),renderControlCharacters:Oe(new f(85,"renderControlCharacters",!0,{description:u.localize(240,null),restricted:!0})),renderFinalNewline:Oe(new f(86,"renderFinalNewline",!0,{description:u.localize(241,null)})),renderLineHighlight:Oe(new d(87,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",u.localize(242,null)],description:u.localize(243,null)})),renderLineHighlightOnlyWhenFocus:Oe(new f(88,"renderLineHighlightOnlyWhenFocus",!1,{description:u.localize(244,null)})),renderValidationDecorations:Oe(new d(89,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Oe(new d(90,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",u.localize(245,null),u.localize(246,null),u.localize(247,null),""],description:u.localize(248,null)})),revealHorizontalRightPadding:Oe(new g(91,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Oe(new f(92,"roundedSelection",!0,{description:u.localize(249,null)})),rulers:Oe(new we),scrollbar:Oe(new me),scrollBeyondLastColumn:Oe(new g(95,"scrollBeyondLastColumn",4,0,1073741824,{description:u.localize(250,null)})),scrollBeyondLastLine:Oe(new f(96,"scrollBeyondLastLine",!0,{description:u.localize(251,null)})),scrollPredominantAxis:Oe(new f(97,"scrollPredominantAxis",!0,{description:u.localize(252,null)})),selectionClipboard:Oe(new f(98,"selectionClipboard",!0,{description:u.localize(253,null),included:n.isLinux})),selectionHighlight:Oe(new f(99,"selectionHighlight",!0,{description:u.localize(254,null)})),selectOnLineNumbers:Oe(new f(100,"selectOnLineNumbers",!0)),showFoldingControls:Oe(new d(101,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[u.localize(255,null),u.localize(256,null),u.localize(257,null)],description:u.localize(258,null)})),showUnused:Oe(new f(102,"showUnused",!0,{description:u.localize(259,null)})),showDeprecated:Oe(new f(128,"showDeprecated",!0,{description:u.localize(260,null)})),inlayHints:Oe(new Y),snippetSuggestions:Oe(new d(103,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[u.localize(261,null),u.localize(262,null),u.localize(263,null),u.localize(264,null)],description:u.localize(265,null)})),smartSelect:Oe(new he),smoothScrolling:Oe(new f(105,"smoothScrolling",!1,{description:u.localize(266,null)})),stopRenderingLineAfter:Oe(new g(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Oe(new Q),inlineSuggest:Oe(new se),suggestFontSize:Oe(new g(109,"suggestFontSize",0,0,1e3,{markdownDescription:u.localize(267,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Oe(new g(110,"suggestLineHeight",0,0,1e3,{markdownDescription:u.localize(268,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Oe(new f(111,"suggestOnTriggerCharacters",!0,{description:u.localize(269,null)})),suggestSelection:Oe(new d(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[u.localize(270,null),u.localize(271,null),u.localize(272,null)],description:u.localize(273,null)})),tabCompletion:Oe(new d(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[u.localize(274,null),u.localize(275,null),u.localize(276,null)],description:u.localize(277,null)})),tabIndex:Oe(new g(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Oe(new Z),unusualLineTerminators:Oe(new d(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[u.localize(278,null),u.localize(279,null),u.localize(280,null)],description:u.localize(281,null)})),useShadowDOM:Oe(new f(117,"useShadowDOM",!0)),useTabStops:Oe(new f(118,"useTabStops",!0,{description:u.localize(282,null)})),wordSeparators:Oe(new m(119,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:u.localize(283,null)})),wordWrap:Oe(new d(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[u.localize(284,null),u.localize(285,null),u.localize(286,null),u.localize(287,null)],description:u.localize(288,null)})),wordWrapBreakAfterCharacters:Oe(new m(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Oe(new m(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Oe(new g(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:u.localize(289,null)})),wordWrapOverride1:Oe(new d(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Oe(new d(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Oe(new i(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],De,{enumDescriptions:[u.localize(290,null),u.localize(291,null),u.localize(292,null),u.localize(293,null)],description:u.localize(294,null)})),wrappingStrategy:Oe(new d(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[u.localize(295,null),u.localize(296,null)],description:u.localize(297,null)})),editorClassName:Oe(new F),pixelRatio:Oe(new Pe),tabFocusMode:Oe(new be),layoutInfo:Oe(new x),wrappingInfo:Oe(new ye)}}),define(Ie[163],ke([19,20]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[164],ke([19,20]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[165],ke([19,20]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[166],ke([19,20]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ie[167],ke([19,20]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(Ie[168],ke([19,20]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(Ie[169],ke([19,20]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(Ie[170],ke([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[171],ke([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[172],ke([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(Ie[173],ke([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[174],ke([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[175],ke([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[176],ke([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[177],ke([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ie[178],ke([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostTunnelService",e)}),define(Ie[179],ke([19,20]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(Ie[180],ke([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[181],ke([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[182],ke([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ie[183],ke([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ie[184],ke([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ie[185],ke([19,20]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[186],ke([19,20]),function(J,e){return J.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ie[187],ke([19,20]),function(J,e){return J.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[188],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var u;(function(y){y[y.ACTIVATE=1]="ACTIVATE",y[y.RESTORE=2]="RESTORE",y[y.PRESERVE=3]="PRESERVE"})(u=e.EditorActivation||(e.EditorActivation={}));var n;(function(y){y[y.PICK=0]="PICK",y[y.DISABLED=1]="DISABLED",y[y.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(n=e.EditorResolution||(e.EditorResolution={}));var D;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(D=e.EditorOpenSource||(e.EditorOpenSource={}));var T;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var C;(function(y){y.PROGRAMMATIC="api",y.NAVIGATION="code.navigation",y.JUMP="code.jump"})(C=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),function(){"use strict";function J(e,u,n,D){function T(y){const b=C(y),I=[b];return e.isAbsolute(b)||I.unshift(D),e.resolve(...I)}function C(y){const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let I=process.env.VSCODE_APPDATA;if(I)return e.join(I,n);const R=y["user-data-dir"];if(R)return R;switch(process.platform){case"win32":if(I=process.env.APPDATA,!I){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");I=e.join(k,"AppData","Roaming")}break;case"darwin":I=e.join(u.homedir(),"Library","Application Support");break;case"linux":I=process.env.XDG_CONFIG_HOME||e.join(u.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(I,n)}return{getUserDataPath:T}}if(typeof define=="function")define(Ie[189],ke([0,304,63,10,22,36]),function(e,u,n,D,T,C){const y=T.dirname(D.FileAccess.asFileUri("",e)),b=e.__$__nodeRequire(T.joinPath(y,"package.json").fsPath);return J(u,n,b.name,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),u=require("path"),n=require("os");module.exports=J(u,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Ie[190],ke([0,1,22,41,165,305]),function(J,e,u,n,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function b(f){return f=f.trim(),f==="*"||C.test(f)}e.isValidVersionStr=b;function I(f){if(!b(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const E=f.match(C);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=I;function R(f){if(!f)return null;const E=f.majorBase,g=f.majorMustEqual,c=f.minorBase;let m=f.minorMustEqual;const a=f.patchBase;let d=f.patchMustEqual;f.hasCaret&&(E===0||(m=!1),d=!1);let i=0;if(f.preRelease){const o=y.exec(f.preRelease);if(o){const[,r,t,s]=o;i=Date.UTC(Number(r),Number(t)-1,Number(s))}}return{majorBase:E,majorMustEqual:g,minorBase:c,minorMustEqual:m,patchBase:a,patchMustEqual:d,isMinimum:f.hasGreaterEquals,notBefore:i}}e.normalizeVersion=R;function k(f,E,g){let c;typeof f=="string"?c=R(I(f)):c=f;let m;E instanceof Date?m=E.getTime():typeof E=="string"&&(m=new Date(E).getTime());let a;if(typeof g=="string"?a=R(I(g)):a=g,!c||!a)return!1;const d=c.majorBase,i=c.minorBase,o=c.patchBase;let r=a.majorBase,t=a.minorBase,s=a.patchBase;const l=a.notBefore;let h=a.majorMustEqual,S=a.minorMustEqual,L=a.patchMustEqual;return a.isMinimum?d>r?!0:d<r?!1:i>t?!0:i<t||m&&m<l?!1:o>=s:(d===1&&r===0&&(!h||!S||!L)&&(r=1,t=0,s=0,h=!0,S=!1,L=!1),d<r?!1:d>r?!h:i<t?!1:i>t?!S:o<s?!1:o>s?!L:!(m&&m<l))}e.isValidVersion=k;function _(f,E,g,c,m){const a=[];if(typeof c.publisher!="undefined"&&typeof c.publisher!="string")return a.push([n.default.Error,D.localize(0,null)]),a;if(typeof c.name!="string")return a.push([n.default.Error,D.localize(1,null,"name")]),a;if(typeof c.version!="string")return a.push([n.default.Error,D.localize(2,null,"version")]),a;if(!c.engines)return a.push([n.default.Error,D.localize(3,null,"engines")]),a;if(typeof c.engines.vscode!="string")return a.push([n.default.Error,D.localize(4,null,"engines.vscode")]),a;if(typeof c.extensionDependencies!="undefined"&&!p(c.extensionDependencies))return a.push([n.default.Error,D.localize(5,null,"extensionDependencies")]),a;if(typeof c.activationEvents!="undefined"){if(!p(c.activationEvents))return a.push([n.default.Error,D.localize(6,null,"activationEvents")]),a;if(typeof c.main=="undefined"&&typeof c.browser=="undefined")return a.push([n.default.Error,D.localize(7,null,"activationEvents","main")]),a}if(typeof c.extensionKind!="undefined"&&typeof c.main=="undefined"&&a.push([n.default.Warning,D.localize(8,null,"extensionKind")]),typeof c.main!="undefined"){if(typeof c.main!="string")return a.push([n.default.Error,D.localize(9,null,"main")]),a;{const o=(0,u.joinPath)(g,c.main);(0,u.isEqualOrParent)(o,g)||a.push([n.default.Warning,D.localize(10,null,o.path,g.path)])}if(typeof c.activationEvents=="undefined")return a.push([n.default.Error,D.localize(11,null,"activationEvents","main")]),a}if(typeof c.browser!="undefined"){if(typeof c.browser!="string")return a.push([n.default.Error,D.localize(12,null,"browser")]),a;{const o=(0,u.joinPath)(g,c.browser);(0,u.isEqualOrParent)(o,g)||a.push([n.default.Warning,D.localize(13,null,o.path,g.path)])}if(typeof c.activationEvents=="undefined")return a.push([n.default.Error,D.localize(14,null,"activationEvents","browser")]),a}if(!T.valid(c.version))return a.push([n.default.Error,D.localize(15,null)]),a;const d=[];if(!P(f,E,c,m,d))for(const o of d)a.push([n.default.Error,o]);return a}e.validateExtensionManifest=_;function P(f,E,g,c,m){return c||typeof g.main=="undefined"&&typeof g.browser=="undefined"?!0:w(f,E,g.engines.vscode,m)}e.isValidExtensionVersion=P;function v(f,E,g){return f==="*"||w(E,g,f)}e.isEngineValid=v;function w(f,E,g,c=[]){const m=R(I(g));if(!m)return c.push(D.localize(16,null,g)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return c.push(D.localize(17,null,g)),!1}else if(!m.majorMustEqual)return c.push(D.localize(18,null,g)),!1;return k(f,E,m)?!0:(c.push(D.localize(19,null,f,g)),!1)}function p(f){if(!Array.isArray(f))return!1;for(let E=0,g=f.length;E<g;E++)if(typeof f[E]!="string")return!1;return!0}}),define(Ie[116],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class u{constructor(D,T=[],C=!1){this.ctor=D,this.staticArguments=T,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=u}),define(Ie[82],ke([0,1,116]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function D(C,y,b){y instanceof u.SyncDescriptor||(y=new u.SyncDescriptor(y,[],b)),n.push([C,y])}e.registerSingleton=D;function T(){return n}e.getSingletonServiceDescriptors=T}),define(Ie[191],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class u{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=u;class n{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(const C of this._nodes.values())C.outgoing.size===0&&T.push(C);return T}insertEdge(T,C){const y=this.lookupOrInsertNode(T),b=this.lookupOrInsertNode(C);y.outgoing.set(this._hashFn(C),b),b.incoming.set(this._hashFn(T),y)}removeNode(T){const C=this._hashFn(T);this._nodes.delete(C);for(const y of this._nodes.values())y.outgoing.delete(C),y.incoming.delete(C)}lookupOrInsertNode(T){const C=this._hashFn(T);let y=this._nodes.get(C);return y||(y=new u(T),this._nodes.set(C,y)),y}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){const T=[];for(const[C,y]of this._nodes)T.push(`${C}, (incoming)[${[...y.incoming.keys()].join(", ")}], (outgoing)[${[...y.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(const[T,C]of this._nodes){const y=new Set([T]),b=this._findCycle(C,y);if(b)return b}}_findCycle(T,C){for(const[y,b]of T.outgoing){if(C.has(y))return[...C,y].join(" -> ");C.add(y);const I=this._findCycle(b,C);if(I)return I;C.delete(y)}}}e.Graph=n}),define(Ie[4],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var u;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function y(b){return b[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=y})(u=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function n(C,y,b){y[u.DI_TARGET]===y?y[u.DI_DEPENDENCIES].push({id:C,index:b}):(y[u.DI_DEPENDENCIES]=[{id:C,index:b}],y[u.DI_TARGET]=y)}function D(C){if(u.serviceIds.has(C))return u.serviceIds.get(C);const y=function(b,I,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(y,b,R)};return y.toString=()=>C,u.serviceIds.set(C,y),y}e.createDecorator=D;function T(C){return C}e.refineServiceDecorator=T}),define(Ie[83],ke([0,1,11,2,4]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function T(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof n.URI)}e.isConfigurationOverrides=T;function C(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||u.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=C;var y;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(y=e.ConfigurationTarget||(e.ConfigurationTarget={}));function b(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=b;function I(f,E){const g=Object.create(null);for(const c in f)R(g,c,f[c],E);return g}e.toValuesTree=I;function R(f,E,g,c){const m=E.split("."),a=m.pop();let d=f;for(let i=0;i<m.length;i++){const o=m[i];let r=d[o];switch(typeof r){case"undefined":r=d[o]=Object.create(null);break;case"object":break;default:c(`Ignoring ${E} as ${m.slice(0,i+1).join(".")} is ${JSON.stringify(r)}`);return}d=r}if(typeof d=="object"&&d!==null)try{d[a]=g}catch{c(`Ignoring ${E} as ${m.join(".")} is ${JSON.stringify(d)}`)}else c(`Ignoring ${E} as ${m.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=R;function k(f,E){const g=E.split(".");_(f,g)}e.removeFromValueTree=k;function _(f,E){const g=E.shift();if(E.length===0){delete f[g];return}if(Object.keys(f).indexOf(g)!==-1){const c=f[g];typeof c=="object"&&!Array.isArray(c)&&(_(c,E),Object.keys(c).length===0&&delete f[g])}}function P(f,E,g){function c(d,i){let o=d;for(const r of i){if(typeof o!="object"||o===null)return;o=o[r]}return o}const m=E.split("."),a=c(f,m);return typeof a=="undefined"?g:a}e.getConfigurationValue=P;function v(f,E,g){Object.keys(E).forEach(c=>{c!=="__proto__"&&(c in f?u.isObject(f[c])&&u.isObject(E[c])?v(f[c],E[c],g):g&&(f[c]=E[c]):f[c]=E[c])})}e.merge=v;function w(f,E,g){const c=f.inspect(E),m=f.inspect(g);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:c.defaultValue}e.getMigratedSettingValue=w;function p(f){return f.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(Ie[51],ke([0,1,13,8,4]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",u.isMacintosh),T.set("isLinux",u.isLinux),T.set("isWindows",u.isWindows),T.set("isWeb",u.isWeb),T.set("isMacNative",u.isMacintosh&&!u.isWeb),T.set("isEdge",u.isEdge),T.set("isFirefox",u.isFirefox),T.set("isChrome",u.isChrome),T.set("isSafari",u.isSafari);const C=Object.prototype.hasOwnProperty;var y;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return k.INSTANCE}static true(){return _.INSTANCE}static has(A){return P.create(A)}static equals(A,B){return v.create(A,B)}static notEquals(A,B){return f.create(A,B)}static regex(A,B){return i.create(A,B)}static in(A,B){return w.create(A,B)}static notIn(A,B){return p.create(A,B)}static not(A){return E.create(A)}static and(...A){return t.create(A,null)}static or(...A){return s.create(A,null,!0)}static greater(A,B){return c.create(A,B)}static greaterEquals(A,B){return m.create(A,B)}static smaller(A,B){return a.create(A,B)}static smallerEquals(A,B){return d.create(A,B)}static deserialize(A,B=!1){if(!!A)return this._deserializeOrExpression(A,B)}static _deserializeOrExpression(A,B){const $=A.split("||");return s.create($.map(U=>this._deserializeAndExpression(U,B)),null,!0)}static _deserializeAndExpression(A,B){const $=A.split("&&");return t.create($.map(U=>this._deserializeOne(U,B)),null)}static _deserializeOne(A,B){if(A=A.trim(),A.indexOf("!=")>=0){const $=A.split("!=");return f.create($[0].trim(),this._deserializeValue($[1],B))}if(A.indexOf("==")>=0){const $=A.split("==");return v.create($[0].trim(),this._deserializeValue($[1],B))}if(A.indexOf("=~")>=0){const $=A.split("=~");return i.create($[0].trim(),this._deserializeRegexValue($[1],B))}if(A.indexOf(" not in ")>=0){const $=A.split(" not in ");return p.create($[0].trim(),$[1].trim())}if(A.indexOf(" in ")>=0){const $=A.split(" in ");return w.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(A)){const $=A.split(">=");return m.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(A)){const $=A.split(">");return c.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(A)){const $=A.split("<=");return d.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(A)){const $=A.split("<");return a.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(A)?E.create(A.substr(1).trim()):P.create(A)}static _deserializeValue(A,B){if(A=A.trim(),A==="true")return!0;if(A==="false")return!1;const $=/^'([^']*)'$/.exec(A);return $?$[1].trim():A}static _deserializeRegexValue(A,B){if((0,n.isFalsyOrWhitespace)(A)){if(B)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const $=A.indexOf("/"),U=A.lastIndexOf("/");if($===U||$<0){if(B)throw new Error(`bad regexp-value '${A}', missing /-enclosure`);return console.warn(`bad regexp-value '${A}', missing /-enclosure`),null}const X=A.slice($+1,U),z=A[U+1]==="i"?"i":"";try{return new RegExp(X,z)}catch(N){if(B)throw new Error(`bad regexp-value '${A}', parse error: ${N}`);return console.warn(`bad regexp-value '${A}', parse error: ${N}`),null}}}e.ContextKeyExpr=b;function I(M,A){const B=M?M.substituteConstants():void 0,$=A?A.substituteConstants():void 0;return!B&&!$?!0:!B||!$?!1:B.equals($)}e.expressionsAreEqualWithConstantSubstitution=I;function R(M,A){return M.cmp(A)}class k{constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return _.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class _{constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=_,_.INSTANCE=new _;class P{constructor(A,B){this.key=A,this.negated=B,this.type=2}static create(A,B=null){const $=T.get(A);return typeof $=="boolean"?$?_.INSTANCE:k.INSTANCE:new P(A,B)}cmp(A){return A.type!==this.type?this.type-A.type:h(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=T.get(this.key);return typeof A=="boolean"?A?_.INSTANCE:k.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.negated||(this.negated=E.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=P;class v{constructor(A,B,$){this.key=A,this.value=B,this.negated=$,this.type=4}static create(A,B,$=null){if(typeof B=="boolean")return B?P.create(A,$):E.create(A,$);const U=T.get(A);return typeof U=="boolean"?B===(U?"true":"false")?_.INSTANCE:k.INSTANCE:new v(A,B,$)}cmp(A){return A.type!==this.type?this.type-A.type:S(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=T.get(this.key);if(typeof A=="boolean"){const B=A?"true":"false";return this.value===B?_.INSTANCE:k.INSTANCE}return this}evaluate(A){return A.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(A){return A.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=v;class w{constructor(A,B){this.key=A,this.valueKey=B,this.type=10,this.negated=null}static create(A,B){return new w(A,B)}cmp(A){return A.type!==this.type?this.type-A.type:S(this.key,this.valueKey,A.key,A.valueKey)}equals(A){return A.type===this.type?this.key===A.key&&this.valueKey===A.valueKey:!1}substituteConstants(){return this}evaluate(A){const B=A.getValue(this.valueKey),$=A.getValue(this.key);return Array.isArray(B)?B.includes($):typeof $=="string"&&typeof B=="object"&&B!==null?C.call(B,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(A){return A.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=p.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=w;class p{constructor(A,B){this.key=A,this.valueKey=B,this.type=11,this._negated=w.create(A,B)}static create(A,B){return new p(A,B)}cmp(A){return A.type!==this.type?this.type-A.type:this._negated.cmp(A._negated)}equals(A){return A.type===this.type?this._negated.equals(A._negated):!1}substituteConstants(){return this}evaluate(A){return!this._negated.evaluate(A)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(A){return A.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=p;class f{constructor(A,B,$){this.key=A,this.value=B,this.negated=$,this.type=5}static create(A,B,$=null){if(typeof B=="boolean")return B?E.create(A,$):P.create(A,$);const U=T.get(A);return typeof U=="boolean"?B===(U?"true":"false")?k.INSTANCE:_.INSTANCE:new f(A,B,$)}cmp(A){return A.type!==this.type?this.type-A.type:S(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=T.get(this.key);if(typeof A=="boolean"){const B=A?"true":"false";return this.value===B?k.INSTANCE:_.INSTANCE}return this}evaluate(A){return A.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(A){return A.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=f;class E{constructor(A,B){this.key=A,this.negated=B,this.type=3}static create(A,B=null){const $=T.get(A);return typeof $=="boolean"?$?k.INSTANCE:_.INSTANCE:new E(A,B)}cmp(A){return A.type!==this.type?this.type-A.type:h(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=T.get(this.key);return typeof A=="boolean"?A?k.INSTANCE:_.INSTANCE:this}evaluate(A){return!A.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(A){return A.mapNot(this.key)}negate(){return this.negated||(this.negated=P.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=E;function g(M,A){if(typeof M=="string"){const B=parseFloat(M);isNaN(B)||(M=B)}return typeof M=="string"||typeof M=="number"?A(M):k.INSTANCE}class c{constructor(A,B,$){this.key=A,this.value=B,this.negated=$,this.type=12}static create(A,B,$=null){return g(B,U=>new c(A,U,$))}cmp(A){return A.type!==this.type?this.type-A.type:S(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=c;class m{constructor(A,B,$){this.key=A,this.value=B,this.negated=$,this.type=13}static create(A,B,$=null){return g(B,U=>new m(A,U,$))}cmp(A){return A.type!==this.type?this.type-A.type:S(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=m;class a{constructor(A,B,$){this.key=A,this.value=B,this.negated=$,this.type=14}static create(A,B,$=null){return g(B,U=>new a(A,U,$))}cmp(A){return A.type!==this.type?this.type-A.type:S(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class d{constructor(A,B,$){this.key=A,this.value=B,this.negated=$,this.type=15}static create(A,B,$=null){return g(B,U=>new d(A,U,$))}cmp(A){return A.type!==this.type?this.type-A.type:S(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=d;class i{constructor(A,B){this.key=A,this.regexp=B,this.type=7,this.negated=null}static create(A,B){return new i(A,B)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.key<A.key)return-1;if(this.key>A.key)return 1;const B=this.regexp?this.regexp.source:"",$=A.regexp?A.regexp.source:"";return B<$?-1:B>$?1:0}equals(A){if(A.type===this.type){const B=this.regexp?this.regexp.source:"",$=A.regexp?A.regexp.source:"";return this.key===A.key&&B===$}return!1}substituteConstants(){return this}evaluate(A){const B=A.getValue(this.key);return this.regexp?this.regexp.test(B):!1}serialize(){const A=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${A}`}keys(){return[this.key]}map(A){return A.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=o.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class o{constructor(A){this._actual=A,this.type=8}static create(A){return new o(A)}cmp(A){return A.type!==this.type?this.type-A.type:this._actual.cmp(A._actual)}equals(A){return A.type===this.type?this._actual.equals(A._actual):!1}substituteConstants(){return this}evaluate(A){return!this._actual.evaluate(A)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(A){return new o(this._actual.map(A))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;function r(M){let A=null;for(let B=0,$=M.length;B<$;B++){const U=M[B].substituteConstants();if(M[B]!==U&&A===null){A=[];for(let X=0;X<B;X++)A[X]=M[X]}A!==null&&(A[B]=U)}return A===null?M:A}class t{constructor(A,B){this.expr=A,this.negated=B,this.type=6}static create(A,B){return t._normalizeArr(A,B)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let B=0,$=this.expr.length;B<$;B++){const U=R(this.expr[B],A.expr[B]);if(U!==0)return U}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let B=0,$=this.expr.length;B<$;B++)if(!this.expr[B].equals(A.expr[B]))return!1;return!0}return!1}substituteConstants(){const A=r(this.expr);return A===this.expr?this:t.create(A,this.negated)}evaluate(A){for(let B=0,$=this.expr.length;B<$;B++)if(!this.expr[B].evaluate(A))return!1;return!0}static _normalizeArr(A,B){const $=[];let U=!1;for(const X of A)if(!!X){if(X.type===1){U=!0;continue}if(X.type===0)return k.INSTANCE;if(X.type===6){$.push(...X.expr);continue}$.push(X)}if($.length===0&&U)return _.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(R);for(let X=1;X<$.length;X++)$[X-1].equals($[X])&&($.splice(X,1),X--);if($.length===1)return $[0];for(;$.length>1;){const X=$[$.length-1];if(X.type!==9)break;$.pop();const z=$.pop(),N=$.length===0,V=s.create(X.expr.map(x=>t.create([x,z],null)),null,N);V&&($.push(V),$.sort(R))}return $.length===1?$[0]:new t($,B)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const B of this.expr)A.push(...B.keys());return A}map(A){return new t(this.expr.map(B=>B.map(A)),null)}negate(){if(!this.negated){const A=[];for(const B of this.expr)A.push(B.negate());this.negated=s.create(A,this,!0)}return this.negated}}class s{constructor(A,B){this.expr=A,this.negated=B,this.type=9}static create(A,B,$){return s._normalizeArr(A,B,$)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let B=0,$=this.expr.length;B<$;B++){const U=R(this.expr[B],A.expr[B]);if(U!==0)return U}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let B=0,$=this.expr.length;B<$;B++)if(!this.expr[B].equals(A.expr[B]))return!1;return!0}return!1}substituteConstants(){const A=r(this.expr);return A===this.expr?this:s.create(A,this.negated,!1)}evaluate(A){for(let B=0,$=this.expr.length;B<$;B++)if(this.expr[B].evaluate(A))return!0;return!1}static _normalizeArr(A,B,$){let U=[],X=!1;if(A){for(let z=0,N=A.length;z<N;z++){const V=A[z];if(!!V){if(V.type===0){X=!0;continue}if(V.type===1)return _.INSTANCE;if(V.type===9){U=U.concat(V.expr);continue}U.push(V)}}if(U.length===0&&X)return k.INSTANCE;U.sort(R)}if(U.length!==0){if(U.length===1)return U[0];for(let z=1;z<U.length;z++)U[z-1].equals(U[z])&&(U.splice(z,1),z--);if(U.length===1)return U[0];if($){for(let z=0;z<U.length;z++)for(let N=z+1;N<U.length;N++)L(U[z],U[N])&&(U.splice(N,1),N--);if(U.length===1)return U[0]}return new s(U,B)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const B of this.expr)A.push(...B.keys());return A}map(A){return new s(this.expr.map(B=>B.map(A)),null)}negate(){if(!this.negated){const A=[];for(const B of this.expr)A.push(B.negate());for(;A.length>1;){const B=A.shift(),$=A.shift(),U=[];for(const z of F(B))for(const N of F($))U.push(t.create([z,N],null));const X=A.length===0;A.unshift(s.create(U,null,X))}this.negated=A[0]}return this.negated}}class l extends P{constructor(A,B,$){super(A,null);this._defaultValue=B,typeof $=="object"?l._info.push({...$,key:A}):$!==!0&&l._info.push({key:A,description:$,type:B!=null?typeof B:void 0})}static all(){return l._info.values()}bindTo(A){return A.createKey(this.key,this._defaultValue)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return v.create(this.key,A)}notEqualsTo(A){return f.create(this.key,A)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(M,A){return M<A?-1:M>A?1:0}function S(M,A,B,$){return M<B?-1:M>B?1:A<$?-1:A>$?1:0}function L(M,A){if(A.type===6&&M.type!==9&&M.type!==6){for(const U of A.expr)if(M.equals(U))return!0}const B=M.negate(),$=F(B).concat(F(A));$.sort(R);for(let U=0;U<$.length;U++){const z=$[U].negate();for(let N=U+1;N<$.length;N++){const V=$[N];if(z.equals(V))return!0}}return!1}e.implies=L;function F(M){return M.type===9?M.expr:[M]}}),define(Ie[192],ke([0,1,4]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,u.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,u.refineServiceDecorator)(e.IEnvironmentService)}),define(Ie[84],ke([0,1,164,4]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDefaultExtensionsProfileInitService=e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function T(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=T;function C(f,E){switch(f){case 3:return E==="x64"?"win32-x64":E==="ia32"?"win32-ia32":E==="arm64"?"win32-arm64":"unknown";case 2:return E==="x64"?"linux-x64":E==="arm64"?"linux-arm64":E==="arm"?"linux-armhf":"unknown";case"alpine":return E==="x64"?"alpine-x64":E==="arm64"?"alpine-arm64":"unknown";case 1:return E==="x64"?"darwin-x64":E==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function y(f,E){return E==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=y;function b(f,E,g){return y(E,g)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===g?!0:I(g).includes(f)}e.isTargetPlatformCompatible=b;function I(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function R(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=R;var k;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var _;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(_=e.SortOrder||(e.SortOrder={}));var P;(function(f){f.Install="install",f.Uninstall="uninstall"})(P=e.StatisticType||(e.StatisticType={}));var v;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,n.createDecorator)("extensionGalleryService");var w;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal"})(w=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class p extends Error{constructor(E,g){super(E);this.code=g,this.name=g}}e.ExtensionManagementError=p,e.IExtensionManagementService=(0,n.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,n.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,n.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,n.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,u.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,u.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,n.createDecorator)("IExtensionManagementCLIService"),e.IDefaultExtensionsProfileInitService=(0,n.createDecorator)("IDefaultExtensionsProfileInitService")}),define(Ie[193],ke([0,1,4]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,u.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,u.createDecorator)("externalTerminal")}),define(Ie[194],ke([0,1,42,10,9,13,102,29,114,166,193]),function(J,e,u,n,D,T,C,y,b,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=I.localize(0,null);class _{async getDefaultTerminalForPlatforms(){return{windows:P.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class P extends _{openTerminal(c,m){return this.spawnTerminal(u,c,b.getWindowsShell(),m)}spawnTerminal(c,m,a,d){const i=m.windowsExec||P.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const o=D.basename(i).toLowerCase();if(o==="cmder"||o==="cmder.exe")return c.spawn(i,d?[d]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return i.indexOf(" ")>=0&&r.push('""'),r.push(i),(o==="wt"||o==="wt.exe")&&r.push("-d ."),new Promise((t,s)=>{const l=p(process),h=c.spawn(a,r,{cwd:d,env:l});h.on("error",s),h.on("exit",()=>t())})}runInTerminal(c,m,a,d,i){const o="windowsExec"in i&&i.windowsExec?i.windowsExec:P.getDefaultTerminalWindows();return new Promise((r,t)=>{const s=`"${m} - ${k}"`,l=`""${a.join('" "')}" & pause"`,h=["/c","start",s,"/wait",o,"/c",l],S=Object.assign({},p(process),d);Object.keys(S).filter(M=>S[M]===null).forEach(M=>delete S[M]);const L={cwd:m,env:S,windowsVerbatimArguments:!0};u.spawn(P.CMD,h,L).on("error",M=>{t(f(M))}),r(void 0)})}static getDefaultTerminalWindows(){if(!P._DEFAULT_TERMINAL_WINDOWS){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");P._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return P._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=P,P.CMD="cmd.exe";class v extends _{openTerminal(c,m){return this.spawnTerminal(u,c,m)}runInTerminal(c,m,a,d,i){const o=i.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((r,t)=>{if(o===R.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const s=o===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",h=[n.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${s}.scpt`,J).fsPath,"-t",c||k,"-w",m];for(const F of a)h.push("-a"),h.push(F);if(d){const F=Object.assign({},p(process),d);for(const M in F){const A=F[M];A===null?(h.push("-u"),h.push(M)):(h.push("-e"),h.push(`${M}=${A}`))}}let S="";const L=u.spawn(v.OSASCRIPT,h);L.on("error",F=>{t(f(F))}),L.stderr.on("data",F=>{S+=F.toString()}),L.on("exit",F=>{if(F===0)r(void 0);else if(S){const M=S.split(`
`,1);t(new Error(M[0]))}else t(new Error(I.localize(1,null,s,F)))})}else t(new Error(I.localize(2,null,o)))})}spawnTerminal(c,m,a){const d=m.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((i,o)=>{const r=["-a",d];a&&r.push(a);const t=p(process),s=c.spawn("/usr/bin/open",r,{cwd:a,env:t});s.on("error",o),s.on("exit",()=>i())})}}e.MacExternalTerminalService=v,v.OSASCRIPT="/usr/bin/osascript";class w extends _{openTerminal(c,m){return this.spawnTerminal(u,c,m)}runInTerminal(c,m,a,d,i){const o=i.linuxExec?Promise.resolve(i.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((r,t)=>{const s=[];o.then(l=>{l.indexOf("gnome-terminal")>=0?s.push("-x"):s.push("-e"),s.push("bash"),s.push("-c");const h=`${E(a)}; echo; read -p "${w.WAIT_MESSAGE}" -n1;`;s.push(`''${h}''`);const S=Object.assign({},p(process),d);Object.keys(S).filter(A=>S[A]===null).forEach(A=>delete S[A]);const L={cwd:m,env:S};let F="";const M=u.spawn(l,s,L);M.on("error",A=>{t(f(A))}),M.stderr.on("data",A=>{F+=A.toString()}),M.on("exit",A=>{if(A===0)r(void 0);else if(F){const B=F.split(`
`,1);t(new Error(B[0]))}else t(new Error(I.localize(4,null,l,A)))})})})}static async getDefaultTerminalLinuxReady(){if(!w._DEFAULT_TERMINAL_LINUX_READY)if(!T.isLinux)w._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const c=await y.Promises.exists("/etc/debian_version");w._DEFAULT_TERMINAL_LINUX_READY=new Promise(m=>{c?m("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?m("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?m("konsole"):process.env.COLORTERM?m(process.env.COLORTERM):process.env.TERM?m(process.env.TERM):m("xterm")})}return w._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(c,m,a){const d=m.linuxExec?Promise.resolve(m.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((i,o)=>{d.then(r=>{const t=p(process),s=c.spawn(r,[],{cwd:a,env:t});s.on("error",o),s.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=w,w.WAIT_MESSAGE=I.localize(3,null);function p(g){const c={...g.env};return(0,C.sanitizeProcessEnvironment)(c),c}function f(g){return"errno"in g&&g.errno==="ENOENT"&&"path"in g&&typeof g.path=="string"?new Error(I.localize(5,null,g.path)):g}function E(g){let c="";for(const m of g)m.indexOf(" ")>=0?c+='"'+m+'"':c+=m,c+=" ";return c}}),define(Ie[43],ke([0,1,25,9,8,11,2,167,4]),function(J,e,u,n,D,T,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function I(z){return z.create===!0}e.isFileOpenForWriteOptions=I;var R;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var k;(function(z){z[z.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var _;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileClone=32768]="FileClone"})(_=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function P(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=P;function v(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=v;function w(z){return!!(z.capabilities&32768)}e.hasFileCloneCapability=w;function p(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function f(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=f;function E(z){return P(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=E;var g;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(N,V){super(N);this.code=V}}e.FileSystemProviderError=c;function m(z,N){const V=new c(z.toString(),N);return d(V,N),V}e.createFileSystemProviderError=m;function a(z){return z||m((0,y.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=a;function d(z,N){return z.name=N?`${N} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=d;function i(z){if(!z)return g.Unknown;if(z instanceof c)return z.code;const N=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!N)return g.Unknown;switch(N[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=i;function o(z){if(z instanceof S)return z.fileOperationResult;switch(i(z)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var r;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class t{constructor(N,V,x){this.resource=N,this.operation=V,this.target=x}isOperation(N){return this.operation===N}}e.FileOperationEvent=t;var s;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class l{constructor(N,V){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=N;const x=new Map;for(const q of N){const te=x.get(q.type);switch(te?te.push([q.resource,q]):x.set(q.type,[[q.resource,q]]),q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}}for(const[q,te]of x)switch(q){case 1:this.added=u.TernarySearchTree.forUris(()=>V),this.added.fill(te);break;case 0:this.updated=u.TernarySearchTree.forUris(()=>V),this.updated.fill(te);break;case 2:this.deleted=u.TernarySearchTree.forUris(()=>V),this.deleted.fill(te);break}}contains(N,...V){return this.doContains(N,{includeChildren:!1},...V)}affects(N,...V){return this.doContains(N,{includeChildren:!0},...V)}doContains(N,V,...x){if(!N)return!1;const q=x.length>0;return!!((!q||x.includes(1))&&(this.added?.get(N)||V.includeChildren&&this.added?.findSuperstr(N))||(!q||x.includes(0))&&(this.updated?.get(N)||V.includeChildren&&this.updated?.findSuperstr(N))||(!q||x.includes(2))&&(this.deleted?.findSubstr(N)||V.includeChildren&&this.deleted?.findSuperstr(N)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=l;function h(z,N,V){return!z||!N||z===N||N.length>z.length?!1:(N.charAt(N.length-1)!==n.sep&&(N+=n.sep),V?(0,D.startsWithIgnoreCase)(z,N):z.indexOf(N)===0)}e.isParent=h;class S extends Error{constructor(N,V,x){super(N);this.fileOperationResult=V,this.options=x}}e.FileOperationError=S;class L extends S{constructor(N,V,x){super(N,2,x);this.stat=V}}e.NotModifiedSinceFileOperationError=L;var F;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(F=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var M;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(M=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function A(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=A;async function B(z,N){if(!N.hasProvider(C.URI.from({scheme:z.scheme})))return new Promise(V=>{const x=N.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===z.scheme&&q.added&&(x.dispose(),V())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(N){return(0,T.isNumber)(N)||(N=0),N<$.KB?(0,y.localize)(1,null,N.toFixed(0)):N<$.MB?(0,y.localize)(2,null,(N/$.KB).toFixed(2)):N<$.GB?(0,y.localize)(3,null,(N/$.MB).toFixed(2)):N<$.TB?(0,y.localize)(4,null,(N/$.GB).toFixed(2)):(0,y.localize)(5,null,(N/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var U;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(U=e.Arch||(e.Arch={}));function X(z){return{maxFileSize:z===0?300*$.MB:16*$.GB,maxHeapSize:z===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=X}),define(Ie[85],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class u{constructor(...D){this._entries=new Map;for(const[T,C]of D)this.set(T,C)}set(D,T){const C=this._entries.get(D);return this._entries.set(D,T),C}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=u}),define(Ie[195],ke([0,1,18,12,116,191,4,85]),function(J,e,u,n,D,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class I extends Error{constructor(v){super("cyclic dependency between services");this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class R{constructor(v=new y.ServiceCollection,w=!1,p){this._activeInstantiations=new Set,this._services=v,this._strict=w,this._parent=p,this._services.set(C.IInstantiationService,this)}createChild(v){return new R(v,this._strict,this)}invokeFunction(v,...w){const p=_.traceInvocation(v);let f=!1;try{return v({get:g=>{if(f)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(g,p);if(!c)throw new Error(`[invokeFunction] unknown service '${g}'`);return c}},...w)}finally{f=!0,p.stop()}}createInstance(v,...w){let p,f;return v instanceof D.SyncDescriptor?(p=_.traceCreation(v.ctor),f=this._createInstance(v.ctor,v.staticArguments.concat(w),p)):(p=_.traceCreation(v),f=this._createInstance(v,w,p)),p.stop(),f}_createInstance(v,w=[],p){const f=C._util.getServiceDependencies(v).sort((c,m)=>c.index-m.index),E=[];for(const c of f){const m=this._getOrCreateServiceInstance(c.id,p);m||this._throwIfStrict(`[createInstance] ${v.name} depends on UNKNOWN service ${c.id}.`,!1),E.push(m)}const g=f.length>0?f[0].index:w.length;if(w.length!==g){console.trace(`[createInstance] First service dependency of ${v.name} at position ${g+1} conflicts with ${w.length} static arguments`);const c=g-w.length;c>0?w=w.concat(new Array(c)):w=w.slice(0,g)}return new v(...[...w,...E])}_setServiceInstance(v,w){if(this._services.get(v)instanceof D.SyncDescriptor)this._services.set(v,w);else if(this._parent)this._parent._setServiceInstance(v,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(v){const w=this._services.get(v);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(v):w}_getOrCreateServiceInstance(v,w){const p=this._getServiceInstanceOrDescriptor(v);return p instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(v,p,w.branch(v,!0)):(w.branch(v,!1),p)}_safeCreateAndCacheServiceInstance(v,w,p){if(this._activeInstantiations.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this._activeInstantiations.add(v);try{return this._createAndCacheServiceInstance(v,w,p)}finally{this._activeInstantiations.delete(v)}}_createAndCacheServiceInstance(v,w,p){const f=new T.Graph(c=>c.id.toString());let E=0;const g=[{id:v,desc:w,_trace:p}];for(;g.length;){const c=g.pop();if(f.lookupOrInsertNode(c),E++>1e3)throw new I(f);for(const m of C._util.getServiceDependencies(c.desc.ctor)){const a=this._getServiceInstanceOrDescriptor(m.id);if(a||this._throwIfStrict(`[createInstance] ${v} depends on ${m.id} which is NOT registered.`,!0),a instanceof D.SyncDescriptor){const d={id:m.id,desc:a,_trace:c._trace.branch(m.id,!0)};f.insertEdge(c,d),g.push(d)}}}for(;;){const c=f.roots();if(c.length===0){if(!f.isEmpty())throw new I(f);break}for(const{data:m}of c){if(this._getServiceInstanceOrDescriptor(m.id)instanceof D.SyncDescriptor){const d=this._createServiceInstanceWithOwner(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this._setServiceInstance(m.id,d)}f.removeNode(m)}}return this._getServiceInstanceOrDescriptor(v)}_createServiceInstanceWithOwner(v,w,p=[],f,E){if(this._services.get(v)instanceof D.SyncDescriptor)return this._createServiceInstance(w,p,f,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(v,w,p,f,E);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(v,w=[],p,f){if(p){const E=new u.IdleValue(()=>this._createInstance(v,w,f));return new Proxy(Object.create(null),{get(g,c){if(c in g)return g[c];const m=E.value;let a=m[c];return typeof a!="function"||(a=a.bind(m),g[c]=a),a},set(g,c,m){return E.value[c]=m,!0}})}else return this._createInstance(v,w,f)}_throwIfStrict(v,w){if(w&&console.warn(v),this._strict)throw new Error(v)}}e.InstantiationService=R;var k;(function(P){P[P.Creation=0]="Creation",P[P.Invocation=1]="Invocation",P[P.Branch=2]="Branch"})(k||(k={}));class _{constructor(v,w){this.type=v,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(v){return b?new _(1,v.name||v.toString().substring(0,42).replace(/\n/g,"")):_._None}static traceCreation(v){return b?new _(0,v.name):_._None}branch(v,w){const p=new _(2,v.toString());return this._dep.push([v,w,p]),p}stop(){const v=Date.now()-this._start;_._totals+=v;let w=!1;function p(E,g){const c=[],m=new Array(E+1).join("	");for(const[a,d,i]of g._dep)if(d&&i){w=!0,c.push(`${m}CREATES -> ${a}`);const o=p(E+1,i);o&&c.push(o)}else c.push(`${m}uses -> ${a}`);return c.join(`
`)}const f=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${_._totals.toFixed(2)}ms)`];(v>2||w)&&console.log(f.join(`
`))}}e.Trace=_,_._None=new class extends _{constructor(){super(-1,null)}stop(){}branch(){return this}},_._totals=0}),define(Ie[14],ke([0,1,49,3,6,13,4]),function(J,e,u,n,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,C.createDecorator)("logService"),e.ILoggerService=(0,C.createDecorator)("loggerService");function y(){return new Date().toISOString()}var b;(function(d){d[d.Trace=0]="Trace",d[d.Debug=1]="Debug",d[d.Info=2]="Info",d[d.Warning=3]="Warning",d[d.Error=4]="Error",d[d.Critical=5]="Critical",d[d.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function I(d,i,o){switch(i){case b.Trace:d.trace(o);break;case b.Debug:d.debug(o);break;case b.Info:d.info(o);break;case b.Warning:d.warn(o);break;case b.Error:d.error(o);break;case b.Critical:d.critical(o);break;default:throw new Error("Invalid log level")}}e.log=I;function R(d){let i="";for(let o=0;o<d.length;o++){let r=d[o];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}i+=(o>0?" ":"")+r}return i}e.format=R;class k extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class _ extends k{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...o){this.checkLogLevel(b.Trace)&&this.log(b.Trace,R([i,...o]))}debug(i,...o){this.checkLogLevel(b.Debug)&&this.log(b.Debug,R([i,...o]))}info(i,...o){this.checkLogLevel(b.Info)&&this.log(b.Info,R([i,...o]))}warn(i,...o){this.checkLogLevel(b.Warning)&&this.log(b.Warning,R([i,...o]))}error(i,...o){if(this.checkLogLevel(b.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(b.Error,R(r))}else this.log(b.Error,R([i,...o]))}critical(i,...o){this.checkLogLevel(b.Critical)&&this.log(b.Critical,R([i,...o]))}flush(){}}e.AbstractMessageLogger=_;class P extends k{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!T.isWindows}trace(i,...o){this.getLevel()<=b.Trace&&(this.useColors?console.log(`[90m[main ${y()}][0m`,i,...o):console.log(`[main ${y()}]`,i,...o))}debug(i,...o){this.getLevel()<=b.Debug&&(this.useColors?console.log(`[90m[main ${y()}][0m`,i,...o):console.log(`[main ${y()}]`,i,...o))}info(i,...o){this.getLevel()<=b.Info&&(this.useColors?console.log(`[90m[main ${y()}][0m`,i,...o):console.log(`[main ${y()}]`,i,...o))}warn(i,...o){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`[93m[main ${y()}][0m`,i,...o):console.warn(`[main ${y()}]`,i,...o))}error(i,...o){this.getLevel()<=b.Error&&(this.useColors?console.error(`[91m[main ${y()}][0m`,i,...o):console.error(`[main ${y()}]`,i,...o))}critical(i,...o){this.getLevel()<=b.Critical&&(this.useColors?console.error(`[90m[main ${y()}][0m`,i,...o):console.error(`[main ${y()}]`,i,...o))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class v extends k{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...o){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",i,...o)}debug(i,...o){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...o)}info(i,...o){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",i,...o)}warn(i,...o){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",i,...o)}error(i,...o){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",i,...o)}critical(i,...o){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...o)}dispose(){}flush(){}}e.ConsoleLogger=v;class w extends k{constructor(i,o=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(o)}trace(i,...o){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(i),...o])}debug(i,...o){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(i),...o])}info(i,...o){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(i),...o])}warn(i,...o){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(i),...o])}error(i,...o){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(i),...o])}critical(i,...o){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(i),...o])}extractMessage(i){return typeof i=="string"?i:(0,u.toErrorMessage)(i,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=w;class p extends k{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const o of this.logServices)o.setLevel(i);super.setLevel(i)}trace(i,...o){for(const r of this.logServices)r.trace(i,...o)}debug(i,...o){for(const r of this.logServices)r.debug(i,...o)}info(i,...o){for(const r of this.logServices)r.info(i,...o)}warn(i,...o){for(const r of this.logServices)r.warn(i,...o)}error(i,...o){for(const r of this.logServices)r.error(i,...o)}critical(i,...o){for(const r of this.logServices)r.critical(i,...o)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=p;class f extends D.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...o){this.logger.trace(i,...o)}debug(i,...o){this.logger.debug(i,...o)}info(i,...o){this.logger.info(i,...o)}warn(i,...o){this.logger.warn(i,...o)}error(i,...o){this.logger.error(i,...o)}critical(i,...o){this.logger.critical(i,...o)}flush(){this.logger.flush()}}e.LogService=f;class E extends D.Disposable{constructor(i,o){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(o(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,o){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,o?.always?b.Trace:this.logLevel,o),this.loggers.set(i.toString(),r),o?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=E;class g{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(i){}getLevel(){return b.Info}trace(i,...o){}debug(i,...o){}info(i,...o){}warn(i,...o){}error(i,...o){}critical(i,...o){}dispose(){}flush(){}}e.NullLogService=g;function c(d){if(d.verbose)return b.Trace;if(typeof d.logLevel=="string"){const i=m(d.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function m(d){switch(d){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=m;function a(d){switch(d){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=a}),define(Ie[196],ke([0,1,43,14]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(y,b,I,R,k){try{const _=await new Promise((v,w)=>{J(["spdlog"],v,w)});_.setFlushOn(n.LogLevel.Trace);const P=await _.createAsyncRotatingLogger(y,b,I,R);return k&&P.clearFormatters(),P}catch(_){console.error(_)}return null}function T(y,b,I){switch(b){case n.LogLevel.Trace:y.trace(I);break;case n.LogLevel.Debug:y.debug(I);break;case n.LogLevel.Info:y.info(I);break;case n.LogLevel.Warning:y.warn(I);break;case n.LogLevel.Error:y.error(I);break;case n.LogLevel.Critical:y.critical(I);break;default:throw new Error("Invalid log level")}}class C extends n.AbstractMessageLogger{constructor(b,I,R,k,_){super();this.buffer=[],this.setLevel(_),this._loggerCreationPromise=this._createSpdLogLogger(b,I,R,k),this._register(this.onDidChangeLogLevel(P=>{this._logger?.setLevel(P)}))}async _createSpdLogLogger(b,I,R,k){const _=R?6:1,P=30/_*u.ByteSize.MB,v=await D(b,I,P,_,k);if(v){this._logger=v,this._logger.setLevel(this.getLevel());for(const{level:w,message:p}of this.buffer)T(this._logger,w,p);this.buffer=[]}}log(b,I){this._logger?T(this._logger,b,I):this.getLevel()<=b&&this.buffer.push({level:b,message:I})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=C}),define(Ie[117],ke([0,1,41,168,4]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var C;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(b){function I(v,w){return w-v}b.compare=I;const R=Object.create(null);R[b.Error]=(0,n.localize)(0,null),R[b.Warning]=(0,n.localize)(1,null),R[b.Info]=(0,n.localize)(2,null);function k(v){return R[v]||""}b.toString=k;function _(v){switch(v){case u.default.Error:return b.Error;case u.default.Warning:return b.Warning;case u.default.Info:return b.Info;case u.default.Ignore:return b.Hint}}b.fromSeverity=_;function P(v){switch(v){case b.Error:return u.default.Error;case b.Warning:return u.default.Warning;case b.Info:return u.default.Info;case b.Hint:return u.default.Ignore}}b.toSeverity=P}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var y;(function(b){const I="";function R(_){return k(_,!0)}b.makeKey=R;function k(_,P){const v=[I];return _.source?v.push(_.source.replace("\xA6","\\\xA6")):v.push(I),_.code?typeof _.code=="string"?v.push(_.code.replace("\xA6","\\\xA6")):v.push(_.code.value.replace("\xA6","\\\xA6")):v.push(I),_.severity!==void 0&&_.severity!==null?v.push(C.toString(_.severity)):v.push(I),_.message&&P?v.push(_.message.replace("\xA6","\\\xA6")):v.push(I),_.startLineNumber!==void 0&&_.startLineNumber!==null?v.push(_.startLineNumber.toString()):v.push(I),_.startColumn!==void 0&&_.startColumn!==null?v.push(_.startColumn.toString()):v.push(I),_.endLineNumber!==void 0&&_.endLineNumber!==null?v.push(_.endLineNumber.toString()):v.push(I),_.endColumn!==void 0&&_.endColumn!==null?v.push(_.endColumn.toString()):v.push(I),v.push(I),v.join("\xA6")}b.makeKeyOptionalMessage=k})(y=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(Ie[197],ke([0,1,3,41,4]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=n.default,e.INotificationService=(0,D.createDecorator)("notificationService");var T;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class y{constructor(){this.progress=new b,this.onDidClose=u.Event.None,this.onDidChangeVisibility=u.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=y;class b{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=b}),define(Ie[118],ke([0,1,6,8,2,4]),function(J,e,u,n,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return u.Disposable.None},registerValidator(){return u.Disposable.None},registerExternalUriResolver(){return u.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return u.Disposable.None},async open(){return!1},async resolveExternalUri(R){return{resolved:R,dispose(){}}}});function C(R,k){return D.URI.isUri(R)?(0,n.equalsIgnoreCase)(R.scheme,k):(0,n.startsWithIgnoreCase)(R,k+":")}e.matchesScheme=C;function y(R,...k){return k.some(_=>C(R,_))}e.matchesSomeScheme=y;function b(R,k){return R.with({fragment:`${k.startLineNumber},${k.startColumn}${k.endLineNumber?`-${k.endLineNumber}${k.endColumn?`,${k.endColumn}`:""}`:""}`})}e.withSelection=b;function I(R){let k;const _=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(R.fragment);return _&&(k={startLineNumber:parseInt(_[1]),startColumn:_[2]?parseInt(_[2]):1,endLineNumber:_[4]?parseInt(_[4]):void 0,endColumn:_[4]?_[5]?parseInt(_[5]):1:void 0},R=R.with({fragment:""})),{selection:k,uri:R}}e.extractSelection=I}),define(Ie[198],ke([0,1,10,13,36,22,189]),function(J,e,u,n,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const b=n.globals.vscode.context.configuration();if(b)y=b.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const b=(0,T.dirname)(u.FileAccess.asFileUri("",J));y=J.__$__nodeRequire((0,T.joinPath)(b,"product.json").fsPath);const I=J.__$__nodeRequire((0,T.joinPath)(b,"package.json").fsPath);try{const w=(...g)=>g.reduce((c,m)=>(Object.keys(m).forEach(a=>{Array.isArray(c[a])&&Array.isArray(m[a])?c[a]=m[a]:typeof c[a]=="object"&&typeof m[a]=="object"?c[a]=w(c[a],m[a]):c[a]=m[a]}),c),{}),p=(0,C.getUserDataPath)({}),f=n.isWindows?`file:///${p}/product.json`:`file://${p}/product.json`,E=J.__$__nodeRequire(u.FileAccess.asFileUri(f,J).fsPath);y=w(y,E)}catch{}D.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`,serverDataFolderName:y.serverDataFolderName?`${y.serverDataFolderName}-dev`:void 0});const{serviceUrl:R,cacheUrl:k,itemUrl:_,controlUrl:P,recommendationsUrl:v}=y.extensionsGallery||{};Object.assign(y,{extensionsGallery:{serviceUrl:D.env.VSCODE_GALLERY_SERVICE_URL||R,cacheUrl:D.env.VSCODE_GALLERY_CACHE_URL||k,itemUrl:D.env.VSCODE_GALLERY_ITEM_URL||_,controlUrl:D.env.VSCODE_GALLERY_CONTROL_URL||P,recommendationsUrl:D.env.VSCODE_GALLERY_RECOMMENDATIONS_URL||v}}),Object.assign(y,{version:I.version,release:I.release})}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=y}),define(Ie[199],ke([0,1,4]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,u.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function(J,e){return function(u,n){e(u,n,J)}};define(Ie[119],ke([0,1,18,21,6,4]),function(J,e,u,n,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,T.createDecorator)("progressService");var C;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class y{constructor(k){this.callback=k}get value(){return this._value}report(k){this._value=k,this.callback(this._value)}}e.Progress=y,y.None=Object.freeze({report(){}});let b=class extends D.Disposable{constructor(k,_){super();this.deferred=new u.DeferredPromise,_.withProgress(k,P=>(this.reporter=P,this.lastStep&&P.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};b=je([Ve(1,e.IProgressService)],b),e.UnmanagedProgress=b;class I extends D.Disposable{constructor(k){super();this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(k){this.stop();const _=++this.currentOperationId,P=new n.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{_===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>P.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:_,token:P.token,stop:()=>this.doStop(_),isCurrent:()=>this.currentOperationId===_}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,T.createDecorator)("editorProgressService")}),define(Ie[44],ke([0,1,56,11]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(C,y){u.ok(n.isString(C)),u.ok(n.isObject(y)),u.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,y)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}e.Registry=new D}),define(Ie[120],ke([0,1,3,44]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class T{constructor(){this._onDidChangeSchema=new u.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,I){this.schemasById[D(b)]=I,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new T;n.Registry.add(e.Extensions.JSONContribution,C)}),define(Ie[121],ke([0,1,16,3,11,163,83,120,44]),function(J,e,u,n,D,T,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=b.Registry.as(y.Extensions.JSONContribution);class _{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(a,d=!0){this.registerConfigurations([a],d)}registerConfigurations(a,d=!0){const i=this.doRegisterConfigurations(a,d);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(a){const d=this.doDeregisterConfigurations(a);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d})}updateConfigurations({add:a,remove:d}){const i=[];i.push(...this.doDeregisterConfigurations(d)),i.push(...this.doRegisterConfigurations(a,!1)),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,u.distinct)(i)})}registerDefaultConfigurations(a){const d=[],i=[];for(const{overrides:o,source:r}of a)for(const t in o)if(d.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){const s=this.configurationDefaultsOverrides.get(t),l=s?.valuesSources??new Map;if(r)for(const F of Object.keys(o[t]))l.set(F,r);const h={...s?.value||{},...o[t]};this.configurationDefaultsOverrides.set(t,{source:r,value:h,valuesSources:l});const S=(0,C.getLanguageTagSettingPlainKey)(t),L={type:"object",default:h,description:T.localize(1,null,S),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:D.isString(r)?void 0:r,defaultValueSource:r};i.push(...w(t)),this.configurationProperties[t]=L,this.defaultLanguageConfigurationOverridesNode.properties[t]=L}else{this.configurationDefaultsOverrides.set(t,{value:o[t],source:r});const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}deregisterDefaultConfigurations(a){const d=[];for(const{overrides:i,source:o}of a)for(const r in i){const t=this.configurationDefaultsOverrides.get(r),s=D.isString(o)?o:o?.id,l=D.isString(t?.source)?t?.source:t?.source?.id;if(s===l)if(d.push(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const h=this.configurationProperties[r];h&&(this.updatePropertyDefaultValue(r,h),this.updateSchema(r,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...a){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(a){for(const d of a)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(a,d){const i=[];return a.forEach(o=>{i.push(...this.validateAndRegisterProperties(o,d,o.extensionInfo,o.restrictedProperties)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),i}doDeregisterConfigurations(a){const d=[],i=o=>{if(o.properties)for(const r in o.properties){d.push(r);const t=this.configurationProperties[r];t?.policy?.name&&this.policyConfigurations.delete(t.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,o.properties[r])}o.allOf?.forEach(r=>i(r))};for(const o of a){i(o);const r=this.configurationContributors.indexOf(o);r!==-1&&this.configurationContributors.splice(r,1)}return d}validateAndRegisterProperties(a,d=!0,i,o,r=3){r=D.isUndefinedOrNull(a.scope)?r:a.scope;const t=[],s=a.properties;if(s)for(const h in s){const S=s[h];if(d&&g(h,S)){delete s[h];continue}if(S.source=i,S.defaultDefaultValue=s[h].default,this.updatePropertyDefaultValue(h,S),e.OVERRIDE_PROPERTY_REGEX.test(h)?S.scope=void 0:(S.scope=D.isUndefinedOrNull(S.scope)?r:S.scope,S.restricted=D.isUndefinedOrNull(S.restricted)?!!o?.includes(h):S.restricted),s[h].hasOwnProperty("included")&&!s[h].included){this.excludedConfigurationProperties[h]=s[h],delete s[h];continue}else this.configurationProperties[h]=s[h],s[h].policy?.name&&this.policyConfigurations.set(s[h].policy.name,h);!s[h].deprecationMessage&&s[h].markdownDeprecationMessage&&(s[h].deprecationMessage=s[h].markdownDeprecationMessage),t.push(h)}const l=a.allOf;if(l)for(const h of l)t.push(...this.validateAndRegisterProperties(h,d,i,o,r));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(a){const d=i=>{const o=i.properties;if(o)for(const t in o)this.updateSchema(t,o[t]);i.allOf?.forEach(d)};d(a)}updateSchema(a,d){switch(e.allSettings.properties[a]=d,d.scope){case 1:e.applicationSettings.properties[a]=d;break;case 2:e.machineSettings.properties[a]=d;break;case 6:e.machineOverridableSettings.properties[a]=d;break;case 3:e.windowSettings.properties[a]=d;break;case 4:e.resourceSettings.properties[a]=d;break;case 5:e.resourceSettings.properties[a]=d,this.resourceLanguageSettingsSchema.properties[a]=d;break}}removeFromSchema(a,d){switch(delete e.allSettings.properties[a],d.scope){case 1:delete e.applicationSettings.properties[a];break;case 2:delete e.machineSettings.properties[a];break;case 6:delete e.machineOverridableSettings.properties[a];break;case 3:delete e.windowSettings.properties[a];break;case 4:case 5:delete e.resourceSettings.properties[a],delete this.resourceLanguageSettingsSchema.properties[a];break}}updateOverridePropertyPatternKey(){for(const a of this.overrideIdentifiers.values()){const d=`[${a}]`,i={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,i),e.allSettings.properties[d]=i,e.applicationSettings.properties[d]=i,e.machineSettings.properties[d]=i,e.machineOverridableSettings.properties[d]=i,e.windowSettings.properties[d]=i,e.resourceSettings.properties[d]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const a={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(a,d){const i=this.configurationDefaultsOverrides.get(a);let o=i?.value,r=i?.source;D.isUndefined(o)&&(o=d.defaultDefaultValue,r=void 0),D.isUndefined(o)&&(o=f(d.type)),d.default=o,d.defaultValueSource=r}}const P="\\[([^\\]]+)\\]",v=new RegExp(P,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${P})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function w(m){const a=[];if(e.OVERRIDE_PROPERTY_REGEX.test(m)){let d=v.exec(m);for(;d?.length;){const i=d[1].trim();i&&a.push(i),d=v.exec(m)}}return(0,u.distinct)(a)}e.overrideIdentifiersFromKey=w;function p(m){return m.reduce((a,d)=>`${a}[${d}]`,"")}e.keyFromOverrideIdentifiers=p;function f(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const E=new _;b.Registry.add(e.Extensions.Configuration,E);function g(m,a){return m.trim()?e.OVERRIDE_PROPERTY_REGEX.test(m)?T.localize(7,null,m):E.getConfigurationProperties()[m]!==void 0?T.localize(8,null,m):a.policy?.name&&E.getPolicyConfigurations().get(a.policy?.name)!==void 0?T.localize(9,null,m,a.policy?.name,E.getPolicyConfigurations().get(a.policy?.name)):null:T.localize(6,null)}e.validateProperty=g;function c(){const m=[],a=E.getConfigurationProperties();for(const d of Object.keys(a))m.push([d,a[d].scope]);return m.push(["launch",4]),m.push(["task",4]),m}e.getScopes=c}),define(Ie[200],ke([0,1,16,3,142,6,25,24,11,2,83,121,44]),function(J,e,u,n,D,T,C,y,b,I,R,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class P{constructor(d={},i=[],o=[]){this._contents=d,this._keys=i,this._overrides=o,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(d){return d?(0,R.getConfigurationValue)(this.contents,d):this.contents}getOverrideValue(d,i){const o=this.getContentsForOverrideIdentifer(i);return o?d?(0,R.getConfigurationValue)(o,d):o:void 0}getKeysForOverrideIdentifier(d){const i=[];for(const o of this.overrides)o.identifiers.includes(d)&&i.push(...o.keys);return u.distinct(i)}getAllOverrideIdentifiers(){const d=[];for(const i of this.overrides)d.push(...i.identifiers);return u.distinct(d)}override(d){let i=this.overrideConfigurations.get(d);return i||(i=this.createOverrideConfigurationModel(d),this.overrideConfigurations.set(d,i)),i}merge(...d){const i=y.deepClone(this.contents),o=y.deepClone(this.overrides),r=[...this.keys];for(const t of d)if(!t.isEmpty()){this.mergeContents(i,t.contents);for(const s of t.overrides){const[l]=o.filter(h=>u.equals(h.identifiers,s.identifiers));l?(this.mergeContents(l.contents,s.contents),l.keys.push(...s.keys),l.keys=u.distinct(l.keys)):o.push(y.deepClone(s))}for(const s of t.keys)r.indexOf(s)===-1&&r.push(s)}return new P(i,r,o)}freeze(){return this.frozen=!0,this}clone(){return new P(y.deepClone(this.contents),[...this.keys],y.deepClone(this.overrides))}createOverrideConfigurationModel(d){const i=this.getContentsForOverrideIdentifer(d);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const o={};for(const r of u.distinct([...Object.keys(this.contents),...Object.keys(i)])){let t=this.contents[r];const s=i[r];s&&(typeof t=="object"&&typeof s=="object"?(t=y.deepClone(t),this.mergeContents(t,s)):t=s),o[r]=t}return new P(o,this.keys,this.overrides)}mergeContents(d,i){for(const o of Object.keys(i)){if(o in d&&b.isObject(d[o])&&b.isObject(i[o])){this.mergeContents(d[o],i[o]);continue}d[o]=y.deepClone(i[o])}}checkAndFreeze(d){return this.frozen&&!Object.isFrozen(d)?y.deepFreeze(d):d}getContentsForOverrideIdentifer(d){let i=null,o=null;const r=t=>{t&&(o?this.mergeContents(o,t):o=y.deepClone(t))};for(const t of this.overrides)u.equals(t.identifiers,[d])?i=t.contents:t.identifiers.includes(d)&&r(t.contents);return r(i),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(d,i){this.addKey(d),(0,R.addToValueTree)(this.contents,d,i,o=>{throw new Error(o)})}removeValue(d){this.removeKey(d)&&(0,R.removeFromValueTree)(this.contents,d)}addKey(d){let i=this.keys.length;for(let o=0;o<i;o++)d.indexOf(this.keys[o])===0&&(i=o);this.keys.splice(i,1,d)}removeKey(d){const i=this.keys.indexOf(d);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=P;class v{constructor(d){this._name=d,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new P}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(d,i){if(!b.isUndefinedOrNull(d)){const o=this.doParseContent(d);this.parseRaw(o,i)}}reparse(d){this._raw&&this.parseRaw(this._raw,d)}parseRaw(d,i){this._raw=d;const{contents:o,keys:r,overrides:t,restricted:s}=this.doParseRaw(d,i);this._configurationModel=new P(o,r,t),this._restrictedConfigurations=s||[]}doParseContent(d){let i={},o=null,r=[];const t=[],s=[];function l(S){Array.isArray(r)?r.push(S):o!==null&&(r[o]=S)}const h={onObjectBegin:()=>{const S={};l(S),t.push(r),r=S,o=null},onObjectProperty:S=>{o=S},onObjectEnd:()=>{r=t.pop()},onArrayBegin:()=>{const S=[];l(S),t.push(r),r=S,o=null},onArrayEnd:()=>{r=t.pop()},onLiteralValue:l,onError:(S,L,F)=>{s.push({error:S,offset:L,length:F})}};if(d)try{D.visit(d,h),i=r[0]||{}}catch(S){console.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return i}doParseRaw(d,i){const o=_.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),r=this.filter(d,o,!0,i);d=r.raw;const t=(0,R.toValuesTree)(d,h=>console.error(`Conflict in settings file ${this._name}: ${h}`)),s=Object.keys(d),l=this.toOverrides(d,h=>console.error(`Conflict in settings file ${this._name}: ${h}`));return{contents:t,keys:s,overrides:l,restricted:r.restricted}}filter(d,i,o,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:d,restricted:[]};const t={},s=[];for(const l in d)if(k.OVERRIDE_PROPERTY_REGEX.test(l)&&o){const h=this.filter(d[l],i,!1,r);t[l]=h.raw,s.push(...h.restricted)}else{const h=i[l],S=h?typeof h.scope!="undefined"?h.scope:3:void 0;h?.restricted&&s.push(l),(S===void 0||r.scopes===void 0||r.scopes.includes(S))&&(r.skipRestricted&&h?.restricted||(t[l]=d[l]))}return{raw:t,restricted:s}}toOverrides(d,i){const o=[];for(const r of Object.keys(d))if(k.OVERRIDE_PROPERTY_REGEX.test(r)){const t={};for(const s in d[r])t[s]=d[r][s];o.push({identifiers:(0,k.overrideIdentifiersFromKey)(r),keys:Object.keys(t),contents:(0,R.toValuesTree)(t,i)})}return o}}e.ConfigurationModelParser=v;class w extends T.Disposable{constructor(d,i,o,r){super();this.userSettingsResource=d,this.scopes=i,this.fileService=r,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.any(n.Event.filter(this.fileService.onDidFilesChange,t=>t.contains(this.userSettingsResource)),n.Event.filter(this.fileService.onDidRunOperation,t=>(t.isOperation(0)||t.isOperation(3)||t.isOperation(1)||t.isOperation(4))&&o.isEqual(t.resource,d)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const d=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(d.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new P}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class p{constructor(d,i,o,r,t=new P,s=new P,l=new C.ResourceMap,h=new P,S=new C.ResourceMap,L=!0){this._defaultConfiguration=d,this._policyConfiguration=i,this._applicationConfiguration=o,this._localUserConfiguration=r,this._remoteUserConfiguration=t,this._workspaceConfiguration=s,this._folderConfigurations=l,this._memoryConfiguration=h,this._memoryConfigurationByResource=S,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(d,i,o){return this.getConsolidatedConfigurationModel(d,i,o).getValue(d)}updateValue(d,i,o={}){let r;o.resource?(r=this._memoryConfigurationByResource.get(o.resource),r||(r=new P,this._memoryConfigurationByResource.set(o.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(d):r.setValue(d,i),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(d,i,o){const r=this.getConsolidatedConfigurationModel(d,i,o),t=this.getFolderConfigurationModelForResource(i.resource,o),s=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,l=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(d):this._defaultConfiguration.freeze().getValue(d),h=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(d),S=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(d),L=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(d):this.userConfiguration.freeze().getValue(d),F=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(d):this.localUserConfiguration.freeze().getValue(d),M=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(d):this.remoteUserConfiguration.freeze().getValue(d),A=o?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(d):this._workspaceConfiguration.freeze().getValue(d):void 0,B=t?i.overrideIdentifier?t.freeze().override(i.overrideIdentifier).getValue(d):t.freeze().getValue(d):void 0,$=i.overrideIdentifier?s.override(i.overrideIdentifier).getValue(d):s.getValue(d),U=r.getValue(d),X=u.distinct(r.overrides.map(z=>z.identifiers).flat()).filter(z=>r.getOverrideValue(d,z)!==void 0);return{defaultValue:l,policyValue:h,applicationValue:S,userValue:L,userLocalValue:F,userRemoteValue:M,workspaceValue:A,workspaceFolderValue:B,memoryValue:$,value:U,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(d),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(d,i.overrideIdentifier):void 0}:void 0,policy:h!==void 0?{value:h}:void 0,application:S!==void 0?{value:S,override:i.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(d,i.overrideIdentifier):void 0}:void 0,user:L!==void 0?{value:this.userConfiguration.freeze().getValue(d),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(d,i.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(d),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(d,i.overrideIdentifier):void 0}:void 0,userRemote:M!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(d),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(d,i.overrideIdentifier):void 0}:void 0,workspace:A!==void 0?{value:this._workspaceConfiguration.freeze().getValue(d),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(d,i.overrideIdentifier):void 0}:void 0,workspaceFolder:B!==void 0?{value:t?.freeze().getValue(d),override:i.overrideIdentifier?t?.freeze().getOverrideValue(d,i.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:s.getValue(d),override:i.overrideIdentifier?s.getOverrideValue(d,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:X.length?X:void 0}}keys(d){const i=this.getFolderConfigurationModelForResource(void 0,d);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(d){this._defaultConfiguration=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(d){this._policyConfiguration=d}updateApplicationConfiguration(d){this._applicationConfiguration=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(d){this._localUserConfiguration=d,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(d){this._remoteUserConfiguration=d,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(d){this._workspaceConfiguration=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(d,i){this._folderConfigurations.set(d,i),this._foldersConsolidatedConfigurations.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this._foldersConsolidatedConfigurations.delete(d)}compareAndUpdateDefaultConfiguration(d,i){const o=[];if(!i){const{added:r,updated:t,removed:s}=c(this._defaultConfiguration,d);i=[...r,...t,...s]}for(const r of i)for(const t of(0,k.overrideIdentifiersFromKey)(r)){const s=this._defaultConfiguration.getKeysForOverrideIdentifier(t),l=d.getKeysForOverrideIdentifier(t),h=[...l.filter(S=>s.indexOf(S)===-1),...s.filter(S=>l.indexOf(S)===-1),...s.filter(S=>!y.equals(this._defaultConfiguration.override(t).getValue(S),d.override(t).getValue(S)))];o.push([t,h])}return this.updateDefaultConfiguration(d),{keys:i,overrides:o}}compareAndUpdatePolicyConfiguration(d){const{added:i,updated:o,removed:r}=c(this._policyConfiguration,d),t=[...i,...o,...r];return t.length&&this.updatePolicyConfiguration(d),{keys:t,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:i,updated:o,removed:r,overrides:t}=c(this.applicationConfiguration,d),s=[...i,...o,...r];return s.length&&this.updateApplicationConfiguration(d),{keys:s,overrides:t}}compareAndUpdateLocalUserConfiguration(d){const{added:i,updated:o,removed:r,overrides:t}=c(this.localUserConfiguration,d),s=[...i,...o,...r];return s.length&&this.updateLocalUserConfiguration(d),{keys:s,overrides:t}}compareAndUpdateRemoteUserConfiguration(d){const{added:i,updated:o,removed:r,overrides:t}=c(this.remoteUserConfiguration,d),s=[...i,...o,...r];return s.length&&this.updateRemoteUserConfiguration(d),{keys:s,overrides:t}}compareAndUpdateWorkspaceConfiguration(d){const{added:i,updated:o,removed:r,overrides:t}=c(this.workspaceConfiguration,d),s=[...i,...o,...r];return s.length&&this.updateWorkspaceConfiguration(d),{keys:s,overrides:t}}compareAndUpdateFolderConfiguration(d,i){const o=this.folderConfigurations.get(d),{added:r,updated:t,removed:s,overrides:l}=c(o,i),h=[...r,...t,...s];return(h.length||!o)&&this.updateFolderConfiguration(d,i),{keys:h,overrides:l}}compareAndDeleteFolderConfiguration(d){const i=this.folderConfigurations.get(d);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:o,updated:r,removed:t,overrides:s}=c(i,void 0);return{keys:[...o,...r,...t],overrides:s}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(d,i,o){let r=this.getConsolidatedConfigurationModelForResource(i,o);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(d)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:d},i){let o=this.getWorkspaceConsolidatedConfiguration();if(i&&d){const r=i.getFolder(d);r&&(o=this.getFolderConsolidatedConfiguration(r.uri)||o);const t=this._memoryConfigurationByResource.get(d);t&&(o=o.merge(t))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(d){let i=this._foldersConsolidatedConfigurations.get(d);if(!i){const o=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(d);r?(i=o.merge(r),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(d,i)):i=o}return i}getFolderConfigurationModelForResource(d,i){if(i&&d){const o=i.getFolder(d);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((d,i)=>{const{contents:o,overrides:r,keys:t}=this._folderConfigurations.get(i);return d.push([i,{contents:o,overrides:r,keys:t}]),d},[])}}allKeys(){const d=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>d.add(i)),this.userConfiguration.freeze().keys.forEach(i=>d.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>d.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(o=>d.add(o))),[...d.values()]}allOverrideIdentifiers(){const d=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>d.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>d.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>d.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(o=>d.add(o))),[...d.values()]}getAllKeysForOverrideIdentifier(d){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(d).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(o=>i.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(d).forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(d).forEach(r=>i.add(r))),[...i.values()]}static parse(d){const i=this.parseConfigurationModel(d.defaults),o=this.parseConfigurationModel(d.policy),r=this.parseConfigurationModel(d.application),t=this.parseConfigurationModel(d.user),s=this.parseConfigurationModel(d.workspace),l=d.folders.reduce((h,S)=>(h.set(I.URI.revive(S[0]),this.parseConfigurationModel(S[1])),h),new C.ResourceMap);return new p(i,o,r,t,new P,s,l,new P,new C.ResourceMap,!1)}static parseConfigurationModel(d){return new P(d.contents,d.keys,d.overrides).freeze()}}e.Configuration=p;function f(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const d=new Set,i=new Map;for(const r of a)r.keys.forEach(t=>d.add(t)),r.overrides.forEach(([t,s])=>{const l=(0,C.getOrSet)(i,t,new Set);s.forEach(h=>l.add(h))});const o=[];return i.forEach((r,t)=>o.push([t,[...r.values()]])),{keys:[...d.values()],overrides:o}}e.mergeChanges=f;class E{constructor(d,i,o,r){this.change=d,this.previous=i,this.currentConfiguraiton=o,this.currentWorkspace=r,this._previousConfiguration=void 0;const t=new Set;d.keys.forEach(l=>t.add(l)),d.overrides.forEach(([,l])=>l.forEach(h=>t.add(h))),this.affectedKeys=[...t.values()];const s=new P;this.affectedKeys.forEach(l=>s.setValue(l,{})),this.affectedKeysTree=s.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(d,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,d)){if(i){const o=this.previousConfiguration?this.previousConfiguration.getValue(d,i,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(d,i,this.currentWorkspace);return!y.equals(o,r)}return!0}return!1}doesAffectedKeysTreeContains(d,i){let o=(0,R.toValuesTree)({[i]:!0},()=>{}),r;for(;typeof o=="object"&&(r=Object.keys(o)[0]);){if(d=d[r],!d)return!1;o=o[r]}return!0}}e.ConfigurationChangeEvent=E;class g extends E{constructor(d,i,o,r){super({keys:d.allKeys(),overrides:[]},void 0,d,i);this.source=o,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=g;function c(a,d){const{added:i,removed:o,updated:r}=m(d,a),t=[],s=a?.getAllOverrideIdentifiers()||[],l=d?.getAllOverrideIdentifiers()||[];if(d){const h=l.filter(S=>!s.includes(S));for(const S of h)t.push([S,d.getKeysForOverrideIdentifier(S)])}if(a){const h=s.filter(S=>!l.includes(S));for(const S of h)t.push([S,a.getKeysForOverrideIdentifier(S)])}if(d&&a){for(const h of s)if(l.includes(h)){const S=m({contents:a.getOverrideValue(void 0,h)||{},keys:a.getKeysForOverrideIdentifier(h)},{contents:d.getOverrideValue(void 0,h)||{},keys:d.getKeysForOverrideIdentifier(h)});t.push([h,[...S.added,...S.removed,...S.updated]])}}return{added:i,removed:o,updated:r,overrides:t}}function m(a,d){const i=a?d?a.keys.filter(t=>d.keys.indexOf(t)===-1):[...a.keys]:[],o=d?a?d.keys.filter(t=>a.keys.indexOf(t)===-1):[...d.keys]:[],r=[];if(a&&d){for(const t of d.keys)if(a.keys.indexOf(t)!==-1){const s=(0,R.getConfigurationValue)(d.contents,t),l=(0,R.getConfigurationValue)(a.contents,t);y.equals(s,l)||r.push(t)}}return{added:i,removed:o,updated:r}}}),define(Ie[122],ke([0,1,12,4]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,n.createDecorator)("remoteAuthorityResolverService");var D;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends u.ErrorNoTelemetry{constructor(y,b=D.Unknown,I){super(y);this._message=y,this._code=b,this._detail=I,this.isHandled=b===D.NotAvailable&&I===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(y){return y instanceof T&&y._code===D.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof T&&y._code===D.NoResolverFound}static isHandled(y){return y instanceof T&&y.isHandled}}e.RemoteAuthorityResolverError=T}),define(Ie[123],ke([0,1,10]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function n(I){return I.scheme===u.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=n;function D(I){if(!I)return;const R=I.indexOf("+");return R<0?I:I.substr(0,R)}e.getRemoteName=D;function T(I){return`/${I.quality??"oss"}-${I.commit??"dev"}`}e.getRemoteServerRootPath=T;function C(I){const{host:R,port:k}=b(I);if(typeof k=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:k}}e.parseAuthorityWithPort=C;function y(I,R){let{host:k,port:_}=b(I);return typeof _=="undefined"&&(_=R),{host:k,port:_}}e.parseAuthorityWithOptionalPort=y;function b(I){const R=I.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const k=I.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const _=I.match(/(.*):(\d+)$/);return _?{host:_[1],port:parseInt(_[2],10)}:{host:I,port:void 0}}}),define(Ie[28],ke([0,1,8,4,123]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=T;function C(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var y;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(y=e.ExtensionType||(e.ExtensionType={}));var b;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(b=e.TargetPlatform||(e.TargetPlatform={}));class I{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,p){if(typeof w=="undefined"||w===null)return typeof p=="undefined"||p===null;if(typeof p=="undefined"||p===null)return!1;if(typeof w=="string"||typeof p=="string"){const f=typeof w=="string"?w:w.value,E=typeof p=="string"?p:p.value;return u.equalsIgnoreCase(f,E)}return w._lower===p._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.ExtensionIdentifier=I;function R(v){return k(v)}e.isApplicationScopedExtension=R;function k(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function _(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=_;function P(v,w){if(w){const p=`onResolveRemoteAuthority:${(0,D.getRemoteName)(w)}`;return v.activationEvents?.indexOf(p)!==-1}return!1}e.isResolverExtension=P,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ie[201],ke([0,1,8,84,28,13,2,12,36]),function(J,e,u,n,D,T,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function I(d,i){return d.uuid&&i.uuid?d.uuid===i.uuid:d.id===i.id?!0:(0,u.compareIgnoreCase)(d.id,i.id)===0}e.areSameExtensions=I;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class k{constructor(i,o,r="undefined"){this.version=o,this.targetPlatform=r,this.id=i.id}static create(i){const o=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new k(i.identifier,o,r)}static parse(i){const o=R.exec(i);return o&&o[1]&&o[2]?new k({id:o[1]},o[2],o[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof k?I(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=k;const _=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function P(d){const i=_.exec(d);return i&&i[1]?[w(i[1]),i[2]]:[w(d),void 0]}e.getIdAndVersion=P;function v(d,i){return`${d}.${i}`}e.getExtensionId=v;function w(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=w;function p(d,i){return w(v(d,i))}e.getGalleryExtensionId=p;function f(d,i){const o=[],r=t=>{for(const s of o)if(s.some(l=>I(i(l),i(t))))return s;return null};for(const t of d){const s=r(t);s?s.push(t):o.push([t])}return o}e.groupByExtension=f;function E(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=E;function g(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function c(d,i){const o=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const t=r.shift();if(t&&o.every(s=>!I(s.identifier,{id:t}))){const s=d.filter(l=>I(l.identifier,{id:t}));s.length===1&&(o.push(s[0]),r.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=c;async function m(d,i){if(!T.isLinux)return!1;let o;try{o=(await d.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await d.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(t){i.debug("Error while getting the os-release file.",(0,y.getErrorMessage)(t))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=m;async function a(d,i){const o=await m(d,i),r=(0,n.getTargetPlatform)(o?"alpine":T.platform,b.arch);return i.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=a}),define(Ie[202],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class u{constructor(){this.validators=new Map}vsda(){return new Promise((D,T)=>J(["vsda"],D,T))}async createNewMessage(D){try{const T=await this.vsda(),C=new T.validator;if(C){const y=String(u._nextId++);return this.validators.set(y,C),{id:y,data:C.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,T){if(!D.id)return!0;const C=this.validators.get(D.id);if(!C)return!1;this.validators.delete(D.id);try{return C.validate(T)==="ok"}catch{return!1}}async sign(D){try{const T=await this.vsda(),C=new T.signer;if(C)return C.sign(D)}catch{}return D}}e.SignService=u,u._nextId=1}),define(Ie[203],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class u{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,T,C=5){const y=T(b=>{const I=typeof b=="string"?b:b.data;let R=this._terminalBufferMap.get(D);if(R){R.data.push(I);return}const k=setTimeout(()=>this.flushBuffer(D),C);R={data:[I],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(D),y.dispose()}},this._terminalBufferMap.set(D,R)});return y}stopBuffering(D){const T=this._terminalBufferMap.get(D);T&&T.dispose()}flushBuffer(D){const T=this._terminalBufferMap.get(D);T&&(this._terminalBufferMap.delete(D),this._callback(D,T.data.join("")))}}e.TerminalDataBufferer=u}),define(Ie[204],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var u;(function(T){T.DARK="dark",T.LIGHT="light",T.HIGH_CONTRAST_DARK="hcDark",T.HIGH_CONTRAST_LIGHT="hcLight"})(u=e.ColorScheme||(e.ColorScheme={}));function n(T){return T===u.HIGH_CONTRAST_DARK||T===u.HIGH_CONTRAST_LIGHT}e.isHighContrast=n;function D(T){return T===u.DARK||T===u.HIGH_CONTRAST_DARK}e.isDark=D}),define(Ie[86],ke([0,1,77,3,6,4,44,204]),function(J,e,u,n,D,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var b;(function(p){function f(E){return E&&typeof E=="object"&&typeof E.id=="string"}p.isThemeColor=f})(b=e.ThemeColor||(e.ThemeColor={}));function I(p){return{id:p}}e.themeColorFromId=I;var R;(function(p){function f(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color=="undefined"||b.isThemeColor(o.color))}p.isThemeIcon=f;const E=new RegExp(`^\\$\\((${u.CSSIcon.iconNameExpression}(?:${u.CSSIcon.iconModifierExpression})?)\\)$`);function g(o){const r=E.exec(o);if(!r)return;const[,t]=r;return{id:t}}p.fromString=g;function c(o){return{id:o}}p.fromId=c;function m(o,r){let t=o.id;const s=t.lastIndexOf("~");return s!==-1&&(t=t.substring(0,s)),r&&(t=`${t}~${r}`),{id:t}}p.modify=m;function a(o){const r=o.id.lastIndexOf("~");if(r!==-1)return o.id.substring(r+1)}p.getModifier=a;function d(o,r){return o.id===r.id&&o.color?.id===r.color?.id}p.isEqual=d;function i(o,r){return{id:o.id,color:r?I(r):void 0}}p.asThemeIcon=i,p.asClassNameArray=u.CSSIcon.asClassNameArray,p.asClassName=u.CSSIcon.asClassName,p.asCSSSelector=u.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=u.Codicon.file,e.FolderThemeIcon=u.Codicon.folder;function k(p){switch(p){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case y.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class _{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(f){return this.themingParticipants.push(f),this.onThemingParticipantAddedEmitter.fire(f),(0,D.toDisposable)(()=>{const E=this.themingParticipants.indexOf(f);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const P=new _;C.Registry.add(e.Extensions.ThemingContribution,P);function v(p){return P.onColorThemeChange(p)}e.registerThemingParticipant=v;class w extends D.Disposable{constructor(f){super();this.themeService=f,this.theme=f.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(f){this.theme=f,this.updateStyles()}updateStyles(){}getColor(f,E){let g=this.theme.getColor(f);return g&&E&&(g=E(g,this.theme)),g?g.toString():null}}e.Themable=w}),define(Ie[124],ke([0,1,3,13,4,14]),function(J,e,u,n,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var C;(function(w){w.Http="http",w.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var y;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(y=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var b;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(b=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(!!p)return{address:p[1],port:+p[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(w){return e.LOCALHOST_ADDRESSES.indexOf(w)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(w){return e.ALL_INTERFACES_ADDRESSES.indexOf(w)>=0}e.isAllInterfaces=k;function _(w,p){return p?p!==1&&w<1024:!n.isWindows&&w<1024}e.isPortPrivileged=_;class P{constructor(p,f,E){this.remoteAddress=p,this.localAddress=f,this._dispose=E,this._onDispose=new u.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=P;let v=class{constructor(p){this.logService=p,this._onTunnelOpened=new u.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new u.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new u.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(p){return this._tunnelProvider=p,p?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(p){this._canElevate=p.elevation,this._privacyOptions=p.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const p=[],f=Array.from(this._tunnels.values());for(const E of f){const g=Array.from(E.values());for(const c of g){const m=await c.value;m&&p.push(m)}}return p}async dispose(){for(const p of this._tunnels.values()){for(const{value:f}of p.values())await f.then(E=>E?.dispose());p.clear()}this._tunnels.clear()}openTunnel(p,f,E,g,c=!1,m,a){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${E} on local port ${g}.`),!p)return;if(f||(f="localhost"),this._tunnelProvider&&this._factoryInProgress.has(E)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const d=this.retainOrCreateTunnel(p,f,E,g,c,m,a);return d?d.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,E);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.makeTunnel(i);return(i.tunnelRemoteHost!==f||i.tunnelRemotePort!==E)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(o),o}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),d)}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,privacy:p.privacy,protocol:p.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemoteHost}:${p.tunnelRemotePort} `);const f=this._tunnels.get(p.tunnelRemoteHost);if(f){const E=f.get(p.tunnelRemotePort);E&&(E.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,E))}}}}async tryDisposeTunnel(p,f,E){if(E.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${f}.`);const g=E.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(f),g}}async closeTunnel(p,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${p}:${f} `);const E=this._tunnels.get(p);if(E&&E.has(f)){const g=E.get(f);g.refcount=0,await this.tryDisposeTunnel(p,f,g)}}addTunnelToMap(p,f,E){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(f,{refcount:1,value:E})}async removeEmptyTunnelFromMap(p,f){const E=this._tunnels.get(p);E&&(await E.get(f)||E.delete(f),E.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,f){const E=[p];R(p)?(E.push(...e.LOCALHOST_ADDRESSES),E.push(...e.ALL_INTERFACES_ADDRESSES)):k(p)&&E.push(...e.ALL_INTERFACES_ADDRESSES);const g=E.map(c=>this._tunnels.get(c));for(const c of g){const m=c?.get(f);if(m)return m}}canTunnel(p){return!!I(p)}createWithProvider(p,f,E,g,c,m,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${E} on local port ${g}.`);const d=E;this._factoryInProgress.add(d);const o={elevationRequired:c?_(g===void 0?E:g):!1},r={remoteAddress:{host:f,port:E},localAddressPort:g,privacy:m,public:m?m!==y.Private:void 0,protocol:a},t=p.forwardPort(r,o);return t?(this.addTunnelToMap(f,E,t),t.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(d)})):this._factoryInProgress.delete(d),t}};v=je([Ve(0,T.ILogService)],v),e.AbstractTunnelService=v}),define(Ie[205],ke([0,1,10]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function n(b){return b.scheme!==u.Schemas.file&&b.scheme!==u.Schemas.vscodeRemote}e.isVirtualResource=n;function D(b){if(b.folders.length)return b.folders.every(I=>n(I.uri))?b.folders[0].uri:void 0;if(b.configuration&&n(b.configuration))return b.configuration}e.getVirtualWorkspaceLocation=D;function T(b){return D(b)?.scheme}e.getVirtualWorkspaceScheme=T;function C(b){return D(b)?.authority}e.getVirtualWorkspaceAuthority=C;function y(b){return D(b)!==void 0}e.isVirtualWorkspace=y}),define(Ie[45],ke([0,1,169,9,25,22,2,4,10]),function(J,e,u,n,D,T,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,y.createDecorator)("contextService");function I(i){const o=i;return typeof o?.id=="string"&&C.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=I;function R(i){if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=R;function k(i){const o=i;return typeof o?.id=="string"&&C.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=k;function _(i){const o=i;if(o?.uri)return{id:o.id,uri:C.URI.revive(o.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:C.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=_;var P;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function v(i){const o=i;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=v;function w(i){const o=i;return!!(o&&typeof o=="object"&&C.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=w;class p{constructor(o,r,t,s,l){this._id=o,this._transient=t,this._configuration=s,this._ignorePathCasing=l,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(o){this._id=o.id,this._configuration=o.configuration,this._transient=o.transient,this._ignorePathCasing=o._ignorePathCasing,this.folders=o.folders}get folders(){return this._folders}set folders(o){this._folders=o,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(o){this._configuration=o}getFolder(o){return o&&this._foldersMap.findSubstr(o)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const o of this.folders)this._foldersMap.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=p;class f{constructor(o,r){this.raw=r,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,T.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function E(i){return new f({uri:i,index:0,name:(0,T.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=E,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,u.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function c(i,o){return T.extUriBiasedIgnorePathCase.isEqualOrParent(i,o.untitledWorkspacesHome)}e.isUntitledWorkspace=c;function m(i){let o;return C.URI.isUri(i)?o=i:o=i.configuration,o?.scheme===b.Schemas.tmp}e.isTemporaryWorkspace=m;function a(i,o){return!c(i,o)&&!m(i)}e.isSavedWorkspace=a;function d(i){return(typeof i=="string"?(0,n.extname)(i):(0,T.extname)(i))===g}e.hasWorkspaceFileExtension=d}),define(Ie[87],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class u{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const T=this._idPool++;return this._data.set(T,D),this.logDebugInfo(),T}get(D,T){return this._data.has(D)?this._data.get(D)[T]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!u.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=u,u.enableDebugLogging=!1}),define(Ie[46],ke([0,1,10,22,4]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(u.Schemas)),this._providerInfo=new Map,this.extUri=new n.ExtUri(y=>{const b=this._providerInfo.get(y.scheme);return!(b===void 0||b&1024)})}$acceptProviderInfos(y,b){b===null?this._providerInfo.delete(y.scheme):this._providerInfo.set(y.scheme,b)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(Ie[26],ke([0,1,4]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,u.createDecorator)("IExtHostInitDataService")}),define(Ie[206],ke([0,1,18]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class n{constructor(C,y,b){this._deferredPromises=new Map,this._id=C,this._shared=y,this._storage=b,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(I=>(this._value=I,this)),this._storageListener=this._storage.onDidChangeStorage(I=>{I.shared===this._shared&&I.key===this._id&&(this._value=I.value)}),this._scheduler=new u.RunOnceScheduler(()=>{const I=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of I.values())R.complete()}catch(R){for(const k of I.values())k.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this._init}get(C,y){let b=this._value[C];return typeof b=="undefined"&&(b=y),b}update(C,y){this._value[C]=y;const b=this._deferredPromises.get(C);if(b!==void 0)return b.p;const I=new u.DeferredPromise;return this._deferredPromises.set(C,I),this._scheduler.isScheduled()||this._scheduler.schedule(),I.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=n;class D extends n{constructor(C,y){super(C.identifier.value,!0,y);this._extension=C}setKeysForSync(C){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},C)}}e.ExtensionGlobalMemento=D}),define(Ie[207],ke([0,1,3,2]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class D{constructor(C){this._notebooksAndEditors=C,this._onDidSaveNotebookDocument=new u.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new u.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(C,y,b,I){const k=this._notebooksAndEditors.getNotebookDocument(n.URI.revive(C)).acceptModelChanged(y.value,b,I);this._onDidChangeNotebookDocument.fire(k)}$acceptDirtyStateChanged(C,y){this._notebooksAndEditors.getNotebookDocument(n.URI.revive(C)).acceptDirty(y)}$acceptModelSaved(C){const y=this._notebooksAndEditors.getNotebookDocument(n.URI.revive(C));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}}e.ExtHostNotebookDocuments=D}),define(Ie[17],ke([0,1,4]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,u.createDecorator)("IExtHostRpcService");class n{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.dispose=T.dispose.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=n});var Ze=this&&this.__classPrivateFieldSet||function(J,e,u,n,D){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?D.call(J,u):D?D.value=u:e.set(J,u),u},Me=this&&this.__classPrivateFieldGet||function(J,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!n:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(J):n?n.value:e.get(J)};define(Ie[208],ke([0,1,28,3]),function(J,e,u,n){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(y,b){D.set(this,void 0),this._onDidChange=new n.Emitter,this.onDidChange=this._onDidChange.event,this._id=u.ExtensionIdentifier.toKey(y.identifier),Ze(this,D,b,"f"),Me(this,D,"f").onDidChangePassword(I=>{I.extensionId===this._id&&this._onDidChange.fire({key:I.key})})}get(y){return Me(this,D,"f").get(this._id,y)}store(y,b){return Me(this,D,"f").store(this._id,y,b)}delete(y){return Me(this,D,"f").delete(this._id,y)}}e.ExtensionSecrets=T,D=new WeakMap}),define(Ie[125],ke([0,1,4,3]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class D{constructor(){this._onDidChangeTelemetryEnabled=new n.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new n.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(C,y){this._level=C,this._productConfig=y||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(C){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=C,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=D,e.IExtHostTelemetry=(0,u.createDecorator)("IExtHostTelemetry")}),define(Ie[52],ke([0,1,4,124,3,17]),function(J,e,u,n,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(b){function I(k){return{remoteAddress:k.remoteAddress,localAddress:k.localAddress,public:!!k.public,privacy:k.privacy??(k.public?n.TunnelPrivacyId.Public:n.TunnelPrivacyId.Private),protocol:k.protocol}}b.fromApiTunnel=I;function R(k){return{remoteAddress:{host:k.tunnelRemoteHost,port:k.tunnelRemotePort},localAddress:k.localAddress,public:k.privacy!==n.TunnelPrivacyId.ConstantPrivate&&k.privacy!==n.TunnelPrivacyId.ConstantPrivate,privacy:k.privacy,protocol:k.protocol}}b.fromServiceTunnel=R})(C=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,u.createDecorator)("IExtHostTunnelService");let y=class{constructor(I){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(I){return I}async openTunnel(I,R){}async getTunnels(){return[]}async setTunnelFactory(I){return{dispose:()=>{}}}registerPortsAttributesProvider(I,R){return{dispose:()=>{}}}async $providePortAttributes(I,R,k,_,P){return[]}async $forwardPort(I,R){}async $closeTunnel(I){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=je([Ve(0,T.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var Ze=this&&this.__classPrivateFieldSet||function(J,e,u,n,D){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?D.call(J,u):D?D.value=u:e.set(J,u),u},Me=this&&this.__classPrivateFieldGet||function(J,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!n:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(J):n?n.value:e.get(J)};define(Ie[7],ke([0,1,16,12,106,25,101,8,11,2,34,43,122]),function(J,e,u,n,D,T,C,y,b,I,R,k,_){"use strict";var P,v,w,p,f,E,g,c,m,a,d,i,o,r,t,s,l,h,S,L,F,M,A;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function B(j){function W(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty(W,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf(W,j),Object.setPrototypeOf(W.prototype,j.prototype),W}let $=E=class{constructor(W){P.set(this,void 0),Ze(this,P,W,"f")}static from(...W){let ae=W;return new E(function(){if(ae){for(const Ae of ae)Ae&&typeof Ae.dispose=="function"&&Ae.dispose();ae=void 0}})}dispose(){typeof Me(this,P,"f")=="function"&&(Me(this,P,"f").call(this),Ze(this,P,void 0,"f"))}};P=new WeakMap,$=E=je([B],$),e.Disposable=$;let U=g=class{constructor(W,ae){if(W<0)throw(0,n.illegalArgument)("line must be non-negative");if(ae<0)throw(0,n.illegalArgument)("character must be non-negative");this._line=W,this._character=ae}static Min(...W){if(W.length===0)throw new TypeError;let ae=W[0];for(let Ae=1;Ae<W.length;Ae++){const Ke=W[Ae];Ke.isBefore(ae)&&(ae=Ke)}return ae}static Max(...W){if(W.length===0)throw new TypeError;let ae=W[0];for(let Ae=1;Ae<W.length;Ae++){const Ke=W[Ae];Ke.isAfter(ae)&&(ae=Ke)}return ae}static isPosition(W){if(!W)return!1;if(W instanceof g)return!0;const{line:ae,character:Ae}=W;return typeof ae=="number"&&typeof Ae=="number"}static of(W){if(W instanceof g)return W;if(this.isPosition(W))return new g(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,ae=0){if(W===null||ae===null)throw(0,n.illegalArgument)();let Ae;return typeof W=="undefined"?Ae=0:typeof W=="number"?Ae=W:(Ae=typeof W.lineDelta=="number"?W.lineDelta:0,ae=typeof W.characterDelta=="number"?W.characterDelta:0),Ae===0&&ae===0?this:new g(this.line+Ae,this.character+ae)}with(W,ae=this.character){if(W===null||ae===null)throw(0,n.illegalArgument)();let Ae;return typeof W=="undefined"?Ae=this.line:typeof W=="number"?Ae=W:(Ae=typeof W.line=="number"?W.line:this.line,ae=typeof W.character=="number"?W.character:this.character),Ae===this.line&&ae===this.character?this:new g(Ae,ae)}toJSON(){return{line:this.line,character:this.character}}};U=g=je([B],U),e.Position=U;let X=c=class{constructor(W,ae,Ae,Ke){let rt,ct;if(typeof W=="number"&&typeof ae=="number"&&typeof Ae=="number"&&typeof Ke=="number"?(rt=new U(W,ae),ct=new U(Ae,Ke)):U.isPosition(W)&&U.isPosition(ae)&&(rt=U.of(W),ct=U.of(ae)),!rt||!ct)throw new Error("Invalid arguments");rt.isBefore(ct)?(this._start=rt,this._end=ct):(this._start=ct,this._end=rt)}static isRange(W){return W instanceof c?!0:W?U.isPosition(W.start)&&U.isPosition(W.end):!1}static of(W){if(W instanceof c)return W;if(this.isRange(W))return new c(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(W){return c.isRange(W)?this.contains(W.start)&&this.contains(W.end):U.isPosition(W)?!(U.of(W).isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const ae=U.Max(W.start,this._start),Ae=U.Min(W.end,this._end);if(!ae.isAfter(Ae))return new c(ae,Ae)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const ae=U.Min(W.start,this._start),Ae=U.Max(W.end,this.end);return new c(ae,Ae)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,ae=this.end){if(W===null||ae===null)throw(0,n.illegalArgument)();let Ae;return W?U.isPosition(W)?Ae=W:(Ae=W.start||this.start,ae=W.end||this.end):Ae=this.start,Ae.isEqual(this._start)&&ae.isEqual(this.end)?this:new c(Ae,ae)}toJSON(){return[this.start,this.end]}};X=c=je([B],X),e.Range=X;let z=m=class extends X{constructor(W,ae,Ae,Ke){let rt,ct;if(typeof W=="number"&&typeof ae=="number"&&typeof Ae=="number"&&typeof Ke=="number"?(rt=new U(W,ae),ct=new U(Ae,Ke)):U.isPosition(W)&&U.isPosition(ae)&&(rt=U.of(W),ct=U.of(ae)),!rt||!ct)throw new Error("Invalid arguments");super(rt,ct);this._anchor=rt,this._active=ct}static isSelection(W){return W instanceof m?!0:W?X.isRange(W)&&U.isPosition(W.anchor)&&U.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};z=m=je([B],z),e.Selection=z;class N{constructor(W,ae,Ae){if(typeof W!="string"||W.length===0)throw(0,n.illegalArgument)("host");if(typeof ae!="number"||ae===0||Math.round(ae)!==ae)throw(0,n.illegalArgument)("port");if(typeof Ae!="undefined"&&(typeof Ae!="string"||Ae.length===0||!/^[0-9A-Za-z\-]+$/.test(Ae)))throw(0,n.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(ae),this.connectionToken=Ae}}e.ResolvedAuthority=N;class V extends Error{constructor(W,ae=_.RemoteAuthorityResolverErrorCode.Unknown,Ae){super(W);this._message=W,this._code=ae,this._detail=Ae,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype)}static NotAvailable(W,ae){return new V(W,_.RemoteAuthorityResolverErrorCode.NotAvailable,ae)}static TemporarilyNotAvailable(W){return new V(W,_.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=V;var x;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(x=e.EndOfLine||(e.EndOfLine={}));var q;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(q=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let te=a=class{constructor(W,ae){this._range=W,this._newText=ae}static isTextEdit(W){return W instanceof a?!0:W?X.isRange(W)&&typeof W.newText=="string":!1}static replace(W,ae){return new a(W,ae)}static insert(W,ae){return a.replace(new X(W,W),ae)}static delete(W){return a.replace(W,"")}static setEndOfLine(W){const ae=new a(new X(new U(0,0),new U(0,0)),"");return ae.newEol=W,ae}get range(){return this._range}set range(W){if(W&&!X.isRange(W))throw(0,n.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,n.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,n.illegalArgument)("newEol");this._newEol=W}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};te=a=je([B],te),e.TextEdit=te;let Y=d=class{constructor(W,ae){this.range=W,this.newCells=ae}static isNotebookCellEdit(W){return W instanceof d?!0:W?$t.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,ae){return new d(W,ae)}static insertCells(W,ae){return new d(new $t(W,W),ae)}static deleteCells(W){return new d(W,[])}static updateCellMetadata(W,ae){const Ae=new d(new $t(W,W),[]);return Ae.newCellMetadata=ae,Ae}static updateNotebookMetadata(W){const ae=new d(new $t(0,0),[]);return ae.newNotebookMetadata=W,ae}};Y=d=je([B],Y),e.NotebookEdit=Y;var le;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(le=e.FileEditType||(e.FileEditType={}));let pe=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,ae,Ae,Ke){this._edits.push({_type:1,from:W,to:ae,options:Ae,metadata:Ke})}createFile(W,ae,Ae){this._edits.push({_type:1,from:void 0,to:W,options:ae,metadata:Ae})}deleteFile(W,ae,Ae){this._edits.push({_type:1,from:W,to:void 0,options:ae,metadata:Ae})}replaceNotebookMetadata(W,ae,Ae){this._edits.push({_type:3,metadata:Ae,uri:W,edit:{editType:5,metadata:ae},notebookMetadata:ae})}replaceNotebookCells(W,ae,Ae,Ke,rt){let ct,ut,yt=[],Rt;if($t.isNotebookRange(ae)&&qt.isNotebookCellDataArray(Ae)&&!qt.isNotebookCellDataArray(Ke)?(ct=ae.start,ut=ae.end,yt=Ae,Rt=Ke):typeof ae=="number"&&typeof Ae=="number"&&qt.isNotebookCellDataArray(Ke)&&(ct=ae,ut=Ae,yt=Ke,Rt=rt),ct===void 0||ut===void 0)throw new Error("Invalid arguments");(ct!==ut||yt.length>0)&&this._edits.push({_type:5,uri:W,index:ct,count:ut-ct,cells:yt,metadata:Rt})}replaceNotebookCellMetadata(W,ae,Ae,Ke){this._edits.push({_type:3,metadata:Ke,uri:W,edit:{editType:8,index:ae,metadata:Ae}})}replace(W,ae,Ae,Ke){typeof Ae=="string"?this._edits.push({_type:2,uri:W,edit:new te(ae,Ae),metadata:Ke}):this._edits.push({_type:6,uri:W,range:ae,edit:Ae,metadata:Ke})}insert(W,ae,Ae,Ke){this.replace(W,new X(ae,ae),Ae,Ke)}delete(W,ae,Ae){this.replace(W,ae,"",Ae)}has(W){return this._edits.some(ae=>ae._type===2&&ae.uri.toString()===W.toString())}set(W,ae){if(ae)for(const Ae of ae)Ae&&(Y.isNotebookCellEdit(Ae)?Ae.newCellMetadata?this.replaceNotebookCellMetadata(W,Ae.range.start,Ae.newCellMetadata):Ae.newNotebookMetadata?this.replaceNotebookMetadata(W,Ae.newNotebookMetadata):this.replaceNotebookCells(W,Ae.range,Ae.newCells):this._edits.push({_type:2,uri:W,edit:Ae}));else{for(let Ae=0;Ae<this._edits.length;Ae++){const Ke=this._edits[Ae];Ke._type===2&&Ke.uri.toString()===W.toString()&&(this._edits[Ae]=void 0)}(0,u.coalesceInPlace)(this._edits)}}get(W){const ae=[];for(const Ae of this._edits)Ae._type===2&&Ae.uri.toString()===W.toString()&&ae.push(Ae.edit);return ae}entries(){const W=new T.ResourceMap;for(const ae of this._edits)if(ae._type===2){let Ae=W.get(ae.uri);Ae||(Ae=[ae.uri,[]],W.set(ae.uri,Ae)),Ae[1].push(ae.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};pe=je([B],pe),e.WorkspaceEdit=pe;let ee=i=class{constructor(W){this._tabstop=1,this.value=W||""}static isSnippetString(W){return W instanceof i?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}appendText(W){return this.value+=i._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,ae=this._tabstop++){if(typeof W=="function"){const Ae=new i;Ae._tabstop=this._tabstop,W(Ae),this._tabstop=Ae._tabstop,W=Ae.value}else W=i._escape(W);return this.value+="${",this.value+=ae,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,ae=this._tabstop++){const Ae=W.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ae,this.value+="|",this.value+=Ae,this.value+="|}",this}appendVariable(W,ae){if(typeof ae=="function"){const Ae=new i;Ae._tabstop=this._tabstop,ae(Ae),this._tabstop=Ae._tabstop,ae=Ae.value}else typeof ae=="string"&&(ae=ae.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,ae&&(this.value+=":",this.value+=ae),this.value+="}",this}};ee=i=je([B],ee),e.SnippetString=ee;var ge;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(ge=e.DiagnosticTag||(e.DiagnosticTag={}));var Ee;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(Ee=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Pe=o=class{constructor(W,ae){if(this.uri=W,ae)if(X.isRange(ae))this.range=X.of(ae);else if(U.isPosition(ae))this.range=new X(ae,ae);else throw new Error("Illegal argument")}static isLocation(W){return W instanceof o?!0:W?X.isRange(W.range)&&I.URI.isUri(W.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Pe=o=je([B],Pe),e.Location=Pe;let Ne=class{constructor(W,ae){this.location=W,this.message=ae}static is(W){return W?typeof W.message=="string"&&W.location&&X.isRange(W.location.range)&&I.URI.isUri(W.location.uri):!1}static isEqual(W,ae){return W===ae?!0:!W||!ae?!1:W.message===ae.message&&W.location.range.isEqual(ae.location.range)&&W.location.uri.toString()===ae.location.uri.toString()}};Ne=je([B],Ne),e.DiagnosticRelatedInformation=Ne;let ve=class{constructor(W,ae,Ae=Ee.Error){if(!X.isRange(W))throw new TypeError("range must be set");if(!ae)throw new TypeError("message must be set");this.range=W,this.message=ae,this.severity=Ae}toJSON(){return{severity:Ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,ae){return W===ae?!0:!W||!ae?!1:W.message===ae.message&&W.severity===ae.severity&&W.code===ae.code&&W.severity===ae.severity&&W.source===ae.source&&W.range.isEqual(ae.range)&&(0,u.equals)(W.tags,ae.tags)&&(0,u.equals)(W.relatedInformation,ae.relatedInformation,Ne.isEqual)}};ve=je([B],ve),e.Diagnostic=ve;let ue=class{constructor(W,ae){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=ae}};ue=je([B],ue),e.Hover=ue;var de;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(de=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let we=class{constructor(W,ae=de.Text){this.range=W,this.kind=ae}toJSON(){return{range:this.range,kind:de[this.kind]}}};we=je([B],we),e.DocumentHighlight=we;var re;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(re=e.SymbolKind||(e.SymbolKind={}));var me;(function(j){j[j.Deprecated=1]="Deprecated"})(me=e.SymbolTag||(e.SymbolTag={}));let Z=r=class{constructor(W,ae,Ae,Ke,rt){this.name=W,this.kind=ae,this.containerName=rt,typeof Ae=="string"&&(this.containerName=Ae),Ke instanceof Pe?this.location=Ke:Ae instanceof X&&(this.location=new Pe(Ke,Ae)),r.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:re[this.kind],location:this.location,containerName:this.containerName}}};Z=r=je([B],Z),e.SymbolInformation=Z;let se=t=class{constructor(W,ae,Ae,Ke,rt){this.name=W,this.detail=ae,this.kind=Ae,this.range=Ke,this.selectionRange=rt,this.children=[],t.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(t.validate)}};se=t=je([B],se),e.DocumentSymbol=se;var O;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(O=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let H=class{constructor(W,ae){this.title=W,this.kind=ae}};H=je([B],H),e.CodeAction=H;let K=s=class{constructor(W){this.value=W}append(W){return new s(this.value?this.value+s.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+s.sep)}};K.sep=".",K=s=je([B],K),e.CodeActionKind=K,K.Empty=new K(""),K.QuickFix=K.Empty.append("quickfix"),K.Refactor=K.Empty.append("refactor"),K.RefactorExtract=K.Refactor.append("extract"),K.RefactorInline=K.Refactor.append("inline"),K.RefactorRewrite=K.Refactor.append("rewrite"),K.Source=K.Empty.append("source"),K.SourceOrganizeImports=K.Source.append("organizeImports"),K.SourceFixAll=K.Source.append("fixAll");let Q=class{constructor(W,ae){if(this.range=W,this.parent=ae,ae&&!ae.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Q=je([B],Q),e.SelectionRange=Q;class he{constructor(W,ae,Ae,Ke,rt,ct){this.kind=W,this.name=ae,this.detail=Ae,this.uri=Ke,this.range=rt,this.selectionRange=ct}}e.CallHierarchyItem=he;class be{constructor(W,ae){this.fromRanges=ae,this.from=W}}e.CallHierarchyIncomingCall=be;class ce{constructor(W,ae){this.fromRanges=ae,this.to=W}}e.CallHierarchyOutgoingCall=ce;var De;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(De=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let ye=class{constructor(W,ae){this.range=W,this.command=ae}get isResolved(){return!!this.command}};ye=je([B],ye),e.CodeLens=ye;let Be=l=class{constructor(W,ae=!1){v.set(this,void 0),Ze(this,v,new D.MarkdownString(W,{supportThemeIcons:ae}),"f")}static isMarkdownString(W){return W instanceof l?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}get value(){return Me(this,v,"f").value}set value(W){Me(this,v,"f").value=W}get isTrusted(){return Me(this,v,"f").isTrusted}set isTrusted(W){Me(this,v,"f").isTrusted=W}get supportThemeIcons(){return Me(this,v,"f").supportThemeIcons}set supportThemeIcons(W){Me(this,v,"f").supportThemeIcons=W}get supportHtml(){return Me(this,v,"f").supportHtml}set supportHtml(W){Me(this,v,"f").supportHtml=W}get baseUri(){return Me(this,v,"f").baseUri}set baseUri(W){Me(this,v,"f").baseUri=W}appendText(W){return Me(this,v,"f").appendText(W),this}appendMarkdown(W){return Me(this,v,"f").appendMarkdown(W),this}appendCodeblock(W,ae){return Me(this,v,"f").appendCodeblock(ae??"",W),this}};v=new WeakMap,Be=l=je([B],Be),e.MarkdownString=Be;let qe=class{constructor(W,ae){this.label=W,this.documentation=ae}};qe=je([B],qe),e.ParameterInformation=qe;let et=class{constructor(W,ae){this.label=W,this.documentation=ae,this.parameters=[]}};et=je([B],et),e.SignatureInformation=et;let Xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Xe=je([B],Xe),e.SignatureHelp=Xe;var Oe;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(Oe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ot;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(ot=e.InlayHintKind||(e.InlayHintKind={}));let ie=class{constructor(W){this.value=W}};ie=je([B],ie),e.InlayHintLabelPart=ie;let oe=class{constructor(W,ae,Ae){this.position=W,this.label=ae,this.kind=Ae}};oe=je([B],oe),e.InlayHint=oe;var G;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(G=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ce;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Ce=e.CompletionItemKind||(e.CompletionItemKind={}));var Re;(function(j){j[j.Deprecated=1]="Deprecated"})(Re=e.CompletionItemTag||(e.CompletionItemTag={}));let We=class{constructor(W,ae){this.label=W,this.kind=ae}toJSON(){return{label:this.label,kind:this.kind&&Ce[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};We=je([B],We),e.CompletionItem=We;let ze=class{constructor(W=[],ae=!1){this.items=W,this.isIncomplete=ae}};ze=je([B],ze),e.CompletionList=ze;let $e=class{constructor(W,ae,Ae){this.insertText=W,this.range=ae,this.command=Ae}};$e=je([B],$e),e.InlineSuggestion=$e;let tt=class{constructor(W){this.commands=void 0,this.items=W}};tt=je([B],tt),e.InlineSuggestionList=tt;let st=class{constructor(W,ae,Ae){this.insertText=W,this.range=ae,this.command=Ae}};st=je([B],st),e.InlineSuggestionNew=st;let lt=class{constructor(W,ae){this.items=W,this.commands=ae}};lt=je([B],lt),e.InlineSuggestionsNew=lt;var nt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(nt=e.ViewColumn||(e.ViewColumn={}));var it;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(it=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ft;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(ft=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ct;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Ct=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var kt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(kt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var mt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Dt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Dt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ut;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Ut=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function W(ae){switch(ae){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=W}(mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Nt=class{constructor(W,ae){if(ae&&!I.URI.isUri(ae))throw(0,n.illegalArgument)("target");if(!X.isRange(W)||W.isEmpty)throw(0,n.illegalArgument)("range");this.range=W,this.target=ae}};Nt=je([B],Nt),e.DocumentLink=Nt;let Ge=class{constructor(W,ae,Ae,Ke){this.red=W,this.green=ae,this.blue=Ae,this.alpha=Ke}};Ge=je([B],Ge),e.Color=Ge;let Ft=class{constructor(W,ae){if(ae&&!(ae instanceof Ge))throw(0,n.illegalArgument)("color");if(!X.isRange(W)||W.isEmpty)throw(0,n.illegalArgument)("range");this.range=W,this.color=ae}};Ft=je([B],Ft),e.ColorInformation=Ft;let Lt=class{constructor(W){if(!W||typeof W!="string")throw(0,n.illegalArgument)("label");this.label=W}};Lt=je([B],Lt),e.ColorPresentation=Lt;var Mt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Mt=e.ColorFormat||(e.ColorFormat={}));var pt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(pt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Pt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(Pt=e.TerminalExitReason||(e.TerminalExitReason={}));class Te{constructor(W,ae,Ae){if(this.startIndex=W,this.length=ae,this.tooltip=Ae,typeof W!="number"||W<0)throw(0,n.illegalArgument)("startIndex");if(typeof ae!="number"||ae<1)throw(0,n.illegalArgument)("length");if(Ae!==void 0&&typeof Ae!="string")throw(0,n.illegalArgument)("tooltip")}}e.TerminalLink=Te;var Le;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Le=e.TerminalLocation||(e.TerminalLocation={}));class Se{constructor(W){if(this.options=W,typeof W!="object")throw(0,n.illegalArgument)("options")}}e.TerminalProfile=Se;var ne;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(ne=e.TaskRevealKind||(e.TaskRevealKind={}));var Fe;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Fe=e.TaskPanelKind||(e.TaskPanelKind={}));let xe=h=class{constructor(W,ae){if(this.label=ae,typeof W!="string"||typeof ae!="string")throw(0,n.illegalArgument)("name");this._id=W}static from(W){switch(W){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}get id(){return this._id}};xe.Clean=new h("clean","Clean"),xe.Build=new h("build","Build"),xe.Rebuild=new h("rebuild","Rebuild"),xe.Test=new h("test","Test"),xe=h=je([B],xe),e.TaskGroup=xe;function Ye(j){let W="";for(let ae=0;ae<j.length;ae++)W+=j[ae].replace(/,/g,",,")+",";return W}let Je=class{constructor(W,ae,Ae){if(typeof W!="string")throw(0,n.illegalArgument)("process");this._args=[],this._process=W,ae!==void 0&&(Array.isArray(ae)?(this._args=ae,this._options=Ae):this._options=ae)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,n.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(const ae of this._args)W.push(ae);return Ye(W)}};Je=je([B],Je),e.ProcessExecution=Je;let Qe=class{constructor(W,ae,Ae){if(this._args=[],Array.isArray(ae)){if(!W)throw(0,n.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,n.illegalArgument)("command");this._command=W,this._args=ae,this._options=Ae}else{if(typeof W!="string")throw(0,n.illegalArgument)("commandLine");this._commandLine=W,this._options=ae}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,n.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,n.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ae of this._args)W.push(typeof ae=="string"?ae:ae.value);return Ye(W)}};Qe=je([B],Qe),e.ShellExecution=Qe;var vt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(vt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class Tt{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=Tt;let bt=S=class{constructor(W,ae,Ae,Ke,rt,ct){this.__deprecated=!1,this._definition=this.definition=W;let ut;typeof ae=="string"?(this._name=this.name=ae,this._source=this.source=Ae,this.execution=Ke,ut=rt,this.__deprecated=!0):ae===Et.Global||ae===Et.Workspace?(this.target=ae,this._name=this.name=Ae,this._source=this.source=Ke,this.execution=rt,ut=ct):(this.target=ae,this._name=this.name=Ae,this._source=this.source=Ke,this.execution=rt,ut=ct),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Je?this._definition={type:S.ProcessType,id:this._execution.computeId()}:this._execution instanceof Qe?this._definition={type:S.ShellType,id:this._execution.computeId()}:this._execution instanceof Tt?this._definition={type:S.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:S.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,n.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,n.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const ae=this._definition.type;(S.EmptyType===ae||S.ProcessType===ae||S.ShellType===ae||S.ExtensionCallbackType===ae)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,n.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=S=je([B],bt),e.Task=bt;var ht;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(ht=e.ProgressLocation||(e.ProgressLocation={}));let Ot=L=class{constructor(W,ae=St.None){this.collapsibleState=ae,I.URI.isUri(W)?this.resourceUri=W:this.label=W}static isTreeItem(W){if(W instanceof L)return!0;const ae=W;if(ae.label!==void 0&&!(0,b.isString)(ae.label)&&!ae.label.label)return console.log("INVALID tree item, invalid label",ae.label),!1;if(ae.id!==void 0&&!(0,b.isString)(ae.id))return console.log("INVALID tree item, invalid id",ae.id),!1;if(ae.iconPath!==void 0&&!(0,b.isString)(ae.iconPath)&&!I.URI.isUri(ae.iconPath)&&!(0,b.isString)(ae.iconPath.id)){const Ae=ae.iconPath;if(!(0,b.isString)(Ae.light)&&!I.URI.isUri(Ae.light)&&!(0,b.isString)(Ae.dark)&&!I.URI.isUri(Ae.dark))return console.log("INVALID tree item, invalid iconPath",ae.iconPath),!1}return ae.description!==void 0&&!(0,b.isString)(ae.description)&&typeof ae.description!="boolean"?(console.log("INVALID tree item, invalid description",ae.description),!1):ae.resourceUri!==void 0&&!I.URI.isUri(ae.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ae.resourceUri),!1):ae.tooltip!==void 0&&!(0,b.isString)(ae.tooltip)&&!(ae.tooltip instanceof Be)?(console.log("INVALID tree item, invalid tooltip",ae.tooltip),!1):ae.command!==void 0&&!ae.command.command?(console.log("INVALID tree item, invalid command",ae.command),!1):ae.collapsibleState!==void 0&&ae.collapsibleState<St.None&&ae.collapsibleState>St.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ae.collapsibleState),!1):ae.contextValue!==void 0&&!(0,b.isString)(ae.contextValue)?(console.log("INVALID tree item, invalid contextValue",ae.contextValue),!1):ae.accessibilityInformation!==void 0&&!ae.accessibilityInformation.label?(console.log("INVALID tree item, invalid accessibilityInformation",ae.accessibilityInformation),!1):!0}};Ot=L=je([B],Ot),e.TreeItem=Ot;var St;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(St=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let wt=class{constructor(W){this.value=W}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};wt=je([B],wt),e.DataTransferItem=wt;let Kt=class{constructor(W){w.set(this,new Map);for(const[ae,Ae]of W??[]){const Ke=Me(this,w,"f").get(ae);Ke?Ke.push(Ae):Me(this,w,"f").set(ae,[Ae])}}get(W){return Me(this,w,"f").get(W)?.[0]}set(W,ae){Me(this,w,"f").set(W,[ae])}forEach(W,ae){for(const[Ae,Ke]of Me(this,w,"f"))for(const rt of Ke)W.call(ae,rt,Ae,this)}*[(w=new WeakMap,Symbol.iterator)](){for(const[W,ae]of Me(this,w,"f"))for(const Ae of ae)yield[W,Ae]}};Kt=je([B],Kt),e.DataTransfer=Kt;let Xt=class{constructor(W){this.insertText=W}};Xt=je([B],Xt),e.DocumentDropEdit=Xt;let xt=class{constructor(W){this.insertText=W}};xt=je([B],xt),e.DocumentPasteEdit=xt;let Vt=class{constructor(W,ae){this.id=W,this.color=ae}};Vt=je([B],Vt),e.ThemeIcon=Vt,Vt.File=new Vt("file"),Vt.Folder=new Vt("folder");let At=class{constructor(W){this.id=W}};At=je([B],At),e.ThemeColor=At;var Sn;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Sn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let fn=class{constructor(W,ae){if(typeof W!="string"&&(!W||!I.URI.isUri(W)&&!I.URI.isUri(W.uri)))throw(0,n.illegalArgument)("base");if(typeof ae!="string")throw(0,n.illegalArgument)("pattern");typeof W=="string"?this.baseUri=I.URI.file(W):I.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=ae}get base(){return this._base}set base(W){this._base=W,this._baseUri=I.URI.file(W)}get baseUri(){return this._baseUri}set baseUri(W){this._baseUri=W,this._base=W.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};fn=je([B],fn),e.RelativePattern=fn;let zt=class{constructor(W,ae,Ae,Ke){this.enabled=typeof W=="boolean"?W:!0,typeof ae=="string"&&(this.condition=ae),typeof Ae=="string"&&(this.hitCondition=Ae),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};zt=je([B],zt),e.Breakpoint=zt;let en=class extends zt{constructor(W,ae,Ae,Ke,rt){super(ae,Ae,Ke,rt);if(W===null)throw(0,n.illegalArgument)("location");this.location=W}};en=je([B],en),e.SourceBreakpoint=en;let dt=class extends zt{constructor(W,ae,Ae,Ke,rt){super(ae,Ae,Ke,rt);this.functionName=W}};dt=je([B],dt),e.FunctionBreakpoint=dt;let mn=class extends zt{constructor(W,ae,Ae,Ke,rt,ct,ut){super(Ke,rt,ct,ut);if(!ae)throw(0,n.illegalArgument)("dataId");this.label=W,this.dataId=ae,this.canPersist=Ae}};mn=je([B],mn),e.DataBreakpoint=mn;let Wt=class{constructor(W,ae,Ae){this.command=W,this.args=ae||[],this.options=Ae}};Wt=je([B],Wt),e.DebugAdapterExecutable=Wt;let Qt=class{constructor(W,ae){this.port=W,this.host=ae}};Qt=je([B],Qt),e.DebugAdapterServer=Qt;let sn=class{constructor(W){this.path=W}};sn=je([B],sn),e.DebugAdapterNamedPipeServer=sn;let gn=class{constructor(W){this.implementation=W}};gn=je([B],gn),e.DebugAdapterInlineImplementation=gn;let on=class{constructor(W,ae){this.range=W,this.expression=ae}};on=je([B],on),e.EvaluatableExpression=on;var Tn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Tn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var yn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(yn=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let tn=class{constructor(W,ae){this.range=W,this.text=ae}};tn=je([B],tn),e.InlineValueText=tn;let pn=class{constructor(W,ae,Ae=!0){this.range=W,this.variableName=ae,this.caseSensitiveLookup=Ae}};pn=je([B],pn),e.InlineValueVariableLookup=pn;let nn=class{constructor(W,ae){this.range=W,this.expression=ae}};nn=je([B],nn),e.InlineValueEvaluatableExpression=nn;let rn=class{constructor(W,ae){this.frameId=W,this.stoppedLocation=ae}};rn=je([B],rn),e.InlineValueContext=rn;var An;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(An=e.FileChangeType||(e.FileChangeType={}));let vn=F=class extends Error{constructor(W,ae=k.FileSystemProviderErrorCode.Unknown,Ae){super(I.URI.isUri(W)?W.toString(!0):W);this.code=Ae?.name??"Unknown",(0,k.markAsFileSystemProviderError)(this,ae),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,F.prototype),typeof Error.captureStackTrace=="function"&&typeof Ae=="function"&&Error.captureStackTrace(this,Ae)}static FileExists(W){return new F(W,k.FileSystemProviderErrorCode.FileExists,F.FileExists)}static FileNotFound(W){return new F(W,k.FileSystemProviderErrorCode.FileNotFound,F.FileNotFound)}static FileNotADirectory(W){return new F(W,k.FileSystemProviderErrorCode.FileNotADirectory,F.FileNotADirectory)}static FileIsADirectory(W){return new F(W,k.FileSystemProviderErrorCode.FileIsADirectory,F.FileIsADirectory)}static NoPermissions(W){return new F(W,k.FileSystemProviderErrorCode.NoPermissions,F.NoPermissions)}static Unavailable(W){return new F(W,k.FileSystemProviderErrorCode.Unavailable,F.Unavailable)}};vn=F=je([B],vn),e.FileSystemError=vn;let Yt=class{constructor(W,ae,Ae){this.start=W,this.end=ae,this.kind=Ae}};Yt=je([B],Yt),e.FoldingRange=Yt;var Rn;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Rn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ln;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Ln=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var On;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(On=e.CommentMode||(e.CommentMode={}));var Nn;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(Nn=e.CommentThreadState||(e.CommentThreadState={}));class wn{constructor(W,ae=[]){this.tokenTypes=W,this.tokenModifiers=ae}}e.SemanticTokensLegend=wn;function Cn(j){return typeof j=="undefined"||(0,b.isStringArray)(j)}class an{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let ae=0,Ae=W.tokenTypes.length;ae<Ae;ae++)this._tokenTypeStrToInt.set(W.tokenTypes[ae],ae);for(let ae=0,Ae=W.tokenModifiers.length;ae<Ae;ae++)this._tokenModifierStrToInt.set(W.tokenModifiers[ae],ae)}}push(W,ae,Ae,Ke,rt){if(typeof W=="number"&&typeof ae=="number"&&typeof Ae=="number"&&typeof Ke=="number"&&(typeof rt=="number"||typeof rt=="undefined"))return typeof rt=="undefined"&&(rt=0),this._pushEncoded(W,ae,Ae,Ke,rt);if(X.isRange(W)&&typeof ae=="string"&&Cn(Ae))return this._push(W,ae,Ae);throw(0,n.illegalArgument)()}_push(W,ae,Ae){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ae))throw new Error("`tokenType` is not in the provided legend");const Ke=W.start.line,rt=W.start.character,ct=W.end.character-W.start.character,ut=this._tokenTypeStrToInt.get(ae);let yt=0;if(Ae)for(const Rt of Ae){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Ht=this._tokenModifierStrToInt.get(Rt);yt|=1<<Ht>>>0}this._pushEncoded(Ke,rt,ct,ut,yt)}_pushEncoded(W,ae,Ae,Ke,rt){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&ae<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let Rt=0,Ht=0;for(let Gt=0;Gt<yt;Gt++){let Jt=this._data[5*Gt],En=this._data[5*Gt+1];Jt===0?(Jt=Rt,En+=Ht):Jt+=Rt,this._data[5*Gt]=Jt,this._data[5*Gt+1]=En,Rt=Jt,Ht=En}}let ct=W,ut=ae;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ct-=this._prevLine,ct===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=ct,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=Ae,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=rt,this._prevLine=W,this._prevChar=ae}static _sortAndDeltaEncode(W){const ae=[],Ae=W.length/5|0;for(let ut=0;ut<Ae;ut++)ae[ut]=ut;ae.sort((ut,yt)=>{const Rt=W[5*ut],Ht=W[5*yt];if(Rt===Ht){const Gt=W[5*ut+1],Jt=W[5*yt+1];return Gt-Jt}return Rt-Ht});const Ke=new Uint32Array(W.length);let rt=0,ct=0;for(let ut=0;ut<Ae;ut++){const yt=5*ae[ut],Rt=W[yt+0],Ht=W[yt+1],Gt=W[yt+2],Jt=W[yt+3],En=W[yt+4],Xn=Rt-rt,bi=Xn===0?Ht-ct:Ht,_n=5*ut;Ke[_n+0]=Xn,Ke[_n+1]=bi,Ke[_n+2]=Gt,Ke[_n+3]=Jt,Ke[_n+4]=En,rt=Rt,ct=Ht}return Ke}build(W){return this._dataIsSortedAndDeltaEncoded?new He(new Uint32Array(this._data),W):new He(an._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=an;class He{constructor(W,ae){this.resultId=ae,this.data=W}}e.SemanticTokens=He;class jt{constructor(W,ae,Ae){this.start=W,this.deleteCount=ae,this.data=Ae}}e.SemanticTokensEdit=jt;class Dn{constructor(W,ae){this.resultId=ae,this.edits=W}}e.SemanticTokensEdits=Dn;var gt;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(gt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let cn=class{constructor(){}};cn.Back={iconPath:new Vt("arrow-left")},cn=je([B],cn),e.QuickInputButtons=cn;var Fn;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Fn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var In;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(In=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Mn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Mn=e.ExtensionKind||(e.ExtensionKind={}));class ln{constructor(W,ae,Ae){this.badge=W,this.tooltip=ae,this.color=Ae}static validate(W){if(W.badge){let ae=(0,y.nextCharLength)(W.badge,0);if(ae<W.badge.length&&(ae+=(0,y.nextCharLength)(W.badge,ae)),W.badge.length>ae)throw new Error("The 'badge'-property must be undefined or a short character")}if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ln;let bn=class{constructor(W){this.kind=W}};bn=je([B],bn),e.ColorTheme=bn;var Un;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(Un=e.ColorThemeKind||(e.ColorThemeKind={}));class $t{constructor(W,ae){if(W<0)throw(0,n.illegalArgument)("start must be positive");if(ae<0)throw(0,n.illegalArgument)("end must be positive");W<=ae?(this._start=W,this._end=ae):(this._start=ae,this._end=W)}static isNotebookRange(W){return W instanceof $t?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(W){let ae=this._start,Ae=this._end;return W.start!==void 0&&(ae=W.start),W.end!==void 0&&(Ae=W.end),ae===this._start&&Ae===this._end?this:new $t(ae,Ae)}}e.NotebookRange=$t;class qt{constructor(W,ae,Ae,Ke,rt,ct,ut){this.kind=W,this.value=ae,this.languageId=Ae,this.mime=Ke,this.outputs=rt??[],this.metadata=ct,this.executionSummary=ut,qt.validate(this)}static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(ae=>qt.isNotebookCellData(ae))}static isNotebookCellData(W){return!0}}e.NotebookCellData=qt;class Bn{constructor(W){this.cells=W}}e.NotebookData=Bn;class Bt{constructor(W,ae){this.data=W,this.mime=ae;const Ae=(0,C.normalizeMimeType)(ae,!0);if(!Ae)throw new Error(`INVALID mime type: ${ae}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ae}static isNotebookCellOutputItem(W){return W instanceof Bt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const ae={name:W.name,message:W.message,stack:W.stack};return Bt.json(ae,"application/vnd.code.notebook.error")}static stdout(W){return Bt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Bt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,ae="application/octet-stream"){return new Bt(W,ae)}static text(W,ae=C.Mimes.text){const Ae=Me(Bt,p,"f",f).encode(String(W));return new Bt(Ae,ae)}static json(W,ae="text/x-json"){const Ae=JSON.stringify(W,void 0,"	");return Bt.text(Ae,ae)}}e.NotebookCellOutputItem=Bt,p=Bt,f={value:new TextEncoder};class un{constructor(W,ae,Ae){this.items=un.ensureUniqueMimeTypes(W,!0),typeof ae=="string"?(this.id=ae,this.metadata=Ae):(this.id=(0,R.generateUuid)(),this.metadata=ae??Ae)}static isNotebookCellOutput(W){return W instanceof un?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&(0,b.isArray)(W.items)}static ensureUniqueMimeTypes(W,ae=!1){const Ae=new Set,Ke=new Set;for(let rt=0;rt<W.length;rt++){const ct=W[rt],ut=(0,C.normalizeMimeType)(ct.mime);if(!Ae.has(ut)){Ae.add(ut);continue}Ke.add(rt),ae&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ke.size===0?W:W.filter((rt,ct)=>!Ke.has(ct))}}e.NotebookCellOutput=un;var zn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(zn=e.NotebookCellKind||(e.NotebookCellKind={}));var Wn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Wn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var fe;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(fe=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var _e;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(_e=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ue{constructor(W,ae){this.text=W,this.alignment=ae}}e.NotebookCellStatusBarItem=Ue;var at;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(at=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class _t{constructor(W,ae=[]){this.uri=W,this.provides=(0,u.asArray)(ae)}}e.NotebookRendererScript=_t;let It=class{constructor(W,ae){this.label=W,this.timestamp=ae}};It=je([B],It),e.TimelineItem=It;var Zn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(Zn=e.ExtensionMode||(e.ExtensionMode={}));var ei;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(ei=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ti;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(ti=e.StandardTokenType||(e.StandardTokenType={}));class ni{constructor(W,ae){this.ranges=W,this.wordPattern=ae}}e.LinkedEditingRanges=ni;class ii{constructor(W,ae){this._port=W,this._autoForwardAction=ae}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=ii;var ri;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(ri=e.TestResultState||(e.TestResultState={}));var si;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(si=e.TestRunProfileKind||(e.TestRunProfileKind={}));let $n=class{constructor(W=void 0,ae=void 0,Ae=void 0){this.include=W,this.exclude=ae,this.profile=Ae}};$n=je([B],$n),e.TestRunRequest=$n;let Hn=M=class{constructor(W){this.message=W}static diff(W,ae,Ae){const Ke=new M(W);return Ke.expectedOutput=ae,Ke.actualOutput=Ae,Ke}};Hn=M=je([B],Hn),e.TestMessage=Hn;let xn=class{constructor(W){this.id=W}};xn=je([B],xn),e.TestTag=xn;let dn=class{constructor(W,ae){this.covered=W,this.total=ae}};dn=je([B],dn),e.CoveredCount=dn;let Vn=A=class{constructor(W,ae,Ae,Ke){this.uri=W,this.statementCoverage=ae,this.branchCoverage=Ae,this.functionCoverage=Ke}static fromDetails(W,ae){const Ae=new dn(0,0),Ke=new dn(0,0),rt=new dn(0,0);for(const ut of ae)if("branches"in ut){Ae.total+=1,Ae.covered+=ut.executionCount>0?1:0;for(const yt of ut.branches)Ke.total+=1,Ke.covered+=yt.executionCount>0?1:0}else rt.total+=1,rt.covered+=ut.executionCount>0?1:0;const ct=new A(W,Ae,Ke.total>0?Ke:void 0,rt.total>0?rt:void 0);return ct.detailedCoverage=ae,ct}};Vn=A=je([B],Vn),e.FileCoverage=Vn;let jn=class{constructor(W,ae,Ae=[]){this.executionCount=W,this.location=ae,this.branches=Ae}};jn=je([B],jn),e.StatementCoverage=jn;let qn=class{constructor(W,ae){this.executionCount=W,this.location=ae}};qn=je([B],qn),e.BranchCoverage=qn;let Gn=class{constructor(W,ae){this.executionCount=W,this.location=ae}};Gn=je([B],Gn),e.FunctionCoverage=Gn;var oi;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(oi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var ai;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(ai=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ci;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(ci=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class li{constructor(W,ae,Ae,Ke,rt,ct){this.kind=W,this.name=ae,this.detail=Ae,this.uri=Ke,this.range=rt,this.selectionRange=ct}}e.TypeHierarchyItem=li;class ui{constructor(W){this.uri=W}}e.TextTabInput=ui;class di{constructor(W,ae){this.original=W,this.modified=ae}}e.TextDiffTabInput=di;class hi{constructor(W,ae,Ae,Ke){this.base=W,this.input1=ae,this.input2=Ae,this.result=Ke}}e.TextMergeTabInput=hi;class fi{constructor(W,ae){this.uri=W,this.viewType=ae}}e.CustomEditorTabInput=fi;class mi{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=mi;class gi{constructor(W,ae){this.uri=W,this.notebookType=ae}}e.NotebookEditorTabInput=gi;class pi{constructor(W,ae,Ae){this.original=W,this.modified=ae,this.notebookType=Ae}}e.NotebookDiffEditorTabInput=pi;class vi{constructor(){}}e.TerminalEditorTabInput=vi;class wi{constructor(W,ae){this.uri=W,this.inputBoxUri=ae}}e.InteractiveWindowInput=wi}),define(Ie[126],ke([0,1,56,10,8,158,99,7,16]),function(J,e,u,n,D,T,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const I=new Map;function R(v,w){w?I.set(v,w):I.delete(v)}e.setWordDefinitionFor=R;function k(v){return I.get(v)}e.getWordDefinitionFor=k;class _ extends T.MirrorTextModel{constructor(w,p,f,E,g,c,m,a){super(p,f,E,g);this._proxy=w,this._languageId=c,this._isDirty=m,this.notebook=a,this._isDisposed=!1}dispose(){(0,u.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(w){return(0,b.equals)(this._lines,w)}get document(){if(!this._document){const w=this;this._document={get uri(){return w._uri},get fileName(){return w._uri.fsPath},get isUntitled(){return w._uri.scheme===n.Schemas.untitled},get languageId(){return w._languageId},get version(){return w._versionId},get isClosed(){return w._isDisposed},get isDirty(){return w._isDirty},save(){return w._save()},getText(p){return p?w._getTextInRange(p):w.getText()},get eol(){return w._eol===`
`?y.EndOfLine.LF:y.EndOfLine.CRLF},get lineCount(){return w._lines.length},lineAt(p){return w._lineAt(p)},offsetAt(p){return w._offsetAt(p)},positionAt(p){return w._positionAt(p)},validateRange(p){return w._validateRange(p)},validatePosition(p){return w._validatePosition(p)},getWordRangeAtPosition(p,f){return w._getWordRangeAtPosition(p,f)}}}return Object.freeze(this._document)}_acceptLanguageId(w){(0,u.ok)(!this._isDisposed),this._languageId=w}_acceptIsDirty(w){(0,u.ok)(!this._isDisposed),this._isDirty=w}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(w){const p=this._validateRange(w);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const f=this._eol,E=p.start.line,g=p.end.line,c=[];c.push(this._lines[E].substring(p.start.character));for(let m=E+1;m<g;m++)c.push(this._lines[m]);return c.push(this._lines[g].substring(0,p.end.character)),c.join(f)}_lineAt(w){let p;if(w instanceof y.Position?p=w.line:typeof w=="number"&&(p=w),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new P(p,this._lines[p],p===this._lines.length-1)}_offsetAt(w){return w=this._validatePosition(w),this._ensureLineStarts(),this._lineStarts.getPrefixSum(w.line-1)+w.character}_positionAt(w){w=Math.floor(w),w=Math.max(0,w),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(w),f=this._lines[p.index].length;return new y.Position(p.index,Math.min(p.remainder,f))}_validateRange(w){if(!(w instanceof y.Range))throw new Error("Invalid argument");const p=this._validatePosition(w.start),f=this._validatePosition(w.end);return p===w.start&&f===w.end?w:new y.Range(p.line,p.character,f.line,f.character)}_validatePosition(w){if(!(w instanceof y.Position))throw new Error("Invalid argument");if(this._lines.length===0)return w.with(0,0);let{line:p,character:f}=w,E=!1;if(p<0)p=0,f=0,E=!0;else if(p>=this._lines.length)p=this._lines.length-1,f=this._lines[p].length,E=!0;else{const g=this._lines[p].length;f<0?(f=0,E=!0):f>g&&(f=g,E=!0)}return E?new y.Position(p,f):w}_getWordRangeAtPosition(w,p){const f=this._validatePosition(w);if(!p)p=k(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const E=(0,C.getWordAtText)(f.character+1,(0,C.ensureValidWordDefinition)(p),this._lines[f.line],0);if(E)return new y.Range(f.line,E.startColumn-1,f.line,E.endColumn-1)}}e.ExtHostDocumentData=_;class P{constructor(w,p,f){this._line=w,this._text=p,this._isLastLine=f}get lineNumber(){return this._line}get text(){return this._text}get range(){return new y.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new y.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=P}),define(Ie[209],ke([0,1,7,17,3]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(y){this._actual=new u.ColorTheme(u.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(y){let b;switch(y){case"light":b=u.ColorThemeKind.Light;break;case"hcDark":b=u.ColorThemeKind.HighContrast;break;case"hcLight":b=u.ColorThemeKind.HighContrastLight;break;default:b=u.ColorThemeKind.Dark}this._actual=new u.ColorTheme(b),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=je([Ve(0,n.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(Ie[65],ke([0,1,4]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,u.createDecorator)("IURITransformerService");class n{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=n}),define(Ie[210],ke([0,1,23]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class n{constructor(){this.buffers=[]}add(b){let I=this.buffers.indexOf(b);return I<0&&(I=this.buffers.length,this.buffers.push(b)),I}}function D(y,b){if(b.serializeBuffersForPostMessage){const I=new n,R=(P,v)=>{if(v instanceof ArrayBuffer){const w=I.add(v);return{$$vscode_array_buffer_reference$$:!0,index:w}}else if(ArrayBuffer.isView(v)){const w=T(v);if(w){const p=I.add(v.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:w,byteLength:v.byteLength,byteOffset:v.byteOffset}}}}return v},k=JSON.stringify(y,R),_=I.buffers.map(P=>{const v=new Uint8Array(P);return u.VSBuffer.wrap(v)});return{message:k,buffers:_}}else return{message:JSON.stringify(y),buffers:[]}}e.serializeWebviewMessage=D;function T(y){switch(y.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(y,b){const I=b.map(_=>{const P=new ArrayBuffer(_.byteLength);return new Uint8Array(P).set(_.buffer),P}),R=b.length?(_,P)=>{if(P&&typeof P=="object"&&P.$$vscode_array_buffer_reference$$){const v=P,{index:w}=v,p=I[w];if(v.view)switch(v.view.type){case 1:return new Int8Array(p,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return P}:void 0;return{message:JSON.parse(y,R),arrayBuffers:I}}e.deserializeWebviewMessage=C}),define(Ie[211],ke([0,1,108]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function n(T){return{transformIncoming:C=>C.scheme==="vscode-remote"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="file"?{scheme:"vscode-local",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoing:C=>C.scheme==="file"?{scheme:"vscode-remote",authority:T,path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="vscode-local"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoingScheme:C=>C==="file"?"vscode-remote":C==="vscode-local"?"file":C}}function D(T){return new u.URITransformer(n(T))}e.createURITransformer=D}),define(Ie[212],ke([0,1,179,11,2,6,4,44,43,16,10]),function(J,e,u,n,D,T,C,y,b,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,u.localize)(0,null),providerDisplayName:(0,u.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var k;(function(N){N[N.PROGRAMMATIC=1]="PROGRAMMATIC",N[N.USER=2]="USER",N[N.EDIT=3]="EDIT",N[N.NAVIGATION=4]="NAVIGATION",N[N.JUMP=5]="JUMP"})(k=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var _;(function(N){N[N.IDENTICAL=1]="IDENTICAL",N[N.SIMILAR=2]="SIMILAR",N[N.DIFFERENT=3]="DIFFERENT"})(_=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function P(N){const V=N;return!!V&&typeof V.getSelection=="function"&&!!V.onDidChangeSelection}e.isEditorPaneWithSelection=P;function v(N,V,x){for(const q of x.visibleEditorPanes)if(q.group.id===V&&N.matches(q.input))return q.getViewState()}e.findViewStateForEditor=v;function w(N){if(o(N))return!1;const V=N;return D.URI.isUri(V?.resource)}e.isResourceEditorInput=w;function p(N){if(o(N))return!1;const V=N;return V?.original!==void 0&&V.modified!==void 0}e.isResourceDiffEditorInput=p;function f(N){if(o(N)||p(N))return!1;const V=N;return V?.primary!==void 0&&V.secondary!==void 0}e.isResourceSideBySideEditorInput=f;function E(N){if(o(N))return!1;const V=N;return V?V.resource===void 0||V.resource.scheme===R.Schemas.untitled||V.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=E;function g(N){if(o(N))return!1;const V=N;return D.URI.isUri(V?.base?.resource)&&D.URI.isUri(V?.input1?.resource)&&D.URI.isUri(V?.input2?.resource)&&D.URI.isUri(V?.result?.resource)}e.isResourceMergeEditorInput=g;var c;(function(N){N[N.SHORT=0]="SHORT",N[N.MEDIUM=1]="MEDIUM",N[N.LONG=2]="LONG"})(c=e.Verbosity||(e.Verbosity={}));var m;(function(N){N[N.EXPLICIT=1]="EXPLICIT",N[N.AUTO=2]="AUTO",N[N.FOCUS_CHANGE=3]="FOCUS_CHANGE",N[N.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(m=e.SaveReason||(e.SaveReason={}));class a{constructor(){this.mapIdToSaveSource=new Map}registerSource(V,x){let q=this.mapIdToSaveSource.get(V);return q||(q={source:V,label:x},this.mapIdToSaveSource.set(V,q)),q.source}getSourceLabel(V){return this.mapIdToSaveSource.get(V)?.label??V}}e.SaveSourceRegistry=new a;var d;(function(N){N[N.None=0]="None",N[N.Readonly=2]="Readonly",N[N.Untitled=4]="Untitled",N[N.Singleton=8]="Singleton",N[N.RequiresTrust=16]="RequiresTrust",N[N.CanSplitInGroup=32]="CanSplitInGroup",N[N.ForceDescription=64]="ForceDescription",N[N.CanDropIntoEditor=128]="CanDropIntoEditor",N[N.MultipleEditors=256]="MultipleEditors"})(d=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class i extends T.Disposable{}e.AbstractEditorInput=i;function o(N){return N instanceof i}e.isEditorInput=o;function r(N){const V=N;return D.URI.isUri(V?.preferredResource)}function t(N){const V=N;return o(V?.primary)&&o(V?.secondary)}e.isSideBySideEditorInput=t;function s(N){const V=N;return o(V?.modified)&&o(V?.original)}e.isDiffEditorInput=s;function l(N){return o(N?.editor)}e.isEditorInputWithOptions=l;function h(N){const V=N;return l(N)&&V?.group!==void 0}e.isEditorInputWithOptionsAndGroup=h;function S(N){const V=N;return typeof V?.groupId=="number"&&o(V.editor)}e.isEditorIdentifier=S;var L;(function(N){N[N.UNKNOWN=0]="UNKNOWN",N[N.REPLACE=1]="REPLACE",N[N.MOVE=2]="MOVE",N[N.UNPIN=3]="UNPIN"})(L=e.EditorCloseContext||(e.EditorCloseContext={}));var F;(function(N){N[N.GROUP_ACTIVE=0]="GROUP_ACTIVE",N[N.GROUP_INDEX=1]="GROUP_INDEX",N[N.GROUP_LOCKED=2]="GROUP_LOCKED",N[N.EDITOR_OPEN=3]="EDITOR_OPEN",N[N.EDITOR_CLOSE=4]="EDITOR_CLOSE",N[N.EDITOR_MOVE=5]="EDITOR_MOVE",N[N.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",N[N.EDITOR_LABEL=7]="EDITOR_LABEL",N[N.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",N[N.EDITOR_PIN=9]="EDITOR_PIN",N[N.EDITOR_STICKY=10]="EDITOR_STICKY",N[N.EDITOR_DIRTY=11]="EDITOR_DIRTY",N[N.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(F=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var M;(function(N){N[N.PRIMARY=1]="PRIMARY",N[N.SECONDARY=2]="SECONDARY",N[N.BOTH=3]="BOTH",N[N.ANY=4]="ANY"})(M=e.SideBySideEditor||(e.SideBySideEditor={}));class A{getOriginalUri(V,x){if(!V)return;if(g(V))return e.EditorResourceAccessor.getOriginalUri(V.result,x);if(x?.supportSideBySide){const{primary:te,secondary:Y}=this.getSideEditors(V);if(te&&Y){if(x?.supportSideBySide===M.BOTH)return{primary:this.getOriginalUri(te,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(Y,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===M.ANY)return this.getOriginalUri(te,{filterByScheme:x.filterByScheme})??this.getOriginalUri(Y,{filterByScheme:x.filterByScheme});V=x.supportSideBySide===M.PRIMARY?te:Y}}if(p(V)||f(V)||g(V))return;const q=r(V)?V.preferredResource:V.resource;return!q||!x||!x.filterByScheme?q:this.filterUri(q,x.filterByScheme)}getSideEditors(V){return t(V)||f(V)?{primary:V.primary,secondary:V.secondary}:s(V)||p(V)?{primary:V.modified,secondary:V.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(V,x){if(!V)return;if(g(V))return e.EditorResourceAccessor.getCanonicalUri(V.result,x);if(x?.supportSideBySide){const{primary:te,secondary:Y}=this.getSideEditors(V);if(te&&Y){if(x?.supportSideBySide===M.BOTH)return{primary:this.getCanonicalUri(te,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(Y,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===M.ANY)return this.getCanonicalUri(te,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(Y,{filterByScheme:x.filterByScheme});V=x.supportSideBySide===M.PRIMARY?te:Y}}if(p(V)||f(V)||g(V))return;const q=V.resource;return!q||!x||!x.filterByScheme?q:this.filterUri(q,x.filterByScheme)}filterUri(V,x){if(Array.isArray(x)){if(x.some(q=>V.scheme===q))return V}else if(x===V.scheme)return V}}e.EditorResourceAccessor=new A;var B;(function(N){N[N.LEFT=0]="LEFT",N[N.RIGHT=1]="RIGHT"})(B=e.CloseDirection||(e.CloseDirection={}));class ${constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(V){const x=this.instantiationService=V.get(C.IInstantiationService);for(const[q,te]of this.editorSerializerConstructors)this.createEditorSerializer(q,te,x);this.editorSerializerConstructors.clear()}createEditorSerializer(V,x,q){const te=q.createInstance(x);this.editorSerializerInstances.set(V,te)}registerFileEditorFactory(V){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=V}getFileEditorFactory(){return(0,n.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(V,x){if(this.editorSerializerConstructors.has(V)||this.editorSerializerInstances.has(V))throw new Error(`A editor serializer with type ID '${V}' was already registered.`);return this.instantiationService?this.createEditorSerializer(V,x,this.instantiationService):this.editorSerializerConstructors.set(V,x),(0,T.toDisposable)(()=>{this.editorSerializerConstructors.delete(V),this.editorSerializerInstances.delete(V)})}getEditorSerializer(V){return this.editorSerializerInstances.get(typeof V=="string"?V:V.typeId)}}y.Registry.add(e.EditorExtensions.EditorFactory,new $);async function U(N,V){if(!N||!N.length)return[];const x=await Promise.all(N.map(async q=>{const te=D.URI.revive(q.fileUri);if(!te||!await V.canHandleResource(te))return;let le=q.exists,pe=q.type;if(typeof le!="boolean"||typeof pe!="number")try{pe=(await V.stat(te)).isDirectory?b.FileType.Directory:b.FileType.Unknown,le=!0}catch{le=!1}if(!le&&q.openOnlyIfExists||pe===b.FileType.Directory)return;const ee={...q.options,pinned:!0};let ge;return le?ge={resource:te,options:ee}:ge={resource:te,options:ee,forceUntitled:!0},ge}));return(0,I.coalesce)(x)}e.pathsToEditors=U;var X;(function(N){N[N.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",N[N.SEQUENTIAL=1]="SEQUENTIAL"})(X=e.EditorsOrder||(e.EditorsOrder={}));function z(N){const V=N;if(!V)return!1;const x=V;if(x.modified)return z(x.modified);const q=V;return!!(q.contributionsState&&q.viewState&&Array.isArray(q.cursorState))}e.isTextEditorViewState=z}),define(Ie[88],ke([0,1,10,2]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function D(y,b){return y.scheme===u.Schemas.http||y.scheme===u.Schemas.https?y:(b&&b.authority&&b.isRemote&&y.scheme===u.Schemas.file&&(y=n.URI.from({scheme:u.Schemas.vscodeRemote,authority:b.authority,path:y.path})),n.URI.from({scheme:u.Schemas.https,authority:`${y.scheme}+${T(y.authority)}.${e.webviewRootResourceAuthority}`,path:y.path,fragment:y.fragment,query:y.query}))}e.asWebviewUri=D;function T(y){return y.replace(/./g,b=>{const I=b.charCodeAt(0);return I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57?b:"-"+I.toString(16).padStart(4,"0")})}function C(y){return y.replace(/-([0-9a-f]{4})/g,(b,I)=>String.fromCharCode(parseInt(I,16)))}e.decodeAuthority=C}),define(Ie[213],ke([0,1,3,6,88]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(y,b,I){this._proxy=y,this._editors=b,this._remoteInfo=I,this._handlePool=0,this._disposables=new n.DisposableStore,this._insets=new Map,this._disposables.add(b.onDidChangeVisibleTextEditors(()=>{const R=b.getVisibleTextEditors();for(const k of this._insets.values())R.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,b,I,R,k){let _;for(const g of this._editors.getVisibleTextEditors(!0))if(g.value===y){_=g;break}if(!_)throw new Error("not a visible editor");const P=this,v=this._handlePool++,w=new u.Emitter,p=new u.Emitter,f=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(g){return(0,D.asWebviewUri)(g,P._remoteInfo)}get cspSource(){return D.webviewGenericCspSource}set options(g){this._options=g,P._proxy.$setOptions(v,g)}get options(){return this._options}set html(g){this._html=g,P._proxy.$setHtml(v,g)}get html(){return this._html}get onDidReceiveMessage(){return w.event}postMessage(g){return P._proxy.$postMessage(v,g)}},E=new class{constructor(){this.editor=y,this.line=b,this.height=I,this.webview=f,this.onDidDispose=p.event}dispose(){P._insets.has(v)&&(P._insets.delete(v),P._proxy.$disposeEditorInset(v),p.fire(),p.dispose(),w.dispose())}};return this._proxy.$createEditorInset(v,_.id,_.value.document.uri,b+1,I,R||{},k.identifier,k.extensionLocation),this._insets.set(v,{editor:y,inset:E,onDidReceiveMessage:w}),E}$onDidDispose(y){const b=this._insets.get(y);b&&b.inset.dispose()}$onDidReceiveMessage(y,b){this._insets.get(y)?.onDidReceiveMessage.fire(b)}}e.ExtHostEditorInsets=T}),define(Ie[127],ke([0,1,3,18,180]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new u.Emitter,this._onExit=new u.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(y){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=y}onEvent(y){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=y}onRequest(y){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=y}sendResponse(y){y.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${y.command}`)):this.internalSend("response",y)}sendRequest(y,b,I,R){const k={command:y};if(b&&Object.keys(b).length>0&&(k.arguments=b),this.internalSend("request",k),typeof R=="number"){const _=setTimeout(()=>{clearTimeout(_);const P=this.pendingRequests.get(k.seq);if(P){this.pendingRequests.delete(k.seq);const v={type:"response",seq:0,request_seq:k.seq,success:!1,command:y,message:(0,D.localize)(0,null,R,y)};P(v)}},R)}return I&&this.pendingRequests.set(k.seq,I),k.seq}acceptMessage(y){this.messageCallback?this.messageCallback(y):(this.queue.push(y),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(y,b){return y.type!=="event"||b.type!=="event"}async processQueue(){let y;for(;this.queue.length;){if((!y||this.needsTaskBoundaryBetween(this.queue[0],y))&&await(0,n.timeout)(0),y=this.queue.shift(),!y)return;switch(y.type){case"event":this.eventCallback?.(y);break;case"request":this.requestCallback?.(y);break;case"response":{const b=y,I=this.pendingRequests.get(b.request_seq);I&&(this.pendingRequests.delete(b.request_seq),I(b));break}}}}internalSend(y,b){b.type=y,b.seq=this.sequence++,this.sendMessage(b)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const y=new Map;this.pendingRequests.forEach((b,I)=>y.set(I,b)),await(0,n.timeout)(500),y.forEach((b,I)=>{b({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(I)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(Ie[214],ke([0,1,181,51,4]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerUiMessage=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new n.RawContextKey("debugType",void 0,{type:"string",description:u.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new n.RawContextKey("debugConfigurationType",void 0,{type:"string",description:u.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new n.RawContextKey("debugState","inactive",{type:"string",description:u.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new n.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:u.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new n.RawContextKey("inDebugMode",!1,{type:"boolean",description:u.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new n.RawContextKey("inDebugRepl",!1,{type:"boolean",description:u.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new n.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:u.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new n.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:u.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new n.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:u.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new n.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:u.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new n.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:u.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new n.RawContextKey("variablesFocused",!0,{type:"boolean",description:u.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new n.RawContextKey("expressionSelected",!1,{type:"boolean",description:u.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new n.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:u.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new n.RawContextKey("callStackItemType",void 0,{type:"string",description:u.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new n.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:u.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new n.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:u.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new n.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:u.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new n.RawContextKey("watchItemType",void 0,{type:"string",description:u.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new n.RawContextKey("canViewMemory",void 0,{type:"boolean",description:u.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new n.RawContextKey("breakpointItemType",void 0,{type:"string",description:u.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new n.RawContextKey("breakpointAccessType",void 0,{type:"string",description:u.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new n.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:u.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new n.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:u.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new n.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:u.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new n.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:u.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new n.RawContextKey("stepBackSupported",!1,{type:"boolean",description:u.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new n.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:u.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new n.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:u.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new n.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:u.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new n.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:u.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new n.RawContextKey("breakpointsExist",!1,{type:"boolean",description:u.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new n.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:u.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new n.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:u.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new n.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:u.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new n.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:u.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new n.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:u.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new n.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:u.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new n.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:u.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new n.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:u.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new n.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:u.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new n.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:u.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new n.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:u.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new n.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:u.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new n.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:u.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new n.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:u.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new n.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:u.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new n.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:u.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new n.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:u.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new n.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:u.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new n.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:u.localize(50,null)});const T=_=>u.localize(51,null,_);e.debuggerDisabledMessage=T,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:u.localize(52,null)};var C;(function(_){_[_.Inactive=0]="Inactive",_[_.Initializing=1]="Initializing",_[_.Stopped=2]="Stopped",_[_.Running=3]="Running"})(C=e.State||(e.State={}));function y(_){switch(_){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=y;var b;(function(_){_[_.Valid=0]="Valid",_[_.Unreadable=1]="Unreadable",_[_.Error=2]="Error"})(b=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var I;(function(_){_[_.Initial=1]="Initial",_[_.Dynamic=2]="Dynamic"})(I=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var R;(function(_){_.UnverifiedBreakpoints="unverifiedBreakpoints"})(R=e.DebuggerUiMessage||(e.DebuggerUiMessage={})),e.IDebugService=(0,D.createDecorator)(e.DEBUG_SERVICE_ID);var k;(function(_){_[_.CONDITION=0]="CONDITION",_[_.HIT_COUNT=1]="HIT_COUNT",_[_.LOG_MESSAGE=2]="LOG_MESSAGE"})(k=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ie[215],ke([0,1,8,2,9,24,10]),function(J,e,u,n,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const y=/{([^}]+)}/g;function b(i,o,r){return i.replace(y,function(t,s){return o&&s.length>0&&s[0]!=="_"?t:r&&r.hasOwnProperty(s)?r[s]:t})}e.formatPII=b;function I(i){const o={};for(const r of Object.keys(i))r.startsWith("!")||(o[r]=i[r]);return o}e.filterExceptionsFromTelemetry=I;function R(i){return i.configuration.request==="attach"&&!k(i)&&(!i.parentSession||R(i.parentSession))}e.isSessionAttach=R;function k(i){let o=i.configuration.type;if(!!o)return o==="vslsShare"&&(o=i.configuration.adapterProxy.configuration.type),(0,u.equalsIgnoreCase)(o,"extensionhost")||(0,u.equalsIgnoreCase)(o,"pwa-extensionhost")?i:i.parentSession?k(i.parentSession):void 0}e.getExtensionHostDebugSession=k;function _(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=_;function P(i,o,r){let t,s=0;const l=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let h=null;for(;h=l.exec(i);){const S=h.index+1,L=S+h[0].length;if(S<=o&&L>=r){t=h[0],s=S;break}}if(t){const S=/\w+/g;let L=null;for(;(L=S.exec(t))&&!(L.index+1+s+L[0].length>=r););L&&(t=t.substring(0,S.lastIndex))}return t?{start:s,end:s+t.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=P;const v=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function w(i){return!!(i&&i.match(v))}e.isUri=w;function p(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(w(i.path))return n.URI.parse(i.path);if((0,D.isAbsolute)(i.path))return n.URI.file(i.path)}return i.path}function f(i){if(typeof i.path=="object"){const o=n.URI.revive(i.path);if(o)return o.scheme===C.Schemas.file?o.fsPath:o.toString()}return i.path}function E(i,o){const r=o?p:f,t=(0,T.deepClone)(i);return c(t,(s,l)=>{s&&l&&(l.path=r(l))}),t}e.convertToDAPaths=E;function g(i,o){const r=o?p:f,t=(0,T.deepClone)(i);return c(t,(s,l)=>{!s&&l&&(l.path=r(l))}),t}e.convertToVSCPaths=g;function c(i,o){switch(i.type){case"event":{const r=i;switch(r.event){case"output":o(!1,r.body.source);break;case"loadedSource":o(!1,r.body.source);break;case"breakpoint":o(!1,r.body.breakpoint.source);break;default:break}break}case"request":{const r=i;switch(r.command){case"setBreakpoints":o(!0,r.arguments.source);break;case"breakpointLocations":o(!0,r.arguments.source);break;case"source":o(!0,r.arguments.source);break;case"gotoTargets":o(!0,r.arguments.source);break;case"launchVSCode":r.arguments.args.forEach(t=>o(!1,t));break;default:break}break}case"response":{const r=i;if(r.success&&r.body)switch(r.command){case"stackTrace":r.body.stackFrames.forEach(t=>o(!1,t.source));break;case"loadedSources":r.body.sources.forEach(t=>o(!1,t));break;case"scopes":r.body.scopes.forEach(t=>o(!1,t.source));break;case"setFunctionBreakpoints":r.body.breakpoints.forEach(t=>o(!1,t.source));break;case"setBreakpoints":r.body.breakpoints.forEach(t=>o(!1,t.source));break;case"disassemble":r.body?.instructions.forEach(s=>o(!1,s.location));break;default:break}break}}}function m(i){return i.filter(o=>!o.presentation?.hidden).sort((o,r)=>o.presentation?r.presentation?o.presentation.group?r.presentation.group?o.presentation.group!==r.presentation.group?o.presentation.group.localeCompare(r.presentation.group):a(o.presentation.order,r.presentation.order):-1:r.presentation.group?1:a(o.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=m;function a(i,o){return typeof i!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:i-o}async function d(i,o){const r=i.getValue("debug.saveBeforeStart",{overrideIdentifier:o.activeTextEditorLanguageId});if(r!=="none"&&(await o.saveAll(),r==="allEditorsInActiveGroup")){const t=o.activeEditorPane;t&&t.input.resource?.scheme===C.Schemas.untitled&&await o.save({editor:t.input,groupId:t.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=d}),define(Ie[216],ke([0,1,29,42,182,217,9,8,24,13,84,127]),function(J,e,u,n,D,T,C,y,b,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class _ extends k.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(E,g){this.outputStream=g,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,E.on("data",c=>this.handleData(c))}sendMessage(E){if(this.outputStream){const g=JSON.stringify(E);this.outputStream.write(`Content-Length: ${Buffer.byteLength(g,"utf8")}${_.TWO_CRLF}${g}`,"utf8")}}handleData(E){for(this.rawData=Buffer.concat([this.rawData,E]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const g=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,g.length>0)try{this.acceptMessage(JSON.parse(g))}catch(c){this._onError.fire(new Error((c.message||c)+`
`+g))}continue}}else{const g=this.rawData.indexOf(_.TWO_CRLF);if(g!==-1){const m=this.rawData.toString("utf8",0,g).split(_.HEADER_LINESEPARATOR);for(const a of m){const d=a.split(_.HEADER_FIELDSEPARATOR);d[0]==="Content-Length"&&(this.contentLength=Number(d[1]))}this.rawData=this.rawData.slice(g+_.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=_,_.TWO_CRLF=`\r
\r
`,_.HEADER_LINESEPARATOR=/\r?\n/,_.HEADER_FIELDSEPARATOR=/: */;class P extends _{startSession(){return new Promise((E,g)=>{let c=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),E(),c=!0}),this.socket.on("close",()=>{c?this._onError.fire(new Error("connection closed")):g(new Error("connection closed"))}),this.socket.on("error",m=>{c?this._onError.fire(m):g(m)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=P;class v extends P{constructor(E){super();this.adapterServer=E}createConnection(E){return T.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",E)}}e.SocketDebugAdapter=v;class w extends P{constructor(E){super();this.adapterServer=E}createConnection(E){return T.createConnection(this.adapterServer.path,E)}}e.NamedPipeDebugAdapter=w;class p extends _{constructor(E,g,c){super();this.adapterExecutable=E,this.debugType=g,this.outputService=c}async startSession(){const E=this.adapterExecutable.command,g=this.adapterExecutable.args,c=this.adapterExecutable.options||{};try{if(E)if(C.isAbsolute(E)){if(!await u.Promises.exists(E))throw new Error(D.localize(0,null,E))}else E.indexOf("/")<0&&E.indexOf("\\")<0;else throw new Error(D.localize(1,null,this.debugType));let m=process.env;if(c.env&&Object.keys(c.env).length>0&&(m=b.mixin(b.deepClone(process.env),c.env)),E==="node")if(Array.isArray(g)&&g.length>0){const d=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:m,execArgv:d?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};c.cwd&&(i.cwd=c.cwd);const o=n.fork(g[0],g.slice(1),i);if(!o.pid)throw new Error(D.localize(2,null,g[0]));this.serverProcess=o}else throw new Error(D.localize(3,null));else{const d={env:m};c.cwd&&(d.cwd=c.cwd),this.serverProcess=n.spawn(E,g,d)}this.serverProcess.on("error",d=>{this._onError.fire(d)}),this.serverProcess.on("exit",(d,i)=>{this._onExit.fire(d)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",d=>{this._onError.fire(d)}),this.serverProcess.stdin.on("error",d=>{this._onError.fire(d)});const a=this.outputService;if(a){const d=i=>i.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",i=>{a.getChannel(R.ExtensionsChannelId)?.append(d(i))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(m){this._onError.fire(m)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),I.isWindows?new Promise((E,g)=>{const c=n.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(m,a,d){if(m)return g(m)});c.on("exit",E),c.on("error",g)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(E,g){if(!E)return;const c=Object.create(null);E.runtime&&(E.runtime.indexOf("./")===0?c.runtime=C.join(g,E.runtime):c.runtime=E.runtime),E.runtimeArgs&&(c.runtimeArgs=E.runtimeArgs),E.program&&(C.isAbsolute(E.program)?c.program=E.program:c.program=C.join(g,E.program)),E.args&&(c.args=E.args);const m=E;return m.win&&(c.win=p.extract(m.win,g)),m.winx86&&(c.winx86=p.extract(m.winx86,g)),m.windows&&(c.windows=p.extract(m.windows,g)),m.osx&&(c.osx=p.extract(m.osx,g)),m.linux&&(c.linux=p.extract(m.linux,g)),c}static platformAdapterExecutable(E,g){let c=Object.create(null);g=g.toLowerCase();for(const r of E)if(r.contributes){const t=r.contributes.debuggers;t&&t.length>0&&t.filter(s=>typeof s.type=="string"&&y.equalsIgnoreCase(s.type,g)).forEach(s=>{const l=p.extract(s,r.extensionLocation.fsPath);c=b.mixin(c,l,r.isBuiltin)})}let m;I.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=c.winx86||c.win||c.windows:I.isWindows?m=c.win||c.windows:I.isMacintosh?m=c.osx:I.isLinux&&(m=c.linux),m=m||c;const a=m.program||c.program,d=m.args||c.args,i=m.runtime||c.runtime,o=m.runtimeArgs||c.runtimeArgs;if(i)return{type:"executable",command:i,args:(o||[]).concat(typeof a=="string"?[a]:[]).concat(d||[])};if(a)return{type:"executable",command:a,args:d||[]}}}e.ExecutableDebugAdapter=p}),define(Ie[218],ke([0,1,42,30,13]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function T(I,R){return new Promise((k,_)=>{let P="";const v=u.spawn(I,R);v.pid&&v.stdout.on("data",w=>{P+=w.toString()}),v.on("error",w=>{_(w)}),v.on("close",w=>{k(P)})})}async function C(I){if(I)if(D.isWindows){const R=await new Promise((k,_)=>{J(["windows-process-tree"],k,_)});return new Promise(k=>{R.getProcessTree(I,_=>{k(!!_&&_.children.length>0)})})}else return T("/usr/bin/pgrep",["-lP",String(I)]).then(R=>{const k=R.trim();return!(k.length===0||k.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.hasChildProcesses=C;var y;(function(I){I[I.cmd=0]="cmd",I[I.powershell=1]="powershell",I[I.bash=2]="bash"})(y||(y={}));function b(I,R,k,_,P){I=I.trim().toLowerCase();let v;I.indexOf("powershell")>=0||I.indexOf("pwsh")>=0?v=1:I.indexOf("cmd.exe")>=0?v=0:I.indexOf("bash")>=0?v=2:D.isWindows?v=0:v=2;let w,p=" ";switch(v){case 1:if(w=f=>(f=f.replace(/\'/g,"''"),f.length>0&&f.charAt(f.length-1)==="\\"?`'${f}\\'`:`'${f}'`),_){const f=(0,n.getDriveLetter)(_);f&&(p+=`${f}:; `),p+=`cd ${w(_)}; `}if(P)for(const f in P){const E=P[f];E===null?p+=`Remove-Item env:${f}; `:p+=`\${env:${f}}='${E}'; `}if(R.length>0){const f=R.shift(),E=k?f:w(f);p+=E[0]==="'"?`& ${E} `:`${E} `;for(const g of R)p+=g==="<"||g===">"||k?g:w(g),p+=" "}break;case 0:if(w=f=>(f=f.replace(/\"/g,'""'),f=f.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(E=>f.includes(E))||f.length===0?`"${f}"`:f),_){const f=(0,n.getDriveLetter)(_);f&&(p+=`${f}: && `),p+=`cd ${w(_)} && `}if(P){p+='cmd /C "';for(const f in P){let E=P[f];E===null?p+=`set "${f}=" && `:(E=E.replace(/[&^|<>]/g,g=>`^${g}`),p+=`set "${f}=${E}" && `)}}for(const f of R)p+=f==="<"||f===">"||k?f:w(f),p+=" ";P&&(p+='"');break;case 2:{w=E=>(E=E.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),E.length===0?'""':E);const f=E=>/[^\w@%\/+=,.:^-]/.test(E)?`'${E.replace(/'/g,"'\\''")}'`:E;if(_&&(p+=`cd ${w(_)} ; `),P){p+="/usr/bin/env";for(const E in P){const g=P[E];g===null?p+=` -u ${f(E)}`:p+=` ${f(`${E}=${g}`)}`}p+=" "}for(const E of R)p+=E==="<"||E===">"||k?E:w(E),p+=" ";break}}return p}e.prepareCommand=b}),define(Ie[128],ke([0,1,23,37,59,101,10,9,13,51]),function(J,e,u,n,D,T,C,y,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var R;(function(t){t[t.Markup=1]="Markup",t[t.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",T.Mimes.latex,T.Mimes.markdown,"image/png","image/jpeg",T.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[T.Mimes.latex,T.Mimes.markdown,"application/json",T.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(t){t[t.Running=1]="Running",t[t.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var _;(function(t){t[t.Unconfirmed=1]="Unconfirmed",t[t.Pending=2]="Pending",t[t.Executing=3]="Executing"})(_=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var P;(function(t){t[t.WithHardKernelDependency=0]="WithHardKernelDependency",t[t.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",t[t.Pure=2]="Pure",t[t.Never=3]="Never"})(P=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var v;(function(t){t.Always="always",t.Never="never",t.Optional="optional"})(v=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var w;(function(t){t[t.ModelChange=1]="ModelChange",t[t.Move=2]="Move",t[t.ChangeCellLanguage=5]="ChangeCellLanguage",t[t.Initialize=6]="Initialize",t[t.ChangeCellMetadata=7]="ChangeCellMetadata",t[t.Output=8]="Output",t[t.OutputItem=9]="OutputItem",t[t.ChangeCellContent=10]="ChangeCellContent",t[t.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",t[t.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",t[t.ChangeCellMime=13]="ChangeCellMime",t[t.Unknown=100]="Unknown"})(w=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var p;(function(t){t[t.Handle=0]="Handle",t[t.Index=1]="Index"})(p=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(t){t[t.Replace=1]="Replace",t[t.Output=2]="Output",t[t.Metadata=3]="Metadata",t[t.CellLanguage=4]="CellLanguage",t[t.DocumentMetadata=5]="DocumentMetadata",t[t.Move=6]="Move",t[t.OutputItems=7]="OutputItems",t[t.PartialMetadata=8]="PartialMetadata",t[t.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var E;(function(t){t.scheme=C.Schemas.vscodeNotebookCell;const s=["W","X","Y","Z","a","b","c","d","e","f"],l=new RegExp(`^[${s.join("")}]+`),h=7;function S(U,X){const z=X.toString(h),V=`${z.length<s.length?s[z.length-1]:"z"}${z}s${(0,u.encodeBase64)(u.VSBuffer.fromString(U.scheme),!0,!0)}`;return U.with({scheme:t.scheme,fragment:V})}t.generate=S;function L(U){if(U.scheme!==t.scheme)return;const X=U.fragment.indexOf("s");if(X<0)return;const z=parseInt(U.fragment.substring(0,X).replace(l,""),h),N=(0,u.decodeBase64)(U.fragment.substring(X+1)).toString();if(!isNaN(z))return{handle:z,notebook:U.with({scheme:N,fragment:null})}}t.parse=L;const F=/^(\d{8,})(\w[\w\d+.-]*)$/;function M(U,X){return U.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${X??""},${U.scheme!==C.Schemas.file?U.scheme:""}`})}t.generateCellOutputUri=M;function A(U){if(U.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const X=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(U.fragment);if(!X)return;const z=X[1]&&X[1]!==""?X[1]:void 0,N=X[2];return{outputId:z,notebook:U.with({scheme:N||C.Schemas.file,fragment:null})}}t.parseCellOutputUri=A;function B(U,X,z){return U.with({scheme:z,fragment:`ch${X.toString().padStart(7,"0")}${U.scheme!==C.Schemas.file?U.scheme:""}`})}t.generateCellUri=B;function $(U,X){if(U.scheme!==X)return;const z=F.exec(U.fragment);return z?{handle:Number(z[1]),notebook:U.with({scheme:U.fragment.substring(z[0].length)||C.Schemas.file,fragment:null})}:void 0}t.parseCellUri=$})(E=e.CellUri||(e.CellUri={}));const g=t=>b.isWindows?t.replace(/\//g,"\\"):t;class c{constructor(s=[],l=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=l,this.order=[...new Set(s)].map(h=>({pattern:h,matches:n.parse(g(h))}))}sort(s){const l=new Map(D.Iterable.map(s,S=>[S,g(S)]));let h=[];for(const{matches:S}of this.order)for(const[L,F]of l)if(S(F)){h.push(L),l.delete(L);break}return l.size&&(h=h.concat([...l.keys()].sort((S,L)=>this.defaultOrder.indexOf(S)-this.defaultOrder.indexOf(L)))),h}prioritize(s,l){const h=this.findIndex(s);if(h===-1){this.order.unshift({pattern:s,matches:n.parse(g(s))});return}const S=new Set(l.map(F=>this.findIndex(F,h)));S.delete(-1);const L=Array.from(S).sort();this.order.splice(h+1,0,...L.map(F=>this.order[F]));for(let F=L.length-1;F>=0;F--)this.order.splice(L[F],1)}toArray(){return this.order.map(s=>s.pattern)}findIndex(s,l=this.order.length){const h=g(s);for(let S=0;S<l;S++)if(this.order[S].matches(h))return S;return-1}}e.MimeTypeDisplayOrder=c;function m(t,s,l,h=(S,L)=>S===L){const S=[];function L(A,B,$){if(B===0&&$.length===0)return;const U=S[S.length-1];U&&U.start+U.deleteCount===A?(U.deleteCount+=B,U.toInsert.push(...$)):S.push({start:A,deleteCount:B,toInsert:$})}let F=0,M=0;for(;;){if(F===t.length){L(F,0,s.slice(M));break}if(M===s.length){L(F,t.length-F,[]);break}const A=t[F],B=s[M];if(h(A,B)){F+=1,M+=1;continue}l(B)?(L(F,1,[]),F+=1):(L(F,0,[B]),M+=1)}return S}e.diff=m,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var a;(function(t){t.default="default",t.option="option"})(a=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function d(t){const s=t;return!!((typeof s.include=="string"||n.isRelativePattern(s.include))&&(typeof s.exclude=="string"||n.isRelativePattern(s.exclude)))}e.isDocumentExcludePattern=d;function i(t,s,l){if(Array.isArray(t.viewType)&&t.viewType.indexOf(s)>=0||t.viewType===s)return!0;if(t.filenamePattern){const h=d(t.filenamePattern)?t.filenamePattern.include:t.filenamePattern,S=d(t.filenamePattern)?t.filenamePattern.exclude:void 0;if(n.match(h,(0,y.basename)(l.fsPath).toLowerCase()))return!(S&&n.match(S,(0,y.basename)(l.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=i,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var o;(function(t){t[t.Left=1]="Left",t[t.Right=2]="Right"})(o=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class r{static create(s){return`${r._prefix}${s}`}static parse(s){if(s.startsWith(r._prefix))return s.substring(r._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=r,r._prefix="notebook/"}),define(Ie[219],ke([0,1,4]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var n;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState"})(n=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,u.createDecorator)("INotebookExecutionService")}),define(Ie[220],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function u(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=u;function n(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=n;function D(C){return Array.from(C.entries()).map(y=>[y[0],u(y[1].map)])}e.serializeEnvironmentVariableCollections=D;function T(C){return new Map(C.map(y=>[y[0],{map:n(y[1])}]))}e.deserializeEnvironmentVariableCollections=T}),define(Ie[66],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var u;(function(T){T.Delimiter="\0"})(u=e.TestIdPathParts||(e.TestIdPathParts={}));var n;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(n=e.TestPosition||(e.TestPosition={}));class D{constructor(C,y=C.length){if(this.path=C,this.viewEnd=y,C.length===0||y<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(C,y,b=C.parent){if(C.id===y)return new D([y]);const I=[C.id];for(let R=b;R&&R.id!==y;R=R.parent)I.push(R.id);return I.push(y),new D(I.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const y=C.indexOf("\0");return y===-1?C:C.slice(0,y)}static fromString(C){return new D(C.split("\0"))}static join(C,y){return new D([...C.path,y])}static joinToString(C,y){return C.toString()+"\0"+y}static compare(C,y){return C===y?0:y.startsWith(C+"\0")?2:C.startsWith(y+"\0")?3:1}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let C=1;C<=this.viewEnd;C++)yield new D(this.path,C)}compare(C){if(typeof C=="string")return D.compare(this.toString(),C);for(let y=0;y<C.viewEnd&&y<this.viewEnd;y++)if(C.path[y]!==this.path[y])return 1;return C.viewEnd>this.viewEnd?2:C.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let C=1;C<this.viewEnd;C++)this.stringifed+="\0",this.stringifed+=this.path[C]}return this.stringifed}}e.TestId=D}),define(Ie[67],ke([0,1,2,35]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var D;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(D=e.TestResultState||(e.TestResultState={}));var T;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable"})(T=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var C;(function(r){r.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),r.deserialize=t=>({range:n.Range.lift(t.range),uri:u.URI.revive(t.uri)})})(C=e.IRichLocation||(e.IRichLocation={}));var y;(function(r){r[r.Error=0]="Error",r[r.Output=1]="Output"})(y=e.TestMessageType||(e.TestMessageType={}));var b;(function(r){r.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&C.serialize(t.location)}),r.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&C.deserialize(t.location)})})(b=e.ITestErrorMessage||(e.ITestErrorMessage={}));var I;(function(r){r.serialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&C.serialize(t.location)}),r.deserialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&C.deserialize(t.location)})})(I=e.ITestOutputMessage||(e.ITestOutputMessage={}));var R;(function(r){r.serialize=t=>t.type===0?b.serialize(t):I.serialize(t),r.deserialize=t=>t.type===0?b.deserialize(t):I.deserialize(t)})(R=e.ITestMessage||(e.ITestMessage={}));var k;(function(r){r.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(R.serialize)}),r.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(R.deserialize)})})(k=e.ITestTaskState||(e.ITestTaskState={}));const _="\0",P=(r,t)=>r+_+t;e.namespaceTestTag=P;const v=r=>{const t=r.indexOf(_);return{ctrlId:r.slice(0,t),tagId:r.slice(t+1)}};e.denamespaceTestTag=v;var w;(function(r){r.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),r.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?u.URI.revive(t.uri):void 0,range:t.range?n.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(w=e.ITestItem||(e.ITestItem={}));var p;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(p=e.TestItemExpandState||(e.TestItemExpandState={}));var f;(function(r){r.serialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:w.serialize(t.item)}),r.deserialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:w.deserialize(t.item)})})(f=e.InternalTestItem||(e.InternalTestItem={}));var E;(function(r){r.serialize=t=>{let s;return t.item&&(s={},t.item.label!==void 0&&(s.label=t.item.label),t.item.tags!==void 0&&(s.tags=t.item.tags),t.item.busy!==void 0&&(s.busy=t.item.busy),t.item.uri!==void 0&&(s.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(s.range=t.item.range?.toJSON()),t.item.description!==void 0&&(s.description=t.item.description),t.item.error!==void 0&&(s.error=t.item.error),t.item.sortText!==void 0&&(s.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:s}},r.deserialize=t=>{let s;return t.item&&(s={},t.item.label!==void 0&&(s.label=t.item.label),t.item.tags!==void 0&&(s.tags=t.item.tags),t.item.busy!==void 0&&(s.busy=t.item.busy),t.item.range!==void 0&&(s.range=t.item.range?n.Range.lift(t.item.range):null),t.item.description!==void 0&&(s.description=t.item.description),t.item.error!==void 0&&(s.error=t.item.error),t.item.sortText!==void 0&&(s.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:s}}})(E=e.ITestItemUpdate||(e.ITestItemUpdate={}));const g=(r,t)=>{t.expand!==void 0&&(r.expand=t.expand),t.item!==void 0&&(r.item=r.item?Object.assign(r.item,t.item):t.item)};e.applyTestItemUpdate=g;var c;(function(r){r.serialize=(t,s)=>({...f.serialize(t),children:s,ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(k.serialize)})})(c=e.TestResultItem||(e.TestResultItem={}));var m;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(m=e.DetailType||(e.DetailType={}));var a;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.Remove=2]="Remove",r[r.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",r[r.Retire=4]="Retire",r[r.AddTag=5]="AddTag",r[r.RemoveTag=6]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var d;(function(r){r.deserialize=t=>t.op===0?{op:t.op,item:f.deserialize(t.item)}:t.op===1?{op:t.op,item:E.deserialize(t.item)}:t,r.serialize=t=>t.op===0?{op:t.op,item:f.serialize(t.item)}:t.op===1?{op:t.op,item:E.serialize(t.item)}:t})(d=e.TestsDiffOp||(e.TestsDiffOp={}));class i{add(t){}update(t){}remove(t,s){}complete(){}}e.IncrementalChangeCollector=i;class o{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const s=this.createChangeCollector();for(const l of t)switch(l.op){case 0:{const h=f.deserialize(l.item);if(h.parent){if(this.items.has(h.parent)){const S=this.items.get(h.parent);S.children.add(h.item.extId);const L=this.createItem(h,S);this.items.set(h.item.extId,L),s.add(L)}}else{const S=this.createItem(h);this.roots.add(S),this.items.set(h.item.extId,S),s.add(S)}h.expand===2&&this.busyControllerCount++;break}case 1:{const h=E.deserialize(l.item),S=this.items.get(h.extId);if(!S)break;h.expand!==void 0&&(S.expand===2&&this.busyControllerCount--,h.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(S,h),s.update(S);break}case 2:{const h=this.items.get(l.itemId);if(!h)break;h.parent?this.items.get(h.parent).children.delete(h.item.extId):this.roots.delete(h);const S=[[l.itemId]];for(;S.length;)for(const L of S.pop()){const F=this.items.get(L);F&&(S.push(F.children),this.items.delete(L),s.remove(F,F!==h),F.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(l.itemId);break;case 3:this.updatePendingRoots(l.amount);break;case 5:this._tags.set(l.tag.id,l.tag);break;case 6:this._tags.delete(l.id);break}s.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new i}}e.AbstractIncrementalTestCollection=o}),define(Ie[89],ke([0,1,18,3,6,11,67,66]),function(J,e,u,n,D,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var b;(function(f){f[f.Upsert=0]="Upsert",f[f.SetTags=1]="SetTags",f[f.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",f[f.RemoveChild=3]="RemoveChild",f[f.SetProp=4]="SetProp",f[f.Bulk=5]="Bulk"})(b=e.TestItemEventOp||(e.TestItemEventOp={}));const I=(f,E)=>f===E,R={range:(f,E)=>f===E?!0:!f||!E?!1:f.equalsRange(E),busy:I,label:I,description:I,error:I,tags:(f,E)=>!(f.length!==E.length||f.some(g=>!E.includes(g)))},k=(f,E)=>{let g;for(const[c,m]of Object.entries(R))m(f[c],E[c])||(g?g[c]=E[c]:g={[c]:E[c]});return g};class _ extends D.Disposable{constructor(E){super();this.options=E,this.debounceSendDiff=this._register(new u.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new n.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(E){this._resolveHandler=E;for(const g of this.tree.values())this.updateExpandability(g)}collectDiff(){const E=this.diff;return this.diff=[],E}pushDiff(E){const g=this.diff[this.diff.length-1];if(g&&E.op===1){if(g.op===1&&g.item.extId===E.item.extId){(0,C.applyTestItemUpdate)(g.item,E.item);return}if(g.op===0&&g.item.item.extId===E.item.extId){(0,C.applyTestItemUpdate)(g.item,E.item);return}}this.diff.push(E),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(E,g){const c=this.tree.get(E);if(!!c){if((c.expandLevels===void 0||g>c.expandLevels)&&(c.expandLevels=g),c.expand===1){const m=this.resolveChildren(c);return m.isOpen()?this.expandChildren(c,g-1):m.wait().then(()=>this.expandChildren(c,g-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.expandChildren(c,g-1)):this.expandChildren(c,g-1)}}dispose(){for(const E of this.tree.values())this.options.getApiFor(E.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(E,g){switch(g.op){case 3:this.removeItem(y.TestId.joinToString(E.fullId,g.id));break;case 0:this.upsertItem(g.item,E);break;case 5:for(const c of g.ops)this.onTestItemEvent(E,c);break;case 1:this.diffTagRefs(g.new,g.old,E.fullId.toString());break;case 2:this.updateExpandability(E);break;case 4:this.pushDiff({op:1,item:{extId:E.fullId.toString(),item:g.update}});break;default:(0,T.assertNever)(g)}}upsertItem(E,g){const c=y.TestId.fromExtHostTestItem(E,this.root.id,g?.actual),m=this.options.getApiFor(E);m.parent&&m.parent!==g?.actual&&this.options.getChildren(m.parent).delete(E.id);let a=this.tree.get(c.toString());if(!a){a={fullId:c,actual:E,parent:g?c.parentId:null,expandLevels:g?.expandLevels?g.expandLevels-1:void 0,expand:0},E.tags.forEach(this.incrementTagRefs,this),this.tree.set(a.fullId.toString(),a),this.setItemParent(E,g),this.pushDiff({op:0,item:{parent:a.parent&&a.parent.toString(),controllerId:this.options.controllerId,expand:a.expand,item:this.options.toITestItem(E)}}),this.connectItemAndChildren(E,a,g);return}if(a.actual===E){this.connectItem(E,a,g);return}const d=this.options.getChildren(a.actual),i=a.actual,o=k(this.options.toITestItem(i),this.options.toITestItem(E));this.options.getApiFor(i).listener=void 0,a.actual=E,a.expand=0,o&&(o.hasOwnProperty("tags")&&(this.diffTagRefs(E.tags,i.tags,c.toString()),delete o.tags),this.onTestItemEvent(a,{op:4,update:o})),this.connectItemAndChildren(E,a,g);for(const[r,t]of d)this.options.getChildren(E).get(t.id)||this.removeItem(y.TestId.joinToString(c,t.id))}diffTagRefs(E,g,c){const m=new Set(g.map(a=>a.id));for(const a of E)m.delete(a.id)||this.incrementTagRefs(a);this.pushDiff({op:1,item:{extId:c,item:{tags:E.map(a=>(0,C.namespaceTestTag)(this.options.controllerId,a.id))}}}),m.forEach(this.decrementTagRefs,this)}incrementTagRefs(E){const g=this.tags.get(E.id);g?g.refCount++:(this.tags.set(E.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,C.namespaceTestTag)(this.options.controllerId,E.id)}}))}decrementTagRefs(E){const g=this.tags.get(E);g&&!--g.refCount&&(this.tags.delete(E),this.pushDiff({op:6,id:(0,C.namespaceTestTag)(this.options.controllerId,E)}))}setItemParent(E,g){this.options.getApiFor(E).parent=g&&g.actual!==this.root?g.actual:void 0}connectItem(E,g,c){this.setItemParent(E,c);const m=this.options.getApiFor(E);m.parent=c?.actual,m.listener=a=>this.onTestItemEvent(g,a),this.updateExpandability(g)}connectItemAndChildren(E,g,c){this.connectItem(E,g,c);for(const[m,a]of this.options.getChildren(E))this.upsertItem(a,g)}updateExpandability(E){let g;this._resolveHandler?E.resolveBarrier?g=E.resolveBarrier.isOpen()?3:2:g=E.actual.canResolveChildren?1:0:g=0,g!==E.expand&&(E.expand=g,this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:g}}),g===1&&E.expandLevels!==void 0&&this.resolveChildren(E))}expandChildren(E,g){if(g<0)return;const c=[];for(const[m,a]of this.options.getChildren(E.actual)){const d=this.expand(y.TestId.joinToString(E.fullId,a.id),g);(0,u.isThenable)(d)&&c.push(d)}if(c.length)return Promise.all(c).then(()=>{})}resolveChildren(E){if(E.resolveBarrier)return E.resolveBarrier;if(!this._resolveHandler){const a=new u.Barrier;return a.open(),a}E.expand=2,this.pushExpandStateUpdate(E);const g=E.resolveBarrier=new u.Barrier,c=a=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,a)};let m;try{m=this._resolveHandler(E.actual===this.root?void 0:E.actual)}catch(a){c(a)}return(0,u.isThenable)(m)?m.catch(c).then(()=>{g.open(),this.updateExpandability(E)}):(g.open(),this.updateExpandability(E)),E.resolveBarrier}pushExpandStateUpdate(E){this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:E.expand}})}removeItem(E){const g=this.tree.get(E);if(!g)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:E});const c=[g];for(;c.length;){const m=c.pop();if(!!m){this.options.getApiFor(m.actual).listener=void 0;for(const a of m.actual.tags)this.decrementTagRefs(a.id);this.tree.delete(m.fullId.toString());for(const[a,d]of this.options.getChildren(m.actual))c.push(this.tree.get(y.TestId.joinToString(m.fullId,d.id)))}}}flushDiff(){const E=this.collectDiff();E.length&&this.diffOpEmitter.fire(E)}}e.TestItemCollection=_;class P extends Error{constructor(E){super(`Attempted to insert a duplicate test item ID ${E}`)}}e.DuplicateTestItemError=P;class v extends Error{constructor(E){super(`TestItem with ID "${E}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=v;class w extends Error{constructor(E,g,c){super(`TestItem with ID "${E}" is from controller "${g}" and cannot be added as a child of an item from controller "${c}".`)}}e.MixedTestItemController=w;const p=(f,E,g)=>{let c=new Map;return{get size(){return c.size},forEach(m,a){for(const d of c.values())m.call(a,d,this)},[Symbol.iterator](){return c.entries()},replace(m){const a=new Map,d=new Set(c.keys()),i={op:5,ops:[]};for(const o of m){if(!(o instanceof g))throw new v(o.id);const r=E(o).controllerId;if(r!==f.controllerId)throw new w(o.id,r,f.controllerId);if(a.has(o.id))throw new P(o.id);a.set(o.id,o),d.delete(o.id),i.ops.push({op:0,item:o})}for(const o of d.keys())i.ops.push({op:3,id:o});f.listener?.(i),c=a},add(m){if(!(m instanceof g))throw new v(m.id);c.set(m.id,m),f.listener?.({op:0,item:m})},delete(m){c.delete(m)&&f.listener?.({op:3,id:m})},get(m){return c.get(m)},toJSON(){return Array.from(c.values())}}};e.createTestItemChildren=p}),define(Ie[129],ke([0,1,89]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const n=new WeakMap,D=(C,y)=>{const b={controllerId:y};return n.set(C,b),b};e.createPrivateApiFor=D;const T=C=>{const y=n.get(C);if(!y)throw new u.InvalidTestItemError(C?.id||"<unknown>");return y};e.getPrivateApiFor=T}),define(Ie[221],ke([0,1,9,36,11,24,13,107,185,8]),function(J,e,u,n,D,T,C,y,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class R{constructor(_,P,v,w){this._contributedVariables=new Map,this._context=_,this._labelService=P,this._userHomePromise=v,w&&(this._envVariablesPromise=w.then(p=>this.prepareEnv(p)))}prepareEnv(_){if(C.isWindows){const P=Object.create(null);return Object.keys(_).forEach(v=>{P[v.toLowerCase()]=_[v]}),P}return _}resolveWithEnvironment(_,P,v){return this.recursiveResolve({env:this.prepareEnv(_),userHome:void 0},P?P.uri:void 0,v)}async resolveAsync(_,P){const v={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(v,_?_.uri:void 0,P)}async resolveAnyBase(_,P,v,w){const p=T.deepClone(P);C.isWindows&&p.windows?Object.keys(p.windows).forEach(E=>p[E]=p.windows[E]):C.isMacintosh&&p.osx?Object.keys(p.osx).forEach(E=>p[E]=p.osx[E]):C.isLinux&&p.linux&&Object.keys(p.linux).forEach(E=>p[E]=p.linux[E]),delete p.windows,delete p.osx,delete p.linux;const f={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(f,_?_.uri:void 0,p,v,w)}async resolveAnyAsync(_,P,v){return this.resolveAnyBase(_,P,v)}async resolveAnyMap(_,P,v){const w=new Map;return{newConfig:await this.resolveAnyBase(_,P,v,w),resolvedVariables:w}}resolveWithInteractionReplace(_,P,v,w){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,P,v,w){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,P){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,P)}async recursiveResolve(_,P,v,w,p){if(D.isString(v))return this.resolveString(_,P,v,w,p);if(D.isArray(v))return Promise.all(v.map(f=>this.recursiveResolve(_,P,f,w,p)));if(D.isObject(v)){const f=Object.create(null),E=await Promise.all(Object.keys(v).map(async g=>[await this.resolveString(_,P,g,w,p),await this.recursiveResolve(_,P,v[g],w,p)]));for(const[g,c]of E)f[g]=c;return f}return v}resolveString(_,P,v,w,p){return(0,I.replaceAsync)(v,R.VARIABLE_REGEXP,async(f,E)=>{if(E.includes(R.VARIABLE_LHS))return f;let g=await this.evaluateSingleVariable(_,f,E,P,w);return p?.set(E,g),g!==f&&D.isString(g)&&g.match(R.VARIABLE_REGEXP)&&(g=await this.resolveString(_,P,g,w,p)),g})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}async evaluateSingleVariable(_,P,v,w,p){let f;const E=v.split(":");E.length>1&&(v=E[0],f=E[1]);const g=()=>{const a=this._context.getFilePath();if(a)return a;throw new Error((0,b.localize)(0,null,P))},c=()=>{const a=g();if(this._context.getWorkspaceFolderPathForFile){const d=this._context.getWorkspaceFolderPathForFile();if(d)return d}throw new Error((0,b.localize)(1,null,P,u.basename(a)))},m=()=>{if(f){const a=this._context.getFolderUri(f);if(a)return a;throw new Error((0,b.localize)(2,null,P,f))}if(w)return w;throw this._context.getWorkspaceFolderCount()>1?new Error((0,b.localize)(3,null,P)):new Error((0,b.localize)(4,null,P))};switch(v){case"env":if(f){if(_.env){const a=_.env[C.isWindows?f.toLowerCase():f];if(D.isString(a))return a}return""}throw new Error((0,b.localize)(5,null,P));case"config":if(f){const a=this._context.getConfigurationValue(w,f);if(D.isUndefinedOrNull(a))throw new Error((0,b.localize)(6,null,P,f));if(D.isObject(a))throw new Error((0,b.localize)(7,null,P,f));return a}throw new Error((0,b.localize)(8,null,P));case"command":return this.resolveFromMap(P,f,p,"command");case"input":return this.resolveFromMap(P,f,p,"input");case"extensionInstallFolder":if(f){const a=await this._context.getExtension(f);if(!a)throw new Error((0,b.localize)(9,null,P,f));return this.fsPath(a.extensionLocation)}throw new Error((0,b.localize)(10,null,P));default:switch(v){case"workspaceRoot":case"workspaceFolder":return(0,y.normalizeDriveLetter)(this.fsPath(m()));case"cwd":return w||f?(0,y.normalizeDriveLetter)(this.fsPath(m())):n.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return u.basename(this.fsPath(m()));case"userHome":{if(_.userHome)return _.userHome;throw new Error((0,b.localize)(11,null,P))}case"lineNumber":{const a=this._context.getLineNumber();if(a)return a;throw new Error((0,b.localize)(12,null,P))}case"selectedText":{const a=this._context.getSelectedText();if(a)return a;throw new Error((0,b.localize)(13,null,P))}case"file":return g();case"fileWorkspaceFolder":return c();case"relativeFile":return w||f?u.relative(this.fsPath(m()),g()):g();case"relativeFileDirname":{const a=u.dirname(g());if(w||f){const d=u.relative(this.fsPath(m()),a);return d.length===0?".":d}return a}case"fileDirname":return u.dirname(g());case"fileExtname":return u.extname(g());case"fileBasename":return u.basename(g());case"fileBasenameNoExtension":{const a=u.basename(g());return a.slice(0,a.length-u.extname(a).length)}case"fileDirnameBasename":return u.basename(u.dirname(g()));case"execPath":{const a=this._context.getExecPath();return a||P}case"execInstallFolder":{const a=this._context.getAppRoot();return a||P}case"pathSeparator":return u.sep;default:try{const a=f?`${v}:${f}`:v;return this.resolveFromMap(P,a,p,void 0)}catch{return P}}}}resolveFromMap(_,P,v,w){if(P&&v){const p=w===void 0?v[P]:v[w+":"+P];if(typeof p=="string")return p;throw new Error((0,b.localize)(14,null,_))}return _}}e.AbstractVariableResolverService=R,R.VARIABLE_LHS="${",R.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ie[130],ke([0,1,4,212]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,u.createDecorator)("editorGroupsService");var D;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var T;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var y;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var b;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(b=e.MergeGroupMode||(e.MergeGroupMode={}));function I(v){const w=v;return(0,n.isEditorInput)(w?.editor)&&(0,n.isEditorInput)(w?.replacement)}e.isEditorReplacement=I;var R;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(k=e.OpenEditorContext||(e.OpenEditorContext={}));function _(v){const w=v;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.isEditorGroup=_;function P(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=P}),define(Ie[222],ke([0,1,4,130]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,u.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(T){const C=T;return typeof T=="number"||(0,n.isEditorGroup)(C)}e.isPreferredGroup=D}),define(Ie[15],ke([0,1,16,23,106,25,143,61,24,11,2,35,64,188,117,129,128,66,67,222,7,58]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v,w,p,f,E,g,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(Te){function Le(ne){const{selectionStartLineNumber:Fe,selectionStartColumn:xe,positionLineNumber:Ye,positionColumn:Je}=ne,Qe=new c.Position(Fe-1,xe-1),vt=new c.Position(Ye-1,Je-1);return new c.Selection(Qe,vt)}Te.to=Le;function Se(ne){const{anchor:Fe,active:xe}=ne;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:xe.line+1,positionColumn:xe.character+1}}Te.from=Se})(a=e.Selection||(e.Selection={}));var d;(function(Te){function Le(ne){if(!ne)return;const{start:Fe,end:xe}=ne;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:xe.line+1,endColumn:xe.character+1}}Te.from=Le;function Se(ne){if(!ne)return;const{startLineNumber:Fe,startColumn:xe,endLineNumber:Ye,endColumn:Je}=ne;return new c.Range(Fe-1,xe-1,Ye-1,Je-1)}Te.to=Se})(d=e.Range||(e.Range={}));var i;(function(Te){function Le(Se){switch(Se){case 1:return c.StandardTokenType.Comment;case 0:return c.StandardTokenType.Other;case 3:return c.StandardTokenType.RegEx;case 2:return c.StandardTokenType.String}}Te.to=Le})(i=e.TokenType||(e.TokenType={}));var o;(function(Te){function Le(ne){return new c.Position(ne.lineNumber-1,ne.column-1)}Te.to=Le;function Se(ne){return{lineNumber:ne.line+1,column:ne.character+1}}Te.from=Se})(o=e.Position||(e.Position={}));var r;(function(Te){function Le(Fe,xe){return(0,u.coalesce)((0,u.asArray)(Fe).map(Ye=>Se(Ye,xe)))}Te.from=Le;function Se(Fe,xe){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:ne(Fe.scheme,xe),pattern:G.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function ne(Fe,xe){return xe&&typeof Fe=="string"?xe.transformOutgoingScheme(Fe):Fe}})(r=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(Te){function Le(ne){switch(ne){case c.DiagnosticTag.Unnecessary:return 1;case c.DiagnosticTag.Deprecated:return 2}}Te.from=Le;function Se(ne){switch(ne){case 1:return c.DiagnosticTag.Unnecessary;case 2:return c.DiagnosticTag.Deprecated;default:return}}Te.to=Se})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var s;(function(Te){function Le(ne){let Fe;return ne.code&&((0,I.isString)(ne.code)||(0,I.isNumber)(ne.code)?Fe=String(ne.code):Fe={value:String(ne.code.value),target:ne.code.target}),{...d.from(ne.range),message:ne.message,source:ne.source,code:Fe,severity:h.from(ne.severity),relatedInformation:ne.relatedInformation&&ne.relatedInformation.map(l.from),tags:Array.isArray(ne.tags)?(0,u.coalesce)(ne.tags.map(t.from)):void 0}}Te.from=Le;function Se(ne){const Fe=new c.Diagnostic(d.to(ne),ne.message,h.to(ne.severity));return Fe.source=ne.source,Fe.code=(0,I.isString)(ne.code)?ne.code:ne.code?.value,Fe.relatedInformation=ne.relatedInformation&&ne.relatedInformation.map(l.to),Fe.tags=ne.tags&&(0,u.coalesce)(ne.tags.map(t.to)),Fe}Te.to=Se})(s=e.Diagnostic||(e.Diagnostic={}));var l;(function(Te){function Le(ne){return{...d.from(ne.location.range),message:ne.message,resource:ne.location.uri}}Te.from=Le;function Se(ne){return new c.DiagnosticRelatedInformation(new c.Location(ne.resource,d.to(ne)),ne.message)}Te.to=Se})(l=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var h;(function(Te){function Le(ne){switch(ne){case c.DiagnosticSeverity.Error:return v.MarkerSeverity.Error;case c.DiagnosticSeverity.Warning:return v.MarkerSeverity.Warning;case c.DiagnosticSeverity.Information:return v.MarkerSeverity.Info;case c.DiagnosticSeverity.Hint:return v.MarkerSeverity.Hint}return v.MarkerSeverity.Error}Te.from=Le;function Se(ne){switch(ne){case v.MarkerSeverity.Info:return c.DiagnosticSeverity.Information;case v.MarkerSeverity.Warning:return c.DiagnosticSeverity.Warning;case v.MarkerSeverity.Error:return c.DiagnosticSeverity.Error;case v.MarkerSeverity.Hint:return c.DiagnosticSeverity.Hint;default:return c.DiagnosticSeverity.Error}}Te.to=Se})(h=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var S;(function(Te){function Le(ne){return typeof ne=="number"&&ne>=c.ViewColumn.One?ne-1:ne===c.ViewColumn.Beside?g.SIDE_GROUP:g.ACTIVE_GROUP}Te.from=Le;function Se(ne){if(typeof ne=="number"&&ne>=0)return ne+1;throw new Error("invalid 'EditorGroupColumn'")}Te.to=Se})(S=e.ViewColumn||(e.ViewColumn={}));function L(Te){return typeof Te.range!="undefined"}function F(Te){return Te.length===0?!0:!!L(Te[0])}e.isDecorationOptionsArr=F;var M;(function(Te){function Le(Je){return Je.map(Te.from)}Te.fromMany=Le;function Se(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function ne(Je){let Qe;if(Se(Je)){const{language:bt,value:ht}=Je;Qe={value:"```"+bt+`
`+ht+"\n```\n"}}else c.MarkdownString.isMarkdownString(Je)?Qe={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?Qe={value:Je}:Qe={value:""};const vt=Object.create(null);Qe.uris=vt;const Et=bt=>{try{let ht=R.URI.parse(bt,!0);ht=ht.with({query:Fe(ht.query,vt)}),vt[bt]=ht}catch{}return""},Tt=new C.marked.Renderer;return Tt.link=Et,Tt.image=bt=>typeof bt=="string"?Et(D.parseHrefAndDimensions(bt).href):"",(0,C.marked)(Qe.value,{renderer:Tt}),Qe}Te.from=ne;function Fe(Je,Qe){if(!Je)return Je;let vt;try{vt=(0,y.parse)(Je)}catch{}if(!vt)return Je;let Et=!1;return vt=(0,b.cloneAndChange)(vt,Tt=>{if(R.URI.isUri(Tt)){const bt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Qe[bt]=Tt,Et=!0,bt}else return}),Et?JSON.stringify(vt):Je}function xe(Je){const Qe=new c.MarkdownString(Je.value,Je.supportThemeIcons);return Qe.isTrusted=Je.isTrusted,Qe.supportHtml=Je.supportHtml,Qe.baseUri=Je.baseUri?R.URI.from(Je.baseUri):void 0,Qe}Te.to=xe;function Ye(Je){if(!!Je)return typeof Je=="string"?Je:Te.from(Je)}Te.fromStrict=Ye})(M=e.MarkdownString||(e.MarkdownString={}));function A(Te){return F(Te)?Te.map(Le=>({range:d.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?M.fromMany(Le.hoverMessage):Le.hoverMessage?M.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):Te.map(Le=>({range:d.from(Le)}))}e.fromRangeOrRangeWithMessage=A;function B(Te){return typeof Te=="undefined"?Te:typeof Te=="string"?R.URI.file(Te):Te}e.pathOrURIToURI=B;var $;(function(Te){function Le(Se){return typeof Se=="undefined"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?B(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Te.from=Le})($=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var U;(function(Te){function Le(Se){return typeof Se=="undefined"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?B(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?$.from(Se.before):void 0,after:Se.after?$.from(Se.after):void 0}}Te.from=Le})(U=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var X;(function(Te){function Le(Se){if(typeof Se=="undefined")return Se;switch(Se){case c.DecorationRangeBehavior.OpenOpen:return 0;case c.DecorationRangeBehavior.ClosedClosed:return 1;case c.DecorationRangeBehavior.OpenClosed:return 2;case c.DecorationRangeBehavior.ClosedOpen:return 3}}Te.from=Le})(X=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var z;(function(Te){function Le(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?X.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?U.from(Se.light):void 0,dark:Se.dark?U.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?B(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?$.from(Se.before):void 0,after:Se.after?$.from(Se.after):void 0}}Te.from=Le})(z=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var N;(function(Te){function Le(ne){return{text:ne.newText,eol:ne.newEol&&Xe.from(ne.newEol),range:d.from(ne.range)}}Te.from=Le;function Se(ne){const Fe=new c.TextEdit(d.to(ne.range),ne.text);return Fe.newEol=typeof ne.eol=="undefined"?void 0:Xe.to(ne.eol),Fe}Te.to=Se})(N=e.TextEdit||(e.TextEdit={}));var V;(function(Te){function Le(ne,Fe,xe){const Ye={edits:[]};if(ne instanceof c.WorkspaceEdit){const Je=new T.ResourceSet;for(const Qe of ne._allEntries())Qe._type===1&&R.URI.isUri(Qe.to)&&Qe.from===void 0&&Je.add(Qe.to);for(const Qe of ne._allEntries())if(Qe._type===1)Ye.edits.push({oldResource:Qe.from,newResource:Qe.to,options:Qe.options,metadata:Qe.metadata});else if(Qe._type===2)Ye.edits.push({resource:Qe.uri,textEdit:N.from(Qe.edit),versionId:Je.has(Qe.uri)?void 0:Fe?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata});else if(Qe._type===6){if(!xe){console.warn("DROPPING snippet text edit because proposal IS NOT ENABLED",Qe);continue}Ye.edits.push({resource:Qe.uri,textEdit:{range:d.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:Je.has(Qe.uri)?void 0:Fe?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata})}else Qe._type===3?Ye.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===5&&Ye.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(st.from)}})}return Ye}Te.from=Le;function Se(ne){const Fe=new c.WorkspaceEdit;for(const xe of ne.edits)xe.textEdit?Fe.replace(R.URI.revive(xe.resource),d.to(xe.textEdit.range),xe.textEdit.text):Fe.renameFile(R.URI.revive(xe.oldResource),R.URI.revive(xe.newResource),xe.options);return Fe}Te.to=Se})(V=e.WorkspaceEdit||(e.WorkspaceEdit={}));var x;(function(Te){const Le=Object.create(null);Le[c.SymbolKind.File]=0,Le[c.SymbolKind.Module]=1,Le[c.SymbolKind.Namespace]=2,Le[c.SymbolKind.Package]=3,Le[c.SymbolKind.Class]=4,Le[c.SymbolKind.Method]=5,Le[c.SymbolKind.Property]=6,Le[c.SymbolKind.Field]=7,Le[c.SymbolKind.Constructor]=8,Le[c.SymbolKind.Enum]=9,Le[c.SymbolKind.Interface]=10,Le[c.SymbolKind.Function]=11,Le[c.SymbolKind.Variable]=12,Le[c.SymbolKind.Constant]=13,Le[c.SymbolKind.String]=14,Le[c.SymbolKind.Number]=15,Le[c.SymbolKind.Boolean]=16,Le[c.SymbolKind.Array]=17,Le[c.SymbolKind.Object]=18,Le[c.SymbolKind.Key]=19,Le[c.SymbolKind.Null]=20,Le[c.SymbolKind.EnumMember]=21,Le[c.SymbolKind.Struct]=22,Le[c.SymbolKind.Event]=23,Le[c.SymbolKind.Operator]=24,Le[c.SymbolKind.TypeParameter]=25;function Se(Fe){return typeof Le[Fe]=="number"?Le[Fe]:6}Te.from=Se;function ne(Fe){for(const xe in Le)if(Le[xe]===Fe)return Number(xe);return c.SymbolKind.Property}Te.to=ne})(x=e.SymbolKind||(e.SymbolKind={}));var q;(function(Te){function Le(ne){switch(ne){case c.SymbolTag.Deprecated:return 1}}Te.from=Le;function Se(ne){switch(ne){case 1:return c.SymbolTag.Deprecated}}Te.to=Se})(q=e.SymbolTag||(e.SymbolTag={}));var te;(function(Te){function Le(ne){return{name:ne.name,kind:x.from(ne.kind),tags:ne.tags&&ne.tags.map(q.from),containerName:ne.containerName,location:ge.from(ne.location)}}Te.from=Le;function Se(ne){const Fe=new c.SymbolInformation(ne.name,x.to(ne.kind),ne.containerName,ge.to(ne.location));return Fe.tags=ne.tags&&ne.tags.map(q.to),Fe}Te.to=Se})(te=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Y;(function(Te){function Le(ne){const Fe={name:ne.name||"!!MISSING: name!!",detail:ne.detail,range:d.from(ne.range),selectionRange:d.from(ne.selectionRange),kind:x.from(ne.kind),tags:ne.tags?.map(q.from)??[]};return ne.children&&(Fe.children=ne.children.map(Le)),Fe}Te.from=Le;function Se(ne){const Fe=new c.DocumentSymbol(ne.name,ne.detail,x.to(ne.kind),d.to(ne.range),d.to(ne.selectionRange));return(0,u.isNonEmptyArray)(ne.tags)&&(Fe.tags=ne.tags.map(q.to)),ne.children&&(Fe.children=ne.children.map(Se)),Fe}Te.to=Se})(Y=e.DocumentSymbol||(e.DocumentSymbol={}));var le;(function(Te){function Le(ne){const Fe=new c.CallHierarchyItem(x.to(ne.kind),ne.name,ne.detail||"",R.URI.revive(ne.uri),d.to(ne.range),d.to(ne.selectionRange));return Fe._sessionId=ne._sessionId,Fe._itemId=ne._itemId,Fe}Te.to=Le;function Se(ne,Fe,xe){if(Fe=Fe??ne._sessionId,xe=xe??ne._itemId,Fe===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:xe,name:ne.name,detail:ne.detail,kind:x.from(ne.kind),uri:ne.uri,range:d.from(ne.range),selectionRange:d.from(ne.selectionRange),tags:ne.tags?.map(q.from)}}Te.from=Se})(le=e.CallHierarchyItem||(e.CallHierarchyItem={}));var pe;(function(Te){function Le(Se){return new c.CallHierarchyIncomingCall(le.to(Se.from),Se.fromRanges.map(ne=>d.to(ne)))}Te.to=Le})(pe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ee;(function(Te){function Le(Se){return new c.CallHierarchyOutgoingCall(le.to(Se.to),Se.fromRanges.map(ne=>d.to(ne)))}Te.to=Le})(ee=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ge;(function(Te){function Le(ne){return{range:ne.range&&d.from(ne.range),uri:ne.uri}}Te.from=Le;function Se(ne){return new c.Location(R.URI.revive(ne.uri),d.to(ne.range))}Te.to=Se})(ge=e.location||(e.location={}));var Ee;(function(Te){function Le(ne){const Fe=ne,xe=ne;return{originSelectionRange:Fe.originSelectionRange?d.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:xe.uri,range:d.from(Fe.targetRange?Fe.targetRange:xe.range),targetSelectionRange:Fe.targetSelectionRange?d.from(Fe.targetSelectionRange):void 0}}Te.from=Le;function Se(ne){return{targetUri:R.URI.revive(ne.uri),targetRange:d.to(ne.range),targetSelectionRange:ne.targetSelectionRange?d.to(ne.targetSelectionRange):void 0,originSelectionRange:ne.originSelectionRange?d.to(ne.originSelectionRange):void 0}}Te.to=Se})(Ee=e.DefinitionLink||(e.DefinitionLink={}));var Pe;(function(Te){function Le(ne){return{range:d.from(ne.range),contents:M.fromMany(ne.contents)}}Te.from=Le;function Se(ne){return new c.Hover(ne.contents.map(M.to),d.to(ne.range))}Te.to=Se})(Pe=e.Hover||(e.Hover={}));var Ne;(function(Te){function Le(ne){return{range:d.from(ne.range),expression:ne.expression}}Te.from=Le;function Se(ne){return new c.EvaluatableExpression(d.to(ne.range),ne.expression)}Te.to=Se})(Ne=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ve;(function(Te){function Le(ne){if(ne instanceof c.InlineValueText)return{type:"text",range:d.from(ne.range),text:ne.text};if(ne instanceof c.InlineValueVariableLookup)return{type:"variable",range:d.from(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};if(ne instanceof c.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(ne.range),expression:ne.expression};throw new Error("Unknown 'InlineValue' type")}Te.from=Le;function Se(ne){switch(ne.type){case"text":return{range:d.to(ne.range),text:ne.text};case"variable":return{range:d.to(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};case"expression":return{range:d.to(ne.range),expression:ne.expression}}}Te.to=Se})(ve=e.InlineValue||(e.InlineValue={}));var ue;(function(Te){function Le(ne){return{frameId:ne.frameId,stoppedLocation:d.from(ne.stoppedLocation)}}Te.from=Le;function Se(ne){return new c.InlineValueContext(ne.frameId,d.to(ne.stoppedLocation))}Te.to=Se})(ue=e.InlineValueContext||(e.InlineValueContext={}));var de;(function(Te){function Le(ne){return{range:d.from(ne.range),kind:ne.kind}}Te.from=Le;function Se(ne){return new c.DocumentHighlight(d.to(ne.range),ne.kind)}Te.to=Se})(de=e.DocumentHighlight||(e.DocumentHighlight={}));var we;(function(Te){function Le(Se){switch(Se){case 1:return c.CompletionTriggerKind.TriggerCharacter;case 2:return c.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return c.CompletionTriggerKind.Invoke}}Te.to=Le})(we=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var re;(function(Te){function Le(Se){return{triggerKind:we.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Te.to=Le})(re=e.CompletionContext||(e.CompletionContext={}));var me;(function(Te){function Le(ne){switch(ne){case c.CompletionItemTag.Deprecated:return 1}}Te.from=Le;function Se(ne){switch(ne){case 1:return c.CompletionItemTag.Deprecated}}Te.to=Se})(me=e.CompletionItemTag||(e.CompletionItemTag={}));var Z;(function(Te){const Le=new Map([[c.CompletionItemKind.Method,0],[c.CompletionItemKind.Function,1],[c.CompletionItemKind.Constructor,2],[c.CompletionItemKind.Field,3],[c.CompletionItemKind.Variable,4],[c.CompletionItemKind.Class,5],[c.CompletionItemKind.Interface,7],[c.CompletionItemKind.Struct,6],[c.CompletionItemKind.Module,8],[c.CompletionItemKind.Property,9],[c.CompletionItemKind.Unit,12],[c.CompletionItemKind.Value,13],[c.CompletionItemKind.Constant,14],[c.CompletionItemKind.Enum,15],[c.CompletionItemKind.EnumMember,16],[c.CompletionItemKind.Keyword,17],[c.CompletionItemKind.Snippet,27],[c.CompletionItemKind.Text,18],[c.CompletionItemKind.Color,19],[c.CompletionItemKind.File,20],[c.CompletionItemKind.Reference,21],[c.CompletionItemKind.Folder,23],[c.CompletionItemKind.Event,10],[c.CompletionItemKind.Operator,11],[c.CompletionItemKind.TypeParameter,24],[c.CompletionItemKind.Issue,26],[c.CompletionItemKind.User,25]]);function Se(xe){return Le.get(xe)??9}Te.from=Se;const ne=new Map([[0,c.CompletionItemKind.Method],[1,c.CompletionItemKind.Function],[2,c.CompletionItemKind.Constructor],[3,c.CompletionItemKind.Field],[4,c.CompletionItemKind.Variable],[5,c.CompletionItemKind.Class],[7,c.CompletionItemKind.Interface],[6,c.CompletionItemKind.Struct],[8,c.CompletionItemKind.Module],[9,c.CompletionItemKind.Property],[12,c.CompletionItemKind.Unit],[13,c.CompletionItemKind.Value],[14,c.CompletionItemKind.Constant],[15,c.CompletionItemKind.Enum],[16,c.CompletionItemKind.EnumMember],[17,c.CompletionItemKind.Keyword],[27,c.CompletionItemKind.Snippet],[18,c.CompletionItemKind.Text],[19,c.CompletionItemKind.Color],[20,c.CompletionItemKind.File],[21,c.CompletionItemKind.Reference],[23,c.CompletionItemKind.Folder],[10,c.CompletionItemKind.Event],[11,c.CompletionItemKind.Operator],[24,c.CompletionItemKind.TypeParameter],[25,c.CompletionItemKind.User],[26,c.CompletionItemKind.Issue]]);function Fe(xe){return ne.get(xe)??c.CompletionItemKind.Property}Te.to=Fe})(Z=e.CompletionItemKind||(e.CompletionItemKind={}));var se;(function(Te){function Le(Se,ne){const Fe=new c.CompletionItem(Se.label);return Fe.insertText=Se.insertText,Fe.kind=Z.to(Se.kind),Fe.tags=Se.tags?.map(me.to),Fe.detail=Se.detail,Fe.documentation=D.isMarkdownString(Se.documentation)?M.to(Se.documentation):Se.documentation,Fe.sortText=Se.sortText,Fe.filterText=Se.filterText,Fe.preselect=Se.preselect,Fe.commitCharacters=Se.commitCharacters,k.Range.isIRange(Se.range)?Fe.range=d.to(Se.range):typeof Se.range=="object"&&(Fe.range={inserting:d.to(Se.range.insert),replacing:d.to(Se.range.replace)}),Fe.keepWhitespace=typeof Se.insertTextRules=="undefined"?!1:Boolean(Se.insertTextRules&1),typeof Se.insertTextRules!="undefined"&&Se.insertTextRules&4?Fe.insertText=new c.SnippetString(Se.insertText):(Fe.insertText=Se.insertText,Fe.textEdit=Fe.range instanceof c.Range?new c.TextEdit(Fe.range,Fe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Se.additionalTextEdits.map(xe=>N.to(xe))),Fe.command=ne&&Se.command?ne.fromInternal(Se.command):void 0,Fe}Te.to=Le})(se=e.CompletionItem||(e.CompletionItem={}));var O;(function(Te){function Le(ne){return{label:ne.label,documentation:M.fromStrict(ne.documentation)}}Te.from=Le;function Se(ne){return{label:ne.label,documentation:D.isMarkdownString(ne.documentation)?M.to(ne.documentation):ne.documentation}}Te.to=Se})(O=e.ParameterInformation||(e.ParameterInformation={}));var H;(function(Te){function Le(ne){return{label:ne.label,documentation:M.fromStrict(ne.documentation),parameters:Array.isArray(ne.parameters)?ne.parameters.map(O.from):[],activeParameter:ne.activeParameter}}Te.from=Le;function Se(ne){return{label:ne.label,documentation:D.isMarkdownString(ne.documentation)?M.to(ne.documentation):ne.documentation,parameters:Array.isArray(ne.parameters)?ne.parameters.map(O.to):[],activeParameter:ne.activeParameter}}Te.to=Se})(H=e.SignatureInformation||(e.SignatureInformation={}));var K;(function(Te){function Le(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(H.from):[]}}Te.from=Le;function Se(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(H.to):[]}}Te.to=Se})(K=e.SignatureHelp||(e.SignatureHelp={}));var Q;(function(Te){function Le(Se,ne){const Fe=new c.InlayHint(o.to(ne.position),typeof ne.label=="string"?ne.label:ne.label.map(he.to.bind(void 0,Se)),ne.kind&&be.to(ne.kind));return Fe.textEdits=ne.textEdits&&ne.textEdits.map(N.to),Fe.tooltip=D.isMarkdownString(ne.tooltip)?M.to(ne.tooltip):ne.tooltip,Fe.paddingLeft=ne.paddingLeft,Fe.paddingRight=ne.paddingRight,Fe}Te.to=Le})(Q=e.InlayHint||(e.InlayHint={}));var he;(function(Te){function Le(Se,ne){const Fe=new c.InlayHintLabelPart(ne.label);return Fe.tooltip=D.isMarkdownString(ne.tooltip)?M.to(ne.tooltip):ne.tooltip,_.Command.is(ne.command)&&(Fe.command=Se.fromInternal(ne.command)),ne.location&&(Fe.location=ge.to(ne.location)),Fe}Te.to=Le})(he=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var be;(function(Te){function Le(ne){return ne}Te.from=Le;function Se(ne){return ne}Te.to=Se})(be=e.InlayHintKind||(e.InlayHintKind={}));var ce;(function(Te){function Le(ne){return{range:d.from(ne.range),url:ne.target,tooltip:ne.tooltip}}Te.from=Le;function Se(ne){let Fe;if(ne.url)try{Fe=typeof ne.url=="string"?R.URI.parse(ne.url,!0):R.URI.revive(ne.url)}catch{}return new c.DocumentLink(d.to(ne.range),Fe)}Te.to=Se})(ce=e.DocumentLink||(e.DocumentLink={}));var De;(function(Te){function Le(ne){const Fe=new c.ColorPresentation(ne.label);return ne.textEdit&&(Fe.textEdit=N.to(ne.textEdit)),ne.additionalTextEdits&&(Fe.additionalTextEdits=ne.additionalTextEdits.map(xe=>N.to(xe))),Fe}Te.to=Le;function Se(ne){return{label:ne.label,textEdit:ne.textEdit?N.from(ne.textEdit):void 0,additionalTextEdits:ne.additionalTextEdits?ne.additionalTextEdits.map(Fe=>N.from(Fe)):void 0}}Te.from=Se})(De=e.ColorPresentation||(e.ColorPresentation={}));var ye;(function(Te){function Le(ne){return new c.Color(ne[0],ne[1],ne[2],ne[3])}Te.to=Le;function Se(ne){return[ne.red,ne.green,ne.blue,ne.alpha]}Te.from=Se})(ye=e.Color||(e.Color={}));var Be;(function(Te){function Le(ne){return{range:d.from(ne.range)}}Te.from=Le;function Se(ne){return new c.SelectionRange(d.to(ne.range))}Te.to=Se})(Be=e.SelectionRange||(e.SelectionRange={}));var qe;(function(Te){function Le(Se){switch(Se){case 2:return c.TextDocumentSaveReason.AfterDelay;case 1:return c.TextDocumentSaveReason.Manual;case 3:case 4:return c.TextDocumentSaveReason.FocusOut}}Te.to=Le})(qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(Te){function Le(ne){switch(ne){case c.TextEditorLineNumbersStyle.Off:return 0;case c.TextEditorLineNumbersStyle.Relative:return 2;case c.TextEditorLineNumbersStyle.On:default:return 1}}Te.from=Le;function Se(ne){switch(ne){case 0:return c.TextEditorLineNumbersStyle.Off;case 2:return c.TextEditorLineNumbersStyle.Relative;case 1:default:return c.TextEditorLineNumbersStyle.On}}Te.to=Se})(et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Xe;(function(Te){function Le(ne){if(ne===c.EndOfLine.CRLF)return 1;if(ne===c.EndOfLine.LF)return 0}Te.from=Le;function Se(ne){if(ne===1)return c.EndOfLine.CRLF;if(ne===0)return c.EndOfLine.LF}Te.to=Se})(Xe=e.EndOfLine||(e.EndOfLine={}));var Oe;(function(Te){function Le(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case c.ProgressLocation.SourceControl:return 3;case c.ProgressLocation.Window:return 10;case c.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Te.from=Le})(Oe=e.ProgressLocation||(e.ProgressLocation={}));var ot;(function(Te){function Le(Se){const ne={start:Se.start+1,end:Se.end+1};return Se.kind&&(ne.kind=ie.from(Se.kind)),ne}Te.from=Le})(ot=e.FoldingRange||(e.FoldingRange={}));var ie;(function(Te){function Le(Se){if(Se)switch(Se){case c.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case c.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case c.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}Te.from=Le})(ie=e.FoldingRangeKind||(e.FoldingRangeKind={}));var oe;(function(Te){function Le(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?d.from(Se.selection):void 0,override:typeof Se.override=="boolean"?P.EditorResolution.DISABLED:void 0}}Te.from=Le})(oe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var G;(function(Te){function Le(xe){return xe instanceof c.RelativePattern?xe.toJSON():typeof xe=="string"?xe:Se(xe)||ne(xe)?new c.RelativePattern(xe.baseUri??xe.base,xe.pattern).toJSON():xe}Te.from=Le;function Se(xe){const Ye=xe;return Ye?R.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function ne(xe){const Ye=xe;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Fe(xe){return typeof xe=="string"?xe:new c.RelativePattern(R.URI.revive(xe.baseUri),xe.pattern)}Te.to=Fe})(G=e.GlobPattern||(e.GlobPattern={}));var Ce;(function(Te){function Le(Se){if(Se){if(Array.isArray(Se))return Se.map(Le);if(typeof Se=="string")return Se;{const ne=Se;return{language:ne.language,scheme:ne.scheme,pattern:G.from(ne.pattern),exclusive:ne.exclusive,notebookType:ne.notebookType}}}else return}Te.from=Le})(Ce=e.LanguageSelector||(e.LanguageSelector={}));var Re;(function(Te){function Le(ne){return{start:ne.start,end:ne.end}}Te.from=Le;function Se(ne){return new c.NotebookRange(ne.start,ne.end)}Te.to=Se})(Re=e.NotebookRange||(e.NotebookRange={}));var We;(function(Te){function Le(ne){return{timing:typeof ne.runStartTime=="number"&&typeof ne.runEndTime=="number"?{startTime:ne.runStartTime,endTime:ne.runEndTime}:void 0,executionOrder:ne.executionOrder,success:ne.lastRunSuccess}}Te.to=Le;function Se(ne){return{lastRunSuccess:ne.success,runStartTime:ne.timing?.startTime,runEndTime:ne.timing?.endTime,executionOrder:ne.executionOrder}}Te.from=Se})(We=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var ze;(function(Te){function Le(Se){if(Se===p.NotebookCellExecutionState.Executing)return c.NotebookCellExecutionState.Executing;if(Se===p.NotebookCellExecutionState.Pending)return c.NotebookCellExecutionState.Pending;if(Se===p.NotebookCellExecutionState.Unconfirmed)return c.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${Se}`)}Te.to=Le})(ze=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var $e;(function(Te){function Le(ne){switch(ne){case c.NotebookCellKind.Markup:return p.CellKind.Markup;case c.NotebookCellKind.Code:default:return p.CellKind.Code}}Te.from=Le;function Se(ne){switch(ne){case p.CellKind.Markup:return c.NotebookCellKind.Markup;case p.CellKind.Code:default:return c.NotebookCellKind.Code}}Te.to=Se})($e=e.NotebookCellKind||(e.NotebookCellKind={}));var tt;(function(Te){function Le(ne){const Fe={metadata:ne.metadata??Object.create(null),cells:[]};for(const xe of ne.cells)c.NotebookCellData.validate(xe),Fe.cells.push(st.from(xe));return Fe}Te.from=Le;function Se(ne){const Fe=new c.NotebookData(ne.cells.map(st.to));return(0,I.isEmptyObject)(ne.metadata)||(Fe.metadata=ne.metadata),Fe}Te.to=Se})(tt=e.NotebookData||(e.NotebookData={}));var st;(function(Te){function Le(ne){return{cellKind:$e.from(ne.kind),language:ne.languageId,mime:ne.mime,source:ne.value,metadata:ne.metadata,internalMetadata:We.from(ne.executionSummary??{}),outputs:ne.outputs?ne.outputs.map(nt.from):[]}}Te.from=Le;function Se(ne){return new c.NotebookCellData($e.to(ne.cellKind),ne.source,ne.language,ne.mime,ne.outputs?ne.outputs.map(nt.to):void 0,ne.metadata,ne.internalMetadata?We.to(ne.internalMetadata):void 0)}Te.to=Se})(st=e.NotebookCellData||(e.NotebookCellData={}));var lt;(function(Te){function Le(ne){return{mime:ne.mime,valueBytes:n.VSBuffer.wrap(ne.data)}}Te.from=Le;function Se(ne){return new c.NotebookCellOutputItem(ne.valueBytes.buffer,ne.mime)}Te.to=Se})(lt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var nt;(function(Te){function Le(ne){return{outputId:ne.id,items:ne.items.map(lt.from),metadata:ne.metadata}}Te.from=Le;function Se(ne){const Fe=ne.items.map(lt.to);return new c.NotebookCellOutput(Fe,ne.outputId,ne.metadata)}Te.to=Se})(nt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var it;(function(Te){function Le(Fe){return ne(Fe)?{include:(0,I.withNullAsUndefined)(G.from(Fe.include)),exclude:(0,I.withNullAsUndefined)(G.from(Fe.exclude))}:(0,I.withNullAsUndefined)(G.from(Fe))}Te.from=Le;function Se(Fe){return ne(Fe)?{include:G.to(Fe.include),exclude:G.to(Fe.exclude)}:G.to(Fe)}Te.to=Se;function ne(Fe){const xe=Fe;return xe?!(0,I.isUndefinedOrNull)(xe.include)&&!(0,I.isUndefinedOrNull)(xe.exclude):!1}})(it=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ft;(function(Te){function Le(Se,ne,Fe){const xe=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===c.NotebookCellStatusBarAlignment.Left?1:2,command:ne.toInternal(xe,Fe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Te.from=Le})(ft=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ct;(function(Te){function Le(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{}}}Te.from=Le})(Ct=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var kt;(function(Te){function Le(ne){return{uri:ne.uri,provides:ne.provides}}Te.from=Le;function Se(ne){return new c.NotebookRendererScript(R.URI.revive(ne.uri),ne.provides)}Te.to=Se})(kt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var mt;(function(Te){function Le(ne){return{message:M.fromStrict(ne.message)||"",type:0,expected:ne.expectedOutput,actual:ne.actualOutput,location:ne.location&&{range:d.from(ne.location.range),uri:ne.location.uri}}}Te.from=Le;function Se(ne){const Fe=new c.TestMessage(typeof ne.message=="string"?ne.message:M.to(ne.message));return Fe.actualOutput=ne.actual,Fe.expectedOutput=ne.expected,Fe.location=ne.location?ge.to(ne.location):void 0,Fe}Te.to=Se})(mt=e.TestMessage||(e.TestMessage={}));var Dt;(function(Te){Te.namespace=E.namespaceTestTag,Te.denamespace=E.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var Ut;(function(Te){function Le(ne){const Fe=(0,w.getPrivateApiFor)(ne).controllerId;return{extId:f.TestId.fromExtHostTestItem(ne,Fe).toString(),label:ne.label,uri:R.URI.revive(ne.uri),busy:!1,tags:ne.tags.map(xe=>Dt.namespace(Fe,xe.id)),range:k.Range.lift(d.from(ne.range)),description:ne.description||null,sortText:ne.sortText||null,error:ne.error&&M.fromStrict(ne.error)||null}}Te.from=Le;function Se(ne){return{parent:void 0,error:void 0,id:f.TestId.fromString(ne.extId).localId,label:ne.label,uri:R.URI.revive(ne.uri),tags:(ne.tags||[]).map(Fe=>{const{tagId:xe}=Dt.denamespace(Fe);return new c.TestTag(xe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(ne.range||void 0),canResolveChildren:!1,busy:!1,description:ne.description||void 0,sortText:ne.sortText||void 0}}Te.toPlain=Se})(Ut=e.TestItem||(e.TestItem={})),function(Te){function Le(ne){return{id:ne.id}}Te.from=Le;function Se(ne){return new c.TestTag(ne.id)}Te.to=Se}(Dt=e.TestTag||(e.TestTag={}));var Nt;(function(Te){const Le=(ne,Fe)=>{const xe={...Ut.toPlain(ne.item),parent:void 0,taskStates:ne.tasks.map(Ye=>({state:Ye.state,duration:Ye.duration,messages:Ye.messages.filter(Je=>Je.type===0).map(mt.to)})),children:ne.children.map(Ye=>Fe.get(Ye)).filter(I.isDefined).map(Ye=>Le(Ye,Fe))};for(const Ye of xe.children)Ye.parent=xe;return xe};function Se(ne){const Fe=[],xe=new Map;for(const Ye of ne.items)xe.set(Ye.item.extId,Ye),ne.request.targets.some(Je=>Je.controllerId===Ye.controllerId&&Je.testIds.includes(Ye.item.extId))&&Fe.push(Ye);return{completedAt:ne.completedAt,results:Fe.map(Ye=>Le(Ye,xe))}}Te.to=Se})(Nt=e.TestResults||(e.TestResults={}));var Ge;(function(Te){function Le(xe){return{covered:xe.covered,total:xe.covered}}function Se(xe){return"line"in xe?o.from(xe):d.from(xe)}function ne(xe){return"branches"in xe?{count:xe.executionCount,location:Se(xe.location),type:1,branches:xe.branches.length?xe.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&Se(Ye.location)})):void 0}:{type:0,count:xe.executionCount,location:Se(xe.location)}}Te.fromDetailed=ne;function Fe(xe){return{uri:xe.uri,statement:Le(xe.statementCoverage),branch:xe.branchCoverage&&Le(xe.branchCoverage),function:xe.functionCoverage&&Le(xe.functionCoverage),details:xe.detailedCoverage?.map(ne)}}Te.fromFile=Fe})(Ge=e.TestCoverage||(e.TestCoverage={}));var Ft;(function(Te){function Le(Se){switch(Se){case 1:return c.CodeActionTriggerKind.Invoke;case 2:return c.CodeActionTriggerKind.Automatic}}Te.to=Le})(Ft=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Lt;(function(Te){function Le(ne){const Fe=new c.TypeHierarchyItem(x.to(ne.kind),ne.name,ne.detail||"",R.URI.revive(ne.uri),d.to(ne.range),d.to(ne.selectionRange));return Fe._sessionId=ne._sessionId,Fe._itemId=ne._itemId,Fe}Te.to=Le;function Se(ne,Fe,xe){if(Fe=Fe??ne._sessionId,xe=xe??ne._itemId,Fe===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:xe,kind:x.from(ne.kind),name:ne.name,detail:ne.detail??"",uri:ne.uri,range:d.from(ne.range),selectionRange:d.from(ne.selectionRange),tags:ne.tags?.map(q.from)}}Te.from=Se})(Lt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Mt;(function(Te){function Le(Se){if(!!Se)return{value:Se.value,tooltip:Se.tooltip}}Te.from=Le})(Mt=e.ViewBadge||(e.ViewBadge={}));var pt;(function(Te){function Le(Se,ne){const Fe=Se.fileData;return Fe?new class extends c.DataTransferItem{asFile(){return{name:Fe.name,uri:R.URI.revive(Fe.uri),data:(0,m.once)(()=>ne())}}}(""):new c.DataTransferItem(Se.asString)}Te.toDataTransferItem=Le})(pt=e.DataTransferItem||(e.DataTransferItem={}));var Pt;(function(Te){function Le(ne,Fe){const xe=ne.items.map(([Ye,Je],Qe)=>[Ye,pt.toDataTransferItem(Je,()=>Fe(Qe))]);return new c.DataTransfer(xe)}Te.toDataTransfer=Le;async function Se(ne){const Fe={items:[]},xe=[];return ne.forEach((Ye,Je)=>{xe.push((async()=>{const Qe=await Ye.asString(),vt=Ye.asFile();Fe.items.push([Je,{asString:Qe,fileData:vt?{name:vt.name,uri:vt.uri}:void 0}])})())}),await Promise.all(xe),Fe}Te.toDataTransferDTO=Se})(Pt=e.DataTransfer||(e.DataTransfer={}))}),define(Ie[223],ke([0,1,2,12,7,15,80]),function(J,e,u,n,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class y{constructor(I,R,k,_={timeout:1500,errors:3}){this._logService=I,this._documents=R,this._mainThreadBulkEdits=k,this._thresholds=_,this._callbacks=new C.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(R,k,_)=>{const v={dispose:this._callbacks.push([R,k,I])};return Array.isArray(_)&&_.push(v),v}}async $participateInSave(I,R){const k=u.URI.revive(I);let _=!1;const P=setTimeout(()=>_=!0,this._thresholds.timeout),v=[];try{for(const w of[...this._callbacks]){if(_)break;const p=this._documents.getDocument(k),f=await this._deliverEventAsyncAndBlameBadListeners(w,{document:p,reason:T.TextDocumentSaveReason.to(R)});v.push(f)}}finally{clearTimeout(P)}return v}_deliverEventAsyncAndBlameBadListeners([I,R,k],_){const P=this._badListeners.get(I);return typeof P=="number"&&P>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,I,R,_).then(()=>!0,v=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const w=this._badListeners.get(I);this._badListeners.set(I,w?w+1:1),typeof w=="number"&&w>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,R,k,_){const P=[],v=Date.now(),{document:w,reason:p}=_,{version:f}=w,E=Object.freeze({document:w,reason:p,waitUntil(g){if(Object.isFrozen(P))throw(0,n.illegalState)("waitUntil can not be called async");P.push(Promise.resolve(g))}});try{R.apply(k,[E])}catch(g){return Promise.reject(g)}return Object.freeze(P),new Promise((g,c)=>{const m=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(P).then(a=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(m),g(a)}).catch(a=>{clearTimeout(m),c(a)})}).then(g=>{const c={edits:[]};for(const m of g)if(Array.isArray(m)&&m.every(a=>a instanceof D.TextEdit))for(const{newText:a,newEol:d,range:i}of m)c.edits.push({resource:w.uri,versionId:void 0,textEdit:{range:i&&T.Range.from(i),text:a,eol:d&&T.EndOfLine.from(d)}});if(c.edits.length!==0)return f===w.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=y}),define(Ie[224],ke([0,1,10,2,15,7,128]),function(J,e,u,n,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(k,_,P,v){this.start=k,this.deletedCount=_,this.deletedItems=P,this.items=v}asApiEvent(){return{range:new T.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class b{constructor(k,_,P){this.notebook=k,this._extHostDocument=_,this._cellData=P,this.handle=P.handle,this.uri=n.URI.revive(P.uri),this.cellKind=P.cellKind,this._outputs=P.outputs.map(D.NotebookCellOutput.to),this._internalMetadata=P.internalMetadata??{},this._metadata=Object.freeze(P.metadata??{}),this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(P.internalMetadata??{}))}static asModelAddData(k,_){return{EOL:_.eol,lines:_.source,languageId:_.language,uri:_.uri,isDirty:!1,versionId:1,notebook:k}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const k=this,_=this._extHostDocument.getDocument(this.uri);if(!_)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const P={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:D.NotebookCellKind.to(this._cellData.cellKind),document:_.document,get mime(){return k._mime},set mime(v){k._mime=v},get outputs(){return k._outputs.slice(0)},get metadata(){return k._metadata},get executionSummary(){return k._previousResult}};this._apiCell=Object.freeze(P)}return this._apiCell}setOutputs(k){this._outputs=k.map(D.NotebookCellOutput.to)}setOutputItems(k,_,P){const v=P.map(D.NotebookCellOutputItem.to),w=this._outputs.find(p=>p.id===k);w&&(_||(w.items.length=0),w.items.push(...v))}setMetadata(k){this._metadata=Object.freeze(k)}setInternalMetadata(k){this._internalMetadata=k,this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.ExtHostCell=b;class I{constructor(k,_,P,v,w){this._proxy=k,this._textDocumentsAndEditors=_,this._textDocuments=P,this.uri=v,this.handle=I._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=w.viewType,this._metadata=Object.freeze(w.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,w.cells]],!0,void 0),this._versionId=w.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const k=this,_={get uri(){return k.uri},get version(){return k._versionId},get notebookType(){return k._notebookType},get isDirty(){return k._isDirty},get isUntitled(){return k.uri.scheme===u.Schemas.untitled},get isClosed(){return k._disposed},get metadata(){return k._metadata},get cellCount(){return k._cells.length},cellAt(P){return P=k._validateIndex(P),k._cells[P].apiCell},getCells(P){return(P?k._getCells(P):k._cells).map(w=>w.apiCell)},save(){return k._save()}};this._notebook=Object.freeze(_)}return this._notebook}updateBackup(k){this._backup?.delete(),this._backup=k}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(k){k.metadata&&(this._metadata=Object.freeze({...this._metadata,...k.metadata}))}acceptDirty(k){this._isDirty=k}acceptModelChanged(k,_,P){this._versionId=k.versionId,this._isDirty=_,this.acceptDocumentPropertiesChanged({metadata:P});const v={notebook:this.apiNotebook,metadata:P,cellChanges:[],contentChanges:[]},w=[];for(const f of k.rawEvents)f.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(f.changes,!1,v.contentChanges):f.kind===C.NotebookCellsChangeType.Move?this._moveCell(f.index,f.newIdx,v.contentChanges):f.kind===C.NotebookCellsChangeType.Output?(this._setCellOutputs(f.index,f.outputs),w.push({cell:this._cells[f.index].apiCell,outputs:this._cells[f.index].apiCell.outputs})):f.kind===C.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(f.index,f.outputId,f.append,f.outputItems),w.push({cell:this._cells[f.index].apiCell,outputs:this._cells[f.index].apiCell.outputs})):f.kind===C.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(f.index,f.language),w.push({cell:this._cells[f.index].apiCell,document:this._cells[f.index].apiCell.document})):f.kind===C.NotebookCellsChangeType.ChangeCellContent?w.push({cell:this._cells[f.index].apiCell,document:this._cells[f.index].apiCell.document}):f.kind===C.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(f.index,f.mime):f.kind===C.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(f.index,f.metadata),w.push({cell:this._cells[f.index].apiCell,metadata:this._cells[f.index].apiCell.metadata})):f.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(f.index,f.internalMetadata),w.push({cell:this._cells[f.index].apiCell,executionSummary:this._cells[f.index].apiCell.executionSummary}));const p=new Map;for(let f=0;f<w.length;f++){const E=w[f],g=p.get(E.cell);if(g===void 0){const c=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...E});p.set(E.cell,c-1)}else v.cellChanges[g]={...v.cellChanges[g],...E}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}_validateIndex(k){return k=k|0,k<0?0:k>=this._cells.length?this._cells.length-1:k}_validateRange(k){let _=k.start|0,P=k.end|0;return _<0&&(_=0),P>this._cells.length&&(P=this._cells.length),k.with({start:_,end:P})}_getCells(k){k=this._validateRange(k);const _=[];for(let P=k.start;P<k.end;P++)_.push(this._cells[P]);return _}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(k,_,P){if(this._disposed)return;const v=[],w=[],p=[];if(k.reverse().forEach(f=>{const g=f[2].map(a=>{const d=new b(this,this._textDocumentsAndEditors,a);return _||w.push(b.asModelAddData(this.apiNotebook,a)),d}),c=new y(f[0],f[1],[],g),m=this._cells.splice(f[0],f[1],...g);for(const a of m)p.push(a.uri),c.deletedItems.push(a.apiCell);v.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:p}),P)for(const f of v)P.push(f.asApiEvent())}_moveCell(k,_,P){const v=this._cells.splice(k,1);this._cells.splice(_,0,...v);const w=[new y(k,1,v.map(p=>p.apiCell),[]),new y(_,0,[],v)];for(const p of w)P.push(p.asApiEvent())}_setCellOutputs(k,_){this._cells[k].setOutputs(_)}_setCellOutputItems(k,_,P,v){this._cells[k].setOutputItems(_,P,v)}_changeCellLanguage(k,_){const P=this._cells[k];P.apiCell.document.languageId!==_&&this._textDocuments.$acceptModelLanguageChanged(P.uri,_)}_changeCellMime(k,_){const P=this._cells[k];P.apiCell.mime=_}_changeCellMetadata(k,_){this._cells[k].setMetadata(_)}_changeCellInternalMetadata(k,_){this._cells[k].setInternalMetadata(_)}getCellFromApiCell(k){return this._cells.find(_=>_.apiCell===k)}getCellFromIndex(k){return this._cells[k]}getCell(k){return this._cells.find(_=>_.handle===k)}getCellIndex(k){return this._cells.indexOf(k)}}e.ExtHostNotebookDocument=I,I._handlePool=0}),define(Ie[131],ke([0,1,7,15,12]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(b){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=b}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(b){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:b})}replaceCellMetadata(b,I){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:b,metadata:I})}replaceCells(b,I,R){this._throwIfFinalized(),!(b===I&&R.length===0)&&this._collectedEdits.push({editType:1,index:b,count:I-b,cells:R.map(n.NotebookCellData.from)})}}class C{constructor(b,I,R,k,_,P){this.id=b,this._proxy=I,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=_,this._visibleRanges=k,this._viewColumn=P}get apiEditor(){if(!this._editor){const b=this;this._editor={get document(){return b.notebookData.apiNotebook},get notebook(){return b.notebookData.apiNotebook},get selection(){return b._selections[0]},set selection(I){this.selections=[I]},get selections(){return b._selections},set selections(I){if(!Array.isArray(I)||!I.every(u.NotebookRange.isNotebookRange))throw(0,D.illegalArgument)("selections");b._selections=I,b._trySetSelections(I)},get visibleRanges(){return b._visibleRanges},revealRange(I,R){b._proxy.$tryRevealRange(b.id,n.NotebookRange.from(I),R??u.NotebookEditorRevealType.Default)},get viewColumn(){return b._viewColumn},edit(I){const R=new T(this.document.version);return I(R),b._applyEdit(R.finalize())}},C.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(b){this._visible=b}_acceptVisibleRanges(b){this._visibleRanges=b}_acceptSelections(b){this._selections=b}_trySetSelections(b){this._proxy.$trySetSelections(this.id,b.map(n.NotebookRange.from))}_acceptViewColumn(b){this._viewColumn=b}_applyEdit(b){if(b.cellEdits.length===0)return Promise.resolve(!0);const I=[];let R=-1;for(let k=0;k<b.cellEdits.length;k++){if(R<0){I.push(b.cellEdits[k]),R++;continue}const P=I[R],v=b.cellEdits[k];if(P.editType===1&&v.editType===1&&P.index===v.index){P.cells.push(...b.cellEdits[k].cells),P.count+=b.cellEdits[k].count;continue}I.push(b.cellEdits[k]),R++}return this._proxy.$tryApplyEdits(this.id,b.documentVersionId,I)}}e.ExtHostNotebookEditor=C,C.apiEditorsToExtHost=new WeakMap}),define(Ie[225],ke([0,1,3,14,15]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let T=class{constructor(y,b){this._logService=y,this._notebooksAndEditors=b,this._onDidChangeNotebookEditorSelection=new u.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new u.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(y,b){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,b);const I=this._notebooksAndEditors.getEditorById(y);b.visibleRanges&&I._acceptVisibleRanges(b.visibleRanges.ranges.map(D.NotebookRange.to)),b.selections&&I._acceptSelections(b.selections.selections.map(D.NotebookRange.to)),b.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:I.apiEditor,visibleRanges:I.apiEditor.visibleRanges}),b.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:I.apiEditor,selections:I.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const b in y)this._notebooksAndEditors.getEditorById(b)._acceptViewColumn(D.ViewColumn.to(y[b]))}};T=je([Ve(0,n.ILogService)],T),e.ExtHostNotebookEditors=T}),define(Ie[226],ke([0,1,15,119,172,21,57,12]),function(J,e,u,n,D,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class b{constructor(_){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=_}async withProgress(_,P,v){const w=this._handles++,{title:p,location:f,cancellable:E}=P,g={label:(0,D.localize)(0,null,_.displayName||_.name),id:_.identifier.value};return this._proxy.$startProgress(w,{location:u.ProgressLocation.from(f),title:p,source:g,cancellable:E},_.isUnderDevelopment?void 0:_.identifier.value).catch(y.onUnexpectedExternalError),this._withProgress(w,v,!!E)}_withProgress(_,P,v){let w;v&&(w=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(_,w));const p=E=>{this._proxy.$progressEnd(E),this._mapHandleToCancellationSource.delete(E),w&&w.dispose()};let f;try{f=P(new R(this._proxy,_),v&&w?w.token:T.CancellationToken.None)}catch(E){throw p(_),E}return f.then(E=>p(_),E=>p(_)),f}$acceptProgressCanceled(_){const P=this._mapHandleToCancellationSource.get(_);P&&(P.cancel(),this._mapHandleToCancellationSource.delete(_))}}e.ExtHostProgress=b;function I(k,_){return k.message=_.message,typeof _.increment=="number"&&(typeof k.increment=="number"?k.increment+=_.increment:k.increment=_.increment),k}class R extends n.Progress{constructor(_,P){super(v=>this.throttledReport(v));this._proxy=_,this._handle=P}throttledReport(_){this._proxy.$progressReport(this._handle,_)}}je([(0,C.throttle)(100,(k,_)=>I(k,_),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Ie[132],ke([0,1,35,129,66,89,67,15,2]),function(J,e,u,n,D,T,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const I=(g,c,m,a)=>{let d=c;return{enumerable:!0,configurable:!1,get(){return d},set(i){if(!m(d,i)){const o=d;d=i,g.listener?.(a(i,o))}}}},R=(g,c)=>g===c,k={range:(g,c)=>g===c?!0:!g||!c?!1:g.isEqual(c),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(g,c)=>!(g.length!==c.length||g.some(m=>!c.find(a=>m.id===a.id)))},_=g=>c=>({op:4,update:g(c)}),P=(g,c)=>({range:I(g,void 0,k.range,_(m=>({range:u.Range.lift(y.Range.from(m))}))),label:I(g,c,k.label,_(m=>({label:m}))),description:I(g,void 0,k.description,_(m=>({description:m}))),sortText:I(g,void 0,k.sortText,_(m=>({sortText:m}))),canResolveChildren:I(g,!1,k.canResolveChildren,m=>({op:2,state:m})),busy:I(g,!1,k.busy,_(m=>({busy:m}))),error:I(g,void 0,k.error,_(m=>({error:y.MarkdownString.fromStrict(m)||null}))),tags:I(g,[],k.tags,(m,a)=>({op:1,new:m.map(y.TestTag.from),old:a.map(y.TestTag.from)}))}),v=g=>{const c=D.TestId.fromString(g.extId),m=new p(c.controllerId,c.localId,g.label,b.URI.revive(g.uri)||void 0);return m.range=y.Range.to(g.range||void 0),m.description=g.description||void 0,m.sortText=g.sortText||void 0,m.tags=g.tags.map(a=>y.TestTag.to({id:(0,C.denamespaceTestTag)(a).tagId})),m},w=g=>{let c;for(const m of g.tests){const a=v(m.item);(0,n.getPrivateApiFor)(a).parent=c,c=a}return c};e.toItemFromContext=w;class p{constructor(c,m,a,d){if(m.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(m)} symbol`);const i=(0,n.createPrivateApiFor)(this,c);Object.defineProperties(this,{id:{value:m,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof f?void 0:i.parent}},children:{value:(0,T.createTestItemChildren)(i,n.getPrivateApiFor,p),enumerable:!0,writable:!1},...P(i,a)})}}e.TestItemImpl=p;class f extends p{constructor(c,m){super(c,c,m,void 0)}}e.TestItemRootImpl=f;class E extends T.TestItemCollection{constructor(c,m){super({controllerId:c,getApiFor:n.getPrivateApiFor,getChildren:a=>a.children,root:new f(c,m),toITestItem:y.TestItem.from})}}e.ExtHostTestItemCollection=E}),define(Ie[133],ke([0,1,56,12,93,15,7]),function(J,e,u,n,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class y{constructor(_,P,v){const w=y._Keys.nextId();_.$registerTextEditorDecorationType(P.identifier,w,T.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:w,dispose(){_.$removeTextEditorDecorationType(w)}})}}e.TextEditorDecorationType=y,y._Keys=new D.IdGenerator("TextEditorDecorationType");class b{constructor(_,P){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=_,this._documentVersionId=_.version,this._undoStopBefore=P.undoStopBefore,this._undoStopAfter=P.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(_,P){this._throwIfFinalized();let v=null;if(_ instanceof C.Position)v=new C.Range(_,_);else if(_ instanceof C.Range)v=_;else throw new Error("Unrecognized location");this._pushEdit(v,P,!1)}insert(_,P){this._throwIfFinalized(),this._pushEdit(new C.Range(_,_),P,!0)}delete(_){this._throwIfFinalized();let P=null;if(_ instanceof C.Range)P=_;else throw new Error("Unrecognized location");this._pushEdit(P,null,!0)}_pushEdit(_,P,v){const w=this._document.validateRange(_);this._collectedEdits.push({range:w,text:P,forceMoveMarkers:v})}setEndOfLine(_){if(this._throwIfFinalized(),_!==C.EndOfLine.LF&&_!==C.EndOfLine.CRLF)throw(0,n.illegalArgument)("endOfLine");this._setEndOfLine=_}}e.TextEditorEdit=b;class I{constructor(_,P,v,w){this._proxy=_,this._id=P,this._accept(v),this._logService=w;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(f){p._setTabSize(f)},get insertSpaces(){return p._insertSpaces},set insertSpaces(f){p._setInsertSpaces(f)},get cursorStyle(){return p._cursorStyle},set cursorStyle(f){p._setCursorStyle(f)},get lineNumbers(){return p._lineNumbers},set lineNumbers(f){p._setLineNumbers(f)}}}_accept(_){this._tabSize=_.tabSize,this._insertSpaces=_.insertSpaces,this._cursorStyle=_.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(_.lineNumbers)}_validateTabSize(_){if(_==="auto")return"auto";if(typeof _=="number"){const P=Math.floor(_);return P>0?P:null}if(typeof _=="string"){const P=parseInt(_,10);return isNaN(P)?null:P>0?P:null}return null}_setTabSize(_){const P=this._validateTabSize(_);if(P!==null){if(typeof P=="number"){if(this._tabSize===P)return;this._tabSize=P}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:P}))}}_validateInsertSpaces(_){return _==="auto"?"auto":_==="false"?!1:Boolean(_)}_setInsertSpaces(_){const P=this._validateInsertSpaces(_);if(typeof P=="boolean"){if(this._insertSpaces===P)return;this._insertSpaces=P}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:P}))}_setCursorStyle(_){this._cursorStyle!==_&&(this._cursorStyle=_,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:_})))}_setLineNumbers(_){this._lineNumbers!==_&&(this._lineNumbers=_,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(_)})))}assign(_){const P={};let v=!1;if(typeof _.tabSize!="undefined"){const w=this._validateTabSize(_.tabSize);w==="auto"?(v=!0,P.tabSize=w):typeof w=="number"&&this._tabSize!==w&&(this._tabSize=w,v=!0,P.tabSize=w)}if(typeof _.insertSpaces!="undefined"){const w=this._validateInsertSpaces(_.insertSpaces);w==="auto"?(v=!0,P.insertSpaces=w):this._insertSpaces!==w&&(this._insertSpaces=w,v=!0,P.insertSpaces=w)}typeof _.cursorStyle!="undefined"&&this._cursorStyle!==_.cursorStyle&&(this._cursorStyle=_.cursorStyle,v=!0,P.cursorStyle=_.cursorStyle),typeof _.lineNumbers!="undefined"&&this._lineNumbers!==_.lineNumbers&&(this._lineNumbers=_.lineNumbers,v=!0,P.lineNumbers=T.TextEditorLineNumbersStyle.from(_.lineNumbers)),v&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,P))}_warnOnError(_,P){P.catch(v=>{this._logService.warn(`ExtHostTextEditorOptions '${_}' failed:'`),this._logService.warn(v)})}}e.ExtHostTextEditorOptions=I;class R{constructor(_,P,v,w,p,f,E,g){this.id=_,this._proxy=P,this._logService=v,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new I(this._proxy,this.id,f,v),this._visibleRanges=E,this._viewColumn=g;const c=this;this.value=Object.freeze({get document(){return w.getValue()},set document(m){throw(0,n.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(m){if(!(m instanceof C.Selection))throw(0,n.illegalArgument)("selection");c._selections=[m],c._trySetSelection()},get selections(){return c._selections},set selections(m){if(!Array.isArray(m)||m.some(a=>!(a instanceof C.Selection)))throw(0,n.illegalArgument)("selections");c._selections=m,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(m){throw(0,n.readonly)("visibleRanges")},get options(){return c._options.value},set options(m){c._disposed||c._options.assign(m)},get viewColumn(){return c._viewColumn},set viewColumn(m){throw(0,n.readonly)("viewColumn")},edit(m,a={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new b(w.getValue(),a);return m(d),c._applyEdit(d)},insertSnippet(m,a,d={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!a||Array.isArray(a)&&a.length===0)i=c._selections.map(o=>T.Range.from(o));else if(a instanceof C.Position){const{lineNumber:o,column:r}=T.Position.from(a);i=[{startLineNumber:o,startColumn:r,endLineNumber:o,endColumn:r}]}else if(a instanceof C.Range)i=[T.Range.from(a)];else{i=[];for(const o of a)if(o instanceof C.Range)i.push(T.Range.from(o));else{const{lineNumber:r,column:t}=T.Position.from(o);i.push({startLineNumber:r,startColumn:t,endLineNumber:r,endColumn:t})}}return P.$tryInsertSnippet(_,w.getValue().version,m.value,i,d)},setDecorations(m,a){const d=a.length===0;d&&!c._hasDecorationsForKey.has(m.key)||(d?c._hasDecorationsForKey.delete(m.key):c._hasDecorationsForKey.add(m.key),c._runOnProxy(()=>{if(T.isDecorationOptionsArr(a))return P.$trySetDecorations(_,m.key,T.fromRangeOrRangeWithMessage(a));{const i=new Array(4*a.length);for(let o=0,r=a.length;o<r;o++){const t=a[o];i[4*o]=t.start.line+1,i[4*o+1]=t.start.character+1,i[4*o+2]=t.end.line+1,i[4*o+3]=t.end.character+1}return P.$trySetDecorationsFast(_,m.key,i)}}))},revealRange(m,a){c._runOnProxy(()=>P.$tryRevealRange(_,T.Range.from(m),a||C.TextEditorRevealType.Default))},show(m){P.$tryShowEditor(_,T.ViewColumn.from(m))},hide(){P.$tryHideEditor(_)}})}dispose(){(0,u.ok)(!this._disposed),this._disposed=!0}_acceptOptions(_){(0,u.ok)(!this._disposed),this._options._accept(_)}_acceptVisibleRanges(_){(0,u.ok)(!this._disposed),this._visibleRanges=_}_acceptViewColumn(_){(0,u.ok)(!this._disposed),this._viewColumn=_}_acceptSelections(_){(0,u.ok)(!this._disposed),this._selections=_}async _trySetSelection(){const _=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,_)),this.value}_applyEdit(_){const P=_.finalize();if(P.edits.length===0&&!P.setEndOfLine)return Promise.resolve(!0);const v=P.edits.map(p=>p.range);v.sort((p,f)=>p.end.line===f.end.line?p.end.character===f.end.character?p.start.line===f.start.line?p.start.character-f.start.character:p.start.line-f.start.line:p.end.character-f.end.character:p.end.line-f.end.line);for(let p=0,f=v.length-1;p<f;p++){const E=v[p].end;if(v[p+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=P.edits.map(p=>({range:T.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,P.documentVersionId,w,{setEndOfLine:typeof P.setEndOfLine=="number"?T.EndOfLine.from(P.setEndOfLine):void 0,undoStopBefore:P.undoStopBefore,undoStopAfter:P.undoStopAfter})}_runOnProxy(_){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):_().then(()=>this,P=>(P instanceof Error&&P.name==="DISPOSED"||this._logService.warn(P),null))}}e.ExtHostTextEditor=R}),define(Ie[227],ke([0,1,4,192]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,u.refineServiceDecorator)(n.IEnvironmentService)}),define(Ie[228],ke([0,1,28,3,9]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(k){this.removedDueToLooping=k}}e.DeltaExtensionsResult=T;class C{constructor(k){this._onDidChange=new n.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=k,this._initialize()}_initialize(){this._extensionDescriptions.sort(b),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const k of this._extensionDescriptions){if(this._extensionsMap.has(u.ExtensionIdentifier.toKey(k.identifier))){console.error("Extension `"+k.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(u.ExtensionIdentifier.toKey(k.identifier),k),this._extensionsArr.push(k),Array.isArray(k.activationEvents))for(let _ of k.activationEvents)_==="onUri"&&(_=`onUri:${u.ExtensionIdentifier.toKey(k.identifier)}`),this._activationMap.has(_)||this._activationMap.set(_,[]),this._activationMap.get(_).push(k)}}set(k){this._extensionDescriptions=k,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(k,_){this._extensionDescriptions=I(this._extensionDescriptions,_),this._extensionDescriptions=this._extensionDescriptions.concat(k);const P=C._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=I(this._extensionDescriptions,P.map(v=>v.identifier)),this._initialize(),this._onDidChange.fire(void 0),new T(P)}static _findLoopingExtensions(k){const _=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(f){this._nodesSet.has(f)||(this._nodesSet.add(f),this._nodesArr.push(f))}addArc(f,E){this.addNode(f),this.addNode(E),this._arcs.has(f)?this._arcs.get(f).push(E):this._arcs.set(f,[E])}getArcs(f){return this._arcs.has(f)?this._arcs.get(f):[]}hasOnlyGoodArcs(f,E){const g=_.getArcs(f);for(let c=0;c<g.length;c++)if(!E.has(g[c]))return!1;return!0}getNodes(){return this._nodesArr}},P=new Map;for(const f of k){const E=u.ExtensionIdentifier.toKey(f.identifier);if(P.set(E,f),f.extensionDependencies)for(const g of f.extensionDependencies){const c=u.ExtensionIdentifier.toKey(g);_.addArc(E,c)}}const v=new Set;_.getNodes().filter(f=>_.getArcs(f).length===0).forEach(f=>v.add(f));const w=_.getNodes().filter(f=>!v.has(f));let p;do{p=!1;for(let f=0;f<w.length;f++){const E=w[f];_.hasOnlyGoodArcs(E,v)&&(w.splice(f,1),f--,v.add(E),p=!0)}}while(p);return w.map(f=>P.get(f))}containsActivationEvent(k){return this._activationMap.has(k)}containsExtension(k){return this._extensionsMap.has(u.ExtensionIdentifier.toKey(k))}getExtensionDescriptionsForActivationEvent(k){const _=this._activationMap.get(k);return _?_.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(k){const _=this._extensionsMap.get(u.ExtensionIdentifier.toKey(k));return _||void 0}getExtensionDescriptionByUUID(k){for(const _ of this._extensionsArr)if(_.uuid===k)return _}getExtensionDescriptionByIdOrUUID(k,_){return this.getExtensionDescription(k)??(_?this.getExtensionDescriptionByUUID(_):void 0)}}e.ExtensionDescriptionRegistry=C;var y;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(y||(y={}));function b(R,k){const _=R.isBuiltin?0:R.isUnderDevelopment?2:1,P=k.isBuiltin?0:k.isUnderDevelopment?2:1;if(_!==P)return _-P;const v=D.posix.basename(R.extensionLocation.path),w=D.posix.basename(k.extensionLocation.path);return v<w?-1:v>w?1:0}function I(R,k){const _=new Set;return k.forEach(P=>_.add(u.ExtensionIdentifier.toKey(P))),R.filter(P=>!_.has(u.ExtensionIdentifier.toKey(P.identifier)))}}),define(Ie[229],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var u;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(u=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class n{constructor(k){this.pipeName=k,this.type=1}serialize(k){k[n.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=n,n.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class D{constructor(){this.type=2}serialize(k){k[D.ENV_KEY]="1"}}e.SocketExtHostConnection=D,D.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class T{constructor(){this.type=3}serialize(k){k[T.ENV_KEY]="1"}}e.MessagePortExtHostConnection=T,T.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function C(R){delete R[n.ENV_KEY],delete R[D.ENV_KEY],delete R[T.ENV_KEY]}function y(R,k){C(k),R.serialize(k)}e.writeExtHostConnection=y;function b(R){if(R[n.ENV_KEY])return I(R,new n(R[n.ENV_KEY]));if(R[D.ENV_KEY])return I(R,new D);if(R[T.ENV_KEY])return I(R,new T);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=b;function I(R,k){return C(R),k}}),define(Ie[134],ke([0,1,23]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var n;(function(I){I[I.Desktop=1]="Desktop",I[I.Web=2]="Web"})(n=e.UIKind||(e.UIKind={}));var D;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(D=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var T;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(T=e.MessageType||(e.MessageType={}));function C(I){const R=u.VSBuffer.alloc(1);switch(I){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=C;function y(I,R){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=y;var b;(function(I){I.Start="START_NATIVE_LOG",I.End="END_NATIVE_LOG"})(b=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ie[27],ke([0,1,3,2,4,28,201]),function(J,e,u,n,D,T,C){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:n.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class b{constructor(t){this.affinity=t,this.kind=1}equals(t){return this.kind===t.kind&&this.affinity===t.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=b;class I{constructor(){this.kind=2,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=I;class R{constructor(){this.kind=3,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"Remote"}}e.RemoteRunningLocation=R;class k{constructor(t){this.dependency=t}}e.MissingExtensionDependency=k;var _;(function(r){r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(_=e.ExtensionHostKind||(e.ExtensionHostKind={}));function P(r){if(r===null)return"None";switch(r){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=P;class v{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(t,s){const l=[],h=[],S=[],L=[],F=f(this._allExtensions),M=f(t),A=(X,z)=>X.extensionLocation.toString()===z.extensionLocation.toString()||X.isBuiltin===z.isBuiltin||X.isUserBuiltin===z.isUserBuiltin||X.isUnderDevelopment===z.isUnderDevelopment;for(const X of this._allExtensions){const z=M.get(T.ExtensionIdentifier.toKey(X.identifier));if(!z){l.push(X.identifier),F.delete(T.ExtensionIdentifier.toKey(X.identifier));continue}if(!A(X,z)){l.push(X.identifier),F.delete(T.ExtensionIdentifier.toKey(X.identifier));continue}}for(const X of t){const z=F.get(T.ExtensionIdentifier.toKey(X.identifier));if(!z){h.push(X);continue}if(!A(z,X)){l.push(z.identifier),F.delete(T.ExtensionIdentifier.toKey(z.identifier));continue}}const B=p(this._myExtensions),$=p(s);for(const X of this._myExtensions)$.has(T.ExtensionIdentifier.toKey(X))||S.push(X);for(const X of s)B.has(T.ExtensionIdentifier.toKey(X))||L.push(X);const U={toRemove:l,toAdd:h,myToRemove:S,myToAdd:L};return this.delta(U),U}delta(t){const{toRemove:s,toAdd:l,myToRemove:h,myToAdd:S}=t,L=p(s),F=p(h);for(let M=0;M<this._allExtensions.length;M++)L.has(T.ExtensionIdentifier.toKey(this._allExtensions[M].identifier))&&(this._allExtensions.splice(M,1),M--);for(let M=0;M<this._myExtensions.length;M++)F.has(T.ExtensionIdentifier.toKey(this._myExtensions[M]))&&(this._myExtensions.splice(M,1),M--);for(const M of l)this._allExtensions.push(M);for(const M of S)this._myExtensions.push(M)}containsExtension(t){for(const s of this._myExtensions)if(T.ExtensionIdentifier.equals(s,t))return!0;return!1}}e.ExtensionHostExtensions=v;class w{constructor(t){if(this[y]="ExtensionIdentifierSet",this._map=new Map,this._toKey=T.ExtensionIdentifier.toKey,t)for(const s of t)this.add(s)}get size(){return this._map.size}add(t){return this._map.set(this._toKey(t),t),this}clear(){this._map.clear()}delete(t){return this._map.delete(this._toKey(t))}has(t){return this._map.has(this._toKey(t))}forEach(t,s){this._map.forEach(l=>t.call(s,l,l,this))}*entries(){for(const[t,s]of this._map)yield[s,s]}keys(){return this._map.values()}values(){return this._map.values()}[(y=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=w;function p(r){const t=new Set;for(const s of r)t.add(T.ExtensionIdentifier.toKey(s));return t}e.extensionIdentifiersArrayToSet=p;function f(r){const t=new Map;for(const s of r)t.set(T.ExtensionIdentifier.toKey(s.identifier),s);return t}function E(r,t){return r.enabledApiProposals?r.enabledApiProposals.includes(t):!1}e.isProposedApiEnabled=E;function g(r,t){if(!E(r,t))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=g;class c{constructor(t,s,l,h){this.codeLoadingTime=t,this.activateCallTime=s,this.activateResolvedTime=l,this.activationReason=h}}e.ActivationTimes=c;class m{constructor(t,s){this.description=t,this.value=s}}e.ExtensionPointContribution=m,e.ExtensionHostLogFileName="exthost";var a;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(a=e.ActivationKind||(e.ActivationKind={}));function d(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function i(r,t){return{identifier:new T.ExtensionIdentifier((0,C.getExtensionId)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!t,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform}}e.toExtensionDescription=i;class o{constructor(){this.onDidRegisterExtensions=u.Event.None,this.onDidChangeExtensionsStatus=u.Event.None,this.onDidChangeExtensions=u.Event.None,this.onWillActivateByEvent=u.Event.None,this.onDidChangeResponsiveChange=u.Event.None}activateByEvent(t){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(t,s){return Promise.resolve(0)}getInspectPorts(t,s){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(t,s){return Promise.resolve()}}e.NullExtensionService=o}),define(Ie[230],ke([0,1,12,28,27,14,18]),function(J,e,u,n,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(p,f,E,g){this.startup=p,this.codeLoadingTime=f,this.activateCallTime=E,this.activateResolvedTime=g}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class b{constructor(p){this._startup=p,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(p,f){return p===-1||f===-1?-1:f-p}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=b;class I{constructor(p,f,E,g,c,m){this.activationFailed=p,this.activationFailedError=f,this.activationTimes=E,this.module=g,this.exports=c,this.subscriptions=m}}e.ActivatedExtension=I;class R extends I{constructor(p){super(!1,null,p,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class k extends I{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=k;class _ extends I{constructor(p){super(!0,p,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=_;let P=class{constructor(p,f,E,g,c){this._logService=c,this._registry=p,this._resolvedExtensionsSet=new Set,f.forEach(m=>this._resolvedExtensionsSet.add(n.ExtensionIdentifier.toKey(m))),this._externalExtensionsMap=new Map,E.forEach(m=>this._externalExtensionsMap.set(n.ExtensionIdentifier.toKey(m),m)),this._host=g,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[p,f]of this._operations)f.dispose()}isActivated(p){const f=this._operations.get(n.ExtensionIdentifier.toKey(p));return Boolean(f&&f.value)}getActivatedExtension(p){const f=this._operations.get(n.ExtensionIdentifier.toKey(p));if(!f||!f.value)throw new Error(`Extension '${p.value}' is not known or not activated`);return f.value}async activateByEvent(p,f){if(this._alreadyActivatedEvents[p])return;const E=this._registry.getExtensionDescriptionsForActivationEvent(p);await this._activateExtensions(E.map(g=>({id:g.identifier,reason:{startup:f,extensionId:g.identifier,activationEvent:p}}))),this._alreadyActivatedEvents[p]=!0}activateById(p,f){const E=this._registry.getExtensionDescription(p);if(!E)throw new Error(`Extension '${p}' is not known`);return this._activateExtensions([{id:E.identifier,reason:f}])}async _activateExtensions(p){const f=p.filter(E=>!this.isActivated(E.id)).map(E=>this._handleActivationRequest(E));await Promise.all(f.map(E=>E.wait()))}_handleActivationRequest(p){if(this._operations.has(n.ExtensionIdentifier.toKey(p.id)))return this._operations.get(n.ExtensionIdentifier.toKey(p.id));if(this._externalExtensionsMap.has(n.ExtensionIdentifier.toKey(p.id)))return this._createAndSaveOperation(p,null,[],null);const f=this._registry.getExtensionDescription(p.id);if(!f){const c=new Error(`Cannot activate unknown extension '${p.id.value}'`),m=this._createAndSaveOperation(p,null,[],new _(c));return this._host.onExtensionActivationError(p.id,c,new D.MissingExtensionDependency(p.id.value)),m}const E=[],g=typeof f.extensionDependencies=="undefined"?[]:f.extensionDependencies;for(const c of g){if(this._resolvedExtensionsSet.has(n.ExtensionIdentifier.toKey(c)))continue;const m=this._operations.get(n.ExtensionIdentifier.toKey(c));if(m){E.push(m);continue}if(this._externalExtensionsMap.has(n.ExtensionIdentifier.toKey(c))){E.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(n.ExtensionIdentifier.toKey(c)),reason:p.reason}));continue}const a=this._registry.getExtensionDescription(c);if(a){if(!a.main&&!a.browser)continue;E.push(this._handleActivationRequest({id:a.identifier,reason:p.reason}));continue}const d=f.displayName||f.identifier.value,i=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${c}'`),o=this._createAndSaveOperation(p,f.displayName,[],new _(i));return this._host.onExtensionActivationError(f.identifier,i,new D.MissingExtensionDependency(c)),o}return this._createAndSaveOperation(p,f.displayName,E,null)}_createAndSaveOperation(p,f,E,g){const c=new v(p.id,f,p.reason,E,g,this._host,this._logService);return this._operations.set(n.ExtensionIdentifier.toKey(p.id),c),c}};P=je([Ve(4,T.ILogService)],P),e.ExtensionsActivator=P;let v=class{constructor(p,f,E,g,c,m,a){this._id=p,this._displayName=f,this._reason=E,this._deps=g,this._value=c,this._host=m,this._logService=a,this._barrier=new C.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let p=0;p<this._deps.length;p++){const f=this._deps[p];if(f.value&&!f.value.activationFailed){this._deps.splice(p,1),p--;continue}if(f.value&&f.value.activationFailed){const E=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${f.friendlyName}' failed to activate`);E.detail=f.value.activationFailedError,this._value=new _(E),this._host.onExtensionActivationError(this._id,E,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(p=>p.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(p){const f=new Error;if(p&&p.name&&(f.name=p.name),p&&p.message?f.message=`Activating extension '${this._id.value}' failed: ${p.message}.`:f.message=`Activating extension '${this._id.value}' failed: ${p}.`,p&&p.stack&&(f.stack=p.stack),this._value=new _(f),this._isDisposed&&u.isCancellationError(p))return;this._host.onExtensionActivationError(this._id,f,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(p)}}};v=je([Ve(6,T.ILogService)],v)}),define(Ie[231],ke([0,1,14,26,27]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends u.LogService{constructor(y,b){super(y.createLogger(b.logFile,{name:D.ExtensionHostLogFileName}))}};T=je([Ve(0,u.ILoggerService),Ve(1,n.IExtHostInitDataService)],T),e.ExtHostLogService=T}),define(Ie[232],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",badges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.badges.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorToolbar:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorToolbar.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewSize.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",contribWebviewContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribWebviewContext.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookEditorEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditorEdit.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookWorkspaceEdit.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",snippetWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.snippetWorkspaceEdit.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExitReason:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExitReason.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ie[233],ke([0,1,186,12,41,84,120,44,28,232,199]),function(J,e,u,n,D,T,C,y,b,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const k=y.Registry.as(C.Extensions.JSONContribution);class _{constructor(c,m,a){this._messageHandler=c,this._extension=m,this._extensionPointId=a}_msg(c,m){this._messageHandler({type:c,message:m,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(c){this._msg(D.default.Error,c)}warn(c){this._msg(D.default.Warning,c)}info(c){this._msg(D.default.Info,c)}}e.ExtensionMessageCollector=_;class P{constructor(c,m){this.added=c,this.removed=m}static _toSet(c){const m=new Set;for(let a=0,d=c.length;a<d;a++)m.add(b.ExtensionIdentifier.toKey(c[a].description.identifier));return m}static compute(c,m){if(!c||!c.length)return new P(m,[]);if(!m||!m.length)return new P([],c);const a=this._toSet(c),d=this._toSet(m),i=m.filter(r=>!a.has(b.ExtensionIdentifier.toKey(r.description.identifier))),o=c.filter(r=>!d.has(b.ExtensionIdentifier.toKey(r.description.identifier)));return new P(i,o)}}e.ExtensionPointUserDelta=P;class v{constructor(c,m){this.name=c,this.defaultExtensionKind=m,this._handler=null,this._users=null,this._delta=null}setHandler(c){if(this._handler!==null)throw new Error("Handler already set!");this._handler=c,this._handle()}acceptUsers(c){this._delta=P.compute(this._users,c),this._users=c,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(c){(0,n.onUnexpectedError)(c)}}}e.ExtensionPoint=v;const w={type:"string",enum:["ui","workspace"],enumDescriptions:[u.localize(0,null),u.localize(1,null)]},p="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:u.localize(2,null),properties:{vscode:{type:"string",description:u.localize(3,null),default:"^1.22.0"}}},publisher:{description:u.localize(4,null),type:"string"},displayName:{description:u.localize(5,null),type:"string"},categories:{description:u.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:b.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:u.localize(7,null)}]}},galleryBanner:{type:"object",description:u.localize(8,null),properties:{color:{description:u.localize(9,null),type:"string"},theme:{description:u.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:u.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:u.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:u.localize(13,null)},enabledApiProposals:{markdownDescription:u.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}},activationEvents:{description:u.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:u.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:u.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:u.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:u.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:u.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:u.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:u.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:u.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:u.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:u.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:u.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:u.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onSearch",description:u.localize(28,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:u.localize(29,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:u.localize(30,null)},{label:"onUri",body:"onUri",description:u.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:u.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:u.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:u.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:u.localize(35,null)},{label:"onRenderer",description:u.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:u.localize(37,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:u.localize(38,null)},{label:"*",description:u.localize(39,null),body:"*"}]}},badges:{type:"array",description:u.localize(40,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:u.localize(41,null)},href:{type:"string",description:u.localize(42,null)},description:{type:"string",description:u.localize(43,null)}}}},markdown:{type:"string",description:u.localize(44,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:u.localize(45,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:u.localize(46,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:u.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:u.localize(48,null),type:"array",items:w,default:["workspace"],defaultSnippets:[{body:["ui"],description:u.localize(49,null)},{body:["workspace"],description:u.localize(50,null)},{body:["ui","workspace"],description:u.localize(51,null)},{body:["workspace","ui"],description:u.localize(52,null)},{body:[],description:u.localize(53,null)}]},capabilities:{description:u.localize(54,null),type:"object",properties:{virtualWorkspaces:{description:u.localize(55,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:u.localize(56,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(57,null),u.localize(58,null),u.localize(59,null)]},description:{type:"string",markdownDescription:u.localize(60,null)}}},untrustedWorkspaces:{description:u.localize(61,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:u.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(63,null),u.localize(64,null),u.localize(65,null)]},restrictedConfigurations:{description:u.localize(66,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:u.localize(67,null)}}}}},sponsor:{description:u.localize(68,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:u.localize(69,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:u.localize(70,null),type:"string"},"vscode:uninstall":{description:u.localize(71,null),type:"string"}}},icon:{type:"string",description:u.localize(72,null)}}};class f{constructor(){this._extensionPoints=new Map}registerExtensionPoint(c){if(this._extensionPoints.has(c.extensionPoint))throw new Error("Duplicate extension point: "+c.extensionPoint);const m=new v(c.extensionPoint,c.defaultExtensionKind);return this._extensionPoints.set(c.extensionPoint,m),e.schema.properties.contributes.properties[c.extensionPoint]=c.jsonSchema,k.registerSchema(p,e.schema),m}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=f;const E={ExtensionsRegistry:"ExtensionsRegistry"};y.Registry.add(E.ExtensionsRegistry,new f),e.ExtensionsRegistry=y.Registry.as(E.ExtensionsRegistry),k.registerSchema(p,e.schema),k.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:u.localize(73,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}}]}}}})}),define(Ie[234],ke([0,1,183,11,24,233,51,3]),function(J,e,u,n,D,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const b={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:u.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:u.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:u.localize(2,null),default:""}}};var I;(function(_){function P(v,w,p){if(!v)return;const f=n.isString(v.type)?v.type:void 0;if(!f||f.length===0){p.error(u.localize(3,null));return}const E=[];if(Array.isArray(v.required))for(const g of v.required)n.isString(g)&&E.push(g);return{extensionId:w.value,taskType:f,required:E,properties:v.properties?D.deepClone(v.properties):{},when:v.when?C.ContextKeyExpr.deserialize(v.when):void 0}}_.from=P})(I||(I={}));const R=T.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:u.localize(4,null),type:"array",items:b}});class k{constructor(){this._onDefinitionsChanged=new y.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((P,v)=>{R.setHandler((w,p)=>{this._schema=void 0;try{for(const f of p.removed){const E=f.value;for(const g of E)this.taskTypes&&g.type&&this.taskTypes[g.type]&&delete this.taskTypes[g.type]}for(const f of p.added){const E=f.value;for(const g of E){const c=I.from(g,f.description.identifier,f.collector);c&&(this.taskTypes[c.taskType]=c)}}(p.removed.length>0||p.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}P(void 0)})})}onReady(){return this.readyPromise}get(P){return this.taskTypes[P]}all(){return Object.keys(this.taskTypes).map(P=>this.taskTypes[P])}getJsonSchema(){if(this._schema===void 0){const P=[];for(const v of this.all()){const w={type:"object",additionalProperties:!1};v.required.length>0&&(w.required=v.required.slice(0)),v.properties!==void 0?w.properties=D.deepClone(v.properties):w.properties=Object.create(null),w.properties.type={type:"string",enum:[v.taskType]},P.push(w)}this._schema={oneOf:P}}return this._schema}}e.TaskDefinitionRegistryImpl=k,e.TaskDefinitionRegistry=new k}),define(Ie[235],ke([0,1,184,11,22,24,51,234]),function(J,e,u,n,D,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new C.RawContextKey("taskRunning",!1,u.localize(0,null)),e.TASKS_CATEGORY={value:u.localize(1,null),original:"Tasks"};var b;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(b=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(U){function X(z){if(!z)return U.Strong;switch(z.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=X}(b=e.ShellQuoting||(e.ShellQuoting={}));var I;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(I=e.CommandOptions||(e.CommandOptions={}));var R;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(R=e.RevealKind||(e.RevealKind={})),function(U){function X(z){switch(z.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=X}(R=e.RevealKind||(e.RevealKind={}));var k;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(k=e.RevealProblemKind||(e.RevealProblemKind={})),function(U){function X(z){switch(z.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=X}(k=e.RevealProblemKind||(e.RevealProblemKind={}));var _;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(_=e.PanelKind||(e.PanelKind={})),function(U){function X(z){switch(z.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=X}(_=e.PanelKind||(e.PanelKind={}));var P;(function(U){U.defaults={echo:!0,reveal:R.Always,revealProblems:k.Never,focus:!1,panel:_.Shared,showReuseMessage:!0,clear:!1}})(P=e.PresentationOptions||(e.PresentationOptions={}));var v;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})(v=e.RuntimeType||(e.RuntimeType={})),function(U){function X(N){switch(N.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=X;function z(N){switch(N){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=z}(v=e.RuntimeType||(e.RuntimeType={}));var w;(function(U){function X(z){return n.isString(z)?z:z.value}U.value=X})(w=e.CommandString||(e.CommandString={}));var p;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function X(N){return N===U.Clean._id||N===U.Build._id||N===U.Rebuild._id||N===U.Test._id}U.is=X;function z(N){if(N!==void 0)return n.isString(N)?X(N)?{_id:N,isDefault:!1}:void 0:N}U.from=z})(p=e.TaskGroup||(e.TaskGroup={}));var f;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(f=e.TaskScope||(e.TaskScope={}));var E;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function X(z){switch(z){case U.User:return 2;case U.WorkspaceFile:return 5;default:return 6}}U.toConfigurationTarget=X})(E=e.TaskSourceKind||(e.TaskSourceKind={}));var g;(function(U){U.parallel="parallel",U.sequence="sequence"})(g=e.DependsOrder||(e.DependsOrder={}));var c;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(c=e.RunOnOptions||(e.RunOnOptions={}));var m;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(m=e.RunOptions||(e.RunOptions={}));class a{constructor(X,z,N,V,x,q){this._label="",this._id=X,z&&(this._label=z),N&&(this.type=N),this.runOptions=V,this.configurationProperties=x,this._source=q}getDefinition(X){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const X={folder:this.getFolderId(),id:this._id};return JSON.stringify(X)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(X,z=!1){if(X===void 0)return!1;if(n.isString(X))return X===this._label||X===this.configurationProperties.identifier||z&&X===this._id;const N=this.getDefinition(!0);return N!==void 0&&N._key===X._key}getQualifiedLabel(){const X=this.getWorkspaceFolder();return X?`${this._label} (${X.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(X){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),X&&(this._taskLoadMessages=this._taskLoadMessages.concat(X))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=a;class d extends a{constructor(X,z,N,V,x,q,te,Y){super(X,N,void 0,te,Y,z);this.command={},this._source=z,this.hasDefinedMatchers=q,x&&(this.command=x)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(X=!1){if(X&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case v.Shell:z="shell";break;case v.Process:z="process";break;case v.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(X){return X instanceof d}getMapKey(){const X=this._source.config.workspaceFolder;return X?`${X.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===E.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const X=this.getFolderId();if(!X)return;let z=this.configurationProperties.identifier;this._source.kind!==E.Workspace&&(z+=this._source.kind);const N={type:e.CUSTOMIZED_TASK_TYPE,folder:X,id:z};return JSON.stringify(N)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(X){return new d(X._id,X._source,X._label,X.type,X.command,X.hasDefinedMatchers,X.runOptions,X.configurationProperties)}}e.CustomTask=d;class i extends a{constructor(X,z,N,V,x,q,te){super(X,N,V,q,te,z);this._source=z,this.configures=x}static is(X){return X instanceof i}fromObject(X){return X}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===E.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const X=this.getFolderId();if(!X)return;let z=this.configurationProperties.identifier;this._source.kind!==E.Workspace&&(z+=this._source.kind);const N={type:e.CUSTOMIZED_TASK_TYPE,folder:X,id:z};return JSON.stringify(N)}}e.ConfiguringTask=i;class o extends a{constructor(X,z,N,V,x,q,te,Y,le){super(X,N,V,Y,le,z);this.defines=x,this.hasDefinedMatchers=te,this.command=q,this.icon=le.icon,this.hide=le.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(X){return X instanceof o}getMapKey(){const X=this._source.workspaceFolder;return X?`${this._source.scope.toString()}|${X.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const X={type:"contributed",scope:this._source.scope,id:this._id};return X.folder=this.getFolderId(),JSON.stringify(X)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(X){return new o(X._id,X._source,X._label,X.type,X.defines,X.command,X.hasDefinedMatchers,X.runOptions,X.configurationProperties)}}e.ContributedTask=o;class r extends a{constructor(X,z,N,V,x,q){super(X,N,V,x,q,z);this._source=z}clone(){return new r(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(X){return X instanceof r}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(X){return new r(X._id,X._source,X._label,X.type,X.runOptions,X.configurationProperties)}}e.InMemoryTask=r;var t;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})(t=e.ExecutionEngine||(e.ExecutionEngine={})),function(U){U._default=U.Terminal}(t=e.ExecutionEngine||(e.ExecutionEngine={}));var s;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(s=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class l{constructor(X){this._order=new Map;for(let z=0;z<X.length;z++)this._order.set(X[z].uri.toString(),z)}compare(X,z){const N=X.getWorkspaceFolder(),V=z.getWorkspaceFolder();if(N&&V){let x=this._order.get(N.uri.toString());x=x===void 0?0:x+1;let q=this._order.get(V.uri.toString());return q=q===void 0?0:q+1,x===q?X._label.localeCompare(z._label):x-q}else return!N&&V?-1:N&&!V?1:0}}e.TaskSorter=l;var h;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})(h=e.TaskEventKind||(e.TaskEventKind={}));var S;(function(U){U.SingleRun="singleRun",U.Background="background"})(S=e.TaskRunType||(e.TaskRunType={}));var L;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange",U[U.Reconnect=4]="Reconnect"})(L=e.TaskRunSource||(e.TaskRunSource={}));var F;(function(U){function X(z,N,V,x){if(N){const q={kind:z,taskId:N._id,taskName:N.configurationProperties.name,runType:N.configurationProperties.isBackground?"background":"singleRun",group:N.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:N};return z==="start"?(q.terminalId=V,q.resolvedVariables=x):z==="processStarted"?q.processId=V:z==="processEnded"&&(q.exitCode=V),Object.freeze(q)}else return Object.freeze({kind:"changed"})}U.create=X})(F=e.TaskEvent||(e.TaskEvent={}));var M;(function(U){function X(N){const V=Object.keys(N).sort();let x="";for(const q of V){let te=N[q];te instanceof Object?te=X(te):typeof te=="string"&&(te=te.replace(/,/g,",,")),x+=q+","+te+","}return x}function z(N){const x={_key:X(N),type:N.taskType};return Object.assign(x,N),x}U.create=z})(M=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var A;(function(U){U.AutoDetect="task.autoDetect",U.SaveBeforeRun="task.saveBeforeRun",U.ShowDecorations="task.showDecorations",U.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",U.SlowProviderWarning="task.slowProviderWarning",U.QuickOpenHistory="task.quickOpen.history",U.QuickOpenDetail="task.quickOpen.detail",U.QuickOpenSkip="task.quickOpen.skip",U.QuickOpenShowAll="task.quickOpen.showAll",U.AllowAutomaticTasks="task.allowAutomaticTasks",U.Reconnection="task.experimental.reconnection"})(A=e.TaskSettingId||(e.TaskSettingId={}));var B;(function(U){U.Tasks="tasks",U.SuppressTaskName="tasks.suppressTaskName",U.Windows="tasks.windows",U.Osx="tasks.osx",U.Linux="tasks.linux",U.ShowOutput="tasks.showOutput",U.IsShellCommand="tasks.isShellCommand",U.ServiceTestSetting="tasks.service.testSetting"})(B=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var $;(function(U){function X(z,N){const V=y.TaskDefinitionRegistry.get(z.type);if(V===void 0){const Y=T.deepClone(z);return delete Y._key,M.create(Y)}const x=Object.create(null);x.type=V.taskType;const q=new Set;V.required.forEach(Y=>q.add(Y));const te=V.properties;for(const Y of Object.keys(te)){const le=z[Y];if(le!=null)x[Y]=le;else if(q.has(Y)){const pe=te[Y];if(pe.default!==void 0)x[Y]=T.deepClone(pe.default);else switch(pe.type){case"boolean":x[Y]=!1;break;case"number":case"integer":x[Y]=0;break;case"string":x[Y]="";break;default:N.error(u.localize(2,null,JSON.stringify(z,void 0,0),Y));return}}}return M.create(x)}U.createTaskIdentifier=X})($=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ie[236],ke([0,1,12]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class n{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,y)=>{this._actualOk=C,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,u.onUnexpectedError)(C))}then(C,y){return this._ensureActual().then(C,y)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=n;class D extends n{constructor(){super();this._hasErr=!0,this._err=new u.CancellationError}}e.CanceledLazyPromise=D}),define(Ie[53],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class u{constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++u.count}}e.ProxyIdentifier=u,u.count=0;const n=[];function D(y){const b=new u(y);return n[b.nid]=b,b}e.createProxyIdentifier=D;function T(y){return n[y].sid}e.getStringIdentifierForProxy=T;class C{constructor(b){this.value=b}}e.SerializableObjectWithBuffers=C}),define(Ie[5],ke([0,1,61,53]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var D;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(D=e.TextEditorRevealType||(e.TextEditorRevealType={}));var T;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput"})(T=e.TabInputKind||(e.TabInputKind={}));var C;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(C=e.TabModelOperationKind||(e.TabModelOperationKind={}));var y;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(y=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var b;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(b=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var I;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(I=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var k;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(k=e.CandidatePortSource||(e.CandidatePortSource={}));class _{static mixin(E){return E._id=_._n++,E}}e.IdObject=_,_._n=0;var P;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.command="m",f.kindModifier="n"})(P=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));function w(f){return f&&f.edits&&(0,u.revive)(f),f}e.reviveWorkspaceEditDto=w;var p;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(p=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,n.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,n.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,n.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,n.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,n.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,n.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,n.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,n.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,n.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,n.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,n.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,n.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,n.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,n.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,n.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,n.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,n.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,n.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,n.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,n.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,n.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,n.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,n.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,n.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,n.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,n.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,n.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,n.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,n.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,n.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,n.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,n.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,n.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,n.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,n.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,n.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,n.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,n.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,n.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,n.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,n.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,n.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,n.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,n.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,n.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,n.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,n.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,n.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,n.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,n.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,n.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,n.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,n.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,n.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,n.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,n.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,n.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,n.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,n.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,n.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,n.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,n.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,n.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,n.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,n.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,n.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,n.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,n.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,n.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,n.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,n.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,n.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,n.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,n.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,n.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,n.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,n.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,n.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,n.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,n.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,n.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,n.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,n.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,n.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,n.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,n.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,n.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,n.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,n.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,n.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,n.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,n.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,n.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,n.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,n.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,n.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,n.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,n.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,n.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,n.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,n.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,n.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,n.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,n.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,n.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,n.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,n.createProxyIdentifier)("ExtHostTelemetry")}}),define(Ie[90],ke([0,1,5,3,4]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(y){this._onDidChangePassword=new n.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=y.getProxy(u.MainContext.MainThreadSecretState)}async $onDidChangePassword(y){this._onDidChangePassword.fire(y)}get(y,b){return this._proxy.$getPassword(y,b)}store(y,b,I){return this._proxy.$setPassword(y,b,I)}delete(y,b){return this._proxy.$deletePassword(y,b)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")}),define(Ie[68],ke([0,1,4,14,5,17]),function(J,e,u,n,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,u.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(b,I){this._extHostLogService=I,this._reportedUsages=new Set,this._telemetryShape=b.getProxy(D.MainContext.MainThreadTelemetry)}report(b,I,R){const k=this.getUsageKey(b,I);this._reportedUsages.has(k)||(this._reportedUsages.add(k),I.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${b}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:b}))}getUsageKey(b,I){return`${b}-${I.identifier.value}`}};C=je([Ve(0,T.IExtHostRpcService),Ve(1,n.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(y,b,I){}})}),define(Ie[237],ke([0,1,3,5,7,28]),function(J,e,u,n,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(b){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new u.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=b.getProxy(n.MainContext.MainThreadAuthentication)}$setProviders(b){return this._providers=b,Promise.resolve()}async getSession(b,I,R,k={}){const _=T.ExtensionIdentifier.toKey(b.identifier),P=this._inFlightRequests.get(_)||[],v=[...R].sort().join(" ");let w=P.find(p=>p.providerId===I&&p.scopes===v);if(w)return w.result;{const p=this._getSession(b,_,I,R,k);w={providerId:I,scopes:v,result:p},P.push(w),this._inFlightRequests.set(_,P);try{await p}finally{const f=P.findIndex(E=>E.providerId===I&&E.scopes===v);f>-1&&(P.splice(f),this._inFlightRequests.set(_,P))}return p}}async _getSession(b,I,R,k,_={}){await this._proxy.$ensureProvider(R);const P=b.displayName||b.name;return this._proxy.$getSession(R,k,I,P,_)}async removeSession(b,I){const R=this._authenticationProviders.get(b);return R?R.provider.removeSession(I):this._proxy.$removeSession(b,I)}registerAuthenticationProvider(b,I,R,k){if(this._authenticationProviders.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this._authenticationProviders.set(b,{label:I,provider:R,options:k??{supportsMultipleAccounts:!1}}),this._providers.find(P=>P.id===b)||this._providers.push({id:b,label:I});const _=R.onDidChangeSessions(P=>{this._proxy.$sendDidChangeSessions(b,{added:P.added??[],changed:P.changed??[],removed:P.removed??[]})});return this._proxy.$registerAuthenticationProvider(b,I,k?.supportsMultipleAccounts??!1),new D.Disposable(()=>{_.dispose(),this._authenticationProviders.delete(b);const P=this._providers.findIndex(v=>v.id===b);P>-1&&this._providers.splice(P),this._proxy.$unregisterAuthenticationProvider(b)})}$createSession(b,I){const R=this._authenticationProviders.get(b);if(R)return Promise.resolve(R.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,I){const R=this._authenticationProviders.get(b);if(R)return Promise.resolve(R.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,I){const R=this._authenticationProviders.get(b);if(R)return Promise.resolve(R.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,I){return this._onDidChangeSessions.fire({provider:{id:b,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(Ie[238],ke([0,1,5,17,15,27]),function(J,e,u,n,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(b,I){this._proxy=b.getProxy(u.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:R=>I.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,I){const R=(0,T.isProposedApiEnabled)(I,"snippetWorkspaceEdit"),k=D.WorkspaceEdit.from(b,this._versionInformationProvider,R);return this._proxy.$tryApplyWorkspaceEdit(k)}};C=je([Ve(0,n.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(Ie[239],ke([0,1,5]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class n{constructor(T){const C=T.getProxy(u.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(y){return C.$writeText(y)}})}}e.ExtHostClipboard=n});var Ze=this&&this.__classPrivateFieldSet||function(J,e,u,n,D){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?D.call(J,u):D?D.value=u:e.set(J,u),u},Me=this&&this.__classPrivateFieldGet||function(J,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!n:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(J):n?n.value:e.get(J)};define(Ie[38],ke([0,1,11,7,15,24,5,16,14,61,35,48,2,6,4,17,132,23,53,49]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v,w,p,f,E,g){"use strict";var c,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let a=class{constructor(s,l){c.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,m.set(this,void 0),Ze(this,c,s.getProxy(C.MainContext.MainThreadCommands),"f"),this._logService=l,Ze(this,m,s.getProxy(C.MainContext.MainThreadTelemetry),"f"),this.converter=new d(this,h=>{const S=this._apiCommands.get(h);return S?.result===o.Void?S:void 0},l),this._argumentProcessors=[{processArgument(h){return(0,I.revive)(h)}},{processArgument(h){return(0,T.cloneAndChange)(h,function(S){if(R.Range.isIRange(S))return D.Range.to(S);if(k.Position.isIPosition(S))return D.Position.to(S);if(R.Range.isIRange(S.range)&&_.URI.isUri(S.uri))return D.location.to(S);if(S instanceof f.VSBuffer)return S.buffer.buffer;if(!Array.isArray(S))return S})}}]}registerArgumentProcessor(s){this._argumentProcessors.push(s)}registerApiCommand(s){const l=this.registerCommand(!1,s.id,async(...h)=>{const S=s.args.map((F,M)=>{if(!F.validate(h[M]))throw new Error(`Invalid argument '${F.name}' when running '${s.id}', received: ${h[M]}`);return F.convert(h[M])}),L=await this.executeCommand(s.internalId,...S);return s.result.convert(L,h,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this._apiCommands.set(s.id,s),new n.Disposable(()=>{l.dispose(),this._apiCommands.delete(s.id)})}registerCommand(s,l,h,S,L,F){if(this._logService.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this._commands.has(l))throw new Error(`command '${l}' already exists`);return this._commands.set(l,{callback:h,thisArg:S,description:L,extension:F}),s&&Me(this,c,"f").$registerCommand(l),new n.Disposable(()=>{this._commands.delete(l)&&s&&Me(this,c,"f").$unregisterCommand(l)})}executeCommand(s,...l){return this._logService.trace("ExtHostCommands#executeCommand",s),this._doExecuteCommand(s,l,!0)}async _doExecuteCommand(s,l,h){if(this._commands.has(s))return Me(this,c,"f").$fireCommandActivationEvent(s),this._executeContributedCommand(s,l,!1);{let S=!1;const L=(0,T.cloneAndChange)(l,function(F){if(F instanceof n.Position)return D.Position.from(F);if(F instanceof n.Range)return D.Range.from(F);if(F instanceof n.Location)return D.location.from(F);if(n.NotebookRange.isNotebookRange(F))return D.NotebookRange.from(F);if(F instanceof ArrayBuffer)return S=!0,f.VSBuffer.wrap(new Uint8Array(F));if(F instanceof Uint8Array)return S=!0,f.VSBuffer.wrap(F);if(F instanceof f.VSBuffer)return S=!0,F;if(!Array.isArray(F))return F});try{const F=await Me(this,c,"f").$executeCommand(s,S?new E.SerializableObjectWithBuffers(L):L,h);return(0,I.revive)(F)}catch(F){if(F instanceof Error&&F.message==="$executeCommand:retry")return this._doExecuteCommand(s,l,!1);throw F}}}async _executeContributedCommand(s,l,h){const S=this._commands.get(s);if(!S)throw new Error("Unknown command");this._reportTelemetry(S,s);const{callback:L,thisArg:F,description:M}=S;if(M)for(let A=0;A<M.args.length;A++)try{(0,u.validateConstraint)(l[A],M.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${M.args[A].name}' - ${M.args[A].description}`)}try{return await L.apply(F,l)}catch(A){if(s===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...l);B&&(s=B.command)}throw this._logService.error(A,s,S.extension?.identifier),h?new class extends Error{constructor(){super((0,g.toErrorMessage)(A));this.id=s,this.source=S.extension?.displayName??S.extension?.name}}:A}}_reportTelemetry(s,l){!s.extension||s.extension.isBuiltin||Me(this,m,"f").$publicLog2("Extension:ActionExecuted",{extensionId:s.extension.identifier.value,id:l})}$executeContributedCommand(s,...l){return this._logService.trace("ExtHostCommands#$executeContributedCommand",s),this._commands.has(s)?(l=l.map(h=>this._argumentProcessors.reduce((S,L)=>L.processArgument(S),h)),this._executeContributedCommand(s,l,!0)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this._logService.trace("ExtHostCommands#getCommands",s),Me(this,c,"f").$getCommands().then(l=>(s&&(l=l.filter(h=>h[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(const[l,h]of this._commands){const{description:S}=h;S&&(s[l]=S)}return Promise.resolve(s)}};c=new WeakMap,m=new WeakMap,a=je([Ve(0,w.IExtHostRpcService),Ve(1,b.ILogService)],a),e.ExtHostCommands=a,e.IExtHostCommands=(0,v.createDecorator)("IExtHostCommands");class d{constructor(s,l,h){this._commands=s,this._lookupApiCommand=l,this._logService=h,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(s,l){if(!s)return;const h={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return h;const S=this._lookupApiCommand(s.command);if(S)h.id=S.internalId,h.arguments=S.args.map((L,F)=>L.convert(s.arguments&&s.arguments[F]));else if((0,y.isNonEmptyArray)(s.arguments)){const L=++this._cachIdPool;this._cache.set(L,s),l.add((0,P.toDisposable)(()=>{this._cache.delete(L),this._logService.trace("CommandsConverter#DISPOSE",L)})),h.$ident=L,h.id=this.delegatingCommandId,h.arguments=[L],this._logService.trace("CommandsConverter#CREATE",s.command,L)}return h}fromInternal(s){return typeof s.$ident=="number"?this._cache.get(s.$ident):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this._cache.get(s[0])}_executeConvertedCommand(...s){const l=this.getActualCommand(...s);return this._logService.trace("CommandsConverter#EXECUTE",s[0],l?l.command:"MISSING"),l?this._commands.executeCommand(l.command,...l.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=d;class i{constructor(s,l,h,S){this.name=s,this.description=l,this.validate=h,this.convert=S}optional(){return new i(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,l){return new i(s??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=i,i.Uri=new i("uri","Uri of a text document",t=>_.URI.isUri(t),t=>t),i.Position=new i("position","A position in a text document",t=>n.Position.isPosition(t),D.Position.from),i.Range=new i("range","A range in a text document",t=>n.Range.isRange(t),D.Range.from),i.Selection=new i("selection","A selection in a text document",t=>n.Selection.isSelection(t),D.Selection.from),i.Number=new i("number","",t=>typeof t=="number",t=>t),i.String=new i("string","",t=>typeof t=="string",t=>t),i.CallHierarchyItem=new i("item","A call hierarchy item",t=>t instanceof n.CallHierarchyItem,D.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",t=>t instanceof n.TypeHierarchyItem,D.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",t=>t instanceof p.TestItemImpl,D.TestItem.from);class o{constructor(s,l){this.description=s,this.convert=l}}e.ApiCommandResult=o,o.Void=new o("no result",t=>t);class r{constructor(s,l,h,S,L){this.id=s,this.internalId=l,this.description=h,this.args=S,this.result=L}}e.ApiCommand=r}),define(Ie[240],ke([0,1,2,15,7,64,38,16,113,118,10]),function(J,e,u,n,D,T,C,y,b,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const k=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",P(n.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(w,p)=>{if((0,y.isFalsyOrEmpty)(w))return;class f extends D.SymbolInformation{static to(g){const c=new f(g.name,n.SymbolKind.to(g.kind),g.containerName||"",new D.Location(p[0],n.Range.to(g.range)));return c.detail=g.detail,c.range=c.location.range,c.selectionRange=n.Range.to(g.selectionRange),c.children=g.children?g.children.map(f.to):[],c}}return w.map(f.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",w=>!0,w=>w)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",P(n.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",w=>!0,w=>w)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",P(n.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",w=>typeof w=="string",w=>w),new C.ApiCommandArgument("options","Formatting options",w=>!0,w=>w)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",P(n.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",P(n.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",P(n.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",w=>Array.isArray(w)&&w.every(p=>D.Position.isPosition(p)),w=>w.map(n.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",w=>w.map(p=>{let f;for(const E of p.reverse())f=new D.SelectionRange(n.Range.to(E),f);return f}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",w=>w.map(n.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",w=>w.map(n.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",w=>w.map(n.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",w=>w.map(n.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",w=>{if(!!w)return{range:n.Range.to(w.range),placeholder:w.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",w=>{if(!!w){if(w.rejectReason)throw new Error(w.rejectReason);return n.WorkspaceEdit.to(w)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",w=>w.map(n.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",w=>{if(!!w)return new D.SemanticTokensLegend(w.tokenTypes,w.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",w=>{if(!w)return;const p=(0,b.decodeSemanticTokensDto)(w);if(p.type==="full")return new D.SemanticTokens(p.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",w=>{if(!!w)return new D.SemanticTokensLegend(w.tokenTypes,w.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",w=>{if(!w)return;const p=(0,b.decodeSemanticTokensDto)(w);if(p.type==="full")return new D.SemanticTokens(p.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(w,p,f)=>{if(!w)return new D.CompletionList([]);const E=w.suggestions.map(g=>n.CompletionItem.to(g,f));return new D.CompletionList(E,w.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",w=>{if(w)return n.SignatureHelp.to(w)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(w,p,f)=>P(E=>new D.CodeLens(n.Range.to(E.range),E.command&&f.fromInternal(E.command)))(w))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",w=>D.Range.isRange(w),w=>D.Selection.isSelection(w)?n.Selection.from(w):n.Range.from(w)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(w,p,f)=>P(E=>{if(E._isSynthetic){if(!E.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(E.command)}else{const g=new D.CodeAction(E.title,E.kind?new D.CodeActionKind(E.kind):void 0);return E.edit&&(g.edit=n.WorkspaceEdit.to(E.edit)),E.command&&(g.command=f.fromInternal(E.command)),g.isPreferred=E.isPreferred,g}})(w))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",w=>w?w.map(p=>new D.ColorInformation(n.Range.to(p.range),n.Color.to(p.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",w=>w instanceof D.Color,n.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",w=>!0,w=>({uri:w.uri,range:n.Range.from(w.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",w=>w?w.map(n.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(w,p,f)=>w.map(n.InlayHint.to.bind(void 0,f)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",P(w=>({viewType:w.viewType,displayName:w.displayName,options:{transientOutputs:w.options.transientOutputs,transientCellMetadata:w.options.transientCellMetadata,transientDocumentMetadata:w.options.transientDocumentMetadata},filenamePattern:w.filenamePattern.map(p=>n.NotebookExclusiveDocumentPattern.to(p))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",w=>w.map(n.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",w=>u.URI.isUri(w)||typeof w=="string"&&(0,I.matchesSomeScheme)(w,R.Schemas.http,R.Schemas.https),w=>w),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",w=>w===void 0||typeof w=="number"||typeof w=="object",w=>w&&(typeof w=="number"?[n.ViewColumn.from(w),void 0]:[n.ViewColumn.from(w.viewColumn),n.TextEditorOpenOptions.from(w)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",w=>w===void 0||typeof w=="number"||typeof w=="object",w=>w&&(typeof w=="number"?[n.ViewColumn.from(w),void 0]:[n.ViewColumn.from(w.viewColumn),n.TextEditorOpenOptions.from(w)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",w=>w===void 0||typeof w=="object",w=>w&&[n.ViewColumn.from(w.viewColumn),n.TextEditorOpenOptions.from(w)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",w=>w.map(n.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",w=>w.map(n.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",w=>w.map(n.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void),new C.ApiCommand("vscode.experimental.editSession.continue","_workbench.experimental.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[C.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],C.ApiCommandResult.Void)];class _{static register(p){k.forEach(p.registerApiCommand,p)}}e.ExtHostApiCommands=_;function P(w){return p=>{if(Array.isArray(p))return p.map(w)}}function v(w){if(!Array.isArray(w))return;const p=[];for(const f of w)T.isLocationLink(f)?p.push(n.DefinitionLink.to(f)):p.push(n.location.to(f));return p}}),define(Ie[241],ke([0,1,18,57,3,6,2,64,28,15,7,27,5]),function(J,e,u,n,D,T,C,y,b,I,R,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function P(v,w,p){const f=v.getProxy(_.MainContext.MainThreadComments);class E{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,w.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const s=this._commentControllers.get(t.handle);return s?s.value:t}else if(t&&t.$mid===7){const s=this._commentControllers.get(t.commentControlHandle);if(!s)return t;const l=s.getCommentThread(t.commentThreadHandle);return l?l.value:t}else if(t&&t.$mid===8){const s=this._commentControllers.get(t.thread.commentControlHandle);if(!s)return t;const l=s.getCommentThread(t.thread.commentThreadHandle);return l?{thread:l.value,text:t.text}:t}else if(t&&t.$mid===9){const s=this._commentControllers.get(t.thread.commentControlHandle);if(!s)return t;const l=s.getCommentThread(t.thread.commentThreadHandle);if(!l)return t;const h=t.commentUniqueId,S=l.getCommentByUniqueId(h);return S||t}else if(t&&t.$mid===10){const s=this._commentControllers.get(t.thread.commentControlHandle);if(!s)return t;const l=s.getCommentThread(t.thread.commentThreadHandle);if(!l)return t;const h=t.text,S=t.commentUniqueId,L=l.getCommentByUniqueId(S);return L?(L.body=h,L):t}return t}})}createCommentController(t,s,l){const h=E.handlePool++,S=new c(t,h,s,l);this._commentControllers.set(S.handle,S);const L=this._commentControllersByExtension.get(b.ExtensionIdentifier.toKey(t.identifier))||[];return L.push(S),this._commentControllersByExtension.set(b.ExtensionIdentifier.toKey(t.identifier),L),S.value}$createCommentThreadTemplate(t,s,l){const h=this._commentControllers.get(t);!h||h.$createCommentThreadTemplate(s,l)}async $updateCommentThreadTemplate(t,s,l){const h=this._commentControllers.get(t);!h||h.$updateCommentThreadTemplate(s,l)}$deleteCommentThread(t,s){this._commentControllers.get(t)?.$deleteCommentThread(s)}$provideCommentingRanges(t,s,l){const h=this._commentControllers.get(t);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const S=p.getDocument(C.URI.revive(s));return(0,u.asPromise)(()=>h.commentingRangeProvider.provideCommentingRanges(S,l)).then(L=>L?L.map(F=>I.Range.from(F)):void 0)}$toggleReaction(t,s,l,h,S){const L=this._commentControllers.get(t);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,u.asPromise)(()=>{const F=L.getCommentThread(s);if(F){const M=F.getCommentByUniqueId(h.uniqueIdInThread);if(L!==void 0&&M&&L.reactionHandler)return L.reactionHandler(M,d(S))}return Promise.resolve(void 0)})}dispose(){}}E.handlePool=0;class g{constructor(t,s,l,h,S,L,F,M){this._commentControllerHandle=s,this._id=l,this._uri=h,this._range=S,this._comments=L,this.extensionDescription=F,this._isTemplate=M,this.handle=g._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),f.$createCommentThread(s,this.handle,this._id,this._uri,I.Range.from(this._range),F.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this._localDisposables.push({dispose:()=>{f.$deleteCommentThread(s,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(B){A.range=B},get comments(){return A.comments},set comments(B){A.comments=B},get collapsibleState(){return A.collapsibleState},set collapsibleState(B){A.collapsibleState=B},get canReply(){return A.canReply},set canReply(B){A.canReply=B},get contextValue(){return A.contextValue},set contextValue(B){A.contextValue=B},get label(){return A.label},set label(B){A.label=B},get state(){return A.state},set state(B){A.state=B},dispose:()=>{A.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get state(){return(0,k.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(t){(0,k.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=t,this.modifications.state=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const t=l=>Object.prototype.hasOwnProperty.call(this.modifications,l),s={};t("range")&&(s.range=I.Range.from(this._range)),t("label")&&(s.label=this.label),t("contextValue")&&(s.contextValue=this.contextValue??null),t("comments")&&(s.comments=this._comments.map(l=>m(this,l,this._commentsMap))),t("collapsibleState")&&(s.collapseState=i(this._collapseState)),t("canReply")&&(s.canReply=this.canReply),t("state")&&(s.state=o(this._state)),t("isTemplate")&&(s.isTemplate=this._isTemplate),this.modifications={},f.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,s)}getCommentByUniqueId(t){for(const s of this._commentsMap){const l=s[0],h=s[1];if(t===h)return l}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}g._handlePool=0,je([(0,n.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null);class c{constructor(t,s,l,h){this._extension=t,this._handle=s,this._id=l,this._label=h,this._threads=new Map,f.$registerCommentController(this.handle,l,h);const S=this;this.value=Object.freeze({id:S.id,label:S.label,get options(){return S.options},set options(L){S.options=L},get commentingRangeProvider(){return S.commentingRangeProvider},set commentingRangeProvider(L){S.commentingRangeProvider=L},get reactionHandler(){return S.reactionHandler},set reactionHandler(L){S.reactionHandler=L},createCommentThread(L,F,M){return S.createCommentThread(L,F,M).value},dispose:()=>{S.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{f.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,f.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,f.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,f.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,s,l,h){if(typeof t=="string"){const S=new g(this.id,this.handle,t,s,l,h,this._extension,!1);return this._threads.set(S.handle,S),S}else{const S=new g(this.id,this.handle,void 0,t,s,l,this._extension,!1);return this._threads.set(S.handle,S),S}}$createCommentThreadTemplate(t,s){const l=new g(this.id,this.handle,void 0,C.URI.revive(t),I.Range.to(s),[],this._extension,!0);return l.collapsibleState=y.CommentThreadCollapsibleState.Expanded,this._threads.set(l.handle,l),l}$updateCommentThreadTemplate(t,s){const l=this._threads.get(t);l&&(l.range=I.Range.to(s))}$deleteCommentThread(t){const s=this._threads.get(t);s&&s.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function m(r,t,s){let l=s.get(t);l||(l=++r.commentHandle,s.set(t,l));const h=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:l,body:typeof t.body=="string"?t.body:I.MarkdownString.from(t.body),userName:t.author.name,userIconPath:h,label:t.label,commentReactions:t.reactions?t.reactions.map(S=>a(S)):void 0,timestamp:t.timestamp?.toJSON()}}function a(r){return{label:r.label,iconPath:r.iconPath?I.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function d(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?C.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function i(r){if(r!==void 0)switch(r){case R.CommentThreadCollapsibleState.Expanded:return y.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return y.CommentThreadCollapsibleState.Collapsed}return y.CommentThreadCollapsibleState.Collapsed}function o(r){if(r!==void 0)switch(r){case R.CommentThreadState.Unresolved:return y.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return y.CommentThreadState.Resolved}return y.CommentThreadState.Unresolved}return new E}e.createExtHostComments=P}),define(Ie[242],ke([0,1,24,5,26,17]),function(J,e,u,n,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let C=class{constructor(R,k){this._mainThreadConsole=R.getProxy(n.MainContext.MainThreadConsole),this._includeStack=k.consoleForward.includeStack,this._logNative=k.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,k){const _=this,P=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){_._handleConsoleCall(R,k,P,arguments)}})}_handleConsoleCall(R,k,_,P){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:k,arguments:b(P,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,_,P)}};C=je([Ve(0,T.IExtHostRpcService),Ve(1,D.IExtHostInitDataService)],C),e.AbstractExtHostConsoleForwarder=C;const y=1e5;function b(I,R){const k=[];if(I.length)for(let _=0;_<I.length;_++){let P=I[_];if(typeof P=="undefined")P="undefined";else if(P instanceof Error){const v=P;v.stack?P=v.stack:P=v.toString()}k.push(P)}if(R){const _=new Error().stack;_&&k.push({__$stack:_.split(`
`).slice(3).join(`
`)})}try{const _=(0,u.safeStringify)(k);return _.length>y?"Output omitted for a large object that exceeds the limits":_}catch(_){return`Output omitted for an object that cannot be inspected ('${_.toString()}')`}}}),define(Ie[135],ke([0,1,2,5,7,4,17,14,16,8,9]),function(J,e,u,n,D,T,C,y,b,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class kn{constructor(P,v){this._logService=v,this._provider=new Map,this._proxy=P.getProxy(n.MainContext.MainThreadDecorations)}registerFileDecorationProvider(P,v){const w=kn._handlePool++;this._provider.set(w,{provider:P,extensionId:v}),this._proxy.$registerDecorationProvider(w,v.value);const p=P.onDidChangeFileDecorations&&P.onDidChangeFileDecorations(f=>{if(!f){this._proxy.$onDidChange(w,null);return}const E=(0,b.asArray)(f);if(E.length<=kn._maxEventSize){this._proxy.$onDidChange(w,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",v.value,E.length);const g=E.map(a=>({uri:a,rank:(0,I.count)(a.path,"/")})),c=(0,b.groupBy)(g,(a,d)=>a.rank-d.rank||(0,I.compare)(a.uri.path,d.uri.path)),m=[];e:for(const a of c){let d;for(const i of a){const o=(0,R.dirname)(i.uri.path);if(d!==o&&(d=o,m.push(i.uri)>=kn._maxEventSize))break e}}this._proxy.$onDidChange(w,m)});return new D.Disposable(()=>{p?.dispose(),this._proxy.$unregisterDecorationProvider(w),this._provider.delete(w)})}async $provideDecorations(P,v,w){if(!this._provider.has(P))return Object.create(null);const p=Object.create(null),{provider:f,extensionId:E}=this._provider.get(P);return await Promise.all(v.map(async g=>{try{const{uri:c,id:m}=g,a=await Promise.resolve(f.provideFileDecoration(u.URI.revive(c),w));if(!a)return;try{D.FileDecoration.validate(a),p[m]=[a.propagate,a.tooltip,a.badge,a.color]}catch(d){this._logService.warn(`INVALID decoration from extension '${E.value}': ${d}`)}}catch(c){this._logService.error(c)}})),p}};k._handlePool=0,k._maxEventSize=250,k=je([Ve(0,C.IExtHostRpcService),Ve(1,y.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(J,e,u,n,D){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?D.call(J,u):D?D.value=u:e.set(J,u),u},Me=this&&this.__classPrivateFieldGet||function(J,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!n:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(J):n?n.value:e.get(J)};define(Ie[243],ke([0,1,170,117,2,5,7,15,3,14,25,46]),function(J,e,u,n,D,T,C,y,b,I,R,k){"use strict";var _,P,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class w{constructor(E,g,c,m,a,d){this._name=E,this._owner=g,this._maxDiagnosticsPerFile=c,_.set(this,void 0),P.set(this,void 0),v.set(this,void 0),this._isDisposed=!1,Ze(this,v,new R.ResourceMap(i=>m.getComparisonKey(i)),"f"),Ze(this,_,a,"f"),Ze(this,P,d,"f")}dispose(){this._isDisposed||(Me(this,P,"f").fire([...Me(this,v,"f").keys()]),Me(this,_,"f")?.$clear(this._owner),Me(this,v,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(E,g){if(!E){this.clear();return}this._checkDisposed();let c=[];if(D.URI.isUri(E)){if(!g){this.delete(E);return}Me(this,v,"f").set(E,g.slice()),c=[E]}else if(Array.isArray(E)){c=[];let a;E=[...E].sort(w._compareIndexedTuplesByUri);for(const d of E){const[i,o]=d;if((!a||i.toString()!==a.toString())&&(a&&Me(this,v,"f").get(a).length===0&&Me(this,v,"f").delete(a),a=i,c.push(i),Me(this,v,"f").set(i,[])),o)Me(this,v,"f").get(i)?.push(...o);else{const r=Me(this,v,"f").get(i);r&&(r.length=0)}}}if(Me(this,P,"f").fire(c),!Me(this,_,"f"))return;const m=[];for(const a of c){let d=[];const i=Me(this,v,"f").get(a);if(i)if(i.length>this._maxDiagnosticsPerFile){d=[];const o=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(const t of i)if(t.severity===o[r]&&d.push(y.Diagnostic.from(t))===this._maxDiagnosticsPerFile)break e;d.push({severity:n.MarkerSeverity.Info,message:(0,u.localize)(0,null,i.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=i.map(o=>y.Diagnostic.from(o));m.push([a,d])}Me(this,_,"f").$changeMany(this._owner,m)}delete(E){this._checkDisposed(),Me(this,P,"f").fire([E]),Me(this,v,"f").delete(E),Me(this,_,"f")?.$changeMany(this._owner,[[E,void 0]])}clear(){this._checkDisposed(),Me(this,P,"f").fire([...Me(this,v,"f").keys()]),Me(this,v,"f").clear(),Me(this,_,"f")?.$clear(this._owner)}forEach(E,g){this._checkDisposed();for(const[c,m]of this)E.call(g,c,m,this)}*[(_=new WeakMap,P=new WeakMap,v=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const E of Me(this,v,"f").keys())yield[E,this.get(E)]}get(E){this._checkDisposed();const g=Me(this,v,"f").get(E);return Array.isArray(g)?Object.freeze(g.slice(0)):[]}has(E){return this._checkDisposed(),Array.isArray(Me(this,v,"f").get(E))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(E,g){return E[0].toString()<g[0].toString()?-1:E[0].toString()>g[0].toString()?1:0}}e.DiagnosticCollection=w;let p=class hn{constructor(E,g,c){this._logService=g,this._fileSystemInfoService=c,this._collections=new Map,this._onDidChangeDiagnostics=new b.DebounceEmitter({merge:m=>m.flat(),delay:50}),this.onDidChangeDiagnostics=b.Event.map(this._onDidChangeDiagnostics.event,hn._mapper),this._proxy=E.getProxy(T.MainContext.MainThreadDiagnostics)}static _mapper(E){const g=new R.ResourceMap;for(const c of E)g.set(c,c);return{uris:Object.freeze(Array.from(g.values()))}}createDiagnosticCollection(E,g){const{_collections:c,_proxy:m,_onDidChangeDiagnostics:a,_logService:d,_fileSystemInfoService:i}=this,o=new class{$changeMany(s,l){m.$changeMany(s,l),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",E.value,s,l.length===0?"CLEARING":l)}$clear(s){m.$clear(s),d.trace("[DiagnosticCollection] remove all (extension, owner)",E.value,s)}dispose(){m.dispose()}};let r;if(!g)g="_generated_diagnostic_collection_name_#"+hn._idPool++,r=g;else if(!c.has(g))r=g;else{this._logService.warn(`DiagnosticCollection with name '${g}' does already exist.`);do r=g+hn._idPool++;while(c.has(r))}return new class extends w{constructor(){super(g,r,hn._maxDiagnosticsPerFile,i.extUri,o,a);c.set(r,this)}dispose(){super.dispose(),c.delete(r)}}}getDiagnostics(E){if(E)return this._getDiagnostics(E);{const g=new Map,c=[];for(const m of this._collections.values())m.forEach((a,d)=>{let i=g.get(a.toString());typeof i=="undefined"&&(i=c.length,g.set(a.toString(),i),c.push([a,[]])),c[i][1]=c[i][1].concat(...d)});return c}}_getDiagnostics(E){let g=[];for(const c of this._collections.values())c.has(E)&&(g=g.concat(c.get(E)));return g}$acceptMarkersChange(E){if(!this._mirrorCollection){const g="_generated_mirror",c=new w(g,g,hn._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(g,c),this._mirrorCollection=c}for(const[g,c]of E)this._mirrorCollection.set(D.URI.revive(g),c.map(y.Diagnostic.to))}};p._idPool=0,p._maxDiagnosticsPerFile=1e3,p=je([Ve(1,I.ILogService),Ve(2,k.IExtHostFileSystemInfo)],p),e.ExtHostDiagnostics=p}),define(Ie[244],ke([0,1,2,5]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(C){this._proxy=C.getProxy(n.MainContext.MainThreadDialogs)}showOpenDialog(C){return this._proxy.$showOpenDialog(C).then(y=>y?y.map(b=>u.URI.revive(b)):void 0)}showSaveDialog(C){return this._proxy.$showSaveDialog(C).then(y=>y?u.URI.revive(y):void 0)}}e.ExtHostDialogs=D}),define(Ie[245],ke([0,1,12,2,7,5,10,21,8]),function(J,e,u,n,D,T,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(k,_,P){this._documentsAndEditors=_,this._logService=P,this._documentContentProviders=new Map,this._proxy=k.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,_){if(Object.keys(C.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const P=I._handlePool++;this._documentContentProviders.set(P,_),this._proxy.$registerTextContentProvider(P,k);let v;return typeof _.onDidChange=="function"&&(v=_.onDidChange(w=>{if(w.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(w)&&this.$provideTextDocumentContent(P,w).then(p=>{if(!p&&typeof p!="string")return;const f=this._documentsAndEditors.getDocument(w);if(!f)return;const E=(0,b.splitLines)(p);if(!f.equalLines(E))return this._proxy.$onVirtualDocumentChange(w,p)},u.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(P)&&this._proxy.$unregisterTextContentProvider(P),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(k,_){const P=this._documentContentProviders.get(k);return P?Promise.resolve(P.provideTextDocumentContent(n.URI.revive(_),y.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${_.scheme}`))}}e.ExtHostDocumentContentProvider=I,I._handlePool=0}),define(Ie[246],ke([0,1,3,6,2,5,126,15,11,24,7]),function(J,e,u,n,D,T,C,y,b,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(P,v){this._onDidAddDocument=new u.Emitter,this._onDidRemoveDocument=new u.Emitter,this._onDidChangeDocument=new u.Emitter,this._onDidSaveDocument=new u.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new n.DisposableStore,this._documentLoader=new Map,this._proxy=P.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=v,this._documentsAndEditors.onDidRemoveDocuments(w=>{for(const p of w)this._onDidRemoveDocument.fire(p.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(w=>{for(const p of w)this._onDidAddDocument.fire(p.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(P){if(!P)return;const v=this._documentsAndEditors.getDocument(P);if(v)return v}getDocument(P){const v=this.getDocumentData(P);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${P}'`);return v.document}ensureDocumentData(P){const v=this._documentsAndEditors.getDocument(P);if(v)return Promise.resolve(v);let w=this._documentLoader.get(P.toString());return w||(w=this._proxy.$tryOpenDocument(P).then(p=>{this._documentLoader.delete(P.toString());const f=D.URI.revive(p);return(0,b.assertIsDefined)(this._documentsAndEditors.getDocument(f))},p=>(this._documentLoader.delete(P.toString()),Promise.reject(p))),this._documentLoader.set(P.toString(),w)),w}createDocumentData(P){return this._proxy.$tryCreateDocument(P).then(v=>D.URI.revive(v))}$acceptModelLanguageChanged(P,v){const w=D.URI.revive(P),p=this._documentsAndEditors.getDocument(w);if(!p)throw new Error("unknown document");this._onDidRemoveDocument.fire(p.document),p._acceptLanguageId(v),this._onDidAddDocument.fire(p.document)}$acceptModelSaved(P){const v=D.URI.revive(P),w=this._documentsAndEditors.getDocument(v);if(!w)throw new Error("unknown document");this.$acceptDirtyStateChanged(P,!1),this._onDidSaveDocument.fire(w.document)}$acceptDirtyStateChanged(P,v){const w=D.URI.revive(P),p=this._documentsAndEditors.getDocument(w);if(!p)throw new Error("unknown document");p._acceptIsDirty(v),this._onDidChangeDocument.fire({document:p.document,contentChanges:[],reason:void 0})}$acceptModelChanged(P,v,w){const p=D.URI.revive(P),f=this._documentsAndEditors.getDocument(p);if(!f)throw new Error("unknown document");f._acceptIsDirty(w),f.onEvents(v);let E;v.isUndoing?E=R.TextDocumentChangeReason.Undo:v.isRedoing&&(E=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,I.deepFreeze)({document:f.document,contentChanges:v.changes.map(g=>({range:y.Range.to(g.range),rangeOffset:g.rangeOffset,rangeLength:g.rangeLength,text:g.text})),reason:E}))}setWordDefinitionFor(P,v){(0,C.setWordDefinitionFor)(P,v)}}e.ExtHostDocuments=k}),define(Ie[54],ke([0,1,56,3,6,2,4,5,126,17,133,15,14,25,10,59,79]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class f{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(c,m){this._extHostRpc=c,this._logService=m,this._activeEditorId=null,this._editors=new Map,this._documents=new P.ResourceMap,this._onDidAddDocuments=new n.Emitter,this._onDidRemoveDocuments=new n.Emitter,this._onDidChangeVisibleTextEditors=new n.Emitter,this._onDidChangeActiveTextEditor=new n.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const m=[],a=[],d=[];if(c.removedDocuments)for(const i of c.removedDocuments){const o=T.URI.revive(i),r=this._documents.get(o);r?.unref()&&(this._documents.delete(o),m.push(r.value))}if(c.addedDocuments)for(const i of c.addedDocuments){const o=T.URI.revive(i.uri);let r=this._documents.get(o);if(r&&o.scheme!==v.Schemas.vscodeNotebookCell&&o.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);r||(r=new f(new b.ExtHostDocumentData(this._extHostRpc.getProxy(y.MainContext.MainThreadDocuments),o,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this._documents.set(o,r),a.push(r.value)),r.ref()}if(c.removedEditors)for(const i of c.removedEditors){const o=this._editors.get(i);this._editors.delete(i),o&&d.push(o)}if(c.addedEditors)for(const i of c.addedEditors){const o=T.URI.revive(i.documentUri);u.ok(this._documents.has(o),`document '${o}' does not exist`),u.ok(!this._editors.has(i.id),`editor '${i.id}' already exists!`);const r=this._documents.get(o).value,t=new R.ExtHostTextEditor(i.id,this._extHostRpc.getProxy(y.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>r.document),i.selections.map(k.Selection.to),i.options,i.visibleRanges.map(s=>k.Range.to(s)),typeof i.editorPosition=="number"?k.ViewColumn.to(i.editorPosition):void 0);this._editors.set(i.id,t)}c.newActiveEditor!==void 0&&(u.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,D.dispose)(m),(0,D.dispose)(d),c.removedDocuments&&this._onDidRemoveDocuments.fire(m),c.addedDocuments&&this._onDidAddDocuments.fire(a),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(i=>i.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){return this._documents.get(c)?.value}allDocuments(){return w.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!this._activeEditorId)return;const m=this._editors.get(this._activeEditorId);return c?m:m?.value}allEditors(){return[...this._editors.values()]}};E=je([Ve(0,I.IExtHostRpcService),Ve(1,_.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ie[55],ke([0,1,15,5,2,3,4,7,17,11,78]),function(J,e,u,n,D,T,C,y,b,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class k{constructor(p,f,E){this._activeTabIdGetter=E,this._parentGroup=f,this.acceptDtoUpdate(p)}get apiObject(){if(!this._apiObject){const p=this,f={get isActive(){return p._dto.id===p._activeTabIdGetter()},get label(){return p._dto.label},get input(){return p._input},get isDirty(){return p._dto.isDirty},get isPinned(){return p._dto.isPinned},get isPreview(){return p._dto.isPreview},get group(){return p._parentGroup.apiObject}};this._apiObject=Object.freeze(f)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(p){this._dto=p,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new y.TextTabInput(D.URI.revive(this._dto.input.uri));case 2:return new y.TextDiffTabInput(D.URI.revive(this._dto.input.original),D.URI.revive(this._dto.input.modified));case 3:return new y.TextMergeTabInput(D.URI.revive(this._dto.input.base),D.URI.revive(this._dto.input.input1),D.URI.revive(this._dto.input.input2),D.URI.revive(this._dto.input.result));case 6:return new y.CustomEditorTabInput(D.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new y.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new y.NotebookEditorTabInput(D.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new y.NotebookDiffEditorTabInput(D.URI.revive(this._dto.input.original),D.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new y.TerminalEditorTabInput;case 9:return new y.InteractiveWindowInput(D.URI.revive(this._dto.input.uri),D.URI.revive(this._dto.input.inputBoxUri));default:return}}}class _{constructor(p,f){this._tabs=[],this._activeTabId="",this._dto=p,this._activeGroupIdGetter=f;for(const E of p.tabs)E.isActive&&(this._activeTabId=E.id),this._tabs.push(new k(E,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const p=this,f={get isActive(){return p._dto.groupId===p._activeGroupIdGetter()},get viewColumn(){return u.ViewColumn.to(p._dto.viewColumn)},get activeTab(){return p._tabs.find(E=>E.tabId===p._activeTabId)?.apiObject},get tabs(){return Object.freeze(p._tabs.map(E=>E.apiObject))}};this._apiObject=Object.freeze(f)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(p){this._dto=p}acceptTabOperation(p){if(p.kind===0){const E=new k(p.tabDto,this,()=>this.activeTabId());return this._tabs.splice(p.index,0,E),p.tabDto.isActive&&(this._activeTabId=E.tabId),E}else if(p.kind===1){const E=this._tabs.splice(p.index,1)[0];if(!E)throw new Error(`Tab close updated received for index ${p.index} which does not exist`);return E.tabId===this._activeTabId&&(this._activeTabId=""),E}else if(p.kind===3){if(p.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const E=this._tabs.splice(p.oldIndex,1)[0];if(!E)throw new Error(`Tab move updated received for index ${p.oldIndex} which does not exist`);return this._tabs.splice(p.index,0,E),E}const f=this._tabs.find(E=>E.tabId===p.tabDto.id);if(!f)throw new Error("INVALID tab");return p.tabDto.isActive?this._activeTabId=p.tabDto.id:this._activeTabId===p.tabDto.id&&!p.tabDto.isActive&&(this._activeTabId=""),f.acceptDtoUpdate(p.tabDto),f}activeTabId(){return this._activeTabId}}let P=class{constructor(p){this._onDidChangeTabs=new T.Emitter,this._onDidChangeTabGroups=new T.Emitter,this._extHostTabGroups=[],this._proxy=p.getProxy(n.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const p=this,f={onDidChangeTabGroups:p._onDidChangeTabGroups.event,onDidChangeTabs:p._onDidChangeTabs.event,get all(){return Object.freeze(p._extHostTabGroups.map(E=>E.apiObject))},get activeTabGroup(){const E=p._activeGroupId;return(0,I.assertIsDefined)(p._extHostTabGroups.find(c=>c.groupId===E)?.apiObject)},close:async(E,g)=>{const c=Array.isArray(E)?E:[E];return c.length?v(c[0])?this._closeGroups(c,g):this._closeTabs(c,g):!0}};this._apiObject=Object.freeze(f)}return this._apiObject}$acceptEditorTabModel(p){const f=new Set(this._extHostTabGroups.map(i=>i.groupId)),E=new Set(p.map(i=>i.groupId)),g=(0,R.diffSets)(f,E),c=this._extHostTabGroups.filter(i=>g.removed.includes(i.groupId)).map(i=>i.apiObject),m=[],a=[];this._extHostTabGroups=p.map(i=>{const o=new _(i,()=>this._activeGroupId);return g.added.includes(o.groupId)?m.push(o.apiObject):a.push(o.apiObject),o});const d=(0,I.assertIsDefined)(p.find(i=>i.isActive===!0)?.groupId);d!==void 0&&this._activeGroupId!==d&&(this._activeGroupId=d),this._onDidChangeTabGroups.fire(Object.freeze({opened:m,closed:c,changed:a}))}$acceptTabGroupUpdate(p){const f=this._extHostTabGroups.find(E=>E.groupId===p.groupId);if(!f)throw new Error("Update Group IPC call received before group creation.");f.acceptGroupDtoUpdate(p),p.isActive&&(this._activeGroupId=p.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[f.apiObject],opened:[],closed:[]}))}$acceptTabOperation(p){const f=this._extHostTabGroups.find(g=>g.groupId===p.groupId);if(!f)throw new Error("Update Tabs IPC call received before group creation.");const E=f.acceptTabOperation(p);switch(p.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[E.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[E.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[E.apiObject]}));return}}_findExtHostTabFromApi(p){for(const f of this._extHostTabGroups)for(const E of f.tabs)if(E.apiObject===p)return E}_findExtHostTabGroupFromApi(p){return this._extHostTabGroups.find(f=>f.apiObject===p)}async _closeTabs(p,f){const E=[];for(const g of p){const c=this._findExtHostTabFromApi(g);if(!c)throw new Error("Tab close: Invalid tab not found!");E.push(c.tabId)}return this._proxy.$closeTab(E,f)}async _closeGroups(p,f){const E=[];for(const g of p){const c=this._findExtHostTabGroupFromApi(g);if(!c)throw new Error("Group close: Invalid group not found!");E.push(c.groupId)}return this._proxy.$closeGroup(E,f)}};P=je([Ve(0,b.IExtHostRpcService)],P),e.ExtHostEditorTabs=P;function v(w){return w.tabs!==void 0}}),define(Ie[247],ke([0,1,2,5,6,7,15,149,8,23,27]),function(J,e,u,n,D,T,C,y,b,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class k{constructor(){this._schemes=[]}add(v){this._stateMachine=void 0,this._schemes.push(v)}delete(v){const w=this._schemes.indexOf(v);w>=0&&(this._schemes.splice(w,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const v=this._schemes.sort(),w=[];let p,f,E=14,g=14;for(const c of v){let m=p?(0,b.commonPrefixLength)(p,c):0;for(m===0?f=1:f=g;m<c.length;m++)m+1===c.length?(E=g,g=9):g+=1,w.push([f,c.toUpperCase().charCodeAt(m),g]),w.push([f,c.toLowerCase().charCodeAt(m),g]),f=g;p=c,g=E}w.push([9,58,10]),w.push([10,47,12]),this._stateMachine=new y.StateMachine(w)}}provideDocumentLinks(v){this._initStateMachine();const w=[],p=y.LinkComputer.computeLinks({getLineContent(f){return v.lineAt(f-1).text},getLineCount(){return v.lineCount}},this._stateMachine);for(const f of p){const E=C.DocumentLink.to(f);E.target&&w.push(E)}return w}}class _{constructor(v,w){this._extHostLanguageFeatures=w,this._linkProvider=new k,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=v.getProxy(n.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(v,w,p,f={}){if(this._registeredSchemes.has(w))throw new Error(`a provider for the scheme '${w}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(v,"*",this._linkProvider));const E=this._handlePool++;this._linkProvider.add(w),this._registeredSchemes.add(w),this._fsProvider.set(E,p);let g=2;f.isCaseSensitive&&(g+=1024),f.isReadonly&&(g+=2048),typeof p.copy=="function"&&(g+=8),typeof p.open=="function"&&typeof p.close=="function"&&typeof p.read=="function"&&typeof p.write=="function"&&((0,R.checkProposedApiEnabled)(v,"fsChunks"),g+=4),this._proxy.$registerFileSystemProvider(E,w,g).catch(m=>{console.error(`FAILED to register filesystem provider of ${v.identifier.value}-extension for the scheme ${w}`),console.error(m)});const c=p.onDidChangeFile(m=>{const a=[];for(const d of m){const{uri:i,type:o}=d;if(i.scheme!==w)continue;let r;switch(o){case T.FileChangeType.Changed:r=0;break;case T.FileChangeType.Created:r=1;break;case T.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:i,type:r})}this._proxy.$onFileSystemChange(E,a)});return(0,D.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(w),this._registeredSchemes.delete(w),this._fsProvider.delete(E),this._proxy.$unregisterProvider(E)})}static _asIStat(v){const{type:w,ctime:p,mtime:f,size:E,permissions:g}=v;return{type:w,ctime:p,mtime:f,size:E,permissions:g}}$stat(v,w){return Promise.resolve(this._getFsProvider(v).stat(u.URI.revive(w))).then(p=>_._asIStat(p))}$readdir(v,w){return Promise.resolve(this._getFsProvider(v).readDirectory(u.URI.revive(w)))}$readFile(v,w){return Promise.resolve(this._getFsProvider(v).readFile(u.URI.revive(w))).then(p=>I.VSBuffer.wrap(p))}$writeFile(v,w,p,f){return Promise.resolve(this._getFsProvider(v).writeFile(u.URI.revive(w),p.buffer,f))}$delete(v,w,p){return Promise.resolve(this._getFsProvider(v).delete(u.URI.revive(w),p))}$rename(v,w,p,f){return Promise.resolve(this._getFsProvider(v).rename(u.URI.revive(w),u.URI.revive(p),f))}$copy(v,w,p,f){const E=this._getFsProvider(v);if(!E.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(E.copy(u.URI.revive(w),u.URI.revive(p),f))}$mkdir(v,w){return Promise.resolve(this._getFsProvider(v).createDirectory(u.URI.revive(w)))}$watch(v,w,p,f){const E=this._getFsProvider(v).watch(u.URI.revive(p),f);this._watches.set(w,E)}$unwatch(v,w){const p=this._watches.get(w);p&&(p.dispose(),this._watches.delete(w))}$open(v,w,p){const f=this._getFsProvider(v);if(!f.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(f.open(u.URI.revive(w),p))}$close(v,w){const p=this._getFsProvider(v);if(!p.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(p.close(w))}$read(v,w,p,f){const E=this._getFsProvider(v);if(!E.read)throw new Error('FileSystemProvider does not implement "read"');const g=I.VSBuffer.alloc(f);return Promise.resolve(E.read(w,p,g.buffer,0,f)).then(c=>g.slice(0,c))}$write(v,w,p,f){const E=this._getFsProvider(v);if(!E.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(E.write(w,p,f.buffer,0,f.byteLength))}_getFsProvider(v){const w=this._fsProvider.get(v);if(!w){const p=new Error;throw p.name="ENOPRO",p.message="no provider",p}return w}}e.ExtHostFileSystem=_}),define(Ie[69],ke([0,1,5,43,7,23,4,17,46,6]),function(J,e,u,n,D,T,C,y,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Zt{constructor(_,P){this._fileSystemProvider=new Map,this._proxy=_.getProxy(u.MainContext.MainThreadFileSystem);const v=this;this.value=Object.freeze({async stat(w){try{const p=v._fileSystemProvider.get(w.scheme);if(!p)return await v._proxy.$stat(w);await v._proxy.$ensureActivation(w.scheme);const f=await p.stat(w);return{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions}}catch(p){Zt._handleError(p)}},async readDirectory(w){try{const p=v._fileSystemProvider.get(w.scheme);return p?(await v._proxy.$ensureActivation(w.scheme),(await p.readDirectory(w)).slice()):await v._proxy.$readdir(w)}catch(p){return Zt._handleError(p)}},async createDirectory(w){try{return await v._proxy.$mkdir(w)}catch(p){return Zt._handleError(p)}},async readFile(w){try{const p=v._fileSystemProvider.get(w.scheme);return p?(await v._proxy.$ensureActivation(w.scheme),(await p.readFile(w)).slice()):(await v._proxy.$readFile(w)).buffer}catch(p){return Zt._handleError(p)}},async writeFile(w,p){try{return await v._proxy.$writeFile(w,T.VSBuffer.wrap(p))}catch(f){return Zt._handleError(f)}},async delete(w,p){try{const f=v._fileSystemProvider.get(w.scheme);return f?(await v._proxy.$ensureActivation(w.scheme),await f.delete(w,{recursive:!1,...p})):await v._proxy.$delete(w,{recursive:!1,useTrash:!1,...p})}catch(f){return Zt._handleError(f)}},async rename(w,p,f){try{return await v._proxy.$rename(w,p,{overwrite:!1,...f})}catch(E){return Zt._handleError(E)}},async copy(w,p,f){try{return await v._proxy.$copy(w,p,{overwrite:!1,...f})}catch(E){return Zt._handleError(E)}},isWritableFileSystem(w){const p=P.getCapabilities(w);if(typeof p=="number")return!(p&2048)}})}static _handleError(_){if(_ instanceof D.FileSystemError)throw _;if(!(_ instanceof Error))throw new D.FileSystemError(String(_));if(_.name==="ENOPRO")throw D.FileSystemError.Unavailable(_.message);switch(_.name){case n.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(_.message);case n.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(_.message);case n.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(_.message);case n.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(_.message);case n.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(_.message);case n.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(_.message);default:throw new D.FileSystemError(_.message,_.name)}}addFileSystemProvider(_,P){return this._fileSystemProvider.set(_,P),(0,I.toDisposable)(()=>this._fileSystemProvider.delete(_))}};R=je([Ve(0,y.IExtHostRpcService),Ve(1,b.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(Ie[248],ke([0,1,3,37,2,5,15,7,27]),function(J,e,u,n,D,T,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class I{constructor(_,P,v,w,p,f,E,g){this._onDidCreate=new u.Emitter,this._onDidChange=new u.Emitter,this._onDidDelete=new u.Emitter;const c=this.ensureWatching(_,v,p);this._config=0,f&&(this._config+=1),E&&(this._config+=2),g&&(this._config+=4);const m=(0,n.parse)(p),a=typeof p=="string",d=w(i=>{if(!f)for(const o of i.created){const r=D.URI.revive(o);m(r.fsPath)&&(!a||P.getWorkspaceFolder(r))&&this._onDidCreate.fire(r)}if(!E)for(const o of i.changed){const r=D.URI.revive(o);m(r.fsPath)&&(!a||P.getWorkspaceFolder(r))&&this._onDidChange.fire(r)}if(!g)for(const o of i.deleted){const r=D.URI.revive(o);m(r.fsPath)&&(!a||P.getWorkspaceFolder(r))&&this._onDidDelete.fire(r)}});this._disposable=y.Disposable.from(c,this._onDidCreate,this._onDidChange,this._onDidDelete,d)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(_,P,v){const w=y.Disposable.from();if(typeof v=="string")return w;const p=_.getProxy(T.MainContext.MainThreadFileSystem);let f=!1;(v.pattern.includes(n.GLOBSTAR)||v.pattern.includes(n.GLOB_SPLIT))&&(f=!0);const E=Math.random();return p.$watch(P.identifier.value,E,v.baseUri,{recursive:f,excludes:[]}),y.Disposable.from({dispose:()=>p.$unwatch(E)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class R{constructor(_,P,v){this._mainContext=_,this._logService=P,this._extHostDocumentsAndEditors=v,this._onFileSystemEvent=new u.Emitter,this._onDidRenameFile=new u.Emitter,this._onDidCreateFile=new u.Emitter,this._onDidDeleteFile=new u.Emitter,this._onWillRenameFile=new u.AsyncEmitter,this._onWillCreateFile=new u.AsyncEmitter,this._onWillDeleteFile=new u.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(_,P,v,w,p,f){return new I(this._mainContext,_,P,this._onFileSystemEvent.event,C.GlobPattern.from(v),w,p,f)}$onFileEvent(_){this._onFileSystemEvent.fire(_)}$onDidRunFileOperation(_,P){switch(_){case 2:this._onDidRenameFile.fire(Object.freeze({files:P.map(v=>({oldUri:D.URI.revive(v.source),newUri:D.URI.revive(v.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:P.map(v=>D.URI.revive(v.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:P.map(v=>D.URI.revive(v.target))}));break;default:}}getOnWillRenameFileEvent(_){return this._createWillExecuteEvent(_,this._onWillRenameFile)}getOnWillCreateFileEvent(_){return this._createWillExecuteEvent(_,this._onWillCreateFile)}getOnWillDeleteFileEvent(_){return this._createWillExecuteEvent(_,this._onWillDeleteFile)}_createWillExecuteEvent(_,P){return(v,w,p)=>{const f=function(g){v.call(w,g)};return f.extension=_,P.event(f,void 0,p)}}async $onWillRunFileOperation(_,P,v,w){switch(_){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:P.map(p=>({oldUri:D.URI.revive(p.source),newUri:D.URI.revive(p.target)}))},v,w);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:P.map(p=>D.URI.revive(p.target))},v,w);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:P.map(p=>D.URI.revive(p.target))},v,w)}}async _fireWillEvent(_,P,v,w){const p=new Set,f=[];if(await _.fireAsync(P,w,async(g,c)=>{const m=Date.now(),a=await Promise.resolve(g);a instanceof y.WorkspaceEdit&&(f.push([c.extension,a]),p.add(c.extension.displayName??c.extension.identifier.value)),Date.now()-m>v&&this._logService.warn("SLOW file-participant",c.extension.identifier)}),w.isCancellationRequested||f.length===0)return;const E={edits:[]};for(const[g,c]of f){const{edits:m}=C.WorkspaceEdit.from(c,{getTextDocumentVersion:a=>this._extHostDocumentsAndEditors.getDocument(a)?.version,getNotebookDocumentVersion:()=>{}},(0,b.isProposedApiEnabled)(g,"snippetWorkspaceEdit"));E.edits=E.edits.concat(m)}return{edit:E,extensionNames:Array.from(p)}}}e.ExtHostFileSystemEventService=R}),define(Ie[249],ke([0,1,2,38]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(C,y,b,I,R){this._extHostNotebooks=y,this._textDocumentsAndEditors=b,this._commands=I;const k=new n.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new n.ApiCommandArgument("showOptions","Show Options",_=>!0,_=>_),new n.ApiCommandArgument("resource","Interactive resource Uri",_=>!0,_=>_),new n.ApiCommandArgument("controllerId","Notebook controller Id",_=>!0,_=>_),new n.ApiCommandArgument("title","Interactive editor title",_=>!0,_=>_)],new n.ApiCommandResult("Notebook and input URI",_=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",_.notebookEditorId),_.notebookEditorId!==void 0){const P=this._extHostNotebooks.getEditorById(_.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",P.id),{notebookUri:u.URI.revive(_.notebookUri),inputUri:u.URI.revive(_.inputUri),notebookEditor:P.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",_.notebookUri,_.inputUri),{notebookUri:u.URI.revive(_.notebookUri),inputUri:u.URI.revive(_.inputUri)}}));this._commands.registerApiCommand(k)}$willAddInteractiveDocument(C,y,b,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:y,lines:[""],languageId:b,uri:C,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(u.URI.revive(I))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,y){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=D}),define(Ie[250],ke([0,1,6,5]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(C){this._handlePool=0,this._proxy=C.getProxy(n.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const y=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(y,C),(0,u.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(y)})}}e.ExtHostLabelService=D}),define(Ie[251],ke([0,1,2,24,15,7,64,5,8,35,16,11,145,21,6,113,93,87,50,12,18,27]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v,w,p,f,E,g,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class a{constructor(O,H){this._documents=O,this._provider=H}async provideDocumentSymbols(O,H){const K=this._documents.getDocument(O),Q=await this._provider.provideDocumentSymbols(K,H);if(!(0,R.isFalsyOrEmpty)(Q))return Q[0]instanceof T.DocumentSymbol?Q.map(D.DocumentSymbol.from):a._asDocumentSymbolTree(Q)}static _asDocumentSymbolTree(O){O=O.slice(0).sort((Q,he)=>{let be=Q.location.range.start.compareTo(he.location.range.start);return be===0&&(be=he.location.range.end.compareTo(Q.location.range.end)),be});const H=[],K=[];for(const Q of O){const he={name:Q.name||"!!MISSING: name!!",kind:D.SymbolKind.from(Q.kind),tags:Q.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:D.Range.from(Q.location.range),selectionRange:D.Range.from(Q.location.range),children:[]};for(;;){if(K.length===0){K.push(he),H.push(he);break}const be=K[K.length-1];if(I.Range.containsRange(be.range,he.range)&&!I.Range.equalsRange(be.range,he.range)){be.children?.push(he),K.push(he);break}K.pop()}}return H}}class d{constructor(O,H,K){this._documents=O,this._commands=H,this._provider=K,this._cache=new f.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(O,H){const K=this._documents.getDocument(O),Q=await this._provider.provideCodeLenses(K,H);if(!Q||H.isCancellationRequested)return;const he=this._cache.add(Q),be=new v.DisposableStore;this._disposables.set(he,be);const ce={cacheId:he,lenses:[]};for(let De=0;De<Q.length;De++)ce.lenses.push({cacheId:[he,De],range:D.Range.from(Q[De].range),command:this._commands.toInternal(Q[De].command,be)});return ce}async resolveCodeLens(O,H){const K=O.cacheId&&this._cache.get(...O.cacheId);if(!K)return;let Q;if(typeof this._provider.resolveCodeLens!="function"||K.isResolved?Q=K:Q=await this._provider.resolveCodeLens(K,H),Q||(Q=K),H.isCancellationRequested)return;const he=O.cacheId&&this._disposables.get(O.cacheId[0]);if(!!he)return O.command=this._commands.toInternal(Q.command??d._badCmd,he),O}releaseCodeLenses(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}}d._badCmd={command:"missing",title:"!!MISSING: command!!"};function i(se){return Array.isArray(se)?se.map(D.DefinitionLink.from):se?[D.DefinitionLink.from(se)]:[]}class o{constructor(O,H){this._documents=O,this._provider=H}async provideDefinition(O,H,K){const Q=this._documents.getDocument(O),he=D.Position.to(H),be=await this._provider.provideDefinition(Q,he,K);return i(be)}}class r{constructor(O,H){this._documents=O,this._provider=H}async provideDeclaration(O,H,K){const Q=this._documents.getDocument(O),he=D.Position.to(H),be=await this._provider.provideDeclaration(Q,he,K);return i(be)}}class t{constructor(O,H){this._documents=O,this._provider=H}async provideImplementation(O,H,K){const Q=this._documents.getDocument(O),he=D.Position.to(H),be=await this._provider.provideImplementation(Q,he,K);return i(be)}}class s{constructor(O,H){this._documents=O,this._provider=H}async provideTypeDefinition(O,H,K){const Q=this._documents.getDocument(O),he=D.Position.to(H),be=await this._provider.provideTypeDefinition(Q,he,K);return i(be)}}class l{constructor(O,H){this._documents=O,this._provider=H}async provideHover(O,H,K){const Q=this._documents.getDocument(O),he=D.Position.to(H),be=await this._provider.provideHover(Q,he,K);if(!(!be||(0,R.isFalsyOrEmpty)(be.contents)))return be.range||(be.range=Q.getWordRangeAtPosition(he)),be.range||(be.range=new T.Range(he,he)),D.Hover.from(be)}}class h{constructor(O,H){this._documents=O,this._provider=H}async provideEvaluatableExpression(O,H,K){const Q=this._documents.getDocument(O),he=D.Position.to(H),be=await this._provider.provideEvaluatableExpression(Q,he,K);if(be)return D.EvaluatableExpression.from(be)}}class S{constructor(O,H){this._documents=O,this._provider=H}async provideInlineValues(O,H,K,Q){const he=this._documents.getDocument(O),be=await this._provider.provideInlineValues(he,D.Range.to(H),D.InlineValueContext.to(K),Q);if(Array.isArray(be))return be.map(ce=>D.InlineValue.from(ce))}}class L{constructor(O,H){this._documents=O,this._provider=H}async provideDocumentHighlights(O,H,K){const Q=this._documents.getDocument(O),he=D.Position.to(H),be=await this._provider.provideDocumentHighlights(Q,he,K);if(Array.isArray(be))return be.map(D.DocumentHighlight.from)}}class F{constructor(O,H){this._documents=O,this._provider=H}async provideLinkedEditingRanges(O,H,K){const Q=this._documents.getDocument(O),he=D.Position.to(H),be=await this._provider.provideLinkedEditingRanges(Q,he,K);if(be&&Array.isArray(be.ranges))return{ranges:(0,R.coalesce)(be.ranges.map(D.Range.from)),wordPattern:be.wordPattern}}}class M{constructor(O,H){this._documents=O,this._provider=H}async provideReferences(O,H,K,Q){const he=this._documents.getDocument(O),be=D.Position.to(H),ce=await this._provider.provideReferences(he,be,K,Q);if(Array.isArray(ce))return ce.map(D.location.from)}}class A{constructor(O,H,K,Q,he,be,ce){this._documents=O,this._commands=H,this._diagnostics=K,this._provider=Q,this._logService=he,this._extension=be,this._apiDeprecation=ce,this._cache=new f.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(O,H,K,Q){const he=this._documents.getDocument(O),be=_.Selection.isISelection(H)?D.Selection.to(H):D.Range.to(H),ce=[];for(const Xe of this._diagnostics.getDiagnostics(O))if(be.intersection(Xe.range)&&ce.push(Xe)>A._maxCodeActionsPerFile)break;const De={diagnostics:ce,only:K.only?new T.CodeActionKind(K.only):void 0,triggerKind:D.CodeActionTriggerKind.to(K.trigger)},ye=await this._provider.provideCodeActions(he,be,De,Q);if(!(0,R.isNonEmptyArray)(ye)||Q.isCancellationRequested)return;const Be=this._cache.add(ye),qe=new v.DisposableStore;this._disposables.set(Be,qe);const et=[];for(let Xe=0;Xe<ye.length;Xe++){const Oe=ye[Xe];!Oe||(A._isCommand(Oe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:Oe.title,command:this._commands.toInternal(Oe,qe)})):(De.only&&(Oe.kind?De.only.contains(Oe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${De.only.value} 'requested but returned code action is of kind '${Oe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${De.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[Be,Xe],title:Oe.title,command:Oe.command&&this._commands.toInternal(Oe.command,qe),diagnostics:Oe.diagnostics&&Oe.diagnostics.map(D.Diagnostic.from),edit:Oe.edit&&D.WorkspaceEdit.from(Oe.edit,void 0,(0,m.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")),kind:Oe.kind&&Oe.kind.value,isPreferred:Oe.isPreferred,disabled:Oe.disabled?.reason})))}return{cacheId:Be,actions:et}}async resolveCodeAction(O,H){const[K,Q]=O,he=this._cache.get(K,Q);if(!he||A._isCommand(he)||!this._provider.resolveCodeAction)return;const be=await this._provider.resolveCodeAction(he,H)??he;return be?.edit?D.WorkspaceEdit.from(be.edit,void 0,(0,m.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")):void 0}releaseCodeActions(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}static _isCommand(O){return typeof O.command=="string"&&typeof O.title=="string"}}A._maxCodeActionsPerFile=1e3;class B{constructor(O,H,K,Q){this._proxy=O,this._documents=H,this._provider=K,this._handle=Q}async prepareDocumentPaste(O,H,K,Q){if(!this._provider.prepareDocumentPaste)return;const he=this._documents.getDocument(O),be=H.map(De=>D.Range.to(De)),ce=D.DataTransfer.toDataTransfer(K,()=>{throw new g.NotImplementedError});return await this._provider.prepareDocumentPaste(he,be,ce,Q),D.DataTransfer.toDataTransferDTO(ce)}async providePasteEdits(O,H,K,Q,he){const be=this._documents.getDocument(H),ce=K.map(Be=>D.Range.to(Be)),De=D.DataTransfer.toDataTransfer(Q,async Be=>(await this._proxy.$resolvePasteFileData(this._handle,O,Be)).buffer),ye=await this._provider.provideDocumentPasteEdits(be,ce,De,he);if(!!ye)return{insertText:typeof ye.insertText=="string"?ye.insertText:{snippet:ye.insertText.value},additionalEdit:ye.additionalEdit?D.WorkspaceEdit.from(ye.additionalEdit,void 0,!0):void 0}}}class ${constructor(O,H){this._documents=O,this._provider=H}async provideDocumentFormattingEdits(O,H,K){const Q=this._documents.getDocument(O),he=await this._provider.provideDocumentFormattingEdits(Q,H,K);if(Array.isArray(he))return he.map(D.TextEdit.from)}}class U{constructor(O,H){this._documents=O,this._provider=H}async provideDocumentRangeFormattingEdits(O,H,K,Q){const he=this._documents.getDocument(O),be=D.Range.to(H),ce=await this._provider.provideDocumentRangeFormattingEdits(he,be,K,Q);if(Array.isArray(ce))return ce.map(D.TextEdit.from)}}class X{constructor(O,H){this._documents=O,this._provider=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,H,K,Q,he){const be=this._documents.getDocument(O),ce=D.Position.to(H),De=await this._provider.provideOnTypeFormattingEdits(be,ce,K,Q,he);if(Array.isArray(De))return De.map(D.TextEdit.from)}}class z{constructor(O,H){this._provider=O,this._logService=H,this._cache=new f.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,H){const K=await this._provider.provideWorkspaceSymbols(O,H);if(!(0,R.isNonEmptyArray)(K))return{symbols:[]};const Q=this._cache.add(K),he={cacheId:Q,symbols:[]};for(let be=0;be<K.length;be++){const ce=K[be];if(!ce||!ce.name){this._logService.warn("INVALID SymbolInformation",ce);continue}he.symbols.push({...D.WorkspaceSymbol.from(ce),cacheId:[Q,be]})}return he}async resolveWorkspaceSymbol(O,H){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const K=this._cache.get(...O.cacheId);if(K){const Q=await this._provider.resolveWorkspaceSymbol(K,H);return Q&&(0,n.mixin)(O,D.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(O){this._cache.delete(O)}}class N{constructor(O,H,K){this._documents=O,this._provider=H,this._logService=K}static supportsResolving(O){return typeof O.prepareRename=="function"}async provideRenameEdits(O,H,K,Q){const he=this._documents.getDocument(O),be=D.Position.to(H);try{const ce=await this._provider.provideRenameEdits(he,be,K,Q);return ce?D.WorkspaceEdit.from(ce):void 0}catch(ce){const De=N._asMessage(ce);return De?{rejectReason:De,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(O,H,K){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const Q=this._documents.getDocument(O),he=D.Position.to(H);try{const be=await this._provider.prepareRename(Q,he,K);let ce,De;if(T.Range.isRange(be)?(ce=be,De=Q.getText(be)):(0,k.isObject)(be)&&(ce=be.range,De=be.placeholder),!ce||!De)return;if(ce.start.line>he.line||ce.end.line<he.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(ce),text:De}}catch(be){const ce=N._asMessage(be);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(be)}}static _asMessage(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class V{constructor(O,H){this.resultId=O,this.tokens=H}}class x{constructor(O,H){this._documents=O,this._provider=H,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(O,H,K){const Q=this._documents.getDocument(O),he=H!==0?this._previousResults.get(H):null;let be=typeof he?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(Q,he.resultId,K):await this._provider.provideDocumentSemanticTokens(Q,K);return he&&this._previousResults.delete(H),be?(be=x._fixProvidedSemanticTokens(be),this._send(x._convertToEdits(he,be),be)):null}async releaseDocumentSemanticColoring(O){this._previousResults.delete(O)}static _fixProvidedSemanticTokens(O){return x._isSemanticTokens(O)?x._isCorrectSemanticTokens(O)?O:new T.SemanticTokens(new Uint32Array(O.data),O.resultId):x._isSemanticTokensEdits(O)?x._isCorrectSemanticTokensEdits(O)?O:new T.SemanticTokensEdits(O.edits.map(H=>new T.SemanticTokensEdit(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),O.resultId):O}static _isSemanticTokens(O){return O&&!!O.data}static _isCorrectSemanticTokens(O){return O.data instanceof Uint32Array}static _isSemanticTokensEdits(O){return O&&Array.isArray(O.edits)}static _isCorrectSemanticTokensEdits(O){for(const H of O.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(O,H){if(!x._isSemanticTokens(H)||!O||!O.tokens)return H;const K=O.tokens,Q=K.length,he=H.data,be=he.length;let ce=0;const De=Math.min(Q,be);for(;ce<De&&K[ce]===he[ce];)ce++;if(ce===Q&&ce===be)return new T.SemanticTokensEdits([],H.resultId);let ye=0;const Be=De-ce;for(;ye<Be&&K[Q-ye-1]===he[be-ye-1];)ye++;return new T.SemanticTokensEdits([{start:ce,deleteCount:Q-ce-ye,data:he.subarray(ce,be-ye)}],H.resultId)}_send(O,H){if(x._isSemanticTokens(O)){const K=this._nextResultId++;return this._previousResults.set(K,new V(O.resultId,O.data)),(0,w.encodeSemanticTokensDto)({id:K,type:"full",data:O.data})}if(x._isSemanticTokensEdits(O)){const K=this._nextResultId++;return x._isSemanticTokens(H)?this._previousResults.set(K,new V(H.resultId,H.data)):this._previousResults.set(K,new V(O.resultId)),(0,w.encodeSemanticTokensDto)({id:K,type:"delta",deltas:(O.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}e.DocumentSemanticTokensAdapter=x;class q{constructor(O,H){this._documents=O,this._provider=H}async provideDocumentRangeSemanticTokens(O,H,K){const Q=this._documents.getDocument(O),he=await this._provider.provideDocumentRangeSemanticTokens(Q,D.Range.to(H),K);return he?this._send(he):null}_send(O){return(0,w.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}e.DocumentRangeSemanticTokensAdapter=q;class te{constructor(O,H,K,Q,he){this._documents=O,this._commands=H,this._provider=K,this._apiDeprecation=Q,this._extension=he,this._cache=new f.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}async provideCompletionItems(O,H,K,Q){const he=this._documents.getDocument(O),be=D.Position.to(H),ce=he.getWordRangeAtPosition(be)||new T.Range(be,be),De=ce.with({end:be}),ye=new E.StopWatch(!0),Be=await this._provider.provideCompletionItems(he,be,Q,D.CompletionContext.to(K));if(!Be||Q.isCancellationRequested)return;const qe=Array.isArray(Be)?new T.CompletionList(Be):Be,et=te.supportsResolving(this._provider)?this._cache.add(qe.items):this._cache.add([]),Xe=new v.DisposableStore;this._disposables.set(et,Xe);const Oe=[],ot={x:et,b:Oe,a:{replace:D.Range.from(ce),insert:D.Range.from(De)},c:qe.isIncomplete||void 0,d:ye.elapsed()};for(let ie=0;ie<qe.items.length;ie++){const oe=qe.items[ie],G=this._convertCompletionItem(oe,[et,ie],De,ce);Oe.push(G)}return ot}async resolveCompletionItem(O,H){if(typeof this._provider.resolveCompletionItem!="function")return;const K=this._cache.get(...O);if(!K)return;const Q=await this._provider.resolveCompletionItem(K,H);if(!!Q)return this._convertCompletionItem(Q,O)}releaseCompletionItems(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_convertCompletionItem(O,H,K,Q){const he=this._disposables.get(H[0]);if(!he)throw Error("DisposableStore is missing...");const be={x:H,a:O.label,b:O.kind!==void 0?D.CompletionItemKind.from(O.kind):void 0,n:O.tags&&O.tags.map(D.CompletionItemTag.from),c:O.detail,d:typeof O.documentation=="undefined"?void 0:D.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters,l:O.additionalTextEdits&&O.additionalTextEdits.map(D.TextEdit.from),m:this._commands.toInternal(O.command,he)};O.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),be.h=O.textEdit.newText):typeof O.insertText=="string"?be.h=O.insertText:O.insertText instanceof T.SnippetString&&(be.h=O.insertText.value,be.i|=4);let ce;return O.textEdit?ce=O.textEdit.range:O.range&&(ce=O.range),T.Range.isRange(ce)?be.j=D.Range.from(ce):ce&&(!K?.isEqual(ce.inserting)||!Q?.isEqual(ce.replacing))&&(be.j={insert:D.Range.from(ce.inserting),replace:D.Range.from(ce.replacing)}),be}}class Y{async provideInlineCompletions(O,H,K,Q){}disposeCompletions(O){}handleDidShowCompletionItem(O,H){}}class le extends Y{constructor(O,H,K,Q){super();this._extension=O,this._documents=H,this._provider=K,this._commands=Q,this._references=new ee,this._isAdditionsProposedApiEnabled=(0,m.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[C.InlineCompletionTriggerKind.Automatic]:T.InlineCompletionTriggerKind.Automatic,[C.InlineCompletionTriggerKind.Explicit]:T.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,m.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(O,H,K,Q){const he=this._documents.getDocument(O),be=D.Position.to(H),ce=await this._provider.provideInlineCompletionItems(he,be,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:D.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[K.triggerKind]},Q);if(!ce||Q.isCancellationRequested)return;const De=(0,k.isArray)(ce)?ce:ce.items,ye=this._isAdditionsProposedApiEnabled?(0,k.isArray)(ce)?[]:ce.commands||[]:[];let Be;return{pid:this._references.createReferenceId({dispose(){Be&&Be.dispose()},items:De}),items:De.map((et,Xe)=>{let Oe;et.command&&(Be||(Be=new v.DisposableStore),Oe=this._commands.toInternal(et.command,Be));const ot=et.insertText;return{insertText:typeof ot=="string"?ot:{snippet:ot.value},filterText:et.filterText,range:et.range?D.Range.from(et.range):void 0,command:Oe,idx:Xe,completeBracketPairs:this._isAdditionsProposedApiEnabled?et.completeBracketPairs:!1}}),commands:ye.map(et=>(Be||(Be=new v.DisposableStore),this._commands.toInternal(et,Be)))}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,H){const K=this._references.get(O)?.items[H];K&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(K)}}class pe extends Y{constructor(O,H,K,Q){super();this.extension=O,this._documents=H,this._provider=K,this._commands=Q,this._references=new ee,this.isAdditionProposedApiEnabled=(0,m.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[C.InlineCompletionTriggerKind.Automatic]:T.InlineCompletionTriggerKindNew.Automatic,[C.InlineCompletionTriggerKind.Explicit]:T.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(O,H,K,Q){const he=this._documents.getDocument(O),be=D.Position.to(H),ce=await this._provider.provideInlineCompletionItems(he,be,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:D.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[K.triggerKind]},Q);if(!ce||Q.isCancellationRequested)return;const De=(0,k.isArray)(ce)?ce:ce.items,ye=(0,k.isArray)(ce)?[]:ce.commands||[];let Be;return{pid:this._references.createReferenceId({dispose(){Be&&Be.dispose()},items:De}),items:De.map((et,Xe)=>{let Oe;et.command&&(Be||(Be=new v.DisposableStore),Oe=this._commands.toInternal(et.command,Be));const ot=et.insertText;return{insertText:typeof ot=="string"?ot:{snippet:ot.value},filterText:et.filterText,range:et.range?D.Range.from(et.range):void 0,command:Oe,idx:Xe,completeBracketPairs:this.isAdditionProposedApiEnabled?et.completeBracketPairs:!1}}),commands:ye.map(et=>(Be||(Be=new v.DisposableStore),this._commands.toInternal(et,Be)))}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,H){const K=this._references.get(O)?.items[H];K&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(K)}}class ee{constructor(){this._references=new Map,this._idPool=1}createReferenceId(O){const H=this._idPool++;return this._references.set(H,O),H}disposeReferenceId(O){const H=this._references.get(O);return this._references.delete(O),H}get(O){return this._references.get(O)}}class ge{constructor(O,H){this._documents=O,this._provider=H,this._cache=new f.Cache("SignatureHelp")}async provideSignatureHelp(O,H,K,Q){const he=this._documents.getDocument(O),be=D.Position.to(H),ce=this.reviveContext(K),De=await this._provider.provideSignatureHelp(he,be,Q,ce);if(De){const ye=this._cache.add([De]);return{...D.SignatureHelp.from(De),id:ye}}}reviveContext(O){let H;if(O.activeSignatureHelp){const K=D.SignatureHelp.to(O.activeSignatureHelp),Q=this._cache.get(O.activeSignatureHelp.id,0);Q?(H=Q,H.activeSignature=K.activeSignature,H.activeParameter=K.activeParameter):H=K}return{...O,activeSignatureHelp:H}}releaseSignatureHelp(O){this._cache.delete(O)}}class Ee{constructor(O,H,K,Q,he){this._documents=O,this._commands=H,this._provider=K,this._logService=Q,this._extension=he,this._cache=new f.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(O,H,K){const Q=this._documents.getDocument(O),he=D.Range.to(H),be=await this._provider.provideInlayHints(Q,he,K);if(!Array.isArray(be)||be.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${H}`);return}if(K.isCancellationRequested)return;const ce=this._cache.add(be);this._disposables.set(ce,new v.DisposableStore);const De={hints:[],cacheId:ce};for(let ye=0;ye<be.length;ye++)this._isValidInlayHint(be[ye],he)&&De.hints.push(this._convertInlayHint(be[ye],[ce,ye]));return this._logService.trace(`[InlayHints] ${De.hints.length} inlay hints from '${this._extension.identifier.value}' for ${H}`),De}async resolveInlayHint(O,H){if(typeof this._provider.resolveInlayHint!="function")return;const K=this._cache.get(...O);if(!K)return;const Q=await this._provider.resolveInlayHint(K,H);if(!!Q&&!!this._isValidInlayHint(Q))return this._convertInlayHint(Q,O)}releaseHints(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_isValidInlayHint(O,H){return O.label.length===0||Array.isArray(O.label)&&O.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(H&&!H.contains(O.position))}_convertInlayHint(O,H){const K=this._disposables.get(H[0]);if(!K)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:H,tooltip:D.MarkdownString.fromStrict(O.tooltip),position:D.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(D.TextEdit.from),kind:O.kind&&D.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?Q.label=O.label:Q.label=O.label.map(he=>{const be={label:he.value};return be.tooltip=D.MarkdownString.fromStrict(he.tooltip),T.Location.isLocation(he.location)&&(be.location=D.location.from(he.location)),he.command&&(be.command=this._commands.toInternal(he.command,K)),be}),Q}}class Pe{constructor(O,H){this._documents=O,this._provider=H,this._cache=new f.Cache("DocumentLink")}async provideLinks(O,H){const K=this._documents.getDocument(O),Q=await this._provider.provideDocumentLinks(K,H);if(!(!Array.isArray(Q)||Q.length===0)&&!H.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:Q.filter(Pe._validateLink).map(D.DocumentLink.from)};{const he=this._cache.add(Q),be={links:[],cacheId:he};for(let ce=0;ce<Q.length;ce++){if(!Pe._validateLink(Q[ce]))continue;const De=D.DocumentLink.from(Q[ce]);De.cacheId=[he,ce],be.links.push(De)}return be}}}static _validateLink(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,H){if(typeof this._provider.resolveDocumentLink!="function")return;const K=this._cache.get(...O);if(!K)return;const Q=await this._provider.resolveDocumentLink(K,H);if(!(!Q||!Pe._validateLink(Q)))return D.DocumentLink.from(Q)}releaseLinks(O){this._cache.delete(O)}}class Ne{constructor(O,H){this._documents=O,this._provider=H}async provideColors(O,H){const K=this._documents.getDocument(O),Q=await this._provider.provideDocumentColors(K,H);return Array.isArray(Q)?Q.map(be=>({color:D.Color.from(be.color),range:D.Range.from(be.range)})):[]}async provideColorPresentations(O,H,K){const Q=this._documents.getDocument(O),he=D.Range.to(H.range),be=D.Color.to(H.color),ce=await this._provider.provideColorPresentations(be,{document:Q,range:he},K);if(!!Array.isArray(ce))return ce.map(D.ColorPresentation.from)}}class ve{constructor(O,H){this._documents=O,this._provider=H}async provideFoldingRanges(O,H,K){const Q=this._documents.getDocument(O),he=await this._provider.provideFoldingRanges(Q,H,K);if(!!Array.isArray(he))return he.map(D.FoldingRange.from)}}class ue{constructor(O,H,K){this._documents=O,this._provider=H,this._logService=K}async provideSelectionRanges(O,H,K){const Q=this._documents.getDocument(O),he=H.map(D.Position.to),be=await this._provider.provideSelectionRanges(Q,he,K);if(!(0,R.isNonEmptyArray)(be))return[];if(be.length!==he.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let De=0;De<he.length;De++){const ye=[];ce.push(ye);let Be=he[De],qe=be[De];for(;;){if(!qe.range.contains(Be))throw new Error("INVALID selection range, must contain the previous range");if(ye.push(D.SelectionRange.from(qe)),!qe.parent)break;Be=qe.range,qe=qe.parent}}return ce}}class de{constructor(O,H){this._documents=O,this._provider=H,this._idPool=new p.IdGenerator(""),this._cache=new Map}async prepareSession(O,H,K){const Q=this._documents.getDocument(O),he=D.Position.to(H),be=await this._provider.prepareCallHierarchy(Q,he,K);if(!be)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(be)?be.map(De=>this._cacheAndConvertItem(ce,De)):[this._cacheAndConvertItem(ce,be)]}async provideCallsTo(O,H,K){const Q=this._itemFromCache(O,H);if(!Q)throw new Error("missing call hierarchy item");const he=await this._provider.provideCallHierarchyIncomingCalls(Q,K);if(!!he)return he.map(be=>({from:this._cacheAndConvertItem(O,be.from),fromRanges:be.fromRanges.map(ce=>D.Range.from(ce))}))}async provideCallsFrom(O,H,K){const Q=this._itemFromCache(O,H);if(!Q)throw new Error("missing call hierarchy item");const he=await this._provider.provideCallHierarchyOutgoingCalls(Q,K);if(!!he)return he.map(be=>({to:this._cacheAndConvertItem(O,be.to),fromRanges:be.fromRanges.map(ce=>D.Range.from(ce))}))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,H){const K=this._cache.get(O),Q=D.CallHierarchyItem.from(H,O,K.size.toString(36));return K.set(Q._itemId,H),Q}_itemFromCache(O,H){return this._cache.get(O)?.get(H)}}class we{constructor(O,H){this._documents=O,this._provider=H,this._idPool=new p.IdGenerator(""),this._cache=new Map}async prepareSession(O,H,K){const Q=this._documents.getDocument(O),he=D.Position.to(H),be=await this._provider.prepareTypeHierarchy(Q,he,K);if(!be)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(be)?be.map(De=>this._cacheAndConvertItem(ce,De)):[this._cacheAndConvertItem(ce,be)]}async provideSupertypes(O,H,K){const Q=this._itemFromCache(O,H);if(!Q)throw new Error("missing type hierarchy item");const he=await this._provider.provideTypeHierarchySupertypes(Q,K);if(!!he)return he.map(be=>this._cacheAndConvertItem(O,be))}async provideSubtypes(O,H,K){const Q=this._itemFromCache(O,H);if(!Q)throw new Error("missing type hierarchy item");const he=await this._provider.provideTypeHierarchySubtypes(Q,K);if(!!he)return he.map(be=>this._cacheAndConvertItem(O,be))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,H){const K=this._cache.get(O),Q=D.TypeHierarchyItem.from(H,O,K.size.toString(36));return K.set(Q._itemId,H),Q}_itemFromCache(O,H){return this._cache.get(O)?.get(H)}}class re{constructor(O,H,K,Q){this._proxy=O,this._documents=H,this._provider=K,this._handle=Q}async provideDocumentOnDropEdits(O,H,K,Q,he){const be=this._documents.getDocument(H),ce=D.Position.to(K),De=D.DataTransfer.toDataTransfer(Q,async Be=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,O,Be)).buffer),ye=await this._provider.provideDocumentDropEdits(be,ce,De,he);if(!!ye)return{insertText:typeof ye.insertText=="string"?ye.insertText:{snippet:ye.insertText.value},additionalEdit:ye.additionalEdit?D.WorkspaceEdit.from(ye.additionalEdit,void 0,!0):void 0}}}class me{constructor(O,H){this.adapter=O,this.extension=H}}class Z{constructor(O,H,K,Q,he,be,ce){this._adapter=new Map,this._uriTransformer=H,this._proxy=O.getProxy(y.MainContext.MainThreadLanguageFeatures),this._documents=K,this._commands=Q,this._diagnostics=he,this._logService=be,this._apiDeprecation=ce}_transformDocumentSelector(O){return D.DocumentSelector.from(O,this._uriTransformer)}_createDisposable(O){return new T.Disposable(()=>{this._adapter.delete(O),this._proxy.$unregister(O)})}_nextHandle(){return Z._handlePool++}async _withAdapter(O,H,K,Q,he,be=!1){const ce=this._adapter.get(O);if(!ce||!(ce.adapter instanceof H))return Q;const De=Date.now();be||this._logService.trace(`[${ce.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const ye=K(ce.adapter,ce.extension);return Promise.resolve(ye).catch(Be=>{(0,g.isCancellationError)(Be)||(this._logService.error(`[${ce.extension.identifier.value}] provider FAILED`),this._logService.error(Be))}).finally(()=>{be||this._logService.trace(`[${ce.extension.identifier.value}] provider DONE after ${Date.now()-De}ms`)}),P.CancellationToken.isCancellationToken(he)?(0,c.raceCancellationError)(ye,he):ye}_addNewAdapter(O,H){const K=this._nextHandle();return this._adapter.set(K,new me(O,H)),K}static _extLabel(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,H,K,Q){const he=this._addNewAdapter(new a(this._documents,K),O),be=Q&&Q.label||Z._extLabel(O);return this._proxy.$registerDocumentSymbolProvider(he,this._transformDocumentSelector(H),be),this._createDisposable(he)}$provideDocumentSymbols(O,H,K){return this._withAdapter(O,a,Q=>Q.provideDocumentSymbols(u.URI.revive(H),K),void 0,K)}registerCodeLensProvider(O,H,K){const Q=this._nextHandle(),he=typeof K.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(Q,new me(new d(this._documents,this._commands.converter,K),O)),this._proxy.$registerCodeLensSupport(Q,this._transformDocumentSelector(H),he);let be=this._createDisposable(Q);if(he!==void 0){const ce=K.onDidChangeCodeLenses(De=>this._proxy.$emitCodeLensEvent(he));be=T.Disposable.from(be,ce)}return be}$provideCodeLenses(O,H,K){return this._withAdapter(O,d,Q=>Q.provideCodeLenses(u.URI.revive(H),K),void 0,K)}$resolveCodeLens(O,H,K){return this._withAdapter(O,d,Q=>Q.resolveCodeLens(H,K),void 0,void 0)}$releaseCodeLenses(O,H){this._withAdapter(O,d,K=>Promise.resolve(K.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(O,H,K){const Q=this._addNewAdapter(new o(this._documents,K),O);return this._proxy.$registerDefinitionSupport(Q,this._transformDocumentSelector(H)),this._createDisposable(Q)}$provideDefinition(O,H,K,Q){return this._withAdapter(O,o,he=>he.provideDefinition(u.URI.revive(H),K,Q),[],Q)}registerDeclarationProvider(O,H,K){const Q=this._addNewAdapter(new r(this._documents,K),O);return this._proxy.$registerDeclarationSupport(Q,this._transformDocumentSelector(H)),this._createDisposable(Q)}$provideDeclaration(O,H,K,Q){return this._withAdapter(O,r,he=>he.provideDeclaration(u.URI.revive(H),K,Q),[],Q)}registerImplementationProvider(O,H,K){const Q=this._addNewAdapter(new t(this._documents,K),O);return this._proxy.$registerImplementationSupport(Q,this._transformDocumentSelector(H)),this._createDisposable(Q)}$provideImplementation(O,H,K,Q){return this._withAdapter(O,t,he=>he.provideImplementation(u.URI.revive(H),K,Q),[],Q)}registerTypeDefinitionProvider(O,H,K){const Q=this._addNewAdapter(new s(this._documents,K),O);return this._proxy.$registerTypeDefinitionSupport(Q,this._transformDocumentSelector(H)),this._createDisposable(Q)}$provideTypeDefinition(O,H,K,Q){return this._withAdapter(O,s,he=>he.provideTypeDefinition(u.URI.revive(H),K,Q),[],Q)}registerHoverProvider(O,H,K,Q){const he=this._addNewAdapter(new l(this._documents,K),O);return this._proxy.$registerHoverProvider(he,this._transformDocumentSelector(H)),this._createDisposable(he)}$provideHover(O,H,K,Q){return this._withAdapter(O,l,he=>he.provideHover(u.URI.revive(H),K,Q),void 0,Q)}registerEvaluatableExpressionProvider(O,H,K,Q){const he=this._addNewAdapter(new h(this._documents,K),O);return this._proxy.$registerEvaluatableExpressionProvider(he,this._transformDocumentSelector(H)),this._createDisposable(he)}$provideEvaluatableExpression(O,H,K,Q){return this._withAdapter(O,h,he=>he.provideEvaluatableExpression(u.URI.revive(H),K,Q),void 0,Q)}registerInlineValuesProvider(O,H,K,Q){const he=typeof K.onDidChangeInlineValues=="function"?this._nextHandle():void 0,be=this._addNewAdapter(new S(this._documents,K),O);this._proxy.$registerInlineValuesProvider(be,this._transformDocumentSelector(H),he);let ce=this._createDisposable(be);if(he!==void 0){const De=K.onDidChangeInlineValues(ye=>this._proxy.$emitInlineValuesEvent(he));ce=T.Disposable.from(ce,De)}return ce}$provideInlineValues(O,H,K,Q,he){return this._withAdapter(O,S,be=>be.provideInlineValues(u.URI.revive(H),K,Q,he),void 0,he)}registerDocumentHighlightProvider(O,H,K){const Q=this._addNewAdapter(new L(this._documents,K),O);return this._proxy.$registerDocumentHighlightProvider(Q,this._transformDocumentSelector(H)),this._createDisposable(Q)}$provideDocumentHighlights(O,H,K,Q){return this._withAdapter(O,L,he=>he.provideDocumentHighlights(u.URI.revive(H),K,Q),void 0,Q)}registerLinkedEditingRangeProvider(O,H,K){const Q=this._addNewAdapter(new F(this._documents,K),O);return this._proxy.$registerLinkedEditingRangeProvider(Q,this._transformDocumentSelector(H)),this._createDisposable(Q)}$provideLinkedEditingRanges(O,H,K,Q){return this._withAdapter(O,F,async he=>{const be=await he.provideLinkedEditingRanges(u.URI.revive(H),K,Q);if(be)return{ranges:be.ranges,wordPattern:be.wordPattern?Z._serializeRegExp(be.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(O,H,K){const Q=this._addNewAdapter(new M(this._documents,K),O);return this._proxy.$registerReferenceSupport(Q,this._transformDocumentSelector(H)),this._createDisposable(Q)}$provideReferences(O,H,K,Q,he){return this._withAdapter(O,M,be=>be.provideReferences(u.URI.revive(H),K,Q,he),void 0,he)}registerCodeActionProvider(O,H,K,Q){const he=new v.DisposableStore,be=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,K,this._logService,O,this._apiDeprecation),O);return this._proxy.$registerQuickFixSupport(be,this._transformDocumentSelector(H),{providedKinds:Q?.providedCodeActionKinds?.map(ce=>ce.value),documentation:Q?.documentation?.map(ce=>({kind:ce.kind.value,command:this._commands.converter.toInternal(ce.command,he)}))},Z._extLabel(O),Boolean(K.resolveCodeAction)),he.add(this._createDisposable(be)),he}$provideCodeActions(O,H,K,Q,he){return this._withAdapter(O,A,be=>be.provideCodeActions(u.URI.revive(H),K,Q,he),void 0,he)}$resolveCodeAction(O,H,K){return this._withAdapter(O,A,Q=>Q.resolveCodeAction(H,K),void 0,void 0)}$releaseCodeActions(O,H){this._withAdapter(O,A,K=>Promise.resolve(K.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(O,H,K){const Q=this._addNewAdapter(new $(this._documents,K),O);return this._proxy.$registerDocumentFormattingSupport(Q,this._transformDocumentSelector(H),O.identifier,O.displayName||O.name),this._createDisposable(Q)}$provideDocumentFormattingEdits(O,H,K,Q){return this._withAdapter(O,$,he=>he.provideDocumentFormattingEdits(u.URI.revive(H),K,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(O,H,K){const Q=this._addNewAdapter(new U(this._documents,K),O);return this._proxy.$registerRangeFormattingSupport(Q,this._transformDocumentSelector(H),O.identifier,O.displayName||O.name),this._createDisposable(Q)}$provideDocumentRangeFormattingEdits(O,H,K,Q,he){return this._withAdapter(O,U,be=>be.provideDocumentRangeFormattingEdits(u.URI.revive(H),K,Q,he),void 0,he)}registerOnTypeFormattingEditProvider(O,H,K,Q){const he=this._addNewAdapter(new X(this._documents,K),O);return this._proxy.$registerOnTypeFormattingSupport(he,this._transformDocumentSelector(H),Q,O.identifier),this._createDisposable(he)}$provideOnTypeFormattingEdits(O,H,K,Q,he,be){return this._withAdapter(O,X,ce=>ce.provideOnTypeFormattingEdits(u.URI.revive(H),K,Q,he,be),void 0,be)}registerWorkspaceSymbolProvider(O,H){const K=this._addNewAdapter(new z(H,this._logService),O);return this._proxy.$registerNavigateTypeSupport(K,typeof H.resolveWorkspaceSymbol=="function"),this._createDisposable(K)}$provideWorkspaceSymbols(O,H,K){return this._withAdapter(O,z,Q=>Q.provideWorkspaceSymbols(H,K),{symbols:[]},K)}$resolveWorkspaceSymbol(O,H,K){return this._withAdapter(O,z,Q=>Q.resolveWorkspaceSymbol(H,K),void 0,void 0)}$releaseWorkspaceSymbols(O,H){this._withAdapter(O,z,K=>K.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(O,H,K){const Q=this._addNewAdapter(new N(this._documents,K,this._logService),O);return this._proxy.$registerRenameSupport(Q,this._transformDocumentSelector(H),N.supportsResolving(K)),this._createDisposable(Q)}$provideRenameEdits(O,H,K,Q,he){return this._withAdapter(O,N,be=>be.provideRenameEdits(u.URI.revive(H),K,Q,he),void 0,he)}$resolveRenameLocation(O,H,K,Q){return this._withAdapter(O,N,he=>he.resolveRenameLocation(u.URI.revive(H),K,Q),void 0,Q)}registerDocumentSemanticTokensProvider(O,H,K,Q){const he=this._addNewAdapter(new x(this._documents,K),O),be=typeof K.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(he,this._transformDocumentSelector(H),Q,be);let ce=this._createDisposable(he);if(be){const De=K.onDidChangeSemanticTokens(ye=>this._proxy.$emitDocumentSemanticTokensEvent(be));ce=T.Disposable.from(ce,De)}return ce}$provideDocumentSemanticTokens(O,H,K,Q){return this._withAdapter(O,x,he=>he.provideDocumentSemanticTokens(u.URI.revive(H),K,Q),null,Q)}$releaseDocumentSemanticTokens(O,H){this._withAdapter(O,x,K=>K.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,H,K,Q){const he=this._addNewAdapter(new q(this._documents,K),O);return this._proxy.$registerDocumentRangeSemanticTokensProvider(he,this._transformDocumentSelector(H),Q),this._createDisposable(he)}$provideDocumentRangeSemanticTokens(O,H,K,Q){return this._withAdapter(O,q,he=>he.provideDocumentRangeSemanticTokens(u.URI.revive(H),K,Q),null,Q)}registerCompletionItemProvider(O,H,K,Q){const he=this._addNewAdapter(new te(this._documents,this._commands.converter,K,this._apiDeprecation,O),O);return this._proxy.$registerCompletionsProvider(he,this._transformDocumentSelector(H),Q,te.supportsResolving(K),`${O.identifier.value}(${Q.join("")})`),this._createDisposable(he)}$provideCompletionItems(O,H,K,Q,he){return this._withAdapter(O,te,be=>be.provideCompletionItems(u.URI.revive(H),K,Q,he),void 0,he)}$resolveCompletionItem(O,H,K){return this._withAdapter(O,te,Q=>Q.resolveCompletionItem(H,K),void 0,K)}$releaseCompletionItems(O,H){this._withAdapter(O,te,K=>K.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(O,H,K){const Q=new le(O,this._documents,K,this._commands.converter),he=this._addNewAdapter(Q,O);return this._proxy.$registerInlineCompletionsSupport(he,this._transformDocumentSelector(H),Q.supportsHandleDidShowCompletionItem),this._createDisposable(he)}registerInlineCompletionsProviderNew(O,H,K){const Q=this._addNewAdapter(new pe(O,this._documents,K,this._commands.converter),O);return this._proxy.$registerInlineCompletionsSupport(Q,this._transformDocumentSelector(H),!0),this._createDisposable(Q)}$provideInlineCompletions(O,H,K,Q,he){return this._withAdapter(O,Y,be=>be.provideInlineCompletions(u.URI.revive(H),K,Q,he),void 0,he)}$handleInlineCompletionDidShow(O,H,K){this._withAdapter(O,Y,async Q=>{Q.handleDidShowCompletionItem(H,K)},void 0,void 0)}$freeInlineCompletionsList(O,H){this._withAdapter(O,Y,async K=>{K.disposeCompletions(H)},void 0,void 0)}registerSignatureHelpProvider(O,H,K,Q){const he=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,be=this._addNewAdapter(new ge(this._documents,K),O);return this._proxy.$registerSignatureHelpProvider(be,this._transformDocumentSelector(H),he),this._createDisposable(be)}$provideSignatureHelp(O,H,K,Q,he){return this._withAdapter(O,ge,be=>be.provideSignatureHelp(u.URI.revive(H),K,Q,he),void 0,he)}$releaseSignatureHelp(O,H){this._withAdapter(O,ge,K=>K.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(O,H,K){const Q=typeof K.onDidChangeInlayHints=="function"?this._nextHandle():void 0,he=this._addNewAdapter(new Ee(this._documents,this._commands.converter,K,this._logService,O),O);this._proxy.$registerInlayHintsProvider(he,this._transformDocumentSelector(H),typeof K.resolveInlayHint=="function",Q,Z._extLabel(O));let be=this._createDisposable(he);if(Q!==void 0){const ce=K.onDidChangeInlayHints(De=>this._proxy.$emitInlayHintsEvent(Q));be=T.Disposable.from(be,ce)}return be}$provideInlayHints(O,H,K,Q){return this._withAdapter(O,Ee,he=>he.provideInlayHints(u.URI.revive(H),K,Q),void 0,Q)}$resolveInlayHint(O,H,K){return this._withAdapter(O,Ee,Q=>Q.resolveInlayHint(H,K),void 0,K)}$releaseInlayHints(O,H){this._withAdapter(O,Ee,K=>K.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(O,H,K){const Q=this._addNewAdapter(new Pe(this._documents,K),O);return this._proxy.$registerDocumentLinkProvider(Q,this._transformDocumentSelector(H),typeof K.resolveDocumentLink=="function"),this._createDisposable(Q)}$provideDocumentLinks(O,H,K){return this._withAdapter(O,Pe,Q=>Q.provideLinks(u.URI.revive(H),K),void 0,K,H.scheme==="output")}$resolveDocumentLink(O,H,K){return this._withAdapter(O,Pe,Q=>Q.resolveLink(H,K),void 0,void 0,!0)}$releaseDocumentLinks(O,H){this._withAdapter(O,Pe,K=>K.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(O,H,K){const Q=this._addNewAdapter(new Ne(this._documents,K),O);return this._proxy.$registerDocumentColorProvider(Q,this._transformDocumentSelector(H)),this._createDisposable(Q)}$provideDocumentColors(O,H,K){return this._withAdapter(O,Ne,Q=>Q.provideColors(u.URI.revive(H),K),[],K)}$provideColorPresentations(O,H,K,Q){return this._withAdapter(O,Ne,he=>he.provideColorPresentations(u.URI.revive(H),K,Q),void 0,Q)}registerFoldingRangeProvider(O,H,K){const Q=this._nextHandle(),he=typeof K.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(Q,new me(new ve(this._documents,K),O)),this._proxy.$registerFoldingRangeProvider(Q,this._transformDocumentSelector(H),he);let be=this._createDisposable(Q);if(he!==void 0){const ce=K.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(he));be=T.Disposable.from(be,ce)}return be}$provideFoldingRanges(O,H,K,Q){return this._withAdapter(O,ve,he=>he.provideFoldingRanges(u.URI.revive(H),K,Q),void 0,Q)}registerSelectionRangeProvider(O,H,K){const Q=this._addNewAdapter(new ue(this._documents,K,this._logService),O);return this._proxy.$registerSelectionRangeProvider(Q,this._transformDocumentSelector(H)),this._createDisposable(Q)}$provideSelectionRanges(O,H,K,Q){return this._withAdapter(O,ue,he=>he.provideSelectionRanges(u.URI.revive(H),K,Q),[],Q)}registerCallHierarchyProvider(O,H,K){const Q=this._addNewAdapter(new de(this._documents,K),O);return this._proxy.$registerCallHierarchyProvider(Q,this._transformDocumentSelector(H)),this._createDisposable(Q)}$prepareCallHierarchy(O,H,K,Q){return this._withAdapter(O,de,he=>Promise.resolve(he.prepareSession(u.URI.revive(H),K,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(O,H,K,Q){return this._withAdapter(O,de,he=>he.provideCallsTo(H,K,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(O,H,K,Q){return this._withAdapter(O,de,he=>he.provideCallsFrom(H,K,Q),void 0,Q)}$releaseCallHierarchy(O,H){this._withAdapter(O,de,K=>Promise.resolve(K.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(O,H,K){const Q=this._addNewAdapter(new we(this._documents,K),O);return this._proxy.$registerTypeHierarchyProvider(Q,this._transformDocumentSelector(H)),this._createDisposable(Q)}$prepareTypeHierarchy(O,H,K,Q){return this._withAdapter(O,we,he=>Promise.resolve(he.prepareSession(u.URI.revive(H),K,Q)),void 0,Q)}$provideTypeHierarchySupertypes(O,H,K,Q){return this._withAdapter(O,we,he=>he.provideSupertypes(H,K,Q),void 0,Q)}$provideTypeHierarchySubtypes(O,H,K,Q){return this._withAdapter(O,we,he=>he.provideSubtypes(H,K,Q),void 0,Q)}$releaseTypeHierarchy(O,H){this._withAdapter(O,we,K=>Promise.resolve(K.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(O,H,K){const Q=this._nextHandle();return this._adapter.set(Q,new me(new re(this._proxy,this._documents,K,Q),O)),this._proxy.$registerDocumentOnDropEditProvider(Q,this._transformDocumentSelector(H)),this._createDisposable(Q)}$provideDocumentOnDropEdits(O,H,K,Q,he,be){return this._withAdapter(O,re,ce=>Promise.resolve(ce.provideDocumentOnDropEdits(H,u.URI.revive(K),Q,he,be)),void 0,void 0)}registerDocumentPasteEditProvider(O,H,K,Q){const he=this._nextHandle();return this._adapter.set(he,new me(new B(this._proxy,this._documents,K,he),O)),this._proxy.$registerPasteEditProvider(he,this._transformDocumentSelector(H),!!K.prepareDocumentPaste,Q.pasteMimeTypes),this._createDisposable(he)}$prepareDocumentPaste(O,H,K,Q,he){return this._withAdapter(O,B,be=>be.prepareDocumentPaste(u.URI.revive(H),K,Q,he),void 0,he)}$providePasteEdits(O,H,K,Q,he,be){return this._withAdapter(O,B,ce=>ce.providePasteEdits(H,u.URI.revive(K),Q,he,be),void 0,be)}static _serializeRegExp(O){return{pattern:O.source,flags:(0,b.regExpFlags)(O)}}static _serializeIndentationRule(O){return{decreaseIndentPattern:Z._serializeRegExp(O.decreaseIndentPattern),increaseIndentPattern:Z._serializeRegExp(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?Z._serializeRegExp(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?Z._serializeRegExp(O.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(O){return{beforeText:Z._serializeRegExp(O.beforeText),afterText:O.afterText?Z._serializeRegExp(O.afterText):void 0,previousLineText:O.previousLineText?Z._serializeRegExp(O.previousLineText):void 0,action:O.action}}static _serializeOnEnterRules(O){return O.map(Z._serializeOnEnterRule)}setLanguageConfiguration(O,H,K){const{wordPattern:Q}=K;if(Q&&(0,b.regExpLeadsToEndlessLoop)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this._documents.setWordDefinitionFor(H,Q):this._documents.setWordDefinitionFor(H,void 0),K.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),K.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const he=this._nextHandle(),be={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?Z._serializeRegExp(K.wordPattern):void 0,indentationRules:K.indentationRules?Z._serializeIndentationRule(K.indentationRules):void 0,onEnterRules:K.onEnterRules?Z._serializeOnEnterRules(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport};return this._proxy.$setLanguageConfiguration(he,H,be),this._createDisposable(he)}$setWordDefinitions(O){for(const H of O)this._documents.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.ExtHostLanguageFeatures=Z,Z._handlePool=0}),define(Ie[252],ke([0,1,5,15,7,41,18,6]),function(J,e,u,n,D,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class b{constructor(R,k,_,P){this._documents=k,this._commands=_,this._uriTransformer=P,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(u.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,k){await this._proxy.$changeLanguage(R,k);const _=this._documents.getDocumentData(R);if(!_)throw new Error(`document '${R.toString()}' NOT found`);return _.document}async tokenAtPosition(R,k){const _=R.version,P=n.Position.from(k),v=await this._proxy.$tokensAtPosition(R.uri,P),w={type:D.StandardTokenType.Other,range:R.getWordRangeAtPosition(k)??new D.Range(k.line,k.character,k.line,k.character)};if(!v)return w;const p={range:n.Range.to(v.range),type:n.TokenType.to(v.type)};return!p.range.contains(k)||_!==R.version?w:p}createLanguageStatusItem(R,k,_){const P=this._handlePool++,v=this._proxy,w=this._ids,p=`${R.identifier.value}/${k}`;if(w.has(p))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);w.add(p);const f={selector:_,id:k,name:R.displayName??R.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let E;const g=new y.DisposableStore,c=()=>{E?.dispose(),E=(0,C.disposableTimeout)(()=>{g.clear(),this._proxy.$setLanguageStatus(P,{id:p,name:f.name??R.displayName??R.name,source:R.displayName??R.name,selector:n.DocumentSelector.from(f.selector,this._uriTransformer),label:f.text,detail:f.detail??"",severity:f.severity===D.LanguageStatusSeverity.Error?T.default.Error:f.severity===D.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:f.command&&this._commands.toInternal(f.command,g),accessibilityInfo:f.accessibilityInformation,busy:f.busy})},0)},m={dispose(){g.dispose(),E?.dispose(),v.$removeLanguageStatus(P),w.delete(p)},get id(){return f.id},get name(){return f.name},set name(a){f.name=a,c()},get selector(){return f.selector},set selector(a){f.selector=a,c()},get text(){return f.text},set text(a){f.text=a,c()},get detail(){return f.detail},set detail(a){f.detail=a,c()},get severity(){return f.severity},set severity(a){f.severity=a,c()},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(a){f.accessibilityInformation=a,c()},get command(){return f.command},set command(a){f.command=a,c()},get busy(){return f.busy},set busy(a){f.busy=a,c()}};return c(),m}}e.ExtHostLanguages=b}),define(Ie[136],ke([0,1,14,5,26,17,3]),function(J,e,u,n,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends u.AbstractLoggerService{constructor(R,k){const _=new C.Emitter;super(k.logLevel,_.event);this._proxy=R.getProxy(n.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(_)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,k,_){return new b(this._proxy,R,k,_)}};y=je([Ve(0,T.IExtHostRpcService),Ve(1,D.IExtHostInitDataService)],y),e.ExtHostLoggerService=y;class b extends u.AbstractMessageLogger{constructor(R,k,_,P){super(P?.always);this.proxy=R,this.file=k,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(_),this.proxy.$createLogger(k,P).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,k){const _=[[R,k]];this.isLoggerCreated?this.doLog(_):this.buffer.push(..._)}doLog(R){this.proxy.$log(this.file,R)}}}),define(Ie[253],ke([0,1,5,14,27]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(y){return y&&y.title}let C=class{constructor(b,I){this._logService=I,this._proxy=b.getProxy(u.MainContext.MainThreadMessageService)}showMessage(b,I,R,k,_){const P={source:{identifier:b.identifier,label:b.displayName||b.name}};let v;typeof k=="string"||T(k)?v=[k,..._]:(P.modal=k?.modal,P.useCustom=k?.useCustom,P.detail=k?.detail,v=_),P.useCustom&&(0,D.checkProposedApiEnabled)(b,"resolvers");const w=[];for(let p=0;p<v.length;p++){const f=v[p];if(typeof f=="string")w.push({title:f,handle:p,isCloseAffordance:!1});else if(typeof f=="object"){const{title:E,isCloseAffordance:g}=f;w.push({title:E,isCloseAffordance:!!g,handle:p})}else this._logService.warn("Invalid message item:",f)}return this._proxy.$showMessage(I,R,P,w).then(p=>{if(typeof p=="number")return v[p]})}};C=je([Ve(1,n.ILogService)],C),e.ExtHostMessageService=C}),define(Ie[254],ke([0,1,23,3,60,6,25,8,11,2,87,5,38,15,7,53,224,131]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v,w,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class E{constructor(c,m,a,d,i){this._textDocumentsAndEditors=a,this._textDocuments=d,this._extensionStoragePaths=i,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new C.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new n.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new n.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new n.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new n.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=c.getProxy(k.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=c.getProxy(k.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=c.getProxy(k.MainContext.MainThreadNotebookEditors),this._commandsConverter=m.converter,m.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===12){const r=o.notebookEditor?.notebookUri,t=o.cell.handle,l=this._documents.get(r)?.getCell(t);if(l)return l.apiCell}return o}}),E._registerApiCommands(m)}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(c=>c.apiEditor)}getEditorById(c){const m=this._editors.get(c);if(!m)throw new Error(`unknown text editor: ${c}. known editors: ${[...this._editors.keys()]} `);return m}getIdByEditor(c){for(const[m,a]of this._editors)if(a.apiEditor===c)return m}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(c,m){const a=this._documents.get(c);if(!a&&!m)throw new Error(`NO notebook document for '${c}'`);return a}_getProviderData(c){const m=this._notebookContentProviders.get(c);if(!m)throw new Error(`NO provider for '${c}'`);return m}registerNotebookContentProvider(c,m,a,d,i){if((0,y.isFalsyOrWhitespace)(m))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(m))throw new Error(`Notebook provider for '${m}' already registered`);this._notebookContentProviders.set(m,{extension:c,provider:a});let o;return a.onDidChangeNotebookContentOptions&&(o=a.onDidChangeNotebookContentOptions(()=>{const r=P.NotebookDocumentContentOptions.from(a.options);this._notebookProxy.$updateNotebookProviderOptions(m,r)})),this._notebookProxy.$registerNotebookProvider({id:c.identifier,location:c.extensionLocation},m,P.NotebookDocumentContentOptions.from(d),E._convertNotebookRegistrationData(c,i)),new v.Disposable(()=>{o?.dispose(),this._notebookContentProviders.delete(m),this._notebookProxy.$unregisterNotebookProvider(m)})}static _convertNotebookRegistrationData(c,m){if(!m)return;const a=m.filenamePattern.map(d=>P.NotebookExclusiveDocumentPattern.from(d)).filter(d=>d!==void 0);if(m.filenamePattern&&!a){console.warn(`Notebook content provider view options file name pattern is invalid ${m.filenamePattern}`);return}return{extension:c.identifier,providerDisplayName:c.displayName||c.name,displayName:m.displayName,filenamePattern:a,exclusive:m.exclusive||!1}}registerNotebookCellStatusBarItemProvider(c,m,a){const d=E._notebookStatusBarItemProviderHandlePool++,i=typeof a.onDidChangeCellStatusBarItems=="function"?E._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(d,a),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(d,i,m);let o;return i!==void 0&&(o=a.onDidChangeCellStatusBarItems(r=>this._notebookProxy.$emitCellStatusBarEvent(i))),new v.Disposable(()=>{this._notebookStatusBarItemProviders.delete(d),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(d,i),o&&o.dispose()})}async createNotebookDocument(c){const m=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:c.viewType,content:c.content&&P.NotebookData.from(c.content)});return I.URI.revive(m)}async openNotebookDocument(c){const m=this._documents.get(c);if(m)return m.apiNotebook;const a=await this._notebookDocumentsProxy.$tryOpenNotebook(c),d=this._documents.get(I.URI.revive(a));return(0,b.assertIsDefined)(d?.apiNotebook)}async showNotebookDocument(c,m){I.URI.isUri(c)&&(c=await this.openNotebookDocument(c));let a;typeof m=="object"?a={position:P.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus,selections:m.selections&&m.selections.map(P.NotebookRange.from),pinned:typeof m.preview=="boolean"?!m.preview:void 0}:a={preserveFocus:!1};const d=await this._notebookEditorsProxy.$tryShowNotebookDocument(c.uri,c.notebookType,a),i=d&&this._editors.get(d)?.apiEditor;if(i)return i;throw d?new Error(`Could NOT open editor for "${c.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${c.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(c,m,a,d){const i=this._notebookStatusBarItemProviders.get(c),o=I.URI.revive(m),r=this._documents.get(o);if(!r||!i)return;const t=r.getCellFromIndex(a);if(!t)return;const s=await i.provideCellStatusBarItems(t.apiCell,d);if(!s)return;const l=new T.DisposableStore,h=this._statusBarCache.add([l]),L=(Array.isArray(s)?s:[s]).map(F=>P.NotebookStatusBarItem.from(F,this._commandsConverter,l));return{cacheId:h,items:L}}$releaseNotebookCellStatusBarItems(c){this._statusBarCache.delete(c)}registerNotebookSerializer(c,m,a,d,i){if((0,y.isFalsyOrWhitespace)(m))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,a),this._notebookProxy.$registerNotebookSerializer(o,{id:c.identifier,location:c.extensionLocation},m,P.NotebookDocumentContentOptions.from(d),E._convertNotebookRegistrationData(c,i)),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(c,m,a){const d=this._notebookSerializer.get(c);if(!d)throw new Error("NO serializer found");const i=await d.deserializeNotebook(m.buffer,a);return new w.SerializableObjectWithBuffers(P.NotebookData.from(i))}async $notebookToData(c,m,a){const d=this._notebookSerializer.get(c);if(!d)throw new Error("NO serializer found");const i=await d.serializeNotebook(P.NotebookData.to(m.value),a);return u.VSBuffer.wrap(i)}async $openNotebook(c,m,a,d,i){const{provider:o}=this._getProviderData(c),r=await o.openNotebook(I.URI.revive(m),{backupId:a,untitledDocumentData:d?.buffer},i);return new w.SerializableObjectWithBuffers({metadata:r.metadata??Object.create(null),cells:r.cells.map(P.NotebookCellData.from)})}async $saveNotebook(c,m,a){const d=this.getNotebookDocument(I.URI.revive(m)),{provider:i}=this._getProviderData(c);return await i.saveNotebook(d.apiNotebook,a),!0}async $saveNotebookAs(c,m,a,d){const i=this.getNotebookDocument(I.URI.revive(m)),{provider:o}=this._getProviderData(c);return await o.saveNotebookAs(I.URI.revive(a),i.apiNotebook,d),!0}async $backupNotebook(c,m,a){const d=this.getNotebookDocument(I.URI.revive(m)),i=this._getProviderData(c),o=this._extensionStoragePaths.workspaceValue(i.extension)??this._extensionStoragePaths.globalValue(i.extension),r=String((0,D.hash)([d.uri.toString(),this._backupIdPool++])),t=I.URI.joinPath(o,r),s=await i.provider.backupNotebook(d.apiNotebook,{destination:t},a);return d.updateBackup(s),s.id}_createExtHostEditor(c,m,a){if(this._editors.has(m))throw new Error(`editor with id ALREADY EXSIST: ${m}`);const d=new f.ExtHostNotebookEditor(m,this._notebookEditorsProxy,c,a.visibleRanges.map(P.NotebookRange.to),a.selections.map(P.NotebookRange.to),typeof a.viewColumn=="number"?P.ViewColumn.to(a.viewColumn):void 0);this._editors.set(m,d)}$acceptDocumentAndEditorsDelta(c){if(c.value.removedDocuments)for(const a of c.value.removedDocuments){const d=I.URI.revive(a),i=this._documents.get(d);i&&(i.dispose(),this._documents.delete(d),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:i.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(i.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===d.toString()&&this._editors.delete(o.id)}if(c.value.addedDocuments){const a=[];for(const d of c.value.addedDocuments){const i=I.URI.revive(d.uri);if(this._documents.has(i))throw new Error(`adding EXISTING notebook ${i} `);const o=new p.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,i,d);a.push(...d.cells.map(r=>p.ExtHostCell.asModelAddData(o.apiNotebook,r))),this._documents.get(i)?.dispose(),this._documents.set(i,o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:a}),this._onDidOpenNotebookDocument.fire(o.apiNotebook)}}if(c.value.addedEditors)for(const a of c.value.addedEditors){if(this._editors.has(a.id))return;const d=I.URI.revive(a.documentUri),i=this._documents.get(d);i&&this._createExtHostEditor(i,a.id,a)}const m=[];if(c.value.removedEditors)for(const a of c.value.removedEditors){const d=this._editors.get(a);d&&(this._editors.delete(a),this._activeNotebookEditor?.id===d.id&&(this._activeNotebookEditor=void 0),m.push(d))}if(c.value.visibleEditors){this._visibleNotebookEditors=c.value.visibleEditors.map(d=>this._editors.get(d)).filter(d=>!!d);const a=new Set;this._visibleNotebookEditors.forEach(d=>a.add(d.id));for(const d of this._editors.values()){const i=a.has(d.id);d._acceptVisibility(i)}this._visibleNotebookEditors=[...this._editors.values()].map(d=>d).filter(d=>d.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}c.value.newActiveEditor===null?this._activeNotebookEditor=void 0:c.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(c.value.newActiveEditor)),c.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(c){const m=_.ApiCommandArgument.String.with("notebookType","A notebook type"),a=new _.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[m,new _.ApiCommandArgument("data","Bytes to convert to data",i=>i instanceof Uint8Array,i=>u.VSBuffer.wrap(i))],new _.ApiCommandResult("Notebook Data",i=>P.NotebookData.to(i.value))),d=new _.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[m,new _.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",i=>!0,i=>new w.SerializableObjectWithBuffers(P.NotebookData.from(i)))],new _.ApiCommandResult("Bytes",i=>i.buffer));c.registerApiCommand(a),c.registerApiCommand(d)}}e.ExtHostNotebookController=E,E._notebookStatusBarItemProviderHandlePool=0}),define(Ie[255],ke([0,1,16,18,21,3,6,25,2,28,14,5,38,15,7,88,219,27,53]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v,w,p,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let g=class{constructor(o,r,t,s,l){this._initData=r,this._extHostNotebook=t,this._commands=s,this._logService=l,this._activeExecutions=new y.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=o.getProxy(k.MainContext.MainThreadNotebookKernels);const h=new _.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new _.ApiCommandArgument("options","Select kernel options",S=>!0,S=>{if(S&&"notebookEditor"in S&&"id"in S){const L=this._extHostNotebook.getIdByEditor(S.notebookEditor);return{id:S.id,extension:S.extension,notebookEditorId:L}}else if(S&&"notebookEditor"in S){const L=this._extHostNotebook.getIdByEditor(S.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${S.notebookEditor.document.uri.toString()}`);return{notebookEditorId:L}}return S})],_.ApiCommandResult.Void);this._commands.registerApiCommand(h)}createNotebookController(o,r,t,s,l,h){for(const te of this._kernelData.values())if(te.controller.id===r&&I.ExtensionIdentifier.equals(o.identifier,te.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const S=this._handlePool++,L=this;this._logService.trace(`NotebookController[${S}], CREATED by ${o.identifier.value}, ${r}`);const F=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${o.identifier}'`);let M=!1;const A=new C.DisposableStore,B=new T.Emitter,$=new T.Emitter,U={id:d(o.identifier,r),notebookType:t,extensionId:o.identifier,extensionLocation:o.extensionLocation,label:s||o.identifier.value,preloads:h?h.map(P.NotebookRendererScript.from):[]};let X=l??F,z;this._proxy.$addKernel(S,U).catch(te=>{console.log(te),M=!0});let N=0;const V=()=>{if(M)return;const te=++N;Promise.resolve().then(()=>{te===N&&this._proxy.$updateKernel(S,U)})},x=new y.ResourceMap,q={get id(){return r},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return U.label},set label(te){U.label=te??o.displayName??o.name,V()},get detail(){return U.detail??""},set detail(te){U.detail=te,V()},get description(){return U.description??""},set description(te){U.description=te,V()},get kind(){return(0,f.checkProposedApiEnabled)(o,"notebookControllerKind"),U.kind??""},set kind(te){(0,f.checkProposedApiEnabled)(o,"notebookControllerKind"),U.kind=te,V()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(te){U.supportedLanguages=te,V()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(te){U.supportsExecutionOrder=te,V()},get rendererScripts(){return U.preloads?U.preloads.map(P.NotebookRendererScript.to):[]},get executeHandler(){return X},set executeHandler(te){X=te??F},get interruptHandler(){return z},set interruptHandler(te){z=te,U.supportsInterrupt=Boolean(te),V()},createNotebookCellExecution(te){if(M)throw new Error("notebook controller is DISPOSED");if(!x.has(te.notebook.uri))throw L._logService.trace(`NotebookController[${S}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(Y=>Y.toString())),new Error(`notebook controller is NOT associated to notebook: ${te.notebook.uri.toString()}`);return L._createNotebookCellExecution(te,d(o.identifier,this.id))},dispose:()=>{M||(this._logService.trace(`NotebookController[${S}], DISPOSED`),M=!0,this._kernelData.delete(S),A.dispose(),B.dispose(),$.dispose(),this._proxy.$removeKernel(S))},updateNotebookAffinity(te,Y){L._proxy.$updateNotebookPriority(S,te.uri,Y)},onDidReceiveMessage:$.event,postMessage(te,Y){return(0,f.checkProposedApiEnabled)(o,"notebookMessaging"),L._proxy.$postMessage(S,Y&&L._extHostNotebook.getIdByEditor(Y),te)},asWebviewUri(te){return(0,f.checkProposedApiEnabled)(o,"notebookMessaging"),(0,w.asWebviewUri)(te,L._initData.remote)}};return this._kernelData.set(S,{extensionId:o.identifier,controller:q,onDidReceiveMessage:$,onDidChangeSelection:B,associatedNotebooks:x}),q}getIdByController(o){for(const[r,t]of this._kernelData)if(t.controller===o)return d(t.extensionId,o.id);return null}$acceptNotebookAssociation(o,r,t){const s=this._kernelData.get(o);if(s){const l=this._extHostNotebook.getNotebookDocument(b.URI.revive(r));t?s.associatedNotebooks.set(l.uri,!0):s.associatedNotebooks.delete(l.uri),this._logService.trace(`NotebookController[${o}] ASSOCIATE notebook`,l.uri.toString(),t),s.onDidChangeSelection.fire({selected:t,notebook:l.apiNotebook})}}async $executeCells(o,r,t){const s=this._kernelData.get(o);if(!s)return;const l=this._extHostNotebook.getNotebookDocument(b.URI.revive(r)),h=[];for(const S of t){const L=l.getCell(S);L&&h.push(L.apiCell)}try{this._logService.trace(`NotebookController[${o}] EXECUTE cells`,l.uri.toString(),h.length),await s.controller.executeHandler.call(s.controller,h,l.apiNotebook,s.controller)}catch(S){this._logService.error(`NotebookController[${o}] execute cells FAILED`,S),console.error(S)}}async $cancelCells(o,r,t){const s=this._kernelData.get(o);if(!s)return;const l=this._extHostNotebook.getNotebookDocument(b.URI.revive(r));if(s.controller.interruptHandler)await s.controller.interruptHandler.call(s.controller,l.apiNotebook);else for(const h of t){const S=l.getCell(h);S&&this._activeExecutions.get(S.uri)?.cancel()}}$acceptKernelMessageFromRenderer(o,r,t){const s=this._kernelData.get(o);if(!s)return;const l=this._extHostNotebook.getEditorById(r);s.onDidReceiveMessage.fire(Object.freeze({editor:l.apiEditor,message:t}))}$cellExecutionChanged(o,r,t){const l=this._extHostNotebook.getNotebookDocument(b.URI.revive(o)).getCell(r);l&&this._onDidChangeCellExecutionState.fire({cell:l.apiCell,state:t?P.NotebookCellExecutionState.to(t):v.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(o,r){if(o.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(o.notebook.uri).getCellFromApiCell(o);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const l=new m(r,s,this._proxy);this._activeExecutions.set(s.uri,l);const h=l.onDidChangeState(()=>{l.state===c.Resolved&&(l.dispose(),h.dispose(),this._activeExecutions.delete(s.uri))});return l.asApiObject()}};g=je([Ve(4,R.ILogService)],g),e.ExtHostNotebookKernels=g;var c;(function(i){i[i.Init=0]="Init",i[i.Started=1]="Started",i[i.Resolved=2]="Resolved"})(c||(c={}));class m extends C.Disposable{constructor(o,r,t){super();this._cell=r,this._proxy=t,this._handle=m.HANDLE++,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new D.CancellationTokenSource),this._collector=new a(10,s=>this.update(s)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,o,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(o){await this._collector.addItem(o)}async update(o){const r=Array.isArray(o)?o:[o];return this._proxy.$updateExecution(this._handle,new E.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===c.Init)throw new Error("Must call start before modifying cell output");if(this._state===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(o){let r=this._cell;if(o&&(r=this._cell.notebook.getCellFromApiCell(o)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(o){return o.map(r=>{const t=v.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return t===r.items?P.NotebookCellOutput.from(r):P.NotebookCellOutput.from({items:t,id:r.id,metadata:r.metadata})})}async updateOutputs(o,r,t){const s=this.cellIndexToHandle(r),l=this.validateAndConvertOutputs((0,u.asArray)(o));return this.updateSoon({editType:p.CellExecutionUpdateType.Output,cellHandle:s,append:t,outputs:l})}async updateOutputItems(o,r,t){return o=v.NotebookCellOutput.ensureUniqueMimeTypes((0,u.asArray)(o),!0),this.updateSoon({editType:p.CellExecutionUpdateType.OutputItems,items:o.map(P.NotebookCellOutputItem.from),outputId:r.id,append:t})}asApiObject(){const o=this;return Object.freeze({get token(){return o._tokenSource.token},get cell(){return o._cell.apiCell},get executionOrder(){return o._executionOrder},set executionOrder(t){o._executionOrder=t,o.update([{editType:p.CellExecutionUpdateType.ExecutionState,executionOrder:o._executionOrder}])},start(t){if(o._state===c.Resolved||o._state===c.Started)throw new Error("Cannot call start again");o._state=c.Started,o._onDidChangeState.fire(),o.update({editType:p.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,s){if(o._state===c.Resolved)throw new Error("Cannot call resolve twice");o._state=c.Resolved,o._onDidChangeState.fire(),o._collector.flush(),o._proxy.$completeExecution(o._handle,new E.SerializableObjectWithBuffers({runEndTime:s,lastRunSuccess:t}))},clearOutput(t){return o.verifyStateForOutput(),o.updateOutputs([],t,!1)},appendOutput(t,s){return o.verifyStateForOutput(),o.updateOutputs(t,s,!0)},replaceOutput(t,s){return o.verifyStateForOutput(),o.updateOutputs(t,s,!1)},appendOutputItems(t,s){return o.verifyStateForOutput(),o.updateOutputItems(t,s,!0)},replaceOutputItems(t,s){return o.verifyStateForOutput(),o.updateOutputItems(t,s,!1)}})}}m.HANDLE=0;class a{constructor(o,r){this.delay=o,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(o){return this.batch.push(o),this.currentDeferred||(this.currentDeferred=new n.DeferredPromise,this.startedTimer=Date.now(),(0,n.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const o=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>o.complete())}}function d(i,o){return`${i.value}/${o}`}e.createKernelId=d}),define(Ie[256],ke([0,1,3,5,131]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class T{constructor(y,b){this._extHostNotebook=b,this._rendererMessageEmitters=new Map,this.proxy=y.getProxy(n.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(y,b,I){const R=this._extHostNotebook.getEditorById(y);this._rendererMessageEmitters.get(b)?.fire({editor:R.apiEditor,message:I})}createRendererMessaging(y,b){if(!y.contributes?.notebookRenderer?.some(R=>R.id===b))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${b})`);return{onDidReceiveMessage:(R,k,_)=>this.getOrCreateEmitterFor(b).event(R,k,_),postMessage:(R,k)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,k]=[k,R]);const _=k&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);return this.proxy.$postMessage(_?.id,b,R)}}}getOrCreateEmitterFor(y){let b=this._rendererMessageEmitters.get(y);return b||(b=new u.Emitter({onLastListenerRemove:()=>{b?.dispose(),this._rendererMessageEmitters.delete(y)}}),this._rendererMessageEmitters.set(y,b),b)}}e.ExtHostNotebookRenderers=T}),define(Ie[257],ke([0,1,21,3,6,5,2,7,12,16,41,86]),function(J,e,u,n,D,T,C,y,b,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function _(P,v,w){const p=P.getProxy(T.MainContext.MainThreadQuickOpen);class f{constructor(r,t){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=t}showQuickPick(r,t,s=u.CancellationToken.None){this._onDidSelectItem=void 0;const l=Promise.resolve(r),h=++this._instances,S=p.$show(h,{title:t?.title,placeHolder:t?.placeHolder,matchOnDescription:t?.matchOnDescription,matchOnDetail:t?.matchOnDetail,ignoreFocusLost:t?.ignoreFocusOut,canPickMany:t?.canPickMany},s),L={},F=S.then(()=>L);return Promise.race([F,l]).then(M=>{if(M!==L)return l.then(A=>{const B=[];for(let $=0;$<A.length;$++){const U=A[$];typeof U=="string"?B.push({label:U,handle:$}):U.kind===y.QuickPickItemKind.Separator?B.push({type:"separator",label:U.label}):B.push({label:U.label,description:U.description,detail:U.detail,picked:U.picked,alwaysShow:U.alwaysShow,handle:$})}return t&&typeof t.onDidSelectItem=="function"&&(this._onDidSelectItem=$=>{t.onDidSelectItem(A[$])}),p.$setItems(h,B),S.then($=>{if(typeof $=="number")return A[$];if(Array.isArray($))return $.map(U=>A[U])})})}).then(void 0,M=>{if(!(0,b.isCancellationError)(M))return p.$setError(h,M),Promise.reject(M)})}$onItemSelected(r){this._onDidSelectItem?.(r)}showInput(r,t=u.CancellationToken.None){return this._validateInput=r?.validateInput,p.$input(r,typeof this._validateInput=="function",t).then(void 0,s=>{if(!(0,b.isCancellationError)(s))return Promise.reject(s)})}async $validateInput(r){if(!this._validateInput)return;const t=await this._validateInput(r);if(!t||typeof t=="string")return t;let s;switch(t.severity){case y.InputBoxValidationSeverity.Info:s=R.default.Info;break;case y.InputBoxValidationSeverity.Warning:s=R.default.Warning;break;case y.InputBoxValidationSeverity.Error:s=R.default.Error;break;default:s=t.message?R.default.Error:R.default.Ignore;break}return{content:t.message,severity:s}}async showWorkspaceFolderPick(r,t=u.CancellationToken.None){const s=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!s)return;const l=await this._workspace.getWorkspaceFolders2();if(!!l)return l.find(h=>h.uri.toString()===s.uri.toString())}createQuickPick(r){const t=new d(r,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}createInputBox(r){const t=new i(r,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}$onDidChangeValue(r,t){this._sessions.get(r)?._fireDidChangeValue(t)}$onDidAccept(r){const t=this._sessions.get(r);t&&t._fireDidAccept()}$onDidChangeActive(r,t){const s=this._sessions.get(r);s instanceof d&&s._fireDidChangeActive(t)}$onDidChangeSelection(r,t){const s=this._sessions.get(r);s instanceof d&&s._fireDidChangeSelection(t)}$onDidTriggerButton(r,t){this._sessions.get(r)?._fireDidTriggerButton(t)}$onDidTriggerItemButton(r,t,s){const l=this._sessions.get(r);l instanceof d&&l._fireDidTriggerItemButton(t,s)}$onDidHide(r){const t=this._sessions.get(r);t&&t._fireDidHide()}}class E{constructor(r,t){this._extensionId=r,this._onDidDispose=t,this._id=d._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new n.Emitter,this._onDidChangeValueEmitter=new n.Emitter,this._onDidTriggerButtonEmitter=new n.Emitter,this._onDidHideEmitter=new n.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((t,s)=>{const l=t===y.QuickInputButtons.Back?-1:s;this._handlesToButtons.set(l,t)}),this.update({buttons:r.map((t,s)=>({...a(t),tooltip:t.tooltip,handle:t===y.QuickInputButtons.Back?-1:s}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const t=this._handlesToButtons.get(r);t&&this._onDidTriggerButtonEmitter.fire(t)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,D.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),p.$dispose(this._id))}update(r){if(!this._disposed){for(const t of Object.keys(r)){const s=r[t];this._pendingUpdate[t]=s===void 0?null:s}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){p.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}E._nextId=1;function g(o){if(o instanceof y.ThemeIcon)return{id:o.id};const r=m(o),t=c(o);return{dark:typeof r=="string"?C.URI.file(r):r,light:typeof t=="string"?C.URI.file(t):t}}function c(o){return typeof o=="object"&&"light"in o?o.light:o}function m(o){return typeof o=="object"&&"dark"in o?o.dark:o}function a(o){const r=g(o.iconPath);let t,s;return"id"in r?s=k.ThemeIcon.asClassName(r):t=r,{iconPath:t,iconClass:s}}class d extends E{constructor(r,t){super(r.identifier,t);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new n.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new n.Emitter,this._onDidTriggerItemButtonEmitter=new n.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((s,l)=>{this._handlesToItems.set(l,s),this._itemsToHandles.set(s,l)});const t=[];for(let s=0;s<r.length;s++){const l=r[s];l.kind===y.QuickPickItemKind.Separator?t.push({type:"separator",label:l.label}):t.push({handle:s,label:l.label,description:l.description,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow,buttons:l.buttons?.map((h,S)=>({...a(h),tooltip:h.tooltip,handle:S}))})}this.update({items:t})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(r){this._keepScrollPosition=r,this.update({keepScrollPosition:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(t=>this._itemsToHandles.has(t)),this.update({activeItems:this._activeItems.map(t=>this._itemsToHandles.get(t))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(t=>this._itemsToHandles.has(t)),this.update({selectedItems:this._selectedItems.map(t=>this._itemsToHandles.get(t))})}_fireDidChangeActive(r){const t=(0,I.coalesce)(r.map(s=>this._handlesToItems.get(s)));this._activeItems=t,this._onDidChangeActiveEmitter.fire(t)}_fireDidChangeSelection(r){const t=(0,I.coalesce)(r.map(s=>this._handlesToItems.get(s)));this._selectedItems=t,this._onDidChangeSelectionEmitter.fire(t)}_fireDidTriggerItemButton(r,t){const s=this._handlesToItems.get(r);if(!s||!s.buttons||!s.buttons.length)return;const l=s.buttons[t];l&&this._onDidTriggerItemButtonEmitter.fire({button:l,item:s})}}class i extends E{constructor(r,t){super(r.identifier,t);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,r?typeof r=="string"?this.update({validationMessage:r,severity:R.default.Error}):this.update({validationMessage:r.message,severity:r.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new f(v,w)}e.createExtHostQuickOpen=_});var Ze=this&&this.__classPrivateFieldSet||function(J,e,u,n,D){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?D.call(J,u):D?D.value=u:e.set(J,u),u},Me=this&&this.__classPrivateFieldGet||function(J,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!n:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(J):n?n.value:e.get(J)};define(Ie[258],ke([0,1,2,3,57,6,18,5,16,104,14,28,86,15,27]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v){"use strict";var w,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(l){if(l)return typeof l.iconPath=="string"?u.URI.file(l.iconPath):u.URI.isUri(l.iconPath)||_.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function E(l,h){if(!l.iconPath&&!h.iconPath)return 0;if(l.iconPath){if(!h.iconPath)return 1}else return-1;const S=typeof l.iconPath=="string"?l.iconPath:u.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,L=typeof h.iconPath=="string"?h.iconPath:u.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,I.comparePaths)(S,L)}function g(l,h){let S=0;if(l.strikeThrough!==h.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==h.faded)return l.faded?1:-1;if(l.tooltip!==h.tooltip)return(l.tooltip||"").localeCompare(h.tooltip||"");if(S=E(l,h),S!==0)return S;if(l.light&&h.light)S=E(l.light,h.light);else{if(l.light)return 1;if(h.light)return-1}if(S!==0)return S;if(l.dark&&h.dark)S=E(l.dark,h.dark);else{if(l.dark)return 1;if(h.dark)return-1}return S}function c(l,h){if(l.command!==h.command)return l.command<h.command?-1:1;if(l.title!==h.title)return l.title<h.title?-1:1;if(l.tooltip!==h.tooltip){if(l.tooltip!==void 0&&h.tooltip!==void 0)return l.tooltip<h.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(l.arguments===h.arguments)return 0;if(l.arguments)if(h.arguments){if(l.arguments.length!==h.arguments.length)return l.arguments.length-h.arguments.length}else return 1;else return-1;for(let S=0;S<l.arguments.length;S++){const L=l.arguments[S],F=h.arguments[S];if(L!==F)return L<F?-1:1}return 0}function m(l,h){let S=(0,I.comparePaths)(l.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(S!==0)return S;if(l.command&&h.command)S=c(l.command,h.command);else{if(l.command)return 1;if(h.command)return-1}if(S!==0)return S;if(l.decorations&&h.decorations)S=g(l.decorations,h.decorations);else{if(l.decorations)return 1;if(h.decorations)return-1}return S}function a(l,h){for(let S=0;S<l.length;S++)if(l[S]!==h[S])return!1;return!0}function d(l,h){return l.command===h.command&&l.title===h.title&&l.tooltip===h.tooltip&&(l.arguments&&h.arguments?a(l.arguments,h.arguments):l.arguments===h.arguments)}function i(l,h){return(0,b.equals)(l,h,d)}class o{constructor(h,S,L){this._extension=h,this._sourceControlHandle=L,w.set(this,void 0),this._value="",this._onDidChange=new n.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Ze(this,w,S,"f")}get value(){return this._value}set value(h){h=h??"",Me(this,w,"f").$setInputBoxValue(this._sourceControlHandle,h),this.updateValue(h)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(h){Me(this,w,"f").$setInputBoxPlaceholder(this._sourceControlHandle,h),this._placeholder=h}get validateInput(){return(0,v.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(h){if((0,v.checkProposedApiEnabled)(this._extension,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=h,Me(this,w,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!h)}get enabled(){return this._enabled}set enabled(h){h=!!h,this._enabled!==h&&(this._enabled=h,Me(this,w,"f").$setInputBoxEnablement(this._sourceControlHandle,h))}get visible(){return this._visible}set visible(h){h=!!h,this._visible!==h&&(this._visible=h,Me(this,w,"f").$setInputBoxVisibility(this._sourceControlHandle,h))}showValidationMessage(h,S){(0,v.checkProposedApiEnabled)(this._extension,"scmValidation"),Me(this,w,"f").$showValidationMessage(this._sourceControlHandle,h,S)}$onInputBoxValueChange(h){this.updateValue(h)}updateValue(h){this._value=h,this._onDidChange.fire(h)}}e.ExtHostSCMInputBox=o,w=new WeakMap;class r{constructor(h,S,L,F,M){this._proxy=h,this._commands=S,this._sourceControlHandle=L,this._id=F,this._label=M,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new n.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(h){this._label=h,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,h)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(h){this._hideWhenEmpty=h,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(h){this._resourceStates=[...h],this._onDidUpdateResourceStates.fire()}getResourceState(h){return this._resourceStatesMap.get(h)}$executeResourceCommand(h,S){const L=this._resourceStatesCommandsMap.get(h);return L?(0,C.asPromise)(()=>this._commands.executeCommand(L.command,...L.arguments||[],S)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this._resourceStates].sort(m),L=(0,b.sortedDiff)(this._resourceSnapshot,h,m).map(A=>{const B=A.toInsert.map($=>{const U=this._resourceHandlePool++;this._resourceStatesMap.set(U,$);const X=$.resourceUri;let z;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const ge=new T.DisposableStore;z=this._commands.converter.toInternal($.command,ge),this._resourceStatesDisposablesMap.set(U,ge)}else this._resourceStatesCommandsMap.set(U,$.command);const N=f($.decorations),V=$.decorations&&f($.decorations.light)||N,x=$.decorations&&f($.decorations.dark)||N,q=[V,x],te=$.decorations&&$.decorations.tooltip||"",Y=$.decorations&&!!$.decorations.strikeThrough,le=$.decorations&&!!$.decorations.faded,pe=$.contextValue||"";return{rawResource:[U,X,q,te,Y,le,pe,z],handle:U}});return{start:A.start,deleteCount:A.deleteCount,toInsert:B}}),F=L.map(({start:A,deleteCount:B,toInsert:$})=>[A,B,$.map(U=>U.rawResource)]),M=L.reverse();for(const{start:A,deleteCount:B,toInsert:$}of M){const U=$.map(z=>z.handle),X=this._handlesSnapshot.splice(A,B,...U);for(const z of X)this._resourceStatesMap.delete(z),this._resourceStatesCommandsMap.delete(z),this._resourceStatesDisposablesMap.get(z)?.dispose(),this._resourceStatesDisposablesMap.delete(z)}return this._resourceSnapshot=h,F}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class t{constructor(h,S,L,F,M,A){this._extension=h,this._commands=L,this._id=F,this._label=M,this._rootUri=A,p.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new T.MutableDisposable,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new n.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ze(this,p,S,"f"),this._inputBox=new o(h,Me(this,p,"f"),this.handle),Me(this,p,"f").$registerSourceControl(this.handle,F,M,A)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(h){this._count!==h&&(this._count=h,Me(this,p,"f").$updateSourceControl(this.handle,{count:h}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(h){this._quickDiffProvider=h,Me(this,p,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!h})}get commitTemplate(){return this._commitTemplate}set commitTemplate(h){h!==this._commitTemplate&&(this._commitTemplate=h,Me(this,p,"f").$updateSourceControl(this.handle,{commitTemplate:h}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(h){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=h;const S=this._commands.converter.toInternal(h,this._acceptInputDisposables.value);Me(this,p,"f").$updateSourceControl(this.handle,{acceptInputCommand:S})}get actionButton(){return(0,v.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(h){(0,v.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new T.DisposableStore,this._actionButton=h;const S=h!==void 0?{command:this._commands.converter.toInternal(h.command,this._actionButtonDisposables.value),secondaryCommands:h.secondaryCommands?.map(L=>L.map(F=>this._commands.converter.toInternal(F,this._actionButtonDisposables.value))),description:h.description,enabled:h.enabled}:void 0;Me(this,p,"f").$updateSourceControl(this.handle,{actionButton:S??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(h){if(this._statusBarCommands&&h&&i(this._statusBarCommands,h))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=h;const S=(h||[]).map(L=>this._commands.converter.toInternal(L,this._statusBarDisposables.value));Me(this,p,"f").$updateSourceControl(this.handle,{statusBarCommands:S})}get selected(){return this._selected}createResourceGroup(h,S){const L=new r(Me(this,p,"f"),this._commands,this.handle,h,S),F=n.Event.once(L.onDidDispose)(()=>this.createdResourceGroups.delete(L));return this.createdResourceGroups.set(L,F),this.eventuallyAddResourceGroups(),L}eventuallyAddResourceGroups(){const h=[],S=[];for(const[L,F]of this.createdResourceGroups){F.dispose();const M=L.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(L),this.eventuallyUpdateResourceStates()});n.Event.once(L.onDidDispose)(()=>{this.updatedResourceGroups.delete(L),M.dispose(),this._groups.delete(L.handle),Me(this,p,"f").$unregisterGroup(this.handle,L.handle)}),h.push([L.handle,L.id,L.label,L.features]);const A=L._takeResourceStateSnapshot();A.length>0&&S.push([L.handle,A]),this._groups.set(L.handle,L)}Me(this,p,"f").$registerGroups(this.handle,h,S),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const h=[];this.updatedResourceGroups.forEach(S=>{const L=S._takeResourceStateSnapshot();L.length!==0&&h.push([S.handle,L])}),h.length>0&&Me(this,p,"f").$spliceResourceStates(this.handle,h),this.updatedResourceGroups.clear()}getResourceGroup(h){return this._groups.get(h)}setSelectionState(h){this._selected=h,this._onDidChangeSelection.fire(h)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(h=>h.dispose()),Me(this,p,"f").$unregisterSourceControl(this.handle)}}p=new WeakMap,t._handlePool=0,je([(0,D.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),je([(0,D.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let s=class Qn{constructor(h,S,L){this._commands=S,this.logService=L,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new n.Emitter,this._proxy=h.getProxy(y.MainContext.MainThreadSCM),this._telemetry=h.getProxy(y.MainContext.MainThreadTelemetry),S.registerArgumentProcessor({processArgument:F=>{if(F&&F.$mid===3){const M=this._sourceControls.get(F.sourceControlHandle);if(!M)return F;const A=M.getResourceGroup(F.groupHandle);return A?A.getResourceState(F.handle):F}else if(F&&F.$mid===4){const M=this._sourceControls.get(F.sourceControlHandle);return M?M.getResourceGroup(F.groupHandle):F}else if(F&&F.$mid===5){const M=this._sourceControls.get(F.handle);return M||F}return F}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(h,S,L,F){this.logService.trace("ExtHostSCM#createSourceControl",h.identifier.value,S,L,F),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const M=Qn._handlePool++,A=new t(h,this._proxy,this._commands,S,L,F);this._sourceControls.set(M,A);const B=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(h.identifier))||[];return B.push(A),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(h.identifier),B),A}getLastInputBox(h){this.logService.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const S=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(h.identifier)),L=S&&S[S.length-1];return L&&L.inputBox}$provideOriginalResource(h,S,L){const F=u.URI.revive(S);this.logService.trace("ExtHostSCM#$provideOriginalResource",h,F.toString());const M=this._sourceControls.get(h);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>M.quickDiffProvider.provideOriginalResource(F,L)).then(A=>A||null)}$onInputBoxValueChange(h,S){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",h);const L=this._sourceControls.get(h);return L&&L.inputBox.$onInputBoxValueChange(S),Promise.resolve(void 0)}$executeResourceCommand(h,S,L,F){this.logService.trace("ExtHostSCM#$executeResourceCommand",h,S,L);const M=this._sourceControls.get(h);if(!M)return Promise.resolve(void 0);const A=M.getResourceGroup(S);return A?A.$executeResourceCommand(L,F):Promise.resolve(void 0)}$validateInput(h,S,L){this.logService.trace("ExtHostSCM#$validateInput",h);const F=this._sourceControls.get(h);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>F.inputBox.validateInput(S,L)).then(M=>{if(!M)return Promise.resolve(void 0);const A=P.MarkdownString.fromStrict(M.message);return A?Promise.resolve([A,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this._sourceControls.get(h)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=h,Promise.resolve(void 0)}};s._handlePool=0,s=je([Ve(2,R.ILogService)],s),e.ExtHostSCM=s});var Ze=this&&this.__classPrivateFieldSet||function(J,e,u,n,D){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?D.call(J,u):D?D.value=u:e.set(J,u),u},Me=this&&this.__classPrivateFieldGet||function(J,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!n:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(J):n?n.value:e.get(J)};define(Ie[259],ke([0,1,7,5,173,6,15,11]),function(J,e,u,n,D,T,C,y){"use strict";var b,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(v,w,p,f,E=u.StatusBarAlignment.Left,g){b.set(this,void 0),I.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,Ze(this,b,v,"f"),Ze(this,I,w,"f"),this._entryId=R.ID_GEN++,this._extension=p,this._id=f,this._alignment=E,this._priority=this.validatePriority(g)}validatePriority(v){if(!!(0,y.isNumber)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(v){this._text=v,this.update()}set name(v){this._name=v,this.update()}set tooltip(v){this._tooltip=v,this.update()}set color(v){this._color=v,this.update()}set backgroundColor(v){v&&!R.ALLOWED_BACKGROUND_COLORS.has(v.id)&&(v=void 0),this._backgroundColor=v,this.update()}set command(v){this._command?.fromApi!==v&&(this._internalCommandRegistration.clear(),typeof v=="string"?this._command={fromApi:v,internal:Me(this,I,"f").toInternal({title:"",command:v},this._internalCommandRegistration)}:v?this._command={fromApi:v,internal:Me(this,I,"f").toInternal(v,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(v){this._accessibilityInformation=v,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Me(this,b,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let v;this._extension?this._id?v=`${this._extension.identifier.value}.${this._id}`:v=this._extension.identifier.value:v=this._id;let w;this._name?w=this._name:w=(0,D.localize)(0,null,this._extension.displayName||this._extension.name);let p=this._color;this._backgroundColor&&(p=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const f=C.MarkdownString.fromStrict(this._tooltip);Me(this,b,"f").$setEntry(this._entryId,v,w,this._text,f,this._command?.internal,p,this._backgroundColor,this._alignment===u.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,b=new WeakMap,I=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new u.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new u.ThemeColor("statusBarItem.warningForeground")]]);class k{constructor(v){this._messages=[],this._item=v.createStatusBarEntry(void 0,"status.extensionMessage",u.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(v){const w={message:v};return this._messages.unshift(w),this._update(),new u.Disposable(()=>{const p=this._messages.indexOf(w);p>=0&&(this._messages.splice(p,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class _{constructor(v,w){this._proxy=v.getProxy(n.MainContext.MainThreadStatusBar),this._commands=w,this._statusMessage=new k(this)}createStatusBarEntry(v,w,p,f){return new R(this._proxy,this._commands,v,w,p,f)}setStatusBarMessage(v,w){const p=this._statusMessage.setMessage(v);let f;return typeof w=="number"?f=setTimeout(()=>p.dispose(),w):typeof w!="undefined"&&w.then(()=>p.dispose(),()=>p.dispose()),new u.Disposable(()=>{p.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=_}),define(Ie[91],ke([0,1,5,3,4]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(y){this._onDidChangeStorage=new n.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=y.getProxy(u.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(y,b){this._proxy.$registerExtensionStorageKeysToSync(y,b)}initializeExtensionStorage(y,b,I){return this._proxy.$initializeExtensionStorage(y,b).then(R=>R||I)}setValue(y,b,I){return this._proxy.$setValue(y,b,I)}$acceptValue(y,b,I){this._onDidChangeStorage.fire({shared:y,key:b,value:I})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(Ie[70],ke([0,1,4,26,14,69,2]),function(J,e,u,n,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,u.createDecorator)("IExtensionStoragePaths");let y=class{constructor(I,R,k){this._logService=R,this._extHostFileSystem=k,this._workspace=I.workspace??void 0,this._environment=I.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(_=>this._value=_)}async _getWorkspaceStorageURI(I){return C.URI.joinPath(this._environment.workspaceStorageHome,I)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const I=this._workspace.id,R=await this._getWorkspaceStorageURI(I);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(C.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:C.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(k){this._logService.error("[ExtHostStorage]",k);return}}workspaceValue(I){if(this._value)return C.URI.joinPath(this._value,I.identifier.value)}globalValue(I){return C.URI.joinPath(this._environment.globalStorageHome,I.identifier.value.toLowerCase())}onWillDeactivateAll(){}};y=je([Ve(0,n.IExtHostInitDataService),Ve(1,D.ILogService),Ve(2,T.IExtHostConsumerFileSystem)],y),e.ExtensionStoragePaths=y}),define(Ie[39],ke([0,1,3,5,4,2,17,6,7,174,12,220,21,34,203,86,11,18]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v,w,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class E{constructor(t,s,l,h){this._proxy=t,this._id=s,this._creationOptions=l,this._name=h,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(L=>this._pidPromiseComplete=L);const S=this;this.value={get name(){return S._name||""},get processId(){return S._pidPromise},get creationOptions(){return S._creationOptions},get exitStatus(){return S._exitStatus},get state(){return S._state},sendText(L,F=!0){S._checkDisposed(),S._proxy.$sendText(S._id,L,F)},show(L){S._checkDisposed(),S._proxy.$show(S._id,L)},hide(){S._checkDisposed(),S._proxy.$hide(S._id)},dispose(){S._disposed||(S._disposed=!0,S._proxy.$dispose(S._id))},get dimensions(){if(!(S._cols===void 0||S._rows===void 0))return{columns:S._cols,rows:S._rows}}}}async create(t,s){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,p.withNullAsUndefined)(t.shellPath),shellArgs:(0,p.withNullAsUndefined)(t.shellArgs),cwd:(0,p.withNullAsUndefined)(t.cwd),env:(0,p.withNullAsUndefined)(t.env),icon:(0,p.withNullAsUndefined)(i(t.iconPath)),color:w.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,p.withNullAsUndefined)(t.message),strictEnv:(0,p.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,p.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,p.withNullAsUndefined)(s?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,p.withNullAsUndefined)(s?.useShellEnvironment),location:s?.location||this._serializeParentTerminal(t.location,s?.resolvedExtHostIdentifier),isTransient:(0,p.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,s,l,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:l,color:w.ThemeColor.isThemeColor(h)?h.id:void 0,location:this._serializeParentTerminal(t,s),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,s){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&s?{parentTerminal:s}:"viewColumn"in t?{viewColumn:t.viewColumn,preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitStatus(t,s){this._exitStatus=Object.freeze({code:t,reason:s})}setDimensions(t,s){return t===this._cols&&s===this._rows||t===0||s===0?!1:(this._cols=t,this._rows=s,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(s=>{s!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=E;class g{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new u.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new u.Emitter,this._onDidChangeProperty=new u.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new u.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,s){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${s}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,s){this._pty.setDimensions?.({columns:t,rows:s})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(s=>this._onProcessData.fire(s)),this._pty.onDidClose?.((s=void 0)=>{this._onProcessExit.fire(s===void 0?void 0:s)}),this._pty.onDidOverrideDimensions?.(s=>{s&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:s.columns,rows:s.rows}})}),this._pty.onDidChangeName?.(s=>{this._onDidChangeProperty.fire({type:"title",value:s})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=g;let c=1,m=class extends y.Disposable{constructor(t,s){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new u.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new u.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new u.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new u.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new u.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=s.getProxy(n.MainContext.MainThreadTerminalService),this._bufferer=new v.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new u.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[l,h]of this._terminalProcesses)h.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,s){const l=new E(this._proxy,(0,P.generateUuid)(),t,t.name),h=new g(t.pty);return l.createExtensionTerminal(t.location,this._serializeParentTerminal(t,s).resolvedExtHostIdentifier,i(t.iconPath),o(t.color)).then(S=>{const L=this._setupExtHostProcessListeners(S,h);this._terminalProcessDisposables[S]=L}),this._terminals.push(l),l.value}_serializeParentTerminal(t,s){if(s=s||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const l=t.location.parentTerminal;if(l){const h=this._terminals.find(S=>S.value===l);h&&(s.resolvedExtHostIdentifier=h._id)}}else t.location&&typeof t.location!="object"?s.location=t.location:s.location&&typeof s.location=="object"&&"splitActiveTerminal"in s.location&&(s.location={splitActiveTerminal:!0});return s}attachPtyToTerminal(t,s){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const h=new g(s),S=this._setupExtHostProcessListeners(t,h);this._terminalProcessDisposables[t]=S}async $acceptActiveTerminalChanged(t){const s=this._activeTerminal;if(t===null){this._activeTerminal=void 0,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const l=this._getTerminalById(t);l&&(this._activeTerminal=l,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,s){const l=this._getTerminalById(t);l&&this._onDidWriteTerminalData.fire({terminal:l.value,data:s})}async $acceptTerminalDimensions(t,s,l){const h=this._getTerminalById(t);h&&h.setDimensions(s,l)&&this._onDidChangeTerminalDimensions.fire({terminal:h.value,dimensions:h.value.dimensions})}async $acceptTerminalMaximumDimensions(t,s,l){this._terminalProcesses.get(t)?.resize(s,l)}async $acceptTerminalTitleChange(t,s){const l=this._getTerminalById(t);l&&(l.name=s)}async $acceptTerminalClosed(t,s,l){const h=this._getTerminalObjectIndexById(this._terminals,t);if(h!==null){const S=this._terminals.splice(h,1)[0];S.setExitStatus(s,l),this._onDidCloseTerminal.fire(S.value)}}$acceptTerminalOpened(t,s,l,h){if(s){const F=this._getTerminalObjectIndexById(this._terminals,s);if(F!==null){this._terminals[F]._id=t,this._onDidOpenTerminal.fire(this.terminals[F]),this._terminals[F].isOpen=!0;return}}const S={name:h.name,shellPath:h.executable,shellArgs:h.args,cwd:typeof h.cwd=="string"?h.cwd:T.URI.revive(h.cwd),env:h.env,hideFromUser:h.hideFromUser},L=new E(this._proxy,t,S,l);this._terminals.push(L),this._onDidOpenTerminal.fire(L.value),L.isOpen=!0}async $acceptTerminalProcessId(t,s){this._getTerminalById(t)?._setProcessId(s)}async $startExtensionTerminal(t,s){const l=this._getTerminalById(t);if(!l)return{message:(0,I.localize)(0,null,t)};l.isOpen||await new Promise(S=>{const L=this.onDidOpenTerminal(async F=>{F===l.value&&(L.dispose(),S())})});const h=this._terminalProcesses.get(t);h?h.startSendingEvents(s):this._extensionTerminalAwaitingStart[t]={initialDimensions:s}}_setupExtHostProcessListeners(t,s){const l=new y.DisposableStore;l.add(s.onProcessReady(S=>this._proxy.$sendProcessReady(t,S.pid,S.cwd))),l.add(s.onDidChangeProperty(S=>this._proxy.$sendProcessProperty(t,S))),this._bufferer.startBuffering(t,s.onProcessData),l.add(s.onProcessExit(S=>this._onProcessExit(t,S))),this._terminalProcesses.set(t,s);const h=this._extensionTerminalAwaitingStart[t];return h&&s instanceof g&&(s.startSendingEvents(h.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),l}$acceptProcessAckDataEvent(t,s){this._terminalProcesses.get(t)?.acknowledgeDataEvent(s)}$acceptProcessInput(t,s){this._terminalProcesses.get(t)?.input(s)}$acceptTerminalInteraction(t){const s=this._getTerminalById(t);s?.setInteractedWith()&&this._onDidChangeTerminalState.fire(s.value)}$acceptProcessResize(t,s,l){try{this._terminalProcesses.get(t)?.resize(s,l)}catch(h){if(h.code!=="EPIPE"&&h.code!=="ERR_IPC_CHANNEL_CLOSED")throw h}}$acceptProcessShutdown(t,s){this._terminalProcesses.get(t)?.shutdown(s)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(s=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:s}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(s=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:s}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new b.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,s,l){if(this._profileProviders.has(s))throw new Error(`Terminal profile provider "${s}" already registered`);return this._profileProviders.set(s,l),this._proxy.$registerProfileProvider(s,t.identifier.value),new b.Disposable(()=>{this._profileProviders.delete(s),this._proxy.$unregisterProfileProvider(s)})}async $createContributedProfileTerminal(t,s){const l=new _.CancellationTokenSource().token;let h=await this._profileProviders.get(t)?.provideTerminalProfile(l);if(!l.isCancellationRequested){if(h&&!("options"in h)&&(h={options:h}),!h||!("options"in h))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in h.options){this.createExtensionTerminal(h.options,s);return}this.createTerminalFromOptions(h.options,s)}}async $provideLinks(t,s){const l=this._getTerminalById(t);if(!l)return[];this._terminalLinkCache.delete(t),this._terminalLinkCancellationSource.get(t)?.dispose(!0);const S=new _.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,S);const L=[],F={terminal:l.value,line:s},M=[];for(const $ of this._linkProviders)M.push(f.Promises.withAsyncBody(async U=>{S.token.onCancellationRequested(()=>U({provider:$,links:[]}));const X=await $.provideTerminalLinks(F,S.token)||[];S.token.isCancellationRequested||U({provider:$,links:X})}));const A=await Promise.all(M);if(S.token.isCancellationRequested)return[];const B=new Map;for(const $ of A)$&&$.links.length>0&&L.push(...$.links.map(U=>{const X={id:c++,startIndex:U.startIndex,length:U.length,label:U.tooltip};return B.set(X.id,{provider:$.provider,link:U}),X}));return this._terminalLinkCache.set(t,B),L}$activateLink(t,s){const l=this._terminalLinkCache.get(t)?.get(s);!l||l.provider.handleTerminalLink(l.link)}_onProcessExit(t,s){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const l=this._terminalProcessDisposables[t];l&&(l.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,s)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,s){const l=this._getTerminalObjectIndexById(t,s);return l!==null?t[l]:null}_getTerminalObjectIndexById(t,s){let l=null;return t.some((h,S)=>h._id===s?(l=S,!0):!1),l}getEnvironmentVariableCollection(t){let s=this._environmentVariableCollections.get(t.identifier.value);return s||(s=new a,this._setEnvironmentVariableCollection(t.identifier.value,s)),s}_syncEnvironmentVariableCollection(t,s){const l=(0,k.serializeEnvironmentVariableCollection)(s.map);this._proxy.$setEnvironmentVariableCollection(t,s.persistent,l.length===0?void 0:l)}$initEnvironmentVariableCollections(t){t.forEach(s=>{const l=s[0],h=new a(s[1]);this._setEnvironmentVariableCollection(l,h)})}$acceptDefaultProfile(t,s){this._defaultProfile=t,this._defaultAutomationProfile=s}_setEnvironmentVariableCollection(t,s){this._environmentVariableCollections.set(t,s),s.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,s)})}};m=je([Ve(1,C.IExtHostRpcService)],m),e.BaseExtHostTerminalService=m;class a{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new u.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,s){this._setIfDiffers(t,{value:s,type:b.EnvironmentVariableMutatorType.Replace})}append(t,s){this._setIfDiffers(t,{value:s,type:b.EnvironmentVariableMutatorType.Append})}prepend(t,s){this._setIfDiffers(t,{value:s,type:b.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,s){const l=this.map.get(t);(!l||l.value!==s.value||l.type!==s.type)&&(this.map.set(t,s),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,s){this.map.forEach((l,h)=>t.call(s,h,l,this))}[Symbol.iterator](){return this.map.entries()}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=a;let d=class extends m{constructor(t){super(!1,t)}createTerminal(t,s,l){throw new R.NotSupportedError}createTerminalFromOptions(t,s){throw new R.NotSupportedError}};d=je([Ve(0,C.IExtHostRpcService)],d),e.WorkerExtHostTerminalService=d;function i(r){if(!(!r||typeof r=="string"))return"id"in r?{id:r.id,color:r.color}:r}function o(r){return w.ThemeColor.isThemeColor(r)?r:void 0}});var Ze=this&&this.__classPrivateFieldSet||function(J,e,u,n,D){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?D.call(J,u):D?D.value=u:e.set(J,u),u},Me=this&&this.__classPrivateFieldGet||function(J,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!n:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(J):n?n.value:e.get(J)};define(Ie[260],ke([0,1,16,23,21,3,58,60,6,24,11,34,5,17,132,15,7,66,89,67]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v,w,p,f,E,g){"use strict";var c,m;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let a=class{constructor(M,A){this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=M.getProxy(_.MainContext.MainThreadTesting),this.observer=new h(this.proxy),this.runTracker=new i(this.proxy),A.registerArgumentProcessor({processArgument:B=>B?.$mid===13?(0,v.toItemFromContext)(B):B})}createTestController(M,A,B){if(this.controllers.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const $=new b.DisposableStore,U=$.add(new v.ExtHostTestItemCollection(M,A));U.root.label=A;const X=new Map,z=this.proxy,N={items:U.root.children,get label(){return A},set label(x){A=x,U.root.label=x,z.$updateController(M,{label:A})},get refreshHandler(){return B},set refreshHandler(x){B=x,z.$updateController(M,{canRefresh:!!x})},get id(){return M},createRunProfile:(x,q,te,Y,le)=>{let pe=(0,y.hash)(x);for(;X.has(pe);)pe++;return new S(this.proxy,X,M,pe,x,q,te,Y,le)},createTestItem(x,q,te){return new v.TestItemImpl(M,x,q,te)},createTestRun:(x,q,te=!0)=>this.runTracker.createTestRun(M,U,x,q,te),set resolveHandler(x){U.resolveHandler=x},get resolveHandler(){return U.resolveHandler},dispose:()=>{$.dispose()}};z.$registerTestController(M,A,!!B),$.add((0,b.toDisposable)(()=>z.$unregisterTestController(M)));const V={controller:N,collection:U,profiles:X};return this.controllers.set(M,V),$.add((0,b.toDisposable)(()=>this.controllers.delete(M))),$.add(U.onDidGenerateDiff(x=>z.$publishDiff(M,x.map(g.TestsDiffOp.serialize)))),N}createTestObserver(){return this.observer.checkout()}async runTests(M,A=D.CancellationToken.None){const B=o(M);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const $=this.controllers.get(B.controllerId);if(!$)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(U=>f.TestId.fromExtHostTestItem(U,$.collection.root.id).toString())??[$.collection.root.id],profileGroup:L[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:M.exclude?.map(U=>U.id)},A)}$provideFileCoverage(M,A,B){return(0,u.mapFind)(this.runTracker.trackers,U=>U.id===M?U.getCoverage(A):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(M,A,B,$){return(0,u.mapFind)(this.runTracker.trackers,X=>X.id===M?X.getCoverage(A):void 0)?.resolveFileCoverage(B,$)??Promise.resolve([])}$configureRunProfile(M,A){this.controllers.get(M)?.profiles.get(A)?.configureHandler?.()}async $refreshTests(M,A){await this.controllers.get(M)?.controller.refreshHandler?.(A)}$publishTestResults(M){this.results=Object.freeze(M.map(A=>(0,I.deepFreeze)(w.TestResults.to(A))).concat(this.results).sort((A,B)=>B.completedAt-A.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(M,A){const B=this.controllers.get(f.TestId.fromString(M).controllerId)?.collection;B&&(await B.expand(M,A<0?1/0:A),B.flushDiff())}$acceptDiff(M){this.observer.applyDiff(M.map(g.TestsDiffOp.deserialize))}async $runControllerTests(M,A){const B=this.controllers.get(M.controllerId);if(!B)return;const{collection:$,profiles:U}=B,X=U.get(M.profileId);if(!X)return;const z=M.testIds.map(q=>$.tree.get(q)).filter(R.isDefined),N=M.excludeExtIds.map(q=>B.collection.tree.get(q)).filter(R.isDefined).filter(q=>z.some(te=>te.fullId.compare(q.fullId)===2));if(!z.length)return;const V=new p.TestRunRequest(z.some(q=>q.actual instanceof v.TestItemRootImpl)?void 0:z.map(q=>q.actual),N.map(q=>q.actual),X),x=this.runTracker.prepareForMainThreadTestRun(V,r.fromInternal(M,B.collection),A);try{await X.runHandler(V,A)}finally{x.isRunning&&!A.isCancellationRequested&&await T.Event.toPromise(x.onEnd),x.dispose()}}$cancelExtensionTestRun(M){M===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(M)}};a=je([Ve(0,P.IExtHostRpcService)],a),e.ExtHostTesting=a;class d extends b.Disposable{constructor(M,A,B){super();this.dto=M,this.proxy=A,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new D.CancellationTokenSource(B)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:$}of this.tasks.values())$.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(M){return this.tasks.get(M)?.coverage}createRun(M){const A=this.dto.id,B=this.dto.controllerId,$=(0,k.generateUuid)(),U=new t(this.proxy,A,$),X=x=>(q,...te)=>{if(N){console.warn(`Setting the state of test "${q.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(q)||(this.ensureTestIsKnown(q),x(q,...te))},z=(x,q)=>{const te=q instanceof Array?q.map(w.TestMessage.from):[w.TestMessage.from(q)];if(x.uri&&x.range){const Y={range:w.Range.from(x.range),uri:x.uri};for(const le of te)le.location=le.location||Y}this.proxy.$appendTestMessagesInRun(A,$,f.TestId.fromExtHostTestItem(x,B).toString(),te)};let N=!1;const V={isPersisted:this.dto.isPersisted,token:this.cts.token,name:M,get coverageProvider(){return U.coverageProvider},set coverageProvider(x){U.coverageProvider=x},enqueued:X(x=>{this.proxy.$updateTestStateInRun(A,$,f.TestId.fromExtHostTestItem(x,B).toString(),1)}),skipped:X(x=>{this.proxy.$updateTestStateInRun(A,$,f.TestId.fromExtHostTestItem(x,B).toString(),5)}),started:X(x=>{this.proxy.$updateTestStateInRun(A,$,f.TestId.fromExtHostTestItem(x,B).toString(),2)}),errored:X((x,q,te)=>{z(x,q),this.proxy.$updateTestStateInRun(A,$,f.TestId.fromExtHostTestItem(x,B).toString(),6,te)}),failed:X((x,q,te)=>{z(x,q),this.proxy.$updateTestStateInRun(A,$,f.TestId.fromExtHostTestItem(x,B).toString(),4,te)}),passed:X((x,q)=>{this.proxy.$updateTestStateInRun(A,$,f.TestId.fromExtHostTestItem(x,this.dto.controllerId).toString(),3,q)}),appendOutput:(x,q,te)=>{N||(te&&(this.dto.isIncluded(te)?this.ensureTestIsKnown(te):te=void 0),this.proxy.$appendOutputToRun(A,$,n.VSBuffer.fromString(x),q&&w.location.from(q),te&&f.TestId.fromExtHostTestItem(te,B).toString()))},end:()=>{N||(N=!0,this.proxy.$finishedTestRunTask(A,$),this.tasks.delete($),this.isRunning||this.dispose())}};return this.tasks.set($,{run:V,coverage:U}),this.proxy.$startedTestRunTask(A,{id:$,name:M,running:!0}),V}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(M){if(!(M instanceof v.TestItemImpl))throw new E.InvalidTestItemError(M.id);if(this.sharedTestIds.has(f.TestId.fromExtHostTestItem(M,this.dto.controllerId).toString()))return;const A=[],B=this.dto.colllection.root;for(;;){const $=w.TestItem.from(M);if(A.unshift($),this.sharedTestIds.has($.extId)||(this.sharedTestIds.add($.extId),M===B))break;M=M.parent||B}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,A)}}class i{constructor(M){this.proxy=M,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(M,A,B){return this.getTracker(M,A,B)}cancelRunById(M){for(const A of this.tracked.values())if(A.id===M){A.dispose();return}}cancelAllRuns(){for(const M of this.tracked.values())M.dispose()}createTestRun(M,A,B,$,U){const X=this.tracked.get(B);if(X)return X.createRun($);const z=r.fromPublic(M,A,B,U),N=o(B);this.proxy.$startedExtensionTestRun({controllerId:M,profile:N&&{group:L[N.kind],id:N.profileId},exclude:B.exclude?.map(x=>f.TestId.fromExtHostTestItem(x,A.root.id).toString())??[],id:z.id,include:B.include?.map(x=>f.TestId.fromExtHostTestItem(x,A.root.id).toString())??[A.root.id],persist:U});const V=this.getTracker(B,z);return V.onEnd(()=>this.proxy.$finishedExtensionTestRun(z.id)),V.createRun($)}getTracker(M,A,B){const $=new d(A,this.proxy,B);return this.tracked.set(M,$),$.onEnd(()=>this.tracked.delete(M)),$}}e.TestRunCoordinator=i;const o=F=>{if(!!F.profile){if(!(F.profile instanceof S))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return F.profile}};class r{constructor(M,A,B,$,U,X){this.controllerId=M,this.id=A,this.isPersisted=U,this.colllection=X,this.includePrefix=B.map(z=>z+"\0"),this.excludePrefix=$.map(z=>z+"\0")}static fromPublic(M,A,B,$){return new r(M,(0,k.generateUuid)(),B.include?.map(U=>f.TestId.fromExtHostTestItem(U,M).toString())??[M],B.exclude?.map(U=>f.TestId.fromExtHostTestItem(U,M).toString())??[],$,A)}static fromInternal(M,A){return new r(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,A)}isIncluded(M){const A=f.TestId.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const B of this.excludePrefix)if(A===B||A.startsWith(B))return!1;for(const B of this.includePrefix)if(A===B||A.startsWith(B))return!0;return!1}}e.TestRunDto=r;class t{constructor(M,A,B){this.proxy=M,this.runId=A,this.taskId=B}set coverageProvider(M){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!M||(this._coverageProvider=M,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(M){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(M))());try{return(await this.fileCoverage)?.map(w.TestCoverage.fromFile)??[]}catch(A){throw this.fileCoverage=void 0,A}}async resolveFileCoverage(M,A){const B=await this.fileCoverage;let $=B?.[M];return!this._coverageProvider||!B||!$?[]:($.detailedCoverage||($=B[M]=await this._coverageProvider.resolveFileCoverage?.($,A)??$),$.detailedCoverage?.map(w.TestCoverage.fromDetailed)??[])}}class s extends g.IncrementalChangeCollector{constructor(M){super();this.emitter=M,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(M){this.added.add(M)}update(M){Object.assign(M.revived,w.TestItem.toPlain(M.item)),this.added.has(M)||this.updated.add(M)}remove(M){if(this.added.has(M)){this.added.delete(M);return}if(this.updated.delete(M),M.parent&&this.alreadyRemoved.has(M.parent)){this.alreadyRemoved.add(M.item.extId);return}this.removed.add(M)}getChangeEvent(){const{added:M,updated:A,removed:B}=this;return{get added(){return[...M].map($=>$.revived)},get updated(){return[...A].map($=>$.revived)},get removed(){return[...B].map($=>$.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class l extends g.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(M){return this.items.get(M)}getMirroredTestDataByReference(M){return this.items.get(M.id)}createItem(M,A){return{...M,revived:w.TestItem.toPlain(M.item),depth:A?A.depth+1:0,children:new Set}}createChangeCollector(){return new s(this.changeEmitter)}}e.MirroredTestCollection=l;class h{constructor(M){this.proxy=M}checkout(){this.current||(this.current=this.createObserverData());const M=this.current;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(A=>A.revived)},dispose:(0,C.once)(()=>{--M.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(M){return this.current?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.current?.tests.apply(M)}createObserverData(){const M=new l;return this.proxy.$subscribeToDiffs(),{observers:0,tests:M}}}class S{constructor(M,A,B,$,U,X,z,N=!1,V=void 0){this.controllerId=B,this.profileId=$,this._label=U,this.kind=X,this.runHandler=z,this._isDefault=N,this._tag=V,c.set(this,void 0),m.set(this,void 0),Ze(this,c,M,"f"),Ze(this,m,A,"f"),A.set($,this);const x=L[X];if(typeof x!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);Me(this,c,"f").$publishTestRunProfile({profileId:$,controllerId:B,tag:V?w.TestTag.namespace(this.controllerId,V.id):null,label:U,group:x,isDefault:N,hasConfigurationHandler:!1})}get label(){return this._label}set label(M){M!==this._label&&(this._label=M,Me(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get isDefault(){return this._isDefault}set isDefault(M){M!==this._isDefault&&(this._isDefault=M,Me(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,Me(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?w.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(M){M!==this._configureHandler&&(this._configureHandler=M,Me(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}dispose(){Me(this,m,"f")?.delete(this.profileId)&&(Ze(this,m,void 0,"f"),Me(this,c,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=S,c=new WeakMap,m=new WeakMap;const L={[p.TestRunProfileKind.Coverage]:8,[p.TestRunProfileKind.Debug]:4,[p.TestRunProfileKind.Run]:2}}),define(Ie[261],ke([0,1,16,3,5,133,15,7]),function(J,e,u,n,D,T,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class b{constructor(R,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new n.Emitter,this._onDidChangeTextEditorOptions=new n.Emitter,this._onDidChangeTextEditorVisibleRanges=new n.Emitter,this._onDidChangeTextEditorViewColumn=new n.Emitter,this._onDidChangeActiveTextEditor=new n.Emitter,this._onDidChangeVisibleTextEditors=new n.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(_=>this._onDidChangeVisibleTextEditors.fire(_)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(_=>this._onDidChangeActiveTextEditor.fire(_))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const k=this._extHostDocumentsAndEditors.allEditors();return R?k:k.map(_=>_.value)}async showTextDocument(R,k,_){let P;typeof k=="number"?P={position:C.ViewColumn.from(k),preserveFocus:_}:typeof k=="object"?P={position:C.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?C.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:P={preserveFocus:!1};const v=await this._proxy.$tryShowTextDocument(R.uri,P),w=v&&this._extHostDocumentsAndEditors.getEditor(v);if(w)return w.value;throw v?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,k){return new T.TextEditorDecorationType(this._proxy,R,k).value}$acceptEditorPropertiesChanged(R,k){const _=this._extHostDocumentsAndEditors.getEditor(R);if(!_)throw new Error("unknown text editor");if(k.options&&_._acceptOptions(k.options),k.selections){const P=k.selections.selections.map(C.Selection.to);_._acceptSelections(P)}if(k.visibleRanges){const P=u.coalesce(k.visibleRanges.map(C.Range.to));_._acceptVisibleRanges(P)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:_.value,options:{...k.options,lineNumbers:C.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const P=y.TextEditorSelectionChangeKind.fromValue(k.selections.source),v=k.selections.selections.map(C.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:_.value,selections:v,kind:P})}if(k.visibleRanges){const P=u.coalesce(k.visibleRanges.map(C.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:_.value,visibleRanges:P})}}$acceptEditorPositionData(R){for(const k in R){const _=this._extHostDocumentsAndEditors.getEditor(k);if(!_)throw new Error("Unknown text editor");const P=C.ViewColumn.to(R[k]);_.value.viewColumn!==P&&(_._acceptViewColumn(P),this._onDidChangeTextEditorViewColumn.fire({textEditor:_.value,viewColumn:P}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=b}),define(Ie[262],ke([0,1,2,4,5,6,7,15,11]),function(J,e,u,n,D,T,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,n.createDecorator)("IExtHostTimeline");class I{constructor(_,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=_.getProxy(D.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===11){const w=v.uri===void 0?void 0:u.URI.revive(v.uri);return this._itemsBySourceAndUriMap.get(v.source)?.get(R(w))?.get(v.handle)}return v}})}async $getTimeline(_,P,v,w){return this._providers.get(_)?.provideTimeline(u.URI.revive(P),v,w)}registerTimelineProvider(_,P,v,w){const p=new T.DisposableStore,f=this.convertTimelineItem(P.id,w,p).bind(this);let E;P.onDidChange&&(E=P.onDidChange(c=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:P.id}),this));const g=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...P,scheme:_,onDidChange:void 0,async provideTimeline(c,m,a){m?.resetCache&&(p.clear(),g.get(P.id)?.clear());const d=await P.provideTimeline(c,m,a);if(d==null)return;const i=f(c,m);return{...d,source:P.id,items:d.items.map(i)}},dispose(){for(const c of g.values())c.get(P.id)?.clear();E?.dispose(),p.dispose()}})}convertTimelineItem(_,P,v){return(w,p)=>{let f;if(p?.cacheResults){let E=this._itemsBySourceAndUriMap.get(_);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(_,E));const g=R(w);f=E.get(g),f===void 0&&(f=new Map,E.set(g,f))}return E=>{const{iconPath:g,...c}=E,m=`${_}|${E.id??E.timestamp}`;f?.set(m,E);let a,d,i;E.iconPath&&(g instanceof C.ThemeIcon?i={id:g.id,color:g.color}:u.URI.isUri(g)?(a=g,d=g):{light:a,dark:d}=g);let o;return C.MarkdownString.isMarkdownString(c.tooltip)?o=y.MarkdownString.from(c.tooltip):(0,b.isString)(c.tooltip)?o=c.tooltip:C.MarkdownString.isMarkdownString(c.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=y.MarkdownString.from(c.detail)):(0,b.isString)(c.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=c.detail),{...c,id:c.id??void 0,handle:m,source:_,command:E.command?P.toInternal(E.command,v):void 0,icon:a,iconDark:d,themeIcon:i,tooltip:o,accessibilityInformation:E.accessibilityInformation}}}}registerTimelineProviderCore(_){if(this._providers.get(_.id))throw new Error(`Timeline Provider ${_.id} already exists.`);return this._proxy.$registerTimelineProvider({id:_.id,label:_.label,scheme:_.scheme}),this._providers.set(_.id,_),(0,T.toDisposable)(()=>{for(const v of this._itemsBySourceAndUriMap.values())v.get(_.id)?.clear();this._providers.delete(_.id),this._proxy.$unregisterTimelineProvider(_.id),_.dispose()})}}e.ExtHostTimeline=I;function R(k){return k?.toString()}}),define(Ie[263],ke([0,1,6,10,2,5]),function(J,e,u,n,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(b){this._openers=new Map,this._proxy=b.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(b,I,R,k){if(this._openers.has(I))throw new Error(`Opener with id '${I}' already registered`);const _=k.schemes.find(P=>!C.supportedSchemes.has(P));if(_)throw new Error(`Scheme '${_}' is not supported. Only http and https are currently supported.`);return this._openers.set(I,R),this._proxy.$registerUriOpener(I,k.schemes,b,k.label),(0,u.toDisposable)(()=>{this._openers.delete(I),this._proxy.$unregisterUriOpener(I)})}async $canOpenUri(b,I,R){const k=this._openers.get(b);if(!k)throw new Error(`Unknown opener with id: ${b}`);const _=D.URI.revive(I);return k.canOpenExternalUri(_,R)}async $openUri(b,I,R){const k=this._openers.get(b);if(!k)throw new Error(`Unknown opener id: '${b}'`);return k.openExternalUri(D.URI.revive(I.resolvedUri),{sourceUri:D.URI.revive(I.sourceUri)},R)}}e.ExtHostUriOpeners=C,C.supportedSchemes=new Set([n.Schemas.http,n.Schemas.https])}),define(Ie[264],ke([0,1,5,2,6,12,28]),function(J,e,u,n,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class y{constructor(I){this.handles=new Set,this.handlers=new Map,this._proxy=I.getProxy(u.MainContext.MainThreadUrls)}registerUriHandler(I,R){if(this.handles.has(C.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const k=y.HandlePool++;return this.handles.add(C.ExtensionIdentifier.toKey(I)),this.handlers.set(k,R),this._proxy.$registerUriHandler(k,I),(0,D.toDisposable)(()=>{this.handles.delete(C.ExtensionIdentifier.toKey(I)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(I,R){const k=this.handlers.get(I);if(!k)return Promise.resolve(void 0);try{k.handleUri(n.URI.revive(R))}catch(_){(0,T.onUnexpectedError)(_)}return Promise.resolve(void 0)}async createAppUri(I){return n.URI.revive(await this._proxy.$createAppUri(I))}}e.ExtHostUrls=y,y.HandlePool=0});var Ze=this&&this.__classPrivateFieldSet||function(J,e,u,n,D){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?D.call(J,u):D?D.value=u:e.set(J,u),u},Me=this&&this.__classPrivateFieldGet||function(J,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!n:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(J):n?n.value:e.get(J)};define(Ie[71],ke([0,1,3,10,2,190,210,88,5]),function(J,e,u,n,D,T,C,y,b){"use strict";var I,R,k,_,P,v,w,p,f,E,g,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class m{constructor(l,h,S,L,F,M,A){I.set(this,void 0),R.set(this,void 0),k.set(this,void 0),_.set(this,void 0),P.set(this,void 0),v.set(this,void 0),w.set(this,""),p.set(this,void 0),f.set(this,!1),E.set(this,!1),g.set(this,!1),this._onMessageEmitter=new u.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new u.Emitter),this._onDidDispose=Me(this,c,"f").event,Ze(this,I,l,"f"),Ze(this,R,h,"f"),Ze(this,p,S,"f"),Ze(this,_,L,"f"),Ze(this,P,F,"f"),Ze(this,v,M,"f"),Ze(this,g,a(M),"f"),Ze(this,k,A,"f")}dispose(){Ze(this,f,!0,"f"),Me(this,c,"f").fire(),Me(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(l){return Ze(this,E,!0,"f"),(0,y.asWebviewUri)(l,Me(this,_,"f"))}get cspSource(){const l=Me(this,v,"f").extensionLocation;if(l.scheme===n.Schemas.https||l.scheme===n.Schemas.http){let h=l.toString();return h.endsWith("/")||(h+="/"),h+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Me(this,w,"f")}set html(l){this.assertNotDisposed(),Me(this,w,"f")!==l&&(Ze(this,w,l,"f"),!Me(this,E,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(l)&&(Ze(this,E,!0,"f"),Me(this,k,"f").report("Webview vscode-resource: uris",Me(this,v,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Me(this,R,"f").$setHtml(Me(this,I,"f"),l))}get options(){return this.assertNotDisposed(),Me(this,p,"f")}set options(l){this.assertNotDisposed(),Me(this,R,"f").$setOptions(Me(this,I,"f"),o(Me(this,v,"f"),Me(this,P,"f"),l)),Ze(this,p,l,"f")}async postMessage(l){if(Me(this,f,"f"))return!1;const h=(0,C.serializeWebviewMessage)(l,{serializeBuffersForPostMessage:Me(this,g,"f")});return Me(this,R,"f").$postMessage(Me(this,I,"f"),h.message,...h.buffers)}assertNotDisposed(){if(Me(this,f,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,I=new WeakMap,R=new WeakMap,k=new WeakMap,_=new WeakMap,P=new WeakMap,v=new WeakMap,w=new WeakMap,p=new WeakMap,f=new WeakMap,E=new WeakMap,g=new WeakMap,c=new WeakMap;function a(s){try{const l=(0,T.normalizeVersion)((0,T.parseVersion)(s.engines.vscode));return!!l&&l.majorBase>=1&&l.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;class d{constructor(l,h,S,L,F){this.remoteInfo=h,this.workspace=S,this._logService=L,this._deprecationService=F,this._webviews=new Map,this._webviewProxy=l.getProxy(b.MainContext.MainThreadWebviews)}$onMessage(l,h,S){const L=this.getWebview(l);if(L){const{message:F}=(0,C.deserializeWebviewMessage)(h,S.value);L._onMessageEmitter.fire(F)}}$onMissingCsp(l,h){this._logService.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(l,h,S){const L=new m(l,this._webviewProxy,r(h),this.remoteInfo,this.workspace,S,this._deprecationService);return this._webviews.set(l,L),L._onDidDispose(()=>{this._webviews.delete(l)}),L}deleteWebview(l){this._webviews.delete(l)}getWebview(l){return this._webviews.get(l)}}e.ExtHostWebviews=d;function i(s){return{id:s.identifier,location:s.extensionLocation}}e.toExtensionData=i;function o(s,l,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||t(s,l)}}e.serializeWebviewOptions=o;function r(s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots?.map(l=>D.URI.from(l))}}e.reviveOptions=r;function t(s,l){return[...(l?.getWorkspaceFolders()||[]).map(h=>h.uri),s.extensionLocation]}}),define(Ie[265],ke([0,1,21,60,6,10,22,2,15,71,87,5,7]),function(J,e,u,n,D,T,C,y,b,I,R,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class P{constructor(a,d){this.document=a,this._storagePath=d,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(a){return this._edits.add([a])}async undo(a,d){await this.getEdit(a).undo(),d||this.disposeBackup()}async redo(a,d){await this.getEdit(a).redo(),d||this.disposeBackup()}disposeEdits(a){for(const d of a)this._edits.delete(d)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const a=c(this.document.uri)+this._backupCounter++;return(0,C.joinPath)(this._storagePath,a)}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(a){const d=this._edits.get(a,0);if(!d)throw new Error("No edit found");return d}}class v{constructor(){this._documents=new Map}get(a,d){return this._documents.get(this.key(a,d))}add(a,d,i){const o=this.key(a,d.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${a} resource:${d.uri}`);const r=new P(d,i);return this._documents.set(o,r),r}delete(a,d){const i=this.key(a,d.uri);this._documents.delete(i)}key(a,d){return`${a}@@@${d}`}}var w;(function(m){m[m.Text=0]="Text",m[m.Custom=1]="Custom"})(w||(w={}));class p{constructor(){this._providers=new Map}addTextProvider(a,d,i){return this.add(0,a,d,i)}addCustomProvider(a,d,i){return this.add(1,a,d,i)}get(a){return this._providers.get(a)}add(a,d,i,o){if(this._providers.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this._providers.set(d,{type:a,extension:i,provider:o}),new _.Disposable(()=>this._providers.delete(d))}}class f{constructor(a,d,i,o,r){this._extHostDocuments=d,this._extensionStoragePaths=i,this._extHostWebview=o,this._extHostWebviewPanels=r,this._editorProviders=new p,this._documents=new v,this._proxy=a.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,d,i,o){const r=new D.DisposableStore;return E(i)?(r.add(this._editorProviders.addTextProvider(d,a,i)),this._proxy.$registerTextEditorProvider((0,I.toExtensionData)(a),d,o.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(a))):(r.add(this._editorProviders.addCustomProvider(d,a,i)),this.supportEditing(i)&&r.add(i.onDidChangeCustomDocument(t=>{const s=this.getCustomDocumentEntry(d,t.document.uri);if(g(t)){const l=s.addEdit(t);this._proxy.$onDidEdit(t.document.uri,d,l,t.label)}else this._proxy.$onContentChange(t.document.uri,d)})),this._proxy.$registerCustomEditorProvider((0,I.toExtensionData)(a),d,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(a))),_.Disposable.from(r,new _.Disposable(()=>{this._proxy.$unregisterEditorProvider(d)}))}async $createCustomDocument(a,d,i,o,r){const t=this._editorProviders.get(d);if(!t)throw new Error(`No provider found for '${d}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${d}'`);const s=y.URI.revive(a),l=await t.provider.openCustomDocument(s,{backupId:i,untitledDocumentData:o?.buffer},r);let h;return this.supportEditing(t.provider)&&this._extensionStoragePaths&&(h=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(d,l,h),{editable:this.supportEditing(t.provider)}}async $disposeCustomDocument(a,d){const i=this._editorProviders.get(d);if(!i)throw new Error(`No provider found for '${d}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${d}'`);const o=y.URI.revive(a),{document:r}=this.getCustomDocumentEntry(d,o);this._documents.delete(d,r),r.dispose()}async $resolveWebviewEditor(a,d,i,o,r,t){const s=this._editorProviders.get(i);if(!s)throw new Error(`No provider found for '${i}'`);const l=b.ViewColumn.to(r),h=this._extHostWebview.createNewWebview(d,o.webviewOptions,s.extension),S=this._extHostWebviewPanels.createNewWebviewPanel(d,i,o.title,l,o.panelOptions,h,!0),L=y.URI.revive(a);switch(s.type){case 1:{const{document:F}=this.getCustomDocumentEntry(i,L);return s.provider.resolveCustomEditor(F,S,t)}case 0:{const F=this._extHostDocuments.getDocument(L);return s.provider.resolveCustomTextEditor(F,S,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,d,i){this.getCustomDocumentEntry(d,a).disposeEdits(i)}async $onMoveCustomEditor(a,d,i){const o=this._editorProviders.get(i);if(!o)throw new Error(`No provider found for '${i}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const r=this._extHostWebviewPanels.getWebviewPanel(a);if(!r)throw new Error("No webview found");const t=y.URI.revive(d),s=this._extHostDocuments.getDocument(t);await o.provider.moveCustomTextEditor(s,r,u.CancellationToken.None)}async $undo(a,d,i,o){return this.getCustomDocumentEntry(d,a).undo(i,o)}async $redo(a,d,i,o){return this.getCustomDocumentEntry(d,a).redo(i,o)}async $revert(a,d,i){const o=this.getCustomDocumentEntry(d,a);await this.getCustomEditorProvider(d).revertCustomDocument(o.document,i),o.disposeBackup()}async $onSave(a,d,i){const o=this.getCustomDocumentEntry(d,a);await this.getCustomEditorProvider(d).saveCustomDocument(o.document,i),o.disposeBackup()}async $onSaveAs(a,d,i,o){const r=this.getCustomDocumentEntry(d,a);return this.getCustomEditorProvider(d).saveCustomDocumentAs(r.document,y.URI.revive(i),o)}async $backup(a,d,i){const o=this.getCustomDocumentEntry(d,a),t=await this.getCustomEditorProvider(d).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},i);return o.updateBackup(t),t.id}getCustomDocumentEntry(a,d){const i=this._documents.get(a,y.URI.revive(d));if(!i)throw new Error("No custom document found");return i}getCustomEditorProvider(a){const i=this._editorProviders.get(a)?.provider;if(!i||!this.supportEditing(i))throw new Error("Custom document is not editable");return i}supportEditing(a){return!!a.onDidChangeCustomDocument}}e.ExtHostCustomEditors=f;function E(m){return typeof m.resolveCustomTextEditor=="function"}function g(m){return typeof m.undo=="function"&&typeof m.redo=="function"}function c(m){const a=m.scheme===T.Schemas.file||m.scheme===T.Schemas.untitled?m.fsPath:m.toString();return(0,n.hash)(a)+""}});var Ze=this&&this.__classPrivateFieldSet||function(J,e,u,n,D){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?D.call(J,u):D?D.value=u:e.set(J,u),u},Me=this&&this.__classPrivateFieldGet||function(J,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!n:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(J):n?n.value:e.get(J)};define(Ie[266],ke([0,1,3,6,2,34,15,71,5,7]),function(J,e,u,n,D,T,C,y,b,I){"use strict";var R,k,_,P,v,w,p,f,E,g,c,m,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class d extends n.Disposable{constructor(t,s,l,h){super();R.set(this,void 0),k.set(this,void 0),_.set(this,void 0),P.set(this,void 0),v.set(this,void 0),w.set(this,void 0),p.set(this,void 0),f.set(this,void 0),E.set(this,!0),g.set(this,void 0),c.set(this,!1),m.set(this,this._register(new u.Emitter)),this.onDidDispose=Me(this,m,"f").event,a.set(this,this._register(new u.Emitter)),this.onDidChangeViewState=Me(this,a,"f").event,Ze(this,R,t,"f"),Ze(this,k,s,"f"),Ze(this,P,l,"f"),Ze(this,_,h.viewType,"f"),Ze(this,v,h.panelOptions,"f"),Ze(this,f,h.viewColumn,"f"),Ze(this,w,h.title,"f"),Ze(this,g,h.active,"f")}dispose(){Me(this,c,"f")||(Ze(this,c,!0,"f"),Me(this,m,"f").fire(),Me(this,k,"f").$disposeWebview(Me(this,R,"f")),Me(this,P,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Me(this,P,"f")}get viewType(){return this.assertNotDisposed(),Me(this,_,"f")}get title(){return this.assertNotDisposed(),Me(this,w,"f")}set title(t){this.assertNotDisposed(),Me(this,w,"f")!==t&&(Ze(this,w,t,"f"),Me(this,k,"f").$setTitle(Me(this,R,"f"),t))}get iconPath(){return this.assertNotDisposed(),Me(this,p,"f")}set iconPath(t){this.assertNotDisposed(),Me(this,p,"f")!==t&&(Ze(this,p,t,"f"),Me(this,k,"f").$setIconPath(Me(this,R,"f"),D.URI.isUri(t)?{light:t,dark:t}:t))}get options(){return Me(this,v,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Me(this,f,"f")=="number"&&Me(this,f,"f")<0))return Me(this,f,"f")}get active(){return this.assertNotDisposed(),Me(this,g,"f")}get visible(){return this.assertNotDisposed(),Me(this,E,"f")}_updateViewState(t){Me(this,c,"f")||(this.active!==t.active||this.visible!==t.visible||this.viewColumn!==t.viewColumn)&&(Ze(this,g,t.active,"f"),Ze(this,E,t.visible,"f"),Ze(this,f,t.viewColumn,"f"),Me(this,a,"f").fire({webviewPanel:this}))}reveal(t,s){this.assertNotDisposed(),Me(this,k,"f").$reveal(Me(this,R,"f"),{viewColumn:typeof t=="undefined"?void 0:C.ViewColumn.from(t),preserveFocus:!!s})}assertNotDisposed(){if(Me(this,c,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,k=new WeakMap,_=new WeakMap,P=new WeakMap,v=new WeakMap,w=new WeakMap,p=new WeakMap,f=new WeakMap,E=new WeakMap,g=new WeakMap,c=new WeakMap,m=new WeakMap,a=new WeakMap;class i{constructor(t,s,l){this.webviews=s,this.workspace=l,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=t.getProxy(b.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(t,s,l,h,S={}){const L=typeof h=="object"?h.viewColumn:h,F={viewColumn:C.ViewColumn.from(L),preserveFocus:typeof h=="object"&&!!h.preserveFocus},M=(0,y.shouldSerializeBuffersForPostMessage)(t),A=i.newHandle();this._proxy.$createWebviewPanel((0,y.toExtensionData)(t),A,s,{title:l,panelOptions:o(S),webviewOptions:(0,y.serializeWebviewOptions)(t,this.workspace,S),serializeBuffersForPostMessage:M},F);const B=this.webviews.createNewWebview(A,S,t);return this.createNewWebviewPanel(A,s,l,L,S,B,!0)}$onDidChangeWebviewPanelViewStates(t){const s=Object.keys(t);s.sort((l,h)=>{const S=t[l],L=t[h];return S.active?1:L.active?-1:+S.visible-+L.visible});for(const l of s){const h=this.getWebviewPanel(l);if(!h)continue;const S=t[l];h._updateViewState({active:S.active,visible:S.visible,viewColumn:C.ViewColumn.to(S.position)})}}async $onDidDisposeWebviewPanel(t){this.getWebviewPanel(t)?.dispose(),this._webviewPanels.delete(t),this.webviews.deleteWebview(t)}registerWebviewPanelSerializer(t,s,l){if(this._serializers.has(s))throw new Error(`Serializer for '${s}' already registered`);return this._serializers.set(s,{serializer:l,extension:t}),this._proxy.$registerSerializer(s,{serializeBuffersForPostMessage:(0,y.shouldSerializeBuffersForPostMessage)(t)}),new I.Disposable(()=>{this._serializers.delete(s),this._proxy.$unregisterSerializer(s)})}async $deserializeWebviewPanel(t,s,l,h){const S=this._serializers.get(s);if(!S)throw new Error(`No serializer found for '${s}'`);const{serializer:L,extension:F}=S,M=this.webviews.createNewWebview(t,l.webviewOptions,F),A=this.createNewWebviewPanel(t,s,l.title,h,l.panelOptions,M,l.active);await L.deserializeWebviewPanel(A,l.state)}createNewWebviewPanel(t,s,l,h,S,L,F){const M=new d(t,this._proxy,L,{viewType:s,title:l,viewColumn:h,panelOptions:S,active:F});return this._webviewPanels.set(t,M),M}getWebviewPanel(t){return this._webviewPanels.get(t)}}e.ExtHostWebviewPanels=i;function o(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(J,e,u,n,D){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?D.call(J,u):D?D.value=u:e.set(J,u),u},Me=this&&this.__classPrivateFieldGet||function(J,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!n:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(J):n?n.value:e.get(J)};define(Ie[267],ke([0,1,3,6,71,27,15,5,7]),function(J,e,u,n,D,T,C,y,b){"use strict";var I,R,k,_,P,v,w,p,f,E,g,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends n.Disposable{constructor(i,o,r,t,s,l,h){super();I.set(this,void 0),R.set(this,void 0),k.set(this,void 0),_.set(this,void 0),P.set(this,void 0),v.set(this,!1),w.set(this,void 0),p.set(this,void 0),f.set(this,void 0),E.set(this,void 0),g.set(this,this._register(new u.Emitter)),this.onDidChangeVisibility=Me(this,g,"f").event,c.set(this,this._register(new u.Emitter)),this.onDidDispose=Me(this,c,"f").event,Ze(this,k,r,"f"),Ze(this,p,t,"f"),Ze(this,I,i,"f"),Ze(this,R,o,"f"),Ze(this,_,s,"f"),Ze(this,P,l,"f"),Ze(this,w,h,"f")}dispose(){Me(this,v,"f")||(Ze(this,v,!0,"f"),Me(this,c,"f").fire(),Me(this,_,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Me(this,p,"f")}set title(i){this.assertNotDisposed(),Me(this,p,"f")!==i&&(Ze(this,p,i,"f"),Me(this,R,"f").$setWebviewViewTitle(Me(this,I,"f"),i))}get description(){return this.assertNotDisposed(),Me(this,f,"f")}set description(i){this.assertNotDisposed(),Me(this,f,"f")!==i&&(Ze(this,f,i,"f"),Me(this,R,"f").$setWebviewViewDescription(Me(this,I,"f"),i))}get visible(){return Me(this,w,"f")}get webview(){return Me(this,_,"f")}get viewType(){return Me(this,k,"f")}_setVisible(i){i===Me(this,w,"f")||Me(this,v,"f")||(Ze(this,w,i,"f"),Me(this,g,"f").fire())}get badge(){return this.assertNotDisposed(),(0,T.checkProposedApiEnabled)(Me(this,P,"f"),"badges"),Me(this,E,"f")}set badge(i){this.assertNotDisposed(),(0,T.checkProposedApiEnabled)(Me(this,P,"f"),"badges"),!(i?.value===Me(this,E,"f")?.value&&i?.tooltip===Me(this,E,"f")?.tooltip)&&(Ze(this,E,C.ViewBadge.from(i),"f"),Me(this,R,"f").$setWebviewViewBadge(Me(this,I,"f"),i))}show(i){this.assertNotDisposed(),Me(this,R,"f").$show(Me(this,I,"f"),!!i)}assertNotDisposed(){if(Me(this,v,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,R=new WeakMap,k=new WeakMap,_=new WeakMap,P=new WeakMap,v=new WeakMap,w=new WeakMap,p=new WeakMap,f=new WeakMap,E=new WeakMap,g=new WeakMap,c=new WeakMap;class a{constructor(i,o){this._extHostWebview=o,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=i.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,o,r,t){if(this._viewProviders.has(o))throw new Error(`View provider for '${o}' already registered`);return this._viewProviders.set(o,{provider:r,extension:i}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(i),o,{retainContextWhenHidden:t?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(i)}),new b.Disposable(()=>{this._viewProviders.delete(o),this._proxy.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(i,o,r,t,s){const l=this._viewProviders.get(o);if(!l)throw new Error(`No view provider found for '${o}'`);const{provider:h,extension:S}=l,L=this._extHostWebview.createNewWebview(i,{},S),F=new m(i,this._proxy,o,r,L,S,!0);this._webviewViews.set(i,F),await h.resolveWebviewView(F,{state:t},s)}async $onDidChangeWebviewViewVisibility(i,o){this.getWebviewView(i)._setVisible(o)}async $disposeWebviewView(i){const o=this.getWebviewView(i);this._webviewViews.delete(i),o.dispose(),this._extHostWebview.deleteWebview(i)}getWebviewView(i){const o=this._webviewViews.get(i);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=a}),define(Ie[137],ke([0,1,3,5,2,10,8,4,17]),function(J,e,u,n,D,T,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class Yn{constructor(k){this._onDidChangeWindowState=new u.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Yn.InitialState,this._proxy=k.getProxy(n.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(_=>this.$onDidChangeWindowFocus(_))}get state(){return this._state}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state={...this._state,focused:k},this._onDidChangeWindowState.fire(this._state))}openUri(k,_){let P;if(typeof k=="string"){P=k;try{k=D.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,C.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,P,_)}async asExternalUri(k,_){if((0,C.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const P=await this._proxy.$asExternalUri(k,_);return D.URI.from(P)}};I.InitialState={focused:!0},I=je([Ve(0,b.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,y.createDecorator)("IExtHostWindow")}),define(Ie[268],ke([0,1,112,269,62,38,2,14,45]),function(J,e,u,n,D,T,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class I{constructor(_,P,v){this._commands=_,this.logService=P,this._ipcHandlePath=v,this._server=n.createServer((w,p)=>this.onRequest(w,p)),this.setup().catch(w=>(P.error(w),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",_=>this.logService.error(_))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(_,P){const v=(p,f)=>{P.writeHead(p,{"content-type":"application/json"}),P.end(JSON.stringify(f||null),E=>E&&this.logService.error(E))},w=[];_.setEncoding("utf8"),_.on("data",p=>w.push(p)),_.on("end",async()=>{try{const p=JSON.parse(w.join(""));let f;switch(p.type){case"open":f=await this.open(p);break;case"openExternal":f=await this.openExternal(p);break;case"status":f=await this.getStatus(p);break;case"extensionManagement":f=await this.manageExtensions(p);break;default:v(404,`Unknown message type: ${p.type}`);break}v(200,f)}catch(p){const f=p instanceof Error?p.message:JSON.stringify(p);v(500,f),this.logService.error("Error while processing pipe request",p)}})}async open(_){const{fileURIs:P,folderURIs:v,forceNewWindow:w,diffMode:p,mergeMode:f,addMode:E,forceReuseWindow:g,gotoLineMode:c,waitMarkerFilePath:m,remoteAuthority:a}=_,d=[];if(Array.isArray(v))for(const t of v)try{d.push({folderUri:C.URI.parse(t)})}catch{}if(Array.isArray(P))for(const t of P)try{(0,b.hasWorkspaceFileExtension)(t)?d.push({workspaceUri:C.URI.parse(t)}):d.push({fileUri:C.URI.parse(t)})}catch{}const i=m?C.URI.file(m):void 0,r={forceNewWindow:w,diffMode:p,mergeMode:f,addMode:E,gotoLineMode:c,forceReuseWindow:g,preferNewWindow:!g&&!i&&!E,waitMarkerFileURI:i,remoteAuthority:a};return this._commands.executeCommand("_remoteCLI.windowOpen",d,r),""}async openExternal(_){for(const P of _.uris){const v=C.URI.parse(P),w=v.scheme==="file"?v:P;await this._commands.executeCommand("_remoteCLI.openExternal",w)}}async manageExtensions(_){const P=w=>w?.map(p=>/\.vsix$/i.test(p)?C.URI.parse(p):p),v={list:_.list,install:P(_.install),uninstall:P(_.uninstall),force:_.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",v)}async getStatus(_){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&D.existsSync(this._ipcHandlePath)&&D.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=I;let R=class extends I{constructor(_,P){super(_,P,(0,u.createRandomIPCHandle)())}};R=je([Ve(0,T.IExtHostCommands),Ve(1,y.ILogService)],R),e.CLIServer=R}),define(Ie[270],ke([0,1,242,26,17]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const T=1024*1024;let C=class extends u.AbstractExtHostConsoleForwarder{constructor(b,I){super(b,I);this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(b,I,R){const k=b==="error"||b==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,k.write(`
START_NATIVE_LOG
`),I.apply(console,R),k.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(b,I){const R=process[b],k=R.write;let _="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(P,v,w)=>{if(!this._isMakingConsoleCall){_+=P.toString(v);const p=_.length>T?_.length:_.lastIndexOf(`
`);p!==-1&&(console[I](_.slice(0,p)),_=_.slice(p+1))}k.call(R,P,v,w)}})}};C=je([Ve(0,D.IExtHostRpcService),Ve(1,n.IExtHostInitDataService)],C),e.ExtHostConsoleForwarder=C}),define(Ie[271],ke([0,1,9,63,34,38,6,5,2,17]),function(J,e,u,n,D,T,C,y,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends C.Disposable{constructor(_,P){super();const v=_.getProxy(y.MainContext.MainThreadDownloadService);P.registerCommand(!1,"_workbench.downloadResource",async w=>{const p=b.URI.file((0,u.join)((0,n.tmpdir)(),(0,D.generateUuid)()));return await v.$download(w,p),p})}};R=je([Ve(0,I.IExtHostRpcService),Ve(1,T.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(Ie[272],ke([0,1,136,10,196,34]),function(J,e,u,n,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class C extends u.ExtHostLoggerService{doCreateLogger(b,I,R){return b.scheme===n.Schemas.file?new D.SpdLogLogger(R?.name||(0,T.generateUuid)(),b.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,I):super.doCreateLogger(b,I,R)}}e.ExtHostLoggerService=C}),define(Ie[273],ke([0,1,62,9,2,70,6,10,18,29]),function(J,e,u,n,D,T,C,y,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class R extends T.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(a){const d=await super._getWorkspaceStorageURI(a);if(d.scheme!==y.Schemas.file)return d;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${d.fsPath}.`),d;const i=d.fsPath;let o=0;do{let r;o===0?r=i:r=/[/\\]$/.test(i)?`${i.substr(0,i.length-1)}-${o}`:`${i}-${o}`,await k(r);const t=n.join(r,"vscode.lock"),s=await w(this._logService,t,!1);if(s)return this._workspaceStorageLock=s,process.on("exit",()=>{s.dispose()}),D.URI.file(r);o++}while(o<10);return d}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=R;async function k(m){try{await I.Promises.stat(m);return}catch{}try{await I.Promises.mkdir(m,{recursive:!0})}catch{}}const _=1e3,P=10*60*1e3;class v extends C.Disposable{constructor(a,d){super();this.logService=a,this.filename=d,this._timer=this._register(new b.IntervalTimer),this._timer.cancelAndSet(async()=>{const i=await p(a,d);(!i||i.pid!==process.pid)&&(a.info(`Lock '${d}': The lock was lost unexpectedly.`),this._timer.cancel());try{await I.Promises.utimes(d,new Date,new Date)}catch(o){a.error(o),a.info(`Lock '${d}': Could not update mtime.`)}},_)}dispose(){super.dispose();try{u.unlinkSync(this.filename)}catch{}}async setWillRelease(a){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${a} ms.`);try{const d={pid:process.pid,willReleaseAt:Date.now()+a};await I.Promises.writeFile(this.filename,JSON.stringify(d),{flag:"w"})}catch(d){this.logService.error(d)}}}async function w(m,a,d){try{const o={pid:process.pid,willReleaseAt:0};await I.Promises.writeFile(a,JSON.stringify(o),{flag:"wx"})}catch(o){m.error(o)}const i=await p(m,a);return!i||i.pid!==process.pid?d?(m.info(`Lock '${a}': Could not acquire lock, giving up.`),null):(m.info(`Lock '${a}': Could not acquire lock, checking if the file is stale.`),g(m,a)):(m.info(`Lock '${a}': Lock acquired.`),new v(m,a))}async function p(m,a){let d;try{d=await I.Promises.readFile(a)}catch(i){return m.error(i),null}try{return JSON.parse(String(d))}catch(i){return m.error(i),null}}async function f(m,a){let d;try{d=await I.Promises.stat(a)}catch(i){return m.error(i),0}return d.mtime.getTime()}function E(m){try{return process.kill(m,0),!0}catch{return!1}}async function g(m,a){const d=await p(m,a);if(!d)return m.info(`Lock '${a}': Could not read pid of lock holder.`),c(m,a);if(d.willReleaseAt){let s=d.willReleaseAt-Date.now();if(s<5e3){for(s>0?m.info(`Lock '${a}': The lockfile is scheduled to be released in ${s} ms.`):m.info(`Lock '${a}': The lockfile is scheduled to have been released.`);s>0;){if(await(0,b.timeout)(Math.min(100,s)),await f(m,a)===0)return c(m,a);s=d.willReleaseAt-Date.now()}return c(m,a)}}if(!E(d.pid))return m.info(`Lock '${a}': The pid ${d.pid} appears to be gone.`),c(m,a);const i=await f(m,a),o=Date.now()-i;if(o<=P)return m.info(`Lock '${a}': The lock does not look stale, elapsed: ${o} ms, giving up.`),null;m.info(`Lock '${a}': The lock looks stale, waiting for 2s.`),await(0,b.timeout)(2e3);const r=await f(m,a),t=Date.now()-r;return t<=P?(m.info(`Lock '${a}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null):(m.info(`Lock '${a}': The lock looks stale even after waiting for 2s.`),c(m,a))}async function c(m,a){m.info(`Lock '${a}': Deleting a stale lock.`);try{await I.Promises.unlink(a)}catch{}return w(m,a,!0)}}),define(Ie[274],ke([0,1,34,17,39]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let T=class extends D.BaseExtHostTerminalService{constructor(y){super(!0,y)}createTerminal(y,b,I){return this.createTerminalFromOptions({name:y,shellPath:b,shellArgs:I})}createTerminalFromOptions(y,b){const I=new D.ExtHostTerminal(this._proxy,(0,u.generateUuid)(),y,y.name);return this._terminals.push(I),I.create(y,this._serializeParentTerminal(y,b)),I.value}};T=je([Ve(0,n.IExtHostRpcService)],T),e.ExtHostTerminalService=T}),define(Ie[275],ke([0,1,5,17,178,6,26,2,42,22,29,7,13,52,3,124,94,14]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v,w,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class E extends w.DisposableTunnel{}function g(s){const l=s.trim().split(`
`),h=[];return l.forEach(L=>{const F=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(L);F&&F.length>=3&&h.push({pid:parseInt(F[1],10),socket:parseInt(F[2],10)})}),h.reduce((L,F)=>(L[F.socket]=F,L),{})}e.getSockets=g;function c(...s){const l=[].concat(...s.map(a));return[...new Map(l.filter(h=>h.st==="0A").map(h=>{const S=h.local_address.split(":");return{socket:parseInt(h.inode,10),ip:m(S[0]),port:parseInt(S[1],16)}}).map(h=>[h.ip+":"+h.port,h])).values()]}e.loadListeningPorts=c;function m(s){let l="";if(s.length===8)for(let h=s.length-2;h>=0;h-=2)l+=parseInt(s.substr(h,2),16),h!==0&&(l+=".");else for(let h=s.length-4;h>=0;h-=4)l+=parseInt(s.substr(h,4),16).toString(16),h!==0&&(l+=":");return l}e.parseIpAddress=m;function a(s){const l=s.trim().split(`
`),h=l.shift().trim().split(/\s+/).filter(L=>L!=="rx_queue"&&L!=="tm->when");return l.map(L=>L.trim().split(/\s+/).reduce((F,M,A)=>(F[h[A]||A]=M,F),{}))}e.loadConnectionTable=a;function d(s){return!!s.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||s.indexOf("out/server-main.js")!==-1||s.indexOf("_productName=VSCode")!==-1}function i(s){const l=s.trim().split(`
`),h=[];return l.forEach(S=>{const L=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(S);L&&L.length>=4&&h.push({pid:parseInt(L[1],10),ppid:parseInt(L[2]),cmd:L[3]})}),h}e.getRootProcesses=i;async function o(s,l,h){const S=h.reduce((F,M)=>(F[M.pid]=M,F),{}),L=[];return s.forEach(({socket:F,ip:M,port:A})=>{const B=l[F]?l[F].pid:void 0,$=B?S[B]?.cmd:void 0;B&&$&&!d($)&&L.push({host:M,port:A,detail:$,pid:B})}),L}e.findPorts=o;function r(s,l,h){const S=new Map,L=i(l);for(const F of s){const M=h.get(F.port);if(M){S.set(F.port,M);continue}const A=L.find(B=>B.cmd.includes(`${F.port}`));if(A){let B=A,$;do $=L.find(U=>U.ppid===B.pid),$&&(B=$);while($);S.set(F.port,{host:F.ip,port:F.port,pid:B.pid,detail:B.cmd,ppid:B.ppid})}else S.set(F.port,{host:F.ip,port:F.port,ppid:Number.MAX_VALUE})}return S}e.tryFindRootPorts=r;let t=class extends T.Disposable{constructor(l,h,S){super();this.logService=S,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new v.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=l.getProxy(u.MainContext.MainThreadTunnelService),_.isLinux&&h.remote.isRemote&&h.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(l,h){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${l.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const S=await this._proxy.$openTunnel(h,l.displayName);if(S){const L=new E(S.remoteAddress,S.localAddress,()=>this._proxy.$closeTunnel(S.remoteAddress));return this._register(L),L}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(l){return Math.max(l*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(l,h){const S=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(S,{selector:l,provider:h}),this._proxy.$registerPortsAttributesProvider(l,S),new k.Disposable(()=>{this._portAttributesProviders.delete(S),this._proxy.$unregisterPortsAttributesProvider(S)})}async $providePortAttributes(l,h,S,L,F){const M=[];for(const B of l){const $=this._portAttributesProviders.get(B);if(!$)return[];M.push(...await Promise.all(h.map(async U=>$.provider.providePortAttributes(U,S,L,F))))}const A=M.filter(B=>!!B);return A.length>0?A.map(B=>({autoForwardAction:B.autoForwardAction,port:B.port})):[]}async $registerCandidateFinder(l){if(l&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=l;const h=new p.MovingAverage;let S;for(;this._candidateFindingEnabled;){const L=new Date().getTime(),F=(await this.findCandidatePorts()).filter(A=>(0,w.isLocalhost)(A.host)||(0,w.isAllInterfaces)(A.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${F.map(A=>A.port).join(", ")}`);const M=new Date().getTime()-L;h.update(M),(!S||JSON.stringify(S)!==JSON.stringify(F))&&(S=F,await this._proxy.$onFoundNewCandidates(S)),await new Promise(A=>setTimeout(()=>A(),this.calculateDelay(h.value)))}}async setTunnelFactory(l){if(l){if(l.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(l.candidatePortSource),l.showCandidatePort&&(this._showCandidatePort=l.showCandidatePort,this._proxy.$setCandidateFilter()),l.tunnelFactory){this._forwardPortProvider=l.tunnelFactory;let h=l.tunnelFeatures?.privacyOptions??[];l.tunnelFeatures?.public&&h.length===0&&(h=[{id:"private",label:D.localize(0,null),themeIcon:"lock"},{id:"public",label:D.localize(1,null),themeIcon:"eye"}]);const S=l.tunnelFeatures?{elevation:!!l.tunnelFeatures?.elevation,public:!!l.tunnelFeatures?.public,privacyOptions:h}:void 0;this._proxy.$setTunnelProvider(S)}}else this._forwardPortProvider=void 0;return(0,T.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(l,h){if(this._extensionTunnels.has(l.host)){const S=this._extensionTunnels.get(l.host);S.has(l.port)&&(h&&S.get(l.port).disposeListener.dispose(),await S.get(l.port).tunnel.dispose(),S.delete(l.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(l,h){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const S=this._forwardPortProvider(l,h);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),S!==void 0){const L=await S;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(l.remoteAddress.host)||this._extensionTunnels.set(l.remoteAddress.host,new Map);const F=this._register(L.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(L.remoteAddress))));return this._extensionTunnels.get(l.remoteAddress.host).set(l.remoteAddress.port,{tunnel:L,disposeListener:F}),P.TunnelDtoConverter.fromApiTunnel(L)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(l){const h=await Promise.all(l.map(L=>this._showCandidatePort(L.host,L.port,L.detail??""))),S=l.filter((L,F)=>h[F]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${l.map(L=>L.port).join(", ")} to ${S.map(L=>L.port).join(", ")}`),S}async findCandidatePorts(){let l="",h="";try{l=await R.Promises.readFile("/proc/net/tcp","utf8"),h=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const S=c(l,h),L=await new Promise(z=>{(0,b.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(N,V,x)=>{z(V)})}),F=g(L),M=await R.Promises.readdir("/proc"),A=[];for(const z of M)try{const N=Number(z),V=I.joinPath(y.URI.file("/proc"),z);if((await R.Promises.stat(V.fsPath)).isDirectory()&&!isNaN(N)){const q=await R.Promises.readlink(I.joinPath(V,"cwd").fsPath),te=await R.Promises.readFile(I.joinPath(V,"cmdline").fsPath,"utf8");A.push({pid:N,cwd:q,cmd:te})}}catch{}const B=[],$=S.filter(z=>{const N=F[z.socket];return N||B.push(z),N}),U=o($,F,A);let X;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${B.length}`),B.length>0){const z=await new Promise(N=>{(0,b.exec)("ps -F -A -l | grep root",(V,x,q)=>{N(x)})});this._foundRootPorts=r(B,z,this._foundRootPorts),X=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${X.join(", ")}`)}return U.then(z=>X?z.concat(X):z)}};t=je([Ve(0,n.IExtHostRpcService),Ve(1,C.IExtHostInitDataService),Ve(2,f.ILogService)],t),e.ExtHostTunnelService=t}),define(Ie[276],ke([0,1,18,23,21,12,3,6,108,236,53]),function(J,e,u,n,D,T,C,y,b,I,R){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function _(S,L){try{return JSON.stringify(S,L)}catch{return"null"}}const P="$$ref$$",v={[P]:-1};class w{constructor(L,F){this.jsonString=L,this.referencedBuffers=F}}function p(S,L=null,F=!1){const M=[];return{jsonString:(F?_:JSON.stringify)(S,(B,$)=>{if(typeof $=="undefined")return v;if(typeof $=="object"){if($ instanceof n.VSBuffer){const U=M.push($)-1;return{[P]:U}}if(L)return L(B,$)}return $}),referencedBuffers:M}}e.stringifyJsonWithBufferRefs=p;function f(S,L,F){return JSON.parse(S,(M,A)=>{if(A){const B=A[P];if(typeof B=="number")return L[B];if(F&&A.$mid===1)return F.transformIncoming(A)}return A})}e.parseJsonAndRestoreBufferRefs=f;function E(S,L){return JSON.stringify(S,L)}function g(S){return S?(L,F)=>F&&F.$mid===1?S.transformOutgoing(F):F:null}var c;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));var m;(function(S){S[S.Responsive=0]="Responsive",S[S.Unresponsive=1]="Unresponsive"})(m=e.ResponsiveState||(e.ResponsiveState={}));const a=()=>{},d=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class o extends y.Disposable{constructor(L,F=null,M=null){super();this[k]=!0,this._onDidChangeResponsiveState=this._register(new C.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=L,this._logger=F,this._uriTransformer=M,this._uriReplacer=g(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let A=0,B=R.ProxyIdentifier.count;A<B;A++)this._locals[A]=null,this._proxies[A]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new u.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(A=>this._receiveOneMessage(A))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(L=>{this._pendingRPCReplies[L].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(L){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(L){this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(L){this._responsiveState!==L&&(this._responsiveState=L,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(L){return this._uriTransformer?(0,b.transformIncomingURIs)(L,this._uriTransformer):L}getProxy(L){const{nid:F,sid:M}=L;return this._proxies[F]||(this._proxies[F]=this._createProxy(F,M)),this._proxies[F]}_createProxy(L,F){const M={get:(A,B)=>(typeof B=="string"&&!A[B]&&B.charCodeAt(0)===36&&(A[B]=(...$)=>this._remoteCall(L,B,$)),B===i?F:A[B])};return new Proxy(Object.create(null),M)}set(L,F){return this._locals[L.nid]=F,F}assertRegistered(L){for(let F=0,M=L.length;F<M;F++){const A=L[F];if(!this._locals[A.nid])throw new Error(`Missing proxy instance ${A.sid}`)}}_receiveOneMessage(L){if(this._isDisposed)return;const F=L.byteLength,M=r.read(L,0),A=M.readUInt8(),B=M.readUInt32();switch(A){case 1:case 2:{let{rpcId:$,method:U,args:X}=s.deserializeRequestJSONArgs(M);this._uriTransformer&&(X=(0,b.transformIncomingURIs)(X,this._uriTransformer)),this._receiveRequest(F,B,$,U,X,A===2);break}case 3:case 4:{let{rpcId:$,method:U,args:X}=s.deserializeRequestMixedArgs(M);this._uriTransformer&&(X=(0,b.transformIncomingURIs)(X,this._uriTransformer)),this._receiveRequest(F,B,$,U,X,A===4);break}case 5:{this._logger?.logIncoming(F,B,0,"ack"),this._onDidReceiveAcknowledge(B);break}case 6:{this._receiveCancel(F,B);break}case 7:{this._receiveReply(F,B,void 0);break}case 9:{let $=s.deserializeReplyOKJSON(M);this._uriTransformer&&($=(0,b.transformIncomingURIs)($,this._uriTransformer)),this._receiveReply(F,B,$);break}case 10:{const $=s.deserializeReplyOKJSONWithBuffers(M,this._uriTransformer);this._receiveReply(F,B,$);break}case 8:{const $=s.deserializeReplyOKVSBuffer(M);this._receiveReply(F,B,$);break}case 11:{let $=s.deserializeReplyErrError(M);this._uriTransformer&&($=(0,b.transformIncomingURIs)($,this._uriTransformer)),this._receiveReplyErr(F,B,$);break}case 12:{this._receiveReplyErr(F,B,void 0);break}default:console.error("received unexpected message"),console.error(L)}}_receiveRequest(L,F,M,A,B,$){this._logger?.logIncoming(L,F,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(M)}.${A}(`,B);const U=String(F);let X,z;if($){const V=new D.CancellationTokenSource;B.push(V.token),X=this._invokeHandler(M,A,B),z=()=>V.cancel()}else X=this._invokeHandler(M,A,B),z=a;this._cancelInvokedHandlers[U]=z;const N=s.serializeAcknowledged(F);this._logger?.logOutgoing(N.byteLength,F,1,"ack"),this._protocol.send(N),X.then(V=>{delete this._cancelInvokedHandlers[U];const x=s.serializeReplyOK(F,V,this._uriReplacer);this._logger?.logOutgoing(x.byteLength,F,1,"reply:",V),this._protocol.send(x)},V=>{delete this._cancelInvokedHandlers[U];const x=s.serializeReplyErr(F,V);this._logger?.logOutgoing(x.byteLength,F,1,"replyErr:",V),this._protocol.send(x)})}_receiveCancel(L,F){this._logger?.logIncoming(L,F,1,"receiveCancel");const M=String(F);this._cancelInvokedHandlers[M]?.()}_receiveReply(L,F,M){this._logger?.logIncoming(L,F,0,"receiveReply:",M);const A=String(F);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const B=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A],B.resolveOk(M)}_receiveReplyErr(L,F,M){this._logger?.logIncoming(L,F,0,"receiveReplyErr:",M);const A=String(F);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const B=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A];let $;M&&(M.$isError?($=new Error,$.name=M.name,$.message=M.message,$.stack=M.stack):$=M),B.resolveErr($)}_invokeHandler(L,F,M){try{return Promise.resolve(this._doInvokeHandler(L,F,M))}catch(A){return Promise.reject(A)}}_doInvokeHandler(L,F,M){const A=this._locals[L];if(!A)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(L));const B=A[F];if(typeof B!="function")throw new Error("Unknown method "+F+" on actor "+(0,R.getStringIdentifierForProxy)(L));return B.apply(A,M)}_remoteCall(L,F,M){if(this._isDisposed)return new I.CanceledLazyPromise;let A=null;if(M.length>0&&D.CancellationToken.isCancellationToken(M[M.length-1])&&(A=M.pop()),A&&A.isCancellationRequested)return Promise.reject(T.canceled());const B=s.serializeRequestArguments(M,this._uriReplacer),$=++this._lastMessageId,U=String($),X=new I.LazyPromise;A&&A.onCancellationRequested(()=>{const N=s.serializeCancel($);this._logger?.logOutgoing(N.byteLength,$,0,"cancel"),this._protocol.send(s.serializeCancel($))}),this._pendingRPCReplies[U]=X,this._onWillSendRequest($);const z=s.serializeRequest($,L,F,B,!!A);return this._logger?.logOutgoing(z.byteLength,$,0,`request: ${(0,R.getStringIdentifierForProxy)(L)}.${F}(`,M),this._protocol.send(z),X}}e.RPCProtocol=o,k=d,o.UNRESPONSIVE_TIME=3*1e3;class r{constructor(L,F){this._buff=L,this._offset=F}static alloc(L,F,M){const A=new r(n.VSBuffer.alloc(M+1+4),0);return A.writeUInt8(L),A.writeUInt32(F),A}static read(L,F){return new r(L,F)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(L){this._buff.writeUInt8(L,this._offset),this._offset+=1}readUInt8(){const L=this._buff.readUInt8(this._offset);return this._offset+=1,L}writeUInt32(L){this._buff.writeUInt32BE(L,this._offset),this._offset+=4}readUInt32(){const L=this._buff.readUInt32BE(this._offset);return this._offset+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this._buff.writeUInt8(L.byteLength,this._offset),this._offset+=1,this._buff.set(L,this._offset),this._offset+=L.byteLength}readShortString(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const M=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,M}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readLongString(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,M}writeBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readVSBuffer(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+L);return this._offset+=L,F}static sizeMixedArray(L){let F=0;F+=1;for(let M=0,A=L.length;M<A;M++){const B=L[M];switch(F+=1,B.type){case 1:F+=this.sizeLongString(B.value);break;case 2:F+=this.sizeVSBuffer(B.value);break;case 3:F+=this.sizeUInt32,F+=this.sizeLongString(B.value);for(let $=0;$<B.buffers.length;++$)F+=this.sizeVSBuffer(B.buffers[$]);break;case 4:break}}return F}writeMixedArray(L){this._buff.writeUInt8(L.length,this._offset),this._offset+=1;for(let F=0,M=L.length;F<M;F++){const A=L[F];switch(A.type){case 1:this.writeUInt8(1),this.writeLongString(A.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(A.value);break;case 3:this.writeUInt8(3),this.writeUInt32(A.buffers.length),this.writeLongString(A.value);for(let B=0;B<A.buffers.length;++B)this.writeBuffer(A.buffers[B]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const F=new Array(L);for(let M=0;M<L;M++)switch(this.readUInt8()){case 1:F[M]=this.readLongString();break;case 2:F[M]=this.readVSBuffer();break;case 3:{const B=this.readUInt32(),$=this.readLongString(),U=[];for(let X=0;X<B;++X)U.push(this.readVSBuffer());F[M]=new R.SerializableObjectWithBuffers(f($,U,null));break}case 4:F[M]=void 0;break}return F}}r.sizeUInt32=4;var t;(function(S){S[S.Simple=0]="Simple",S[S.Mixed=1]="Mixed"})(t||(t={}));class s{static _useMixedArgSerialization(L){for(let F=0,M=L.length;F<M;F++)if(L[F]instanceof n.VSBuffer||L[F]instanceof R.SerializableObjectWithBuffers||typeof L[F]=="undefined")return!0;return!1}static serializeRequestArguments(L,F){if(this._useMixedArgSerialization(L)){const M=[];for(let A=0,B=L.length;A<B;A++){const $=L[A];if($ instanceof n.VSBuffer)M[A]={type:2,value:$};else if(typeof $=="undefined")M[A]={type:4};else if($ instanceof R.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:X}=p($.value,F);M[A]={type:3,value:n.VSBuffer.fromString(U),buffers:X}}else M[A]={type:1,value:n.VSBuffer.fromString(E($,F))}}return{type:1,args:M}}return{type:0,args:E(L,F)}}static serializeRequest(L,F,M,A,B){switch(A.type){case 0:return this._requestJSONArgs(L,F,M,A.args,B);case 1:return this._requestMixedArgs(L,F,M,A.args,B)}}static _requestJSONArgs(L,F,M,A,B){const $=n.VSBuffer.fromString(M),U=n.VSBuffer.fromString(A);let X=0;X+=r.sizeUInt8(),X+=r.sizeShortString($),X+=r.sizeLongString(U);const z=r.alloc(B?2:1,L,X);return z.writeUInt8(F),z.writeShortString($),z.writeLongString(U),z.buffer}static deserializeRequestJSONArgs(L){const F=L.readUInt8(),M=L.readShortString(),A=L.readLongString();return{rpcId:F,method:M,args:JSON.parse(A)}}static _requestMixedArgs(L,F,M,A,B){const $=n.VSBuffer.fromString(M);let U=0;U+=r.sizeUInt8(),U+=r.sizeShortString($),U+=r.sizeMixedArray(A);const X=r.alloc(B?4:3,L,U);return X.writeUInt8(F),X.writeShortString($),X.writeMixedArray(A),X.buffer}static deserializeRequestMixedArgs(L){const F=L.readUInt8(),M=L.readShortString(),A=L.readMixedArray(),B=new Array(A.length);for(let $=0,U=A.length;$<U;$++){const X=A[$];typeof X=="string"?B[$]=JSON.parse(X):B[$]=X}return{rpcId:F,method:M,args:B}}static serializeAcknowledged(L){return r.alloc(5,L,0).buffer}static serializeCancel(L){return r.alloc(6,L,0).buffer}static serializeReplyOK(L,F,M){if(typeof F=="undefined")return this._serializeReplyOKEmpty(L);if(F instanceof n.VSBuffer)return this._serializeReplyOKVSBuffer(L,F);if(F instanceof R.SerializableObjectWithBuffers){const{jsonString:A,referencedBuffers:B}=p(F.value,M,!0);return this._serializeReplyOKJSONWithBuffers(L,A,B)}else return this._serializeReplyOKJSON(L,_(F,M))}static _serializeReplyOKEmpty(L){return r.alloc(7,L,0).buffer}static _serializeReplyOKVSBuffer(L,F){let M=0;M+=r.sizeVSBuffer(F);const A=r.alloc(8,L,M);return A.writeVSBuffer(F),A.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static _serializeReplyOKJSON(L,F){const M=n.VSBuffer.fromString(F);let A=0;A+=r.sizeLongString(M);const B=r.alloc(9,L,A);return B.writeLongString(M),B.buffer}static _serializeReplyOKJSONWithBuffers(L,F,M){const A=n.VSBuffer.fromString(F);let B=0;B+=r.sizeUInt32,B+=r.sizeLongString(A);for(const U of M)B+=r.sizeVSBuffer(U);const $=r.alloc(10,L,B);$.writeUInt32(M.length),$.writeLongString(A);for(const U of M)$.writeBuffer(U);return $.buffer}static deserializeReplyOKJSON(L){const F=L.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(L,F){const M=L.readUInt32(),A=L.readLongString(),B=[];for(let $=0;$<M;++$)B.push(L.readVSBuffer());return new R.SerializableObjectWithBuffers(f(A,B,F))}static serializeReplyErr(L,F){const M=F?_(T.transformErrorForSerialization(F),null):void 0;if(typeof M!="string")return this._serializeReplyErrEmpty(L);const A=n.VSBuffer.fromString(M);let B=0;B+=r.sizeLongString(A);const $=r.alloc(11,L,B);return $.writeLongString(A),$.buffer}static deserializeReplyErrError(L){const F=L.readLongString();return JSON.parse(F)}static _serializeReplyErrEmpty(L){return r.alloc(12,L,0).buffer}}var l;(function(S){S[S.RequestJSONArgs=1]="RequestJSONArgs",S[S.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",S[S.RequestMixedArgs=3]="RequestMixedArgs",S[S.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",S[S.Acknowledged=5]="Acknowledged",S[S.Cancel=6]="Cancel",S[S.ReplyOKEmpty=7]="ReplyOKEmpty",S[S.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",S[S.ReplyOKJSON=9]="ReplyOKJSON",S[S.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",S[S.ReplyErrError=11]="ReplyErrError",S[S.ReplyErrEmpty=12]="ReplyErrEmpty"})(l||(l={}));var h;(function(S){S[S.String=1]="String",S[S.VSBuffer=2]="VSBuffer",S[S.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",S[S.Undefined=4]="Undefined"})(h||(h={}))}),define(Ie[277],ke([0,1,3,44,51,4,43,12,18]),function(J,e,u,n,D,T,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new D.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new D.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new D.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,T.createDecorator)(e.OUTPUT_SERVICE_ID);var I;(function(P){P[P.Append=1]="Append",P[P.Replace=2]="Replace",P[P.Clear=3]="Clear"})(I=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.channels=new Map,this._onDidRegisterChannel=new u.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new u.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(v){this.channels.has(v.id)||(this.channels.set(v.id,v),this._onDidRegisterChannel.fire(v.id))}getChannels(){const v=[];return this.channels.forEach(w=>v.push(w)),v}getChannel(v){return this.channels.get(v)}removeChannel(v){this.channels.delete(v),this._onDidRemoveChannel.fire(v)}}n.Registry.add(e.Extensions.OutputChannels,new R);function k(P,v,w,p,f){return(0,b.createCancelablePromise)(async E=>{await(0,C.whenProviderRegistered)(w,p);const g=n.Registry.as(e.Extensions.OutputChannels);try{await _(w,1,p,f,E),g.registerChannel({id:P,label:v,file:w,log:!0})}catch(c){(0,y.isCancellationError)(c)||f.error("Error while registering log channel",w.toString(),(0,y.getErrorMessage)(c))}})}e.registerLogChannel=k;async function _(P,v,w,p,f){if(!await w.exists(P)){if(f.isCancellationRequested)throw new y.CancellationError;if(v>10)throw new Error("Timed out while waiting for file to be created");p.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",P.toString()),await(0,b.timeout)(1e3,f),await _(P,v+1,w,p,f)}}}),define(Ie[138],ke([0,1,5,6,4,17,14,277,69,26,46,152,23,11]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class v extends n.Disposable{constructor(f,E,g,c){super();this.id=f,this.name=E,this.logger=g,this.proxy=c,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(f){this.append(f+`
`)}append(f){this.write(f),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,y.OutputChannelUpdateMode.Append))}clear(){const f=this.offset;this.logger.flush(),this.proxy.$update(this.id,y.OutputChannelUpdateMode.Clear,f)}replace(f){const E=this.offset;this.write(f),this.proxy.$update(this.id,y.OutputChannelUpdateMode.Replace,E),this.visible&&this.logger.flush()}show(f,E){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof f=="boolean"?f:E))}hide(){this.proxy.$close(this.id)}write(f){this.offset+=_.VSBuffer.fromString(f).byteLength,this.logger.info(f)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=v;let w=class{constructor(f,E,g,c,m){this.extHostFileSystem=g,this.extHostFileSystemInfo=c,this.loggerService=m,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=f.getProxy(u.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(E.logsLocation,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(f){this.visibleChannelId=f;for(const[E,g]of this.channels)g.visible=E===this.visibleChannelId}createOutputChannel(f,E,g){if(f=f.trim(),!f)throw new Error("illegal argument `name`. must not be falsy");if((0,P.isString)(E)&&!E.trim())throw new Error("illegal argument `languageId`. must not be empty");const c=this.doCreateOutputChannel(f,E,g);return c.then(m=>{this.channels.set(m.id,m),m.visible=m.id===this.visibleChannelId}),this.createExtHostOutputChannel(f,c)}async doCreateOutputChannel(f,E,g){const c=await this.createOutputDirectory(),m=this.extHostFileSystemInfo.extUri.joinPath(c,`${this.namePool++}-${f.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.loggerService.createLogger(m,{always:!0,donotRotate:!0,donotUseFormatters:!0}),d=await this.proxy.$register(f,!1,m,E,g.identifier.value);return new v(d,f,a,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(f,E){let g=!1;const c=()=>{if(g)throw new Error("Channel has been closed")};return{get name(){return f},append(m){c(),E.then(a=>a.append(m))},appendLine(m){c(),E.then(a=>a.appendLine(m))},clear(){c(),E.then(m=>m.clear())},replace(m){c(),E.then(a=>a.replace(m))},show(m,a){c(),E.then(d=>d.show(m,a))},hide(){c(),E.then(m=>m.hide())},dispose(){g=!0,E.then(m=>m.dispose())}}}};w=je([Ve(0,T.IExtHostRpcService),Ve(1,I.IExtHostInitDataService),Ve(2,b.IExtHostConsumerFileSystem),Ve(3,R.IExtHostFileSystemInfo),Ve(4,C.ILoggerService)],w),e.ExtHostOutputService=w,e.IExtHostOutputService=(0,D.createDecorator)("IExtHostOutputService")}),define(Ie[278],ke([0,1,4]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,u.createDecorator)("remoteAgentService")}),define(Ie[279],ke([0,1,30,10,9,13,22,2,4,205,45,227,278]),function(J,e,u,n,D,T,C,y,b,I,R,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,b.createDecorator)("pathService");let P=class Jn{constructor(w,p,f,E){this.localUserHome=w,this.remoteAgentService=p,this.environmentService=f,this.contextService=E,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||T.OS)(),this.resolveUserHome=(async()=>{const g=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=g?.userHome??w})()}hasValidBasename(w,p,f){return typeof p=="string"||typeof p=="undefined"?this.resolveOS.then(E=>this.doHasValidBasename(w,E,p)):this.doHasValidBasename(w,p,f)}doHasValidBasename(w,p,f){return w.scheme===n.Schemas.file||w.scheme===n.Schemas.vscodeRemote?(0,u.isValidBasename)(f??(0,C.basename)(w),p===1):!0}get defaultUriScheme(){return Jn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(w,p){if(w.remoteAuthority)return n.Schemas.vscodeRemote;const f=(0,I.getVirtualWorkspaceScheme)(p.getWorkspace());if(f)return f;const E=p.getWorkspace().folders[0];if(E)return E.uri.scheme;const g=p.getWorkspace().configuration;return g?g.scheme:n.Schemas.file}userHome(w){return w?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(w=>w===1?D.win32:D.posix)}async fileURI(w){let p="";if(await this.resolveOS===1&&(w=w.replace(/\\/g,"/")),w[0]==="/"&&w[1]==="/"){const E=w.indexOf("/",2);E===-1?(p=w.substring(2),w="/"):(p=w.substring(2,E),w=w.substring(E)||"/")}return y.URI.from({scheme:n.Schemas.file,authority:p,path:w,query:"",fragment:""})}};P=je([Ve(1,_.IRemoteAgentService),Ve(2,k.IWorkbenchEnvironmentService),Ve(3,R.IWorkspaceContextService)],P),e.AbstractPathService=P}),define(Ie[72],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class u{constructor(C,y){this.line=C,this.character=y}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,y){return new u(0,0)}with(C){return new u(0,0)}}e.Position=u;class n{constructor(C,y,b,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new u(C,y),this.end=new u(b,I)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new n(0,0,0,0)}with(C){return new n(0,0,0,0)}}e.Range=n;var D;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ie[31],ke([0,1,16,37,24,30,8,4,9,12,72,18]),function(J,e,u,n,D,T,C,y,b,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const _="\u27EA ",P=" characters skipped \u27EB",v=(_.length+P.length+5)*2;e.ISearchService=(0,y.createDecorator)("searchService");var w;(function(q){q[q.file=0]="file",q[q.text=1]="text"})(w=e.SearchProviderType||(e.SearchProviderType={}));var p;(function(q){q[q.File=1]="File",q[q.Text=2]="Text"})(p=e.QueryType||(e.QueryType={}));function f(q){return!!q.preview}e.resultIsMatch=f;function E(q){return!!q.resource}e.isFileMatch=E;function g(q){return!!q.message}e.isProgressMessage=g;var c;(function(q){q[q.Normal=0]="Normal",q[q.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class m{constructor(te){this.resource=te,this.results=[]}}e.FileMatch=m;class a{constructor(te,Y,le){this.ranges=Y;const pe=Array.isArray(Y)?Y:[Y];if(le&&le.matchLines===1&&d(pe)){te=(0,C.getNLines)(te,le.matchLines);let ee="",ge=0,Ee=0;const Pe=Math.floor(le.charsPerLine/5),Ne=[];for(const ve of pe){const ue=Math.max(ve.startColumn-Pe,0),de=ve.startColumn+le.charsPerLine;if(ue>Ee+Pe+v){const we=_+(ue-Ee)+P;ee+=we+te.slice(ue,de),ge+=ue-(Ee+we.length)}else ee+=te.slice(Ee,de);Ne.push(new o(0,ve.startColumn-ge,ve.endColumn-ge)),Ee=de}this.preview={text:ee,matches:Array.isArray(this.ranges)?Ne:Ne[0]}}else{const ee=Array.isArray(Y)?Y[0].startLineNumber:Y.startLineNumber;this.preview={text:te,matches:(0,u.mapArrayOrNot)(Y,ge=>new i(ge.startLineNumber-ee,ge.startColumn,ge.endLineNumber-ee,ge.endColumn))}}}}e.TextSearchMatch=a;function d(q){const te=q[0].startLineNumber;for(const Y of q)if(Y.startLineNumber!==te||Y.endLineNumber!==te)return!1;return!0}class i{constructor(te,Y,le,pe){this.startLineNumber=te,this.startColumn=Y,this.endLineNumber=le,this.endColumn=pe}}e.SearchRange=i;class o extends i{constructor(te,Y,le){super(te,Y,te,le)}}e.OneLineRange=o;var r;(function(q){q.Default="default",q.FileNames="fileNames",q.Type="type",q.Modified="modified",q.CountDescending="countDescending",q.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function t(q,te=!0){const Y=q&&q.files&&q.files.exclude,le=te&&q&&q.search&&q.search.exclude;if(!Y&&!le)return;if(!Y||!le)return Y||le;let pe=Object.create(null);return pe=D.mixin(pe,D.deepClone(Y)),pe=D.mixin(pe,D.deepClone(le),!0),pe}e.getExcludes=t;function s(q,te){return q.excludePattern&&n.match(q.excludePattern,te)?!1:q.includePattern||q.usingSearchPaths?q.includePattern&&n.match(q.includePattern,te)?!0:q.usingSearchPaths?!!q.folderQueries&&q.folderQueries.some(Y=>{const le=Y.folder.fsPath;if(T.isEqualOrParent(te,le)){const pe=b.relative(le,te);return!Y.includePattern||!!n.match(Y.includePattern,pe)}else return!1}):!1:!0}e.pathIncludedInQuery=s;var l;(function(q){q[q.unknownEncoding=1]="unknownEncoding",q[q.regexParseError=2]="regexParseError",q[q.globParseError=3]="globParseError",q[q.invalidLiteral=4]="invalidLiteral",q[q.rgProcessError=5]="rgProcessError",q[q.other=6]="other",q[q.canceled=7]="canceled"})(l=e.SearchErrorCode||(e.SearchErrorCode={}));class h extends Error{constructor(te,Y){super(te);this.code=Y}}e.SearchError=h;function S(q){const te=q.message;if((0,I.isCancellationError)(q))return new h(te,l.canceled);try{const Y=JSON.parse(te);return new h(Y.message,Y.code)}catch{return new h(te,l.other)}}e.deserializeSearchError=S;function L(q){const te={message:q.message,code:q.code};return new Error(JSON.stringify(te))}e.serializeSearchError=L;function F(q){return q.type==="error"?!0:q.type==="success"}e.isSerializedSearchComplete=F;function M(q){return q.type==="success"}e.isSerializedSearchSuccess=M;function A(q){return!!q.path}e.isSerializedFileMatch=A;function B(q,te){const Y=q.searchPath?q.searchPath:q.relativePath;return(0,C.fuzzyContains)(Y,te)}e.isFilePatternMatch=B;class ${constructor(te){this.path=te,this.results=[]}addMatch(te){this.results.push(te)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=$;function U(q,te){const Y={...q||{},...te||{}};return Object.keys(Y).filter(le=>{const pe=Y[le];return typeof pe=="boolean"&&pe})}e.resolvePatternsForProvider=U;class X{constructor(te,Y){this._parsedIncludeExpression=null,this._excludeExpression={...te.excludePattern||{},...Y.excludePattern||{}},this._parsedExcludeExpression=n.parse(this._excludeExpression);let le=te.includePattern;Y.includePattern&&(le?le={...le,...Y.includePattern}:le=Y.includePattern),le&&(this._parsedIncludeExpression=n.parse(le))}matchesExcludesSync(te,Y,le){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(te,Y,le))}includedInQuerySync(te,Y,le){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(te,Y,le)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(te,Y,le))}includedInQuery(te,Y,le){const pe=this._parsedExcludeExpression(te,Y,le),ee=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(te,Y,le):!0;return(0,k.isThenable)(pe)?pe.then(ge=>ge?!1:ee()):ee()}hasSiblingExcludeClauses(){return z(this._excludeExpression)}}e.QueryGlobTester=X;function z(q){for(const te in q)if(typeof q[te]!="boolean")return!0;return!1}function N(q){if(!q)return;let te;return Y=>(te||(te=(q()||Promise.resolve([])).then(le=>le?x(le):{})),te.then(le=>!!le[Y]))}e.hasSiblingPromiseFn=N;function V(q){if(!q)return;let te;return Y=>{if(!te){const le=q();te=le?x(le):{}}return!!te[Y]}}e.hasSiblingFn=V;function x(q){const te={};for(const Y of q)te[Y]=!0;return te}}),define(Ie[32],ke([0,1,16,18,21,3,25,10,94,22,8,11,2,176,4,14,197,45,46,26,17,15,7,31,5]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v,w,p,f,E,g,c,m,a,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(F,M,A){return new I.ExtUri(B=>l(B,A)).isEqual(F,M)}function r(F,M,A){return o(F.uri,M.uri,A)?0:(0,R.compare)(F.uri.toString(),M.uri.toString())}function t(F,M,A){return F.index!==M.index?F.index<M.index?-1:1:o(F.uri,M.uri,A)?(0,R.compare)(F.name,M.name):(0,R.compare)(F.uri.toString(),M.uri.toString())}function s(F,M,A,B){const $=F.slice(0).sort((X,z)=>A(X,z,B)),U=M.slice(0).sort((X,z)=>A(X,z,B));return(0,u.delta)($,U,(X,z)=>A(X,z,B))}function l(F,M){const A=M.getCapabilities(F.scheme);return!(A&&A&1024)}class h extends f.Workspace{constructor(M,A,B,$,U,X,z){super(M,B.map(N=>new f.WorkspaceFolder(N)),$,U,z);this._name=A,this._isUntitled=X,this._workspaceFolders=[],this._structure=C.TernarySearchTree.forUris(z),B.forEach(N=>{this._workspaceFolders.push(N),this._structure.set(N.uri,N)})}static toExtHostWorkspace(M,A,B,$){if(!M)return{workspace:null,added:[],removed:[]};const{id:U,name:X,folders:z,configuration:N,transient:V,isUntitled:x}=M,q=[],te=A;A?z.forEach((ee,ge)=>{const Ee=_.URI.revive(ee.uri),Pe=h._findFolder(B||A,Ee,$);Pe?(Pe.name=ee.name,Pe.index=ee.index,q.push(Pe)):q.push({uri:Ee,name:ee.name,index:ge})}):q.push(...z.map(({uri:ee,name:ge,index:Ee})=>({uri:_.URI.revive(ee),name:ge,index:Ee}))),q.sort((ee,ge)=>ee.index<ge.index?-1:1);const Y=new h(U,X,q,!!V,N?_.URI.revive(N):null,!!x,ee=>l(ee,$)),{added:le,removed:pe}=s(te?te.workspaceFolders:[],Y.workspaceFolders,r,$);return{workspace:Y,added:le,removed:pe}}static _findFolder(M,A,B){for(let $=0;$<M.folders.length;$++){const U=M.workspaceFolders[$];if(o(U.uri,A,B))return U}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(M,A){return A&&this._structure.get(M)&&(M=(0,I.dirname)(M)),this._structure.findSubstr(M)}resolveWorkspaceFolder(M){return this._structure.get(M)}}let S=class{constructor(M,A,B,$){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=$,this._extHostFileSystemInfo=B,this._requestIdProvider=new b.Counter,this._barrier=new n.Barrier,this._proxy=M.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=M.getProxy(i.MainContext.MainThreadMessageService);const U=A.workspace;this._confirmedWorkspace=U?new h(U.id,U.name,[],!!U.transient,U.configuration?_.URI.revive(U.configuration):null,!!U.isUntitled,X=>l(X,B)):void 0}$initializeWorkspace(M,A){this._trusted=A,this.$acceptWorkspaceData(M),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?_.URI.from({scheme:y.Schemas.untitled,path:(0,I.basename)((0,I.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(M,A,B,...$){const U=[];if(Array.isArray($)&&$.forEach(x=>{_.URI.isUri(x.uri)&&!U.some(q=>o(q.uri,x.uri,this._extHostFileSystemInfo))&&U.push({uri:x.uri,name:x.name||(0,I.basenameOrAuthority)(x.uri)})}),this._unconfirmedWorkspace||[A,B].some(x=>typeof x!="number"||x<0)||B===0&&U.length===0)return!1;const X=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(A+B>X.length)return!1;const z=X.slice(0);z.splice(A,B,...U.map(x=>({uri:x.uri,name:x.name||(0,I.basenameOrAuthority)(x.uri),index:void 0})));for(let x=0;x<z.length;x++){const q=z[x];if(z.some((te,Y)=>Y!==x&&o(q.uri,te.uri,this._extHostFileSystemInfo)))return!1}z.forEach((x,q)=>x.index=q);const{added:N,removed:V}=s(X,z,t,this._extHostFileSystemInfo);if(N.length===0&&V.length===0)return!1;if(this._proxy){const x=M.displayName||M.name;this._proxy.$updateWorkspaceFolders(x,A,B,U).then(void 0,q=>{this._unconfirmedWorkspace=void 0;const te={source:{identifier:M.identifier,label:M.displayName||M.name}};this._messageService.$showMessage(p.Severity.Error,(0,P.localize)(0,null,x,q.toString()),te,[])})}return this.trySetWorkspaceFolders(z),!0}getWorkspaceFolder(M,A){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(M,A)}async getWorkspaceFolder2(M,A){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(M,A)}async resolveWorkspaceFolder(M){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(M)}getPath(){if(!this._actualWorkspace)return;const{folders:M}=this._actualWorkspace;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,A){let B,$="";if(typeof M=="string"?(B=_.URI.file(M),$=M):typeof M!="undefined"&&(B=M,$=M.fsPath),!B)return $;const U=this.getWorkspaceFolder(B,!0);if(!U)return $;typeof A=="undefined"&&this._actualWorkspace&&(A=this._actualWorkspace.folders.length>1);let X=(0,I.relativePath)(U.uri,B);return A&&U.name&&(X=`${U.name}/${X}`),X}trySetWorkspaceFolders(M){this._actualWorkspace&&(this._unconfirmedWorkspace=h.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:M,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:A,added:B,removed:$}=h.toExtHostWorkspace(M,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=A||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:B,removed:$}))}findFiles(M,A,B,$,U=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${$.value}, entryPoint: findFiles`);let X;if(A===null?X=!1:A&&(typeof A=="string"?X=A:X=A.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:z,folder:N}=L(m.GlobPattern.from(M));return this._proxy.$startFileSearch((0,k.withUndefinedAsNull)(z),(0,k.withUndefinedAsNull)(N),(0,k.withUndefinedAsNull)(X),(0,k.withUndefinedAsNull)(B),U).then(V=>Array.isArray(V)?V.map(x=>_.URI.revive(x)):[])}async findTextInFiles(M,A,B,$,U=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${$.value}, entryPoint: findTextInFiles`);const X=this._requestIdProvider.getNext(),z=typeof A.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:A.previewOptions,{includePattern:N,folder:V}=L(m.GlobPattern.from(A.include)),x=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,q={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof A.useParentIgnoreFiles=="boolean"?!A.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!0,fileEncoding:A.encoding,maxResults:A.maxResults,previewOptions:z,afterContext:A.afterContext,beforeContext:A.beforeContext,includePattern:N,excludePattern:x},te=!1;if(this._activeSearchCallbacks[X]=Y=>{if(te)return;const le=_.URI.revive(Y.resource);Y.results.forEach(pe=>{(0,d.resultIsMatch)(pe)?B({uri:le,preview:{text:pe.preview.text,matches:(0,u.mapArrayOrNot)(pe.preview.matches,ee=>new a.Range(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))},ranges:(0,u.mapArrayOrNot)(pe.ranges,ee=>new a.Range(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))}):B({uri:le,text:pe.text,lineNumber:pe.lineNumber})})},U.isCancellationRequested)return{};try{const Y=await this._proxy.$startTextSearch(M,(0,k.withUndefinedAsNull)(V),q,X,U);return delete this._activeSearchCallbacks[X],Y||{}}catch(Y){throw delete this._activeSearchCallbacks[X],Y}}$handleTextSearchResult(M,A){this._activeSearchCallbacks[A]?.(M)}saveAll(M){return this._proxy.$saveAll(M)}resolveProxy(M){return this._proxy.$resolveProxy(M)}get trusted(){return this._trusted}requestWorkspaceTrust(M){return this._proxy.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};S=je([Ve(0,c.IExtHostRpcService),Ve(1,g.IExtHostInitDataService),Ve(2,E.IExtHostFileSystemInfo),Ve(3,w.ILogService)],S),e.ExtHostWorkspace=S,e.IExtHostWorkspace=(0,v.createDecorator)("IExtHostWorkspace");function L(F){let M,A;return F&&(typeof F=="string"?M=F:(M=F.pattern,A=_.URI.revive(F.baseUri))),{includePattern:M,folder:A}}}),define(Ie[33],ke([0,1,24,3,32,5,7,200,121,11,18,4,17,14,2]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function w(d,i){if(i){const o=i.split(".");let r=d;for(let t=0;r&&t<o.length;t++)r=r[o[t]];return r}}function p(d){return d instanceof v.URI}function f(d){return d&&d.uri instanceof v.URI&&d.languageId&&typeof d.languageId=="string"}function E(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function g(d){return d&&d.uri instanceof v.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function c(d){if(p(d))return{resource:d};if(f(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(E(d))return{overrideIdentifier:d.languageId};if(g(d))return{resource:d.uri};if(d===null)return{resource:null}}let m=class{constructor(i,o,r){this._proxy=i.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=r,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(i=>this._actual)}$initializeConfiguration(i){this._actual=new a(this._proxy,this._extHostWorkspace,i,this._logService),this._barrier.open()}$acceptConfigurationChanged(i,o){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(i,o))}};m=je([Ve(0,_.IExtHostRpcService),Ve(1,D.IExtHostWorkspace),Ve(2,P.ILogService)],m),e.ExtHostConfiguration=m;class a{constructor(i,o,r,t){this._onDidChangeConfiguration=new n.Emitter,this._proxy=i,this._logService=t,this._extHostWorkspace=o,this._configuration=y.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(i,o){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=y.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,r))}getConfiguration(i,o,r){const t=c(o)||{},s=this._toReadonlyValue(i?w(this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace),i):this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace));i&&this._validateConfigurationAccess(i,t,r?.identifier);function l(S){if(S==null)return null;if(typeof S=="boolean")return S?2:5;switch(S){case C.ConfigurationTarget.Global:return 2;case C.ConfigurationTarget.Workspace:return 5;case C.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(S){return typeof w(s,S)!="undefined"},get:(S,L)=>{this._validateConfigurationAccess(i?`${i}.${S}`:S,t,r?.identifier);let F=w(s,S);if(typeof F=="undefined")F=L;else{let M;const A=(B,$)=>{let U;const X=()=>{M=M||(0,u.deepClone)(s),U=U||w(M,$)};return(0,I.isObject)(B)?new Proxy(B,{get:(z,N)=>{if(typeof N=="string"&&N.toLowerCase()==="tojson")return X(),()=>U;if(M)return U=U||w(M,$),U[N];const V=z[N];return typeof N=="string"?A(V,`${$}.${N}`):V},set:(z,N,V)=>(X(),U&&(U[N]=V),!0),deleteProperty:(z,N)=>(X(),U&&delete U[N],!0),defineProperty:(z,N,V)=>(X(),U&&Object.defineProperty(U,N,V),!0)}):B};F=A(F,S)}return F},update:(S,L,F,M)=>{S=i?`${i}.${S}`:S;const A=l(F);return L!==void 0?this._proxy.$updateConfigurationOption(A,S,L,t,M):this._proxy.$removeConfigurationOption(A,S,t,M)},inspect:S=>{S=i?`${i}.${S}`:S;const L=(0,u.deepClone)(this._configuration.inspect(S,t,this._extHostWorkspace.workspace));if(L)return{key:S,defaultValue:L.policy?.value??L.default?.value,globalValue:L.user?.value??L.application?.value,workspaceValue:L.workspace?.value,workspaceFolderValue:L.workspaceFolder?.value,defaultLanguageValue:L.default?.override,globalLanguageValue:L.user?.override??L.application?.override,workspaceLanguageValue:L.workspace?.override,workspaceFolderLanguageValue:L.workspaceFolder?.override,languageIds:L.overrideIdentifiers}}};return typeof s=="object"&&(0,u.mixin)(h,s,!1),Object.freeze(h)}_toReadonlyValue(i){const o=r=>(0,I.isObject)(r)?new Proxy(r,{get:(t,s)=>o(t[s]),set:(t,s,l)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(s)}' of object`)},deleteProperty:(t,s)=>{throw new Error(`TypeError: Cannot delete read only property '${String(s)}' of object`)},defineProperty:(t,s)=>{throw new Error(`TypeError: Cannot define property '${String(s)}' for a readonly object`)},setPrototypeOf:t=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return o(i)}_validateConfigurationAccess(i,o,r){const t=b.OVERRIDE_PROPERTY_REGEX.test(i)?4:this._configurationScopes.get(i),s=r?`[${r.value}] `:"";if(t===4){typeof o?.resource=="undefined"&&this._logService.warn(`${s}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(t===3){o?.resource&&this._logService.warn(`${s}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(i,o){const r=new y.ConfigurationChangeEvent(i,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(t,s)=>r.affectsConfiguration(t,c(s))})}_toMap(i){return i.reduce((o,r)=>(o.set(r[0],r[1]),o),new Map)}}e.ExtHostConfigProvider=a,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(J,e,u,n,D){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?D.call(J,u):D?D.value=u:e.set(J,u),u},Me=this&&this.__classPrivateFieldGet||function(J,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!n:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(J):n?n.value:e.get(J)};define(Ie[73],ke([0,1,2,18,3,5,7,32,54,33,21,39,17,26,4,10,13,14,68,235,12]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v,w,p,f,E,g,c){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var a;(function($){function U(z){if(z!=null)return z}$.from=U;function X(z){if(z!=null)return z}$.to=X})(a=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var d;(function($){function U(z){if(z!=null)return z}$.from=U;function X(z){if(z!=null)return z}$.to=X})(d=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function($){function U(z){if(z!=null)return z}$.from=U;function X(z){if(z!=null)return z}$.to=X})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var o;(function($){function U(N){if(N){const V=N;return V&&!!V.process}else return!1}$.is=U;function X(N){if(N==null)return;const V={process:N.process,args:N.args};return N.options&&(V.options=i.from(N.options)),V}$.from=X;function z(N){if(N!=null)return new C.ProcessExecution(N.process,N.args,N.options)}$.to=z})(o=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var r;(function($){function U(z){if(z!=null)return z}$.from=U;function X(z){if(z!=null)return z}$.to=X})(r=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var t;(function($){function U(N){if(N){const V=N;return V&&(!!V.commandLine||!!V.command)}else return!1}$.is=U;function X(N){if(N==null)return;const V={};return N.commandLine!==void 0?V.commandLine=N.commandLine:(V.command=N.command,V.args=N.args),N.options&&(V.options=r.from(N.options)),V}$.from=X;function z(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new C.ShellExecution(N.commandLine,N.options):new C.ShellExecution(N.command,N.args?N.args:[],N.options)}$.to=z})(t=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var s;(function($){function U(N){if(N){const V=N;return V&&V.customExecution==="customExecution"}else return!1}$.is=U;function X(N){return{customExecution:"customExecution"}}$.from=X;function z(N,V){return V.get(N)}$.to=z})(s=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var l;(function($){function U(X,z){let N;return X.scope!==void 0&&typeof X.scope!="number"?N=X.scope.uri:X.scope!==void 0&&typeof X.scope=="number"&&(X.scope===C.TaskScope.Workspace&&z&&z.workspaceFile?N=z.workspaceFile:N=g.USER_TASKS_GROUP_KEY),{id:X._id,workspaceFolder:N}}$.from=U})(l=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function($){function U(X){if(X!=null)return{_id:X.id,isDefault:X.isDefault}}$.from=U})(h=e.TaskGroupDTO||(e.TaskGroupDTO={}));var S;(function($){function U(N,V){if(N==null)return[];const x=[];for(const q of N){const te=X(q,V);te&&x.push(te)}return x}$.fromMany=U;function X(N,V){if(N==null)return;let x;N.execution instanceof C.ProcessExecution?x=o.from(N.execution):N.execution instanceof C.ShellExecution?x=t.from(N.execution):N.execution&&N.execution instanceof C.CustomExecution&&(x=s.from(N.execution));const q=a.from(N.definition);let te;return N.scope?typeof N.scope=="number"?te=N.scope:te=N.scope.uri:te=C.TaskScope.Workspace,!q||!te?void 0:{_id:N._id,definition:q,name:N.name,source:{extensionId:V.identifier.value,label:N.source,scope:te},execution:x,isBackground:N.isBackground,group:h.from(N.group),presentationOptions:d.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}$.from=X;async function z(N,V,x){if(N==null)return;let q;o.is(N.execution)?q=o.to(N.execution):t.is(N.execution)?q=t.to(N.execution):s.is(N.execution)&&(q=s.to(N._id,x));const te=a.to(N.definition);let Y;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Y=N.source.scope:Y=await V.resolveWorkspaceFolder(u.URI.revive(N.source.scope)):Y=C.TaskScope.Workspace),!te||!Y)return;const le=new C.Task(te,Y,N.name,N.source.label,q,N.problemMatchers);return N.isBackground!==void 0&&(le.isBackground=N.isBackground),N.group!==void 0&&(le.group=C.TaskGroup.from(N.group._id),le.group&&N.group.isDefault&&(le.group=new C.TaskGroup(le.group.id,le.group.label),N.group.isDefault===!0&&(le.group.isDefault=N.group.isDefault))),N.presentationOptions&&(le.presentationOptions=d.to(N.presentationOptions)),N._id&&(le._id=N._id),N.detail&&(le.detail=N.detail),le}$.to=z})(S=e.TaskDTO||(e.TaskDTO={}));var L;(function($){function U(z){return z}$.from=U;function X(z){if(!!z)return Object.assign(Object.create(null),z)}$.to=X})(L=e.TaskFilterDTO||(e.TaskFilterDTO={}));class F{constructor(U,X,z){this._id=X,this._task=z,m.set(this,void 0),Ze(this,m,U,"f")}get task(){return this._task}terminate(){Me(this,m,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}m=new WeakMap;var M;(function($){function U(X){return{id:X._id,task:void 0}}$.from=U})(M=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let A=class{constructor(U,X,z,N,V,x,q,te){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=U.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=z,this._editorService=N,this._configurationService=V,this._terminalService=x,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=q,this._deprecationService=te,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(U,X,z){if(!z)return new C.Disposable(()=>{});const N=this.nextHandle();return this._handlers.set(N,{type:X,provider:z,extension:U}),this._proxy.$registerTaskProvider(N,X),new C.Disposable(()=>{this._handlers.delete(N),this._proxy.$unregisterTaskProvider(N)})}registerTaskSystem(U,X){this._proxy.$registerTaskSystem(U,X)}fetchTasks(U){return this._proxy.$fetchTasks(L.from(U)).then(async X=>{const z=[];for(const N of X){const V=await S.to(N,this._workspaceProvider,this._providedCustomExecutions2);V&&z.push(V)}return z})}get taskExecutions(){const U=[];return this._taskExecutions.forEach(X=>U.push(X)),U}terminateTask(U){if(!(U instanceof F))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(U._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(U,X,z){const N=this._providedCustomExecutions2.get(U.id);N&&(this._activeCustomExecutions2.set(U.id,N),this._terminalService.attachPtyToTerminal(X,await N.callback(z))),this._lastStartedTask=U.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(U)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(U){const X=await this.getTaskExecution(U);this._taskExecutionPromises.delete(U.id),this._taskExecutions.delete(U.id),this.customExecutionComplete(U),this._onDidTerminateTask.fire({execution:X})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(U){const X=await this.getTaskExecution(U.id);this._onDidTaskProcessStarted.fire({execution:X,processId:U.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(U){const X=await this.getTaskExecution(U.id);this._onDidTaskProcessEnded.fire({execution:X,exitCode:U.exitCode})}$provideTasks(U,X){const z=this._handlers.get(U);if(!z)return Promise.reject(new Error("no handler found"));const N=[],V=(0,n.asPromise)(()=>z.provider.provideTasks(R.CancellationToken.None)).then(x=>this.provideTasksInternal(X,N,z,x));return new Promise(x=>{V.then(q=>{Promise.all(N).then(()=>{x(q)})})})}async $resolveTask(U,X){const z=this._handlers.get(U);if(!z)return Promise.reject(new Error("no handler found"));if(X.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${X.definition.type}] cannot be resolved by provider of type [${z.type}].`);const N=await S.to(X,this._workspaceProvider,this._providedCustomExecutions2);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const V=await z.provider.resolveTask(N,R.CancellationToken.None);if(!V)return;this.checkDeprecation(V,z);const x=S.from(V,z.extension);if(!x)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return s.is(x.execution)&&await this.addCustomExecution(x,V,!0),await this.resolveTaskInternal(x)}nextHandle(){return this._handleCounter++}async addCustomExecution(U,X,z){const N=await this._proxy.$createTaskId(U);!z&&!this._providedCustomExecutions2.has(N)&&(this._notProvidedCustomExecutions.add(N),this._activeCustomExecutions2.set(N,X.execution)),this._providedCustomExecutions2.set(N,X.execution)}async getTaskExecution(U,X){if(typeof U=="string"){const V=this._taskExecutionPromises.get(U);if(!V)throw new Error("Unexpected: The specified task is missing an execution");return V}const z=this._taskExecutionPromises.get(U.id);if(z)return z;const N=new Promise((V,x)=>{function q(te,Y,le){le?V(new F(te,Y.id,le)):x("Unexpected: Task does not exist.")}X?q(this,U,X):S.to(U.task,this._workspaceProvider,this._providedCustomExecutions2).then(te=>q(this,U,te))});return this._taskExecutionPromises.set(U.id,N),N.then(V=>(this._taskExecutions.set(U.id,V),V),V=>Promise.reject(V))}checkDeprecation(U,X){U._deprecated&&this._deprecationService.report("Task.constructor",X.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(U){this._activeCustomExecutions2.get(U.id)&&this._activeCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.has(U.id)&&this._lastStartedTask!==U.id&&(this._providedCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.delete(U.id));const z=this._notProvidedCustomExecutions.values();let N=z.next();for(;!N.done;)!this._activeCustomExecutions2.has(N.value)&&this._lastStartedTask!==N.value&&(this._providedCustomExecutions2.delete(N.value),this._notProvidedCustomExecutions.delete(N.value)),N=z.next()}};A=je([Ve(0,_.IExtHostRpcService),Ve(1,P.IExtHostInitDataService),Ve(2,y.IExtHostWorkspace),Ve(3,b.IExtHostDocumentsAndEditors),Ve(4,I.IExtHostConfiguration),Ve(5,k.IExtHostTerminalService),Ve(6,f.ILogService),Ve(7,E.IExtHostApiDeprecationService)],A),e.ExtHostTaskBase=A;let B=class extends A{constructor(U,X,z,N,V,x,q,te){super(U,X,z,N,V,x,q,te);this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(U,X){if(!X.execution)throw new Error("Tasks to execute must include an execution");const z=S.from(X,U);if(z===void 0)throw new Error("Task is not valid");if(s.is(z.execution))await this.addCustomExecution(z,X,!1);else throw new c.NotSupportedError;const N=await this.getTaskExecution(await this._proxy.$getTaskExecution(z),X);return this._proxy.$executeTask(z).catch(V=>{throw new Error(V)}),N}provideTasksInternal(U,X,z,N){const V=[];if(N)for(const x of N){this.checkDeprecation(x,z),(!x.definition||!U[x.definition.type])&&this._logService.warn(`The task [${x.source}, ${x.name}] uses an undefined task type. The task will be ignored in the future.`);const q=S.from(x,z.extension);q&&s.is(q.execution)?(V.push(q),X.push(this.addCustomExecution(q,x,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:V,extension:z.extension}}async resolveTaskInternal(U){if(s.is(U.execution))return U;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(U,X){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,X,z){}};B=je([Ve(0,_.IExtHostRpcService),Ve(1,P.IExtHostInitDataService),Ve(2,y.IExtHostWorkspace),Ve(3,b.IExtHostDocumentsAndEditors),Ve(4,I.IExtHostConfiguration),Ve(5,k.IExtHostTerminalService),Ve(6,f.ILogService),Ve(7,E.IExtHostApiDeprecationService)],B),e.WorkerExtHostTask=B,e.IExtHostTask=(0,v.createDecorator)("IExtHostTask")}),define(Ie[280],ke([0,1,9,21,49,37,22,50,31]),function(J,e,u,n,D,T,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(_,P,v){this.config=_,this.provider=P,this.sessionToken=v,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=_.filePattern,this.includePattern=_.includePattern&&T.parse(_.includePattern),this.maxResults=_.maxResults||void 0,this.exists=_.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=_.excludePattern&&T.parse(_.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(_=>_.cancel()),this.activeCancellationTokens=new Set}search(_){const P=this.config.folderQueries||[];return new Promise((v,w)=>{const p=f=>{this.resultCount++,_(f)};if(this.isCanceled)return v({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(f=>{const E=f.toString(),g=u.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,g)||this.matchFile(p,{base:f,basename:g})}),Promise.all(P.map(f=>this.searchInFolder(f,p))).then(f=>{v({limitHit:this.isLimitHit,stats:f[0]||void 0})},f=>{w(new Error((0,D.toErrorMessage)(f)))})})}async searchInFolder(_,P){const v=new n.CancellationTokenSource,w=this.getSearchOptionsForFolder(_),p=this.initDirectoryTree(),f=new b.QueryGlobTester(this.config,_),E=!f.hasSiblingExcludeClauses();let g;try{this.activeCancellationTokens.add(v),g=y.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},w,v.token),m=g.elapsed(),a=y.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(d=>{const i=u.posix.relative(_.folder.path,d.path);if(E){const o=u.basename(d.path);this.matchFile(P,{base:_.folder,relativePath:i,basename:o});return}this.addDirectoryEntries(p,_.folder,i,P)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,f,P),{providerTime:m,postProcessTime:a.elapsed()})}finally{v.dispose(),this.activeCancellationTokens.delete(v)}}getSearchOptionsForFolder(_){const P=(0,b.resolvePatternsForProvider)(this.config.includePattern,_.includePattern),v=(0,b.resolvePatternsForProvider)(this.config.excludePattern,_.excludePattern);return{folder:_.folder,excludes:v,includes:P,useIgnoreFiles:!_.disregardIgnoreFiles,useGlobalIgnoreFiles:!_.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!_.disregardParentIgnoreFiles,followSymlinks:!_.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const _={rootEntries:[],pathToEntries:Object.create(null)};return _.pathToEntries["."]=_.rootEntries,_}addDirectoryEntries({pathToEntries:_},P,v,w){if(v===this.filePattern){const f=u.basename(this.filePattern);this.matchFile(w,{base:P,relativePath:this.filePattern,basename:f})}function p(f){const E=u.basename(f),g=u.dirname(f);let c=_[g];c||(c=_[g]=[],p(g)),c.push({base:P,relativePath:f,basename:E})}p(v)}matchDirectoryTree({rootEntries:_,pathToEntries:P},v,w){const p=this,f=this.filePattern;function E(g){const c=(0,b.hasSiblingFn)(()=>g.map(m=>m.basename));for(let m=0,a=g.length;m<a;m++){const d=g[m],{relativePath:i,basename:o}=d;if(v.matchesExcludesSync(i,o,f!==o?c:void 0))continue;const r=P[i];if(r)E(r);else{if(i===f)continue;p.matchFile(w,d)}if(p.isLimitHit)break}}E(_)}matchFile(_,P){(!this.includePattern||P.relativePath&&this.includePattern(P.relativePath,P.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||_(P))}}class R{constructor(){this.sessions=new Map}fileSearch(_,P,v,w){const p=this.getSessionTokenSource(_.cacheKey),f=new I(_,P,p&&p.token);let E=0;const g=c=>{E+=c.length,v(c.map(m=>this.rawMatchToSearchItem(m)))};return this.doSearch(f,R.BATCH_SIZE,g,w).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:c.stats}}))}clearCache(_){const P=this.getSessionTokenSource(_);P&&P.cancel()}getSessionTokenSource(_){if(!!_)return this.sessions.has(_)||this.sessions.set(_,new n.CancellationTokenSource),this.sessions.get(_)}rawMatchToSearchItem(_){return _.relativePath?{resource:C.joinPath(_.base,_.relativePath)}:{resource:_.base}}doSearch(_,P,v,w){w.onCancellationRequested(()=>{_.cancel()});const p=E=>{E&&(f.push(E),P>0&&f.length>=P&&(v(f),f=[]))};let f=[];return _.search(p).then(E=>(f.length&&v(f),E),E=>(f.length&&v(f),Promise.reject(E)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(Ie[281],ke([0,1,16,78,37,107,25,10,9,22,8,11,2,159,187,83,14,45,130,279,31]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v,w,p,f,E,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let m=class{constructor(h,S,L,F,M){this.configurationService=h,this.workspaceContextService=S,this.editorGroupsService=L,this.logService=F,this.pathService=M}text(h,S,L={}){h=this.getContentPattern(h,L);const F=this.configurationService.getValue(),M=S&&S.some(B=>!this.configurationService.getValue({resource:B}).search.useRipgrep);return{...this.commonQuery(S?.map(f.toWorkspaceFolder),L),type:2,contentPattern:h,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:F.search.usePCRE2||M||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}getContentPattern(h,S){const L=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const F={...h,wordSeparators:L.editor.wordSeparators};return this.isCaseSensitive(h,S)&&(F.isCaseSensitive=!0),this.isMultiline(h)&&(F.isMultiline=!0),F}file(h,S={}){return{...this.commonQuery(h,S),type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey}}handleIncludeExclude(h,S){return h?(h=Array.isArray(h)?h.map(r):r(h),S?this.parseSearchPaths(h):{pattern:d(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],S={}){const L=this.handleIncludeExclude(S.includePattern,S.expandPatterns),F=this.handleIncludeExclude(S.excludePattern,S.expandPatterns),M=h.length>1,A=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(U=>this.getFolderQueryForSearchPath(U,S,F)):h.map(U=>this.getFolderQueryForRoot(U,S,F,M))).filter(U=>!!U),B={_reason:S._reason,folderQueries:A,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:F.pattern,includePattern:L.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const U=u.coalesce(u.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(V=>V.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(U));const X=U.filter(N=>(0,c.pathIncludedInQuery)(B,N.fsPath)),z=this.commonQueryFromFileList(X);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(z)),{...B,...z}}const $=S.extraFileResources&&S.extraFileResources.filter(U=>(0,c.pathIncludedInQuery)(B,U.fsPath));return B.extraFileResources=$&&$.length?$:void 0,B}commonQueryFromFileList(h){const S=[],L=new C.ResourceMap,F={};let M=!1;return h.forEach(A=>{if(A.scheme===y.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(A)){const $=this.workspaceContextService.getWorkspaceFolder(A)?.uri??A.with({path:b.dirname(A.fsPath)});let U=L.get($);U||(M=!0,U={folder:$,includePattern:{}},S.push(U),L.set($,U));const X=b.relative($.fsPath,A.fsPath);(0,k.assertIsDefined)(U.includePattern)[X.replace(/\\/g,"/")]=!0}else A.fsPath&&(M=!0,F[A.fsPath]=!0)}),{folderQueries:S,includePattern:F,usingSearchPaths:!0,excludePattern:M?void 0:{"**/*":!0}}}isCaseSensitive(h,S){if(S.isSmartCase){if(h.isRegExp){if(R.containsUppercaseCharacter(h.pattern,!0))return!0}else if(R.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,P.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const S=z=>b.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),F=(Array.isArray(h)?h:i(h)).map(z=>{const N=this.pathService.resolvedUserHome;return N?(0,T.untildify)(z,N.scheme===y.Schemas.file?N.fsPath:N.path):z}),M=n.groupBy(F,z=>S(z)?"searchPaths":"exprSegments"),A=(M.exprSegments||[]).map(z=>R.rtrim(z,"/")).map(z=>R.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),o(z))),B={},$=this.expandSearchPathPatterns(M.searchPaths||[]);$&&$.length&&(B.searchPaths=$);const U=u.flatten(A),X=d(...U);return X&&(B.pattern=X),B}getExcludesForFolder(h,S){return S.disregardExcludeSettings?void 0:(0,c.getExcludes)(h,!S.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const S=u.flatten(h.map(F=>{let{pathPortion:M,globPortion:A}=a(F);A&&(A=t(A));const B=this.expandOneSearchPath(M);return u.flatten(B.map($=>this.resolveOneSearchPathPattern($,A)))})),L=new Map;return S.forEach(F=>{const M=F.searchPath.toString(),A=L.get(M);A?F.pattern&&(A.pattern=A.pattern||{},A.pattern[F.pattern]=!0):L.set(M,{searchPath:F.searchPath,pattern:F.pattern?d(F.pattern):void 0})}),Array.from(L.values())}expandOneSearchPath(h){if(b.isAbsolute(h)){const S=this.workspaceContextService.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==y.Schemas.file?[{searchPath:S[0].uri.with({path:h})}]:[{searchPath:_.URI.file(b.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const S=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=r(h),h.startsWith("../")||h===".."){const F=b.posix.resolve(S.path,h);return[{searchPath:S.with({path:F})}]}const L=t(h);return[{searchPath:S,pattern:L}]}else{if(h==="./"||h===".\\")return[];{const S=h.replace(/^\.[\/\\]/,""),F=this.workspaceContextService.getWorkspace().folders.map(M=>{const A=S.match(new RegExp(`^${R.escapeRegExpCharacters(M.name)}(?:/(.*)|$)`));return A?{match:A,folder:M}:null}).filter(k.isDefined);if(F.length)return F.map(M=>{const A=M.match[1];return{searchPath:M.folder.uri,pattern:A&&t(A)}});{const M=h.match(/\.[\/\\](.+)[\/\\]?/),A=M?M[1]:h,B=v.localize(0,null,A);throw new Error(B)}}}}resolveOneSearchPathPattern(h,S){const L=h.pattern&&S?`${h.pattern}/${S}`:h.pattern||S,F=[{searchPath:h.searchPath,pattern:L}];return L&&!L.endsWith("**")&&F.push({searchPath:h.searchPath,pattern:L+"/**"}),F}getFolderQueryForSearchPath(h,S,L){const F=this.getFolderQueryForRoot((0,f.toWorkspaceFolder)(h.searchPath),S,L,!1);return F?{...F,includePattern:h.pattern}:null}getFolderQueryForRoot(h,S,L,F){let M;const A=_.URI.isUri(h)?h:h.uri;if(L.searchPaths){const z=L.searchPaths.filter(N=>(0,I.isEqual)(N.searchPath,A))[0];if(z&&!z.pattern)return null;z&&(M=z.pattern)}const B=this.configurationService.getValue({resource:A}),U={...this.getExcludesForFolder(B,S)||{},...M||{}},X=_.URI.isUri(h)?(0,I.basename)(h):h.name;return{folder:A,folderName:F?X:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof S.disregardParentIgnoreFiles=="boolean"?S.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!B.search.followSymlinks}}};m=je([Ve(0,w.IConfigurationService),Ve(1,f.IWorkspaceContextService),Ve(2,E.IEditorGroupsService),Ve(3,p.ILogService),Ve(4,g.IPathService)],m),e.QueryBuilder=m;function a(l){const h=l.match(/[\*\{\}\(\)\[\]\?]/);if(h){const S=h.index,L=l.substr(0,S).match(/[/|\\][^/\\]*$/);if(L){let F=l.substr(0,L.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:l.substr((L.index||0)+1)}}}return{pathPortion:l}}function d(...l){return l.length?l.reduce((h,S)=>(h[S]=!0,h),Object.create(null)):void 0}function i(l){return D.splitGlobAware(l,",").map(h=>h.trim()).filter(h=>!!h.length)}function o(l){return[`**/${l}/**`,`**/${l}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function r(l){return l.replace(/\\/g,"/")}function t(l){return r(l).replace(/^\.\//,"").replace(/\/+$/g,"")}function s(l,h){l=u.distinct(l,F=>F.toString());const S=[],L=h.getWorkspace();return l&&l.forEach(F=>{let M;if(h.getWorkbenchState()===2)M=(0,I.relativePath)(L.folders[0].uri,F),M&&M!=="."&&(M="./"+M);else{const A=h.getWorkspaceFolder(F);if(A){const B=A.name;if(L.folders.filter(U=>U.name===B).length===1){const U=(0,I.relativePath)(A.uri,F);U===""?M=`./${A.name}`:M=`./${A.name}/${U}`}else M=F.fsPath}}M&&S.push(M)}),S}e.resolveResourcesForSearchIncludes=s}),define(Ie[282],ke([0,1,22,2,21,12,4,281,31,45]),function(J,e,u,n,D,T,C,y,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function k(w,p){const f=p.activationEvents;if(!f)return Promise.resolve(void 0);const E=[],g=[];for(const o of f)if(/^workspaceContains:/.test(o)){const r=o.substr("workspaceContains:".length);r.indexOf("*")>=0||r.indexOf("?")>=0||w.forceUsingSearch?g.push(r):E.push(r)}if(E.length===0&&g.length===0)return Promise.resolve(void 0);let c;const m=new Promise((o,r)=>{c=o}),a=o=>c({activationEvent:o}),d=Promise.all(E.map(o=>_(w,o,a))).then(()=>{}),i=P(w,p.identifier,g,a);return Promise.all([d,i]).then(()=>{c(void 0)}),m}e.checkActivateWorkspaceContainsExtension=k;async function _(w,p,f){for(const E of w.folders)if(await w.exists(u.joinPath(n.URI.revive(E),p))){f(`workspaceContains:${p}`);return}}async function P(w,p,f,E){if(f.length===0)return Promise.resolve(void 0);const g=new D.CancellationTokenSource,c=w.checkExists(w.folders,f,g.token),m=setTimeout(async()=>{g.cancel(),w.logService.info(`Not activating extension '${p.value}': Timed out while searching for 'workspaceContains' pattern ${f.join(",")}`)},R);let a=!1;try{a=await c}catch(d){T.isCancellationError(d)||T.onUnexpectedError(d)}g.dispose(),clearTimeout(m),a&&E(`workspaceContains:${f.join(",")}`)}function v(w,p,f,E){const g=w.get(C.IInstantiationService),c=w.get(b.ISearchService),a=g.createInstance(y.QueryBuilder).file(p.map(d=>(0,I.toWorkspaceFolder)(n.URI.revive(d))),{_reason:"checkExists",includePattern:f,exists:!0});return c.fileSearch(a,E).then(d=>!!d.limitHit,d=>T.isCancellationError(d)?!1:Promise.reject(d))}e.checkGlobFileExists=v});var Ze=this&&this.__classPrivateFieldSet||function(J,e,u,n,D){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?D.call(J,u):D?D.value=u:e.set(J,u),u},Me=this&&this.__classPrivateFieldGet||function(J,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!n:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(J):n?n.value:e.get(J)};define(Ie[40],ke([0,1,171,9,74,22,18,6,25,2,14,5,33,230,91,32,27,228,12,28,23,206,7,122,4,26,70,17,85,52,39,3,282,90,208,10]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v,w,p,f,E,g,c,m,a,d,i,o,r,t,s,l,h,S,L,F,M,A){"use strict";var B,$,U;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,i.createDecorator)("IHostUtils");let X=class Pn extends y.Disposable{constructor(Y,le,pe,ee,ge,Ee,Pe,Ne,ve,ue){super();this._onDidChangeRemoteConnectionData=this._register(new S.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=le,this._extHostContext=pe,this._initData=Pe,this._extHostWorkspace=ee,this._extHostConfiguration=ge,this._logService=Ee,this._extHostTunnelService=ve,this._extHostTerminalService=ue,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new C.Barrier,this._readyToStartExtensionHost=new C.Barrier,this._readyToRunExtensions=new C.Barrier,this._eagerExtensionsActivated=new C.Barrier,this._globalRegistry=new f.ExtensionDescriptionRegistry(this._initData.allExtensions);const de=(0,p.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new f.ExtensionDescriptionRegistry(V(this._globalRegistry,de)),this._storage=new v.ExtHostStorage(this._extHostContext),this._secretState=new F.ExtHostSecretState(this._extHostContext),this._storagePath=Ne,this._instaService=Y.createChild(new s.ServiceCollection([v.IExtHostStorage,this._storage],[F.IExtHostSecretState,this._secretState]));let we=[],re=[];this._initData.remote.isRemote&&(we=this._initData.allExtensions.filter(Z=>!Z.main&&!Z.browser).map(Z=>Z.identifier),re=this._initData.allExtensions.filter(Z=>!de.has(g.ExtensionIdentifier.toKey(Z.identifier.value))).filter(Z=>(Z.main||Z.browser)&&Z.api==="none").map(Z=>Z.identifier));const me=(0,p.extensionIdentifiersArrayToSet)(re);this._activator=this._register(new P.ExtensionsActivator(this._myRegistry,we,re,{onExtensionActivationError:(Z,se,O)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Z,E.transformErrorForSerialization(se),O)},actualActivateExtension:async(Z,se)=>{if(me.has(g.ExtensionIdentifier.toKey(Z)))return await this._mainThreadExtensionsProxy.$activateExtension(Z,se),new P.HostExtension;const O=this._myRegistry.getExtensionDescription(Z);return this._activateExtension(O,se)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(Y){E.onUnexpectedError(Y)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let Y=[];try{Y=this._myRegistry.getAllExtensionDescriptions().map(ge=>ge.identifier).filter(ge=>this.isActivated(ge)).map(ge=>this._deactivate(ge))}catch{}await Promise.all(Y)}terminate(Y,le=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${Y}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),E.setUnexpectedErrorHandler(ee=>{this._logService.error(ee)}),this._extHostContext.dispose();const pe=this._deactivateAll();Promise.race([(0,C.timeout)(5e3),pe]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${le}`):this._logService.info(`Extension host exiting with code ${le}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(le)})}isActivated(Y){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(Y):!1}async getExtension(Y){const le=await this._mainThreadExtensionsProxy.$getExtension(Y);return le&&{...le,identifier:new g.ExtensionIdentifier(le.identifier.value),extensionLocation:I.URI.revive(le.extensionLocation)}}_activateByEvent(Y,le){return this._activator.activateByEvent(Y,le)}_activateById(Y,le){return this._activator.activateById(Y,le)}activateByIdWithErrors(Y,le){return this._activateById(Y,le).then(()=>{const pe=this._activator.getActivatedExtension(Y);if(pe.activationFailed)return Promise.reject(pe.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(Y=>this._myRegistry)}getExtensionExports(Y){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(Y).exports:null}async _realPathExtensionUri(Y){if(Y.scheme!==A.Schemas.file)return Y;const le=await this._hostUtils.realpath(Y.fsPath);return I.URI.file(le)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(Y=>new q(Y))),this._extensionPathIndex}async _createExtensionPathIndex(Y){const le=b.TernarySearchTree.forUris(pe=>T.extUriBiasedIgnorePathCase.ignorePathCasing(pe));return await Promise.all(Y.map(async pe=>{if(this._getEntryPoint(pe)){const ee=await this._realPathExtensionUri(pe.extensionLocation);le.set(ee,pe)}})),le}_deactivate(Y){let le=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(Y))return le;const pe=this._activator.getActivatedExtension(Y);if(!pe)return le;try{typeof pe.module.deactivate=="function"&&(le=Promise.resolve(pe.module.deactivate()).then(void 0,ee=>(this._logService.error(ee),Promise.resolve(void 0))))}catch(ee){this._logService.error(`An error occurred when deactivating the extension '${Y.value}':`),this._logService.error(ee)}try{(0,y.dispose)(pe.subscriptions)}catch(ee){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${Y.value}':`),this._logService.error(ee)}return le}async _activateExtension(Y,le){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(Y.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(Y.identifier),this._doActivateExtension(Y,le).then(pe=>{const ee=pe.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(Y.identifier,ee.codeLoadingTime,ee.activateCallTime,ee.activateResolvedTime,le),this._logExtensionActivationTimes(Y,le,"success",ee),pe},pe=>{throw this._logExtensionActivationTimes(Y,le,"failure"),pe})}_logExtensionActivationTimes(Y,le,pe,ee){const ge=z(Y,le);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ge,...ee||{},outcome:pe})}_doActivateExtension(Y,le){const pe=z(Y,le);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",pe);const ee=this._getEntryPoint(Y);if(!ee)return Promise.resolve(new P.EmptyExtension(P.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${le.startup}, activationEvent: '${le.activationEvent}'${Y.identifier.value!==le.extensionId.value?`, root cause: ${le.extensionId.value}`:""}`),this._logService.flush();const ge=new P.ExtensionActivationTimesBuilder(le.startup);return Promise.all([this._loadCommonJSModule(Y.identifier,(0,T.joinPath)(Y.extensionLocation,ee),ge),this._loadExtensionContext(Y)]).then(Ee=>(D.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),Pn._callActivate(this._logService,Y.identifier,Ee[0],Ee[1],ge))).then(Ee=>(D.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),Ee))}_loadExtensionContext(Y){const le=new m.ExtensionGlobalMemento(Y,this._storage),pe=new m.ExtensionMemento(Y.identifier.value,!1,this._storage),ee=new M.ExtensionSecrets(Y,this._secretState),ge=Y.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?a.ExtensionMode.Test:a.ExtensionMode.Development:a.ExtensionMode.Production,Ee=this._initData.remote.isRemote?a.ExtensionKind.Workspace:a.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([le.whenReady,pe.whenReady,this._storagePath.whenReady]).then(()=>{const Pe=this;let Ne,ve;const ue=(0,p.isProposedApiEnabled)(Y,"ipc")?this._initData.messagePorts?.get(g.ExtensionIdentifier.toKey(Y.identifier)):void 0;return Object.freeze({globalState:le,workspaceState:pe,secrets:ee,subscriptions:[],get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(de){return n.join(Y.extensionLocation.fsPath,de)},get storagePath(){return Pe._storagePath.workspaceValue(Y)?.fsPath},get globalStoragePath(){return Pe._storagePath.globalValue(Y).fsPath},get logPath(){return n.join(Pe._initData.logsLocation.fsPath,Y.identifier.value)},get logUri(){return I.URI.joinPath(Pe._initData.logsLocation,Y.identifier.value)},get storageUri(){return Pe._storagePath.workspaceValue(Y)},get globalStorageUri(){return Pe._storagePath.globalValue(Y)},get extensionMode(){return ge},get extension(){return Ne===void 0&&(Ne=new N(Pe,Y.identifier,Y,Ee,!1)),Ne},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(Y,"extensionRuntime"),Pe.extensionRuntime},get environmentVariableCollection(){return Pe._extHostTerminalService.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!ve){if(!ue)return;const de=S.Event.buffer(S.Event.fromDOMEventEmitter(ue,"message",we=>we.data));ue.start(),ve={onDidReceiveMessage:de,postMessage:ue.postMessage.bind(ue)}}return ve}})})}static _callActivate(Y,le,pe,ee,ge){return pe=pe||{activate:void 0,deactivate:void 0},this._callActivateOptional(Y,le,pe,ee,ge).then(Ee=>new P.ActivatedExtension(!1,null,ge.build(),pe,Ee,ee.subscriptions))}static _callActivateOptional(Y,le,pe,ee,ge){if(typeof pe.activate=="function")try{ge.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${le.value}`);const Ee=typeof global=="object"?global:self,Pe=pe.activate.apply(Ee,[ee]);return ge.activateCallStop(),ge.activateResolveStart(),Promise.resolve(Pe).then(Ne=>(ge.activateResolveStop(),Ne))}catch(Ee){return Promise.reject(Ee)}else return Promise.resolve(pe)}_activateOneStartupFinished(Y,le){this._activateById(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:le}).then(void 0,pe=>{this._logService.error(pe)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const Y of this._myRegistry.getAllExtensionDescriptions())if(Y.activationEvents)for(const le of Y.activationEvents)le==="onStartupFinished"&&this._activateOneStartupFinished(Y,le)}_handleEagerExtensions(){const Y=this._activateByEvent("*",!0).then(void 0,ge=>{this._logService.error(ge)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ge=>this._handleWorkspaceContainsEagerExtensions(ge.added)));const le=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],pe=this._handleWorkspaceContainsEagerExtensions(le),ee=Promise.all([Y,pe]).then(()=>{});return Promise.race([ee,(0,C.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ee}_handleWorkspaceContainsEagerExtensions(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(le=>this._handleWorkspaceContainsEagerExtension(Y,le))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(Y,le){if(this.isActivated(le.identifier))return;const pe=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ee={logService:this._logService,folders:Y.map(Ee=>Ee.uri),forceUsingSearch:pe,exists:Ee=>this._hostUtils.exists(Ee.fsPath),checkExists:(Ee,Pe,Ne)=>this._mainThreadWorkspaceProxy.$checkExists(Ee,Pe,Ne)},ge=await(0,L.checkActivateWorkspaceContainsExtension)(ee,le);if(!!ge)return this._activateById(le.identifier,{startup:!0,extensionId:le.identifier,activationEvent:ge.activationEvent}).then(void 0,Ee=>this._logService.error(Ee))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(Y){throw console.error(Y),Y}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:le}=this._initData.environment;if(!Y||!le)throw new Error(u.localize(0,null));const pe=await this._loadCommonJSModule(null,le,new P.ExtensionActivationTimesBuilder(!1));if(!pe||typeof pe.run!="function")throw new Error(u.localize(1,null,le.toString()));return new Promise((ee,ge)=>{const Ee=(ve,ue)=>{ve?ge(ve):ee(typeof ue=="number"&&ue>0?1:0)},Pe=(0,T.originalFSPath)(le),Ne=pe.run(Pe,Ee);Ne&&Ne.then&&Ne.then(()=>{ee(0)}).catch(ve=>{ge(ve instanceof Error&&ve.stack?ve.stack:String(ve))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,le){return this._resolvers[Y]=le,(0,y.toDisposable)(()=>{delete this._resolvers[Y]})}async _activateAndGetResolver(Y){const le=Y.indexOf("+");if(le===-1)throw new Error("Not an authority that can be resolved!");const pe=Y.substr(0,le);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${pe}`,!1),{authorityPrefix:pe,resolver:this._resolvers[pe]}}async $resolveAuthority(Y,le){this._logService.info(`$resolveAuthority invoked for authority (${x(Y)})`);const{authorityPrefix:pe,resolver:ee}=await this._activateAndGetResolver(Y);if(!ee)return{type:"error",error:{code:d.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${pe}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ee)),D.mark(`code/extHost/willResolveAuthority/${pe}`);const ge=await ee.resolve(Y,{resolveAttempt:le});D.mark(`code/extHost/didResolveAuthorityOK/${pe}`);const Ee={authority:Y,host:ge.host,port:ge.port,connectionToken:ge.connectionToken},Pe={extensionHostEnv:ge.extensionHostEnv,isTrusted:ge.isTrusted,authenticationSession:ge.authenticationSessionForInitializingExtensions?{id:ge.authenticationSessionForInitializingExtensions.id,providerId:ge.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Ee,options:Pe,tunnelInformation:{environmentTunnels:ge.environmentTunnels,features:ge.tunnelFeatures}}}}catch(ge){if(D.mark(`code/extHost/didResolveAuthorityError/${pe}`),ge instanceof a.RemoteAuthorityResolverError)return{type:"error",error:{code:ge._code,message:ge._message,detail:ge._detail}};throw ge}}async $getCanonicalURI(Y,le){this._logService.info(`$getCanonicalURI invoked for authority (${x(Y)})`);const{resolver:pe}=await this._activateAndGetResolver(Y);if(!pe)return null;const ee=I.URI.revive(le);if(typeof pe.getCanonicalURI=="undefined")return ee;const ge=await(0,C.asPromise)(()=>pe.getCanonicalURI(ee));return ge||ee}static _applyExtensionsDelta(Y,le,pe){const ee=new f.ExtensionDescriptionRegistry(Y.getAllExtensionDescriptions());ee.deltaExtensions(pe.toAdd,pe.toRemove);const ge=(0,p.extensionIdentifiersArrayToSet)(le.getAllExtensionDescriptions().map(Pe=>Pe.identifier));for(const Pe of pe.myToRemove)ge.delete(g.ExtensionIdentifier.toKey(Pe));for(const Pe of pe.myToAdd)ge.add(g.ExtensionIdentifier.toKey(Pe));const Ee=V(ee,ge);return{globalRegistry:ee,myExtensions:Ee}}$startExtensionHost(Y){Y.toAdd.forEach(ee=>ee.extensionLocation=I.URI.revive(ee.extensionLocation));const{globalRegistry:le,myExtensions:pe}=Pn._applyExtensionsDelta(this._globalRegistry,this._myRegistry,Y);return this._globalRegistry.set(le.getAllExtensionDescriptions()),this._myRegistry.set(pe),this._startExtensionHost()}$activateByEvent(Y,le){return le===1?this._activateByEvent(Y,!1):this._readyToRunExtensions.wait().then(pe=>this._activateByEvent(Y,!1))}async $activate(Y,le){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(Y)?(await this._activateById(Y,le),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(Ee=>Ee.extensionLocation=I.URI.revive(Ee.extensionLocation));const{globalRegistry:le,myExtensions:pe}=Pn._applyExtensionsDelta(this._globalRegistry,this._myRegistry,Y),ee=await this._createExtensionPathIndex(pe);return(await this.getExtensionPathIndex()).setSearchTree(ee),this._globalRegistry.set(le.getAllExtensionDescriptions()),this._myRegistry.set(pe),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const le=c.VSBuffer.alloc(Y),pe=Math.random()%256;for(let ee=0;ee<Y;ee++)le.writeUInt8(pe,ee);return le}async $updateRemoteConnectionData(Y){this._remoteConnectionData=Y,this._onDidChangeRemoteConnectionData.fire()}};X=je([Ve(0,i.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,t.IExtHostRpcService),Ve(3,w.IExtHostWorkspace),Ve(4,_.IExtHostConfiguration),Ve(5,R.ILogService),Ve(6,o.IExtHostInitDataService),Ve(7,r.IExtensionStoragePaths),Ve(8,l.IExtHostTunnelService),Ve(9,h.IExtHostTerminalService)],X),e.AbstractExtHostExtensionService=X;function z(te,Y){return{id:te.identifier.value,name:te.name,extensionVersion:te.version,publisherDisplayName:te.publisher,activationEvents:te.activationEvents?te.activationEvents.join(","):null,isBuiltin:te.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}e.IExtHostExtensionService=(0,i.createDecorator)("IExtHostExtensionService");class N{constructor(Y,le,pe,ee,ge){B.set(this,void 0),$.set(this,void 0),U.set(this,void 0),Ze(this,B,Y,"f"),Ze(this,$,le,"f"),Ze(this,U,pe.identifier,"f"),this.id=pe.identifier.value,this.extensionUri=pe.extensionLocation,this.extensionPath=n.normalize((0,T.originalFSPath)(pe.extensionLocation)),this.packageJSON=pe,this.extensionKind=ee,this.isFromDifferentExtensionHost=ge}get isActive(){return Me(this,B,"f").isActivated(Me(this,U,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Me(this,B,"f").getExtensionExports(Me(this,U,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Me(this,B,"f").activateByIdWithErrors(Me(this,U,"f"),{startup:!1,extensionId:Me(this,$,"f"),activationEvent:"api"}),this.exports}}e.Extension=N,B=new WeakMap,$=new WeakMap,U=new WeakMap;function V(te,Y){return te.getAllExtensionDescriptions().filter(le=>Y.has(g.ExtensionIdentifier.toKey(le.identifier)))}function x(te){const Y=te.indexOf("+");return Y===-1?te:te.substring(0,Y)}class q{constructor(Y){this._searchTree=Y}setSearchTree(Y){this._searchTree=Y}findSubstr(Y){return this._searchTree.findSubstr(Y)}forEach(Y){return this._searchTree.forEach(Y)}}e.ExtensionPaths=q}),define(Ie[283],ke([0,1,74,2,5,33,27,28,17,26,4,40,36,14,8]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let w=class{constructor(m,a,d,i,o,r,t){this._apiFactory=m,this._extensionRegistry=a,this._instaService=d,this._extHostConfiguration=i,this._extHostExtensionService=o,this._initData=r,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),u.mark("code/extHost/willWaitForConfig");const m=await this._extHostConfiguration.getConfigProvider();u.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new f(this._apiFactory,a,this._extensionRegistry,m,this._logService)),this.register(this._instaService.createInstance(E,a)),this.register(this._instaService.createInstance(p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(g,a,this._initData.environment.appUriScheme))}register(m){if("nodeModuleName"in m)if(Array.isArray(m.nodeModuleName))for(const a of m.nodeModuleName)this._factories.set(a,m);else this._factories.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this._alternatives.push(a=>m.alternativeModuleName(a))}};w=je([Ve(2,R.IInstantiationService),Ve(3,T.IExtHostConfiguration),Ve(4,k.IExtHostExtensionService),Ve(5,I.IExtHostInitDataService),Ve(6,P.ILogService)],w),e.RequireInterceptor=w;let p=class Kn{constructor(m){if(m.environment.appRoot&&Kn.aliased.size){const a=(0,v.escapeRegExpCharacters)(this.forceForwardSlashes(m.environment.appRoot.fsPath)),d="[a-z0-9_.-]",i=`@${d}+\\/${d}+|${d}+`,o="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${a}/${o}\\/)(${i})(.*)$`,"i")}}alternativeModuleName(m){if(!this.re)return;const a=this.re.exec(this.forceForwardSlashes(m));if(!a)return;const[,d,i,o]=a,r=Kn.aliased.get(i);if(r!==void 0)return console.warn(`${i} as been renamed to ${r}, please update your imports`),d+r+o}forceForwardSlashes(m){return m.replace(/\\/g,"/")}};p.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),p=je([Ve(0,I.IExtHostInitDataService)],p);class f{constructor(m,a,d,i,o){this._apiFactory=m,this._extensionPaths=a,this._extensionRegistry=d,this._configProvider=i,this._logService=o,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(m,a){const d=this._extensionPaths.findSubstr(a);if(d){let i=this._extApiImpl.get(y.ExtensionIdentifier.toKey(d.identifier));return i||(i=this._apiFactory(d,this._extensionRegistry,this._configProvider),this._extApiImpl.set(y.ExtensionIdentifier.toKey(d.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((o,r)=>i+=`	${r} -> ${o.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(C.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let E=class{constructor(m,a,d){this._extensionPaths=m,this.nodeModuleName="keytar",this._mainThreadTelemetry=a.getProxy(D.MainContext.MainThreadTelemetry);const{environment:i}=d,o=a.getProxy(D.MainContext.MainThreadKeytar);if(i.appRoot){let r=i.appRoot.fsPath;_.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,t)=>o.$getPassword(r,t),setPassword:(r,t,s)=>o.$setPassword(r,t,s),deletePassword:(r,t)=>o.$deletePassword(r,t),findPassword:r=>o.$findPassword(r),findCredentials(r){return o.$findCredentials(r)}}}load(m,a){const d=this._extensionPaths.findSubstr(a);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:d?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(m){const a=m.length;if(a<=7||!this.alternativeNames)return;const d=a-7;if((m.charAt(d)==="/"||m.charAt(d)==="\\")&&m.endsWith("keytar")&&(m=m.replace(/\\/g,"/"),this.alternativeNames.has(m)))return"keytar"}};E=je([Ve(1,b.IExtHostRpcService),Ve(2,I.IExtHostInitDataService)],E);let g=class{constructor(m,a,d){this._extensionPaths=m,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=d.getProxy(D.MainContext.MainThreadTelemetry);const i=d.getProxy(D.MainContext.MainThreadWindow);this._impl=(o,r)=>{const t=n.URI.parse(o);return r?this.callOriginal(o,r):t.scheme==="http"||t.scheme==="https"?i.$openUri(t,o,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?i.$openUri(t,o,{}):this.callOriginal(o,r)}}load(m,a,d){const i=this._extensionPaths.findSubstr(a);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=d(m),this._impl}callOriginal(m,a){return this.sendNoForwardTelemetry(),this._original(m,a)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};g=je([Ve(2,b.IExtHostRpcService)],g)}),define(Ie[47],ke([0,1,79,6,9,36,4,54,55,40,7,32,221,33]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,C.createDecorator)("IExtHostVariableResolverProvider");class v extends _.AbstractVariableResolverService{constructor(f,E,g,c,m,a,d){function i(){if(g){const o=g.activeEditor();if(o)return o.document.uri;const r=c.tabGroups.all.find(t=>t.isActive)?.activeTab;if(r!==void 0){if(r.input instanceof R.TextDiffTabInput||r.input instanceof R.NotebookDiffEditorTabInput)return r.input.modified;if(r.input instanceof R.TextTabInput||r.input instanceof R.NotebookEditorTabInput||r.input instanceof R.CustomEditorTabInput)return r.input.uri}}}super({getFolderUri:o=>{const r=a.folders.filter(t=>t.name===o);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>a.folders.length,getConfigurationValue:(o,r)=>m.getConfiguration(void 0,o).get(r),getAppRoot:()=>T.cwd(),getExecPath:()=>T.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=i();if(o)return D.normalize(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(E){const o=i();if(o){const r=E.getWorkspaceFolder(o);if(r)return D.normalize(r.uri.fsPath)}}},getSelectedText:()=>{if(g){const o=g.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(g){const o=g.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>f.getExtension(o)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(T.env))}}let w=class extends n.Disposable{constructor(f,E,g,c,m){super();this.extensionService=f,this.workspaceService=E,this.editorService=g,this.configurationService=c,this.editorTabs=m,this._resolver=new u.Lazy(async()=>{const a=await this.configurationService.getConfigProvider(),i={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async o=>{i.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new v(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,a,i,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};w=je([Ve(0,I.IExtHostExtensionService),Ve(1,k.IExtHostWorkspace),Ve(2,y.IExtHostDocumentsAndEditors),Ve(3,P.IExtHostConfiguration),Ve(4,b.IExtHostEditorTabs)],w),e.ExtHostVariableResolverProviderService=w}),define(Ie[75],ke([0,1,18,3,11,2,4,5,55,40,17,7,32,127,215,33,47]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,C.createDecorator)("IExtHostDebugService");let f=class{constructor(i,o,r,t,s,l){this._workspaceService=o,this._extensionService=r,this._configurationService=t,this._editorTabs=s,this._variableResolver=l,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new n.Emitter,this._onDidTerminateDebugSession=new n.Emitter,this._onDidChangeActiveDebugSession=new n.Emitter,this._onDidReceiveDebugSessionCustomEvent=new n.Emitter,this._debugServiceProxy=i.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new n.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new g(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(h=>{h.onDidChange(S=>{this.registerAllDebugTypes(h)}),this.registerAllDebugTypes(h)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(i,o){const r=i;if(typeof r.sourceReference=="number"&&r.sourceReference>0){let t=`debug:${encodeURIComponent(r.path||"")}`,s="?";return o&&(t+=`${s}session=${encodeURIComponent(o.id)}`,s="&"),t+=`${s}ref=${r.sourceReference}`,T.URI.parse(t)}else{if(r.path)return T.URI.file(r.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(i){const o=[];for(const r of i.getAllExtensionDescriptions())if(r.contributes){const t=r.contributes.debuggers;if(t&&t.length>0)for(const s of t)(0,v.isDebuggerMainContribution)(s)&&o.push(s.type)}this._debugServiceProxy.$registerDebugTypes(o)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const i=[];return this._breakpoints.forEach(o=>i.push(o)),i}addBreakpoints(i){this.startBreakpoints();const o=i.filter(s=>{const l=s.id;return this._breakpoints.has(l)?!1:(this._breakpoints.set(l,s),!0)});this.fireBreakpointChanges(o,[],[]);const r=[],t=new Map;for(const s of o)if(s instanceof k.SourceBreakpoint){let l=t.get(s.location.uri.toString());l||(l={type:"sourceMulti",uri:s.location.uri,lines:[]},t.set(s.location.uri.toString(),l),r.push(l)),l.lines.push({id:s.id,enabled:s.enabled,condition:s.condition,hitCondition:s.hitCondition,logMessage:s.logMessage,line:s.location.range.start.line,character:s.location.range.start.character})}else s instanceof k.FunctionBreakpoint&&r.push({type:"function",id:s.id,enabled:s.enabled,hitCondition:s.hitCondition,logMessage:s.logMessage,condition:s.condition,functionName:s.functionName});return this._debugServiceProxy.$registerBreakpoints(r)}removeBreakpoints(i){this.startBreakpoints();const o=i.filter(l=>this._breakpoints.delete(l.id));this.fireBreakpointChanges([],o,[]);const r=o.filter(l=>l instanceof k.SourceBreakpoint).map(l=>l.id),t=o.filter(l=>l instanceof k.FunctionBreakpoint).map(l=>l.id),s=o.filter(l=>l instanceof k.DataBreakpoint).map(l=>l.id);return this._debugServiceProxy.$unregisterBreakpoints(r,t,s)}startDebugging(i,o,r){return this._debugServiceProxy.$startDebugging(i?i.uri:void 0,o,{parentSessionID:r.parentSession?r.parentSession.id:void 0,lifecycleManagedByParent:r.lifecycleManagedByParent,repl:r.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:r.noDebug,compact:r.compact,debugUI:r.debugUI,suppressSaveBeforeStart:r.suppressSaveBeforeStart})}stopDebugging(i){return this._debugServiceProxy.$stopDebugging(i?i.id:void 0)}registerDebugConfigurationProvider(i,o,r){if(!o)return new k.Disposable(()=>{});const t=this._configProviderHandleCounter++;return this._configProviders.push({type:i,handle:t,provider:o}),this._debugServiceProxy.$registerDebugConfigurationProvider(i,r,!!o.provideDebugConfigurations,!!o.resolveDebugConfiguration,!!o.resolveDebugConfigurationWithSubstitutedVariables,t),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(s=>s.provider!==o),this._debugServiceProxy.$unregisterDebugConfigurationProvider(t)})}registerDebugAdapterDescriptorFactory(i,o,r){if(!r)return new k.Disposable(()=>{});if(!this.definesDebugType(i,o))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${o}' debugger.`);if(this.getAdapterDescriptorFactoryByType(o))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const t=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:o,handle:t,factory:r}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(o,t),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(s=>s.factory!==r),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(t)})}registerDebugAdapterTrackerFactory(i,o){if(!o)return new k.Disposable(()=>{});const r=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:i,handle:r,factory:o}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(t=>t.factory!==o)})}async $runInTerminal(i,o){return Promise.resolve(void 0)}async $substituteVariables(i,o){let r;const t=await this.getFolder(i);return t&&(r={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(r,o)}createDebugAdapter(i,o){if(i.type==="implementation")return new m(i.implementation)}createSignService(){}async $startDASession(i,o){const r=this,t=await this.getSession(o);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(t.type),t).then(s=>{if(!s)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}' (extension might have failed to activate)`);const l=this.convertToDto(s),h=this.createDebugAdapter(l,t);if(!h)throw new Error(`Couldn't create a debug adapter for type '${t.type}'.`);const S=h;return this._debugAdapters.set(i,S),this.getDebugAdapterTrackers(t).then(L=>(L&&this._debugAdaptersTrackers.set(i,L),S.onMessage(async F=>{if(F.type==="request"&&F.command==="handshake"){const M=F,A={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const B=await this._signService.sign(M.arguments.value);A.body={signature:B},S.sendResponse(A)}else throw new Error("no signer")}catch(B){A.success=!1,A.message=B.message,S.sendResponse(A)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(F),F=(0,v.convertToVSCPaths)(F,!0),r._debugServiceProxy.$acceptDAMessage(i,F)}),S.onError(F=>{L&&L.onError&&L.onError(F),this._debugServiceProxy.$acceptDAError(i,F.name,F.message,F.stack)}),S.onExit(F=>{L&&L.onExit&&L.onExit((0,D.withNullAsUndefined)(F),void 0),this._debugServiceProxy.$acceptDAExit(i,(0,D.withNullAsUndefined)(F),void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),S.startSession()))})}$sendDAMessage(i,o){o=(0,v.convertToDAPaths)(o,!1);const r=this._debugAdaptersTrackers.get(i);r&&r.onWillReceiveMessage&&r.onWillReceiveMessage(o),this._debugAdapters.get(i)?.sendMessage(o)}$stopDASession(i){const o=this._debugAdaptersTrackers.get(i);this._debugAdaptersTrackers.delete(i),o&&o.onWillStopSession&&o.onWillStopSession();const r=this._debugAdapters.get(i);return this._debugAdapters.delete(i),r?r.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(i){const o=[],r=[],t=[];if(i.added)for(const s of i.added){const l=s.id;if(l&&!this._breakpoints.has(l)){let h;if(s.type==="function")h=new k.FunctionBreakpoint(s.functionName,s.enabled,s.condition,s.hitCondition,s.logMessage);else if(s.type==="data")h=new k.DataBreakpoint(s.label,s.dataId,s.canPersist,s.enabled,s.hitCondition,s.condition,s.logMessage);else{const S=T.URI.revive(s.uri);h=new k.SourceBreakpoint(new k.Location(S,new k.Position(s.line,s.character)),s.enabled,s.condition,s.hitCondition,s.logMessage)}h._id=l,this._breakpoints.set(l,h),o.push(h)}}if(i.removed)for(const s of i.removed){const l=this._breakpoints.get(s);l&&(this._breakpoints.delete(s),r.push(l))}if(i.changed){for(const s of i.changed)if(s.id){const l=this._breakpoints.get(s.id);if(l){if(l instanceof k.FunctionBreakpoint&&s.type==="function"){const h=l;h.enabled=s.enabled,h.condition=s.condition,h.hitCondition=s.hitCondition,h.logMessage=s.logMessage,h.functionName=s.functionName}else if(l instanceof k.SourceBreakpoint&&s.type==="source"){const h=l;h.enabled=s.enabled,h.condition=s.condition,h.hitCondition=s.hitCondition,h.logMessage=s.logMessage,h.location=new k.Location(T.URI.revive(s.uri),new k.Position(s.line,s.character))}t.push(l)}}}this.fireBreakpointChanges(o,r,t)}$provideDebugConfigurations(i,o,r){return(0,u.asPromise)(async()=>{const t=this.getConfigProviderByHandle(i);if(!t)throw new Error("no DebugConfigurationProvider found");if(!t.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const s=await this.getFolder(o);return t.provideDebugConfigurations(s,r)}).then(t=>{if(!t)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return t})}$resolveDebugConfiguration(i,o,r,t){return(0,u.asPromise)(async()=>{const s=this.getConfigProviderByHandle(i);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const l=await this.getFolder(o);return s.resolveDebugConfiguration(l,r,t)})}$resolveDebugConfigurationWithSubstitutedVariables(i,o,r,t){return(0,u.asPromise)(async()=>{const s=this.getConfigProviderByHandle(i);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const l=await this.getFolder(o);return s.resolveDebugConfigurationWithSubstitutedVariables(l,r,t)})}async $provideDebugAdapter(i,o){const r=this.getAdapterDescriptorFactoryByHandle(i);if(!r)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const t=await this.getSession(o);return this.getAdapterDescriptor(r,t).then(s=>{if(!s)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}'`);return this.convertToDto(s)})}async $acceptDebugSessionStarted(i){const o=await this.getSession(i);this._onDidStartDebugSession.fire(o)}async $acceptDebugSessionTerminated(i){const o=await this.getSession(i);o&&(this._onDidTerminateDebugSession.fire(o),this._debugSessions.delete(o.id))}async $acceptDebugSessionActiveChanged(i){this._activeDebugSession=i?await this.getSession(i):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(i,o){(await this.getSession(i))?._acceptNameChanged(o)}async $acceptDebugSessionCustomEvent(i,o){const t={session:await this.getSession(i),event:o.event,body:o.body};this._onDidReceiveDebugSessionCustomEvent.fire(t)}convertToDto(i){if(i instanceof k.DebugAdapterExecutable)return{type:"executable",command:i.command,args:i.args,options:i.options};if(i instanceof k.DebugAdapterServer)return{type:"server",port:i.port,host:i.host};if(i instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:i.path};if(i instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:i.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(i){const o=this._adapterFactories.filter(r=>r.type===i);if(o.length>0)return o[0].factory}getAdapterDescriptorFactoryByHandle(i){const o=this._adapterFactories.filter(r=>r.handle===i);if(o.length>0)return o[0].factory}getConfigProviderByHandle(i){const o=this._configProviders.filter(r=>r.handle===i);if(o.length>0)return o[0].provider}definesDebugType(i,o){if(i.contributes){const r=i.contributes.debuggers;if(r&&r.length>0){for(const t of r)if(t.label&&t.type&&t.type===o)return!0}}return!1}getDebugAdapterTrackers(i){const r=i.configuration.type,t=this._trackerFactories.filter(s=>s.type===r||s.type==="*").map(s=>(0,u.asPromise)(()=>s.factory.createDebugAdapterTracker(i)).then(l=>l,l=>null));return Promise.race([Promise.all(t).then(s=>{const l=s.filter(h=>!!h);if(l.length>0)return new c(l)}),new Promise((s,l)=>{const h=setTimeout(()=>{clearTimeout(h),l(new Error("timeout"))},1e3)})]).catch(s=>{})}async getAdapterDescriptor(i,o){const r=o.configuration.debugServer;if(typeof r=="number")return Promise.resolve(new k.DebugAdapterServer(r));if(i){const s=await this._extensionService.getExtensionRegistry();return(0,u.asPromise)(()=>i.createDebugAdapterDescriptor(o,this.daExecutableFromPackage(o,s))).then(l=>{if(l)return l})}const t=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(o,t))}daExecutableFromPackage(i,o){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(i,o,r){(i.length>0||o.length>0||r.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:i,removed:o,changed:r}))}async getSession(i){if(i)if(typeof i=="string"){const o=this._debugSessions.get(i);if(o)return o}else{let o=this._debugSessions.get(i.id);if(!o){const r=await this.getFolder(i.folderUri),t=i.parent?this._debugSessions.get(i.parent):void 0;o=new E(this._debugServiceProxy,i.id,i.type,i.name,r,i.configuration,t),this._debugSessions.set(o.id,o),this._debugServiceProxy.$sessionCached(o.id)}return o}throw new Error("cannot find session")}getFolder(i){if(i){const o=T.URI.revive(i);return this._workspaceService.resolveWorkspaceFolder(o)}return Promise.resolve(void 0)}};f=je([Ve(0,R.IExtHostRpcService),Ve(1,_.IExtHostWorkspace),Ve(2,I.IExtHostExtensionService),Ve(3,w.IExtHostConfiguration),Ve(4,b.IExtHostEditorTabs),Ve(5,p.IExtHostVariableResolverProvider)],f),e.ExtHostDebugServiceBase=f;class E{constructor(i,o,r,t,s,l,h){this._debugServiceProxy=i,this._id=o,this._type=r,this._name=t,this._workspaceFolder=s,this._configuration=l,this._parentSession=h}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(i){this._name=i,this._debugServiceProxy.$setDebugSessionName(this._id,i)}get parentSession(){return this._parentSession}_acceptNameChanged(i){this._name=i}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(i,o){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,i,o)}getDebugProtocolBreakpoint(i){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,i.id)}}e.ExtHostDebugSession=E;class g{constructor(i){this.value=Object.freeze({append(o){i.$appendDebugConsole(o)},appendLine(o){this.append(o+`
`)}})}}e.ExtHostDebugConsole=g;class c{constructor(i){this.trackers=i}onWillStartSession(){this.trackers.forEach(i=>i.onWillStartSession?i.onWillStartSession():void 0)}onWillReceiveMessage(i){this.trackers.forEach(o=>o.onWillReceiveMessage?o.onWillReceiveMessage(i):void 0)}onDidSendMessage(i){this.trackers.forEach(o=>o.onDidSendMessage?o.onDidSendMessage(i):void 0)}onWillStopSession(){this.trackers.forEach(i=>i.onWillStopSession?i.onWillStopSession():void 0)}onError(i){this.trackers.forEach(o=>o.onError?o.onError(i):void 0)}onExit(i,o){this.trackers.forEach(r=>r.onExit?r.onExit(i,o):void 0)}}class m extends P.AbstractDebugAdapter{constructor(i){super();this.implementation=i,i.onDidSendMessage(o=>{this.acceptMessage(o)})}startSession(){return Promise.resolve(void 0)}sendMessage(i){this.implementation.handleMessage(i)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends f{constructor(i,o,r,t,s,l){super(i,o,r,t,s,l)}};a=je([Ve(0,R.IExtHostRpcService),Ve(1,_.IExtHostWorkspace),Ve(2,I.IExtHostExtensionService),Ve(3,w.IExtHostConfiguration),Ve(4,b.IExtHostEditorTabs),Ve(5,p.IExtHostVariableResolverProvider)],a),e.WorkerExtHostDebugService=a}),define(Ie[284],ke([0,1,12,74,2,5,276,14,82,85,26,195,17,65,40]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class w{constructor(f,E,g,c,m){this._hostUtils=g,this._rpcProtocol=new C.RPCProtocol(f,null,c),E=w._transform(E,this._rpcProtocol);const a=new I.ServiceCollection(...(0,b.getSingletonServiceDescriptors)());a.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...E,messagePorts:m}),a.set(_.IExtHostRpcService,new _.ExtHostRpcService(this._rpcProtocol)),a.set(P.IURITransformerService,new P.URITransformerService(c)),a.set(v.IHostUtils,g);const d=new k.InstantiationService(a,!0);this._logService=d.invokeFunction(t=>t.get(y.ILogService)),n.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",E),this._extensionService=d.invokeFunction(t=>t.get(v.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const i=new WeakMap;this._extensionService.getExtensionPathIndex().then(t=>{Error.prepareStackTrace=(s,l)=>{let h="",S,L;for(const F of l)h+=`
	at ${F.toString()}`,L=F.getFileName(),!S&&L&&(S=t.findSubstr(D.URI.file(L)));return i.set(s,S),`${s.name||"Error"}: ${s.message||""}${h}`}});const o=this._rpcProtocol.getProxy(T.MainContext.MainThreadExtensionService),r=this._rpcProtocol.getProxy(T.MainContext.MainThreadErrors);u.setUnexpectedErrorHandler(t=>{const s=u.transformErrorForSerialization(t),l=i.get(t);l?o.$onExtensionRuntimeError(l.identifier,s):r.$onUnexpectedError(s)})}async asBrowserUri(f){const E=this._rpcProtocol.getProxy(T.MainContext.MainThreadExtensionService);return D.URI.revive(await E.$asBrowserUri(f))}terminate(f){this._extensionService.terminate(f)}static _transform(f,E){f.allExtensions.forEach(c=>c.extensionLocation=D.URI.revive(E.transformIncomingURIs(c.extensionLocation))),f.environment.appRoot=D.URI.revive(E.transformIncomingURIs(f.environment.appRoot));const g=f.environment.extensionDevelopmentLocationURI;return g&&(f.environment.extensionDevelopmentLocationURI=g.map(c=>D.URI.revive(E.transformIncomingURIs(c)))),f.environment.extensionTestsLocationURI=D.URI.revive(E.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=D.URI.revive(E.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=D.URI.revive(E.transformIncomingURIs(f.environment.workspaceStorageHome)),f.logsLocation=D.URI.revive(E.transformIncomingURIs(f.logsLocation)),f.logFile=D.URI.revive(E.transformIncomingURIs(f.logFile)),f.workspace=E.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=w}),define(Ie[285],ke([0,1,18,13,177,194,202,75,55,40,17,39,7,47,32,216,218,33]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v,w,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let E=class extends y.ExtHostDebugServiceBase{constructor(d,i,o,r,t,s,l){super(d,i,o,r,s,l);this._terminalService=t,this._integratedTerminalInstances=new m}createDebugAdapter(d,i){switch(d.type){case"server":return new w.SocketDebugAdapter(d);case"pipeServer":return new w.NamedPipeDebugAdapter(d);case"executable":return new w.ExecutableDebugAdapter(d,i.type)}return super.createDebugAdapter(d,i)}daExecutableFromPackage(d,i){const o=w.ExecutableDebugAdapter.platformAdapterExecutable(i.getAllExtensionDescriptions(),d.type);if(o)return new _.DebugAdapterExecutable(o.command,o.args,o.options)}createSignService(){return new C.SignService}async $runInTerminal(d,i){if(d.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(B=>{this._integratedTerminalInstances.onTerminalClosed(B)}));const o=await this._configurationService.getConfigProvider(),r=this._terminalService.getDefaultShell(!0),t=this._terminalService.getDefaultShellArgs(!0),s=d.title||D.localize(0,null),l=JSON.stringify({shell:r,shellArgs:t});let h=await this._integratedTerminalInstances.checkout(l,s),S,L=!1;if(h)S=d.cwd;else{const B={shellPath:r,shellArgs:t,cwd:d.cwd,name:s,iconPath:new _.ThemeIcon("debug")};L=!0,h=this._terminalService.createTerminalFromOptions(B,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(h,l)}h.show(!0);const F=await h.processId;L?await new Promise(B=>setTimeout(B,1e3)):o.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?h.sendText("cls"):r.indexOf("bash")>=0?h.sendText("clear"):n.isWindows?h.sendText("cls"):h.sendText("clear"));const M=(0,p.prepareCommand)(r,d.args,!!d.argsCanBeInterpretedByShell,S,d.env);h.sendText(M);const A=this.onDidTerminateDebugSession(B=>{B.id===i&&(this._integratedTerminalInstances.free(h),A.dispose())});return F}else if(d.kind==="external")return c(d,await this._configurationService.getConfigProvider());return super.$runInTerminal(d,i)}};E=je([Ve(0,R.IExtHostRpcService),Ve(1,v.IExtHostWorkspace),Ve(2,I.IExtHostExtensionService),Ve(3,f.IExtHostConfiguration),Ve(4,k.IExtHostTerminalService),Ve(5,b.IExtHostEditorTabs),Ve(6,P.IExtHostVariableResolverProvider)],E),e.ExtHostDebugService=E;let g;function c(a,d){if(!g)if(n.isWindows)g=new T.WindowsExternalTerminalService;else if(n.isMacintosh)g=new T.MacExternalTerminalService;else if(n.isLinux)g=new T.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const i=d.getConfiguration("terminal");return g.runInTerminal(a.title,a.cwd,a.args,a.env||{},i.external||{})}e.runInExternalTerminal=c;class m{constructor(){this._terminalInstances=new Map}async checkout(d,i){const r=[...this._terminalInstances.entries()].map(([t,s])=>(0,u.createCancelablePromise)(async l=>{if(t.name!==i||s.lastUsedAt!==-1&&await(0,p.hasChildProcesses)(await t.processId))return null;const h=Date.now();return s.lastUsedAt+m.minUseDelay>h||l.isCancellationRequested||s.config!==d?null:(s.lastUsedAt=h,t)}));return await(0,u.firstParallel)(r,t=>!!t)}insert(d,i){this._terminalInstances.set(d,{lastUsedAt:Date.now(),config:i})}free(d){const i=this._terminalInstances.get(d);i&&(i.lastUsedAt=-1)}onTerminalClosed(d){this._terminalInstances.delete(d)}}m.minUseDelay=1e3}),define(Ie[286],ke([0,1,9,2,114,32,54,33,45,39,17,26,73,10,14,68,22,63,47]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v,w,p,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let g=class extends _.ExtHostTaskBase{constructor(m,a,d,i,o,r,t,s,l){super(m,a,d,i,o,r,t,s);this.workspaceService=d,this.variableResolver=l,a.remote.isRemote&&a.remote.authority?this.registerTaskSystem(P.Schemas.vscodeRemote,{scheme:P.Schemas.vscodeRemote,authority:a.remote.authority,platform:process.platform}):this.registerTaskSystem(P.Schemas.file,{scheme:P.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(m,a){const d=a;if(!a.execution&&d._id===void 0)throw new Error("Tasks to execute must include an execution");if(d._id!==void 0){const i=_.TaskHandleDTO.from(d,this.workspaceService),o=await this._proxy.$getTaskExecution(i);if(o.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.getTaskExecution(o,a);return this._proxy.$executeTask(i).catch(()=>{}),r}else{const i=_.TaskDTO.from(a,m);if(i===void 0)return Promise.reject(new Error("Task is not valid"));_.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,a,!1);const o=await this.getTaskExecution(await this._proxy.$getTaskExecution(i),a);return this._proxy.$executeTask(i).catch(()=>{}),o}}provideTasksInternal(m,a,d,i){const o=[];if(i)for(const r of i){this.checkDeprecation(r,d),(!r.definition||!m[r.definition.type])&&this._logService.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const t=_.TaskDTO.from(r,d.extension);t&&(o.push(t),_.CustomExecutionDTO.is(t.execution)&&a.push(this.addCustomExecution(t,r,!0)))}return{tasks:o,extension:d.extension}}async resolveTaskInternal(m){return m}async getAFolder(m){let a=m&&m.length>0?m[0]:void 0;if(!a){const d=n.URI.file((0,f.homedir)());a=new b.WorkspaceFolder({uri:d,name:p.basename(d),index:0})}return{uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(m,a){const d=n.URI.revive(m),i={process:void 0,variables:Object.create(null)},o=await this._workspaceProvider.resolveWorkspaceFolder(d),r=await this._workspaceProvider.getWorkspaceFolders2()??[],t=await this.variableResolver.getResolver(),s=o?{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(r);for(const l of a.variables)i.variables[l]=await t.resolveAsync(s,l);if(a.process!==void 0){let l;if(a.process.path!==void 0){l=a.process.path.split(u.delimiter);for(let h=0;h<l.length;h++)l[h]=await t.resolveAsync(s,l[h])}i.process=await D.win32.findExecutable(await t.resolveAsync(s,a.process.name),a.process.cwd!==void 0?await t.resolveAsync(s,a.process.cwd):void 0,l)}return i}async $jsonTasksSupported(){return!0}async $findExecutable(m,a,d){return D.win32.findExecutable(m,a,d)}};g=je([Ve(0,R.IExtHostRpcService),Ve(1,k.IExtHostInitDataService),Ve(2,T.IExtHostWorkspace),Ve(3,C.IExtHostDocumentsAndEditors),Ve(4,y.IExtHostConfiguration),Ve(5,I.IExtHostTerminalService),Ve(6,v.ILogService),Ve(7,w.IExtHostApiDeprecationService),Ve(8,E.IExtHostVariableResolverProvider)],g),e.ExtHostTask=g}),define(Ie[287],ke([0,1,63,47]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class D extends n.ExtHostVariableResolverProviderService{homeDir(){return(0,u.homedir)()}}e.NodeExtHostVariableResolverProviderService=D}),define(Ie[139],ke([0,1,16,18,21,49,10,9,22,11,2,31]),function(J,e,u,n,D,T,C,y,b,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class _{constructor(g,c,m,a){this.query=g,this.provider=c,this.fileUtils=m,this.processType=a,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(g,c){const m=this.query.folderQueries||[],a=new D.CancellationTokenSource;return c.onCancellationRequested(()=>a.cancel()),new Promise((d,i)=>{this.collector=new v(g);let o=!1;const r=(t,s)=>{if(!o&&!this.isLimitHit){const l=this.resultSize(t);p(t)&&typeof this.query.maxResults=="number"&&this.resultCount+l>this.query.maxResults&&(this.isLimitHit=!0,o=!0,a.cancel(),t=this.trimResultToSize(t,this.query.maxResults-this.resultCount));const h=this.resultSize(t);this.resultCount+=h,(h>0||!p(t))&&this.collector.add(t,s)}};Promise.all(m.map((t,s)=>this.searchInFolder(t,l=>r(l,s),a.token))).then(t=>{a.dispose(),this.collector.flush();const s=t.some(l=>!!l&&!!l.limitHit);d({limitHit:this.isLimitHit||s,messages:(0,u.flatten)(t.map(l=>l?.message?(0,I.isArray)(l.message)?l.message:[l.message]:[])),stats:{type:this.processType}})},t=>{a.dispose();const s=(0,T.toErrorMessage)(t);i(new Error(s))})})}resultSize(g){return p(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}trimResultToSize(g,c){const m=Array.isArray(g.ranges)?g.ranges:[g.ranges],a=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:m.slice(0,c),preview:{matches:a.slice(0,c),text:g.preview.text},uri:g.uri}}async searchInFolder(g,c,m){const a=new k.QueryGlobTester(this.query,g),d=[],i={report:t=>{if(!this.validateProviderResult(t))return;const s=g.folder.scheme===C.Schemas.file?(0,k.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(b.dirname(t.uri))):void 0,l=b.relativePath(g.folder,t.uri);if(l){const h=a.includedInQuery(l,y.basename(l),s);(0,n.isThenable)(h)?d.push(h.then(S=>{S&&c(t)})):h&&c(t)}}},o=this.getSearchOptionsForFolder(g),r=await this.provider.provideTextSearchResults(P(this.query.contentPattern),o,i,m);return d.length&&await Promise.all(d),r}validateProviderResult(g){if(p(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(g){const c=(0,k.resolvePatternsForProvider)(this.query.includePattern,g.includePattern),m=(0,k.resolvePatternsForProvider)(this.query.excludePattern,g.excludePattern),a={folder:R.URI.from(g.folder),excludes:m,includes:c,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.fileUtils.toCanonicalName(g.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return a.usePCRE2=this.query.usePCRE2,a}}e.TextSearchManager=_;function P(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class v{constructor(g){this._onResult=g,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new f(512,c=>this.sendItems(c))}add(g,c){this._currentFileMatch&&(this._currentFolderIdx!==c||!b.isEqual(this._currentUri,g.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=c,this._currentFileMatch={resource:g.uri,results:[]}),this._currentFileMatch.results.push(w(g))}pushToCollector(){const g=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,g)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(g){this._onResult(g)}}e.TextSearchResultsCollector=v;function w(E){return p(E)?{preview:{matches:(0,u.mapArrayOrNot)(E.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:E.preview.text},ranges:(0,u.mapArrayOrNot)(E.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function p(E){return!!E.preview}e.extensionResultIsMatch=p;class f{constructor(g,c){this.maxBatchSize=g,this.cb=c,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(g,c){!g||this.addItemToBatch(g,c)}addItems(g,c){!g||this.addItemsToBatch(g,c)}addItemToBatch(g,c){this.batch.push(g),this.batchSize+=c,this.onUpdate()}addItemsToBatch(g,c){this.batch=this.batch.concat(g),this.batchSize+=c,this.onUpdate()}onUpdate(){this.totalNumberCompleted<f.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},f.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=f,f.TIMEOUT=4e3,f.START_BATCH_AFTER_COUNT=50}),define(Ie[76],ke([0,1,6,5,4,280,17,65,14,2,139]),function(J,e,u,n,D,T,C,y,b,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let k=class{constructor(w,p,f){this.extHostRpc=w,this._uriTransformer=p,this._logService=f,this._proxy=this.extHostRpc.getProxy(n.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}registerTextSearchProvider(w,p){if(this._textSearchUsedSchemes.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this._textSearchUsedSchemes.add(w);const f=this._handlePool++;return this._textSearchProvider.set(f,p),this._proxy.$registerTextSearchProvider(f,this._transformScheme(w)),(0,u.toDisposable)(()=>{this._textSearchUsedSchemes.delete(w),this._textSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}registerFileSearchProvider(w,p){if(this._fileSearchUsedSchemes.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this._fileSearchUsedSchemes.add(w);const f=this._handlePool++;return this._fileSearchProvider.set(f,p),this._proxy.$registerFileSearchProvider(f,this._transformScheme(w)),(0,u.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(w),this._fileSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}$provideFileSearchResults(w,p,f,E){const g=_(f),c=this._fileSearchProvider.get(w);if(c)return this._fileSearchManager.fileSearch(g,c,m=>{this._proxy.$handleFileMatch(w,p,m.map(a=>a.resource))},E);throw new Error("unknown provider: "+w)}$clearCache(w){return this._fileSearchManager.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,p,f,E){const g=this._textSearchProvider.get(w);if(!g||!g.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const c=_(f);return this.createTextSearchManager(c,g).search(a=>this._proxy.$handleTextMatch(w,p,a),E)}$enableExtensionHostSearch(){}createTextSearchManager(w,p){return new R.TextSearchManager(w,p,{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"textSearchProvider")}};k=je([Ve(0,C.IExtHostRpcService),Ve(1,y.IURITransformerService),Ve(2,b.ILogService)],k),e.ExtHostSearch=k;function _(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(P),extraFileResources:v.extraFileResources&&v.extraFileResources.map(w=>I.URI.revive(w))}}e.reviveQuery=_;function P(v){return{...v,folder:I.URI.revive(v.folder)}}}),define(Ie[288],ke([0,1,82,138,32,135,33,38,54,39,73,75,76,91,52,68,137,69,46,90,125,55,136,14,231,47]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v,w,p,f,E,g,c,m,a,d,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.registerSingleton)(d.ILoggerService,a.ExtHostLoggerService),(0,u.registerSingleton)(d.ILogService,i.ExtHostLogService),(0,u.registerSingleton)(w.IExtHostApiDeprecationService,w.ExtHostApiDeprecationService),(0,u.registerSingleton)(y.IExtHostCommands,y.ExtHostCommands),(0,u.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration),(0,u.registerSingleton)(f.IExtHostConsumerFileSystem,f.ExtHostConsumerFileSystem),(0,u.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService),(0,u.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,u.registerSingleton)(b.IExtHostDocumentsAndEditors,b.ExtHostDocumentsAndEditors),(0,u.registerSingleton)(E.IExtHostFileSystemInfo,E.ExtHostFileSystemInfo),(0,u.registerSingleton)(n.IExtHostOutputService,n.ExtHostOutputService),(0,u.registerSingleton)(_.IExtHostSearch,_.ExtHostSearch),(0,u.registerSingleton)(P.IExtHostStorage,P.ExtHostStorage),(0,u.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,u.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService),(0,u.registerSingleton)(v.IExtHostTunnelService,v.ExtHostTunnelService),(0,u.registerSingleton)(p.IExtHostWindow,p.ExtHostWindow),(0,u.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace),(0,u.registerSingleton)(g.IExtHostSecretState,g.ExtHostSecretState),(0,u.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry),(0,u.registerSingleton)(m.IExtHostEditorTabs,m.ExtHostEditorTabs),(0,u.registerSingleton)(o.IExtHostVariableResolverProvider,o.ExtHostVariableResolverProviderService)}),define(Ie[92],ke([0,1,16,14,31,72]),function(J,e,u,n,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function C(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=C;function y(k,_,P,v){const w=(0,u.mapArrayOrNot)(P,b),p=new D.TextSearchMatch(_,w,v),f=p.preview.matches;return{ranges:(0,u.mapArrayOrNot)(w,I),uri:k,preview:{text:p.preview.text,matches:(0,u.mapArrayOrNot)(f,I)}}}e.createTextSearchResult=y;function b(k){return new D.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function I(k){return new T.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let R=class{constructor(_,P){this.prefix=_,this.logService=P}appendLine(_){this.logService.debug(`${this.prefix}#search`,_)}};R=je([Ve(1,n.ILogService)],R),e.OutputChannel=R}),define(Ie[289],ke([0,1,42,9,81,30,13,8,92,290]),function(J,e,u,n,D,T,C,y,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const R=I.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(g,c,m,a){const d=_(g,c,m,a),i=c.folder.fsPath;return{cmd:u.spawn(R,d.args,{cwd:i}),rgDiskPath:R,siblingClauses:d.siblingClauses,rgArgs:d,cwd:i}}e.spawnRipgrepCmd=k;function _(g,c,m,a){const d=["--files","--hidden","--case-sensitive"];v([c],m,!1).forEach(o=>{const r=(0,b.anchorGlob)(o);if(d.push("-g",r),C.isMacintosh){const t=(0,D.normalizeNFD)(r);t!==r&&d.push("-g",t)}});const i=P([c],a,void 0,!1);return i.globArgs.forEach(o=>{const r=`!${(0,b.anchorGlob)(o)}`;if(d.push("-g",r),C.isMacintosh){const t=(0,D.normalizeNFD)(r);t!==r&&d.push("-g",t)}}),c.disregardIgnoreFiles!==!1?d.push("--no-ignore"):c.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),c.ignoreSymlinks||d.push("--follow"),g.exists&&d.push("--quiet"),d.push("--no-config"),c.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:i.siblingClauses}}function P(g,c,m,a=!0){const d=[];let i={};return g.forEach(o=>{const r=Object.assign({},o.excludePattern||{},c||{}),t=w(r,a?o.folder.fsPath:void 0,m);d.push(...t.globArgs),t.siblingClauses&&(i=Object.assign(i,t.siblingClauses))}),{globArgs:d,siblingClauses:i}}e.foldersToRgExcludeGlobs=P;function v(g,c,m=!0){const a=[];return g.forEach(d=>{const i=Object.assign({},c||{},d.includePattern||{}),o=w(i,m?d.folder.fsPath:void 0);a.push(...o.globArgs)}),a}e.foldersToIncludeGlobs=v;function w(g,c,m){const a=[],d={};return Object.keys(g).forEach(i=>{if(m&&m.has(i)||!i)return;const o=g[i];i=f(c?p(c,i):i),i.startsWith("\\\\")?i="\\\\"+i.substr(2).replace(/\\/g,"/"):i=i.replace(/\\/g,"/"),typeof o=="boolean"&&o?(i.startsWith("\\\\")&&(i+="**"),a.push(E(i))):o&&o.when&&(d[i]=o)}),{globArgs:a,siblingClauses:d}}function p(g,c){return n.isAbsolute(c)?c:n.join(g,c)}e.getAbsoluteGlob=p;function f(g){return g=y.rtrim(g,"\\"),y.rtrim(g,"/")}function E(g){return T.getRoot(g).toLowerCase()==="c:/"?g.replace(/^c:[/\\]/i,"/"):g}e.fixDriveC=E}),define(Ie[291],ke([0,1,42,62,9,97,16,49,37,81,30,13,50,8,11,29,31,289,105]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v,w,p,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const g=new Set;process.on("exit",()=>{g.forEach(i=>i())});class c{constructor(o){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=o,this.filePattern=o.filePattern||"",this.includePattern=o.includePattern&&b.parse(o.includePattern),this.maxResults=o.maxResults||null,this.exists=!!o.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,E.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=o.excludePattern&&b.parse(o.excludePattern),this.folderExcludePatterns=new Map,o.folderQueries.forEach(r=>{const t=Object.assign({},r.excludePattern||{},this.config.excludePattern||{}),s=r.folder.fsPath;o.folderQueries.map(l=>l.folder.fsPath).filter(l=>l!==s).forEach(l=>{(0,R.isEqualOrParent)(l,s)&&(t[D.relative(s,l)]=!0)}),this.folderExcludePatterns.set(s,new a(t,s))})}cancel(){this.isCanceled=!0,g.forEach(o=>o())}walk(o,r,t,s,l){if(this.fileWalkSW=_.StopWatch.create(!1),this.isCanceled)return l(null,this.isLimitHit);r.forEach(h=>{const S=D.basename(h.fsPath);this.globalExcludePattern&&this.globalExcludePattern(h.fsPath,S)||this.matchFile(t,{relativePath:h.fsPath,searchPath:void 0})}),this.cmdSW=_.StopWatch.create(!1),this.parallel(o,(h,S)=>{this.call(this.cmdTraversal,this,h,t,s,L=>{if(L){const F=(0,y.toErrorMessage)(L);console.error(F),this.errors.push(F),S(L,void 0)}else S(null,void 0)})},(h,S)=>{this.fileWalkSW.stop();const L=h?C.coalesce(h)[0]:null;l(L,this.isLimitHit)})}parallel(o,r,t){const s=new Array(o.length),l=new Array(o.length);let h=!1,S=0;if(o.length===0)return t(null,[]);o.forEach((L,F)=>{r(L,(M,A)=>{if(M?(h=!0,s[F]=null,l[F]=M):(s[F]=A,l[F]=null),++S===o.length)return t(h?l:null,s)})})}call(o,r,...t){try{o.apply(r,t)}catch(s){t[t.length-1](s)}}cmdTraversal(o,r,t,s){const l=o.folder.fsPath,h=k.isMacintosh,S=()=>B&&B.kill();g.add(S);let L=z=>{g.delete(S),L=()=>{},s(z)},F="";const M=this.initDirectoryTree(),A=(0,f.spawnRipgrepCmd)(this.config,o,this.config.includePattern,this.folderExcludePatterns.get(o.folder.fsPath).expression),B=A.cmd,$=!Object.keys(A.siblingClauses).length,U=A.rgArgs.args.map(z=>z.match(/^-/)?z:`'${z}'`).join(" ");let X=`${A.rgDiskPath} ${U}
 - cwd: ${A.cwd}`;A.rgArgs.siblingClauses&&(X+=`
 - Sibling clauses: ${JSON.stringify(A.rgArgs.siblingClauses)}`),t({message:X}),this.cmdResultCount=0,this.collectStdout(B,"utf8",t,(z,N,V)=>{if(z){L(z);return}if(this.isLimitHit){L();return}const q=(F+(h?I.normalizeNFC(N||""):N)).split(`
`);if(V){const te=q.length;q[te-1]=q[te-1].trim(),q[te-1]||q.pop()}else F=q.pop()||"";if(q.length&&q[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=q.length,$){for(const te of q)if(this.matchFile(r,{base:l,relativePath:te,searchPath:this.getSearchPath(o,te)}),this.isLimitHit){S();break}(V||this.isLimitHit)&&L();return}this.addDirectoryEntries(o,M,l,q,r),V&&(this.matchDirectoryTree(M,l,r),L())})}spawnFindCmd(o){const r=this.folderExcludePatterns.get(o.folder.fsPath),t=r.getBasenameTerms(),s=r.getPathTerms(),l=["-L","."];if(t.length||s.length){l.push("-not","(","(");for(const h of t)l.push("-name",h),l.push("-o");for(const h of s)l.push("-path",h),l.push("-o");l.pop(),l.push(")","-prune",")")}return l.push("-type","f"),u.spawn("find",l,{cwd:o.folder.fsPath})}readStdout(o,r,t){let s="";this.collectStdout(o,r,()=>{},(l,h,S)=>{if(l){t(l);return}s+=h,S&&t(null,s)})}collectStdout(o,r,t,s){let l=(L,F,M)=>{(L||M)&&(l=()=>{},this.cmdSW&&this.cmdSW.stop()),s(L,F,M)},h=!1;o.stdout?(this.forwardData(o.stdout,r,l),o.stdout.once("data",()=>h=!0)):t({message:"stdout is null"});let S;o.stderr?S=this.collectData(o.stderr):t({message:"stderr is null"}),o.on("error",L=>{l(L)}),o.on("close",L=>{let F;!h&&(F=this.decodeData(S,r))&&d(F)?l(new Error(`command failed with error code ${L}: ${this.decodeData(S,r)}`)):(this.exists&&L===0&&(this.isLimitHit=!0),l(null,"",!0))})}forwardData(o,r,t){const s=new T.StringDecoder(r);return o.on("data",l=>{t(null,s.write(l))}),s}collectData(o){const r=[];return o.on("data",t=>{r.push(t)}),r}decodeData(o,r){const t=new T.StringDecoder(r);return o.map(s=>t.write(s)).join("")}initDirectoryTree(){const o={rootEntries:[],pathToEntries:Object.create(null)};return o.pathToEntries["."]=o.rootEntries,o}addDirectoryEntries(o,{pathToEntries:r},t,s,l){s.indexOf(this.filePattern)!==-1&&this.matchFile(l,{base:t,relativePath:this.filePattern,searchPath:this.getSearchPath(o,this.filePattern)});const h=S=>{const L=D.basename(S),F=D.dirname(S);let M=r[F];M||(M=r[F]=[],h(F)),M.push({base:t,relativePath:S,basename:L,searchPath:this.getSearchPath(o,S)})};s.forEach(h)}matchDirectoryTree({rootEntries:o,pathToEntries:r},t,s){const l=this,h=this.folderExcludePatterns.get(t),S=this.filePattern;function L(F){l.directoriesWalked++;const M=(0,p.hasSiblingFn)(()=>F.map(A=>A.basename));for(let A=0,B=F.length;A<B;A++){const $=F[A],{relativePath:U,basename:X}=$;if(h.test(U,X,S!==X?M:void 0))continue;const z=r[U];if(z)L(z);else{if(l.filesWalked++,U===S)continue;l.matchFile(s,$)}if(l.isLimitHit)break}}L(o)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(o,r,t,s,l){const h=o.folder,S=(0,p.hasSiblingFn)(()=>t);this.parallel(t,(L,F)=>{if(this.isCanceled||this.isLimitHit)return F(null);const M=r?[r,L].join(D.sep):L;if(this.folderExcludePatterns.get(o.folder.fsPath).test(M,L,this.config.filePattern!==L?S:void 0))return F(null);const A=[h.fsPath,M].join(D.sep);n.lstat(A,(B,$)=>{if(B||this.isCanceled||this.isLimitHit)return F(null);this.statLinkIfNeeded(A,$,(U,X)=>U||this.isCanceled||this.isLimitHit?F(null):X.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(A,$,(z,N)=>z||this.isCanceled||this.isLimitHit||(N=N||"",this.walkedPaths[N])?F(null):(this.walkedPaths[N]=!0,w.Promises.readdir(A).then(V=>{if(this.isCanceled||this.isLimitHit)return F(null);this.doWalk(o,M,V,s,x=>F(x||null))},V=>{F(null)})))):(this.filesWalked++,M===this.filePattern||this.maxFilesize&&v.isNumber(X.size)&&X.size>this.maxFilesize||this.matchFile(s,{base:h.fsPath,relativePath:M,searchPath:this.getSearchPath(o,M)}),F(null,void 0)))})},L=>{const F=L&&C.coalesce(L);return l(F&&F.length>0?F[0]:void 0)})}matchFile(o,r){this.isFileMatch(r)&&(!this.includePattern||this.includePattern(r.relativePath,D.basename(r.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||o(r))}isFileMatch(o){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,p.isFilePatternMatch)(o,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(o,r,t){return r.isSymbolicLink()?n.stat(o,t):t(null,r)}realPathIfNeeded(o,r,t){return r.isSymbolicLink()?n.realpath(o,(s,l)=>s?t(s):t(null,l)):t(null,o)}getSearchPath(o,r){return o.folderName?D.join(o.folderName,r):r}}e.FileWalker=c;class m{constructor(o){this.folderQueries=o.folderQueries,this.extraFiles=o.extraFileResources||[],this.walker=new c(o)}search(o,r,t){this.walker.walk(this.folderQueries,this.extraFiles,o,r,(s,l)=>{t(s,{limitHit:l,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=m;class a{constructor(o,r){this.expression=o,this.root=r,this.init(o)}init(o){let r,t;Object.keys(o).filter(s=>o[s]).forEach(s=>{D.isAbsolute(s)?(r=r||b.getEmptyExpression(),r[s]=o[s]):(t=t||b.getEmptyExpression(),t[s]=o[s])}),this.absoluteParsedExpr=r&&b.parse(r,{trimForExclusions:!0}),this.relativeParsedExpr=t&&b.parse(t,{trimForExclusions:!0})}test(o,r,t){return this.relativeParsedExpr&&this.relativeParsedExpr(o,r,t)||this.absoluteParsedExpr&&this.absoluteParsedExpr(D.join(this.root,o),r,t)}getBasenameTerms(){const o=[];return this.absoluteParsedExpr&&o.push(...b.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&o.push(...b.getBasenameTerms(this.relativeParsedExpr)),o}getPathTerms(){const o=[];return this.absoluteParsedExpr&&o.push(...b.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&o.push(...b.getPathTerms(this.relativeParsedExpr)),o}}function d(i){const o=i.trim().split(`
`),r=o[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return P.uppercaseFirstLetter(o[o.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}e.rgErrorMsgForDisplay=d}),define(Ie[292],ke([0,1,95,23]),function(J,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function D(i){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(o=>o===i)}e.isUTFEncoding=D,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const T=512,C=512,y=512*8,b=512*128;var I;(function(i){i[i.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class R extends Error{constructor(o,r){super(o);this.decodeStreamErrorKind=r}}e.DecodeStreamError=R;class k{constructor(o){this.iconvLiteDecoder=o}static async create(o){let r;if(o!==e.UTF8)r=(await new Promise((s,l)=>{J(["@vscode/iconv-lite-umd"],s,l)})).getDecoder(w(o));else{const t=new TextDecoder;r={write(s){return t.decode(s,{stream:!0})},end(){return t.decode()}}}return new k(r)}write(o){return this.iconvLiteDecoder.write(o)}end(){return this.iconvLiteDecoder.end()}}function _(i,o){const r=o.minBytesRequiredForDetection??o.guessEncoding?y:C;return new Promise((t,s)=>{const l=(0,u.newWriteableStream)(A=>A.join("")),h=[];let S=0,L,F;const M=async()=>{try{const A=await d({buffer:n.VSBuffer.concat(h),bytesRead:S},o.guessEncoding);if(A.seemsBinary&&o.acceptTextOnly)throw new R("Stream is binary but only text is accepted for decoding",1);A.encoding=await o.overwriteEncoding(A.encoding),L=await k.create(A.encoding);const B=L.write(n.VSBuffer.concat(h).buffer);l.write(B),h.length=0,S=0,t({stream:l,detected:A})}catch(A){F?.dispose(),l.destroy(),s(A)}};F=(0,u.listenStream)(i,{onData:async A=>{L?l.write(L.write(A.buffer)):(h.push(A),S+=A.byteLength,S>=r&&(i.pause(),await M(),setTimeout(()=>i.resume())))},onError:A=>l.error(A),onEnd:async()=>{L||await M(),l.end(L?.end())}})})}e.toDecodeStream=_;async function P(i,o,r){const s=(await new Promise((S,L)=>{J(["@vscode/iconv-lite-umd"],S,L)})).getEncoder(w(o),r);let l=!1,h=!1;return{read(){if(h)return null;const S=i.read();if(typeof S!="string"){if(h=!0,!l&&r?.addBOM)switch(o){case e.UTF8:case e.UTF8_with_bom:return n.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return n.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return n.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const L=s.end();return L&&L.length>0?(l=!0,n.VSBuffer.wrap(L)):null}return l=!0,n.VSBuffer.wrap(s.write(S))}}}e.toEncodeReadable=P;async function v(i){return(await new Promise((r,t)=>{J(["@vscode/iconv-lite-umd"],r,t)})).encodingExists(w(i))}e.encodingExists=v;function w(i){return i===e.UTF8_with_bom||i===null?e.UTF8:i}e.toNodeEncoding=w;function p(i,o){if(!i||o<e.UTF16be_BOM.length)return null;const r=i.readUInt8(0),t=i.readUInt8(1);if(r===e.UTF16be_BOM[0]&&t===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&t===e.UTF16le_BOM[1])return e.UTF16le;if(o<e.UTF8_BOM.length)return null;const s=i.readUInt8(2);return r===e.UTF8_BOM[0]&&t===e.UTF8_BOM[1]&&s===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=p;const f=["ascii","utf-16","utf-32"];async function E(i){const o=await new Promise((h,S)=>{J(["jschardet"],h,S)}),r=i.slice(0,b),t=m(r.buffer),s=o.detect(t);if(!s||!s.encoding)return null;const l=s.encoding.toLowerCase();return 0<=f.indexOf(l)?null:c(s.encoding)}const g={ibm866:"cp866",big5:"cp950"};function c(i){const o=i.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return g[o]||o}function m(i){let o="";for(let r=0;r<i.length;r++)o+=String.fromCharCode(i[r]);return o}function a(i){switch(i){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const o=i.match(/windows(\d+)/);return o?"windows-"+o[1]:i}}}e.toCanonicalName=a;function d({buffer:i,bytesRead:o},r){let t=p(i,o),s=!1;if(t!==e.UTF16be&&t!==e.UTF16le&&i){let l=!0,h=!0,S=!1;for(let L=0;L<o&&L<T;L++){const F=L%2==1,M=i.readUInt8(L)===0;if(M&&(S=!0),l&&(F&&!M||!F&&M)&&(l=!1),h&&(F&&M||!F&&!M)&&(h=!1),M&&!l&&!h)break}S&&(l?t=e.UTF16le:h?t=e.UTF16be:s=!0)}return r&&!s&&!t&&i?E(i.slice(0,o)).then(l=>({seemsBinary:!1,encoding:l})):{seemsBinary:s,encoding:t}}e.detectEncodingFromBuffer=d,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ie[140],ke([0,1,292,29,139]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class T extends D.TextSearchManager{constructor(y,b,I=n,R="searchProcess"){super(y,b,{readdir:k=>I.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,u.toCanonicalName)(k)},R)}}e.NativeTextSearchManager=T}),define(Ie[293],ke([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class u{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(D){if(D&&this._dragOperations.has(D)){const T=this._dragOperations.get(D);return this._dragOperations.delete(D),T}}addDragOperationTransfer(D,T){this._dragOperations.set(D,T)}getRenderedTreeElement(D){if(this._renderedElements.has(D))return this._renderedElements.get(D)}addRenderedTreeItemElement(D,T){this._renderedElements.set(D,T)}removeRenderedTreeItemElement(D){this._renderedElements.has(D)&&this._renderedElements.delete(D)}}e.TreeviewsService=u}),define(Ie[294],ke([0,1,175,7,22,2,3,6,18,7,11,16,15,21,293,27]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function p(g,c){if((0,R.isString)(g))return{label:g};if(g&&typeof g=="object"&&typeof g.label=="string"){let m;return Array.isArray(g.highlights)&&(m=g.highlights.filter(a=>a.length===2&&typeof a[0]=="number"&&typeof a[1]=="number"),m=m.length?m:void 0),{label:g.label,highlights:m}}}class f{constructor(c,m,a){this._proxy=c,this.commands=m,this.logService=a,this.treeViews=new Map,this.treeDragAndDropService=new v.TreeviewsService;function d(i){return i&&i.$treeViewId&&i.$treeItemHandle}m.registerArgumentProcessor({processArgument:i=>d(i)?this.convertArgument(i):Array.isArray(i)&&i.length>0?i.map(o=>d(o)?this.convertArgument(o):o):i})}registerTreeDataProvider(c,m,a){const d=this.createTreeView(c,{treeDataProvider:m},a);return{dispose:()=>d.dispose()}}createTreeView(c,m,a){if(!m||!m.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=m.dragAndDropController?.dropMimeTypes??[],i=m.dragAndDropController?.dragMimeTypes??[],o=!!m.dragAndDropController?.handleDrag,r=!!m.dragAndDropController?.handleDrop,t=this._proxy.$registerTreeViewDataProvider(c,{showCollapseAll:!!m.showCollapseAll,canSelectMany:!!m.canSelectMany,dropMimeTypes:d,dragMimeTypes:i,hasHandleDrag:o,hasHandleDrop:r}),s=this.createExtHostTreeView(c,m,a);return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get message(){return s.message},set message(l){s.message=l},get title(){return s.title},set title(l){s.title=l},get description(){return s.description},set description(l){s.description=l},get badge(){return(0,w.checkProposedApiEnabled)(a,"badges"),s.badge},set badge(l){(0,w.checkProposedApiEnabled)(a,"badges"),s.badge=l},reveal:(l,h)=>s.reveal(l,h),dispose:async()=>{await t,this.treeViews.delete(c),s.dispose()}}}$getChildren(c,m){const a=this.treeViews.get(c);return a?a.getChildren(m):Promise.reject(new Error((0,u.localize)(0,null,c)))}async $handleDrop(c,m,a,d,i,o,r,t){const s=this.treeViews.get(c);if(!s)return Promise.reject(new Error((0,u.localize)(1,null,c)));const l=_.DataTransfer.toDataTransfer(a,async h=>(await this._proxy.$resolveDropFileData(c,m,h)).buffer);return r===c&&t&&await this.addAdditionalTransferItems(l,s,t,i,o),s.onDrop(l,d,i)}async addAdditionalTransferItems(c,m,a,d,i){const o=this.treeDragAndDropService.removeDragOperationTransfer(i);if(o)(await o)?.forEach((r,t)=>{r&&c.set(t,r)});else if(i&&m.handleDrag){const r=m.handleDrag(a,c,d);this.treeDragAndDropService.addDragOperationTransfer(i,r),await r}return c}async $handleDrag(c,m,a,d){const i=this.treeViews.get(c);if(!i)return Promise.reject(new Error((0,u.localize)(2,null,c)));const o=await this.addAdditionalTransferItems(new n.DataTransfer,i,m,d,a);if(!!o)return _.DataTransfer.toDataTransferDTO(o)}async $hasResolve(c){const m=this.treeViews.get(c);if(!m)throw new Error((0,u.localize)(3,null,c));return m.hasResolve}$resolve(c,m,a){const d=this.treeViews.get(c);if(!d)throw new Error((0,u.localize)(4,null,c));return d.resolveTreeItem(m,a)}$setExpanded(c,m,a){const d=this.treeViews.get(c);if(!d)throw new Error((0,u.localize)(5,null,c));d.setExpanded(m,a)}$setSelection(c,m){const a=this.treeViews.get(c);if(!a)throw new Error((0,u.localize)(6,null,c));a.setSelection(m)}$setVisible(c,m){const a=this.treeViews.get(c);if(!a)throw new Error((0,u.localize)(7,null,c));a.setVisible(m)}createExtHostTreeView(c,m,a){const d=new E(c,m,this._proxy,this.commands.converter,this.logService,a);return this.treeViews.set(c,d),d}convertArgument(c){const m=this.treeViews.get(c.$treeViewId);return m?m.getExtensionElement(c.$treeItemHandle):null}}e.ExtHostTreeViews=f;class E extends y.Disposable{constructor(c,m,a,d,i,o){super();if(this.viewId=c,this.proxy=a,this.commands=d,this.logService=i,this.extension=o,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new P.CancellationTokenSource,o.contributes&&o.contributes.views)for(const s in o.contributes.views)for(const l of o.contributes.views[s])l.id===c&&(this._title=l.name);this.dataProvider=m.treeDataProvider,this.dndController=m.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(s=>this._onDidChangeData.fire({message:!1,element:s})));let r,t;this._register(C.Event.debounce(this._onDidChangeData.event,(s,l)=>(s||(s={message:!1,elements:[]}),l.element!==!1&&(r||(r=new Promise(h=>t=h),this.refreshPromise=this.refreshPromise.then(()=>r)),Array.isArray(l.element)?s.elements.push(...l.element):s.elements.push(l.element)),l.message&&(s.message=!0),s),200,!0)(({message:s,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=t;return r=null,this.refresh(l).then(()=>h())})),s&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(c=>this.getExtensionElement(c)).filter(c=>!(0,R.isUndefinedOrNull)(c))}async getChildren(c){const m=c?this.getExtensionElement(c):void 0;if(c&&!m)return this.logService.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let a=this.getChildrenNodes(c);return a||(a=await this.fetchChildrenNodes(m)),a?a.map(d=>d.item):void 0}getExtensionElement(c){return this.elements.get(c)}reveal(c,m){m=m||{select:!0,focus:!1};const a=(0,R.isUndefinedOrNull)(m.select)?!0:m.select,d=(0,R.isUndefinedOrNull)(m.focus)?!1:m.focus,i=(0,R.isUndefinedOrNull)(m.expand)?!1:m.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.refreshPromise.then(()=>this.resolveUnknownParentChain(c)).then(o=>this.resolveTreeNode(c,o[o.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:o.map(t=>t.item)},{select:a,focus:d,expand:i})),o=>this.logService.error(o)):this.proxy.$reveal(this.viewId,void 0,{select:a,focus:d,expand:i})}get message(){return this._message}set message(c){this._message=c,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(c){this._title=c,this.proxy.$setTitle(this.viewId,c,this._description)}get description(){return this._description}set description(c){this._description=c,this.proxy.$setTitle(this.viewId,this._title,c)}get badge(){return this._badge}set badge(c){this._badge?.value===c?.value&&this._badge?.tooltip===c?.tooltip||(this._badge=_.ViewBadge.from(c),this.proxy.$setBadge(this.viewId,c))}setExpanded(c,m){const a=this.getExtensionElement(c);a&&(m?this._onDidExpandElement.fire(Object.freeze({element:a})):this._onDidCollapseElement.fire(Object.freeze({element:a})))}setSelection(c){(0,k.equals)(this._selectedHandles,c)||(this._selectedHandles=c,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(c){c!==this._visible&&(this._visible=c,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(c,m,a){const d=[];for(const i of c){const o=this.getExtensionElement(i);o&&d.push(o)}if(!(!this.dndController?.handleDrag||d.length===0))return await this.dndController.handleDrag(d,m,a),m}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(c,m,a){const d=m?this.getExtensionElement(m):void 0;if(!(!d&&m||!this.dndController?.handleDrop))return(0,b.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(d,c,a):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(c,m){if(!this.dataProvider.resolveTreeItem)return;const a=this.elements.get(c);if(a){const d=this.nodes.get(a);if(d){const i=await this.dataProvider.resolveTreeItem(d.extensionItem,a,m)??d.extensionItem;return this.validateTreeItem(i),d.item.tooltip=this.getTooltip(i.tooltip),d.item.command=this.getCommand(d.disposableStore,i.command),d.item}}}resolveUnknownParentChain(c){return this.resolveParent(c).then(m=>m?this.resolveUnknownParentChain(m).then(a=>this.resolveTreeNode(m,a[a.length-1]).then(d=>(a.push(d),a))):Promise.resolve([]))}resolveParent(c){const m=this.nodes.get(c);return m?Promise.resolve(m.parent?this.elements.get(m.parent.item.handle):void 0):(0,b.asPromise)(()=>this.dataProvider.getParent(c))}resolveTreeNode(c,m){const a=this.nodes.get(c);return a?Promise.resolve(a):(0,b.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(d=>this.createHandle(c,d,m,!0)).then(d=>this.getChildren(m?m.item.handle:void 0).then(()=>{const i=this.getExtensionElement(d);if(i){const o=this.nodes.get(i);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${d}`)}))}getChildrenNodes(c){if(c){let m;if(typeof c=="string"){const a=this.getExtensionElement(c);m=a?this.nodes.get(a):void 0}else m=c;return m&&m.children||void 0}return this.roots}async fetchChildrenNodes(c){this.clearChildren(c);const m=new P.CancellationTokenSource(this._refreshCancellationSource.token);try{const a=c?this.nodes.get(c):void 0,d=await this.dataProvider.getChildren(c);if(m.token.isCancellationRequested)return;const i=await Promise.all((0,k.coalesce)(d||[]).map(async o=>{const r=await this.dataProvider.getTreeItem(o);return r&&!m.token.isCancellationRequested?this.createAndRegisterTreeNode(o,r,a):null}));return m.token.isCancellationRequested?void 0:(0,k.coalesce)(i)}finally{m.dispose()}}refresh(c){if(c.some(a=>!a))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new P.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const a=this.getHandlesToRefresh(c);if(a.length)return this.refreshHandles(a)}return Promise.resolve(void 0)}getHandlesToRefresh(c){const m=new Set,a=c.map(i=>this.nodes.get(i));for(const i of a)if(i&&!m.has(i.item.handle)){let o=i;for(;o&&o.parent&&a.findIndex(r=>o&&o.parent&&r&&r.item.handle===o.parent.item.handle)===-1;){const r=this.elements.get(o.parent.item.handle);o=r?this.nodes.get(r):void 0}o&&!o.parent&&m.add(i.item.handle)}const d=[];return m.forEach(i=>{const o=this.elements.get(i);if(o){const r=this.nodes.get(o);r&&(!r.parent||!m.has(r.parent.item.handle))&&d.push(i)}}),d}refreshHandles(c){const m={};return Promise.all(c.map(a=>this.refreshNode(a).then(d=>{d&&(m[a]=d.item)}))).then(()=>Object.keys(m).length?this.proxy.$refresh(this.viewId,m):void 0)}refreshNode(c){const m=this.getExtensionElement(c);if(m){const a=this.nodes.get(m);if(a)return this.clearChildren(m),(0,b.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(d=>{if(d){const i=this.createTreeNode(m,d,a.parent);return this.updateNodeCache(m,i,a,a.parent),a.dispose(),i}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(c,m,a){const d=this.createTreeNode(c,m,a);if(m.id&&this.elements.has(d.item.handle))throw new Error((0,u.localize)(8,null,m.id));return this.addNodeToCache(c,d),this.addNodeToParentCache(d,a),d}getTooltip(c){return I.MarkdownString.isMarkdownString(c)?_.MarkdownString.from(c):c}getCommand(c,m){return m?this.commands.toInternal(m,c):void 0}validateTreeItem(c){I.TreeItem.isTreeItem(c)||console.log(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(c,m,a){this.validateTreeItem(m);const d=new y.DisposableStore,i=this.createHandle(c,m,a),o=this.getLightIconPath(m);return{item:{handle:i,parentHandle:a?a.item.handle:void 0,label:p(m.label,this.extension),description:m.description,resourceUri:m.resourceUri,tooltip:this.getTooltip(m.tooltip),command:this.getCommand(d,m.command),contextValue:m.contextValue,icon:o,iconDark:this.getDarkIconPath(m)||o,themeIcon:this.getThemeIcon(m),collapsibleState:(0,R.isUndefinedOrNull)(m.collapsibleState)?I.TreeItemCollapsibleState.None:m.collapsibleState,accessibilityInformation:m.accessibilityInformation},extensionItem:m,parent:a,children:void 0,disposableStore:d,dispose(){d.dispose()}}}getThemeIcon(c){return c.iconPath instanceof I.ThemeIcon?c.iconPath:void 0}createHandle(c,{id:m,label:a,resourceUri:d},i,o){if(m)return`${E.ID_HANDLE_PREFIX}/${m}`;const r=p(a,this.extension),t=i?i.item.handle:E.LABEL_HANDLE_PREFIX;let s=r?r.label:d?(0,D.basename)(d):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const l=this.nodes.has(c)?this.nodes.get(c).item.handle:void 0,h=this.getChildrenNodes(i)||[];let S,L=0;do{if(S=`${t}/${L}:${s}`,o||!this.elements.has(S)||l===S)break;L++}while(L<=h.length);return S}getLightIconPath(c){if(c.iconPath&&!(c.iconPath instanceof I.ThemeIcon))return typeof c.iconPath=="string"||T.URI.isUri(c.iconPath)?this.getIconPath(c.iconPath):this.getIconPath(c.iconPath.light)}getDarkIconPath(c){if(c.iconPath&&!(c.iconPath instanceof I.ThemeIcon)&&c.iconPath.dark)return this.getIconPath(c.iconPath.dark)}getIconPath(c){return T.URI.isUri(c)?c:T.URI.file(c)}addNodeToCache(c,m){this.elements.set(m.item.handle,c),this.nodes.set(c,m)}updateNodeCache(c,m,a,d){this.elements.delete(m.item.handle),this.nodes.delete(c),m.item.handle!==a.item.handle&&this.elements.delete(a.item.handle),this.addNodeToCache(c,m);const i=this.getChildrenNodes(d)||[],o=i.filter(r=>r.item.handle===a.item.handle)[0];o&&i.splice(i.indexOf(o),1,m)}addNodeToParentCache(c,m){m?(m.children||(m.children=[]),m.children.push(c)):(this.roots||(this.roots=[]),this.roots.push(c))}clearChildren(c){if(c){const m=this.nodes.get(c);if(m){if(m.children)for(const a of m.children){const d=this.elements.get(a.item.handle);d&&this.clear(d)}m.children=void 0}}else this.clearAll()}clear(c){const m=this.nodes.get(c);if(m){if(m.children)for(const a of m.children){const d=this.elements.get(a.item.handle);d&&this.clear(d)}this.nodes.delete(c),this.elements.delete(m.item.handle),m.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(c=>c.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}E.LABEL_HANDLE_PREFIX="0",E.ID_HANDLE_PREFIX="1"}),define(Ie[295],ke([0,1,21,12,3,41,2,115,100,148,157,43,5,134,240,239,38,241,33,243,244,245,223,246,54,40,247,248,251,252,253,138,226,257,258,259,91,39,261,294,15,7,264,71,137,32,213,250,123,135,73,75,76,14,65,17,26,254,209,52,68,237,262,70,69,267,265,266,238,46,260,263,90,55,125,255,72,256,10,118,225,207,249,6,27,214,8]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v,w,p,f,E,g,c,m,a,d,i,o,r,t,s,l,h,S,L,F,M,A,B,$,U,X,z,N,V,x,q,te,Y,le,pe,ee,ge,Ee,Pe,Ne,ve,ue,de,we,re,me,Z,se,O,H,K,Q,he,be,ce,De,ye,Be,qe,et,Xe,Oe,ot,ie,oe,G,Ce,Re,We,ze,$e,tt,st){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function lt(nt){const it=nt.get(de.IExtHostInitDataService),ft=nt.get(De.IExtHostFileSystemInfo),Ct=nt.get(K.IExtHostConsumerFileSystem),kt=nt.get(o.IExtHostExtensionService),mt=nt.get(te.IExtHostWorkspace),Dt=nt.get(Xe.IExtHostTelemetry),Ut=nt.get(E.IExtHostConfiguration),Nt=nt.get(ve.IURITransformerService),Ge=nt.get(ue.IExtHostRpcService),Ft=nt.get(B.IExtHostStorage),Lt=nt.get(H.IExtensionStoragePaths),Mt=nt.get(Ne.ILoggerService),pt=nt.get(Ne.ILogService),Pt=nt.get(me.IExtHostTunnelService),Te=nt.get(Z.IExtHostApiDeprecationService),Le=nt.get(q.IExtHostWindow),Se=nt.get(qe.IExtHostSecretState),ne=nt.get(et.IExtHostEditorTabs);Ge.set(_.ExtHostContext.ExtHostFileSystemInfo,ft),Ge.set(_.ExtHostContext.ExtHostLogLevelServiceShape,Mt),Ge.set(_.ExtHostContext.ExtHostWorkspace,mt),Ge.set(_.ExtHostContext.ExtHostConfiguration,Ut),Ge.set(_.ExtHostContext.ExtHostExtensionService,kt),Ge.set(_.ExtHostContext.ExtHostStorage,Ft),Ge.set(_.ExtHostContext.ExtHostTunnelService,Pt),Ge.set(_.ExtHostContext.ExtHostWindow,Le),Ge.set(_.ExtHostContext.ExtHostSecretState,Se),Ge.set(_.ExtHostContext.ExtHostTelemetry,Dt),Ge.set(_.ExtHostContext.ExtHostEditorTabs,ne);const Fe=Ge.set(_.ExtHostContext.ExtHostDecorations,nt.get(ee.IExtHostDecorations)),xe=Ge.set(_.ExtHostContext.ExtHostDocumentsAndEditors,nt.get(i.IExtHostDocumentsAndEditors)),Ye=Ge.set(_.ExtHostContext.ExtHostCommands,nt.get(p.IExtHostCommands)),Je=Ge.set(_.ExtHostContext.ExtHostTerminalService,nt.get($.IExtHostTerminalService)),Qe=Ge.set(_.ExtHostContext.ExtHostDebugService,nt.get(Ee.IExtHostDebugService)),vt=Ge.set(_.ExtHostContext.ExtHostSearch,nt.get(Pe.IExtHostSearch)),Et=Ge.set(_.ExtHostContext.ExtHostTask,nt.get(ge.IExtHostTask)),Tt=Ge.set(_.ExtHostContext.ExtHostOutputService,nt.get(S.IExtHostOutputService)),bt=Ge.set(_.ExtHostContext.ExtHostUrls,new V.ExtHostUrls(Ge)),ht=Ge.set(_.ExtHostContext.ExtHostDocuments,new d.ExtHostDocuments(Ge,xe)),Ot=Ge.set(_.ExtHostContext.ExtHostDocumentContentProviders,new m.ExtHostDocumentContentProvider(Ge,xe,pt)),St=Ge.set(_.ExtHostContext.ExtHostDocumentSaveParticipant,new a.ExtHostDocumentSaveParticipant(pt,ht,Ge.getProxy(_.MainContext.MainThreadBulkEdits))),wt=Ge.set(_.ExtHostContext.ExtHostNotebook,new we.ExtHostNotebookController(Ge,Ye,xe,ht,Lt)),Kt=Ge.set(_.ExtHostContext.ExtHostNotebookDocuments,new Re.ExtHostNotebookDocuments(wt)),Xt=Ge.set(_.ExtHostContext.ExtHostNotebookEditors,new Ce.ExtHostNotebookEditors(pt,wt)),xt=Ge.set(_.ExtHostContext.ExtHostNotebookKernels,new Oe.ExtHostNotebookKernels(Ge,it,wt,Ye,pt)),Vt=Ge.set(_.ExtHostContext.ExtHostNotebookRenderers,new ie.ExtHostNotebookRenderers(Ge,wt)),At=Ge.set(_.ExtHostContext.ExtHostEditors,new U.ExtHostEditors(Ge,xe)),Sn=Ge.set(_.ExtHostContext.ExtHostTreeViews,new X.ExtHostTreeViews(Ge.getProxy(_.MainContext.MainThreadTreeViews),Ye,pt)),fn=Ge.set(_.ExtHostContext.ExtHostEditorInsets,new Y.ExtHostEditorInsets(Ge.getProxy(_.MainContext.MainThreadEditorInsets),At,it.remote)),zt=Ge.set(_.ExtHostContext.ExtHostDiagnostics,new g.ExtHostDiagnostics(Ge,pt,ft)),en=Ge.set(_.ExtHostContext.ExtHostLanguages,new l.ExtHostLanguages(Ge,ht,Ye.converter,Nt)),dt=Ge.set(_.ExtHostContext.ExtHostLanguageFeatures,new s.ExtHostLanguageFeatures(Ge,Nt,ht,Ye,zt,pt,Te)),mn=Ge.set(_.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(Ge,dt)),Wt=Ge.set(_.ExtHostContext.ExtHostFileSystemEventService,new t.ExtHostFileSystemEventService(Ge,pt,xe)),Qt=Ge.set(_.ExtHostContext.ExtHostQuickOpen,(0,F.createExtHostQuickOpen)(Ge,mt,Ye)),sn=Ge.set(_.ExtHostContext.ExtHostSCM,new M.ExtHostSCM(Ge,Ye,pt)),gn=Ge.set(_.ExtHostContext.ExtHostComments,(0,f.createExtHostComments)(Ge,Ye,ht)),on=Ge.set(_.ExtHostContext.ExtHostProgress,new L.ExtHostProgress(Ge.getProxy(_.MainContext.MainThreadProgress))),Tn=Ge.set(_.ExtHostContext.ExtHosLabelService,new le.ExtHostLabelService(Ge)),yn=Ge.set(_.ExtHostContext.ExtHostTheming,new re.ExtHostTheming(Ge)),tn=Ge.set(_.ExtHostContext.ExtHostAuthentication,new se.ExtHostAuthentication(Ge)),pn=Ge.set(_.ExtHostContext.ExtHostTimeline,new O.ExtHostTimeline(Ge,Ye)),nn=Ge.set(_.ExtHostContext.ExtHostWebviews,new x.ExtHostWebviews(Ge,it.remote,mt,pt,Te)),rn=Ge.set(_.ExtHostContext.ExtHostWebviewPanels,new be.ExtHostWebviewPanels(Ge,nn,mt)),An=Ge.set(_.ExtHostContext.ExtHostCustomEditors,new he.ExtHostCustomEditors(Ge,ht,Lt,nn,rn)),vn=Ge.set(_.ExtHostContext.ExtHostWebviewViews,new Q.ExtHostWebviewViews(Ge,nn)),Yt=Ge.set(_.ExtHostContext.ExtHostTesting,new ye.ExtHostTesting(Ge,Ye)),Rn=Ge.set(_.ExtHostContext.ExtHostUriOpeners,new Be.ExtHostUriOpeners(Ge));Ge.set(_.ExtHostContext.ExtHostInteractive,new We.ExtHostInteractive(Ge,wt,xe,Ye,pt));const Ln=Object.values(_.ExtHostContext);Ge.assertRegistered(Ln);const On=new ce.ExtHostBulkEdits(Ge,xe),Nn=new w.ExtHostClipboard(Ge),wn=new h.ExtHostMessageService(Ge,pt),Cn=new c.ExtHostDialogs(Ge),an=new A.ExtHostStatusBar(Ge,Ye.converter);return v.ExtHostApiCommands.register(Ye),function(He,jt,Dn){const gt=function(){let fe=!He.isUnderDevelopment;function _e(){fe||(pt.info(`Extension '${He.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),fe=!0)}return function Ue(at){if(Array.isArray(at))at.forEach(Ue);else if(typeof at=="string")_e();else{const _t=at;typeof _t.scheme=="undefined"&&_e(),typeof _t.exclusive=="boolean"&&(0,$e.checkProposedApiEnabled)(He,"documentFiltersExclusive")}return at}}(),cn={getSession(fe,_e,Ue){return tn.getSession(He,fe,_e,Ue)},async hasSession(fe,_e){return(0,$e.checkProposedApiEnabled)(He,"authSession"),!!await tn.getSession(He,fe,_e,{silent:!0})},get onDidChangeSessions(){return tn.onDidChangeSessions},registerAuthenticationProvider(fe,_e,Ue,at){return tn.registerAuthenticationProvider(fe,_e,Ue,at)}},Fn={registerCommand(fe,_e,Ue){return Ye.registerCommand(!0,fe,_e,Ue,void 0,He)},registerTextEditorCommand(fe,_e,Ue){return Ye.registerCommand(!0,fe,(...at)=>{const _t=At.getActiveTextEditor();if(!_t){pt.warn("Cannot execute "+fe+" because there is no active text editor.");return}return _t.edit(It=>{_e.apply(Ue,[_t,It,...at])}).then(It=>{It||pt.warn("Edits from command "+fe+" were not applied.")},It=>{pt.warn("An error occurred while running command "+fe,It)})},void 0,void 0,He)},registerDiffInformationCommand:(fe,_e,Ue)=>((0,$e.checkProposedApiEnabled)(He,"diffCommand"),Ye.registerCommand(!0,fe,async(...at)=>{const _t=xe.activeEditor(!0);if(!_t){pt.warn("Cannot execute "+fe+" because there is no active text editor.");return}const It=await At.getDiffInformation(_t.id);_e.apply(Ue,[It,...at])},void 0,void 0,He)),executeCommand(fe,..._e){return Ye.executeCommand(fe,..._e)},getCommands(fe=!1){return Ye.getCommands(fe)}},In={get machineId(){return it.telemetryInfo.machineId},get sessionId(){return it.telemetryInfo.sessionId},get language(){return it.environment.appLanguage},get appName(){return it.environment.appName},get appRoot(){return it.environment.appRoot?.fsPath??""},get appHost(){return it.environment.appHost},get uriScheme(){return it.environment.appUriScheme},get clipboard(){return Nn.value},get shell(){return Je.getDefaultShell(!1)},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,$e.checkProposedApiEnabled)(He,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,$e.checkProposedApiEnabled)(He,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const fe=Date.now()-new Date(it.telemetryInfo.firstSessionDate).getTime();return isNaN(fe)?!1:fe<1e3*60*60*24},openExternal(fe,_e){return Le.openUri(fe,{allowTunneling:!!it.remote.authority,allowContributedOpeners:_e?.allowContributedOpeners})},async asExternalUri(fe){if(fe.scheme===it.environment.appUriScheme)return bt.createAppUri(fe);try{return await Le.asExternalUri(fe,{allowTunneling:!!it.remote.authority})}catch(_e){if((0,G.matchesScheme)(fe,oe.Schemas.http)||(0,G.matchesScheme)(fe,oe.Schemas.https))return fe;throw _e}},get remoteName(){return(0,pe.getRemoteName)(it.remote.authority)},get remoteAuthority(){return(0,$e.checkProposedApiEnabled)(He,"resolvers"),it.remote.authority},get uiKind(){return it.uiKind}};it.environment.extensionTestsLocationURI||Object.freeze(In);const Mn={createTestController(fe,_e,Ue){return Yt.createTestController(fe,_e,Ue)},createTestObserver(){return(0,$e.checkProposedApiEnabled)(He,"testObserver"),Yt.createTestObserver()},runTests(fe){return(0,$e.checkProposedApiEnabled)(He,"testObserver"),Yt.runTests(fe)},get onDidChangeTestResults(){return(0,$e.checkProposedApiEnabled)(He,"testObserver"),Yt.onResultsChanged},get testResults(){return(0,$e.checkProposedApiEnabled)(He,"testObserver"),Yt.results}},ln=it.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,bn={getExtension(fe,_e){(0,st.equalsIgnoreCase)(fe,"ms-vscode.references-view")&&(Te.report("The extension 'ms-vscode.references-view' has been renamed.",He,"Use 'vscode.references-view' instead."),fe="vscode.references-view"),(0,$e.isProposedApiEnabled)(He,"extensionsAny")||(_e=!1);const Ue=jt.mine.getExtensionDescription(fe);if(Ue)return new o.Extension(kt,He.identifier,Ue,ln,!1);if(_e){const at=jt.all.getExtensionDescription(fe);if(at)return new o.Extension(kt,He.identifier,at,ln,!0)}},get all(){const fe=[];for(const _e of jt.mine.getAllExtensionDescriptions())fe.push(new o.Extension(kt,He.identifier,_e,ln,!1));return fe},get allAcrossExtensionHosts(){(0,$e.checkProposedApiEnabled)(He,"extensionsAny");const fe=new $e.ExtensionIdentifierSet(jt.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),_e=[];for(const Ue of jt.all.getAllExtensionDescriptions()){const at=!fe.has(Ue.identifier);_e.push(new o.Extension(kt,He.identifier,Ue,ln,at))}return _e},get onDidChange(){return(0,$e.isProposedApiEnabled)(He,"extensionsAny")?D.Event.any(jt.mine.onDidChange,jt.all.onDidChange):jt.mine.onDidChange}},Un={createDiagnosticCollection(fe){return zt.createDiagnosticCollection(He.identifier,fe)},get onDidChangeDiagnostics(){return zt.onDidChangeDiagnostics},getDiagnostics:fe=>zt.getDiagnostics(fe),getLanguages(){return en.getLanguages()},setTextDocumentLanguage(fe,_e){return en.changeLanguage(fe.uri,_e)},match(fe,_e){const Ue=ht.getDocumentData(_e.uri)?.notebook;return(0,R.score)(z.LanguageSelector.from(fe),_e.uri,_e.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(fe,_e,Ue){return dt.registerCodeActionProvider(He,gt(fe),_e,Ue)},registerDocumentPasteEditProvider(fe,_e,Ue){return(0,$e.checkProposedApiEnabled)(He,"documentPaste"),dt.registerDocumentPasteEditProvider(He,gt(fe),_e,Ue)},registerCodeLensProvider(fe,_e){return dt.registerCodeLensProvider(He,gt(fe),_e)},registerDefinitionProvider(fe,_e){return dt.registerDefinitionProvider(He,gt(fe),_e)},registerDeclarationProvider(fe,_e){return dt.registerDeclarationProvider(He,gt(fe),_e)},registerImplementationProvider(fe,_e){return dt.registerImplementationProvider(He,gt(fe),_e)},registerTypeDefinitionProvider(fe,_e){return dt.registerTypeDefinitionProvider(He,gt(fe),_e)},registerHoverProvider(fe,_e){return dt.registerHoverProvider(He,gt(fe),_e,He.identifier)},registerEvaluatableExpressionProvider(fe,_e){return dt.registerEvaluatableExpressionProvider(He,gt(fe),_e,He.identifier)},registerInlineValuesProvider(fe,_e){return dt.registerInlineValuesProvider(He,gt(fe),_e,He.identifier)},registerDocumentHighlightProvider(fe,_e){return dt.registerDocumentHighlightProvider(He,gt(fe),_e)},registerLinkedEditingRangeProvider(fe,_e){return dt.registerLinkedEditingRangeProvider(He,gt(fe),_e)},registerReferenceProvider(fe,_e){return dt.registerReferenceProvider(He,gt(fe),_e)},registerRenameProvider(fe,_e){return dt.registerRenameProvider(He,gt(fe),_e)},registerDocumentSymbolProvider(fe,_e,Ue){return dt.registerDocumentSymbolProvider(He,gt(fe),_e,Ue)},registerWorkspaceSymbolProvider(fe){return dt.registerWorkspaceSymbolProvider(He,fe)},registerDocumentFormattingEditProvider(fe,_e){return dt.registerDocumentFormattingEditProvider(He,gt(fe),_e)},registerDocumentRangeFormattingEditProvider(fe,_e){return dt.registerDocumentRangeFormattingEditProvider(He,gt(fe),_e)},registerOnTypeFormattingEditProvider(fe,_e,Ue,...at){return dt.registerOnTypeFormattingEditProvider(He,gt(fe),_e,[Ue].concat(at))},registerDocumentSemanticTokensProvider(fe,_e,Ue){return dt.registerDocumentSemanticTokensProvider(He,gt(fe),_e,Ue)},registerDocumentRangeSemanticTokensProvider(fe,_e,Ue){return dt.registerDocumentRangeSemanticTokensProvider(He,gt(fe),_e,Ue)},registerSignatureHelpProvider(fe,_e,Ue,...at){return typeof Ue=="object"?dt.registerSignatureHelpProvider(He,gt(fe),_e,Ue):dt.registerSignatureHelpProvider(He,gt(fe),_e,typeof Ue=="undefined"?[]:[Ue,...at])},registerCompletionItemProvider(fe,_e,...Ue){return dt.registerCompletionItemProvider(He,gt(fe),_e,Ue)},registerInlineCompletionItemProvider(fe,_e){return _e.handleDidShowCompletionItem&&(0,$e.checkProposedApiEnabled)(He,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(He,gt(fe),_e)},registerInlineCompletionItemProviderNew(fe,_e){if((0,$e.checkProposedApiEnabled)(He,"inlineCompletionsNew"),_e.handleDidShowCompletionItem&&!(0,$e.isProposedApiEnabled)(He,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return dt.registerInlineCompletionsProviderNew(He,gt(fe),_e)},registerDocumentLinkProvider(fe,_e){return dt.registerDocumentLinkProvider(He,gt(fe),_e)},registerColorProvider(fe,_e){return dt.registerColorProvider(He,gt(fe),_e)},registerFoldingRangeProvider(fe,_e){return dt.registerFoldingRangeProvider(He,gt(fe),_e)},registerSelectionRangeProvider(fe,_e){return dt.registerSelectionRangeProvider(He,fe,_e)},registerCallHierarchyProvider(fe,_e){return dt.registerCallHierarchyProvider(He,fe,_e)},registerTypeHierarchyProvider(fe,_e){return dt.registerTypeHierarchyProvider(He,fe,_e)},setLanguageConfiguration:(fe,_e)=>dt.setLanguageConfiguration(He,fe,_e),getTokenInformationAtPosition(fe,_e){return(0,$e.checkProposedApiEnabled)(He,"tokenInformation"),en.tokenAtPosition(fe,_e)},registerInlayHintsProvider(fe,_e){return dt.registerInlayHintsProvider(He,fe,_e)},createLanguageStatusItem(fe,_e){return en.createLanguageStatusItem(He,fe,_e)},registerDocumentDropEditProvider(fe,_e){return dt.registerDocumentOnDropEditProvider(He,fe,_e)}},$t={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return Je.activeTerminal},get terminals(){return Je.terminals},async showTextDocument(fe,_e,Ue){const at=await(C.URI.isUri(fe)?Promise.resolve(qt.openTextDocument(fe)):Promise.resolve(fe));return At.showTextDocument(at,_e,Ue)},createTextEditorDecorationType(fe){return At.createTextEditorDecorationType(He,fe)},onDidChangeActiveTextEditor(fe,_e,Ue){return At.onDidChangeActiveTextEditor(fe,_e,Ue)},onDidChangeVisibleTextEditors(fe,_e,Ue){return At.onDidChangeVisibleTextEditors(fe,_e,Ue)},onDidChangeTextEditorSelection(fe,_e,Ue){return At.onDidChangeTextEditorSelection(fe,_e,Ue)},onDidChangeTextEditorOptions(fe,_e,Ue){return At.onDidChangeTextEditorOptions(fe,_e,Ue)},onDidChangeTextEditorVisibleRanges(fe,_e,Ue){return At.onDidChangeTextEditorVisibleRanges(fe,_e,Ue)},onDidChangeTextEditorViewColumn(fe,_e,Ue){return At.onDidChangeTextEditorViewColumn(fe,_e,Ue)},onDidCloseTerminal(fe,_e,Ue){return Je.onDidCloseTerminal(fe,_e,Ue)},onDidOpenTerminal(fe,_e,Ue){return Je.onDidOpenTerminal(fe,_e,Ue)},onDidChangeActiveTerminal(fe,_e,Ue){return Je.onDidChangeActiveTerminal(fe,_e,Ue)},onDidChangeTerminalDimensions(fe,_e,Ue){return(0,$e.checkProposedApiEnabled)(He,"terminalDimensions"),Je.onDidChangeTerminalDimensions(fe,_e,Ue)},onDidChangeTerminalState(fe,_e,Ue){return Je.onDidChangeTerminalState(fe,_e,Ue)},onDidWriteTerminalData(fe,_e,Ue){return(0,$e.checkProposedApiEnabled)(He,"terminalDataWriteEvent"),Je.onDidWriteTerminalData(fe,_e,Ue)},get state(){return Le.state},onDidChangeWindowState(fe,_e,Ue){return Le.onDidChangeWindowState(fe,_e,Ue)},showInformationMessage(fe,..._e){return wn.showMessage(He,T.default.Info,fe,_e[0],_e.slice(1))},showWarningMessage(fe,..._e){return wn.showMessage(He,T.default.Warning,fe,_e[0],_e.slice(1))},showErrorMessage(fe,..._e){return wn.showMessage(He,T.default.Error,fe,_e[0],_e.slice(1))},showQuickPick(fe,_e,Ue){return Qt.showQuickPick(fe,_e,Ue)},showWorkspaceFolderPick(fe){return Qt.showWorkspaceFolderPick(fe)},showInputBox(fe,_e){return Qt.showInput(fe,_e)},showOpenDialog(fe){return Cn.showOpenDialog(fe)},showSaveDialog(fe){return Cn.showSaveDialog(fe)},createStatusBarItem(fe,_e,Ue){let at,_t,It;return typeof fe=="string"?(at=fe,_t=_e,It=Ue):(_t=fe,It=_e),an.createStatusBarEntry(He,at,_t,It)},setStatusBarMessage(fe,_e){return an.setStatusBarMessage(fe,_e)},withScmProgress(fe){return Te.report("window.withScmProgress",He,"Use 'withProgress' instead."),on.withProgress(He,{location:N.ProgressLocation.SourceControl},(_e,Ue)=>fe({report(at){}}))},withProgress(fe,_e){return on.withProgress(He,fe,_e)},createOutputChannel(fe,_e){return Tt.createOutputChannel(fe,_e,He)},createWebviewPanel(fe,_e,Ue,at){return rn.createWebviewPanel(He,fe,_e,Ue,at)},createWebviewTextEditorInset(fe,_e,Ue,at){return(0,$e.checkProposedApiEnabled)(He,"editorInsets"),fn.createWebviewEditorInset(fe,_e,Ue,at,He)},createTerminal(fe,_e,Ue){return typeof fe=="object"?"pty"in fe?Je.createExtensionTerminal(fe):Je.createTerminalFromOptions(fe):Je.createTerminal(fe,_e,Ue)},registerTerminalLinkProvider(fe){return Je.registerLinkProvider(fe)},registerTerminalProfileProvider(fe,_e){return Je.registerProfileProvider(He,fe,_e)},registerTreeDataProvider(fe,_e){return Sn.registerTreeDataProvider(fe,_e,He)},createTreeView(fe,_e){return Sn.createTreeView(fe,_e,He)},registerWebviewPanelSerializer:(fe,_e)=>rn.registerWebviewPanelSerializer(He,fe,_e),registerCustomEditorProvider:(fe,_e,Ue={})=>An.registerCustomEditorProvider(He,fe,_e,Ue),registerFileDecorationProvider(fe){return Fe.registerFileDecorationProvider(fe,He.identifier)},registerUriHandler(fe){return bt.registerUriHandler(He.identifier,fe)},createQuickPick(){return Qt.createQuickPick(He)},createInputBox(){return Qt.createInputBox(He)},get activeColorTheme(){return yn.activeColorTheme},onDidChangeActiveColorTheme(fe,_e,Ue){return yn.onDidChangeActiveColorTheme(fe,_e,Ue)},registerWebviewViewProvider(fe,_e,Ue){return vn.registerWebviewViewProvider(He,fe,_e,Ue?.webviewOptions)},get activeNotebookEditor(){return wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(fe,_e,Ue){return wt.onDidChangeActiveNotebookEditor(fe,_e,Ue)},get visibleNotebookEditors(){return wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(fe,_e,Ue){return Xt.onDidChangeNotebookEditorSelection(fe,_e,Ue)},onDidChangeNotebookEditorVisibleRanges(fe,_e,Ue){return Xt.onDidChangeNotebookEditorVisibleRanges(fe,_e,Ue)},showNotebookDocument(fe,_e){return C.URI.isUri(fe)&&Te.report("window.showNotebookDocument(uri)",He,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),wt.showNotebookDocument(fe,_e)},registerExternalUriOpener(fe,_e,Ue){return(0,$e.checkProposedApiEnabled)(He,"externalUriOpener"),Rn.registerExternalUriOpener(He.identifier,fe,_e,Ue)},get tabGroups(){return ne.tabGroups}},qt={get rootPath(){return Te.report("workspace.rootPath",He,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(fe){throw n.readonly()},getWorkspaceFolder(fe){return mt.getWorkspaceFolder(fe)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(fe){throw n.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(fe){throw n.readonly()},updateWorkspaceFolders:(fe,_e,...Ue)=>mt.updateWorkspaceFolders(He,fe,_e||0,...Ue),onDidChangeWorkspaceFolders:function(fe,_e,Ue){return mt.onDidChangeWorkspace(fe,_e,Ue)},asRelativePath:(fe,_e)=>mt.getRelativePath(fe,_e),findFiles:(fe,_e,Ue,at)=>mt.findFiles(fe,_e,Ue,He.identifier,at),findTextInFiles:(fe,_e,Ue,at)=>{(0,$e.checkProposedApiEnabled)(He,"findTextInFiles");let _t,It;return typeof _e=="object"?(_t=_e,It=Ue):(_t={},It=_e,at=Ue),mt.findTextInFiles(fe,_t||{},It,He.identifier,at)},saveAll:fe=>mt.saveAll(fe),applyEdit(fe){return On.applyWorkspaceEdit(fe,He)},createFileSystemWatcher:(fe,_e,Ue,at)=>Wt.createFileSystemWatcher(mt,He,fe,_e,Ue,at),get textDocuments(){return ht.getAllDocumentData().map(fe=>fe.document)},set textDocuments(fe){throw n.readonly()},openTextDocument(fe){let _e;const Ue=fe;if(typeof fe=="string")_e=Promise.resolve(C.URI.file(fe));else if(C.URI.isUri(fe))_e=Promise.resolve(fe);else if(!Ue||typeof Ue=="object")_e=ht.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return _e.then(at=>ht.ensureDocumentData(at).then(_t=>_t.document))},onDidOpenTextDocument:(fe,_e,Ue)=>ht.onDidAddDocument(fe,_e,Ue),onDidCloseTextDocument:(fe,_e,Ue)=>ht.onDidRemoveDocument(fe,_e,Ue),onDidChangeTextDocument:(fe,_e,Ue)=>ht.onDidChangeDocument(fe,_e,Ue),onDidSaveTextDocument:(fe,_e,Ue)=>ht.onDidSaveDocument(fe,_e,Ue),onWillSaveTextDocument:(fe,_e,Ue)=>St.getOnWillSaveTextDocumentEvent(He)(fe,_e,Ue),get notebookDocuments(){return wt.notebookDocuments.map(fe=>fe.apiNotebook)},async openNotebookDocument(fe,_e){let Ue;if(C.URI.isUri(fe))Ue=fe,await wt.openNotebookDocument(fe);else if(typeof fe=="string")Ue=C.URI.revive(await wt.createNotebookDocument({viewType:fe,content:_e}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(fe,_e,Ue){return Kt.onDidSaveNotebookDocument(fe,_e,Ue)},onDidChangeNotebookDocument(fe,_e,Ue){return Kt.onDidChangeNotebookDocument(fe,_e,Ue)},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(fe,_e,Ue,at){return wt.registerNotebookSerializer(He,fe,_e,Ue,(0,$e.isProposedApiEnabled)(He,"notebookLiveShare")?at:void 0)},registerNotebookContentProvider:(fe,_e,Ue,at)=>((0,$e.checkProposedApiEnabled)(He,"notebookContentProvider"),Te.report("workspace.registerNotebookContentProvider",He,"The notebookContentProvider API is not on track for finalization and will be removed."),wt.registerNotebookContentProvider(He,fe,_e,Ue,(0,$e.isProposedApiEnabled)(He,"notebookLiveShare")?at:void 0)),onDidChangeConfiguration:(fe,_e,Ue)=>Dn.onDidChangeConfiguration(fe,_e,Ue),getConfiguration(fe,_e){return _e=arguments.length===1?void 0:_e,Dn.getConfiguration(fe,_e,He)},registerTextDocumentContentProvider(fe,_e){return Ot.registerTextDocumentContentProvider(fe,_e)},registerTaskProvider:(fe,_e)=>(Te.report("window.registerTaskProvider",He,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(He,fe,_e)),registerFileSystemProvider(fe,_e,Ue){return(0,ze.combinedDisposable)(mn.registerFileSystemProvider(He,fe,_e,Ue),Ct.addFileSystemProvider(fe,_e))},get fs(){return Ct.value},registerFileSearchProvider:(fe,_e)=>((0,$e.checkProposedApiEnabled)(He,"fileSearchProvider"),vt.registerFileSearchProvider(fe,_e)),registerTextSearchProvider:(fe,_e)=>((0,$e.checkProposedApiEnabled)(He,"textSearchProvider"),vt.registerTextSearchProvider(fe,_e)),registerRemoteAuthorityResolver:(fe,_e)=>((0,$e.checkProposedApiEnabled)(He,"resolvers"),kt.registerRemoteAuthorityResolver(fe,_e)),registerResourceLabelFormatter:fe=>((0,$e.checkProposedApiEnabled)(He,"resolvers"),Tn.$registerResourceLabelFormatter(fe)),onDidCreateFiles:(fe,_e,Ue)=>Wt.onDidCreateFile(fe,_e,Ue),onDidDeleteFiles:(fe,_e,Ue)=>Wt.onDidDeleteFile(fe,_e,Ue),onDidRenameFiles:(fe,_e,Ue)=>Wt.onDidRenameFile(fe,_e,Ue),onWillCreateFiles:(fe,_e,Ue)=>Wt.getOnWillCreateFileEvent(He)(fe,_e,Ue),onWillDeleteFiles:(fe,_e,Ue)=>Wt.getOnWillDeleteFileEvent(He)(fe,_e,Ue),onWillRenameFiles:(fe,_e,Ue)=>Wt.getOnWillRenameFileEvent(He)(fe,_e,Ue),openTunnel:fe=>((0,$e.checkProposedApiEnabled)(He,"resolvers"),Pt.openTunnel(He,fe).then(_e=>{if(!_e)throw new Error("cannot open tunnel");return _e})),get tunnels(){return(0,$e.checkProposedApiEnabled)(He,"resolvers"),Pt.getTunnels()},onDidChangeTunnels:(fe,_e,Ue)=>((0,$e.checkProposedApiEnabled)(He,"resolvers"),Pt.onDidChangeTunnels(fe,_e,Ue)),registerPortAttributesProvider:(fe,_e)=>((0,$e.checkProposedApiEnabled)(He,"portsAttributes"),Pt.registerPortsAttributesProvider(fe,_e)),registerTimelineProvider:(fe,_e)=>((0,$e.checkProposedApiEnabled)(He,"timeline"),pn.registerTimelineProvider(fe,_e,He.identifier,Ye.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:fe=>((0,$e.checkProposedApiEnabled)(He,"workspaceTrust"),mt.requestWorkspaceTrust(fe)),onDidGrantWorkspaceTrust:(fe,_e,Ue)=>mt.onDidGrantWorkspaceTrust(fe,_e,Ue)},Bn={get inputBox(){return Te.report("scm.inputBox",He,"Use 'SourceControl.inputBox' instead"),sn.getLastInputBox(He)},createSourceControl(fe,_e,Ue){return sn.createSourceControl(He,fe,_e,Ue)}},Bt={createCommentController(fe,_e){return gn.createCommentController(He,fe,_e)}},un={get activeDebugSession(){return Qe.activeDebugSession},get activeDebugConsole(){return Qe.activeDebugConsole},get breakpoints(){return Qe.breakpoints},onDidStartDebugSession(fe,_e,Ue){return Qe.onDidStartDebugSession(fe,_e,Ue)},onDidTerminateDebugSession(fe,_e,Ue){return Qe.onDidTerminateDebugSession(fe,_e,Ue)},onDidChangeActiveDebugSession(fe,_e,Ue){return Qe.onDidChangeActiveDebugSession(fe,_e,Ue)},onDidReceiveDebugSessionCustomEvent(fe,_e,Ue){return Qe.onDidReceiveDebugSessionCustomEvent(fe,_e,Ue)},onDidChangeBreakpoints(fe,_e,Ue){return Qe.onDidChangeBreakpoints(fe,_e,Ue)},registerDebugConfigurationProvider(fe,_e,Ue){return Qe.registerDebugConfigurationProvider(fe,_e,Ue||tt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(fe,_e){return Qe.registerDebugAdapterDescriptorFactory(He,fe,_e)},registerDebugAdapterTrackerFactory(fe,_e){return Qe.registerDebugAdapterTrackerFactory(fe,_e)},startDebugging(fe,_e,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?Qe.startDebugging(fe,_e,{parentSession:Ue}):Qe.startDebugging(fe,_e,Ue||{})},stopDebugging(fe){return Qe.stopDebugging(fe)},addBreakpoints(fe){return Qe.addBreakpoints(fe)},removeBreakpoints(fe){return Qe.removeBreakpoints(fe)},asDebugSourceUri(fe,_e){return Qe.asDebugSourceUri(fe,_e)}},zn={registerTaskProvider:(fe,_e)=>Et.registerTaskProvider(He,fe,_e),fetchTasks:fe=>Et.fetchTasks(fe),executeTask:fe=>Et.executeTask(He,fe),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(fe,_e,Ue)=>Et.onDidStartTask(fe,_e,Ue),onDidEndTask:(fe,_e,Ue)=>Et.onDidEndTask(fe,_e,Ue),onDidStartTaskProcess:(fe,_e,Ue)=>Et.onDidStartTaskProcess(fe,_e,Ue),onDidEndTaskProcess:(fe,_e,Ue)=>Et.onDidEndTaskProcess(fe,_e,Ue)},Wn={createNotebookController(fe,_e,Ue,at,_t){return xt.createNotebookController(He,fe,_e,Ue,at,(0,$e.isProposedApiEnabled)(He,"notebookMessaging")?_t:void 0)},registerNotebookCellStatusBarItemProvider:(fe,_e)=>wt.registerNotebookCellStatusBarItemProvider(He,fe,_e),createRendererMessaging(fe){return Vt.createRendererMessaging(He,fe)},onDidChangeNotebookCellExecutionState(fe,_e,Ue){return(0,$e.checkProposedApiEnabled)(He,"notebookCellExecutionState"),xt.onDidChangeNotebookCellExecutionState(fe,_e,Ue)}};return{version:it.version,authentication:cn,commands:Fn,comments:Bt,debug:un,env:In,extensions:bn,languages:Un,notebooks:Wn,scm:Bn,tasks:zn,tests:Mn,window:$t,workspace:qt,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:n.CancellationError,CancellationTokenSource:u.CancellationTokenSource,CandidatePortSource:_.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CommentThreadState:N.CommentThreadState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:tt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:N.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:N.InlineCompletionTriggerKindNew,EventEmitter:D.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,InlineCompletionItem:N.InlineSuggestion,InlineCompletionItemNew:N.InlineSuggestionNew,InlineCompletionList:N.InlineSuggestionList,InlineCompletionListNew:N.InlineSuggestionsNew,Hover:N.Hover,IndentAction:I.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:b.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TerminalLink:N.TerminalLink,TerminalLocation:N.TerminalLocation,TerminalProfile:N.TerminalProfile,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,TextDocumentChangeReason:N.TextDocumentChangeReason,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,TypeHierarchyItem:N.TypeHierarchyItem,UIKind:P.UIKind,Uri:C.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,DocumentDropEdit:N.DocumentDropEdit,DocumentPasteEdit:N.DocumentPasteEdit,InlayHint:N.InlayHint,InlayHintLabelPart:N.InlayHintLabelPart,InlayHintKind:N.InlayHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookRendererScript:N.NotebookRendererScript,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,NotebookControllerAffinity:N.NotebookControllerAffinity,NotebookEdit:N.NotebookEdit,PortAttributes:N.PortAttributes,LinkedEditingRanges:N.LinkedEditingRanges,TestResultState:N.TestResultState,TestRunRequest:N.TestRunRequest,TestMessage:N.TestMessage,TestTag:N.TestTag,TestRunProfileKind:N.TestRunProfileKind,TextSearchCompleteMessageType:ot.TextSearchCompleteMessageType,DataTransfer:N.DataTransfer,DataTransferItem:N.DataTransferItem,CoveredCount:N.CoveredCount,FileCoverage:N.FileCoverage,StatementCoverage:N.StatementCoverage,BranchCoverage:N.BranchCoverage,FunctionCoverage:N.FunctionCoverage,WorkspaceTrustState:N.WorkspaceTrustState,LanguageStatusSeverity:N.LanguageStatusSeverity,QuickPickItemKind:N.QuickPickItemKind,InputBoxValidationSeverity:N.InputBoxValidationSeverity,TabInputText:N.TextTabInput,TabInputTextDiff:N.TextDiffTabInput,TabInputTextMerge:N.TextMergeTabInput,TabInputCustom:N.CustomEditorTabInput,TabInputNotebook:N.NotebookEditorTabInput,TabInputNotebookDiff:N.NotebookDiffEditorTabInput,TabInputWebview:N.WebviewEditorTabInput,TabInputTerminal:N.TerminalEditorTabInput,TabInputInteractiveWindow:N.InteractiveWindowInput,TerminalExitReason:N.TerminalExitReason}}}e.createApiFactoryAndRegisterActors=lt}),define(Ie[296],ke([0,1,269,306,307,2,308]),function(J,e,u,n,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function y(k,_,P,v,w,p){const f=p.environment.useHostProxy,E=typeof f=="boolean"?f:!p.remote.isRemote,g=(0,C.createProxyResolver)({resolveProxy:m=>k.resolveProxy(m),getHttpProxySetting:()=>_.getConfiguration("http").get("proxy"),log:(m,a,...d)=>{switch(m){case C.LogLevel.Trace:v.trace(a,...d);break;case C.LogLevel.Debug:v.debug(a,...d);break;case C.LogLevel.Info:v.info(a,...d);break;case C.LogLevel.Warning:v.warn(a,...d);break;case C.LogLevel.Error:v.error(a,...d);break;case C.LogLevel.Critical:v.critical(a,...d);break;case C.LogLevel.Off:break;default:i(m,a,d);break}function i(o,r,...t){v.error("Unknown log level",o),v.error(r,...t)}},getLogLevel:()=>v.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:E,env:process.env}),c=b(_,g);return R(P,c)}e.connectProxyResolver=y;function b(k,_){const P={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(w=>{P.config=k.getConfiguration("http").get("proxySupport")||"off"});const v={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(w=>{v.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},u,(0,C.createHttpPatch)(u,_,{config:"off"},v,!0)),on:Object.assign({},u,(0,C.createHttpPatch)(u,_,{config:"on"},v,!0)),override:Object.assign({},u,(0,C.createHttpPatch)(u,_,{config:"override"},v,!0)),onRequest:Object.assign({},u,(0,C.createHttpPatch)(u,_,P,v,!0)),default:Object.assign(u,(0,C.createHttpPatch)(u,_,P,v,!1))},https:{off:Object.assign({},n,(0,C.createHttpPatch)(n,_,{config:"off"},v,!0)),on:Object.assign({},n,(0,C.createHttpPatch)(n,_,{config:"on"},v,!0)),override:Object.assign({},n,(0,C.createHttpPatch)(n,_,{config:"override"},v,!0)),onRequest:Object.assign({},n,(0,C.createHttpPatch)(n,_,P,v,!0)),default:Object.assign(n,(0,C.createHttpPatch)(n,_,P,v,!1))},tls:Object.assign(D,(0,C.createTlsPatch)(D))}}const I=new Map;function R(k,_){return k.getExtensionPathIndex().then(P=>{const v=J.__$__nodeRequire("module"),w=v._load;v._load=function(f,E,g){if(f==="tls")return _.tls;if(f!=="http"&&f!=="https")return w.apply(this,arguments);const c=_[f],m=P.findSubstr(T.URI.file(E.filename));let a=I.get(m);if(a||I.set(m,a={}),!a[f]){const d=c.default;a[f]={...d}}return a[f]}})}}),define(Ie[297],ke([0,1,74,295,283,296,40,271,2,10,7,268,109,270]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class v extends D.RequireInterceptor{_installInterceptor(){const f=this,E=J.__$__nodeRequire("module"),g=E._load;E._load=function(d,i,o){return d=m(d),f._factories.has(d)?f._factories.get(d).load(d,b.URI.file((0,_.realpathSync)(i.filename)),r=>g.apply(this,[r,i,o])):g.apply(this,arguments)};const c=E._resolveLookupPaths;E._resolveLookupPaths=(a,d)=>c.call(this,m(a),d);const m=a=>{for(const d of f._alternatives){const i=d(a);if(i){a=i;break}}return a}}}class w extends C.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=R.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(P.ExtHostConsoleForwarder);const f=this._instaService.invokeFunction(n.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(y.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const c=this._instaService.createInstance(k.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=c.ipcHandlePath}await this._instaService.createInstance(v,f,{mine:this._myRegistry,all:this._globalRegistry}).install(),u.mark("code/extHost/didInitAPI");const g=await this._extHostConfiguration.getConfigProvider();await(0,T.connectProxyResolver)(this._extHostWorkspace,g,this,this._logService,this._mainThreadTelemetryProxy,this._initData),u.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(f){return f.main}_loadCommonJSModule(f,E,g){if(E.scheme!==I.Schemas.file)throw new Error(`Cannot load URI: '${E}', must be of file-scheme`);let c=null;g.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${E.toString(!0)}`),this._logService.flush();try{f&&u.mark(`code/extHost/willLoadExtensionCode/${f.value}`),c=J.__$__nodeRequire(E.fsPath)}catch(m){return Promise.reject(m)}finally{f&&u.mark(`code/extHost/didLoadExtensionCode/${f.value}`),g.codeLoadingStop()}return Promise.resolve(c)}async $setRemoteEnvironment(f){if(!!this._initData.remote.isRemote)for(const E in f){const g=f[E];g===null?delete process.env[E]:process.env[E]=g}}}e.ExtHostExtensionService=w}),define(Ie[141],ke([0,1,42,309,97,16,78,37,9,8,2,31,72,310,290,92]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const p=v.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(h){this.outputChannel=h}provideTextSearchResults(h,S,L,F){return this.outputChannel.appendLine(`provideTextSearchResults ${h.pattern}, ${JSON.stringify({...S,folder:S.folder.toString()})}`),new Promise((M,A)=>{F.onCancellationRequested(()=>x());const B=d(h,S),$=S.folder.fsPath,U=B.map(pe=>pe.match(/^-/)?pe:`'${pe}'`).join(" ");this.outputChannel.appendLine(`${p} ${U}
 - cwd: ${$}`);let X=u.spawn(p,B,{cwd:$});X.on("error",pe=>{console.error(pe),this.outputChannel.appendLine("Error: "+(pe&&pe.message)),A((0,k.serializeSearchError)(new k.SearchError(pe&&pe.message,k.SearchErrorCode.rgProcessError)))});let z=!1;const N=new c(S.maxResults,$,S.previewOptions);N.on("result",pe=>{z=!0,te="",L.report(pe)});let V=!1;const x=()=>{V=!0,X&&X.kill(),N&&N.cancel()};let q=!1;N.on("hitLimit",()=>{q=!0,x()});let te="";X.stdout.on("data",pe=>{N.handleData(pe),z||(te+=pe)});let Y=!1;X.stdout.once("data",()=>Y=!0);let le="";X.stderr.on("data",pe=>{const ee=pe.toString();this.outputChannel.appendLine(ee),le+=ee}),X.on("close",()=>{if(this.outputChannel.appendLine(Y?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(z?"Got result from parser":"No result from parser"),te&&this.outputChannel.appendLine(`Got data without result: ${te}`),this.outputChannel.appendLine(""),V)M({limitHit:q});else{N.flush(),X=null;let pe;le&&!Y&&(pe=E(le))?A((0,k.serializeSearchError)(new k.SearchError(pe.message,pe.code))):M({limitHit:q})}})})}}e.RipgrepTextSearchEngine=f;function E(l){const h=l.split(`
`),S=h[0].trim();if(h.some(F=>F.startsWith("regex parse error")))return new k.SearchError(g(h),k.SearchErrorCode.regexParseError);const L=S.match(/grep config error: unknown encoding: (.*)/);if(L)return new k.SearchError(`Unknown encoding: ${L[1]}`,k.SearchErrorCode.unknownEncoding);if(S.startsWith("error parsing glob"))return new k.SearchError(S.charAt(0).toUpperCase()+S.substr(1),k.SearchErrorCode.globParseError);if(S.startsWith("the literal"))return new k.SearchError(S.charAt(0).toUpperCase()+S.substr(1),k.SearchErrorCode.invalidLiteral);if(S.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(S,k.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=E;function g(l){const h=["Regex parse error"],S=l.filter(L=>L.startsWith("PCRE2:"));if(S.length>=1){const L=S[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const F=L.split(":")[1];h.push(":"+F)}}return h.join("")}e.buildRegexParseError=g;class c extends n.EventEmitter{constructor(h,S,L){super();this.maxResults=h,this.rootFolder=S,this.previewOptions=L,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new D.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(h,S){return super.on(h,S),this}handleData(h){if(this.isDone)return;const S=typeof h=="string"?h:this.stringDecoder.write(h);this.handleDecodedData(S)}handleDecodedData(h){let S=h.indexOf(`
`);const L=this.remainder+h;if(S>=0)S+=this.remainder.length;else{this.remainder=L;return}let F=0;for(;S>=0;)this.handleLine(L.substring(F,S).trim()),F=S+1,S=L.indexOf(`
`,F);this.remainder=L.substring(F)}handleLine(h){if(this.isDone||!h)return;let S;try{S=JSON.parse(h)}catch{throw new Error(`malformed line from rg: ${h}`)}if(S.type==="match"){const L=m(S.data.path),F=R.URI.file(b.join(this.rootFolder,L)),M=this.createTextSearchMatch(S.data,F);this.onResult(M),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(S.type==="context"){const L=m(S.data.path),F=R.URI.file(b.join(this.rootFolder,L));this.createTextSearchContext(S.data,F).forEach(A=>this.onResult(A))}}createTextSearchMatch(h,S){const L=h.line_number-1,F=m(h.lines),M=Buffer.from(F);let A=0,B=0,$=L;h.submatches.length===0&&h.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const U=(0,T.coalesce)(h.submatches.map((X,z)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const N=m(X.match),V=M.slice(A,X.start).toString().length,x=B+V,q=a(N),te=$,Y=q.numLines+te,le=q.numLines>0?q.lastLineLength:q.lastLineLength+x;return A=X.end,B=le,$=Y,new _.Range(te,x,Y,le)}));return(0,w.createTextSearchResult)(S,F,U,this.previewOptions)}createTextSearchContext(h,S){const L=m(h.lines),F=h.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((M,A)=>({text:M,uri:S,lineNumber:F+A}))}onResult(h){this.emit("result",h)}}e.RipgrepParser=c;function m(l){return l.bytes?Buffer.from(l.bytes,"base64").toString():l.text}function a(l){const h=/\n/g;let S=0,L=-1,F;for(;F=h.exec(l);)S++,L=F.index;const M=L>=0?l.length-L-1:l.length;return{numLines:S,lastLineLength:M}}function d(l,h){const S=["--hidden"];S.push(l.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:F}=(0,C.groupBy)(h.includes,A=>A.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const A=new Set;F.forEach(B=>{A.add(B)}),S.push("-g","!*"),A.forEach(B=>{i(B).map(w.anchorGlob).forEach($=>{S.push("-g",$)})})}L&&L.length&&L.forEach(A=>{S.push("-g",A)}),h.excludes.map(w.anchorGlob).forEach(A=>S.push("-g",`!${A}`)),h.maxFileSize&&S.push("--max-filesize",h.maxFileSize+""),h.useIgnoreFiles?h.useParentIgnoreFiles||S.push("--no-ignore-parent"):S.push("--no-ignore"),h.followSymlinks&&S.push("--follow"),h.encoding&&h.encoding!=="utf8"&&S.push("--encoding",h.encoding),l.pattern==="--"&&(l.isRegExp=!0,l.pattern="\\-\\-"),l.isMultiline&&!l.isRegExp&&(l.pattern=(0,I.escapeRegExpCharacters)(l.pattern),l.isRegExp=!0),h.usePCRE2&&S.push("--pcre2"),S.push("--crlf"),l.isRegExp&&(l.pattern=o(l.pattern),S.push("--engine","auto"));let M;if(l.isWordMatch){const B=(0,I.createRegExp)(l.pattern,!!l.isRegExp,{wholeWord:l.isWordMatch}).source.replace(/\\\//g,"/");S.push("--regexp",B)}else if(l.isRegExp){let A=t(l.pattern);A=s(A),S.push("--regexp",A)}else M=l.pattern,S.push("--fixed-strings");return S.push("--no-config"),h.useGlobalIgnoreFiles||S.push("--no-ignore-global"),S.push("--json"),l.isMultiline&&S.push("--multiline"),h.beforeContext&&S.push("--before-context",h.beforeContext+""),h.afterContext&&S.push("--after-context",h.afterContext+""),S.push("--"),M&&S.push(M),S.push("."),S}function i(l){const h=(0,y.splitGlobAware)(l,"/");return h.map((S,L)=>h.slice(0,L+1).join("/"))}e.spreadGlobComponents=i;function o(l){const h=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;l.match(h);)l=l.replace(h,"$1\\x{$2}");const S=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;l.match(S);)l=l.replace(S,"$1\\x{$2}");return l}e.unicodeEscapesToPCRE2=o;const r=l=>l.type==="Assertion"&&l.kind==="lookbehind";function t(l){let h;try{h=new P.RegExpParser().parsePattern(l)}catch{return l}let S="",L=0;const F=(B,$,U)=>{S+=l.slice(L,B)+U,L=$},M=[];return new P.RegExpVisitor({onCharacterEnter(B){if(B.raw!=="\\n")return;const $=M[0];if(!$)F(B.start,B.end,"\\r?\\n");else if(!M.some(r))if($.type==="CharacterClass")if($.negate){const U=l.slice($.start+2,B.start)+l.slice(B.end,$.end-1);$.parent?.type==="Quantifier"?F($.start,$.end,U?`[^${U}]`:"."):F($.start,$.end,"(?!\\r?\\n"+(U?`|[${U}]`:"")+")")}else{const U=l.slice($.start+1,B.start)+l.slice(B.end,$.end-1);F($.start,$.end,U===""?"\\r?\\n":`(?:[${U}]|\\r?\\n)`)}else $.type==="Quantifier"&&F(B.start,B.end,"(?:\\r?\\n)")},onQuantifierEnter(B){M.unshift(B)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(B){M.unshift(B)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(B){M.unshift(B)},onCharacterClassLeave(){M.shift()},onAssertionEnter(B){r(B)&&M.push(B)},onAssertionLeave(B){M[0]===B&&M.shift()}}).visit(h),S+=l.slice(L),S}e.fixRegexNewline=t;function s(l){return l.replace(/\n/g,"\\r?\\n")}e.fixNewline=s}),define(Ie[298],ke([0,1,21,141,119,10]),function(J,e,u,n,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class C{constructor(I){this.outputChannel=I,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(I,R,k,_){const P=new n.RipgrepTextSearchEngine(this.outputChannel);if(R.folder.scheme===T.Schemas.vscodeUserData){const v={...R,folder:R.folder.with({scheme:T.Schemas.file})},w=new D.Progress(p=>k.report({...p,uri:p.uri.with({scheme:R.folder.scheme})}));return this.withToken(_,p=>P.provideTextSearchResults(I,v,w,p))}else return this.withToken(_,v=>P.provideTextSearchResults(I,R,k,v))}async withToken(I,R){const k=y(I);this.inProgress.add(k);const _=await R(k.token);return this.inProgress.delete(k),_}dispose(){this.inProgress.forEach(I=>I.cancel())}}e.RipgrepSearchProvider=C;function y(b){const I=new u.CancellationTokenSource;return b.onCancellationRequested(()=>I.cancel()),I}}),define(Ie[299],ke([0,1,29,141,140]),function(J,e,u,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class T{constructor(b){this.query=b}search(b,I,R){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(P){R({message:P})}},_=new D.NativeTextSearchManager(this.query,new n.RipgrepTextSearchEngine(k),u);return new Promise((P,v)=>_.search(w=>{I(w.map(C))},b).then(w=>P({limitHit:w.limitHit,type:"success",stats:w.stats}),v))}}e.TextSearchEngineAdapter=T;function C(y){return{path:y.resource&&y.resource.fsPath,results:y.results,numMatches:(y.results||[]).reduce((b,I)=>{if(I.ranges){const R=I;return b+(Array.isArray(R.ranges)?R.ranges.length:1)}else return b+1},0)}}}),define(Ie[300],ke([0,1,16,18,12,3,105,9,50,2,43,31,291,299]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class v{constructor(c="searchProcess"){this.processType=c,this.caches=Object.create(null)}fileSearch(c){let m;const a=f(c),d=new T.Emitter({onFirstListenerDidAdd:()=>{m=(0,n.createCancelablePromise)(i=>this.doFileSearchWithEngine(_.Engine,a,o=>d.fire(o),i)),m.then(i=>d.fire(i),i=>d.fire({type:"error",error:{message:i.message,stack:i.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return d.event}textSearch(c){let m;const a=f(c),d=new T.Emitter({onFirstListenerDidAdd:()=>{m=(0,n.createCancelablePromise)(i=>this.ripgrepTextSearch(a,o=>d.fire(o),i)),m.then(i=>d.fire(i),i=>d.fire({type:"error",error:{message:i.message,stack:i.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return d.event}ripgrepTextSearch(c,m,a){return c.maxFileSize=(0,R.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new P.TextSearchEngineAdapter(c).search(a,m,m)}doFileSearch(c,m,a){return this.doFileSearchWithEngine(_.Engine,c,m,a)}doFileSearchWithEngine(c,m,a,d,i=v.BATCH_SIZE){let o=0;const r=s=>{Array.isArray(s)?(o+=s.length,a(s.map(l=>this.rawMatchToSearchItem(l)))):s.relativePath?(o++,a(this.rawMatchToSearchItem(s))):a(s)};if(m.sortByScore){let s=this.trySortedSearchFromCache(m,r,d);if(!s){const l=m.maxResults?Object.assign({},m,{maxResults:null}):m,h=new c(l);s=this.doSortedSearch(h,m,a,r,d)}return new Promise((l,h)=>{s.then(([S,L])=>{const F=L.map(M=>this.rawMatchToSearchItem(M));this.sendProgress(F,a,i),l(S)},h)})}const t=new c(m);return this.doSearch(t,r,i,d).then(s=>({limitHit:s.limitHit,type:"success",stats:{detailStats:s.stats,type:this.processType,fromCache:!1,resultCount:o,sortingTime:void 0}}))}rawMatchToSearchItem(c){return{path:c.base?(0,y.join)(c.base,c.relativePath):c.relativePath}}doSortedSearch(c,m,a,d,i){const o=new T.Emitter;let r=(0,n.createCancelablePromise)(s=>{let l=[];const h=S=>{Array.isArray(S)?l=S:(d(S),o.fire(S))};return this.doSearch(c,h,-1,s).then(S=>[S,l])}),t;if(m.cacheKey){t=this.getOrCreateCache(m.cacheKey);const s={promise:r,event:o.event,resolved:!1};t.resultsToSearchCache[m.filePattern||""]=s,r.then(()=>{s.resolved=!0},l=>{delete t.resultsToSearchCache[m.filePattern||""]}),r=this.preventCancellation(r)}return r.then(([s,l])=>{const h=t?t.scorerCache:Object.create(null),S=(typeof m.maxResults!="number"||m.maxResults>0)&&b.StopWatch.create(!1);return this.sortResults(m,l,h,i).then(L=>{const F=S?S.elapsed():-1;return[{type:"success",stats:{detailStats:s.stats,sortingTime:F,fromCache:!1,type:this.processType,workspaceFolderCount:m.folderQueries.length,resultCount:L.length},messages:s.messages,limitHit:s.limitHit||typeof m.maxResults=="number"&&l.length>m.maxResults},L]})})}getOrCreateCache(c){const m=this.caches[c];return m||(this.caches[c]=new w)}trySortedSearchFromCache(c,m,a){const d=c.cacheKey&&this.caches[c.cacheKey];if(!d)return;const i=this.getResultsFromCache(d,c.filePattern||"",m,a);if(i)return i.then(([o,r,t])=>{const s=b.StopWatch.create(!1);return this.sortResults(c,r,d.scorerCache,a).then(l=>{const h=s.elapsed(),S={fromCache:!0,detailStats:t,type:this.processType,resultCount:r.length,sortingTime:h};return[{type:"success",limitHit:o.limitHit||typeof c.maxResults=="number"&&r.length>c.maxResults,stats:S},l]})})}sortResults(c,m,a,d){const i=(0,C.prepareQuery)(c.filePattern||""),o=(t,s)=>(0,C.compareItemsByFuzzyScore)(t,s,i,!0,p,a),r=typeof c.maxResults=="number"?c.maxResults:Number.MAX_VALUE;return u.topAsync(m,o,r,1e4,d)}sendProgress(c,m,a){if(a&&a>0)for(let d=0;d<c.length;d+=a)m(c.slice(d,d+a));else m(c)}getResultsFromCache(c,m,a,d){const i=b.StopWatch.create(!1),o=m.indexOf(y.sep)>=0;let r;for(const h in c.resultsToSearchCache)if(m.startsWith(h)){if(o&&h.indexOf(y.sep)<0&&h!=="")continue;const S=c.resultsToSearchCache[h];r={promise:this.preventCancellation(S.promise),event:S.event,resolved:S.resolved};break}if(!r)return null;const t=i.elapsed(),s=b.StopWatch.create(!1),l=r.event(a);return d&&d.onCancellationRequested(()=>{l.dispose()}),r.promise.then(([h,S])=>{if(d&&d.isCancellationRequested)throw(0,D.canceled)();const L=[],F=(0,C.prepareQuery)(m).normalizedLowercase;for(const M of S)!(0,k.isFilePatternMatch)(M,F)||L.push(M);return[h,L,{cacheWasResolved:r.resolved,cacheLookupTime:t,cacheFilterTime:s.elapsed(),cacheEntryCount:S.length}]})}doSearch(c,m,a,d){return new Promise((i,o)=>{let r=[];d?.onCancellationRequested(()=>c.cancel()),c.search(t=>{t&&(a?(r.push(t),a>0&&r.length>=a&&(m(r),r=[])):m(t))},t=>{m(t)},(t,s)=>{r.length&&m(r),t?o(t):i(s)})})}clearCache(c){return delete this.caches[c],Promise.resolve(void 0)}preventCancellation(c){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(m,a){return c.then(m,a)}catch(m){return this.then(void 0,m)}finally(m){return c.finally(m)}}}}e.SearchService=v,v.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const p=new class{getItemLabel(g){return(0,y.basename)(g.relativePath)}getItemDescription(g){return(0,y.dirname)(g.relativePath)}getItemPath(g){return g.relativePath}};function f(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(E),extraFileResources:g.extraFileResources&&g.extraFileResources.map(c=>I.URI.revive(c))}}function E(g){return{...g,folder:I.URI.revive(g.folder)}}}),define(Ie[301],ke([0,1,6,10,2,29,14,26,17,76,65,31,300,298,92,140]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let p=class extends I.ExtHostSearch{constructor(E,g,c,m){super(E,c,m);this._pfs=T,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const a=new v.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(n.Schemas.vscodeUserData,new P.RipgrepSearchProvider(a)),g.remote.isRemote&&g.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const E=new v.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(n.Schemas.file,new P.RipgrepSearchProvider(E)),this.registerInternalFileSearchProvider(n.Schemas.file,new _.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(E,g){const c=this._handlePool++;return this._internalFileSearchProvider=g,this._internalFileSearchHandle=c,this._proxy.$registerFileSearchProvider(c,this._transformScheme(E)),(0,u.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(E,g,c,m){const a=(0,I.reviveQuery)(c);return E===this._internalFileSearchHandle?this.doInternalFileSearch(E,g,a,m):super.$provideFileSearchResults(E,g,c,m)}doInternalFileSearch(E,g,c,m){const a=d=>{if((0,k.isSerializedFileMatch)(d)&&(d=[d]),Array.isArray(d)){this._proxy.$handleFileMatch(E,g,d.map(i=>D.URI.file(i.path)));return}d.message&&this._logService.debug("ExtHostSearch",d.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(c,a,m)}$clearCache(E){return this._internalFileSearchProvider?.clearCache(E),super.$clearCache(E)}createTextSearchManager(E,g){return new w.NativeTextSearchManager(E,g,void 0,"textSearchProvider")}};p=je([Ve(0,b.IExtHostRpcService),Ve(1,y.IExtHostInitDataService),Ve(2,R.IURITransformerService),Ve(3,C.ILogService)],p),e.NativeExtHostSearch=p}),define(Ie[302],ke([0,1,82,274,286,285,301,297,275,75,40,76,73,39,52,70,273,272,14,287,47]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v,w,p,f,E,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.registerSingleton)(R.IExtHostExtensionService,y.ExtHostExtensionService),(0,u.registerSingleton)(E.ILoggerService,f.ExtHostLoggerService),(0,u.registerSingleton)(w.IExtensionStoragePaths,p.ExtensionStoragePaths),(0,u.registerSingleton)(I.IExtHostDebugService,T.ExtHostDebugService),(0,u.registerSingleton)(k.IExtHostSearch,C.NativeExtHostSearch),(0,u.registerSingleton)(_.IExtHostTask,D.ExtHostTask),(0,u.registerSingleton)(P.IExtHostTerminalService,n.ExtHostTerminalService),(0,u.registerSingleton)(v.IExtHostTunnelService,b.ExtHostTunnelService),(0,u.registerSingleton)(c.IExtHostVariableResolverProvider,g.NodeExtHostVariableResolverProviderService)}),define(Ie[311],ke([0,1,217,312,74,12,111,112,198,134,284,23,29,109,18,115,211,229,288,302]),function(J,e,u,n,D,T,C,y,b,I,R,k,_,P,v,w,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let t=0;t<process.execArgv.length;t++)process.execArgv[t]==="--inspect-port=0"&&(process.execArgv.splice(t,1),t--)}();const E=n(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const r=J.__$__nodeRequire("module"),t=r._load;r._load=function(s){if(s==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return t.apply(this,arguments)}})();const g=process.exit.bind(process);function c(r){process.exit=function(t){if(r)g(t);else{const s=new Error("An extension called process.exit() and this was prevented.");console.warn(s.stack)}},process.crash=function(){const t=new Error("An extension called process.crash() and this was prevented.");console.warn(t.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let m=function(r){g()};function a(){const r=(0,f.readExtHostConnection)(process.env);if(r.type===3)return new Promise((t,s)=>{const l=h=>{const S=h[0],L=new C.BufferedEmitter;S.on("message",F=>L.fire(k.VSBuffer.wrap(F.data))),S.on("close",()=>{m("renderer closed the MessagePort")}),S.start(),t({onMessage:L.event,send:F=>S.postMessage(F.buffer)})};if(global.vscodePorts){const h=global.vscodePorts;delete global.vscodePorts,l(h)}else global.vscodePortsCallback=l});if(r.type===2)return new Promise((t,s)=>{let l=null;const h=setTimeout(()=>{m("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),S=108e5,L=3e5,F=new v.ProcessTimeRunOnceScheduler(()=>m("renderer disconnected for too long (1)"),S),M=new v.ProcessTimeRunOnceScheduler(()=>m("renderer disconnected for too long (2)"),L);process.on("message",(B,$)=>{if(B&&B.type==="VSCODE_EXTHOST_IPC_SOCKET"){$.setNoDelay(!0);const U=k.VSBuffer.wrap(Buffer.from(B.initialDataChunk,"base64"));let X;if(B.skipWebSocketFrames)X=new y.NodeSocket($,"extHost-socket");else{const z=k.VSBuffer.wrap(Buffer.from(B.inflateBytes,"base64"));X=new y.WebSocketNodeSocket(new y.NodeSocket($,"extHost-socket"),B.permessageDeflate,z,!1)}l?(F.cancel(),M.cancel(),l.beginAcceptReconnection(X,U),l.endAcceptReconnection(),l.sendResume()):(clearTimeout(h),l=new C.PersistentProtocol(X,U),l.sendResume(),l.onDidDispose(()=>m("renderer disconnected")),t(l),l.onSocketClose(()=>{F.schedule()}))}if(B&&B.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(M.isScheduled())return;F.isScheduled()&&M.schedule()}});const A={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(A)});{const t=r.pipeName;return new Promise((s,l)=>{const h=u.createConnection(t,()=>{h.removeListener("error",l);const S=new C.PersistentProtocol(new y.NodeSocket(h,"extHost-renderer"));S.sendResume(),s(S)});h.once("error",l),h.on("close",()=>{m("renderer closed the socket")})})}}async function d(){const r=await a();return new class{constructor(){this._onMessage=new C.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,r.onMessage(t=>{(0,I.isMessageOfType)(t,2)?(this._terminating=!0,m("received terminate message from renderer")):this._onMessage.fire(t)})}send(t){this._terminating||r.send(t)}async drain(){if(r.drain)return r.drain()}}}function i(r){return new Promise(t=>{const s=r.onMessage(l=>{s.dispose();const h=JSON.parse(l.toString()),S=h.commit,L=b.default.commit;if(S&&L&&S!==L&&g(55),h.parentPid){let F=0;setInterval(function(){try{process.kill(h.parentPid,0),F=0}catch(A){A&&A.code==="EPERM"?(F++,F>=3&&m(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${A.message} (code: ${A.code}) (errno: ${A.errno})`)):m(`parent process ${h.parentPid} does not exist anymore: ${A.message} (code: ${A.code}) (errno: ${A.errno})`)}},1e3);let M;try{M=J.__$__nodeRequire("native-watchdog"),M.start(h.parentPid)}catch(A){(0,T.onUnexpectedError)(A)}}r.send((0,I.createMessageOfType)(0)),t({protocol:r,initData:h})});r.send((0,I.createMessageOfType)(1))})}async function o(){const r=[];process.on("unhandledRejection",(F,M)=>{r.push(M),setTimeout(()=>{const A=r.indexOf(M);A>=0&&M.catch(B=>{r.splice(A,1),(0,T.isCancellationError)(B)||(console.warn(`rejected promise not handled within 1 second: ${B}`),B&&B.stack&&console.warn(`stack trace: ${B.stack}`),F&&(0,T.onUnexpectedError)(F))})},1e3)}),process.on("rejectionHandled",F=>{const M=r.indexOf(F);M>=0&&r.splice(M,1)}),process.on("uncaughtException",function(F){(0,T.onUnexpectedError)(F)}),D.mark("code/extHost/willConnectToRenderer");const t=await d();D.mark("code/extHost/didConnectToRenderer");const s=await i(t);D.mark("code/extHost/didWaitForInitData");const{initData:l}=s;c(!!l.environment.extensionTestsLocationURI),l.environment.useHostProxy=E.useHostProxy!==void 0?E.useHostProxy!=="false":void 0,l.environment.skipWorkspaceStorageLock=(0,w.boolean)(E.skipWorkspaceStorageLock,!1);const h=new class{constructor(){this.pid=process.pid}exit(M){g(M)}exists(M){return _.Promises.exists(M)}realpath(M){return(0,P.realpath)(M)}};let S=null;l.remote.authority&&E.transformURIs&&(S=(0,p.createURITransformer)(l.remote.authority));const L=new R.ExtensionHostMain(s.protocol,l,h,S);m=F=>L.terminate(F)}e.startExtensionHostProcess=o,o().catch(r=>console.log(r))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6c122d9b2d1af2c37bd55caad614321eb53b342f/core/vs/workbench/api/node/extensionHostProcess.js.map
